/* DUPLICATOR-LITE (PHP BUILD MODE) MYSQL SCRIPT CREATED ON : 2022-03-07 23:05:05 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'comment',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB AUTO_INCREMENT=246 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=55 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "A WordPress Commenter", "wapuu@wordpress.example", "https://wordpress.org/", "", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "Hi, this is a comment.\nTo get started with moderating, editing, and deleting comments, please visit the Comments screen in the dashboard.\nCommenter avatars come from <a href=\"https://gravatar.com\">Gravatar</a>.", "0", "1", "", "comment", "0", "0");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("3", "20220307_eatery_startfiles_wp59_php808", "75f37e49073220034218_20220307230459", "22", "2022-03-07 23:05:05", "unknown", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2022-03-07 23:04:59\";s:7:\"Version\";s:5:\"1.4.4\";s:9:\"VersionWP\";s:5:\"5.9.1\";s:9:\"VersionDB\";s:6:\"5.7.34\";s:10:\"VersionPHP\";s:5:\"8.0.8\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";i:3;s:4:\"Name\";s:38:\"20220307_eatery_startfiles_wp59_php808\";s:4:\"Hash\";s:35:\"75f37e49073220034218_20220307230459\";s:8:\"NameHash\";s:74:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";s:84:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";s:4:\"21.5\";s:6:\"WPUser\";s:7:\"unknown\";s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:86:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:56:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":6:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":7:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2022-03-07 23:04:59\";s:7:\"Version\";s:5:\"1.4.4\";s:9:\"VersionWP\";s:5:\"5.9.1\";s:9:\"VersionDB\";s:6:\"5.7.34\";s:10:\"VersionPHP\";s:5:\"8.0.8\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";N;s:4:\"Name\";s:38:\"20220307_eatery_startfiles_wp59_php808\";s:4:\"Hash\";s:35:\"75f37e49073220034218_20220307230459\";s:8:\"NameHash\";s:74:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:21;s:9:\"Installer\";O:13:\"DUP_Installer\":13:{s:4:\"File\";s:88:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:13:\"OptsDBCharset\";s:0:\"\";s:15:\"OptsDBCollation\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:87:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":16:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:0;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:1:{s:14:\"wp_commentmeta\";s:1:\"0\";}s:11:\"triggerList\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:24:\"\0DUP_Database\0tempDbPath\";s:161:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-snapshots/tmp/20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:65:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-admin\";i:1;s:75:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content/uploads\";i:2;s:77:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content/languages\";i:3;s:74:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content/themes\";i:4;s:68:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:56:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022\";i:1;s:67:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content\";}}s:9:\"Installer\";r:84;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:131;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://localhost:8888/CanonicalExercises/Eatery-2022", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://localhost:8888/CanonicalExercises/Eatery-2022", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "The Eatery", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "Just another WordPress site", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "kevinmc@shaw.ca", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "0", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%year%/%monthnum%/%day%/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "rewrite_rules", "a:94:{s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:17:\"^wp-sitemap\\.xml$\";s:23:\"index.php?sitemap=index\";s:17:\"^wp-sitemap\\.xsl$\";s:36:\"index.php?sitemap-stylesheet=sitemap\";s:23:\"^wp-sitemap-index\\.xsl$\";s:34:\"index.php?sitemap-stylesheet=index\";s:48:\"^wp-sitemap-([a-z]+?)-([a-z\\d_-]+?)-(\\d+?)\\.xml$\";s:75:\"index.php?sitemap=$matches[1]&sitemap-subtype=$matches[2]&paged=$matches[3]\";s:34:\"^wp-sitemap-([a-z]+?)-(\\d+?)\\.xml$\";s:47:\"index.php?sitemap=$matches[1]&paged=$matches[2]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:53:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/embed/?$\";s:91:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:61:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(?:/([0-9]+))?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:53:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:6:{i:0;s:30:\"advanced-custom-fields/acf.php\";i:1;s:41:\"advanced-gutenberg/advanced-gutenberg.php\";i:3;s:43:\"custom-post-type-ui/custom-post-type-ui.php\";i:4;s:32:\"duplicate-page/duplicatepage.php\";i:5;s:25:\"duplicator/duplicator.php\";i:6;s:47:\"show-current-template/show-current-template.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("37", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("39", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("40", "template", "twentytwenty", "yes");
INSERT INTO `wp_options` VALUES("41", "stylesheet", "twentytwenty", "yes");
INSERT INTO `wp_options` VALUES("44", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("48", "db_version", "51917", "yes");
INSERT INTO `wp_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("51", "blog_public", "0", "yes");
INSERT INTO `wp_options` VALUES("52", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("53", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("69", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("71", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("73", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("78", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_text", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("81", "uninstall_plugins", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("82", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("83", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_options` VALUES("88", "site_icon", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "wp_page_for_privacy_policy", "3", "yes");
INSERT INTO `wp_options` VALUES("92", "show_comments_cookies_opt_in", "1", "yes");
INSERT INTO `wp_options` VALUES("93", "admin_email_lifespan", "1662245063", "yes");
INSERT INTO `wp_options` VALUES("94", "initial_db_version", "45805", "yes");
INSERT INTO `wp_options` VALUES("95", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:69:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:19:\"edit_advgb_profiles\";b:1;s:26:\"edit_others_advgb_profiles\";b:1;s:21:\"create_advgb_profiles\";b:1;s:22:\"publish_advgb_profiles\";b:1;s:21:\"delete_advgb_profiles\";b:1;s:28:\"delete_others_advgb_profiles\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:37:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;s:19:\"edit_advgb_profiles\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:13:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:19:\"edit_advgb_profiles\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:7:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("96", "fresh_site", "0", "yes");
INSERT INTO `wp_options` VALUES("97", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("98", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("99", "widget_recent-comments", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "sidebars_widgets", "a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";}s:9:\"sidebar-2\";a:3:{i:0;s:10:\"archives-2\";i:1;s:12:\"categories-2\";i:2;s:6:\"meta-2\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("103", "cron", "a:8:{i:1646695628;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1646731627;a:1:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1646731628;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1646731639;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1646731640;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1646736520;a:1:{s:18:\"wp_https_detection\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1646779720;a:1:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("104", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("105", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("106", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("107", "widget_media_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("108", "widget_media_gallery", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("109", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("110", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("111", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("112", "widget_custom_html", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("114", "recovery_keys", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("121", "theme_mods_twentytwenty", "a:1:{s:18:\"custom_css_post_id\";i:-1;}", "yes");
INSERT INTO `wp_options` VALUES("145", "recently_activated", "a:1:{s:19:\"akismet/akismet.php\";i:1646693136;}", "yes");
INSERT INTO `wp_options` VALUES("146", "acf_version", "5.12", "yes");
INSERT INTO `wp_options` VALUES("155", "duplicate_page_options", "a:4:{s:21:\"duplicate_post_status\";s:5:\"draft\";s:23:\"duplicate_post_redirect\";s:7:\"to_list\";s:21:\"duplicate_post_suffix\";s:0:\"\";s:21:\"duplicate_post_editor\";s:7:\"classic\";}", "yes");
INSERT INTO `wp_options` VALUES("156", "advgb_version", "2.11.5", "yes");
INSERT INTO `wp_options` VALUES("157", "advgb_settings", "a:5:{s:16:\"gallery_lightbox\";i:1;s:24:\"gallery_lightbox_caption\";i:1;s:17:\"blocks_icon_color\";s:7:\"#5952de\";s:15:\"disable_wpautop\";i:0;s:27:\"enable_columns_visual_guide\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("158", "advgb_jureview_installation_time", "unnecessary", "yes");
INSERT INTO `wp_options` VALUES("159", "advgb_jufeedback_version", "1.0.0", "yes");
INSERT INTO `wp_options` VALUES("160", "advgb_blocks_list", "a:99:{i:0;a:5:{s:4:\"name\";s:15:\"advgb/accordion\";s:4:\"icon\";s:497:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;rect x=&quot;3&quot; y=&quot;17&quot; width=&quot;18&quot; height=&quot;2&quot;&gt;&lt;/rect&gt;&lt;path d=&quot;M19,12v1H5v-1H19 M21,10H3v5h18V10L21,10z&quot;&gt;&lt;/path&gt;&lt;rect x=&quot;3&quot; y=&quot;6&quot; width=&quot;18&quot; height=&quot;2&quot;&gt;&lt;/rect&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Accordion\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:1;a:6:{s:4:\"name\";s:20:\"advgb/accordion-item\";s:4:\"icon\";s:497:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;rect x=&quot;3&quot; y=&quot;17&quot; width=&quot;18&quot; height=&quot;2&quot;&gt;&lt;/rect&gt;&lt;path d=&quot;M19,12v1H5v-1H19 M21,10H3v5h18V10L21,10z&quot;&gt;&lt;/path&gt;&lt;rect x=&quot;3&quot; y=&quot;6&quot; width=&quot;18&quot; height=&quot;2&quot;&gt;&lt;/rect&gt;&lt;/svg&gt;\";s:5:\"title\";s:14:\"Accordion Item\";s:8:\"category\";s:14:\"advgb-category\";s:6:\"parent\";a:1:{i:0;s:16:\"advgb/accordions\";}s:9:\"iconColor\";s:7:\"#5952de\";}i:2;a:5:{s:4:\"name\";s:16:\"advgb/accordions\";s:4:\"icon\";s:343:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M2 20h20v-4H2v4zm2-3h2v2H4v-2zM2 4v4h20V4H2zm4 3H4V5h2v2zm-4 7h20v-4H2v4zm2-3h2v2H4v-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:18:\"Advanced Accordion\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:3;a:5:{s:4:\"name\";s:12:\"advgb/button\";s:4:\"icon\";s:347:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M19 7H5c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V9c0-1.1-.9-2-2-2zm0 8H5V9h14v6z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:15:\"Advanced Button\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:4;a:5:{s:4:\"name\";s:10:\"advgb/icon\";s:4:\"icon\";s:457:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;24&quot; height=&quot;24&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M19 1H5c-1.1 0-1.99.9-1.99 2L3 15.93c0 .69.35 1.3.88 1.66L12 23l8.11-5.41c.53-.36.88-.97.88-1.66L21 3c0-1.1-.9-2-2-2zm-7 19.6l-7-4.66V3h14v12.93l-7 4.67zm-2.01-7.42l-2.58-2.59L6 12l4 4 8-8-1.42-1.42z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Advanced Icon\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:5;a:5:{s:4:\"name\";s:11:\"advgb/image\";s:4:\"icon\";s:406:\"&lt;svg height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; width=&quot;20&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot;&gt;&lt;path d=&quot;M0 0h24v24H0V0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M1 5h2v14H1zm4 0h2v14H5zm17 0H10c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h12c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1zM11 17l2.5-3.15L15.29 16l2.5-3.22L21 17H11z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:14:\"Advanced Image\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:6;a:5:{s:4:\"name\";s:10:\"advgb/list\";s:4:\"icon\";s:342:\"&lt;svg height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; width=&quot;20&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot;&gt;&lt;path d=&quot;M3 13h2v-2H3v2zm0 4h2v-2H3v2zm0-8h2V7H3v2zm4 4h14v-2H7v2zm0 4h14v-2H7v2zM7 7v2h14V7H7z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Advanced List\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:7;a:5:{s:4:\"name\";s:11:\"advgb/table\";s:4:\"icon\";s:328:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path d=&quot;M3 3v18h18V3H3zm8 16H5v-6h6v6zm0-8H5V5h6v6zm8 8h-6v-6h6v6zm0-8h-6V5h6v6z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:14:\"Advanced Table\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:8;a:5:{s:4:\"name\";s:14:\"advgb/adv-tabs\";s:4:\"icon\";s:440:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M21,3H3C1.9,3,1,3.9,1,5v14c0,1.1,0.9,2,2,2h18c1.1,0,2-0.9,2-2V5C23,3.9,22.1,3,21,3z M21,19H3V5h10v4h8V19z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Advanced Tabs\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:9;a:6:{s:4:\"name\";s:9:\"advgb/tab\";s:4:\"icon\";s:440:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M21,3H3C1.9,3,1,3.9,1,5v14c0,1.1,0.9,2,2,2h18c1.1,0,2-0.9,2-2V5C23,3.9,22.1,3,21,3z M21,19H3V5h10v4h8V19z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:8:\"Tab Item\";s:8:\"category\";s:14:\"advgb-category\";s:6:\"parent\";a:1:{i:0;s:14:\"advgb/adv-tabs\";}s:9:\"iconColor\";s:7:\"#5952de\";}i:10;a:5:{s:4:\"name\";s:11:\"advgb/video\";s:4:\"icon\";s:403:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M10 16.5l6-4.5-6-4.5v9zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:14:\"Advanced Video\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:11;a:5:{s:4:\"name\";s:13:\"advgb/columns\";s:4:\"icon\";s:79:\"&lt;span class=&quot;dashicon dashicons dashicons-layout&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:15:\"Columns Manager\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:12;a:6:{s:4:\"name\";s:12:\"advgb/column\";s:4:\"icon\";s:304:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path d=&quot;M10 18h5V5h-5v13zm-6 0h5V5H4v13zM16 5v13h5V5h-5z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:11:\"Adv. Column\";s:8:\"category\";s:14:\"advgb-category\";s:6:\"parent\";a:1:{i:0;s:13:\"advgb/columns\";}s:9:\"iconColor\";s:7:\"#5952de\";}i:13;a:5:{s:4:\"name\";s:18:\"advgb/contact-form\";s:4:\"icon\";s:376:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M22 6c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6zm-2 0l-8 4.99L4 6h16zm0 12H4V8l8 5 8-5v10z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Contact Form\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:14;a:5:{s:4:\"name\";s:15:\"advgb/container\";s:4:\"icon\";s:317:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M3 5v14h19V5H3zm2 2h15v4H5V7zm0 10v-4h4v4H5zm6 0v-4h9v4h-9z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Container\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:15;a:5:{s:4:\"name\";s:14:\"advgb/count-up\";s:4:\"icon\";s:869:\"&lt;svg height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; width=&quot;20&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot;&gt;&lt;path d=&quot;M0 0h24v24H0zm0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M16.05 16.29l2.86-3.07c.38-.39.72-.79 1.04-1.18.32-.39.59-.78.82-1.17.23-.39.41-.78.54-1.17.13-.39.19-.79.19-1.18 0-.53-.09-1.02-.27-1.46-.18-.44-.44-.81-.78-1.11-.34-.31-.77-.54-1.26-.71-.51-.16-1.08-.24-1.72-.24-.69 0-1.31.11-1.85.32-.54.21-1 .51-1.36.88-.37.37-.65.8-.84 1.3-.18.47-.27.97-.28 1.5h2.14c.01-.31.05-.6.13-.87.09-.29.23-.54.4-.75.18-.21.41-.37.68-.49.27-.12.6-.18.96-.18.31 0 .58.05.81.15.23.1.43.25.59.43.16.18.28.4.37.65.08.25.13.52.13.81 0 .22-.03.43-.08.65-.06.22-.15.45-.29.7-.14.25-.32.53-.56.83-.23.3-.52.65-.88 1.03l-4.17 4.55V18H22v-1.71h-5.95zM8 7H6v4H2v2h4v4h2v-4h4v-2H8V7z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:8:\"Count Up\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:16;a:5:{s:4:\"name\";s:19:\"advgb/images-slider\";s:4:\"icon\";s:506:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; class=&quot;dashicon&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M20 4h-3.17L15 2H9L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zM9.88 4h4.24l1.83 2H20v12H4V6h4.05&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M15 11H9V8.5L5.5 12 9 15.5V13h6v2.5l3.5-3.5L15 8.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Images Slider\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:17;a:5:{s:4:\"name\";s:13:\"advgb/infobox\";s:4:\"icon\";s:346:\"&lt;svg version=&quot;1.1&quot; id=&quot;Layer_1&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; x=&quot;0px&quot; y=&quot;0px&quot; viewbox=&quot;0 0 250 250&quot;&gt;&lt;path d=&quot;M114,110h23v69.1h-23V110z M114,63.9v23h23v-23H114z M225,22v11v177v11h-11H37H26v-11V33V22h11h177H225z M214,33H37v177h177V33z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:8:\"Info Box\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:18;a:5:{s:4:\"name\";s:16:\"advgb/login-form\";s:4:\"icon\";s:512:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M11 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm0-6c1.1 0 2 .9 2 2s-.9 2-2 2-2-.9-2-2 .9-2 2-2zM5 18c.2-.63 2.57-1.68 4.96-1.94l2.04-2c-.39-.04-.68-.06-1-.06-2.67 0-8 1.34-8 4v2h9l-2-2H5zm15.6-5.5l-5.13 5.17-2.07-2.08L12 17l3.47 3.5L22 13.91z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:19:\"Login/Register Form\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:19;a:5:{s:4:\"name\";s:9:\"advgb/map\";s:4:\"icon\";s:463:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; class=&quot;dashicon&quot;&gt;&lt;path d=&quot;M20.5 3l-.16.03L15 5.1 9 3 3.36 4.9c-.21.07-.36.25-.36.48V20.5c0 .28.22.5.5.5l.16-.03L9 18.9l6 2.1 5.64-1.9c.21-.07.36-.25.36-.48V3.5c0-.28-.22-.5-.5-.5zM15 19l-6-2.11V5l6 2.11V19z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:3:\"Map\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:20;a:5:{s:4:\"name\";s:16:\"advgb/newsletter\";s:4:\"icon\";s:635:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path fill-opacity=&quot;.9&quot; d=&quot;M12 1.95c-5.52 0-10 4.48-10 10s4.48 10 10 10h5v-2h-5c-4.34 0-8-3.66-8-8s3.66-8 8-8 8 3.66 8 8v1.43c0 .79-.71 1.57-1.5 1.57s-1.5-.78-1.5-1.57v-1.43c0-2.76-2.24-5-5-5s-5 2.24-5 5 2.24 5 5 5c1.38 0 2.64-.56 3.54-1.47.65.89 1.77 1.47 2.96 1.47 1.97 0 3.5-1.6 3.5-3.57v-1.43c0-5.52-4.48-10-10-10zm0 13c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Newsletter\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:21;a:5:{s:4:\"name\";s:18:\"advgb/recent-posts\";s:4:\"icon\";s:662:\"&lt;svg width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;rect x=&quot;13&quot; y=&quot;7.5&quot; width=&quot;5&quot; height=&quot;2&quot;&gt;&lt;/rect&gt;&lt;rect x=&quot;13&quot; y=&quot;14.5&quot; width=&quot;5&quot; height=&quot;2&quot;&gt;&lt;/rect&gt;&lt;path d=&quot;M19,3H5C3.9,3,3,3.9,3,5v14c0,1.1,0.9,2,2,2h14c1.1,0,2-0.9,2-2V5C21,3.9,20.1,3,19,3z M19,19H5V5h14V19z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M11,6H6v5h5V6z M10,10H7V7h3V10z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M11,13H6v5h5V13z M10,17H7v-3h3V17z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:15:\"Content Display\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:22;a:5:{s:4:\"name\";s:16:\"advgb/search-bar\";s:4:\"icon\";s:427:\"&lt;svg fill=&quot;none&quot; height=&quot;20&quot; width=&quot;20&quot; stroke=&quot;currentColor&quot; strokewidth=&quot;2&quot; viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot;&gt;&lt;circle fill=&quot;none&quot; cx=&quot;11&quot; cy=&quot;11&quot; r=&quot;8&quot;&gt;&lt;/circle&gt;&lt;line x1=&quot;21&quot; x2=&quot;16.65&quot; y1=&quot;21&quot; y2=&quot;16.65&quot;&gt;&lt;/line&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Search Bar\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:23;a:5:{s:4:\"name\";s:18:\"advgb/social-links\";s:4:\"icon\";s:875:\"&lt;svg width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;g fill=&quot;currentColor&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M18,16.08c-0.76,0-1.44,0.3-1.96,0.77L8.91,12.7C8.96,12.47,9,12.24,9,12s-0.04-0.47-0.09-0.7l7.05-4.11 C16.5,7.69,17.21,8,18,8c1.66,0,3-1.34,3-3c0-1.66-1.34-3-3-3s-3,1.34-3,3c0,0.24,0.04,0.47,0.09,0.7L8.04,9.81 C7.5,9.31,6.79,9,6,9c-1.66,0-3,1.34-3,3c0,1.66,1.34,3,3,3c0.79,0,1.5-0.31,2.04-0.81l7.12,4.16c-0.05,0.21-0.08,0.43-0.08,0.65 c0,1.61,1.31,2.92,2.92,2.92s2.92-1.31,2.92-2.92C20.92,17.39,19.61,16.08,18,16.08z M18,4c0.55,0,1,0.45,1,1s-0.45,1-1,1 s-1-0.45-1-1S17.45,4,18,4z M6,13c-0.55,0-1-0.45-1-1s0.45-1,1-1s1,0.45,1,1S6.55,13,6,13z M18,20.02c-0.55,0-1-0.45-1-1 s0.45-1,1-1s1,0.45,1,1S18.55,20.02,18,20.02z&quot;&gt;&lt;/path&gt;&lt;/g&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Social Links\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:24;a:5:{s:4:\"name\";s:13:\"advgb/summary\";s:4:\"icon\";s:317:\"&lt;svg height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; width=&quot;20&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot;&gt;&lt;path d=&quot;M14 17H4v2h10v-2zm6-8H4v2h16V9zM4 15h16v-2H4v2zM4 5v2h16V5H4z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:17:\"Table of Contents\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:25;a:5:{s:4:\"name\";s:10:\"advgb/tabs\";s:4:\"icon\";s:440:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M21,3H3C1.9,3,1,3.9,1,5v14c0,1.1,0.9,2,2,2h18c1.1,0,2-0.9,2-2V5C23,3.9,22.1,3,21,3z M21,19H3V5h10v4h8V19z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:4:\"Tabs\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:26;a:5:{s:4:\"name\";s:17:\"advgb/testimonial\";s:4:\"icon\";s:491:\"&lt;svg height=&quot;20&quot; viewbox=&quot;2 2 22 22&quot; width=&quot;20&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot;&gt;&lt;path d=&quot;M19 2H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h4l3 3 3-3h4c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 3.3c1.49 0 2.7 1.21 2.7 2.7 0 1.49-1.21 2.7-2.7 2.7-1.49 0-2.7-1.21-2.7-2.7 0-1.49 1.21-2.7 2.7-2.7zM18 16H6v-.9c0-2 4-3.1 6-3.1s6 1.1 6 3.1v.9z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M0 0h24v24H0z&quot; fill=&quot;none&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:11:\"Testimonial\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:27;a:5:{s:4:\"name\";s:18:\"advgb/woo-products\";s:4:\"icon\";s:657:\"&lt;svg width=&quot;20&quot; height=&quot;20&quot; viewbox=&quot;0 0 24 24&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0,0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M15.55,13c0.75,0,1.41-0.41,1.75-1.03l3.58-6.49C21.25,4.82,20.77,4,20.01,4H5.21L4.27,2H1v2h2l3.6,7.59l-1.35,2.44 C4.52,15.37,5.48,17,7,17h12v-2H7l1.1-2H15.55z M6.16,6h12.15l-2.76,5H8.53L6.16,6z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M7,18c-1.1,0-1.99,0.9-1.99,2c0,1.1,0.89,2,1.99,2c1.1,0,2-0.9,2-2C9,18.9,8.1,18,7,18z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M17,18c-1.1,0-1.99,0.9-1.99,2c0,1.1,0.89,2,1.99,2c1.1,0,2-0.9,2-2C19,18.9,18.1,18,17,18z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Woo Products\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:28;a:4:{s:4:\"name\";s:14:\"core/paragraph\";s:4:\"icon\";s:280:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18.3 4H9.9v-.1l-.9.2c-2.3.4-4 2.4-4 4.8s1.7 4.4 4 4.8l.7.1V20h1.5V5.5h2.9V20h1.5V5.5h2.7V4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Paragraph\";s:8:\"category\";s:4:\"text\";}i:29;a:4:{s:4:\"name\";s:10:\"core/image\";s:4:\"icon\";s:465:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM5 4.5h14c.3 0 .5.2.5.5v8.4l-3-2.9c-.3-.3-.8-.3-1 0L11.9 14 9 12c-.3-.2-.6-.2-.8 0l-3.6 2.6V5c-.1-.3.1-.5.4-.5zm14 15H5c-.3 0-.5-.2-.5-.5v-2.4l4.1-3 3 1.9c.3.2.7.2.9-.1L16 12l3.5 3.4V19c0 .3-.2.5-.5.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Image\";s:8:\"category\";s:5:\"media\";}i:30;a:4:{s:4:\"name\";s:12:\"core/heading\";s:4:\"icon\";s:222:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M6.2 5.2v13.4l5.8-4.8 5.8 4.8V5.2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:7:\"Heading\";s:8:\"category\";s:4:\"text\";}i:31;a:4:{s:4:\"name\";s:12:\"core/gallery\";s:4:\"icon\";s:576:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M20.2 8v11c0 .7-.6 1.2-1.2 1.2H6v1.5h13c1.5 0 2.7-1.2 2.7-2.8V8h-1.5zM18 16.4V4.6c0-.9-.7-1.6-1.6-1.6H4.6C3.7 3 3 3.7 3 4.6v11.8c0 .9.7 1.6 1.6 1.6h11.8c.9 0 1.6-.7 1.6-1.6zM4.5 4.6c0-.1.1-.1.1-.1h11.8c.1 0 .1.1.1.1V12l-2.3-1.7c-.3-.2-.6-.2-.9 0l-2.9 2.1L8 11.3c-.2-.1-.5-.1-.7 0l-2.9 1.5V4.6zm0 11.8v-1.8l3.2-1.7 2.4 1.2c.2.1.5.1.8-.1l2.8-2 2.8 2v2.5c0 .1-.1.1-.1.1H4.6c0-.1-.1-.2-.1-.2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:7:\"Gallery\";s:8:\"category\";s:5:\"media\";}i:32;a:4:{s:4:\"name\";s:9:\"core/list\";s:4:\"icon\";s:290:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M4 4v1.5h16V4H4zm8 8.5h8V11h-8v1.5zM4 20h16v-1.5H4V20zm4-8c0-1.1-.9-2-2-2s-2 .9-2 2 .9 2 2 2 2-.9 2-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:4:\"List\";s:8:\"category\";s:4:\"text\";}i:33;a:4:{s:4:\"name\";s:10:\"core/quote\";s:4:\"icon\";s:389:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M13 6v6h5.2v4c0 .8-.2 1.4-.5 1.7-.6.6-1.6.6-2.5.5h-.3v1.5h.5c1 0 2.3-.1 3.3-1 .6-.6 1-1.6 1-2.8V6H13zm-9 6h5.2v4c0 .8-.2 1.4-.5 1.7-.6.6-1.6.6-2.5.5h-.3v1.5h.5c1 0 2.3-.1 3.3-1 .6-.6 1-1.6 1-2.8V6H4v6z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Quote\";s:8:\"category\";s:4:\"text\";}i:34;a:4:{s:4:\"name\";s:13:\"core/archives\";s:4:\"icon\";s:447:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 6.2h-5.9l-.6-1.1c-.3-.7-1-1.1-1.8-1.1H5c-1.1 0-2 .9-2 2v11.8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V8.2c0-1.1-.9-2-2-2zm.5 11.6c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h5.8c.2 0 .4.1.4.3l1 2H19c.3 0 .5.2.5.5v9.5zM8 12.8h8v-1.5H8v1.5zm0 3h8v-1.5H8v1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:8:\"Archives\";s:8:\"category\";s:7:\"widgets\";}i:35;a:4:{s:4:\"name\";s:10:\"core/audio\";s:4:\"icon\";s:382:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M17.7 4.3c-1.2 0-2.8 0-3.8 1-.6.6-.9 1.5-.9 2.6V14c-.6-.6-1.5-1-2.5-1C8.6 13 7 14.6 7 16.5S8.6 20 10.5 20c1.5 0 2.8-1 3.3-2.3.5-.8.7-1.8.7-2.5V7.9c0-.7.2-1.2.5-1.6.6-.6 1.8-.6 2.8-.6h.3V4.3h-.4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Audio\";s:8:\"category\";s:5:\"media\";}i:36;a:5:{s:4:\"name\";s:11:\"core/button\";s:4:\"icon\";s:365:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 6.5H5c-1.1 0-2 .9-2 2v7c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-7c0-1.1-.9-2-2-2zm.5 9c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5v-7c0-.3.2-.5.5-.5h14c.3 0 .5.2.5.5v7zM8 12.8h8v-1.5H8v1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:6:\"Button\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:12:\"core/buttons\";}}i:37;a:4:{s:4:\"name\";s:12:\"core/buttons\";s:4:\"icon\";s:538:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M17 3H7c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm.5 6c0 .3-.2.5-.5.5H7c-.3 0-.5-.2-.5-.5V5c0-.3.2-.5.5-.5h10c.3 0 .5.2.5.5v4zm-8-1.2h5V6.2h-5v1.6zM17 13H7c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2zm.5 6c0 .3-.2.5-.5.5H7c-.3 0-.5-.2-.5-.5v-4c0-.3.2-.5.5-.5h10c.3 0 .5.2.5.5v4zm-8-1.2h5v-1.5h-5v1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:7:\"Buttons\";s:8:\"category\";s:6:\"design\";}i:38;a:4:{s:4:\"name\";s:13:\"core/calendar\";s:4:\"icon\";s:404:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm.5 16c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V7h15v12zM9 10H7v2h2v-2zm0 4H7v2h2v-2zm4-4h-2v2h2v-2zm4 0h-2v2h2v-2zm-4 4h-2v2h2v-2zm4 0h-2v2h2v-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:8:\"Calendar\";s:8:\"category\";s:7:\"widgets\";}i:39;a:4:{s:4:\"name\";s:15:\"core/categories\";s:4:\"icon\";s:811:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M6 5.5h3a.5.5 0 01.5.5v3a.5.5 0 01-.5.5H6a.5.5 0 01-.5-.5V6a.5.5 0 01.5-.5zM4 6a2 2 0 012-2h3a2 2 0 012 2v3a2 2 0 01-2 2H6a2 2 0 01-2-2V6zm11-.5h3a.5.5 0 01.5.5v3a.5.5 0 01-.5.5h-3a.5.5 0 01-.5-.5V6a.5.5 0 01.5-.5zM13 6a2 2 0 012-2h3a2 2 0 012 2v3a2 2 0 01-2 2h-3a2 2 0 01-2-2V6zm5 8.5h-3a.5.5 0 00-.5.5v3a.5.5 0 00.5.5h3a.5.5 0 00.5-.5v-3a.5.5 0 00-.5-.5zM15 13a2 2 0 00-2 2v3a2 2 0 002 2h3a2 2 0 002-2v-3a2 2 0 00-2-2h-3zm-9 1.5h3a.5.5 0 01.5.5v3a.5.5 0 01-.5.5H6a.5.5 0 01-.5-.5v-3a.5.5 0 01.5-.5zM4 15a2 2 0 012-2h3a2 2 0 012 2v3a2 2 0 01-2 2H6a2 2 0 01-2-2v-3z&quot; fillrule=&quot;evenodd&quot; cliprule=&quot;evenodd&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Categories\";s:8:\"category\";s:7:\"widgets\";}i:40;a:4:{s:4:\"name\";s:13:\"core/freeform\";s:4:\"icon\";s:462:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M20 6H4c-1.1 0-2 .9-2 2v9c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm.5 11c0 .3-.2.5-.5.5H4c-.3 0-.5-.2-.5-.5V8c0-.3.2-.5.5-.5h16c.3 0 .5.2.5.5v9zM10 10H8v2h2v-2zm-5 2h2v-2H5v2zm8-2h-2v2h2v-2zm-5 6h8v-2H8v2zm6-4h2v-2h-2v2zm3 0h2v-2h-2v2zm0 4h2v-2h-2v2zM5 16h2v-2H5v2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:7:\"Classic\";s:8:\"category\";s:4:\"text\";}i:41;a:4:{s:4:\"name\";s:9:\"core/code\";s:4:\"icon\";s:373:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M20.8 10.7l-4.3-4.3-1.1 1.1 4.3 4.3c.1.1.1.3 0 .4l-4.3 4.3 1.1 1.1 4.3-4.3c.7-.8.7-1.9 0-2.6zM4.2 11.8l4.3-4.3-1-1-4.3 4.3c-.7.7-.7 1.8 0 2.5l4.3 4.3 1.1-1.1-4.3-4.3c-.2-.1-.2-.3-.1-.4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:4:\"Code\";s:8:\"category\";s:4:\"text\";}i:42;a:5:{s:4:\"name\";s:11:\"core/column\";s:4:\"icon\";s:362:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 6H6c-1.1 0-2 .9-2 2v9c0 1.1.9 2 2 2h13c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zM6 17.5c-.3 0-.5-.2-.5-.5V8c0-.3.2-.5.5-.5h3v10H6zm13.5-.5c0 .3-.2.5-.5.5h-3v-10h3c.3 0 .5.2.5.5v9z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:6:\"Column\";s:8:\"category\";s:4:\"text\";s:6:\"parent\";a:1:{i:0;s:12:\"core/columns\";}}i:43;a:4:{s:4:\"name\";s:12:\"core/columns\";s:4:\"icon\";s:388:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 6H6c-1.1 0-2 .9-2 2v9c0 1.1.9 2 2 2h13c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm-4.1 1.5v10H10v-10h4.9zM5.5 17V8c0-.3.2-.5.5-.5h2.5v10H6c-.3 0-.5-.2-.5-.5zm14 0c0 .3-.2.5-.5.5h-2.6v-10H19c.3 0 .5.2.5.5v9z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:7:\"Columns\";s:8:\"category\";s:6:\"design\";}i:44;a:4:{s:4:\"name\";s:10:\"core/cover\";s:4:\"icon\";s:398:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18.7 3H5.3C4 3 3 4 3 5.3v13.4C3 20 4 21 5.3 21h13.4c1.3 0 2.3-1 2.3-2.3V5.3C21 4 20 3 18.7 3zm.8 15.7c0 .4-.4.8-.8.8H5.3c-.4 0-.8-.4-.8-.8V5.3c0-.4.4-.8.8-.8h6.2v8.9l2.5-3.1 2.5 3.1V4.5h2.2c.4 0 .8.4.8.8v13.4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Cover\";s:8:\"category\";s:5:\"media\";}i:45;a:4:{s:4:\"name\";s:10:\"core/embed\";s:4:\"icon\";s:429:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm.5 16c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V9.8l4.7-5.3H19c.3 0 .5.2.5.5v14zm-6-9.5L16 12l-2.5 2.8 1.1 1L18 12l-3.5-3.5-1 1zm-3 0l-1-1L6 12l3.5 3.8 1.1-1L8 12l2.5-2.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Embed\";s:8:\"category\";s:5:\"embed\";}i:46;a:4:{s:4:\"name\";s:9:\"core/file\";s:4:\"icon\";s:408:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 6.2h-5.9l-.6-1.1c-.3-.7-1-1.1-1.8-1.1H5c-1.1 0-2 .9-2 2v11.8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V8.2c0-1.1-.9-2-2-2zm.5 11.6c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h5.8c.2 0 .4.1.4.3l1 2H19c.3 0 .5.2.5.5v9.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:4:\"File\";s:8:\"category\";s:5:\"media\";}i:47;a:4:{s:4:\"name\";s:10:\"core/group\";s:4:\"icon\";s:526:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18 4h-7c-1.1 0-2 .9-2 2v3H6c-1.1 0-2 .9-2 2v7c0 1.1.9 2 2 2h7c1.1 0 2-.9 2-2v-3h3c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-4.5 14c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5v-7c0-.3.2-.5.5-.5h3V13c0 1.1.9 2 2 2h2.5v3zm0-4.5H11c-.3 0-.5-.2-.5-.5v-2.5H13c.3 0 .5.2.5.5v2.5zm5-.5c0 .3-.2.5-.5.5h-3V11c0-1.1-.9-2-2-2h-2.5V6c0-.3.2-.5.5-.5h7c.3 0 .5.2.5.5v7z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Group\";s:8:\"category\";s:6:\"design\";}i:48;a:4:{s:4:\"name\";s:9:\"core/html\";s:4:\"icon\";s:379:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M4.8 11.4H2.1V9H1v6h1.1v-2.6h2.7V15h1.1V9H4.8v2.4zm1.9-1.3h1.7V15h1.1v-4.9h1.7V9H6.7v1.1zM16.2 9l-1.5 2.7L13.3 9h-.9l-.8 6h1.1l.5-4 1.5 2.8 1.5-2.8.5 4h1.1L17 9h-.8zm3.8 5V9h-1.1v6h3.6v-1H20z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:11:\"Custom HTML\";s:8:\"category\";s:7:\"widgets\";}i:49;a:4:{s:4:\"name\";s:20:\"core/latest-comments\";s:4:\"icon\";s:364:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18 4H6c-1.1 0-2 .9-2 2v12.9c0 .6.5 1.1 1.1 1.1.3 0 .5-.1.8-.3L8.5 17H18c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm.5 11c0 .3-.2.5-.5.5H7.9l-2.4 2.4V6c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v9z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:15:\"Latest Comments\";s:8:\"category\";s:7:\"widgets\";}i:50;a:4:{s:4:\"name\";s:17:\"core/latest-posts\";s:4:\"icon\";s:400:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18 4H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm.5 14c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v12zM7 11h2V9H7v2zm0 4h2v-2H7v2zm3-4h7V9h-7v2zm0 4h7v-2h-7v2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Latest Posts\";s:8:\"category\";s:7:\"widgets\";}i:51;a:4:{s:4:\"name\";s:15:\"core/media-text\";s:4:\"icon\";s:262:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M3 18h8V6H3v12zM14 7.5V9h7V7.5h-7zm0 5.3h7v-1.5h-7v1.5zm0 3.7h7V15h-7v1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Media & Text\";s:8:\"category\";s:5:\"media\";}i:52;a:4:{s:4:\"name\";s:12:\"core/missing\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:11:\"Unsupported\";s:8:\"category\";s:4:\"text\";}i:53;a:4:{s:4:\"name\";s:9:\"core/more\";s:4:\"icon\";s:259:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M4 9v1.5h16V9H4zm12 5.5h4V13h-4v1.5zm-6 0h4V13h-4v1.5zm-6 0h4V13H4v1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:4:\"More\";s:8:\"category\";s:6:\"design\";}i:54;a:5:{s:4:\"name\";s:13:\"core/nextpage\";s:4:\"icon\";s:429:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M7.8 6c0-.7.6-1.2 1.2-1.2h6c.7 0 1.2.6 1.2 1.2v3h1.5V6c0-1.5-1.2-2.8-2.8-2.8H9C7.5 3.2 6.2 4.5 6.2 6v3h1.5V6zm8.4 11c0 .7-.6 1.2-1.2 1.2H9c-.7 0-1.2-.6-1.2-1.2v-3H6.2v3c0 1.5 1.2 2.8 2.8 2.8h6c1.5 0 2.8-1.2 2.8-2.8v-3h-1.5v3zM4 11v1h16v-1H4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Page Break\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:17:\"core/post-content\";}}i:55;a:4:{s:4:\"name\";s:14:\"core/page-list\";s:4:\"icon\";s:472:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M7 13.8h6v-1.5H7v1.5zM18 16V4c0-1.1-.9-2-2-2H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2zM5.5 16V4c0-.3.2-.5.5-.5h10c.3 0 .5.2.5.5v12c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5zM7 10.5h8V9H7v1.5zm0-3.3h8V5.8H7v1.4zM20.2 6v13c0 .7-.6 1.2-1.2 1.2H8v1.5h11c1.5 0 2.7-1.2 2.7-2.8V6h-1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Page List\";s:8:\"category\";s:7:\"widgets\";}i:56;a:4:{s:4:\"name\";s:12:\"core/pattern\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:7:\"Pattern\";s:8:\"category\";s:5:\"theme\";}i:57;a:4:{s:4:\"name\";s:17:\"core/preformatted\";s:4:\"icon\";s:415:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18 4H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm.5 14c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v12zM7 16.5h6V15H7v1.5zm4-4h6V11h-6v1.5zM9 11H7v1.5h2V11zm6 5.5h2V15h-2v1.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Preformatted\";s:8:\"category\";s:4:\"text\";}i:58;a:4:{s:4:\"name\";s:14:\"core/pullquote\";s:4:\"icon\";s:377:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18 8H6c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2zm.5 6c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5v-4c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v4zM4 4v1.5h16V4H4zm0 16h16v-1.5H4V20z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Pullquote\";s:8:\"category\";s:4:\"text\";}i:59;a:4:{s:4:\"name\";s:10:\"core/block\";s:4:\"icon\";s:518:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M21.3 10.8l-5.6-5.6c-.7-.7-1.8-.7-2.5 0l-5.6 5.6c-.7.7-.7 1.8 0 2.5l5.6 5.6c.3.3.8.5 1.2.5s.9-.2 1.2-.5l5.6-5.6c.8-.7.8-1.9.1-2.5zm-1 1.4l-5.6 5.6c-.1.1-.3.1-.4 0l-5.6-5.6c-.1-.1-.1-.3 0-.4l5.6-5.6s.1-.1.2-.1.1 0 .2.1l5.6 5.6c.1.1.1.3 0 .4zm-16.6-.4L10 5.5l-1-1-6.3 6.3c-.7.7-.7 1.8 0 2.5L9 19.5l1.1-1.1-6.3-6.3c-.2 0-.2-.2-.1-.3z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:14:\"Reusable block\";s:8:\"category\";s:8:\"reusable\";}i:60;a:4:{s:4:\"name\";s:8:\"core/rss\";s:4:\"icon\";s:434:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M5 10.2h-.8v1.5H5c1.9 0 3.8.8 5.1 2.1 1.4 1.4 2.1 3.2 2.1 5.1v.8h1.5V19c0-2.3-.9-4.5-2.6-6.2-1.6-1.6-3.8-2.6-6.1-2.6zm10.4-1.6C12.6 5.8 8.9 4.2 5 4.2h-.8v1.5H5c3.5 0 6.9 1.4 9.4 3.9s3.9 5.8 3.9 9.4v.8h1.5V19c0-3.9-1.6-7.6-4.4-10.4zM4 20h3v-3H4v3z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:3:\"RSS\";s:8:\"category\";s:7:\"widgets\";}i:61;a:4:{s:4:\"name\";s:11:\"core/search\";s:4:\"icon\";s:369:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M13.5 6C10.5 6 8 8.5 8 11.5c0 1.1.3 2.1.9 3l-3.4 3 1 1.1 3.4-2.9c1 .9 2.2 1.4 3.6 1.4 3 0 5.5-2.5 5.5-5.5C19 8.5 16.5 6 13.5 6zm0 9.5c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4-1.8 4-4 4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:6:\"Search\";s:8:\"category\";s:7:\"widgets\";}i:62;a:4:{s:4:\"name\";s:14:\"core/separator\";s:4:\"icon\";s:233:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M20.2 7v4H3.8V7H2.2v9h1.6v-3.5h16.4V16h1.6V7z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Separator\";s:8:\"category\";s:6:\"design\";}i:63;a:4:{s:4:\"name\";s:14:\"core/shortcode\";s:4:\"icon\";s:302:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M16 4.2v1.5h2.5v12.5H16v1.5h4V4.2h-4zM4.2 19.8h4v-1.5H5.8V5.8h2.5V4.2h-4l-.1 15.6zm5.1-3.1l1.4.6 4-10-1.4-.6-4 10z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Shortcode\";s:8:\"category\";s:7:\"widgets\";}i:64;a:5:{s:4:\"name\";s:16:\"core/social-link\";s:4:\"icon\";s:435:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M9 11.8l6.1-4.5c.1.4.4.7.9.7h2c.6 0 1-.4 1-1V5c0-.6-.4-1-1-1h-2c-.6 0-1 .4-1 1v.4l-6.4 4.8c-.2-.1-.4-.2-.6-.2H6c-.6 0-1 .4-1 1v2c0 .6.4 1 1 1h2c.2 0 .4-.1.6-.2l6.4 4.8v.4c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2c0-.6-.4-1-1-1h-2c-.5 0-.8.3-.9.7L9 12.2v-.4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:11:\"Social Icon\";s:8:\"category\";s:7:\"widgets\";s:6:\"parent\";a:1:{i:0;s:17:\"core/social-links\";}}i:65;a:4:{s:4:\"name\";s:17:\"core/social-links\";s:4:\"icon\";s:435:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M9 11.8l6.1-4.5c.1.4.4.7.9.7h2c.6 0 1-.4 1-1V5c0-.6-.4-1-1-1h-2c-.6 0-1 .4-1 1v.4l-6.4 4.8c-.2-.1-.4-.2-.6-.2H6c-.6 0-1 .4-1 1v2c0 .6.4 1 1 1h2c.2 0 .4-.1.6-.2l6.4 4.8v.4c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2c0-.6-.4-1-1-1h-2c-.5 0-.8.3-.9.7L9 12.2v-.4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Social Icons\";s:8:\"category\";s:7:\"widgets\";}i:66;a:4:{s:4:\"name\";s:11:\"core/spacer\";s:4:\"icon\";s:259:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M12.5 4.2v1.6h4.7L5.8 17.2V12H4.2v7.8H12v-1.6H6.8L18.2 6.8v4.7h1.6V4.2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:6:\"Spacer\";s:8:\"category\";s:6:\"design\";}i:67;a:4:{s:4:\"name\";s:10:\"core/table\";s:4:\"icon\";s:428:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM5 4.5h14c.3 0 .5.2.5.5v3.5h-15V5c0-.3.2-.5.5-.5zm8 5.5h6.5v3.5H13V10zm-1.5 3.5h-7V10h7v3.5zm-7 5.5v-4h7v4.5H5c-.3 0-.5-.2-.5-.5zm14.5.5h-6V15h6.5v4c0 .3-.2.5-.5.5z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Table\";s:8:\"category\";s:4:\"text\";}i:68;a:4:{s:4:\"name\";s:14:\"core/tag-cloud\";s:4:\"icon\";s:533:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M20.1 11.2l-6.7-6.7c-.1-.1-.3-.2-.5-.2H5c-.4-.1-.8.3-.8.7v7.8c0 .2.1.4.2.5l6.7 6.7c.2.2.5.4.7.5s.6.2.9.2c.3 0 .6-.1.9-.2.3-.1.5-.3.8-.5l5.6-5.6c.4-.4.7-1 .7-1.6.1-.6-.2-1.2-.6-1.6zM19 13.4L13.4 19c-.1.1-.2.1-.3.2-.2.1-.4.1-.6 0-.1 0-.2-.1-.3-.2l-6.5-6.5V5.8h6.8l6.5 6.5c.2.2.2.4.2.6 0 .1 0 .3-.2.5zM9 8c-.6 0-1 .4-1 1s.4 1 1 1 1-.4 1-1-.4-1-1-1z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Tag Cloud\";s:8:\"category\";s:7:\"widgets\";}i:69;a:4:{s:4:\"name\";s:17:\"core/text-columns\";s:4:\"icon\";s:80:\"&lt;span class=&quot;dashicon dashicons dashicons-columns&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:25:\"Text Columns (deprecated)\";s:8:\"category\";s:6:\"design\";}i:70;a:4:{s:4:\"name\";s:10:\"core/verse\";s:4:\"icon\";s:625:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M17.8 2l-.9.3c-.1 0-3.6 1-5.2 2.1C10 5.5 9.3 6.5 8.9 7.1c-.6.9-1.7 4.7-1.7 6.3l-.9 2.3c-.2.4 0 .8.4 1 .1 0 .2.1.3.1.3 0 .6-.2.7-.5l.6-1.5c.3 0 .7-.1 1.2-.2.7-.1 1.4-.3 2.2-.5.8-.2 1.6-.5 2.4-.8.7-.3 1.4-.7 1.9-1.2s.8-1.2 1-1.9c.2-.7.3-1.6.4-2.4.1-.8.1-1.7.2-2.5 0-.8.1-1.5.2-2.1V2zm-1.9 5.6c-.1.8-.2 1.5-.3 2.1-.2.6-.4 1-.6 1.3-.3.3-.8.6-1.4.9-.7.3-1.4.5-2.2.8-.6.2-1.3.3-1.8.4L15 7.5c.3-.3.6-.7 1-1.1 0 .4 0 .8-.1 1.2zM6 20h8v-1.5H6V20z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Verse\";s:8:\"category\";s:4:\"text\";}i:71;a:4:{s:4:\"name\";s:10:\"core/video\";s:4:\"icon\";s:388:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18.7 3H5.3C4 3 3 4 3 5.3v13.4C3 20 4 21 5.3 21h13.4c1.3 0 2.3-1 2.3-2.3V5.3C21 4 20 3 18.7 3zm.8 15.7c0 .4-.4.8-.8.8H5.3c-.4 0-.8-.4-.8-.8V5.3c0-.4.4-.8.8-.8h13.4c.4 0 .8.4.8.8v13.4zM10 15l5-3-5-3v6z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Video\";s:8:\"category\";s:5:\"media\";}i:72;a:4:{s:4:\"name\";s:15:\"core/navigation\";s:4:\"icon\";s:350:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M12 4c-4.4 0-8 3.6-8 8s3.6 8 8 8 8-3.6 8-8-3.6-8-8-8zm0 14.5c-3.6 0-6.5-2.9-6.5-6.5S8.4 5.5 12 5.5s6.5 2.9 6.5 6.5-2.9 6.5-6.5 6.5zM9 16l4.5-3L15 8.4l-4.5 3L9 16z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Navigation\";s:8:\"category\";s:5:\"theme\";}i:73;a:5:{s:4:\"name\";s:20:\"core/navigation-link\";s:4:\"icon\";s:553:\"&lt;svg xmlns=&quot;https://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M12.5 14.5h-1V16h1c2.2 0 4-1.8 4-4s-1.8-4-4-4h-1v1.5h1c1.4 0 2.5 1.1 2.5 2.5s-1.1 2.5-2.5 2.5zm-4 1.5v-1.5h-1C6.1 14.5 5 13.4 5 12s1.1-2.5 2.5-2.5h1V8h-1c-2.2 0-4 1.8-4 4s1.8 4 4 4h1zm-1-3.2h5v-1.5h-5v1.5zM18 4H9c-1.1 0-2 .9-2 2v.5h1.5V6c0-.3.2-.5.5-.5h9c.3 0 .5.2.5.5v12c0 .3-.2.5-.5.5H9c-.3 0-.5-.2-.5-.5v-.5H7v.5c0 1.1.9 2 2 2h9c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:11:\"Custom Link\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:15:\"core/navigation\";}}i:74;a:5:{s:4:\"name\";s:23:\"core/navigation-submenu\";s:4:\"icon\";s:350:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M2 12c0 3.6 2.4 5.5 6 5.5h.5V19l3-2.5-3-2.5v2H8c-2.5 0-4.5-1.5-4.5-4s2-4.5 4.5-4.5h3.5V6H8c-3.6 0-6 2.4-6 6zm19.5-1h-8v1.5h8V11zm0 5h-8v1.5h8V16zm0-10h-8v1.5h8V6z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:7:\"Submenu\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:15:\"core/navigation\";}}i:75;a:4:{s:4:\"name\";s:14:\"core/site-logo\";s:4:\"icon\";s:499:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M12 3c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 1.5c4.1 0 7.5 3.4 7.5 7.5v.1c-1.4-.8-3.3-1.7-3.4-1.8-.2-.1-.5-.1-.8.1l-2.9 2.1L9 11.3c-.2-.1-.4 0-.6.1l-3.7 2.2c-.1-.5-.2-1-.2-1.5 0-4.2 3.4-7.6 7.5-7.6zm0 15c-3.1 0-5.7-1.9-6.9-4.5l3.7-2.2 3.5 1.2c.2.1.5 0 .7-.1l2.9-2.1c.8.4 2.5 1.2 3.5 1.9-.9 3.3-3.9 5.8-7.4 5.8z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Site Logo\";s:8:\"category\";s:5:\"theme\";}i:76;a:4:{s:4:\"name\";s:15:\"core/site-title\";s:4:\"icon\";s:593:\"&lt;svg xmlns=&quot;https://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M12 9c-.8 0-1.5.7-1.5 1.5S11.2 12 12 12s1.5-.7 1.5-1.5S12.8 9 12 9zm0-5c-3.6 0-6.5 2.8-6.5 6.2 0 .8.3 1.8.9 3.1.5 1.1 1.2 2.3 2 3.6.7 1 3 3.8 3.2 3.9l.4.5.4-.5c.2-.2 2.6-2.9 3.2-3.9.8-1.2 1.5-2.5 2-3.6.6-1.3.9-2.3.9-3.1C18.5 6.8 15.6 4 12 4zm4.3 8.7c-.5 1-1.1 2.2-1.9 3.4-.5.7-1.7 2.2-2.4 3-.7-.8-1.9-2.3-2.4-3-.8-1.2-1.4-2.3-1.9-3.3-.6-1.4-.7-2.2-.7-2.5 0-2.6 2.2-4.7 5-4.7s5 2.1 5 4.7c0 .2-.1 1-.7 2.4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Site Title\";s:8:\"category\";s:5:\"theme\";}i:77;a:4:{s:4:\"name\";s:17:\"core/site-tagline\";s:4:\"icon\";s:305:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;24&quot; height=&quot;24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M4 9h16v2H4V9zm0 4h10v2H4v-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Site Tagline\";s:8:\"category\";s:5:\"theme\";}i:78;a:4:{s:4:\"name\";s:10:\"core/query\";s:4:\"icon\";s:1090:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18.1823 11.6392C18.1823 13.0804 17.0139 14.2487 15.5727 14.2487C14.3579 14.2487 13.335 13.4179 13.0453 12.2922L13.0377 12.2625L13.0278 12.2335L12.3985 10.377L12.3942 10.3785C11.8571 8.64997 10.246 7.39405 8.33961 7.39405C5.99509 7.39405 4.09448 9.29465 4.09448 11.6392C4.09448 13.9837 5.99509 15.8843 8.33961 15.8843C8.88499 15.8843 9.40822 15.781 9.88943 15.5923L9.29212 14.0697C8.99812 14.185 8.67729 14.2487 8.33961 14.2487C6.89838 14.2487 5.73003 13.0804 5.73003 11.6392C5.73003 10.1979 6.89838 9.02959 8.33961 9.02959C9.55444 9.02959 10.5773 9.86046 10.867 10.9862L10.8772 10.9836L11.4695 12.7311C11.9515 14.546 13.6048 15.8843 15.5727 15.8843C17.9172 15.8843 19.8178 13.9837 19.8178 11.6392C19.8178 9.29465 17.9172 7.39404 15.5727 7.39404C15.0287 7.39404 14.5066 7.4968 14.0264 7.6847L14.6223 9.20781C14.9158 9.093 15.2358 9.02959 15.5727 9.02959C17.0139 9.02959 18.1823 10.1979 18.1823 11.6392Z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Query Loop\";s:8:\"category\";s:5:\"theme\";}i:79;a:4:{s:4:\"name\";s:18:\"core/template-part\";s:4:\"icon\";s:407:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M21.3 10.8l-5.6-5.6c-.7-.7-1.8-.7-2.5 0l-5.6 5.6c-.7.7-.7 1.8 0 2.5l5.6 5.6c.3.3.8.5 1.2.5s.9-.2 1.2-.5l5.6-5.6c.8-.7.8-1.9.1-2.5zm-17.6 1L10 5.5l-1-1-6.3 6.3c-.7.7-.7 1.8 0 2.5L9 19.5l1.1-1.1-6.3-6.3c-.2 0-.2-.2-.1-.3z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Template Part\";s:8:\"category\";s:5:\"theme\";}i:80;a:4:{s:4:\"name\";s:15:\"core/post-title\";s:4:\"icon\";s:446:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M4 14.5h16V16H4zM4 18.5h9V20H4zM4 4h3c2 0 3 .86 3 2.583 0 .891-.253 1.554-.76 1.988-.505.435-1.24.652-2.204.652H5.542V12H4V4zm2.855 4c.53 0 .924-.114 1.18-.343.266-.228.398-.579.398-1.051 0-.473-.132-.82-.397-1.04-.265-.229-.67-.343-1.217-.343H5.542V8h1.313z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Post Title\";s:8:\"category\";s:5:\"theme\";}i:81;a:4:{s:4:\"name\";s:17:\"core/post-excerpt\";s:4:\"icon\";s:648:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M12.75 9.333c0 .521-.102.977-.327 1.354-.23.386-.555.628-.893.774-.545.234-1.183.227-1.544.222l-.12-.001v-1.5h.123c.414.001.715.002.948-.099a.395.395 0 00.199-.166c.05-.083.114-.253.114-.584V7.2H8.8V4h3.95v5.333zM7.95 9.333c0 .521-.102.977-.327 1.354-.23.386-.555.628-.893.774-.545.234-1.183.227-1.544.222l-.12-.001v-1.5h.123c.414.001.715.002.948-.099a.394.394 0 00.198-.166c.05-.083.115-.253.115-.584V7.2H4V4h3.95v5.333zM13 20H4v-1.5h9V20zM20 16H4v-1.5h16V16z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Post Excerpt\";s:8:\"category\";s:5:\"theme\";}i:82;a:4:{s:4:\"name\";s:24:\"core/post-featured-image\";s:4:\"icon\";s:439:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M19 3H5c-.6 0-1 .4-1 1v7c0 .5.4 1 1 1h14c.5 0 1-.4 1-1V4c0-.6-.4-1-1-1zM5.5 10.5v-.4l1.8-1.3 1.3.8c.3.2.7.2.9-.1L11 8.1l2.4 2.4H5.5zm13 0h-2.9l-4-4c-.3-.3-.8-.3-1.1 0L8.9 8l-1.2-.8c-.3-.2-.6-.2-.9 0l-1.3 1V4.5h13v6zM4 20h9v-1.5H4V20zm0-4h16v-1.5H4V16z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:19:\"Post Featured Image\";s:8:\"category\";s:5:\"theme\";}i:83;a:4:{s:4:\"name\";s:17:\"core/post-content\";s:4:\"icon\";s:266:\"&lt;svg xmlns=&quot;https://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M4 20h16v-1.5H4V20zm0-4.8h16v-1.5H4v1.5zm0-6.4v1.5h16V8.8H4zM16 4H4v1.5h12V4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Post Content\";s:8:\"category\";s:5:\"theme\";}i:84;a:4:{s:4:\"name\";s:16:\"core/post-author\";s:4:\"icon\";s:480:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M10 4.5a1 1 0 11-2 0 1 1 0 012 0zm1.5 0a2.5 2.5 0 11-5 0 2.5 2.5 0 015 0zm2.25 7.5v-1A2.75 2.75 0 0011 8.25H7A2.75 2.75 0 004.25 11v1h1.5v-1c0-.69.56-1.25 1.25-1.25h4c.69 0 1.25.56 1.25 1.25v1h1.5zM4 20h9v-1.5H4V20zm16-4H4v-1.5h16V16z&quot; fillrule=&quot;evenodd&quot; cliprule=&quot;evenodd&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:11:\"Post Author\";s:8:\"category\";s:5:\"theme\";}i:85;a:4:{s:4:\"name\";s:14:\"core/post-date\";s:4:\"icon\";s:735:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M11.696 13.972c.356-.546.599-.958.728-1.235a1.79 1.79 0 00.203-.783c0-.264-.077-.47-.23-.618-.148-.153-.354-.23-.618-.23-.295 0-.569.07-.82.212a3.413 3.413 0 00-.738.571l-.147-1.188c.289-.234.59-.41.903-.526.313-.117.66-.175 1.041-.175.375 0 .695.08.959.24.264.153.46.362.59.626.135.265.203.556.203.876 0 .362-.08.734-.24 1.115-.154.381-.427.87-.82 1.466l-.756 1.152H14v1.106h-4l1.696-2.609z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M19.5 7h-15v12a.5.5 0 00.5.5h14a.5.5 0 00.5-.5V7zM3 7V5a2 2 0 012-2h14a2 2 0 012 2v14a2 2 0 01-2 2H5a2 2 0 01-2-2V7z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Post Date\";s:8:\"category\";s:5:\"theme\";}i:86;a:4:{s:4:\"name\";s:15:\"core/post-terms\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:10:\"Post Terms\";s:8:\"category\";s:5:\"theme\";}i:87;a:4:{s:4:\"name\";s:25:\"core/post-navigation-link\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:20:\"Post Navigation Link\";s:8:\"category\";s:5:\"theme\";}i:88;a:5:{s:4:\"name\";s:18:\"core/post-template\";s:4:\"icon\";s:368:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M18 5.5H6a.5.5 0 00-.5.5v3h13V6a.5.5 0 00-.5-.5zm.5 5H10v8h8a.5.5 0 00.5-.5v-7.5zm-10 0h-3V18a.5.5 0 00.5.5h2.5v-8zM6 4h12a2 2 0 012 2v12a2 2 0 01-2 2H6a2 2 0 01-2-2V6a2 2 0 012-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Post Template\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:10:\"core/query\";}}i:89;a:5:{s:4:\"name\";s:21:\"core/query-pagination\";s:4:\"icon\";s:576:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;rect x=&quot;4&quot; y=&quot;10.5&quot; width=&quot;6&quot; height=&quot;3&quot; rx=&quot;1.5&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;rect x=&quot;12&quot; y=&quot;10.5&quot; width=&quot;3&quot; height=&quot;3&quot; rx=&quot;1.5&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;rect x=&quot;17&quot; y=&quot;10.5&quot; width=&quot;3&quot; height=&quot;3&quot; rx=&quot;1.5&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;/svg&gt;\";s:5:\"title\";s:10:\"Pagination\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:10:\"core/query\";}}i:90;a:5:{s:4:\"name\";s:26:\"core/query-pagination-next\";s:4:\"icon\";s:552:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;rect x=&quot;6&quot; y=&quot;10.5&quot; width=&quot;3&quot; height=&quot;3&quot; rx=&quot;1.5&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;rect x=&quot;11&quot; y=&quot;10.5&quot; width=&quot;3&quot; height=&quot;3&quot; rx=&quot;1.5&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;path d=&quot;M16.5 9.5L19 12l-2.5 2.5&quot; stroke=&quot;#1E1E1E&quot; strokewidth=&quot;1.5&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Next Page\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:21:\"core/query-pagination\";}}i:91;a:5:{s:4:\"name\";s:29:\"core/query-pagination-numbers\";s:4:\"icon\";s:693:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;rect x=&quot;4&quot; y=&quot;10.5&quot; width=&quot;6&quot; height=&quot;3&quot; rx=&quot;1.5&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;path d=&quot;M13.5 14v-4l-1.5.5&quot; stroke=&quot;#1E1E1E&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M19.266 9.805c-.473-.611-1.22-.51-1.702-.367a3.854 3.854 0 00-.718.307l.13 1.082c.192-.17.47-.422.782-.515.34-.1.578.025.668.141.21.27-.034.835-.16 1.055-.49.85-.93 1.594-1.45 2.492H19.5v-1h-.914c.277-.574.814-1.443.914-2.106.052-.343.02-.762-.234-1.09z&quot; fill=&quot;#1E1E1E&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:12:\"Page Numbers\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:21:\"core/query-pagination\";}}i:92;a:5:{s:4:\"name\";s:30:\"core/query-pagination-previous\";s:4:\"icon\";s:637:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;rect x=&quot;18&quot; y=&quot;13.5&quot; width=&quot;3&quot; height=&quot;3&quot; rx=&quot;1.5&quot; transform=&quot;rotate(-180 18 13.5)&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;rect x=&quot;13&quot; y=&quot;13.5&quot; width=&quot;3&quot; height=&quot;3&quot; rx=&quot;1.5&quot; transform=&quot;rotate(-180 13 13.5)&quot; fill=&quot;#000&quot;&gt;&lt;/rect&gt;&lt;path d=&quot;M7.5 14.5L5 12l2.5-2.5&quot; stroke=&quot;#1E1E1E&quot; strokewidth=&quot;1.5&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Previous Page\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:21:\"core/query-pagination\";}}i:93;a:4:{s:4:\"name\";s:18:\"core/post-comments\";s:4:\"icon\";s:479:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M14 10.1V4c0-.6-.4-1-1-1H5c-.6 0-1 .4-1 1v8.3c0 .3.2.7.6.8.1.1.2.1.3.1.2 0 .5-.1.6-.3l1.8-1.8H13c.6 0 1-.4 1-1zm-1.5-.5H6.7l-1.2 1.2V4.5h7v5.1zM19 12h-8c-.6 0-1 .4-1 1v6.1c0 .6.4 1 1 1h5.7l1.8 1.8c.1.2.4.3.6.3.1 0 .2 0 .3-.1.4-.1.6-.5.6-.8V13c0-.6-.4-1-1-1zm-.5 7.8l-1.2-1.2h-5.8v-5.1h7v6.3z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:13:\"Post Comments\";s:8:\"category\";s:5:\"theme\";}i:94;a:4:{s:4:\"name\";s:13:\"core/loginout\";s:4:\"icon\";s:422:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path d=&quot;M11 14.5l1.1 1.1 3-3 .5-.5-.6-.6-3-3-1 1 1.7 1.7H5v1.5h7.7L11 14.5zM16.8 5h-7c-1.1 0-2 .9-2 2v1.5h1.5V7c0-.3.2-.5.5-.5h7c.3 0 .5.2.5.5v10c0 .3-.2.5-.5.5h-7c-.3 0-.5-.2-.5-.5v-1.5H7.8V17c0 1.1.9 2 2 2h7c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:9:\"Login/out\";s:8:\"category\";s:5:\"theme\";}i:95;a:4:{s:4:\"name\";s:21:\"core/term-description\";s:4:\"icon\";s:457:\"&lt;svg xmlns=&quot;http://www.w3.org/2000/svg&quot; viewbox=&quot;0 0 24 24&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot;&gt;&lt;path stroke=&quot;#1E1E1E&quot; strokewidth=&quot;1.5&quot; d=&quot;M9 19.25h6M4 19.25h4M12 15.25h8M4 15.25h7&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M8.994 10.103H6.08L5.417 12H4l2.846-8h1.383l2.845 8H9.657l-.663-1.897zm-.457-1.28l-.994-2.857-1.006 2.857h2z&quot; fill=&quot;#1E1E1E&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:16:\"Term Description\";s:8:\"category\";s:5:\"theme\";}i:96;a:4:{s:4:\"name\";s:16:\"core/query-title\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:11:\"Query Title\";s:8:\"category\";s:5:\"theme\";}i:97;a:4:{s:4:\"name\";s:18:\"core/legacy-widget\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:13:\"Legacy Widget\";s:8:\"category\";s:7:\"widgets\";}i:98;a:4:{s:4:\"name\";s:10:\"core/video\";s:4:\"icon\";s:430:\"&lt;svg viewbox=&quot;0 0 24 24&quot; xmlns=&quot;http://www.w3.org/2000/svg&quot; role=&quot;img&quot; aria-hidden=&quot;true&quot; focusable=&quot;false&quot;&gt;&lt;path fill=&quot;none&quot; d=&quot;M0 0h24v24H0V0z&quot;&gt;&lt;/path&gt;&lt;path d=&quot;M4 6.47L5.76 10H20v8H4V6.47M22 4h-4l2 4h-3l-2-4h-2l2 4h-3l-2-4H8l2 4H7L5 4H4c-1.1 0-1.99.9-1.99 2L2 18c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V4z&quot;&gt;&lt;/path&gt;&lt;/svg&gt;\";s:5:\"title\";s:5:\"Video\";s:8:\"category\";s:6:\"common\";}}", "yes");
INSERT INTO `wp_options` VALUES("163", "cptui_new_install", "false", "yes");
INSERT INTO `wp_options` VALUES("166", "duplicator_settings", "a:17:{s:7:\"version\";s:5:\"1.4.4\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:1;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:19:\"installer_name_mode\";s:6:\"simple\";s:16:\"storage_position\";s:6:\"legacy\";s:20:\"storage_htaccess_off\";b:0;s:18:\"archive_build_mode\";i:2;s:17:\"skip_archive_scan\";b:0;s:21:\"unhook_third_party_js\";b:0;s:22:\"unhook_third_party_css\";b:0;s:17:\"active_package_id\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("167", "duplicator_version_plugin", "1.4.4", "yes");
INSERT INTO `wp_options` VALUES("168", "duplicator_package_active", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2022-03-07 23:04:59\";s:7:\"Version\";s:5:\"1.4.4\";s:9:\"VersionWP\";s:5:\"5.9.1\";s:9:\"VersionDB\";s:6:\"5.7.34\";s:10:\"VersionPHP\";s:5:\"8.0.8\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";N;s:4:\"Name\";s:38:\"20220307_eatery_startfiles_wp59_php808\";s:4:\"Hash\";s:35:\"75f37e49073220034218_20220307230459\";s:8:\"NameHash\";s:74:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";s:84:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":21:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:56:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":6:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":7:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2022-03-07 23:04:59\";s:7:\"Version\";s:5:\"1.4.4\";s:9:\"VersionWP\";s:5:\"5.9.1\";s:9:\"VersionDB\";s:6:\"5.7.34\";s:10:\"VersionPHP\";s:5:\"8.0.8\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";N;s:4:\"Name\";s:38:\"20220307_eatery_startfiles_wp59_php808\";s:4:\"Hash\";s:35:\"75f37e49073220034218_20220307230459\";s:8:\"NameHash\";s:74:\"20220307_eatery_startfiles_wp59_php808_75f37e49073220034218_20220307230459\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:21;s:9:\"Installer\";O:13:\"DUP_Installer\":13:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:13:\"OptsDBCharset\";s:0:\"\";s:15:\"OptsDBCollation\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:63;}s:8:\"Database\";O:12:\"DUP_Database\":14:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":16:{s:9:\"buildMode\";N;s:13:\"collationList\";a:0:{}s:17:\"isTablesUpperCase\";N;s:15:\"isNameUpperCase\";N;s:4:\"name\";N;s:15:\"tablesBaseCount\";N;s:16:\"tablesFinalCount\";N;s:14:\"tablesRowCount\";N;s:16:\"tablesSizeOnDisk\";N;s:18:\"varLowerCaseTables\";i:0;s:7:\"version\";N;s:14:\"versionComment\";N;s:18:\"tableWiseRowCounts\";a:0:{}s:11:\"triggerList\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:63;s:24:\"\0DUP_Database\0tempDbPath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:63;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:5:{i:0;s:65:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-admin\";i:1;s:75:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content/uploads\";i:2;s:77:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content/languages\";i:3;s:74:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content/themes\";i:4;s:68:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-includes\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:2:{i:0;s:56:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022\";i:1;s:67:\"/Applications/MAMP/htdocs/CanonicalExercises/Eatery-2022/wp-content\";}}s:9:\"Installer\";r:84;s:8:\"Database\";r:98;s:13:\"BuildProgress\";r:129;}", "yes");
INSERT INTO `wp_options` VALUES("169", "duplicator_exe_safe_mode", "", "yes");
INSERT INTO `wp_options` VALUES("174", "_site_transient_timeout_theme_roots", "1646695176", "no");
INSERT INTO `wp_options` VALUES("175", "_site_transient_theme_roots", "a:4:{s:14:\"twentynineteen\";s:7:\"/themes\";s:12:\"twentytwenty\";s:7:\"/themes\";s:15:\"twentytwentyone\";s:7:\"/themes\";s:15:\"twentytwentytwo\";s:7:\"/themes\";}", "no");
INSERT INTO `wp_options` VALUES("181", "auto_core_update_notified", "a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:15:\"kevinmc@shaw.ca\";s:7:\"version\";s:6:\"5.3.11\";s:9:\"timestamp\";i:1646693061;}", "no");
INSERT INTO `wp_options` VALUES("182", "_transient_timeout_plugin_slugs", "1646779536", "no");
INSERT INTO `wp_options` VALUES("183", "_transient_plugin_slugs", "a:7:{i:0;s:30:\"advanced-custom-fields/acf.php\";i:1;s:19:\"akismet/akismet.php\";i:2;s:43:\"custom-post-type-ui/custom-post-type-ui.php\";i:3;s:32:\"duplicate-page/duplicatepage.php\";i:4;s:25:\"duplicator/duplicator.php\";i:5;s:41:\"advanced-gutenberg/advanced-gutenberg.php\";i:6;s:47:\"show-current-template/show-current-template.php\";}", "no");
INSERT INTO `wp_options` VALUES("185", "widget_akismet_widget", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("188", "advanced-gutenberg_wp_reviews_installed_on", "2022-03-07 22:45:11", "yes");
INSERT INTO `wp_options` VALUES("189", "advgb_blocks_user_roles", "a:3:{s:13:\"administrator\";a:2:{s:13:\"active_blocks\";a:89:{i:0;s:15:\"advgb/accordion\";i:1;s:20:\"advgb/accordion-item\";i:2;s:16:\"advgb/accordions\";i:3;s:12:\"advgb/button\";i:4;s:10:\"advgb/icon\";i:5;s:11:\"advgb/image\";i:6;s:10:\"advgb/list\";i:7;s:11:\"advgb/table\";i:8;s:14:\"advgb/adv-tabs\";i:9;s:9:\"advgb/tab\";i:10;s:11:\"advgb/video\";i:11;s:13:\"advgb/columns\";i:12;s:12:\"advgb/column\";i:13;s:18:\"advgb/contact-form\";i:14;s:14:\"advgb/count-up\";i:15;s:14:\"core/paragraph\";i:16;s:10:\"core/image\";i:17;s:12:\"core/heading\";i:18;s:12:\"core/gallery\";i:19;s:9:\"core/list\";i:20;s:10:\"core/quote\";i:21;s:14:\"core/shortcode\";i:22;s:13:\"core/archives\";i:23;s:10:\"core/audio\";i:24;s:11:\"core/button\";i:25;s:13:\"core/calendar\";i:26;s:15:\"core/categories\";i:27;s:9:\"core/code\";i:28;s:12:\"core/columns\";i:29;s:11:\"core/column\";i:30;s:10:\"core/cover\";i:31;s:10:\"core/embed\";i:32;s:18:\"core-embed/twitter\";i:33;s:18:\"core-embed/youtube\";i:34;s:19:\"core-embed/facebook\";i:35;s:20:\"core-embed/instagram\";i:36;s:20:\"core-embed/wordpress\";i:37;s:21:\"core-embed/soundcloud\";i:38;s:18:\"core-embed/spotify\";i:39;s:17:\"core-embed/flickr\";i:40;s:16:\"core-embed/vimeo\";i:41;s:18:\"core-embed/animoto\";i:42;s:18:\"core-embed/cloudup\";i:43;s:23:\"core-embed/collegehumor\";i:44;s:22:\"core-embed/crowdsignal\";i:45;s:22:\"core-embed/dailymotion\";i:46;s:15:\"core-embed/hulu\";i:47;s:16:\"core-embed/imgur\";i:48;s:16:\"core-embed/issuu\";i:49;s:22:\"core-embed/kickstarter\";i:50;s:21:\"core-embed/meetup-com\";i:51;s:19:\"core-embed/mixcloud\";i:52;s:20:\"core-embed/polldaddy\";i:53;s:17:\"core-embed/reddit\";i:54;s:23:\"core-embed/reverbnation\";i:55;s:21:\"core-embed/screencast\";i:56;s:17:\"core-embed/scribd\";i:57;s:21:\"core-embed/slideshare\";i:58;s:18:\"core-embed/smugmug\";i:59;s:18:\"core-embed/speaker\";i:60;s:23:\"core-embed/speaker-deck\";i:61;s:14:\"core-embed/ted\";i:62;s:17:\"core-embed/tumblr\";i:63;s:21:\"core-embed/videopress\";i:64;s:23:\"core-embed/wordpress-tv\";i:65;s:24:\"core-embed/amazon-kindle\";i:66;s:9:\"core/file\";i:67;s:10:\"core/group\";i:68;s:13:\"core/freeform\";i:69;s:9:\"core/html\";i:70;s:15:\"core/media-text\";i:71;s:20:\"core/latest-comments\";i:72;s:17:\"core/latest-posts\";i:73;s:12:\"core/missing\";i:74;s:9:\"core/more\";i:75;s:13:\"core/nextpage\";i:76;s:17:\"core/preformatted\";i:77;s:14:\"core/pullquote\";i:78;s:8:\"core/rss\";i:79;s:11:\"core/search\";i:80;s:14:\"core/separator\";i:81;s:10:\"core/block\";i:82;s:11:\"core/spacer\";i:83;s:12:\"core/subhead\";i:84;s:10:\"core/table\";i:85;s:14:\"core/tag-cloud\";i:86;s:17:\"core/text-columns\";i:87;s:10:\"core/verse\";i:88;s:10:\"core/video\";}s:15:\"inactive_blocks\";a:1:{i:0;s:15:\"advgb/container\";}}s:6:\"editor\";a:2:{s:13:\"active_blocks\";a:89:{i:0;s:15:\"advgb/accordion\";i:1;s:20:\"advgb/accordion-item\";i:2;s:16:\"advgb/accordions\";i:3;s:12:\"advgb/button\";i:4;s:10:\"advgb/icon\";i:5;s:11:\"advgb/image\";i:6;s:10:\"advgb/list\";i:7;s:11:\"advgb/table\";i:8;s:14:\"advgb/adv-tabs\";i:9;s:9:\"advgb/tab\";i:10;s:11:\"advgb/video\";i:11;s:13:\"advgb/columns\";i:12;s:12:\"advgb/column\";i:13;s:18:\"advgb/contact-form\";i:14;s:14:\"advgb/count-up\";i:15;s:14:\"core/paragraph\";i:16;s:10:\"core/image\";i:17;s:12:\"core/heading\";i:18;s:12:\"core/gallery\";i:19;s:9:\"core/list\";i:20;s:10:\"core/quote\";i:21;s:14:\"core/shortcode\";i:22;s:13:\"core/archives\";i:23;s:10:\"core/audio\";i:24;s:11:\"core/button\";i:25;s:13:\"core/calendar\";i:26;s:15:\"core/categories\";i:27;s:9:\"core/code\";i:28;s:12:\"core/columns\";i:29;s:11:\"core/column\";i:30;s:10:\"core/cover\";i:31;s:10:\"core/embed\";i:32;s:18:\"core-embed/twitter\";i:33;s:18:\"core-embed/youtube\";i:34;s:19:\"core-embed/facebook\";i:35;s:20:\"core-embed/instagram\";i:36;s:20:\"core-embed/wordpress\";i:37;s:21:\"core-embed/soundcloud\";i:38;s:18:\"core-embed/spotify\";i:39;s:17:\"core-embed/flickr\";i:40;s:16:\"core-embed/vimeo\";i:41;s:18:\"core-embed/animoto\";i:42;s:18:\"core-embed/cloudup\";i:43;s:23:\"core-embed/collegehumor\";i:44;s:22:\"core-embed/crowdsignal\";i:45;s:22:\"core-embed/dailymotion\";i:46;s:15:\"core-embed/hulu\";i:47;s:16:\"core-embed/imgur\";i:48;s:16:\"core-embed/issuu\";i:49;s:22:\"core-embed/kickstarter\";i:50;s:21:\"core-embed/meetup-com\";i:51;s:19:\"core-embed/mixcloud\";i:52;s:20:\"core-embed/polldaddy\";i:53;s:17:\"core-embed/reddit\";i:54;s:23:\"core-embed/reverbnation\";i:55;s:21:\"core-embed/screencast\";i:56;s:17:\"core-embed/scribd\";i:57;s:21:\"core-embed/slideshare\";i:58;s:18:\"core-embed/smugmug\";i:59;s:18:\"core-embed/speaker\";i:60;s:23:\"core-embed/speaker-deck\";i:61;s:14:\"core-embed/ted\";i:62;s:17:\"core-embed/tumblr\";i:63;s:21:\"core-embed/videopress\";i:64;s:23:\"core-embed/wordpress-tv\";i:65;s:24:\"core-embed/amazon-kindle\";i:66;s:9:\"core/file\";i:67;s:10:\"core/group\";i:68;s:13:\"core/freeform\";i:69;s:9:\"core/html\";i:70;s:15:\"core/media-text\";i:71;s:20:\"core/latest-comments\";i:72;s:17:\"core/latest-posts\";i:73;s:12:\"core/missing\";i:74;s:9:\"core/more\";i:75;s:13:\"core/nextpage\";i:76;s:17:\"core/preformatted\";i:77;s:14:\"core/pullquote\";i:78;s:8:\"core/rss\";i:79;s:11:\"core/search\";i:80;s:14:\"core/separator\";i:81;s:10:\"core/block\";i:82;s:11:\"core/spacer\";i:83;s:12:\"core/subhead\";i:84;s:10:\"core/table\";i:85;s:14:\"core/tag-cloud\";i:86;s:17:\"core/text-columns\";i:87;s:10:\"core/verse\";i:88;s:10:\"core/video\";}s:15:\"inactive_blocks\";a:1:{i:0;s:15:\"advgb/container\";}}s:6:\"author\";a:2:{s:13:\"active_blocks\";a:89:{i:0;s:15:\"advgb/accordion\";i:1;s:20:\"advgb/accordion-item\";i:2;s:16:\"advgb/accordions\";i:3;s:12:\"advgb/button\";i:4;s:10:\"advgb/icon\";i:5;s:11:\"advgb/image\";i:6;s:10:\"advgb/list\";i:7;s:11:\"advgb/table\";i:8;s:14:\"advgb/adv-tabs\";i:9;s:9:\"advgb/tab\";i:10;s:11:\"advgb/video\";i:11;s:13:\"advgb/columns\";i:12;s:12:\"advgb/column\";i:13;s:18:\"advgb/contact-form\";i:14;s:14:\"advgb/count-up\";i:15;s:14:\"core/paragraph\";i:16;s:10:\"core/image\";i:17;s:12:\"core/heading\";i:18;s:12:\"core/gallery\";i:19;s:9:\"core/list\";i:20;s:10:\"core/quote\";i:21;s:14:\"core/shortcode\";i:22;s:13:\"core/archives\";i:23;s:10:\"core/audio\";i:24;s:11:\"core/button\";i:25;s:13:\"core/calendar\";i:26;s:15:\"core/categories\";i:27;s:9:\"core/code\";i:28;s:12:\"core/columns\";i:29;s:11:\"core/column\";i:30;s:10:\"core/cover\";i:31;s:10:\"core/embed\";i:32;s:18:\"core-embed/twitter\";i:33;s:18:\"core-embed/youtube\";i:34;s:19:\"core-embed/facebook\";i:35;s:20:\"core-embed/instagram\";i:36;s:20:\"core-embed/wordpress\";i:37;s:21:\"core-embed/soundcloud\";i:38;s:18:\"core-embed/spotify\";i:39;s:17:\"core-embed/flickr\";i:40;s:16:\"core-embed/vimeo\";i:41;s:18:\"core-embed/animoto\";i:42;s:18:\"core-embed/cloudup\";i:43;s:23:\"core-embed/collegehumor\";i:44;s:22:\"core-embed/crowdsignal\";i:45;s:22:\"core-embed/dailymotion\";i:46;s:15:\"core-embed/hulu\";i:47;s:16:\"core-embed/imgur\";i:48;s:16:\"core-embed/issuu\";i:49;s:22:\"core-embed/kickstarter\";i:50;s:21:\"core-embed/meetup-com\";i:51;s:19:\"core-embed/mixcloud\";i:52;s:20:\"core-embed/polldaddy\";i:53;s:17:\"core-embed/reddit\";i:54;s:23:\"core-embed/reverbnation\";i:55;s:21:\"core-embed/screencast\";i:56;s:17:\"core-embed/scribd\";i:57;s:21:\"core-embed/slideshare\";i:58;s:18:\"core-embed/smugmug\";i:59;s:18:\"core-embed/speaker\";i:60;s:23:\"core-embed/speaker-deck\";i:61;s:14:\"core-embed/ted\";i:62;s:17:\"core-embed/tumblr\";i:63;s:21:\"core-embed/videopress\";i:64;s:23:\"core-embed/wordpress-tv\";i:65;s:24:\"core-embed/amazon-kindle\";i:66;s:9:\"core/file\";i:67;s:10:\"core/group\";i:68;s:13:\"core/freeform\";i:69;s:9:\"core/html\";i:70;s:15:\"core/media-text\";i:71;s:20:\"core/latest-comments\";i:72;s:17:\"core/latest-posts\";i:73;s:12:\"core/missing\";i:74;s:9:\"core/more\";i:75;s:13:\"core/nextpage\";i:76;s:17:\"core/preformatted\";i:77;s:14:\"core/pullquote\";i:78;s:8:\"core/rss\";i:79;s:11:\"core/search\";i:80;s:14:\"core/separator\";i:81;s:10:\"core/block\";i:82;s:11:\"core/spacer\";i:83;s:12:\"core/subhead\";i:84;s:10:\"core/table\";i:85;s:14:\"core/tag-cloud\";i:86;s:17:\"core/text-columns\";i:87;s:10:\"core/verse\";i:88;s:10:\"core/video\";}s:15:\"inactive_blocks\";a:1:{i:0;s:15:\"advgb/container\";}}}", "yes");
INSERT INTO `wp_options` VALUES("196", "_site_transient_update_themes", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1646693998;s:7:\"checked\";a:4:{s:14:\"twentynineteen\";s:3:\"2.2\";s:12:\"twentytwenty\";s:3:\"1.9\";s:15:\"twentytwentyone\";s:3:\"1.5\";s:15:\"twentytwentytwo\";s:3:\"1.1\";}s:8:\"response\";a:0:{}s:9:\"no_update\";a:4:{s:14:\"twentynineteen\";a:6:{s:5:\"theme\";s:14:\"twentynineteen\";s:11:\"new_version\";s:3:\"2.2\";s:3:\"url\";s:44:\"https://wordpress.org/themes/twentynineteen/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/theme/twentynineteen.2.2.zip\";s:8:\"requires\";s:5:\"4.9.6\";s:12:\"requires_php\";s:5:\"5.2.4\";}s:12:\"twentytwenty\";a:6:{s:5:\"theme\";s:12:\"twentytwenty\";s:11:\"new_version\";s:3:\"1.9\";s:3:\"url\";s:42:\"https://wordpress.org/themes/twentytwenty/\";s:7:\"package\";s:58:\"https://downloads.wordpress.org/theme/twentytwenty.1.9.zip\";s:8:\"requires\";s:3:\"4.7\";s:12:\"requires_php\";s:5:\"5.2.4\";}s:15:\"twentytwentyone\";a:6:{s:5:\"theme\";s:15:\"twentytwentyone\";s:11:\"new_version\";s:3:\"1.5\";s:3:\"url\";s:45:\"https://wordpress.org/themes/twentytwentyone/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/theme/twentytwentyone.1.5.zip\";s:8:\"requires\";s:3:\"5.3\";s:12:\"requires_php\";s:3:\"5.6\";}s:15:\"twentytwentytwo\";a:6:{s:5:\"theme\";s:15:\"twentytwentytwo\";s:11:\"new_version\";s:3:\"1.1\";s:3:\"url\";s:45:\"https://wordpress.org/themes/twentytwentytwo/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/theme/twentytwentytwo.1.1.zip\";s:8:\"requires\";s:3:\"5.9\";s:12:\"requires_php\";s:3:\"5.6\";}}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("198", "widget_block", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("199", "disallowed_keys", "", "no");
INSERT INTO `wp_options` VALUES("200", "comment_previously_approved", "1", "yes");
INSERT INTO `wp_options` VALUES("201", "auto_plugin_theme_update_emails", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("202", "auto_update_core_dev", "enabled", "yes");
INSERT INTO `wp_options` VALUES("203", "auto_update_core_minor", "enabled", "yes");
INSERT INTO `wp_options` VALUES("204", "auto_update_core_major", "unset", "yes");
INSERT INTO `wp_options` VALUES("205", "wp_force_deactivated_plugins", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("206", "finished_updating_comment_type", "1", "yes");
INSERT INTO `wp_options` VALUES("207", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("209", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.9.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-5.9.1.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-5.9.1-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-5.9.1-new-bundled.zip\";s:7:\"partial\";s:0:\"\";s:8:\"rollback\";s:0:\"\";}s:7:\"current\";s:5:\"5.9.1\";s:7:\"version\";s:5:\"5.9.1\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"5.9\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1646693974;s:15:\"version_checked\";s:5:\"5.9.1\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("211", "https_detection_errors", "a:1:{s:20:\"https_request_failed\";a:1:{i:0;s:21:\"HTTPS request failed.\";}}", "yes");
INSERT INTO `wp_options` VALUES("212", "can_compress_scripts", "1", "no");
INSERT INTO `wp_options` VALUES("216", "_site_transient_timeout_browser_dc6b53dac6b9a5e704a6a751b957a28d", "1647298212", "no");
INSERT INTO `wp_options` VALUES("217", "_site_transient_browser_dc6b53dac6b9a5e704a6a751b957a28d", "a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"98.0.4758.109\";s:8:\"platform\";s:9:\"Macintosh\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("218", "_site_transient_timeout_php_check_20f4df878f211a5689e76acb3f9067a8", "1647298212", "no");
INSERT INTO `wp_options` VALUES("219", "_site_transient_php_check_20f4df878f211a5689e76acb3f9067a8", "a:5:{s:19:\"recommended_version\";s:3:\"7.4\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}", "no");
INSERT INTO `wp_options` VALUES("220", "_site_transient_timeout_community-events-d41d8cd98f00b204e9800998ecf8427e", "1646736881", "no");
INSERT INTO `wp_options` VALUES("221", "_site_transient_community-events-d41d8cd98f00b204e9800998ecf8427e", "a:4:{s:9:\"sandboxed\";b:0;s:5:\"error\";N;s:8:\"location\";a:1:{s:2:\"ip\";b:0;}s:6:\"events\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("222", "_transient_timeout_feed_9bbd59226dc36b9b26cd43f15694c5c3", "1646736614", "no");
INSERT INTO `wp_options` VALUES("223", "_transient_feed_9bbd59226dc36b9b26cd43f15694c5c3", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:109:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"The latest news about WordPress and the WordPress community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 22:25:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=6.0-alpha-52828\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:30:{i:0;a:6:{s:4:\"data\";s:61:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WP Briefing: Episode 26: Matt Mullenweg on Ukraine, Community, and WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"https://wordpress.org/news/2022/03/episode-26-matt-mullenweg-on-ukraine-community-and-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 21:39:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"wp-briefing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=12415\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:384:\"Matt Mullenweg speaks to WordPress contributors worldwide on this special edition of the WP Briefing podcast with Josepha Haden Chomphosy. Join us to hear Matt’s thoughts on Ukraine. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits Hosts: Josepha Haden Chomphosy and Matt Mullenweg [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2022/03/WP-Briefing-026.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6361:\"\n<p>Matt Mullenweg speaks to WordPress contributors worldwide on this special edition of the WP Briefing podcast with Josepha Haden Chomphosy. Join us to hear Matt’s thoughts on Ukraine.</p>\n\n\n\n<p><strong><em>H</em></strong><em><strong>ave a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Hosts: <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden Chomphosy</a> and <a href=\"https://profiles.wordpress.org/matt/\">Matt Mullenweg</a></li><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a> &amp; <a href=\"https://profiles.wordpress.org/santanainniss/\">Santana Inniss</a></li></ul>\n\n\n\n<h2>How You Can Help</h2>\n\n\n\n<p><a href=\"https://www.unicefusa.org/stories/unicef-children-crossfire-ukraine-crisis/39542?utm_campaign=20220225_Emergencies&amp;utm_medium=Organic&amp;utm_source=UkraineWebStoryChildrenFeb2022&amp;utm_content=LearnMoreUkraineWebStoryChildrenFeb2022&amp;ms=Organic_PRL_2022_Emergencies_20220225_UkraineWebStoryChildrenFeb2022_LearnMoreUkraineWebStoryChildrenFeb2022_none_none&amp;initialms=Organic_PRL_2022_Emergencies_20220225_UkraineWebStoryChildrenFeb2022_LearnMoreUkraineWebStoryChildrenFeb2022_none_none\">UNICEF</a></p>\n\n\n\n<p><a href=\"https://www.doctorswithoutborders.org/what-we-do/countries/ukraine\">Médecins Sans Frontieres</a>&nbsp;</p>\n\n\n\n<p><a href=\"https://www.icrc.org/en/where-we-work/europe-central-asia/ukraine\">International Committee of the Red Cross</a>&nbsp;</p>\n\n\n\n<p><a href=\"https://help.rescue.org/donate/ukraine-acq?ms=gs_ppc_fy22_ukraine_mmus_feb&amp;initialms=gs_ppc_fy22_ukraine_mmus_feb&amp;gclid=CjwKCAiAjoeRBhAJEiwAYY3nDHNlEUUNRM4wKl1bY0ploy1RNl0M7G1OlLTqawZdg_XhrJ0TircZ_RoCfh8QAvD_BwE\">International Rescue Committee</a></p>\n\n\n\n<p><a href=\"https://www.unrefugees.org/what-we-do/\">UN Refugee Agency</a>&nbsp;</p>\n\n\n\n<p><a href=\"https://donate.wck.org/give/236738/#!/donation/checkout\">World Central Kitchen</a></p>\n\n\n\n<p><a href=\"https://www.techtotherescue.org/tech/tech-for-ukraine\">Tech For Ukraine</a></p>\n\n\n\n<p><a href=\"https://twitter.com/hashtag/wp4ukraine\">#WP4Ukraine</a></p>\n\n\n\n<h2>Transcript</h2>\n\n\n\n<span id=\"more-12415\"></span>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:00</p>\n\n\n\n<p>Hello, everyone, and welcome to a special edition of the WordPress Briefing. I have Matt here with me today because we want to acknowledge that we are once again at the start of a very difficult time. Neither of us would presume to know what it&#8217;s like to be at the heart of such massive disruption in our lives. But who would we be if we didn&#8217;t stop and check in with you all, the project that we hold so dear? And with that, I&#8217;ll hand it right over to you, Matt.</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>00:27</p>\n\n\n\n<p>Hello everyone. First, I want to thank Josepha for inviting me to join the WordPress Briefing to share what’s been on my mind in light of recent global events.&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>00:37</p>\n\n\n\n<p>I&#8217;ve been listening and watching events escalate in Ukraine, often in a state of shock. The scale alone is hard to take in. I mean, in the last 7 days, more than 500,000 people have fled their homes, more refugees are expected every day. The downstream humanitarian crises of the invasion are unimaginable.&nbsp;&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>00:56</p>\n\n\n\n<p>And seeing destruction in the world we live in is confusing, disconcerting, and difficult. In my experience, open source and WordPress bring people together; people from other countries and cultures, people that we know as friends and colleagues. Technology connects us, regardless of where we are. Nothing can negate the bad things happening in the world, but when I see how this community of contributors collaborates, regardless of borders, you all remind me of the good in the world every day.</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>01:30</p>\n\n\n\n<p>I firmly believe that the web can be an equalizer and a force for good in the world. To me, the WordPress project is the epitome of goodness—everyone has a voice, a platform, and a community. You have the power to make your corner of the world, and the web, a sanctuary for those who need it—especially now.</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>01:45</p>\n\n\n\n<p>If you or someone you know is affected by this war, I encourage you to be present as the ramifications unfold. While we may all feel fatigued and have a sense of languishing from the past two years of the Covid pandemic, the gift of time and support for one another cannot be overstated. I&#8217;m confident that every single person in the WordPress community will approach the situation in Ukraine with sensitivity and understanding.&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>02:07</p>\n\n\n\n<p>I invite you to join me in standing with those in the world working to end conflict and working toward a world of peace, promise, and opportunity. If you&#8217;re looking for a way to help support the humanitarian crisis in Ukraine, I will offer some suggested NGOs, or Non-Governmental Organizations, that provide assistance to local peacebuilders in the region.&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>02:26</p>\n\n\n\n<p>In closing, please know that my thoughts are with everyone in our community. I know that my words here can’t change anything there, but I hope that we all remember that words of support are never unwelcome. And we can never know when a little human kindness can help someone share the invisible heaviness in their heart.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:44</p>\n\n\n\n<p>Thanks for that, Matt. My friends, there are links in the show notes to some of the groups that Matt referenced. And that is it for this special edition of the WordPress Briefing. I&#8217;m your host, Josepha Haden Chomphosy. Be safe, be kind to yourself and others, and I&#8217;ll see you again in a couple of weeks.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12415\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"The Month in WordPress – February 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2022/03/the-month-in-wordpress-february-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 17:40:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:18:\"Month in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:22:\"the month in wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12411\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:332:\"There’s a lot going on in the world right now, and safety is top of mind for everyone in the WordPress community. If you don&#8217;t know where to begin, or how to support your peers, Executive Director Josepha Chomphosy’s advice to the global community is to start small.&#160; Overall, February has been a busy month [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Anjana Vasan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:11935:\"\n<p>There’s a lot going on in the world right now, and safety is top of mind for everyone in the WordPress community. If you don&#8217;t know where to begin, or how to support your peers, Executive Director <a href=\"https://josepha.blog/2022/02/25/to-my-global-community-start-small/\">Josepha Chomphosy’s advice</a> to the global community is to start small.&nbsp;</p>\n\n\n\n<p>Overall, February has been a busy month for WordPress. To begin with, it was thrilling to see the enthusiasm for the release of WordPress 5.9 Joséphine from January continue last month, and that’s not all.&nbsp;</p>\n\n\n\n<p>We have many exciting updates to share, so keep reading to learn about the latest achievements from the WordPress community.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordPress 6.0: May 24, 2022 is the proposed release date</h2>\n\n\n\n<ul><li>The proposed <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-6-0-planning-roundup/\">release schedule for WordPress 6.0</a>, the second major release of 2022, has been published.</li><li>While we’re waiting for 6.0, check out the <a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\">WordPress 5.9.1 maintenance release</a> which was released on February 22, 2022.</li></ul>\n\n\n\n<div class=\"wp-container-1 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://wordpress.slack.com/archives/C02RQBWTW\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Are you interested in contributing to WordPress core?</strong> Join the #core channel in Slack. Also, don&#8217;t miss the Core Team’s weekly developer chat on Wednesdays at 8 PM UTC.</a></div>\n</div>\n\n\n\n<h2>Gutenberg releases: Versions 12.5, 12.6, and 12.7 were released</h2>\n\n\n\n<p>The Core Team launched three new versions of Gutenberg last month. All come with new features, code quality improvements, and bug fixes.</p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\">Gutenberg 12.7 </a>is available to download. This version improves the Patterns experience, allows you to add border styles to column blocks, and includes other new features.</li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/\">Gutenberg 12.6</a> was launched on February 16, 2022. This release includes a new color panel, updated color controls, a new Post Author Biography block, Read More block, and plenty of other exciting updates!</li><li><a href=\"https://make.wordpress.org/core/2022/02/03/whats-new-in-gutenberg-12-5-february-2nd/\">Gutenberg 12.5 </a>was released on February 2, 2022. This version allows switching theme styles variations, custom taxonomies filtering, and more.</li></ul>\n\n\n\n<div class=\"wp-container-2 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://make.wordpress.org/chat/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Want to get involved in developing Gutenberg? </strong>Contribute to Gutenberg on GitHub, and join the #core-editor channel in the Make WordPress Slack. Follow the #gutenberg-new tag for details on the latest updates.</a></div>\n</div>\n\n\n\n<h2>WordPress News gets a new look</h2>\n\n\n\n<p>The redesign of <a href=\"https://wordpress.org/news\">WordPress News</a>, which was first announced by Matt Mullenweg, Co-Founder of WordPress, in State of the Word 2021, went live on February 16, 2022.</p>\n\n\n\n<div class=\"wp-container-3 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://wordpress.org/news/2022/02/a-new-wordpress-news/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Read the redesign announcement </strong>to learn more about the inspiration behind the new look.</a></div>\n</div>\n\n\n\n<h2>Team updates: #WP Diversity, a new blog for developers, and more</h2>\n\n\n\n<ul><li>The #WPDiversity working group, which is part of the Community Team, hosted an open Zoom meeting with volunteers on February 23, 2022. If you’re interested in contributing, read the <a href=\"https://make.wordpress.org/community/2022/02/24/recap-of-the-diverse-speaker-training-group-wpdiversity-on-february-23-2022/\">recap of the meeting</a> to view available roles. </li><li>The Core Team shared a <a href=\"https://make.wordpress.org/core/2022/02/25/proposal-to-start-a-news-blog-on-developer-wordpress-org/\">proposal to start a blog</a> on developer.wordpress.org to share news and updates relevant to developers. </li><li>The first Gutenberg Developer Hours session hosted on February 8th by the Core Team was successful. Head over to <a href=\"https://make.wordpress.org/core/2022/02/24/february-8th-gutenberg-developer-hours-session-evaluation/\">this page</a> to learn more about the participants’ feedback.</li><li>The Core Team published “<a href=\"https://make.wordpress.org/core/2022/02/24/feature-project-plugin-dependencies/\">Feature Project: Plugin Dependencies</a>,” where they identified the problems with plugin dependencies and suggested potential solutions to improve the plugin experience.</li><li>The WordPress Photo Directory has a <a href=\"https://make.wordpress.org/photos/\">new Make team</a>. There is currently an open <a href=\"https://make.wordpress.org/photos/2022/02/23/photo-directory-team-rep-nominations-for-2022/\">call for team reps</a> and collaboration is happening at the new <a href=\"https://wordpress.slack.com/messages/photos/\">#photos</a> channel of the Make WordPress Slack.</li><li>The Polyglots Team shared a proposal for a <a href=\"https://make.wordpress.org/polyglots/2022/02/01/proposal-milestone-template-for-polyglots-locale-teams/\">milestone template </a>for the Polyglots Locale Teams.</li><li>The Community Team published a proposal for <a href=\"https://make.wordpress.org/community/2022/02/16/proposal-refurbishing-camera-kits/\">refurbishing camera kits</a>.</li><li>The <a href=\"https://make.wordpress.org/community/2022/02/21/2022-global-sponsors-announcement/\">Global Community Sponsors for 2022</a> have been announced.</li><li>The February 2022 edition of the monthly <a href=\"https://make.wordpress.org/community/2022/02/15/meetup-organizer-newsletter-february-2022/\">Meetup Organizer Newsletter</a> has been published.</li><li>The latest edition of People of WordPress highlighting <a href=\"https://wordpress.org/news/2022/02/people-of-wordpress-tonya-mork/\">Tonya Mork</a> was published on February 28, 2022. Read Tonya’s story to learn more about how WordPress helped her find herself again after a health crisis. </li><li>The February 2022 edition of the <a href=\"https://make.wordpress.org/polyglots/2022/02/22/polyglots-monthly-newsletter-february-2022/\">Polyglots Monthly Newsletter</a> has been published.</li></ul>\n\n\n\n<div class=\"wp-container-4 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>The Community Team published a discussion on diversity in WordPress events.</strong> If you’re comfortable sharing your experience, you can still comment on the post.</a></div>\n</div>\n\n\n\n<h2>Feedback/Testing requests: WordPress iOS 19.3 and Android 19.3 </h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/mobile/2022/02/22/call-for-testing-wordpress-for-ios-19-3/\">WordPress for iOS 19.3</a> beta is available for testing, along with <a href=\"https://make.wordpress.org/mobile/2022/02/22/call-for-testing-wordpress-for-android-19-3/\">WordPress for Android 19.3</a></li></ul>\n\n\n\n<div class=\"wp-container-5 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://make.wordpress.org/polyglots/2022/02/08/call-for-early-testers-glotpress-feedback-feature/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Test and share your feedback</strong> on the GlotPress feedback feature.</a></div>\n</div>\n\n\n\n<h2>WordCamp Europe 2022 announces steps to ensure a diverse, inclusive, and welcoming event</h2>\n\n\n\n<ul><li>WordCamp Europe 2022 <a href=\"https://europe.wordcamp.org/2022/diversity-at-wceu/\">announced a plan</a> to ensure more diversity and inclusion in events moving forward.</li><li>The WordPress Foundation published a post on how <a href=\"https://wordpressfoundation.org/news/2022/open-source-software-good-for-business/\">open source software is good for business</a>.</li><li>In a recent episode of WP Briefing titled “<a href=\"https://wordpress.org/news/2022/02/episode-25-five-cents-on-five-for-the-future/\">Five Cents on Five for the Future</a>,” Executive Director Josepha Haden Chomphosy talks about future-proofing the WordPress project with the Five for the Future pledge.</li><li>The Training Team is hosting several WordPress Social Learning Meetups <a href=\"https://www.meetup.com/wordpress-social-learning/events/\">in March 2022</a>.</li><li>Don’t miss the following upcoming WordCamps:<ul><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e8-1f1ed.png\" alt=\"🇨🇭\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://geneve.wordcamp.org/2022/\">WordCamp Genève</a>, Switzerland on April 9, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1f7.png\" alt=\"🇬🇷\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://central.wordcamp.org/wordcamps/wordcamp-athens-attica-greece-2022/\">WordCamp Athens</a>, Greece between April 9 and 10, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e6-1f1f9.png\" alt=\"🇦🇹\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://vienna.wordcamp.org/2022/\">WordCamp Vienna</a>, Austria from April 23 to 24, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ea-1f1fa.png\" alt=\"🇪🇺\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://europe.wordcamp.org/2022/\">WordCamp Europe</a> in Porto, Portugal from June 2 to 4, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://montclair.wordcamp.org/2022/\">WordCamp Montclair</a> in New Jersey, USA June 25 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://us.wordcamp.org/2022/\">WordCamp US</a> in San Diego, California from September 9 to 11, 2022 (in person)</li></ul></li></ul>\n\n\n\n<div class=\"wp-container-6 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://europe.wordcamp.org/2022/call-for-volunteers/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>It’s not too late to be a volunteer at WordCamp Europe 2022. </strong>If you’re interested, head over to this page to apply.</a></div>\n</div>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p><strong><em>Have a story that we could include in the next ‘Month in WordPress’ post? Let us know by filling out </em></strong><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><strong><em>this form</em></strong></a><strong><em>.</em></strong></p>\n\n\n\n<p><em>The following folks contributed to December 2021’s Month in WordPress: </em><a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a><em> </em><a href=\'https://profiles.wordpress.org/harishanker/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>harishanker</a><em> </em><a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a> <a href=\'https://profiles.wordpress.org/mysweetcate/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>mysweetcate</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12411\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:78:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"People of WordPress: Tonya Mork\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://wordpress.org/news/2022/02/people-of-wordpress-tonya-mork/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Feb 2022 23:55:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:8:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Features\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:10:\"Interviews\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:4:\"core\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:9:\"HeroPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:19:\"People of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:7;a:5:{s:4:\"data\";s:9:\"Test Team\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12151\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"The People of WordPress feature this month shares the story of engineer and developer Tonya Mork. \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"webcommsat AbhaNonStopNewsUK\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:14136:\"\n<p><strong>In this series, we share some of the inspiring stories of how WordPress and its global network of contributors can change people’s lives for the better. This month we feature a website developer and engineer from the US, who found the software and its community provide the impetus to keep her going forward.</strong></p>\n\n\n\n<p>WordPress gave Tonya Mork a new lease of energy after a health crisis from which she nearly died. She had spent two decades as an electrical and software engineer in high tech automated manufacturing. But when she discovered the WordPress software, teaching it to others became her new purpose. Through this discovery, she has gone on to help thousands of developers understand and build code in great depth.</p>\n\n\n\n<p>As part of her WordPress journey, she has shared her skills in the roles of Release Coordinator and the Core Tech Editor for the most recent major WordPress release, <a href=\"https://make.wordpress.org/core/5-9/\">5.9</a> Joséphine.&nbsp;</p>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img width=\"1024\" height=\"515\" src=\"https://i0.wp.com/wordpress.org/news/files/2022/02/featured-img-tonyamork.jpg?resize=1024%2C515&#038;ssl=1\" alt=\"Tonya pictured in her work room\" class=\"wp-image-12326\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2022/02/featured-img-tonyamork.jpg?resize=1024%2C515&amp;ssl=1 1024w, https://i0.wp.com/wordpress.org/news/files/2022/02/featured-img-tonyamork.jpg?resize=300%2C151&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2022/02/featured-img-tonyamork.jpg?resize=768%2C386&amp;ssl=1 768w, https://i0.wp.com/wordpress.org/news/files/2022/02/featured-img-tonyamork.jpg?w=1247&amp;ssl=1 1247w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<h2 id=\"life-takes-an-unexpected-turn\">Life takes an unexpected turn</h2>\n\n\n\n<p>For the first 22 years of Tonya’s life, she rose through the ranks from enlisted personnel in the US Navy to a highly sought after chief engineer with a multi million-dollar industrial automation engineering firm.  </p>\n\n\n\n<p>However, while she was working in engineering, her life was to change dramatically. In 2007, Tonya started to face health challenges that had an impact on all that she had known.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><strong>“My career defined me. It was my canvas and my art. When it was gone, I did not recognize myself.</strong></p><cite>Tonya Mork</cite></blockquote>\n\n\n\n<p>One day, she woke up at home ready to visit a client’s facility where her firm was building a robotic system. She said: “As I headed for the door, I fell to my knees, as this wave of pain crushed down on my chest.”</p>\n\n\n\n<p>Doctors diagnosed her with a very rare heart disease that caused her blood vessels to spasm, cutting off blood to whatever was downstream of the blockage. </p>\n\n\n\n<p>A few months later, she was diagnosed with a second rare and more serious condition, related to the migraines from which she had been suffering. Combined with her heart condition, this made every migraine attack life-threatening.</p>\n\n\n\n<p>For nearly seven years, the unexpected changes to her health left her mostly homebound and constantly monitored. This meant she had to close her engineering firm and say goodbye to staff and clients. </p>\n\n\n\n<p>“My career defined me. It was my canvas and my art. When it was gone, I was lost. I didn’t recognize myself.”</p>\n\n\n\n<p>But in her darkest hour, she found her strength. Tonya made a choice to move forward, and make the most of her life.</p>\n\n\n\n<p>“When you are at rock bottom, you have to make a decision or else it will consume you. My decision was that I chose to be happy,” said Tonya.</p>\n\n\n\n<p>One of Tonya’s first steps was to start writing a blog using WordPress. In this she shared insights on how to find peace and joy in any situation. She wrote about kindness and helping one another.&nbsp;</p>\n\n\n\n<p>The joy of making solutions through WordPress became a way for Tonya to accept her new life and not feel as limited by her health. She wanted purpose, and in WordPress, she found just that.</p>\n\n\n\n<p>Tonya felt she could do something worthwhile in the virtual world.&nbsp;</p>\n\n\n\n<h2 id=\"a-ray-of-hope-for-tonya\">A ray of hope for Tonya</h2>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full\"><img loading=\"lazy\" width=\"1000\" height=\"750\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/02/tonya.jpg?resize=1000%2C750&#038;ssl=1\" alt=\"\" class=\"wp-image-12327\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2022/02/tonya.jpg?w=1000&amp;ssl=1 1000w, https://i1.wp.com/wordpress.org/news/files/2022/02/tonya.jpg?resize=300%2C225&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2022/02/tonya.jpg?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<p>In 2013, Tonya’s health deteriorated further. She was admitted into intensive care and was diagnosed with a third rare disease, this time related to her autoimmunity. She was not expected to survive this time. </p>\n\n\n\n<p>Following what she describes as a ‘miraculous recovery,’ she became stronger and was able to stop relying on a wheelchair. She used the energy from working on websites to keep going. “WordPress kept my mind alive,” said Tonya.</p>\n\n\n\n<p>She had first used WordPress for her engineering firm’s intranet. But when she discovered the software’s full potential and the collaborative opportunities of open source, it opened a new world.&nbsp;</p>\n\n\n\n<figure class=\"wp-block-pullquote\"><blockquote><p>&#8220;Finding WordPress helped me to find myself again&#8221;</p><cite>Tonya Mork</cite></blockquote></figure>\n\n\n\n<p>During the years which followed, she donated her time to build some WordPress websites and plugins. She said: “Through giving my time, I was able to do something other than sit in isolation.” </p>\n\n\n\n<p>Tonya was amazed by the sharing in open source in general and in WordPress in particular. She said: “I was amazed to see people sharing so much information freely with one another. In my former engineering world, information was proprietary. Throughout my career, I had worked to break down those silos and help anyone to understand complex systems. I was drawn to this open community.”&nbsp;</p>\n\n\n\n<p>She also became aware that WordPress developers were hungry to learn more about development. She wanted to be part of the solution with her passion for teaching and the knowledge she had gained in industry.<br><br>She said: “Finding WordPress helped me to find myself again. Here in this community, I was able to feel like a person again, not a sick one, but a professional with something to give.”</p>\n\n\n\n<p>As her interest in the software grew, Tonya decided to start a non-profit where she turned to WordPress to build the websites. This re-sparked her interest in programming. She said: “I wanted to really know the code and understand what made it tick.”</p>\n\n\n\n<p>The realization led Tonya to start the WP Developers’ Club, which in turn spawned <a href=\"https://knowthecode.io/\">Know the Code</a>, to help educate individual developers, and is still used today.</p>\n\n\n\n<h2 id=\"from-helping-wordpress-companies-to-working-on-wordpress-core\">From helping WordPress companies to working on WordPress Core</h2>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full\"><img loading=\"lazy\" width=\"300\" height=\"300\" src=\"https://i0.wp.com/wordpress.org/news/files/2022/02/tonya-with-dog.jpg?resize=300%2C300&#038;ssl=1\" alt=\"Tonya pictured with her dog\" class=\"wp-image-12328\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2022/02/tonya-with-dog.jpg?w=300&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2022/02/tonya-with-dog.jpg?resize=150%2C150&amp;ssl=1 150w\" sizes=\"(max-width: 300px) 100vw, 300px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<p>Tonya went on to work with big and medium size WordPress companies helping their developers and supporting them in raising their firms’ leverage with WordPress.</p>\n\n\n\n<p>By late 2020, she knew she wanted to do even more with WordPress.</p>\n\n\n\n<p>In February 2021, Tonya joined an international firm in the ecosystem and began working closely on WordPress Core.</p>\n\n\n\n<p>At that time, WordPress Core was pulling together a new Triage team. Tonya started volunteering on that team to find collaborative solutions, and help others do so. In 2020 for <a href=\"https://wordpress.org/news/2020/12/simone/\">WordPress 5.6 Simone</a>, she became the release’s Triage lead, and again for <a href=\"https://make.wordpress.org/core/5-7/\">WordPress 5.7 Esperanza</a>.&nbsp;</p>\n\n\n\n<p>In 2021, she became a Test Team Rep and helped to expand the team and is an advocate for the value of testing and feedback in the release development process.</p>\n\n\n\n<h2 id=\"a-new-successful-chapter-with-wordpress-5-9\">A new, successful chapter with WordPress 5.9</h2>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img loading=\"lazy\" width=\"1024\" height=\"480\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=1024%2C480&#038;ssl=1\" alt=\"Tonya was one of the notable contributors to the WordPress 5.9 release featured in this picture.\" class=\"wp-image-12329\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=1024%2C480&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=300%2C141&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=768%2C360&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=1536%2C719&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=2048%2C959&amp;ssl=1 2048w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<p>Tonya’s passion for the software and getting people involved in its growth continued. For the WordPress 5.9 release in 2021, she took on the role of both the Core Tech Lead and the Release Coordinator. As this was a big release and included the first major implementation of Full Site Editing, it had many moving parts and hundreds of contributors. She was able to share the skills she had learned in communication and project management from her days streamlining and documenting engineering software and processes.&nbsp;</p>\n\n\n\n<p>In the first 24 hours of WordPress 5.9 landing, it had more than 10 million downloads—and 17 formally reported bugs.</p>\n\n\n\n<h2 id=\"giving-back-to-open-source\">Giving back to open source</h2>\n\n\n\n<p>Now in what Tonya describes as her third chapter. She said: “I’m a very different person from the engineer I used to know. What really matters in this world is when you reach out and make a difference in someone’s life.”</p>\n\n\n\n<p>She feels she has found her purpose in this life. “I’m on a mission to give back and make a difference. Teaching is how I will do it. And in WordPress I have found my professional home, and I have all this software knowledge that I just want to share.”</p>\n\n\n\n<h2 id=\"share-the-stories\">Share the stories</h2>\n\n\n\n<p>Help share these stories of open source contributors and continue to grow the community. Meet more WordPressers in the <a href=\"https://wordpress.org/news/category/newsletter/interviews/\">People of WordPress series.</a> #ContributorStory.</p>\n\n\n\n<h2 id=\"contributors-to-this-feature\">Contributors to this feature</h2>\n\n\n\n<p>Thank you to Tonya Mork (<a href=\'https://profiles.wordpress.org/hellofromtonya/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>hellofromtonya</a>) for sharing her story. </p>\n\n\n\n<p>Interviews and feature by Abha Thakor (<a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a>) and Mary Baum (<a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a>). Reviewed by Chloe Bringmann (<a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a>), Nalini Thakor (<a href=\'https://profiles.wordpress.org/nalininonstopnewsuk/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>nalininonstopnewsuk</a>), Meher Bala (<a href=\'https://profiles.wordpress.org/meher/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>meher</a>), and Anjana Vasan (<a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a>). Photo editing Reyez Martínez (<a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a>) and Jean Baptiste Audras (<a href=\'https://profiles.wordpress.org/audrasjb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>audrasjb</a>). </p>\n\n\n\n<p><em>Thanks to Josepha Haden Chomphosy&nbsp;(@<a href=\"https://profiles.wordpress.org/chanthaboune/\">chanthaboune</a>) and Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\">@topher1kenobe</a>) and others for their support&nbsp;</em>of this initiative.</p>\n\n\n\n<div class=\"wp-block-media-text is-stacked-on-mobile is-vertically-aligned-center\" style=\"grid-template-columns:29% auto\"><figure class=\"wp-block-media-text__media\"><img loading=\"lazy\" width=\"180\" height=\"135\" src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?resize=180%2C135&#038;ssl=1\" alt=\"HeroPress logo\" class=\"wp-image-8409 size-full\" data-recalc-dims=\"1\" /></figure><div class=\"wp-block-media-text__content\">\n<p class=\"has-small-font-size\"><em>This People of WordPress feature is inspired by an essay originally published on </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>, a community initiative created by Topher DeRosia. It highlights people in the WordPress community who have overcome barriers and whose stories might otherwise go unheard. </em>#HeroPress </p>\n</div></div>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12151\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 5.9.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 15:49:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12266\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 5.9.1 is now available!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Jb Audras\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7744:\"\n<p>WordPress 5.9.1 is now available!</p>\n\n\n\n<p>This maintenance release features&nbsp;82 bug fixes in both Core and the block editor.</p>\n\n\n\n<p>WordPress 5.9.1 is a short-cycle maintenance release. The next major release will be version&nbsp;<a href=\"https://make.wordpress.org/core/6.0/\">6.0</a>.</p>\n\n\n\n<p>You can <a href=\"https://wordpress.org/wordpress-5.9.1.zip\">download WordPress 5.9.1 from WordPress.org</a>, or visit your Dashboard&nbsp;→ Updates and click &#8220;Update Now&#8221;.</p>\n\n\n\n<p>If you have sites that support automatic background updates, they’ve already started the update process.</p>\n\n\n\n<p>For more information, browse the <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-5-9-1-rc-1/\">full list of both Trac and GitHub changes in the release candidate post</a>, or check out the&nbsp;<a href=\"https://wordpress.org/support/wordpress-version/version-5-9-1/\">version 5.9.1 HelpHub documentation page</a>.</p>\n\n\n\n<h2 id=\"thanks-and-props\">Thanks and props!</h2>\n\n\n\n<p>The 5.9.1 release was led by <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a> and <a href=\"https://profiles.wordpress.org/mamaduka/\">George Mamadashvili</a>.</p>\n\n\n\n<p>Special props to <a href=\'https://profiles.wordpress.org/sergeybiryukov/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>sergeybiryukov</a> for running mission control.</p>\n\n\n\n<p>Thank you to everyone who helped make WordPress 5.9.1 happen:</p>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/aljullu/\">Albert Juhé Lluveras</a>, <a href=\"https://profiles.wordpress.org/ajlende/\">Alex Lende</a>, <a href=\"https://profiles.wordpress.org/alexstine/\">alexstine</a>, <a href=\"https://profiles.wordpress.org/oandregal/\">André</a>, <a href=\"https://profiles.wordpress.org/antonvlasenko/\">Anton Vlasenko</a>, <a href=\"https://profiles.wordpress.org/aristath/\">Ari Stathopoulos</a>, <a href=\"https://profiles.wordpress.org/madeinua/\">ArteMa</a>, <a href=\"https://profiles.wordpress.org/scruffian/\">Ben Dwyer</a>, <a href=\"https://profiles.wordpress.org/blogaid/\">BlogAid</a>, <a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a>, <a href=\"https://profiles.wordpress.org/critterverse/\">Channing Ritter</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/costdev/\">Colin Stewart</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/davidbinda/\">David Biňovec</a>, <a href=\"https://profiles.wordpress.org/get_dave/\">David Smith</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/eddystile/\">Eddy</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/kebbet/\">Erik</a>, <a href=\"https://profiles.wordpress.org/fabiankaegy/\">Fabian Kägy</a>, <a href=\"https://profiles.wordpress.org/azouamauriac/\">Flinim Asso</a>, <a href=\"https://profiles.wordpress.org/gadhiyaravi/\">gadhiyaravi</a>, <a href=\"https://profiles.wordpress.org/revgeorge/\">George Hotelling</a>, <a href=\"https://profiles.wordpress.org/mamaduka/\">George Mamadashvili</a>, <a href=\"https://profiles.wordpress.org/glendaviesnz/\">glendaviesnz</a>, <a href=\"https://profiles.wordpress.org/gziolo/\">Greg Ziółkowski</a>, <a href=\"https://profiles.wordpress.org/ianatkins/\">ianatkins</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/ironprogrammer/\">ironprogrammer</a>, <a href=\"https://profiles.wordpress.org/itsamoreh/\">itsamoreh</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a>, <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>, <a href=\"https://profiles.wordpress.org/jeherve/\">Jeremy Herve</a>, <a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joen/\">Joen A.</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/jrf/\">Juliette Reinders Folmer</a>, <a href=\"https://profiles.wordpress.org/kafleg/\">KafleG</a>, <a href=\"https://profiles.wordpress.org/kapilpaul/\">Kapil Paul</a>, <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a>, <a href=\"https://profiles.wordpress.org/linux4me2/\">linux4me2</a>, <a href=\"https://profiles.wordpress.org/pyrobd/\">Lukman Nakib</a>, <a href=\"https://profiles.wordpress.org/manfcarlo/\">manfcarlo</a>, <a href=\"https://profiles.wordpress.org/clorith/\">Marius L. J.</a>, <a href=\"https://profiles.wordpress.org/mgol/\">mgol</a>, <a href=\"https://profiles.wordpress.org/nidhidhandhukiya/\">nidhidhandhukiya</a>, <a href=\"https://profiles.wordpress.org/ntsekouras/\">Nik Tsekouras</a>, <a href=\"https://profiles.wordpress.org/alshakero/\">Omar Alshaker</a>, <a href=\"https://profiles.wordpress.org/pls78/\">Paolo L. Scala</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/malinevskiy/\">Pavlo</a>, <a href=\"https://profiles.wordpress.org/petaryoast/\">Petar Ratković</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/walbo/\">Petter Walbø Johnsgård</a>, <a href=\"https://profiles.wordpress.org/johnstonphilip/\">Phil Johnston</a>, <a href=\"https://profiles.wordpress.org/boniu91/\">Piotrek Boniu</a>, <a href=\"https://profiles.wordpress.org/ravipatel/\">ravipatel</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/rolfsiebers/\">Rolf Siebers</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/stacimc/\">stacimc</a>, <a href=\"https://profiles.wordpress.org/sabernhardt/\">Stephen Bernhardt</a>, <a href=\"https://profiles.wordpress.org/mahype/\">Sven Wagener</a>, <a href=\"https://profiles.wordpress.org/staatic/\">Team Staatic</a>, <a href=\"https://profiles.wordpress.org/tnolte/\">Tim Nolte</a>, <a href=\"https://profiles.wordpress.org/hellofromtonya/\">Tonya Mork</a>, <a href=\"https://profiles.wordpress.org/webcommsat/\">webcommsat AbhaNonStopNewsUK</a>, <a href=\"https://profiles.wordpress.org/webmandesign/\">WebMan Design | Oliver Juhas</a>, <a href=\"https://profiles.wordpress.org/antonynz/\">wpcharged</a>, <a href=\"https://profiles.wordpress.org/wpsoul/\">wpsoul</a>, <a href=\"https://profiles.wordpress.org/dolphingg/\">Yunus Ertuğrul</a>, and <a href=\"https://profiles.wordpress.org/rafiahmedd/\">Rafi Ahmed</a>.</p>\n\n\n\n<p>Thanks to <a href=\'https://profiles.wordpress.org/estelaris/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>estelaris</a>, <a href=\'https://profiles.wordpress.org/pbiron/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>pbiron</a>, <a href=\'https://profiles.wordpress.org/ironprogrammer/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>ironprogrammer</a>, <a href=\'https://profiles.wordpress.org/bph/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>bph</a>, <a href=\'https://profiles.wordpress.org/abhanonstopnewsuk/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>abhanonstopnewsuk</a> and <a href=\'https://profiles.wordpress.org/threadi/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>threadi</a> for their help to test the release package.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12266\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:61:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"WP Briefing: Episode 25: Five Cents on Five for the Future\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"https://wordpress.org/news/2022/02/episode-25-five-cents-on-five-for-the-future/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 Feb 2022 12:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"wp-briefing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=12288\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:450:\"In this twenty-fifth episode of the WordPress Briefing, Executive Director, Josepha Haden Chomphosy discusses future-proofing the WordPress project with the Five for the Future pledge. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits Editor:&#160;Dustin Hartzler Logo:&#160;Beatriz Fialho Production:&#160;Chloé Bringmann &#38; Santana Inniss Song: [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2022/02/WP-Briefing-025.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:10286:\"\n<p>In this twenty-fifth episode of the WordPress Briefing, Executive Director, Josepha Haden Chomphosy discusses future-proofing the WordPress project with the Five for the Future pledge. </p>\n\n\n\n<p><em><strong>Have a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a> &amp; <a href=\"https://profiles.wordpress.org/santanainniss/\">Santana Inniss</a></li><li>Song: Fearless First by Kevin MacLeod</li></ul>\n\n\n\n<h2 id=\"references\">References</h2>\n\n\n\n<ul><li><a href=\"https://ma.tt/2014/09/five-for-the-future/\">Five for the Future</a>, on ma.tt circa 2014</li><li><a href=\"https://www.cambridge.org/core/books/governing-the-commons/A8BB63BC4A1433A50A3FB92EDBBB97D5\">Governing the Commons</a>, Elinor Ostrom</li><li><a href=\"https://wordpress.org/five-for-the-future/files/2022/01/WP-Sponsored-Contributor-Team-White-Paper-Google-Docs.pdf\">Five for the Future White Paper</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-6-0-planning-roundup/\">6.0 Planning Roundup</a></li><li><a href=\"https://learn.wordpress.org/course/simple-site-design-with-full-site-editing/\">Part I: Full Site Editing Course</a></li><li><a href=\"https://learn.wordpress.org/course/part-2-personalized-site-design-with-full-site-editing-and-theme-blocks/\">Part II: Full Site Editing Course</a></li><li><a href=\"https://learn.wordpress.org/course/part-3-advanced-site-design-with-full-site-editing-site-editor-templates-and-template-parts/\">Part III: Full Site Eiditing Course</a></li></ul>\n\n\n\n<h2 id=\"transcript\">Transcript</h2>\n\n\n\n<span id=\"more-12288\"></span>\n\n\n\n<p>Episode 25</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:00:00]&nbsp;</strong></p>\n\n\n\n<p>Hello everyone, and welcome to the WordPress Briefing. The podcast where you can catch quick explanations of the ideas behind the WordPress open source project. Some insight into the community that supports it and get a small list of big things coming up in the next two weeks. I&#8217;m your host, Josepha Haden Chomphosy &#8211; here we go!</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:00:42]&nbsp;</strong></p>\n\n\n\n<p>I have a non-mailbag mailbag question that I would like to answer for y&#8217;all today. Non-mailbag because no one actually emailed me about it and mailbag because Twitter is basically like a giant mailbag. And I do get a lot of DMS about this particular topic. If you want to send something to my actual WP Briefing mailbag, you can send it to <a href=\"mailto:wpbriefing@worpress.org\">wpbriefing@worpress.org</a>.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:01:06]&nbsp;</strong></p>\n\n\n\n<p>But the question that I frequently get asked in my DMS on Twitter is: what is Five for the Future? It&#8217;s not always that tidy the question, but that still is the question we&#8217;re answering today. So if you take a casual survey of active contributors to the WordPress project, the high-level answer that you&#8217;re likely to get to that question is “a way to remind people to give back to the project.” Or, if you run in more business-y circles, you might hear that it is an initiative that encourages companies to give back 5% of their resources.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:01:40]&nbsp;</strong></p>\n\n\n\n<p>And both of those answers are true. So a quick mini-history lesson; the original concept of Five for the Future came from Matt Mullenweg in 2014. There&#8217;s a lovely blog post on it that I will link in the notes below, but it was essentially a call to any companies experiencing success with WordPress to contribute back to the project and make sure that the project was a success.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:02:07]&nbsp;</strong></p>\n\n\n\n<p>The initial program then included outreach recognition, et cetera, proposed in 2017 by <a href=\"https://wordpress.org/support/users/liljimmi/\">Tracy Levesque</a> and <a href=\"https://wordpress.org/support/users/iandunn/\">Ian Dunn</a>. Then that was defined and formalized with the help of the WordPress community in 2018. And then, in 2019, we had our first trial run with entire dedicated teams sponsored by companies inside the WordPress ecosystem.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:02:36]&nbsp;</strong></p>\n\n\n\n<p>So that&#8217;s the mini-history lesson chronology of this program. The intentions that informed the work of building the program in 2017 have become a bit lost to the ages. So I&#8217;m here to share it with you. The basic heart and soul of the Five for the Future program is to make sure that there is a way to refresh the commons of the WordPress community and ecosystem.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:03:00]&nbsp;</strong></p>\n\n\n\n<p>And as a result, ensure that the common resources of WordPress are available long after we have stopped being available to care for them. If you are familiar with the concept of the tragedy of the commons, Five for the Future was created to help avoid that tragedy. There were two original goals for formalizing the program.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:03:22]&nbsp;</strong></p>\n\n\n\n<p>The first one was to acknowledge companies that participated in Five for the Future by sponsoring contributors to work on the WordPress project. And the second was to motivate more companies to sponsor more volunteers. Either by hiring them and paying them to contribute or by assigning their existing employees to contribute to the WordPress project.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:03:46]&nbsp;</strong></p>\n\n\n\n<p>Of course, it&#8217;s hard to quantify participation and hard to qualify what should be seen as an impactful contribution, which is why when the program was originally created, it was in partnership with team reps and community members who were active at the time. There are many posts around that discuss the next steps for this program.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:04:07]&nbsp;</strong></p>\n\n\n\n<p>And as I&#8217;m looking through them, the next steps revolve around some of the hardest and most important questions that we have to answer as a project and as stewards of open source. Those questions are things like:</p>\n\n\n\n<ul><li> How do we remain true to these gloriously subversive values of WordPress and open source while also finding a way to thoughtfully secure our organization&#8217;s future?</li><li>Does contributing without the expectation of reciprocity hold up when we are looking at how to acknowledge contributors who sustain us?</li></ul>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:04:40]&nbsp;</strong></p>\n\n\n\n<p>And if you&#8217;re familiar with Elinor Ostrom&#8217;s award-winning work, Governing the Commons, you may also be wondering how this particular program aligns with her eight principles designed to sustain organizations like ours.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:04:57]&nbsp;</strong></p>\n\n\n\n<p>As an aside to that last question, this particular program does not have all eight principles accounted for, but among WordPress&#8217;s many programs, we do account for most of them. Although imperfectly, as is the way with human beings, that&#8217;s probably a whole episode unto itself, I did want to quickly answer that particular question.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:05:16]&nbsp;</strong></p>\n\n\n\n<p>So to get back to my non-mailbag, mailbag question, if I had to tell you in the span of an elevator ride what Five for the Future was, this would be my answer. <strong>It is a v1 program with a dual goal of boldly declaring the need to refresh the shared resources of WordPress and offering the ways and means for communities and individuals alike to participate in refreshing those resources</strong>.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:05:45]&nbsp;</strong></p>\n\n\n\n<p>If you want to learn more about the Five for the Future initiative, you can check out wordpress.org/5. Like literally just the number five. Or, if you want to learn more about the program that has grown from the Five for the Future initiative, you can check out the white paper that&#8217;s linked in the notes below.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:06:11]&nbsp;</strong></p>\n\n\n\n<p>And that brings us now to our small list of big things. Number one on my small list, the planning post for WordPress 6.0 is out. I&#8217;ve included a link in my massive list of links below. But it includes our best guess at timing, features that we intend to include, and a call for volunteers as well. So if you are looking for ways to give back, that is a clear and immediate option.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:06:38]&nbsp;</strong></p>\n\n\n\n<p>The second thing on the list is if you are a team rep, don&#8217;t forget that we have daylight saving time ending and starting depending on your hemisphere within the month. If you move meetings, if you&#8217;re in a team that moves your meetings, discuss it now so that folks have time to adjust their calendars.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:06:55]&nbsp;</strong></p>\n\n\n\n<p>And the third thing on my small list of big things is that there&#8217;s a suite of Full Site Editing courses that are now available on learn.wordpress.org. I will add that to my giant list of links below, but I encourage you to wander on over and see what all the fuss is about. I think the courses are excellent. They&#8217;re great for folks who don&#8217;t quite know what Full Site Editing is yet, but then also they give you a few intermediate tips and tricks as you&#8217;re getting your legs underneath you.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy [00:07:27]&nbsp;</strong></p>\n\n\n\n<p>So, that my friends, is your small list of big things. Thank you for tuning in today for the WordPress Briefing. I&#8217;m your host, Josepha Haden Chomphosy. I&#8217;ll see you again in a couple of weeks.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12288\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:63:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"A New WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2022/02/a-new-wordpress-news/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Feb 2022 17:56:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:6:\"Design\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:7:\"General\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"Meta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12244\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:385:\"In June 2021, @beafialho in collaboration with @pablohoney floated the idea of giving WordPress News a new look. Today, those ideas become a reality—we&#8217;re excited to share that redesign of WordPress News is live! The new design leans on the aesthetics of jazz, intrinsically connected to WordPress and which ultimately translates its uniqueness, historic significance [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Kelly Hoffman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5727:\"\n<figure class=\"wp-block-image alignfull size-full\"><img loading=\"lazy\" width=\"2560\" height=\"1605\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?resize=2560%2C1605&#038;ssl=1\" alt=\"\" class=\"wp-image-12279\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?w=2560&amp;ssl=1 2560w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?resize=300%2C188&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?resize=1024%2C642&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?resize=768%2C482&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?resize=1536%2C963&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_responsive_sizes-scaled.jpg?resize=2048%2C1284&amp;ssl=1 2048w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<p>In June 2021, <a href=\'https://profiles.wordpress.org/beafialho/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>beafialho</a> in collaboration with <a href=\'https://profiles.wordpress.org/pablohoney/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>pablohoney</a> <a href=\"https://make.wordpress.org/design/2021/06/03/redesign-of-wordpress-org-news/\">floated the idea</a> of giving WordPress News a new look. Today, those ideas become a reality—we&#8217;re excited to share that redesign of <a href=\"https://wordpress.org/news/\">WordPress News</a> is live!</p>\n\n\n\n<p>The new design leans on the aesthetics of jazz, intrinsically connected to WordPress and which ultimately translates its uniqueness, historic significance and future potential. Among other improvements, the new design leaves more space for content and includes new typefaces for better readability. It also uses a color palette intended to reflect the evolving Gutenberg language.</p>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"2560\" height=\"1605\" src=\"https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?resize=2560%2C1605&#038;ssl=1\" alt=\"\" class=\"wp-image-12260\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?w=2560&amp;ssl=1 2560w, https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?resize=300%2C188&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?resize=1024%2C642&amp;ssl=1 1024w, https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?resize=768%2C482&amp;ssl=1 768w, https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?resize=1536%2C963&amp;ssl=1 1536w, https://i0.wp.com/wordpress.org/news/files/2022/02/news_postpages-scaled.jpg?resize=2048%2C1284&amp;ssl=1 2048w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"2560\" height=\"1605\" src=\"https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?resize=2560%2C1605&#038;ssl=1\" alt=\"\" class=\"wp-image-12262\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?w=2560&amp;ssl=1 2560w, https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?resize=300%2C188&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?resize=1024%2C642&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?resize=768%2C482&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?resize=1536%2C963&amp;ssl=1 1536w, https://i2.wp.com/wordpress.org/news/files/2022/02/news_communitypodcast-scaled.jpg?resize=2048%2C1284&amp;ssl=1 2048w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<p>The revamp of the WordPress News page includes the header and footer of the page. We also shipped those two global elements to all pages of WordPress.org. However, there’s more work to do within the header to improve the information architecture. This new design is just the first, small step to modernize and improve the site iteratively. Any further discussion on future redesigns will occur in the <a href=\"http://wordpress.slack.com\">#design channel on Slack</a>.</p>\n\n\n\n<figure class=\"wp-block-image alignfull size-full\"><img loading=\"lazy\" width=\"2560\" height=\"1605\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?resize=2560%2C1605&#038;ssl=1\" alt=\"\" class=\"wp-image-12263\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?w=2560&amp;ssl=1 2560w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?resize=300%2C188&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?resize=1024%2C642&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?resize=768%2C482&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?resize=1536%2C963&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2022/02/news_mobile_menu-scaled.jpg?resize=2048%2C1284&amp;ssl=1 2048w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<p>Take a look around and subscribe to WordPress News if you haven’t already. If you see something in the design that doesn’t look right, please submit an issue on <a href=\"https://github.com/WordPress/wporg-news-2021/\">GitHub</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12244\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:58:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WP Briefing: Episode 24: Three Goals in 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://wordpress.org/news/2022/02/episode-24-three-goals-in-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 07 Feb 2022 12:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=12176\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:413:\"In episode 24 of the WordPress Briefing, the Project&#8217;s Executive Director reviews three big-picture goals for the year: Increased Gutenberg adoption, support of all open source alternatives, and stewarding the open source ethos. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits Editor:&#160;Dustin Hartzler [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2022/02/WP-Briefing-024.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9160:\"\n<p>In episode 24 of the WordPress Briefing, the Project&#8217;s Executive Director reviews three big-picture goals for the year: Increased Gutenberg adoption, support of all open source alternatives, and stewarding the open source ethos.</p>\n\n\n\n<p><em><strong>Have a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a></li><li>Song: Fearless First by Kevin MacLeod</li></ul>\n\n\n\n<h2 id=\"references\">References</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/project/2022/01/21/big-picture-goals-2022/\">Big Picture Goals 2022</a></li><li><a href=\"https://make.wordpress.org/core/2022/01/26/preliminary-roadmap-for-6-0/\">Preliminary Roadmap for 6.0</a> (Gutenberg Phase 2)</li><li><a href=\"https://wordpress.org/news/2021/06/a-new-design-is-coming-to-wordpress-news/\">A New News Design</a></li><li><a href=\"https://wpmake.tumblr.com/\">Making WordPress</a>: Unofficial aggregator for all&nbsp;<a href=\"https://make.wordpress.org/\">Making WordPress blogs</a></li></ul>\n\n\n\n<h2 id=\"transcript\">Transcript</h2>\n\n\n\n<span id=\"more-12176\"></span>\n\n\n\n<h2 id=\"episode-24\">Episode 24</h2>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:00</p>\n\n\n\n<p>Hello everyone, and welcome to the WordPress Briefing, the podcast where you can catch quick explanations of the ideas behind the WordPress open source project. Some insight into the community that supports it and get a small list of big things coming up in the next two weeks. I&#8217;m your host, Josepha Haden Chomphosy. Here we go!</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:07</p>\n\n\n\n<p>A couple of weeks ago, I published a post about the big picture goals for the WordPress project in 2022. As I was thinking through our planned releases for the year and looking out toward what would spell success for WordPress over the next three years, three things really lined up in both sets of answers for me.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:23</p>\n\n\n\n<p>I provided some detail on how we can work toward these goals in the post, which I will link for you in the show notes, but I also wanted to take some time to explain why I feel we have to work toward these goals this year. So these all build on one another. To refresh your memory of the three big focuses, they are one to drive adoption of the new editor in WordPress, support open source alternatives for site building necessities, and three, open source stewardship.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:52</p>\n\n\n\n<p>So the first one; is driving the adoption of the new WordPress editor. Early on in the start of the Gutenberg Project, folks could not go two days without hearing me talk about the phases of adoption and how those line up with the phases of Gutenberg, and who would need our support the most in each of those phases.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:09</p>\n\n\n\n<p>I have always believed that what we would be shipping at this point in our project would prove the plausible promise of what we were doing in phase one. That&#8217;s definitely what I&#8217;m seeing from what was shipped in 5.9, as well as what we plan to ship in May with 6.0. And the people who need the most support right now are absolutely our users, your clients, no matter whether they were not keeping up with WordPress developments or simply were waiting to see what all the fuss was about.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:37</p>\n\n\n\n<p>There will be people who look to you as someone who has been here a while to help them make sense of what they&#8217;re seeing. And what I find so exciting about this adoption, sort of, work in the WordPress project is that this is the time when we as practitioners of WordPress, no matter whether you are a designer or a developer or builder, business coach. This is the time when we get to guide others through the hardest parts of our learning processes.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>03:07</p>\n\n\n\n<p>The process of helping people to learn new technologies relies not only on your hard-won expertise but also on the belief that the future is worth fighting for. Enabling someone’s success is an investment in the future and investment for that person or for WordPress or your community. All investments are welcome here.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>03:28</p>\n\n\n\n<p>Fortunately, table stakes are just that you care. And speaking of future investments, the second focus is open source alternatives for site building necessities. So things like images, forms, stores, themes, etc. It literally just things you need to build a site. I would like to start by saying that I am completely aware of the fact that 99% of WordPress users will never care about open source freedoms and philosophies in the same way that WordPress maintainers and contributors care about open source freedoms and philosophies.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>04:04</p>\n\n\n\n<p>You could substitute the name of any other open source project right there, and the statement would still be true. And yet, I will always believe that people should have the rights and freedoms that open source brings to them even if they do not know they are there. And so it makes all the sense in the world to me that as a project and open source community, we should strive to make choosing Open Source as easy as possible.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>04:33</p>\n\n\n\n<p>And finally, open source stewardship is one of the focuses for this year. This one is obviously about supporting open source as a concept and maintaining WordPress as a project. But I also think that it is relevant to our current global circumstances. Open Source suddenly became very visible to the public eye last year following the Log4J vulnerability, and ever since then, I&#8217;ve been hearing consistent concern over how We make sure that WordPress is sustainable moving into the future. Fortunately, this is a topic that&#8217;s near and dear to my heart. And I have been delighted to see so many community members bringing that conversation to the forefront.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:14</p>\n\n\n\n<p>There is a lot that is done in the WordPress project to keep us from the tragedy of the commons. But that work honestly never ends. Not only does it not end, but as we get bigger, there is more and more that we can and should be doing to keep us around for the long term. And, of course, for the keen readers of my posts, there&#8217;s a bonus focus.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:39</p>\n\n\n\n<p>The bonus focus is, of course, that WordPress turns 20 years old next year. This year, we will also be seeing some preparatory work for that major milestone as well.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:56</p>\n\n\n\n<p>So that brings us today to our small list of big things. There is a redesign of the News Page coming. We&#8217;ve been talking about this over on make.wordpress.org/design for a bit since like June of last year or something. But it&#8217;s coming in the next few weeks. I&#8217;ll share a link to the GitHub repo in case anyone has any specific things that they see as they are reading through all of our many news stories that come out on that particular page. I think it&#8217;s beautiful, and I&#8217;m very excited to take a look at it.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>06:30</p>\n\n\n\n<p>The second thing is that planning is underway for WordPress 6.0; that release that we&#8217;re doing in May. I&#8217;ll add the project page link to the show notes. I&#8217;ve had a few raised hands for that release squad. But if you&#8217;re interested in participating in the release, I encourage you to keep an eye out on make.wordpress.org/core for updates and any news about how to get involved.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>06:53</p>\n\n\n\n<p>And my third thing is actually that, in general, there are a lot of opportunities to contribute right now. There are discussions about projects, goals, and dreams happening all over the place. I&#8217;ll link in the show notes below the unofficial project “firehose” where you can see all the headlines and quickly find discussions that might be interesting to you.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>07:18</p>\n\n\n\n<p>And that, my friends, is your small list of big things. Thank you for tuning in today for the WordPress Briefing. I&#8217;m your host Josepha Haden Chomphosy, and I&#8217;ll see you again in a couple of weeks.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12176\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"The Month in WordPress – January 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/news/2022/02/the-month-in-wordpress-january-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Feb 2022 19:41:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Month in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12180\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:335:\"There are a few significant moments in the history of the WordPress project. January 2022 is one of them, with the release of WordPress 5.9! But that’s not all. Read on to learn more about the latest updates and achievements from the community. WordPress 5.9 Joséphine is here Meet WordPress 5.9 Joséphine. Named in honor [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Anjana Vasan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:12751:\"\n<p>There are a few significant moments in the history of the WordPress project. January 2022 is one of them, with the release of WordPress 5.9! But that’s not all. Read on to learn more about the latest updates and achievements from the community.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"wordpress-5-9-josephine-is-here\">WordPress 5.9 Joséphine is here</h2>\n\n\n\n<p class=\"has-text-align-center\"><img loading=\"lazy\" width=\"405\" height=\"274\" src=\"https://lh3.googleusercontent.com/Iq09sZdu0Npal6XWBF6Bbfqb8AWizWVPCUtCqxgU4T-1E3uWM1bmZ7cDEHA0RJlEaFTPN5jAAXwHfx-x52rIC2Gac55j96fhUSdFlHyEmFtooRM9_NmuLyRJ-_ujotnKAAYzBEBh\"></p>\n\n\n\n<p>Meet <a href=\"https://wordpress.org/news/2022/01/josephine/\">WordPress 5.9 Joséphine</a>. Named in honor of the acclaimed jazz singer, Joséphine Baker, this is one of the much-awaited releases. Version 5.9 brings full site editing to WordPress, among other exciting updates!<strong> </strong><a href=\"https://wordpress.org/download/\"><strong>Download WordPress 5.9</strong></a><strong> and try the new features! </strong><br><br>Check out the <a href=\"https://make.wordpress.org/core/2022/01/10/wordpress-5-9-field-guide/\">WordPress 5.9 Field Guide</a> to learn more. Lastly, everyone’s invited to participate in a retrospective of the <a href=\"https://make.wordpress.org/core/2022/01/27/wordpress-5-9-simone-retrospective/\">WordPress 5.9 Joséphine</a> release!</p>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Are you interested in contributing to WordPress core?</strong> Join the <a href=\"https://wordpress.slack.com/archives/C02RQBWTW\">#core</a> channel, follow the <a href=\"https://make.wordpress.org/core/\">Core Team blog</a>, and check out the <a href=\"https://make.wordpress.org/core/handbook/\">team handbook</a>. Also, don&#8217;t miss the Core Team’s weekly developer chat on Wednesdays at <a href=\"https://www.timeanddate.com/worldclock/fixedtime.html?hour=20&amp;min=00&amp;sec=0\">8 PM</a> UTC.</p></blockquote>\n\n\n\n<h2 id=\"gutenberg-releases-versions-12-3-12-4-and-12-5-are-here\">Gutenberg releases: Versions 12.3, 12.4, and 12.5 are here</h2>\n\n\n\n<p>The Core Team launched three new versions of Gutenberg since last month’s edition of the Month in WordPress.</p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/02/03/whats-new-in-gutenberg-12-5-february-2nd/\">Gutenberg 12.5</a> brings global styles variations and Query Loop block enhancements, along with the Code Editor view to the Side Editor. Moreover, inserting new buttons is now easier than ever!</li><li><a href=\"https://make.wordpress.org/core/2022/01/19/whats-new-in-gutenberg-12-4-19-january/\">Gutenberg 12.4</a> was released on January 19, 2022. This version includes accessibility improvements, suggestions for assigning categories, keyboard shortcuts for the Site Editor, and more.&nbsp;</li><li><a href=\"https://make.wordpress.org/core/2022/01/05/whats-new-in-gutenberg-12-3-5-january/\">Gutenberg 12.3</a> was released on January 5, 2022. This release brings new blocks, like the Author Name, Comments Next Page, and Comments Previous Page blocks, and many other cool updates!</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Want to get involved in developing Gutenberg? </strong>Follow <a href=\"https://make.wordpress.org/core/\">the Core Team blog</a>, contribute to Gutenberg on <a href=\"https://github.com/WordPress/gutenberg/\">GitHub</a>, and join the <a href=\"https://wordpress.slack.com/archives/C02QB2JS7\">#core-editor</a> channel in the <a href=\"https://make.wordpress.org/chat/\">Make WordPress Slack</a>. Follow the <a href=\"https://make.wordpress.org/core/tag/gutenberg-new/\">#gutenberg-new</a> tag for details on the latest updates.</p></blockquote>\n\n\n\n<h2 id=\"team-updates-proposals-announcements-and-more-for-2022\">Team updates: Proposals, announcements, and more for 2022</h2>\n\n\n\n<ul><li>Executive Director Josepha Haden<a href=\"https://make.wordpress.org/core/2022/01/27/proposal-2022-major-release-timing/\"> shared a proposal</a> on 2022 major release timing. </li><li>In the <a href=\"https://wordpress.org/news/2022/02/episode-24-three-goals-in-2022/\">latest episode of WP Briefing</a>, Josepha Haden Comphosy reviews the <a href=\"https://make.wordpress.org/updates/2022/01/21/our-three-big-ideas-for-2022/\">three major areas of focus</a> for the WordPress project in 2022. She also shared the <a href=\"https://make.wordpress.org/project/2022/01/21/big-picture-goals-2022/\">big-picture goals for 2022</a>.</li><li>The Core Team <a href=\"https://make.wordpress.org/core/2022/01/31/ensuring-proper-attribution-for-contributions-to-wordpress-on-github/\">made a proposal</a> regarding proper attributions for contributions to WordPress on GitHub. Although the proposal has since then been withdrawn, it&#8217;s still a discussion and comments are welcome.</li><li>Check out the <a href=\"https://make.wordpress.org/core/2022/01/26/preliminary-roadmap-for-6-0/\">preliminary roadmap</a> for WordPress 6.0 (Gutenberg Phase Two). </li><li>Core Team members <a href=\"https://make.wordpress.org/core/2022/01/26/proposed-improvements-to-the-core-editor-chat-agenda-and-format/\">proposed improvements</a> to the Core Editor chat agenda and format. </li><li>The Accessibility Team made some <a href=\"https://make.wordpress.org/accessibility/2022/01/22/accessibility-team-meeting-notes-january-21-2022/\">major goal proposals for WordPress 6.0</a>.</li><li>The Polyglots Team shared a proposal for a <a href=\"https://make.wordpress.org/polyglots/2022/02/01/proposal-milestone-template-for-polyglots-locale-teams/\">milestone template for polyglots locale teams</a>.</li><li>The <a href=\"https://make.wordpress.org/polyglots/2022/01/20/polyglots-monthly-newsletter-january-2022/\">January 2022 edition</a> of the Polyglots monthly newsletter is out!</li><li>The Community Team shared an <a href=\"https://make.wordpress.org/community/2022/02/03/open-invitation-diverse-speaker-training-group-wpdiversity-zoom-call/\">open invitation for the Diverse Speaker Training group</a> Zoom call.</li><li>Although the WordPress Photo Directory hasn’t fully launched yet, you can now <a href=\"https://wordpress.org/photos/submit/\">submit your images</a>. You can also contribute in other ways, as there’s <a href=\"https://make.wordpress.org/meta/2022/01/13/wordpress-photo-directory-call-for-volunteers/\">currently a call for volunteers</a>.</li><li>Openverse has now a redesigned user interface and includes support for audio files. Check out <a href=\"https://make.wordpress.org/openverse/2022/01/25/everything-you-need-to-know-about-openverse-and-the-wordpress-photo-directory/\">this post</a> to learn what&#8217;s new.</li><li>The Community Team will be hosting <a href=\"https://make.wordpress.org/community/2022/02/02/community-team-goals-2022-open-discussion-sessions/\">open discussion sessions</a> to collaborate on its goals for 2022. </li><li>The January 2022 edition of the <a href=\"https://make.wordpress.org/community/2022/01/14/meetup-organizer-newsletter-january-2022/\">Meetup Organizer Newsletter</a> was published.</li><li>The Community Team shared a <a href=\"https://make.wordpress.org/community/2022/01/10/proposal-mandatory-safety-measures-for-in-person-wordpress-events-in-2022/\">proposal for mandatory safety measures</a> for in-person WordPress events taking place this year.</li><li>The Training Team published its <a href=\"https://make.wordpress.org/training/2022/02/02/february-2022-team-sprint/\">February 2022 Team Sprint</a>.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Take the course on Learn WordPress to </strong><a href=\"https://learn.wordpress.org/course/simple-site-design-with-full-site-editing/\"><strong>learn about the full site editing features</strong></a><strong> in WordPress 5.9!&nbsp; Also, help spread the word about </strong><a href=\"https://learn.wordpress.org/social-learning/\"><strong>social learning spaces</strong></a><strong> on </strong><a href=\"https://twitter.com/WordPress/status/1487180438347128836\"><strong>Twitter</strong></a><strong>!</strong></p></blockquote>\n\n\n\n<h2 id=\"feedback-testing-requests-share-your-thoughts-on-wordpress-5-9-josephine\">Feedback/Testing requests: Share your thoughts on WordPress 5.9 Joséphine</h2>\n\n\n\n<ul><li>There’s currently a call for testing <a href=\"https://make.wordpress.org/mobile/2022/01/27/call-for-testing-wordpress-for-android-19-1/\">WordPress for Android 19.1</a> and <a href=\"https://make.wordpress.org/mobile/2022/01/24/call-for-testing-wordpress-for-ios-19-1/\">iOS 19.1</a>, along with <a href=\"https://make.wordpress.org/mobile/2022/01/10/call-for-testing-wordpress-for-android-19-0/\">Android 19.0</a> and iOS 19.0.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><a href=\"https://forms.gle/Hf7E2JJokfnNLprG7\"><strong>Share your feedback</strong></a><strong> on the release of WordPress 5.9 Joséphine.</strong></p></blockquote>\n\n\n\n<h2 id=\"wordcamp-europe-2022-wants-volunteers-photographers-and-media-partners\">WordCamp Europe 2022 wants volunteers, photographers and media partners</h2>\n\n\n\n<ul><li>WordCamp Birmingham, Alabama has been postponed until April or May.</li><li>The WordPress Foundation <a href=\"https://wordpressfoundation.org/news/2022/what-is-the-wordpress-foundation-and-why-does-it-exist/\">published a post</a> explaining more about the nonprofit’s mission and why it exists.</li><li>Don’t miss the following upcoming WordCamps: <ul><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e8-1f1ff.png\" alt=\"🇨🇿\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://prague.wordcamp.org/2022/\">WordCamp Prague</a>, Switzerland on February  26, 2022 (online)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e8-1f1ed.png\" alt=\"🇨🇭\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /><a href=\"https://geneve.wordcamp.org/2022/\"> WordCamp Genève</a>, Switzerland on April 9, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1f7.png\" alt=\"🇬🇷\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://central.wordcamp.org/wordcamps/wordcamp-athens-attica-greece-2022/\">WordCamp Athens</a>, Greece between April 9 and 10, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e6-1f1f9.png\" alt=\"🇦🇹\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://vienna.wordcamp.org/2022/\">WordCamp Vienna</a>, Austria from April 23 to 24, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ea-1f1fa.png\" alt=\"🇪🇺\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://europe.wordcamp.org/2022/\">WordCamp Europe</a> in Porto, Portugal from June 2 to 4, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> <a href=\"https://us.wordcamp.org/2022/\">WordCamp US</a> in San Diego, CA USA from September 9-11, 2022 (in person)</li></ul></li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>WordCamp Europe 2022 opened a new call for </strong><a href=\"https://europe.wordcamp.org/2022/join-the-wceu-volunteers-team/\"><strong>volunteers</strong></a><strong>, </strong><a href=\"https://europe.wordcamp.org/2022/capture-wceu-on-camera/\"><strong>photographers</strong></a><strong>, and </strong><a href=\"https://europe.wordcamp.org/2022/join-us-as-a-media-partner/\"><strong>media partners</strong></a><strong>!</strong></p></blockquote>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p><strong><em>Have a story that we could include in the next ‘Month in WordPress’ post? Let us know by filling out </em></strong><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><strong><em>this form</em></strong></a><strong><em>.</em></strong></p>\n\n\n\n<p><em>The following folks contributed to January 2022’s Month in WordPress: </em><a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a><em> </em><a href=\'https://profiles.wordpress.org/harishanker/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>harishanker</a><em> </em><a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a><em> </em><a href=\"https://profiles.wordpress.org/lmurillom/\">@lmurillom</a> <em><a href=\"https://profiles.wordpress.org/webcommsat/\">@webcommsat</a> and <a href=\"https://profiles.wordpress.org/nalininonstopnewsuk/\">@nalininonstopnewsuk</a></em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12180\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"WordPress 5.9 “Josephine”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/news/2022/01/josephine/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 25 Jan 2022 16:17:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12089\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WordPress 5.9 is available thanks to more than 600 contributors who helped make it happen.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:62669:\"\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"1024\" height=\"694\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?resize=1024%2C694&#038;ssl=1\" alt=\"\" class=\"wp-image-12139\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?resize=1024%2C694&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?resize=300%2C203&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?resize=768%2C521&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?resize=1536%2C1042&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?resize=2048%2C1389&amp;ssl=1 2048w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-inline-v2.png?w=3000&amp;ssl=1 3000w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h2 id=\"welcome-to-josephine\">Welcome to Joséphine!</h2>\n\n\n\n<p>Introducing 5.9, “Joséphine”. Named in honor of acclaimed international jazz singer Joséphine Baker, this latest, most versatile WordPress release is here: <a href=\"https://wordpress.org/download/\">download it</a> or update it directly from your dashboard. <br><br>As a lifelong civil rights campaigner, Joséphine Baker believed that all people could live in harmony together, just as different instruments in a jazz band blend together to make a whole piece. Turn on a playlist from your favorite music service and enjoy her famous renditions of “You are the greatest love”, “Sans Amour”, and “Love is a Dreamer” as you discover all the features of this brand-new WordPress release. </p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"full-site-editing-is-here\">Full site editing is here.</h2>\n\n\n\n<p>It puts you in control of your whole site, right in the WordPress Admin.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-1.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12101\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-1.png?w=1204&amp;ssl=1 1204w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-1.png?resize=300%2C225&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-1.png?resize=1024%2C768&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-1.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"say-hello-to-twenty-twenty-two\">Say hello to Twenty Twenty-Two.</h3>\n\n\n\n<p>And say hello to the first default block theme in the history of WordPress. This is more than just a new default theme. It’s a brand-new way to work with WordPress themes.</p>\n\n\n\n<p><a href=\"https://wordpress.org/support/article/block-themes/\">Block themes</a> put a wide array of visual choices directly in your hands, from color schemes and font combinations to page templates and image filters, all from the <a href=\"https://wordpress.org/support/article/site-editor/\">Site Editor</a>. So in one place, you can give Twenty Twenty-Two the same look and feel as your organization’s other materials—or take your site’s look in another direction.</p>\n\n\n\n<p>You already have the Twenty Twenty-Two theme—it came installed with WordPress 5.9. You will find it with your other installed themes.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-2.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12102\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-2.png?w=1204&amp;ssl=1 1204w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-2.png?resize=300%2C225&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-2.png?resize=1024%2C768&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-2.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"your-personal-paintbox-awaits\">Your personal paintbox awaits</h3>\n\n\n\n<p>Twenty Twenty-Two is not the only theme built for full site editing. More block themes are in the Themes directory, and the number will grow.&nbsp;</p>\n\n\n\n<p>When you use any of those new themes, you no longer need the Customizer. Instead, you have all the power of the Styles interface inside the Site Editor. Just as in Twenty Twenty-Two, you build your site’s look and feel there, with the tools you need for the job in a fluid interface that practically comes alive in your hands.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i0.wp.com/wordpress.org/news/files/2022/01/5-9-release-3.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12103\" srcset=\"https://i0.wp.com/wordpress.org/news/files/2022/01/5-9-release-3.png?w=1204&amp;ssl=1 1204w, https://i0.wp.com/wordpress.org/news/files/2022/01/5-9-release-3.png?resize=300%2C225&amp;ssl=1 300w, https://i0.wp.com/wordpress.org/news/files/2022/01/5-9-release-3.png?resize=1024%2C768&amp;ssl=1 1024w, https://i0.wp.com/wordpress.org/news/files/2022/01/5-9-release-3.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"the-navigation-block\">The Navigation block</h3>\n\n\n\n<p>Blocks come to site navigation, the heart of user experience.</p>\n\n\n\n<p>The new Navigation block gives you the power to choose: an always-on responsive menu or one that adapts to your user’s screen size. And your choices are remembered! In 5.9, the block saves menus as custom post types, which get saved to the database.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"more-improvements-and-updates\">More improvements and updates</h2>\n\n\n\n<p>Do you love to blog? New tweaks to the publishing flow help you say more, faster.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-release-5.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12105\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-release-5.png?w=1204&amp;ssl=1 1204w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-release-5.png?resize=300%2C225&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-release-5.png?resize=1024%2C768&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2022/01/5-9-release-5.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"better-block-controls\">Better block controls</h3>\n\n\n\n<p>WordPress 5.9 features new typography tools, flexible layout controls, and finer control of details like spacing, borders, and more—to help you get not just the look, but the polish that says you care about details.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-4.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12104\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-4.png?w=1204&amp;ssl=1 1204w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-4.png?resize=300%2C225&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-4.png?resize=1024%2C768&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-4.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"the-power-of-patterns\">The power of patterns</h3>\n\n\n\n<p>The WordPress Pattern Directory is the home of a wide range of block patterns built to save you time and add to your site&#8217;s functionality. And you can edit them as you see fit. Need something different in the header or footer for your theme? Swap it out with a new one in a few clicks.</p>\n\n\n\n<p>With a nearly full-screen view that draws you in to see fine details, the Pattern Explorer makes it easy to compare patterns and choose the one your users need.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-6.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12106\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-6.png?w=1204&amp;ssl=1 1204w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-6.png?resize=300%2C225&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-6.png?resize=1024%2C768&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-6.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"a-revamped-list-view\">A revamped List View</h3>\n\n\n\n<p>In 5.9, the List View lets you drag and drop your content exactly where you want it. Managing complex documents is easier, too: simple controls let you expand and collapse sections as you build your site—and add HTML anchors to your blocks to help users get around the page.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"1204\" height=\"903\" src=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-7.png?resize=1204%2C903&#038;ssl=1\" alt=\"\" class=\"wp-image-12107\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-7.png?w=1204&amp;ssl=1 1204w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-7.png?resize=300%2C225&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-7.png?resize=1024%2C768&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2022/01/5-9-release-7.png?resize=768%2C576&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h3 id=\"a-better-gallery-block\">A better Gallery block</h3>\n\n\n\n<p>Treat every image in a Gallery Block the same way you would treat it in the Image Block.</p>\n\n\n\n<p>Style every image in your gallery differently, or make them all the same, except for one or two. Or change the layout with drag-and-drop.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"wordpress-5-9-for-developers\">WordPress 5.9 for developers</h2>\n\n\n\n<h3 id=\"theme-json-for-child-themes\">Theme.json for child themes</h3>\n\n\n\n<p>In 5.9, theme.json supports child themes. That means your users can build a child theme right in the WordPress Admin, without writing a single line of code.&nbsp;</p>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/2022/01/04/block-themes-a-new-way-to-build-themes-in-wordpress-5-9/\">This dev note</a> has all the details. Take a look!</p>\n\n\n\n<h3 id=\"block-level-locking\">Block-level locking</h3>\n\n\n\n<p>Now you can lock any block (or a few of them) in a pattern, just by <a href=\"https://make.wordpress.org/core/2022/01/08/locking-blocks-in-wordpress-5-9/\">adding a lock attribute to its settings in block.json</a>—leaving the rest of the pattern free for users to adapt to their content.&nbsp;</p>\n\n\n\n<h3 id=\"multiple-stylesheets-in-a-block\">Multiple stylesheets in a block</h3>\n\n\n\n<p>Now you can register more than one stylesheet per block, which lets a given block load only the styles its markup requests, and not a whole sheet. Read the details in this <a href=\"https://make.wordpress.org/core/2021/12/15/using-multiple-stylesheets-per-block/\">dev note</a>.</p>\n\n\n\n<h3 id=\"a-refactored-gallery-block\">A refactored Gallery Block</h3>\n\n\n\n<p>The changes to the Gallery Block listed above are the result of near-complete refactor. Have you built a plugin or theme on the Gallery Block functionality? Be sure you read this <a href=\"https://make.wordpress.org/core/2021/08/20/gallery-block-refactor-dev-note/\">dev note</a>. It tells you what you need to do for compatibility.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h3 id=\"learn-more-about-the-new-features-in-5-9\">Learn more about the new features in 5.9</h3>\n\n\n\n<p>Want to dive into 5.9 but don’t know where to start? Check out this free course about <a href=\"https://learn.wordpress.org/course/simple-site-design-with-full-site-editing/\">Simple Site Design</a> from <a href=\"https://learn.wordpress.org/\">Learn WordPress</a>. There are a variety of learning materials including short how-to video tutorials and resources on new features in WordPress 5.9, with much more planned.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h3 id=\"check-the-field-guide-for-more\">Check the Field Guide for more!</h3>\n\n\n\n<p>Check out the latest version of the WordPress Field Guide. It has lots of useful information with links to detailed developer notes to support you building in WordPress for everyone you serve. <a href=\"https://make.wordpress.org/core/2022/01/10/wordpress-5-9-field-guide/\">WordPress 5.9 Field Guide</a>.</p>\n\n\n\n<div style=\"height:10px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"the-squad\"><strong>The Squad</strong></h2>\n\n\n\n<p>The WordPress 5.9 release was led by <a href=\"https://profiles.wordpress.org/matt/\">Matt Mullenweg</a>, and supported by this highly enthusiastic release squad:</p>\n\n\n\n<ul><li>Release Lead: <a href=\"https://profiles.wordpress.org/matt/\">Matt Mullenweg</a></li><li>Core Tech and Release Coordinator: <a href=\"https://profiles.wordpress.org/hellofromtonya/\">Tonya Mork</a></li><li>Triage Leads: <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a> and <a href=\"https://profiles.wordpress.org/chaion07/\">Ahmed Chaion</a></li><li>Editor Tech: <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a> and <a href=\"https://profiles.wordpress.org/mamaduka/\">George Mamadashvili</a></li><li>Theme Leads: <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a> and <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a></li><li>Technical Writer: <a href=\"https://profiles.wordpress.org/psykro/\">Jonathan Bossenger</a></li><li>Documentation Leads: <a href=\"https://profiles.wordpress.org/mkaz/\">Marcus Kazmierczak</a> and <a href=\"https://profiles.wordpress.org/milana_cap/\">Milana Cap</a></li><li>Marketing &amp; Communications Leads: <a href=\"https://profiles.wordpress.org/marybaum/\">Mary Baum</a>, <a href=\"https://profiles.wordpress.org/webcommsat/\">Abha Thakor</a>, and <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden Chomphosy</a></li><li>Test Leads: <a href=\"https://profiles.wordpress.org/boniu91/\">Piotrek Boniu</a> and <a href=\"https://profiles.wordpress.org/annezazu/\">Anne McCarthy</a></li></ul>\n\n\n\n<p>WordPress 5.9 also reflects the hard work of 624 generous volunteer contributors. Collaboration occurred on <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=5.9&amp;group=component&amp;col=id&amp;col=summary&amp;col=status&amp;col=milestone&amp;col=owner&amp;col=type&amp;col=priority&amp;order=priority\">370 tickets on Trac</a> and more than <a href=\"https://github.com/WordPress/gutenberg/compare/v10.8.0...v11.9.0\">1900 pull requests on GitHub</a>.</p>\n\n\n<p><a href=\"https://profiles.wordpress.org/2linctools/\">2linctools</a>, <a href=\"https://profiles.wordpress.org/aaroncampbell/\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/aaronrobertshaw/\">Aaron Robertshaw</a>, <a href=\"https://profiles.wordpress.org/abesell132/\">abesell132</a>, <a href=\"https://profiles.wordpress.org/webcommsat/\">Abha Thakor</a>, <a href=\"https://profiles.wordpress.org/acosmin/\">acosmin</a>, <a href=\"https://profiles.wordpress.org/wpmudev-support8/\">Adam - WPMU DEV Support</a>, <a href=\"https://profiles.wordpress.org/bosconiandynamics/\">Adam Bosco</a>, <a href=\"https://profiles.wordpress.org/adam3128/\">Adam Morgan</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/zieladam/\">Adam Zielinski</a>, <a href=\"https://profiles.wordpress.org/addiestavlo/\">Addie</a>, <a href=\"https://profiles.wordpress.org/aadilali/\">Adil Ali</a>, <a href=\"https://profiles.wordpress.org/aduth/\">aduth</a>, <a href=\"https://profiles.wordpress.org/aezazshekh/\">Aezaz Shekh</a>, <a href=\"https://profiles.wordpress.org/chaion07/\">Ahmed Chaion</a>, <a href=\"https://profiles.wordpress.org/ajotka/\">ajotka</a>, <a href=\"https://profiles.wordpress.org/soniakash/\">Akash Soni</a>, <a href=\"https://profiles.wordpress.org/atachibana/\">Akira Tachibana</a>, <a href=\"https://profiles.wordpress.org/schlessera/\">Alain Schlesser</a>, <a href=\"https://profiles.wordpress.org/alanjacobmathew/\">Alan Jacob Mathew</a>, <a href=\"https://profiles.wordpress.org/aljullu/\">Albert Juh&#233; Lluveras</a>, <a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/ajlende/\">Alex Lende</a>, <a href=\"https://profiles.wordpress.org/alexvorn2/\">Alexandru Vornicescu</a>, <a href=\"https://profiles.wordpress.org/alexeydemidov/\">alexeydemidov</a>, <a href=\"https://profiles.wordpress.org/alexislloyd/\">Alexis Lloyd</a>, <a href=\"https://profiles.wordpress.org/alexstine/\">alexstine</a>, <a href=\"https://profiles.wordpress.org/algala/\">AlGala</a>, <a href=\"https://profiles.wordpress.org/firewatch/\">allilevine</a>, <a href=\"https://profiles.wordpress.org/almendron/\">almendron</a>, <a href=\"https://profiles.wordpress.org/amandariu/\">Amanda Riu</a>, <a href=\"https://profiles.wordpress.org/anandau14/\">Anand Upadhyay</a>, <a href=\"https://profiles.wordpress.org/nosolosw/\">Andr&#233;</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/andraganescu/\">Andrei Draganescu</a>, <a href=\"https://profiles.wordpress.org/nacin/\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/anevins/\">Andrew Nevins</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/andrewserong/\">Andrew Serong</a>, <a href=\"https://profiles.wordpress.org/oandregal/\">André</a>, <a href=\"https://profiles.wordpress.org/afragen/\">Andy Fragen</a>, <a href=\"https://profiles.wordpress.org/apeatling/\">Andy Peatling</a>, <a href=\"https://profiles.wordpress.org/andy-schmidt/\">Andy Schmidt</a>, <a href=\"https://profiles.wordpress.org/andynick/\">andynick</a>, <a href=\"https://profiles.wordpress.org/la-geek/\">Angelika Reisiger</a>, <a href=\"https://profiles.wordpress.org/anjanavasan/\">Anjana Vasan</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta/\">Ankit K Gupta</a>, <a href=\"https://profiles.wordpress.org/ankitmaru/\">Ankit Panchal</a>, <a href=\"https://profiles.wordpress.org/annezazu/\">Anne McCarthy</a>, <a href=\"https://profiles.wordpress.org/antpb/\">Anthony Burchell</a>, <a href=\"https://profiles.wordpress.org/anthonyeden/\">Anthony Eden</a>, <a href=\"https://profiles.wordpress.org/paranoia1906/\">Anthony Ledesma</a>, <a href=\"https://profiles.wordpress.org/antonvlasenko/\">Anton Vlasenko</a>, <a href=\"https://profiles.wordpress.org/antonisme/\">Antonis Lilis</a>, <a href=\"https://profiles.wordpress.org/arena/\">arena</a>, <a href=\"https://profiles.wordpress.org/aristath/\">Ari Stathopoulos</a>, <a href=\"https://profiles.wordpress.org/madeinua/\">ArteMa</a>, <a href=\"https://profiles.wordpress.org/arthur791004/\">Arthur Chu</a>, <a href=\"https://profiles.wordpress.org/ashfame/\">Ashfame</a>, <a href=\"https://profiles.wordpress.org/ayeshrajans/\">Ayesh Karunaratne</a>, <a href=\"https://profiles.wordpress.org/baelx/\">baelx</a>, <a href=\"https://profiles.wordpress.org/allerune/\">Bartlomiej</a>, <a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a>, <a href=\"https://profiles.wordpress.org/beaulebens/\">Beau Lebens</a>, <a href=\"https://profiles.wordpress.org/bedas/\">Beda</a>, <a href=\"https://profiles.wordpress.org/scruffian/\">Ben Dwyer</a>, <a href=\"https://profiles.wordpress.org/utz119/\">Benachi</a>, <a href=\"https://profiles.wordpress.org/benitolopez/\">benitolopez</a>, <a href=\"https://profiles.wordpress.org/rainbowgeek/\">Benjamin Denis</a>, <a href=\"https://profiles.wordpress.org/benjamingosset/\">Benjamin Gosset</a>, <a href=\"https://profiles.wordpress.org/benjaminanakena/\">benjamin.anakena</a>, <a href=\"https://profiles.wordpress.org/bernhard-reiter/\">Bernhard Reiter</a>, <a href=\"https://profiles.wordpress.org/bijayyadav/\">Bijay Yadav</a>, <a href=\"https://profiles.wordpress.org/binarykitten/\">BinaryKitten</a>, <a href=\"https://profiles.wordpress.org/birgire/\">Birgir Erlendsson (birgire)</a>, <a href=\"https://profiles.wordpress.org/bph/\">Birgit Pauli-Haack</a>, <a href=\"https://profiles.wordpress.org/blogaid/\">BlogAid</a>, <a href=\"https://profiles.wordpress.org/bobbingwide/\">bobbingwide</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bjorsch/\">Brad Jorsch</a>, <a href=\"https://profiles.wordpress.org/bradparbs/\">Brad Parbs</a>, <a href=\"https://profiles.wordpress.org/bradleyt/\">Bradley Taylor</a>, <a href=\"https://profiles.wordpress.org/kraftbj/\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/bravokeyl/\">bravokeyl</a>, <a href=\"https://profiles.wordpress.org/bgoewert/\">Brennan Goewert</a>, <a href=\"https://profiles.wordpress.org/bgardner/\">Brian Gardner</a>, <a href=\"https://profiles.wordpress.org/rzen/\">Brian Richards</a>, <a href=\"https://profiles.wordpress.org/bronsonquick/\">bronsonquick</a>, <a href=\"https://profiles.wordpress.org/ribaricplusplus/\">Bruno Ribaric</a>, <a href=\"https://profiles.wordpress.org/brylie/\">Brylie Christopher Oxley</a>, <a href=\"https://profiles.wordpress.org/icaleb/\">Caleb Burks</a>, <a href=\"https://profiles.wordpress.org/calebwoodbridge/\">calebwoodbridge</a>, <a href=\"https://profiles.wordpress.org/carepsules/\">carepsules</a>, <a href=\"https://profiles.wordpress.org/carike/\">Carike</a>, <a href=\"https://profiles.wordpress.org/cbravobernal/\">Carlos Bravo</a>, <a href=\"https://profiles.wordpress.org/carlosgprim/\">Carlos Garcia</a>, <a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a>, <a href=\"https://profiles.wordpress.org/cdyerkes/\">cdyerkes</a>, <a href=\"https://profiles.wordpress.org/ceyhun0/\">Ceyhun Ozugur</a>, <a href=\"https://profiles.wordpress.org/shireling/\">Chad Chadbourne</a>, <a href=\"https://profiles.wordpress.org/critterverse/\">Channing Ritter</a>, <a href=\"https://profiles.wordpress.org/chiaki/\">Chiaki</a>, <a href=\"https://profiles.wordpress.org/chintan1896/\">Chintan hingrajiya</a>, <a href=\"https://profiles.wordpress.org/chipsnyder/\">Chip Snyder</a>, <a href=\"https://profiles.wordpress.org/cbringmann/\">Chloe Bringmann</a>, <a href=\"https://profiles.wordpress.org/chouby/\">Chouby</a>, <a href=\"https://profiles.wordpress.org/cklosows/\">Chris Klosowski</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/chriscct7/\">chriscct7</a>, <a href=\"https://profiles.wordpress.org/christianztamayo/\">Christian Tamayo</a>, <a href=\"https://profiles.wordpress.org/amethystanswers/\">Christina Workman</a>, <a href=\"https://profiles.wordpress.org/vimes1984/\">Christopher Churchill</a>, <a href=\"https://profiles.wordpress.org/clucasrowlands/\">clucasrowlands</a>, <a href=\"https://profiles.wordpress.org/costdev/\">Colin Stewart</a>, <a href=\"https://profiles.wordpress.org/callye/\">Collieth Clarke</a>, <a href=\"https://profiles.wordpress.org/collizo4sky/\">Collins Agbonghama</a>, <a href=\"https://profiles.wordpress.org/copons/\">Copons</a>, <a href=\"https://profiles.wordpress.org/coreyw/\">Corey</a>, <a href=\"https://profiles.wordpress.org/cr0ybot/\">Cory Hughart</a>, <a href=\"https://profiles.wordpress.org/courane01/\">Courtney Robertson</a>, <a href=\"https://profiles.wordpress.org/craigfrancis/\">craigfrancis</a>, <a href=\"https://profiles.wordpress.org/mitogh/\">Crisoforo Gaspar</a>, <a href=\"https://profiles.wordpress.org/littlebigthing/\">Csaba (LittleBigThings)</a>, <a href=\"https://profiles.wordpress.org/davidszabo/\">D&#225;vid Szab&#243;</a>, <a href=\"https://profiles.wordpress.org/daisyo/\">Daisy Olsen</a>, <a href=\"https://profiles.wordpress.org/colorful-tones/\">Damon Cook</a>, <a href=\"https://profiles.wordpress.org/danfarrow/\">Dan Farrow</a>, <a href=\"https://profiles.wordpress.org/dansoschin/\">Dan Soschin</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber/\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/danielpost/\">Daniel Post</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/chthnc/\">Daniel Shaw</a>, <a href=\"https://profiles.wordpress.org/danieldudzic/\">danieldudzic</a>, <a href=\"https://profiles.wordpress.org/mte90/\">Daniele Scasciafratte</a>, <a href=\"https://profiles.wordpress.org/darerodz/\">darerodz</a>, <a href=\"https://profiles.wordpress.org/dariak/\">Daria</a>, <a href=\"https://profiles.wordpress.org/daschmi/\">Daschmi</a>, <a href=\"https://profiles.wordpress.org/datagutten/\">datagutten</a>, <a href=\"https://profiles.wordpress.org/datainterlock/\">datainterlock</a>, <a href=\"https://profiles.wordpress.org/davecpage/\">Dave Page</a>, <a href=\"https://profiles.wordpress.org/davidanderson/\">David Anderson</a>, <a href=\"https://profiles.wordpress.org/davidbaumwald/\">David Baumwald</a>, <a href=\"https://profiles.wordpress.org/davidbinda/\">David Biňovec</a>, <a href=\"https://profiles.wordpress.org/dpcalhoun/\">David Calhoun</a>, <a href=\"https://profiles.wordpress.org/dgwyer/\">David Gwyer</a>, <a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/davidkryzaniak/\">David Kryzaniak</a>, <a href=\"https://profiles.wordpress.org/davidmosterd/\">David Mosterd</a>, <a href=\"https://profiles.wordpress.org/daviedr/\">David Rozando</a>, <a href=\"https://profiles.wordpress.org/dryanpress/\">David Ryan</a>, <a href=\"https://profiles.wordpress.org/get_dave/\">David Smith</a>, <a href=\"https://profiles.wordpress.org/davidwebca/\">davidwebca</a>, <a href=\"https://profiles.wordpress.org/devutpol/\">Deb Nath Utpol</a>, <a href=\"https://profiles.wordpress.org/dkarfa/\">Debabrata Karfa</a>, <a href=\"https://profiles.wordpress.org/deepaklalwani/\">Deepak Lalwani</a>, <a href=\"https://profiles.wordpress.org/denisco/\">Denis Yanchevskiy</a>, <a href=\"https://profiles.wordpress.org/dingo_d/\">Denis Žoljom</a>, <a href=\"https://profiles.wordpress.org/dmsnell/\">Dennis Snell</a>, <a href=\"https://profiles.wordpress.org/dhanendran/\">Dhanendran</a>, <a href=\"https://profiles.wordpress.org/dhusakovic/\">dhusakovic</a>, <a href=\"https://profiles.wordpress.org/diedeexterkate/\">DiedeExterkate</a>, <a href=\"https://profiles.wordpress.org/dilipbheda/\">Dilip Bheda</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/dlt101/\">dlt101</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/donmhico/\">donmhico</a>, <a href=\"https://profiles.wordpress.org/codezen8/\">Donna Botti</a>, <a href=\"https://profiles.wordpress.org/dontgo2sleep/\">dontgo2sleep</a>, <a href=\"https://profiles.wordpress.org/dougwollison/\">Doug Wollison</a>, <a href=\"https://profiles.wordpress.org/dpegasusm/\">dpegasusm</a>, <a href=\"https://profiles.wordpress.org/raubvogel/\">Dr. Ronny Harbich</a>, <a href=\"https://profiles.wordpress.org/dratwas/\">dratwas</a>, <a href=\"https://profiles.wordpress.org/drewapicture/\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/drosmog/\">drosmog</a>, <a href=\"https://profiles.wordpress.org/dustinrue/\">dustinrue</a>, <a href=\"https://profiles.wordpress.org/seedsca/\">ecotechie</a>, <a href=\"https://profiles.wordpress.org/eddystile/\">Eddy</a>, <a href=\"https://profiles.wordpress.org/ehtis/\">ehtis</a>, <a href=\"https://profiles.wordpress.org/ekojr/\">EkoJR</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/manooweb/\">Emmanuel Hesry</a>, <a href=\"https://profiles.wordpress.org/empatogen/\">empatogen</a>, <a href=\"https://profiles.wordpress.org/enchiridion/\">Enchiridion</a>, <a href=\"https://profiles.wordpress.org/enej/\">Enej Bajgorić</a>, <a href=\"https://profiles.wordpress.org/nrqsnchz/\">Enrique S&#225;nchez</a>, <a href=\"https://profiles.wordpress.org/erayalakese/\">erayalakese</a>, <a href=\"https://profiles.wordpress.org/teachlynx/\">Eric Malalel</a>, <a href=\"https://profiles.wordpress.org/ethitter/\">Erick Hitter</a>, <a href=\"https://profiles.wordpress.org/kebbet/\">Erik Betshammar</a>, <a href=\"https://profiles.wordpress.org/etoledo/\">etoledo</a>, <a href=\"https://profiles.wordpress.org/circlecube/\">Evan Mullins</a>, <a href=\"https://profiles.wordpress.org/fabiankaegy/\">Fabian K&#228;gy</a>, <a href=\"https://profiles.wordpress.org/gaambo/\">Fabian Todt</a>, <a href=\"https://profiles.wordpress.org/faisal03/\">Faisal Alvi</a>, <a href=\"https://profiles.wordpress.org/fedepia/\">fedepia</a>, <a href=\"https://profiles.wordpress.org/felipeelia/\">Felipe Elia</a>, <a href=\"https://profiles.wordpress.org/felipeloureirosantos/\">Felipe Santos</a>, <a href=\"https://profiles.wordpress.org/flixos90/\">Felix Arntz</a>, <a href=\"https://profiles.wordpress.org/azouamauriac/\">Flinim Asso</a>, <a href=\"https://profiles.wordpress.org/mista-flo/\">Florian TIAR</a>, <a href=\"https://profiles.wordpress.org/fpcsjames/\">FPCSJames</a>, <a href=\"https://profiles.wordpress.org/piewp/\">fperdaan</a>, <a href=\"https://profiles.wordpress.org/francina/\">Francesca Marano</a>, <a href=\"https://profiles.wordpress.org/fcolombo/\">Francesco</a>, <a href=\"https://profiles.wordpress.org/gadhiyaravi/\">gadhiyaravi</a>, <a href=\"https://profiles.wordpress.org/galbaras/\">Gal Baras</a>, <a href=\"https://profiles.wordpress.org/garrett-eclipse/\">Garrett Hyder</a>, <a href=\"https://profiles.wordpress.org/garyj/\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento/\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/gazchap/\">gazchap</a>, <a href=\"https://profiles.wordpress.org/generosus/\">generosus</a>, <a href=\"https://profiles.wordpress.org/soulseekah/\">Gennady Kovshenin</a>, <a href=\"https://profiles.wordpress.org/revgeorge/\">George Hotelling</a>, <a href=\"https://profiles.wordpress.org/mamaduka/\">George Mamadashvili</a>, <a href=\"https://profiles.wordpress.org/georgestephanis/\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/geriux/\">Gerardo Pacheco</a>, <a href=\"https://profiles.wordpress.org/gilbitron/\">Gilbert Pellegrom</a>, <a href=\"https://profiles.wordpress.org/glendaviesnz/\">Glen Davies</a>, <a href=\"https://profiles.wordpress.org/goldsounds/\">goldsounds</a>, <a href=\"https://profiles.wordpress.org/gkloveweb/\">Govind</a>, <a href=\"https://profiles.wordpress.org/grantmkin/\">Grant M. Kinney</a>, <a href=\"https://profiles.wordpress.org/gregrickaby/\">Greg Rickaby</a>, <a href=\"https://profiles.wordpress.org/gziolo/\">Greg Zi&#243;łkowski</a>, <a href=\"https://profiles.wordpress.org/guillaumeturpin/\">Guillaume TURPIN</a>, <a href=\"https://profiles.wordpress.org/priethor/\">H&#233;ctor Prieto</a>, <a href=\"https://profiles.wordpress.org/hansjovisyoast/\">Hans-Christiaan Braun</a>, <a href=\"https://profiles.wordpress.org/haosun/\">haosun</a>, <a href=\"https://profiles.wordpress.org/hareesh-pillai/\">Hareesh</a>, <a href=\"https://profiles.wordpress.org/hasanuzzamanshamim/\">Hasanuzzaman</a>, <a href=\"https://profiles.wordpress.org/azhiyadev/\">Hauwa Abashiya</a>, <a href=\"https://profiles.wordpress.org/hazdiego/\">Haz</a>, <a href=\"https://profiles.wordpress.org/henrywright/\">Henry Wright</a>, <a href=\"https://profiles.wordpress.org/herbmiller/\">herbmiller</a>, <a href=\"https://profiles.wordpress.org/hermpheus/\">Herm Martini</a>, <a href=\"https://profiles.wordpress.org/herregroen/\">Herre Groen</a>, <a href=\"https://profiles.wordpress.org/hilayt24/\">Hilay Trivedi</a>, <a href=\"https://profiles.wordpress.org/hirofumi2012/\">hirofumi2012</a>, <a href=\"https://profiles.wordpress.org/hitendra-chopda/\">Hitendra Chopda</a>, <a href=\"https://profiles.wordpress.org/h71/\">Hossein Farahani</a>, <a href=\"https://profiles.wordpress.org/htmgarcia/\">htmgarcia</a>, <a href=\"https://profiles.wordpress.org/hudson-atwell/\">Hudson Atwell</a>, <a href=\"https://profiles.wordpress.org/hlashbrooke/\">Hugh Lashbrooke</a>, <a href=\"https://profiles.wordpress.org/hugod/\">hugod</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/iandunn/\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ianatkins/\">ianatkins</a>, <a href=\"https://profiles.wordpress.org/ianhayes94/\">ianhayes94</a>, <a href=\"https://profiles.wordpress.org/ianmjones/\">ianmjones</a>, <a href=\"https://profiles.wordpress.org/ignatggeorgiev/\">Ignat Georgiev</a>, <a href=\"https://profiles.wordpress.org/ibenic/\">Igor Benic</a>, <a href=\"https://profiles.wordpress.org/ilovecats7/\">ilovecats7</a>, <a href=\"https://profiles.wordpress.org/infected/\">infected</a>, <a href=\"https://profiles.wordpress.org/ipstenu/\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/ironprogrammer/\">ironprogrammer</a>, <a href=\"https://profiles.wordpress.org/iluy/\">Isaac</a>, <a href=\"https://profiles.wordpress.org/isabel_brison/\">Isabel Brison</a>, <a href=\"https://profiles.wordpress.org/ismaeld/\">ismaeld</a>, <a href=\"https://profiles.wordpress.org/itsamoreh/\">itsamoreh</a>, <a href=\"https://profiles.wordpress.org/jdgrimes/\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jackreichert/\">Jack Reichert</a>, <a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/jakubtyrcha/\">jakub.tyrcha</a>, <a href=\"https://profiles.wordpress.org/mcjambi/\">Jam Viet</a>, <a href=\"https://profiles.wordpress.org/macmanx/\">James Huff</a>, <a href=\"https://profiles.wordpress.org/jameskoster/\">James Koster</a>, <a href=\"https://profiles.wordpress.org/janthiel/\">Jan Thiel</a>, <a href=\"https://profiles.wordpress.org/janwoostendorp/\">janw.oostendorp</a>, <a href=\"https://profiles.wordpress.org/jsnjohnston/\">Jason Johnston</a>, <a href=\"https://profiles.wordpress.org/evermail/\">Jason R. Johnston</a>, <a href=\"https://profiles.wordpress.org/javiarce/\">Javier Arce</a>, <a href=\"https://profiles.wordpress.org/javiercasares/\">Javier Casares</a>, <a href=\"https://profiles.wordpress.org/jayupadhyay01/\">Jay Upadhyay</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jean-Baptiste Audras</a>, <a href=\"https://profiles.wordpress.org/teucrium/\">Jean-Philippe</a>, <a href=\"https://profiles.wordpress.org/jblz/\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>, <a href=\"https://profiles.wordpress.org/jeffpaul/\">Jeffrey Paul</a>, <a href=\"https://profiles.wordpress.org/jdy68/\">Jenny Dupuy</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt/\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jeherve/\">Jeremy Herve</a>, <a href=\"https://profiles.wordpress.org/jeremyescott/\">Jeremy Scott</a>, <a href=\"https://profiles.wordpress.org/jeremyyip/\">Jeremy Yip</a>, <a href=\"https://profiles.wordpress.org/amieiro/\">Jes&#250;s Amieiro</a>, <a href=\"https://profiles.wordpress.org/engelen/\">Jesper van Engelen</a>, <a href=\"https://profiles.wordpress.org/luminuu/\">Jessica Lyschik</a>, <a href=\"https://profiles.wordpress.org/jigneshnakrani/\">Jignesh Nakrani</a>, <a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joemcgill/\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/joegasper/\">joegasper</a>, <a href=\"https://profiles.wordpress.org/joelcj91/\">Joel James</a>, <a href=\"https://profiles.wordpress.org/joen/\">Joen Asmussen</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnillo/\">John Espiritu</a>, <a href=\"https://profiles.wordpress.org/johnny5/\">John Godley</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/zenithcity/\">john zenith</a>, <a href=\"https://profiles.wordpress.org/lwangaman/\">JohnRDOrazio (CLPTE)</a>, <a href=\"https://profiles.wordpress.org/psykro/\">Jonathan Bossenger</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/spacedmonkey/\">Jonny Harris</a>, <a href=\"https://profiles.wordpress.org/jonoaldersonwp/\">Jono Alderson</a>, <a href=\"https://profiles.wordpress.org/joostdevalk/\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/josklever/\">Jos Klever</a>, <a href=\"https://profiles.wordpress.org/josephdickson/\">Joseph Dickson</a>, <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden</a>, <a href=\"https://profiles.wordpress.org/joyously/\">Joy</a>, <a href=\"https://profiles.wordpress.org/jsnajdr/\">jsnajdr</a>, <a href=\"https://profiles.wordpress.org/juanruitina/\">Juan Ruiti&#241;a</a>, <a href=\"https://profiles.wordpress.org/juanmaguitar/\">JuanMa Garrido</a>, <a href=\"https://profiles.wordpress.org/juhise/\">Juhi Saxena</a>, <a href=\"https://profiles.wordpress.org/jrf/\">Juliette Reinders Folmer</a>, <a href=\"https://profiles.wordpress.org/junaidbhura/\">Junaid Bhura</a>, <a href=\"https://profiles.wordpress.org/nukaga/\">Junko Nukaga</a>, <a href=\"https://profiles.wordpress.org/justinahinon/\">Justin Ahinon</a>, <a href=\"https://profiles.wordpress.org/justindocanto/\">Justin DoCanto</a>, <a href=\"https://profiles.wordpress.org/greenshady/\">Justin Tadlock</a>, <a href=\"https://profiles.wordpress.org/kadamwhite/\">K. Adam White</a>, <a href=\"https://profiles.wordpress.org/kafleg/\">KafleG</a>, <a href=\"https://profiles.wordpress.org/kevin940726/\">Kai Hao</a>, <a href=\"https://profiles.wordpress.org/kallookoo/\">kallookoo</a>, <a href=\"https://profiles.wordpress.org/akabarikalpesh/\">Kalpesh Akabari</a>, <a href=\"https://profiles.wordpress.org/kaneva/\">kaneva</a>, <a href=\"https://profiles.wordpress.org/kapilpaul/\">Kapil Paul</a>, <a href=\"https://profiles.wordpress.org/ryelle/\">Kelly Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/kellychoffman/\">Kelly Hoffman</a>, <a href=\"https://profiles.wordpress.org/keoshi/\">keoshi</a>, <a href=\"https://profiles.wordpress.org/sourav926/\">Keramot UL Islam</a>, <a href=\"https://profiles.wordpress.org/kingkero/\">kero</a>, <a href=\"https://profiles.wordpress.org/gwwar/\">Kerry Liu</a>, <a href=\"https://profiles.wordpress.org/kevinfodness/\">Kevin Fodness</a>, <a href=\"https://profiles.wordpress.org/keyur5/\">keyur5</a>, <a href=\"https://profiles.wordpress.org/kharisblank/\">Kharis Sulistiyono</a>, <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a>, <a href=\"https://profiles.wordpress.org/knutsp/\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/vdwijngaert/\">Koen Van den Wijngaert</a>, <a href=\"https://profiles.wordpress.org/obenland/\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/xkon/\">Konstantinos Xenos</a>, <a href=\"https://profiles.wordpress.org/kurudrive/\">kurudrive</a>, <a href=\"https://profiles.wordpress.org/kwisatz/\">kwisatz</a>, <a href=\"https://profiles.wordpress.org/devnel/\">Kyle Nel</a>, <a href=\"https://profiles.wordpress.org/kzeni/\">KZeni</a>, <a href=\"https://profiles.wordpress.org/lalitjalandhar/\">lalitjalandhar</a>, <a href=\"https://profiles.wordpress.org/laurelfulford/\">laurelfulford</a>, <a href=\"https://profiles.wordpress.org/laxman-prajapati/\">Laxman Prajapati</a>, <a href=\"https://profiles.wordpress.org/leemon/\">leemon</a>, <a href=\"https://profiles.wordpress.org/leogermani/\">leogermani</a>, <a href=\"https://profiles.wordpress.org/lgladdy/\">Liam Gladdy</a>, <a href=\"https://profiles.wordpress.org/liammitchell/\">liammitchell</a>, <a href=\"https://profiles.wordpress.org/rudlinkon/\">Linkon Miyan</a>, <a href=\"https://profiles.wordpress.org/linux4me2/\">linux4me2</a>, <a href=\"https://profiles.wordpress.org/webaxones/\">Lo&#239;c Antignac</a>, <a href=\"https://profiles.wordpress.org/loranrendel/\">Loran A. Rendel</a>, <a href=\"https://profiles.wordpress.org/karpstrucking/\">Lucas Karpiuk</a>, <a href=\"https://profiles.wordpress.org/lucasw89/\">lucasw89</a>, <a href=\"https://profiles.wordpress.org/lucatume/\">lucatume</a>, <a href=\"https://profiles.wordpress.org/zaguiini/\">Luis Felipe Zaguini</a>, <a href=\"https://profiles.wordpress.org/lukecarbis/\">Luke Carbis</a>, <a href=\"https://profiles.wordpress.org/lukecavanagh/\">Luke Cavanagh</a>, <a href=\"https://profiles.wordpress.org/pyrobd/\">Lukman Nakib</a>, <a href=\"https://profiles.wordpress.org/luovalabs/\">luovalabs</a>, <a href=\"https://profiles.wordpress.org/lynk/\">lynk</a>, <a href=\"https://profiles.wordpress.org/asif2bd/\">M Asif Rahman</a>, <a href=\"https://profiles.wordpress.org/gorby31/\">Madalin Gorbanescu</a>, <a href=\"https://profiles.wordpress.org/aetherunbound/\">Madison</a>, <a href=\"https://profiles.wordpress.org/onemaggie/\">Maggie Cabrera</a>, <a href=\"https://profiles.wordpress.org/mai21/\">Mai</a>, <a href=\"https://profiles.wordpress.org/malae/\">Malae</a>, <a href=\"https://profiles.wordpress.org/malthert/\">malthert</a>, <a href=\"https://profiles.wordpress.org/manfcarlo/\">manfcarlo</a>, <a href=\"https://profiles.wordpress.org/manishamakhija/\">Manisha Makhija</a>, <a href=\"https://profiles.wordpress.org/manzoorwanijk/\">Manzoor Wani</a>, <a href=\"https://profiles.wordpress.org/fullofcaffeine/\">Marcelo de Moraes Serpa</a>, <a href=\"https://profiles.wordpress.org/mciampini/\">Marco Ciampini</a>, <a href=\"https://profiles.wordpress.org/mkaz/\">Marcus Kazmierczak</a>, <a href=\"https://profiles.wordpress.org/marekhrabe/\">Marek Hrabe</a>, <a href=\"https://profiles.wordpress.org/tyxla/\">Marin Atanasov</a>, <a href=\"https://profiles.wordpress.org/clorith/\">Marius L. J.</a>, <a href=\"https://profiles.wordpress.org/mark-k/\">Mark-k</a>, <a href=\"https://profiles.wordpress.org/marybaum/\">Mary Baum</a>, <a href=\"https://profiles.wordpress.org/wetah/\">Mateus Machado Luna</a>, <a href=\"https://profiles.wordpress.org/matveb/\">Matias Ventura</a>, <a href=\"https://profiles.wordpress.org/mhuntdesign/\">Matt</a>, <a href=\"https://profiles.wordpress.org/mattchowning/\">Matt Chowning</a>, <a href=\"https://profiles.wordpress.org/matt/\">Matt Mullenweg</a>, <a href=\"https://profiles.wordpress.org/mattwiebe/\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mattoakley/\">mattoakley</a>, <a href=\"https://profiles.wordpress.org/wppunk/\">Max</a>, <a href=\"https://profiles.wordpress.org/max-dayala/\">MaxD</a>, <a href=\"https://profiles.wordpress.org/maximeculea/\">Maxime Culea</a>, <a href=\"https://profiles.wordpress.org/mclaurent/\">mclaurent</a>, <a href=\"https://profiles.wordpress.org/medusor/\">MEDUSOR</a>, <a href=\"https://profiles.wordpress.org/megphillips91/\">Meg Phillips</a>, <a href=\"https://profiles.wordpress.org/meher/\">Meher Bala</a>, <a href=\"https://profiles.wordpress.org/melchoyce/\">Mel Choyce-Dwan</a>, <a href=\"https://profiles.wordpress.org/mgol/\">mgol</a>, <a href=\"https://profiles.wordpress.org/wpscholar/\">Micah Wood</a>, <a href=\"https://profiles.wordpress.org/mdawaffe/\">Michael Adams (mdawaffe)</a>, <a href=\"https://profiles.wordpress.org/tw2113/\">Michael Beckwith</a>, <a href=\"https://profiles.wordpress.org/mburridge/\">Michael Burridge</a>, <a href=\"https://profiles.wordpress.org/mnelson4/\">Michael Nelson</a>, <a href=\"https://profiles.wordpress.org/czapla/\">Michal Czaplinski</a>, <a href=\"https://profiles.wordpress.org/michelwppi/\">Michel - xiligroup dev</a>, <a href=\"https://profiles.wordpress.org/mcsf/\">Miguel Fonseca</a>, <a href=\"https://profiles.wordpress.org/mikaelmayer/\">mikaelmayer</a>, <a href=\"https://profiles.wordpress.org/mikejolley/\">Mike Jolley (a11n)</a>, <a href=\"https://profiles.wordpress.org/mikeschroder/\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/dimadin/\">Milan Dinić</a>, <a href=\"https://profiles.wordpress.org/milana_cap/\">Milana Cap</a>, <a href=\"https://profiles.wordpress.org/multidots1896/\">Minal Diwan</a>, <a href=\"https://profiles.wordpress.org/0mirka00/\">mirka</a>, <a href=\"https://profiles.wordpress.org/mjaschen/\">mjaschen</a>, <a href=\"https://profiles.wordpress.org/mjulian7/\">mjulian7</a>, <a href=\"https://profiles.wordpress.org/mmxxi/\">mmxxi</a>, <a href=\"https://profiles.wordpress.org/moch11/\">moch11</a>, <a href=\"https://profiles.wordpress.org/opurockey/\">Mohammad Rockeybul Alam</a>, <a href=\"https://profiles.wordpress.org/monikarao/\">Monika Rao</a>, <a href=\"https://profiles.wordpress.org/mt8biz/\">moto hachi</a>, <a href=\"https://profiles.wordpress.org/computerguru/\">mqudsi</a>, <a href=\"https://profiles.wordpress.org/mreishus/\">mreishus</a>, <a href=\"https://profiles.wordpress.org/mrjoeldean/\">mrjoeldean</a>, <a href=\"https://profiles.wordpress.org/mtoensing/\">mtoensing</a>, <a href=\"https://profiles.wordpress.org/wparslan/\">Muhammad Arslan</a>, <a href=\"https://profiles.wordpress.org/muhammadfaizanhaidar/\">Muhammad Faizan Haidar</a>, <a href=\"https://profiles.wordpress.org/mukesh27/\">Mukesh Panchal</a>, <a href=\"https://profiles.wordpress.org/musabshakeel/\">Musab Shakeel</a>, <a href=\"https://profiles.wordpress.org/amustaque97/\">Mustaque Ahmed</a>, <a href=\"https://profiles.wordpress.org/assassinateur/\">Nadir Seghir</a>, <a href=\"https://profiles.wordpress.org/nalininonstopnewsuk/\">Nalini Thakor</a>, <a href=\"https://profiles.wordpress.org/namithjawahar/\">Namith Jawahar</a>, <a href=\"https://profiles.wordpress.org/nao/\">Naoko Takano</a>, <a href=\"https://profiles.wordpress.org/natewr/\">NateWr</a>, <a href=\"https://profiles.wordpress.org/greatislander/\">Ned Zimmerman</a>, <a href=\"https://profiles.wordpress.org/nettsite/\">NettSite</a>, <a href=\"https://profiles.wordpress.org/eidolonnight/\">Nicholas Garofalo</a>, <a href=\"https://profiles.wordpress.org/ndiego/\">Nick Diego</a>, <a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nickcernis/\">nickcernis</a>, <a href=\"https://profiles.wordpress.org/nico23/\">Nico</a>, <a href=\"https://profiles.wordpress.org/jainnidhi/\">Nidhi Jain</a>, <a href=\"https://profiles.wordpress.org/nidhidhandhukiya/\">nidhidhandhukiya</a>, <a href=\"https://profiles.wordpress.org/nielslange/\">Niels Lange</a>, <a href=\"https://profiles.wordpress.org/ntsekouras/\">Nik Tsekouras</a>, <a href=\"https://profiles.wordpress.org/nikschavan/\">Nikhil Chavan</a>, <a href=\"https://profiles.wordpress.org/nlpro/\">nlpro</a>, <a href=\"https://profiles.wordpress.org/ockham/\">ockham</a>, <a href=\"https://profiles.wordpress.org/oglekler/\">Olga Gleckler</a>, <a href=\"https://profiles.wordpress.org/domainsupport/\">Oliver Campion</a>, <a href=\"https://profiles.wordpress.org/alshakero/\">Omar Alshaker</a>, <a href=\"https://profiles.wordpress.org/omarreiss/\">Omar Reiss</a>, <a href=\"https://profiles.wordpress.org/opr18/\">opr18</a>, <a href=\"https://profiles.wordpress.org/ellenbauer/\">Outzen Larkin</a>, <a href=\"https://profiles.wordpress.org/ov3rfly/\">Ov3rfly</a>, <a href=\"https://profiles.wordpress.org/ovann86/\">ovann86</a>, <a href=\"https://profiles.wordpress.org/ovidiul/\">ovidiul</a>, <a href=\"https://profiles.wordpress.org/paaljoachim/\">Paal Joachim Romdahl</a>, <a href=\"https://profiles.wordpress.org/pablohoneyhoney/\">Pablo Honey</a>, <a href=\"https://profiles.wordpress.org/iaaxpage/\">page-carbajal</a>, <a href=\"https://profiles.wordpress.org/palmiak/\">palmiak</a>, <a href=\"https://profiles.wordpress.org/pankajmohale/\">Pankaj Mohale</a>, <a href=\"https://profiles.wordpress.org/pls78/\">Paolo L. Scala</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/patrick-b/\">Patrick Boehner</a>, <a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pbiron/\">Paul Biron</a>, <a href=\"https://profiles.wordpress.org/pabline/\">Paul Bunkham</a>, <a href=\"https://profiles.wordpress.org/rixeo/\">Paul Kevin</a>, <a href=\"https://profiles.wordpress.org/paulschreiber/\">Paul Schreiber</a>, <a href=\"https://profiles.wordpress.org/pschrottky/\">Paul Von Schrottky</a>, <a href=\"https://profiles.wordpress.org/psrpinto/\">Paulo Pinto</a>, <a href=\"https://profiles.wordpress.org/malinevskiy/\">Pavlo</a>, <a href=\"https://profiles.wordpress.org/pbking/\">pbking</a>, <a href=\"https://profiles.wordpress.org/pedromendonca/\">Pedro Mendon&#231;a</a>, <a href=\"https://profiles.wordpress.org/pputzer/\">pepe</a>, <a href=\"https://profiles.wordpress.org/petaryoast/\">Petar Ratković</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/walbo/\">Petter Walb&#248; Johnsg&#229;rd</a>, <a href=\"https://profiles.wordpress.org/johnstonphilip/\">Phil Johnston</a>, <a href=\"https://profiles.wordpress.org/philipmjackson/\">Philip Jackson</a>, <a href=\"https://profiles.wordpress.org/pierlo/\">Pierre Gordon</a>, <a href=\"https://profiles.wordpress.org/nekojonez/\">Pieterjan Deneys</a>, <a href=\"https://profiles.wordpress.org/boniu91/\">Piotrek Boniu</a>, <a href=\"https://profiles.wordpress.org/webtechpooja/\">Pooja Derashri</a>, <a href=\"https://profiles.wordpress.org/powerbuoy/\">powerbuoy</a>, <a href=\"https://profiles.wordpress.org/praem90/\">praem90</a>, <a href=\"https://profiles.wordpress.org/promz/\">Pramod Jodhani</a>, <a href=\"https://profiles.wordpress.org/presskopp/\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/presstoke/\">presstoke</a>, <a href=\"https://profiles.wordpress.org/procodewp/\">procodewp</a>, <a href=\"https://profiles.wordpress.org/psealock/\">psealock</a>, <a href=\"https://profiles.wordpress.org/psufan/\">psufan</a>, <a href=\"https://profiles.wordpress.org/pwtyler/\">pwtyler</a>, <a href=\"https://profiles.wordpress.org/rachelbaker/\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/radixweb/\">Radixweb</a>, <a href=\"https://profiles.wordpress.org/rafiahmedd/\">Rafi Ahmed</a>, <a href=\"https://profiles.wordpress.org/rtm909/\">Rahul Mehta</a>, <a href=\"https://profiles.wordpress.org/ralucastn/\">ralucastn</a>, <a href=\"https://profiles.wordpress.org/rahmohn/\">Ramon Ahnert</a>, <a href=\"https://profiles.wordpress.org/ramonopoly/\">ramonopoly</a>, <a href=\"https://profiles.wordpress.org/ravipatel/\">ravipatel</a>, <a href=\"https://profiles.wordpress.org/rehanali/\">Rehan Ali</a>, <a href=\"https://profiles.wordpress.org/renathoc/\">Renatho (a11n)</a>, <a href=\"https://profiles.wordpress.org/retrofox/\">retrofox</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/rianrietveld/\">Rian Rietveld</a>, <a href=\"https://profiles.wordpress.org/richtabor/\">Rich Tabor</a>, <a href=\"https://profiles.wordpress.org/richardfoley/\">Richard Foley</a>, <a href=\"https://profiles.wordpress.org/richards1052/\">richards1052</a>, <a href=\"https://profiles.wordpress.org/rickcurran/\">Rick Curran</a>, <a href=\"https://profiles.wordpress.org/rbrishabh/\">Rishabh Budhiraja</a>, <a href=\"https://profiles.wordpress.org/saju4wordpress/\">Riyadh Ahmed</a>, <a href=\"https://profiles.wordpress.org/rmartinezduque/\">rmartinezduque</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/robertghetau/\">robertght</a>, <a href=\"https://profiles.wordpress.org/robtarr/\">robtarr</a>, <a href=\"https://profiles.wordpress.org/kreppar/\">Rodrigo Arias</a>, <a href=\"https://profiles.wordpress.org/rohan013/\">Rohan Rawat</a>, <a href=\"https://profiles.wordpress.org/rhnsharma/\">Rohan Sharma</a>, <a href=\"https://profiles.wordpress.org/rolfsiebers/\">Rolf Siebers</a>, <a href=\"https://profiles.wordpress.org/ronakganatra/\">Ronak Ganatra</a>, <a href=\"https://profiles.wordpress.org/rkohilakis/\">Roxy Kohilakis</a>, <a href=\"https://profiles.wordpress.org/russhylov/\">Ruslan</a>, <a href=\"https://profiles.wordpress.org/rviscomi/\">rviscomi</a>, <a href=\"https://profiles.wordpress.org/welcher/\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/skierpage/\">S Page</a>, <a href=\"https://profiles.wordpress.org/sebastienserre/\">S&#233;bastien SERRE</a>, <a href=\"https://profiles.wordpress.org/soean/\">S&#246;ren Wrede</a>, <a href=\"https://profiles.wordpress.org/sabbirshouvo/\">Sabbir Hasan</a>, <a href=\"https://profiles.wordpress.org/sabrib/\">Sabri Bouchaala</a>, <a href=\"https://profiles.wordpress.org/zeo/\">Safirul Alredha</a>, <a href=\"https://profiles.wordpress.org/solarissmoke/\">Samir Shah</a>, <a href=\"https://profiles.wordpress.org/otto42/\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/sandipmondal/\">Sandip Mondal - a11n</a>, <a href=\"https://profiles.wordpress.org/sanketchodavadiya/\">Sanket Chodavadiya</a>, <a href=\"https://profiles.wordpress.org/mikachan/\">Sarah Norris</a>, <a href=\"https://profiles.wordpress.org/sarayourfriend/\">sarayourfriend</a>, <a href=\"https://profiles.wordpress.org/sathyapulse/\">Sathiyamoorthy V</a>, <a href=\"https://profiles.wordpress.org/savicmarko1985/\">savicmarko1985</a>, <a href=\"https://profiles.wordpress.org/sayedulsayem/\">Sayedul Sayem</a>, <a href=\"https://profiles.wordpress.org/swb1192/\">Scott Buscemi</a>, <a href=\"https://profiles.wordpress.org/scribu/\">scribu</a>, <a href=\"https://profiles.wordpress.org/seanmcmillan/\">Sean McMillan</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula/\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/omaeyusuke/\">Segayuu</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sergiocinos/\">Sergio Cinos</a>, <a href=\"https://profiles.wordpress.org/sergioestevao/\">SergioEstevao</a>, <a href=\"https://profiles.wordpress.org/shaharyar10/\">Shaharyar Afzal</a>, <a href=\"https://profiles.wordpress.org/shaunandrews/\">shaunandrews</a>, <a href=\"https://profiles.wordpress.org/shohag121/\">Shazahanul Islam Shohag</a>, <a href=\"https://profiles.wordpress.org/shimon246/\">shimon246</a>, <a href=\"https://profiles.wordpress.org/shital-patel/\">Shital Marakana</a>, <a href=\"https://profiles.wordpress.org/shivapoudel/\">Shiva Poudel</a>, <a href=\"https://profiles.wordpress.org/rsiddharth/\">siddharth</a>, <a href=\"https://profiles.wordpress.org/nomnom99/\">Siddharth Thevaril</a>, <a href=\"https://profiles.wordpress.org/siliconforks/\">siliconforks</a>, <a href=\"https://profiles.wordpress.org/simonhammes/\">simonhammes</a>, <a href=\"https://profiles.wordpress.org/siobhan/\">Siobhan</a>, <a href=\"https://profiles.wordpress.org/siobhyb/\">Siobhan</a>, <a href=\"https://profiles.wordpress.org/sirreal/\">sirreal</a>, <a href=\"https://profiles.wordpress.org/sjlevy/\">sjlevy</a>, <a href=\"https://profiles.wordpress.org/skunkbad/\">skunkbad</a>, <a href=\"https://profiles.wordpress.org/smit08/\">Smit Rathod</a>, <a href=\"https://profiles.wordpress.org/snapfractalpop/\">snapfractalpop</a>, <a href=\"https://profiles.wordpress.org/sourovroy/\">Sourov Roy</a>, <a href=\"https://profiles.wordpress.org/spytzo/\">spytzo</a>, <a href=\"https://profiles.wordpress.org/ssergei/\">ssergei</a>, <a href=\"https://profiles.wordpress.org/stacimc/\">stacimc</a>, <a href=\"https://profiles.wordpress.org/ryokuhi/\">Stefano Minoia</a>, <a href=\"https://profiles.wordpress.org/hypest/\">Stefanos Togoulidis</a>, <a href=\"https://profiles.wordpress.org/sabernhardt/\">Stephen Bernhardt</a>, <a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/strider72/\">Stephen Rider</a>, <a href=\"https://profiles.wordpress.org/dufresnesteven/\">Steve Dufresne</a>, <a href=\"https://profiles.wordpress.org/stevehenty/\">Steve Henty</a>, <a href=\"https://profiles.wordpress.org/stevegs/\">stevegs</a>, <a href=\"https://profiles.wordpress.org/stormrockwell/\">Storm Rockwell</a>, <a href=\"https://profiles.wordpress.org/mahype/\">Sven Wagener</a>, <a href=\"https://profiles.wordpress.org/cybr/\">Sybre Waaijer</a>, <a href=\"https://profiles.wordpress.org/synchro/\">Synchro</a>, <a href=\"https://profiles.wordpress.org/szaqal21/\">szaqal21</a>, <a href=\"https://profiles.wordpress.org/tacoverdo/\">Taco Verdonschot</a>, <a href=\"https://profiles.wordpress.org/takahashi_fumiki/\">Takahashi Fumiki</a>, <a href=\"https://profiles.wordpress.org/karmatosed/\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/sparklingrobots/\">Tara King</a>, <a href=\"https://profiles.wordpress.org/tareiking/\">Tarei King</a>, <a href=\"https://profiles.wordpress.org/staatic/\">Team Staatic</a>, <a href=\"https://profiles.wordpress.org/tellyworth/\">Tellyworth</a>, <a href=\"https://profiles.wordpress.org/terraling/\">terraling</a>, <a href=\"https://profiles.wordpress.org/terriann/\">Terri Ann</a>, <a href=\"https://profiles.wordpress.org/wildworks/\">Tetsuaki Hamano</a>, <a href=\"https://profiles.wordpress.org/themiked/\">theMikeD</a>, <a href=\"https://profiles.wordpress.org/tweetythierry/\">Thierry Muller</a>, <a href=\"https://profiles.wordpress.org/thulshof/\">Thijs Hulshof</a>, <a href=\"https://profiles.wordpress.org/thimalw/\">Thimal Wickremage</a>, <a href=\"https://profiles.wordpress.org/thisiswilliam/\">thisiswilliam</a>, <a href=\"https://profiles.wordpress.org/thomasplevy/\">Thomas Patrick Levy</a>, <a href=\"https://profiles.wordpress.org/timlappe/\">Tim Lappe</a>, <a href=\"https://profiles.wordpress.org/tnolte/\">Tim Nolte</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs/\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/titsmaker/\">titsmaker</a>, <a href=\"https://profiles.wordpress.org/tjcafferkey/\">tjcafferkey</a>, <a href=\"https://profiles.wordpress.org/tmatsuur/\">tmatsuur</a>, <a href=\"https://profiles.wordpress.org/tobiasbg/\">TobiasBg</a>, <a href=\"https://profiles.wordpress.org/tobifjellner/\">tobifjellner (Tor-Bjorn Fjellner)</a>, <a href=\"https://profiles.wordpress.org/tomalec/\">Tomek</a>, <a href=\"https://profiles.wordpress.org/shimotomoki/\">Tomoki Shimomura</a>, <a href=\"https://profiles.wordpress.org/starbuck/\">Tony G</a>, <a href=\"https://profiles.wordpress.org/ttahmouch/\">Tony Tahmouch</a>, <a href=\"https://profiles.wordpress.org/hellofromtonya/\">Tonya Mork</a>, <a href=\"https://profiles.wordpress.org/toro_unit/\">Toro_Unit (Hiroshi Urabe)</a>, <a href=\"https://profiles.wordpress.org/zodiac1978/\">Torsten Landsiedel</a>, <a href=\"https://profiles.wordpress.org/sierratr/\">Tracy</a>, <a href=\"https://profiles.wordpress.org/travisnorthcutt/\">Travis Northcutt</a>, <a href=\"https://profiles.wordpress.org/tubys/\">tubys</a>, <a href=\"https://profiles.wordpress.org/dinhtungdu/\">Tung Du</a>, <a href=\"https://profiles.wordpress.org/twstokes/\">twstokes</a>, <a href=\"https://profiles.wordpress.org/desaiuditd/\">Udit Desai</a>, <a href=\"https://profiles.wordpress.org/umesh84/\">Umesh Gupta</a>, <a href=\"https://profiles.wordpress.org/webulous/\">Venkat Raj</a>, <a href=\"https://profiles.wordpress.org/versusbassz/\">versusbassz</a>, <a href=\"https://profiles.wordpress.org/bartoszgrzesik/\">verybg</a>, <a href=\"https://profiles.wordpress.org/vcanales/\">Vicente Canales</a>, <a href=\"https://profiles.wordpress.org/szepeviktor/\">Viktor Sz&#233;pe</a>, <a href=\"https://profiles.wordpress.org/vishitshah/\">Vishit Shah</a>, <a href=\"https://profiles.wordpress.org/vladytimy/\">Vlad T</a>, <a href=\"https://profiles.wordpress.org/vondelphia/\">Vondelphia.com</a>, <a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>, <a href=\"https://profiles.wordpress.org/wb1234/\">wb1234</a>, <a href=\"https://profiles.wordpress.org/webmandesign/\">WebMan Design &#124; Oliver Juhas</a>, <a href=\"https://profiles.wordpress.org/west7/\">Wes Theron</a>, <a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/wfmattr/\">WFMattR</a>, <a href=\"https://profiles.wordpress.org/skorasaurus/\">Will Skora</a>, <a href=\"https://profiles.wordpress.org/earnjam/\">William Earnhardt</a>, <a href=\"https://profiles.wordpress.org/williampatton/\">williampatton</a>, <a href=\"https://profiles.wordpress.org/wojsmol/\">wojsmol</a>, <a href=\"https://profiles.wordpress.org/woodyhayday/\">woodyhayday</a>, <a href=\"https://profiles.wordpress.org/wp_kc/\">wp_kc</a>, <a href=\"https://profiles.wordpress.org/antonynz/\">wpcharged</a>, <a href=\"https://profiles.wordpress.org/wpnomad/\">wpnomad a11n</a>, <a href=\"https://profiles.wordpress.org/wpsoul/\">wpsoul</a>, <a href=\"https://profiles.wordpress.org/wpweaver/\">wpweaver</a>, <a href=\"https://profiles.wordpress.org/yagniksangani/\">Yagnik Sangani</a>, <a href=\"https://profiles.wordpress.org/fierevere/\">Yui</a>, <a href=\"https://profiles.wordpress.org/dolphingg/\">Yunus Ertuğrul</a>, <a href=\"https://profiles.wordpress.org/yvettesonneveld/\">Yvette Sonneveld</a>, <a href=\"https://profiles.wordpress.org/zebulan/\">Zebulan Stanphill</a>, and <a href=\"https://profiles.wordpress.org/zoiec/\">zoiec</a>.</p>\n\n\n\n<p>By release day, 71 locales had translated 90 percent or more of WordPress 5.9 in their language. Community translators are hard at work ensuring more translations are on their way. Thank you to everyone who helps to make WordPress available in 205 languages.</p>\n\n\n\n<p>Many thanks to all of the community volunteers who contribute in the <a href=\"https://wordpress.org/support/\">support forums</a>. They help to answer questions from people across the world. The success of releases, from the first one in 2003, owes much to the efforts of the support contributors.&nbsp;</p>\n\n\n\n<p><em>If contributing to WordPress appeals to you, it’s easy to learn more and get involved. Discover the different teams that come together to <a href=\"https://make.wordpress.org/\">Make WordPress</a> website and find out the latest plans on the <a href=\"https://make.wordpress.org/core/\">core development blog</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12089\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:63:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 5.9 RC3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2022/01/wordpress-5-9-rc3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 18 Jan 2022 22:28:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12050\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"Download to test the third Release Candidate (RC3) for WordPress 5.9.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4760:\"\n<p>The third <a href=\"https://make.wordpress.org/core/handbook/glossary/#rc\">Release Candidate</a> (RC3) for <a href=\"https://make.wordpress.org/core/5-9/\">WordPress 5.9</a> is here!</p>\n\n\n\n<p>Thank you to everyone who has contributed thus far toward testing and filing bugs to help make WordPress 5.9 a great release. <strong>WordPress 5.9 is slated to land in just</strong> <strong>one week—on January 25, 2022.</strong> You still have time to help! Since RC2 arrived last week, testers have found and fixed <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=5.9&amp;time=01%2F12%2F2022..01%2F17%2F2022&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">two</a> bugs, <a href=\"https://core.trac.wordpress.org/changeset/52596\">14 fixes</a> from Gutenberg. There has been one additional <a href=\"https://core.trac.wordpress.org/changeset/52598\">Gutenberg fix</a> today.</p>\n\n\n\n<h2 id=\"testing-the-release\">Testing the release</h2>\n\n\n\n<p>You can test the WordPress 5.9 release candidate in three ways:</p>\n\n\n\n<p><strong>Option 1</strong>: Install and activate the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</p>\n\n\n\n<p><strong>Option 2</strong>: Download the beta version here (<a href=\"https://wordpress.org/wordpress-5.9-RC3.zip\">zip</a>).</p>\n\n\n\n<p><strong>Option 3</strong>: When using WP-CLI to upgrade from Beta 1, 2, 3, 4, RC1, or RC2 on a case-insensitive filesystem, please use the following command sequence:</p>\n\n\n\n<h4 id=\"command-one\">Command One:</h4>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-RC3</code></pre>\n\n\n\n<h4 id=\"command-two\">Command Two:</h4>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-RC3 --force</code></pre>\n\n\n\n<p>Your help to test the third Release Candidate is vital: the more testing that happens, the more stable the release, and the better the experience for users, developers, and the WordPress community.</p>\n\n\n\n<p>Thank you to all contributors who tested the <a href=\"https://wordpress.org/news/2022/01/wordpress-5-9-rc-2/\">RC2 release</a> and gave feedback. Testing for bugs is a critical part of polishing every release and is a great way to contribute to WordPress.</p>\n\n\n\n<h2 id=\"how-to-help\">How to help</h2>\n\n\n\n<p><a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\">Help test WordPress 5.9 features</a> – this post provides a guide to set up your testing environment, a list of testable features, and information about how to submit feedback you find as you go.</p>\n\n\n\n<p>Skilled in languages other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help translate WordPress into more than 100 languages!</a> Thanks to every locale that is working on translations.</p>\n\n\n\n<p>Developers and those interested in more background to the features can find more in the <a href=\"https://make.wordpress.org/core/2022/01/10/wordpress-5-9-field-guide/” with “https://make.wordpress.org/core/2022/01/10/wordpress-5-9-field-guide/\">Field Guide</a>. You can also follow the <a href=\"https://make.wordpress.org/core/5-9/\">5.9 development cycle</a> and timeline.</p>\n\n\n\n<p>If you have found a bug, you can post the details to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums.</p>\n\n\n\n<p>If you are comfortable writing a reproducible bug report, you can <a href=\"https://core.trac.wordpress.org/newticket\">file one on WordPress Trac</a>, where you can also check the issue against <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</p>\n\n\n\n<p><em>For their help in compiling this post, props to </em><a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a>, <em><a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a>, </em><a href=\'https://profiles.wordpress.org/psykro/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>psykro</a><em>,<a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a>, <a href=\'https://profiles.wordpress.org/chanthaboune/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>chanthaboune</a>, <a href=\'https://profiles.wordpress.org/davidbaumwald/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>davidbaumwald</a>, and <a href=\'https://profiles.wordpress.org/hellofromtonya/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>hellofromtonya</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12050\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:61:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WP Briefing: Episode 23: A letter from WordPress’ Executive Director\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"https://wordpress.org/news/2022/01/episode-23-a-letter-from-wordpress-executive-director/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 17 Jan 2022 12:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"wp-briefing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=12043\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:408:\"As we greet a new year, WordPress&#8217; Executive Director writes a letter to the project and community that speaks to the hopes of the year ahead. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits Editor:&#160;Dustin Hartzler Logo:&#160;Beatriz Fialho Production:&#160;Chloé Bringmann Song: Fearless First [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2022/01/WP-Briefing-023.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6741:\"\n<p>As we greet a new year, WordPress&#8217; Executive Director writes a letter to the project and community that speaks to the hopes of the year ahead.</p>\n\n\n\n<p><em><strong>Have a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a></li><li>Song: Fearless First by Kevin MacLeod</li></ul>\n\n\n\n<h2 id=\"transcript\">Transcript</h2>\n\n\n\n<span id=\"more-12043\"></span>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:10</p>\n\n\n\n<p>Hello, everyone, and welcome to the WordPress Briefing. The podcast where you can catch quick explanations of the ideas behind the WordPress open source project, some insight into the community that supports it, and get a small list of big things coming up in the next two weeks. I&#8217;m your host, Josepha Haden Chomphosy. Here we go!</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:40</p>\n\n\n\n<p>Yesterday marked three years since the WordPress project welcomed me as their executive director. As I start my fourth year, I&#8217;ve spent a bit of time considering what the next five years will bring us. WordPress will turn 19 this year, which means that we will soon be a whopping 20 years old; for some of the people who have been with the project since the beginning, that can represent two-thirds of their whole life. And even if you were not that young when you got here, two decades as an open source project is really a cause for celebration.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:10</p>\n\n\n\n<p>I am not in that group that has been here forever. I showed up for the first time in 2009, as a community organizer, self-sponsored, and I learned so much about myself as a person and as a leader while I was doing that. So when I arrived as a sponsored contributor in 2015, I already knew exactly what made this work so fulfilling for me was these three things:&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:34</p>\n\n\n\n<p>First, the ability to lend a hand in those moments where I wish someone had lent a hand.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:40</p>\n\n\n\n<p>Second is the delight of seeing people&#8217;s first successes and the joy of watching them grow over time.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:48</p>\n\n\n\n<p>And the third was a chance to be part of something great, which turned out to be something greater; greater than me or you or a CMS.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:58</p>\n\n\n\n<p>This list is still at the heart of what I feel I get out of the WordPress project. But it has also grown substantially in my seven years as a sponsored contributor. I now also love how we as a community of contributors get to foster a better way to lead and a better way to collaborate. And through those things help people find a way to have a better life. Not just through WordPress, the CMS, but through WordPress, the people, and WordPress, the project.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:25</p>\n\n\n\n<p>And so when I think of what I want for WordPress in its 19th year, so that we can head with confidence and dignity into our 20th year, it is this:&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:35</p>\n\n\n\n<p>I want you to remember that you are not alone here. People come together in the world often because of a shared location. But WordPress fosters this beautiful experience of bringing us together because of what we care about. Whether you care about PHP standards, diversity in technology, helping people with their first big wins, making WordPress more secure. I mean, if what you care about is being able to write the most arcane and complex apps on top of WordPress that the world has ever seen. Then there are others out there who want to do that with you, too. We have so many things to connect about. And fortunately, we support a great piece of software for getting our thoughts out in the world. Take some time to see who else shares your thoughts and potentially learn a bit about the view from the other side.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>03:26</p>\n\n\n\n<p>And speaking of the other side, I also want us to approach our discussions as the US versus the Problem TM. WordPress may be 20 years old, and we may stand on the shoulders of giants, but right now, the people who are here you, you are explorers and creators and guides toward the best possible future for WordPress. The tension that we witness between teams is always about the best possible answers for the people who use our software. It is about securing the freedoms of the open web for everyone who comes after us whether they know they need those freedoms or not.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>04:04</p>\n\n\n\n<p>And finally, I want us to expand our reasons for doing this at all. If you are a member of the community of contributors, We frequently talk about how we give back because WordPress gave to us. Or if you are part of a Five for the Future group. You have heard that companies who have experienced success because of WordPress should commit 5% of their resources back to the project to ensure WordPress&#8217; long-term success. But the reason that I keep doing this, and hopefully a new reason for you to keep doing this is that we can take part in securing opportunities for future users of WordPress.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>04:42</p>\n\n\n\n<p>Yes, I want WordPress to be the best CMS. Yes, I want this community to be vibrant and engaged. Yes, I want WordPress to be a shining beacon of how to work remotely. And I want all of that because I know it is our careful and tireless stewardship of this project that lets us continue to lend a hand in those moments where people wish for someone to lend a hand.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:11</p>\n\n\n\n<p>Those are my hopes for WordPress in 2022 to move us forward into WordPress of the future. I hope you all will come with me and we can continue our journey together.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:23</p>\n\n\n\n<p>Thanks again for listening. I&#8217;m Josepha Haden and this is the WP Briefing. See you again in a couple of weeks.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12043\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress 5.9 RC 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/news/2022/01/wordpress-5-9-rc-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jan 2022 20:43:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:3:\"RC2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12014\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"The second Release Candidate (RC2) for WordPress 5.9 is available! The final release is slated for January 25, 2022. \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Jonathan Bossenger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4966:\"\n<p>The second Release Candidate (RC2) for<a href=\"https://make.wordpress.org/core/5-9/\"> WordPress 5.9</a> is now available!&nbsp;</p>\n\n\n\n<p>“Release Candidate” means the new version of the software is ready for release. It helps the community check that nothing is missed, given the thousands of plugins and themes and differences in how millions of people use the software.</p>\n\n\n\n<p>Thank you to everyone who has contributed thus far towards testing and filing bugs to help make WordPress 5.9 a great release. WordPress 5.9 is slated for release in just two weeks on January 25, 2022. There&#8217;s still time to help! Since RC1 was released, <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=5.9&amp;time=01%2F05%2F2022..01%2F12%2F2022&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\" target=\"_blank\" rel=\"noreferrer noopener\">six</a> bugs have been found and fixed. There were <a href=\"https://core.trac.wordpress.org/changeset/52551\">13 bug fixes backported from Gutenberg.</a></p>\n\n\n\n<h2 id=\"testing-the-release\"><strong>Testing the release</strong></h2>\n\n\n\n<p>You can test the WordPress 5.9 release candidate in three ways:</p>\n\n\n\n<p><strong>Option 1:</strong> Install and activate the<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\"> <strong>WordPress Beta Tester</strong></a><strong> </strong>plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</p>\n\n\n\n<p><strong>Option 2:</strong> Direct download the beta version here (<a href=\"https://wordpress.org/wordpress-5.9-RC2.zip\"><strong>zip</strong></a>).</p>\n\n\n\n<p><strong>Option 3:</strong> When using WP-CLI to upgrade from Beta 1, 2, 3, 4, or RC1, on a case-insensitive filesystem, please use the following command sequence:</p>\n\n\n\n<p>Command One:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-RC2</code></pre>\n\n\n\n<p>Command Two:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-RC2 --force</code></pre>\n\n\n\n<p>Your help to test the second Release Candidate is vital: the more testing that happens, the more stable the release, and the better the experience for users and developers—and the entire WordPress community.</p>\n\n\n\n<p>Thank you to all of the contributors who tested the RC1 release and gave feedback. Testing for bugs is not just a critical part of polishing every release, it is also a great way to contribute to WordPress.</p>\n\n\n\n<h2 id=\"how-to-help\"><strong>How to Help</strong></h2>\n\n\n\n<p><a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\">Help test WordPress 5.9 features</a> – a guide to how you can take part.</p>\n\n\n\n<p>Can you write in another language other than English? You can<a href=\"https://translate.wordpress.org/projects/wp/dev\"> help translate WordPress into more than 100 languages!</a> Release Candidate 1 marked the<a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\"> hard string freeze</a> point of the 5.9 release schedule. Thanks to every locale that is already involved with translations.</p>\n\n\n\n<p>Developers and those interested in more of the background to the features can find more in the <a href=\"https://make.wordpress.org/core/2022/01/10/wordpress-5-9-field-guide/\">Field Notes</a>. More developer notes will be added as the release progresses to its final stage. You can also follow the <a href=\"https://make.wordpress.org/core/5-9/\">5.9 development cycle</a> and timeline.</p>\n\n\n\n<p><strong><em>If you think you have found a bug</em></strong><em>, you can post the details to the</em><a href=\"https://wordpress.org/support/forum/alphabeta\"><em> </em><em>Alpha/Beta area</em></a><em> in the support forums.</em></p>\n\n\n\n<p><em>&nbsp;If you are comfortable writing a reproducible bug report, you can</em><a href=\"https://core.trac.wordpress.org/newticket\"><em> </em><em>file one on WordPress Trac</em></a><em>, where you can also check the issue against</em><a href=\"https://core.trac.wordpress.org/tickets/major\"><em> </em><em>a list of known bugs</em></a><em>.</em></p>\n\n\n\n<p><em>Props to: </em><a href=\'https://profiles.wordpress.org/psykro/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>psykro</a> and <a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a><em>, and </em><a href=\'https://profiles.wordpress.org/hellofromtonya/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>hellofromtonya</a>, <a href=\'https://profiles.wordpress.org/audrasjb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>audrasjb</a>, <a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a> and <a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a> <em>for final review.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"12014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 5.8.3 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2022/01/wordpress-5-8-3-security-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jan 2022 21:02:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11999\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:360:\"This security release features four security fixes. Because this is a security release, it is recommended that you update your sites immediately. All versions since WordPress 3.7 have also been updated. WordPress 5.8.3 is a short-cycle security release. The next major release will be version 5.9, which is already in the Release Candidate stage. You [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Jonathan Desrosiers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3681:\"\n<p>This security release features four security fixes. Because this is a security release, it is recommended that you update your sites immediately. All versions since WordPress 3.7 have also been updated.</p>\n\n\n\n<p>WordPress 5.8.3 is a short-cycle security release. The next major release will be version <a href=\"https://make.wordpress.org/core/5-9/\">5.9</a>, which is already in the Release Candidate stage.</p>\n\n\n\n<p>You can update to WordPress 5.8.3 by downloading from WordPress.org or visiting your Dashboard → Updates and clicking Update Now.</p>\n\n\n\n<p>If you have sites that support automatic background updates, they’ve already started the update process.</p>\n\n\n\n<h3 id=\"security-updates\">Security Updates</h3>\n\n\n\n<p>Four security issues affect WordPress versions between 3.7 and 5.8. If you haven’t yet updated to 5.8, all WordPress versions since 3.7 have also been updated to fix the following security issue (except where noted otherwise):</p>\n\n\n\n<ul><li>Props to Karim El Ouerghemmi and Simon Scannell of <a href=\"https://www.sonarsource.com/\">SonarSource</a> for disclosing an issue with stored XSS through post slugs.</li><li>Props to Simon Scannell of <a href=\"https://www.sonarsource.com/\">SonarSource</a> for reporting an issue with Object injection in some multisite installations.</li><li>Props to ngocnb and khuyenn from <a href=\"https://giaohangtietkiem.vn/\">GiaoHangTietKiem JSC</a> for working with <a href=\"https://www.zerodayinitiative.com/\">Trend Micro Zero Day Initiative</a> on reporting a SQL injection vulnerability in WP_Query.</li><li>Props to Ben Bidner from the WordPress security team for reporting a SQL injection vulnerability in WP_Meta_Query (only relevant to versions 4.1-5.8). </li></ul>\n\n\n\n<p>Thank you to all of the reporters above for <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">privately disclosing the vulnerabilities</a>. This gave the security team time to fix the vulnerabilities before WordPress sites could be attacked. Thank you to the members of the WordPress security team for implementing these fixes in WordPress.</p>\n\n\n\n<p>For more information, check out the <a href=\"https://wordpress.org/support/wordpress-version/version-5-8-3/\">5.8.3 HelpHub documentation page</a>.</p>\n\n\n\n<h3 id=\"thanks-and-props\">Thanks and props!</h3>\n\n\n\n<p>The 5.8.3 release was led by <a href=\'https://profiles.wordpress.org/desrosj/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>desrosj</a> and <a href=\'https://profiles.wordpress.org/circlecube/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>circlecube</a>.</p>\n\n\n\n<p>In addition to the security researchers and release squad members mentioned above, thank you to everyone who helped make WordPress 5.8.3 happen:</p>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/xknown/\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/ehtis/\">ehtis</a>, <a href=\"https://profiles.wordpress.org/circlecube/\">Evan Mullins</a>, <a href=\"https://profiles.wordpress.org/whyisjake/\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/iandunn/\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>, and <a href=\"https://profiles.wordpress.org/zieladam/\">zieladam</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11999\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"The Month in WordPress – December 2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2022/01/the-month-in-wordpress-december-2021/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Jan 2022 19:03:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:18:\"Month in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:18:\"month in wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11972\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:335:\"December was a busy month for the WordPress community. In the latest episode of the WP Briefing podcast, WordPress Executive Director Josepha Haden Chomphosy shares a carol of thanks and shows her gratitude to all the people who make the WordPress project a success. (&#8230;) I know that we have gotten so much done together [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"rmartinezduque\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:13065:\"\n<p>December was a busy month for the WordPress community. In the<a href=\"https://wordpress.org/news/2021/12/episode-22-a-carol-of-thanks/\"> latest episode of the WP Briefing podcast</a>, WordPress Executive Director Josepha Haden Chomphosy shares a carol of thanks and shows her gratitude to all the people who make the WordPress project a success.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>(&#8230;) I know that we have gotten so much done together in the last few years. And I am equally sure that we’re going to get so much done in the years to come. And so thank you all so much for your continued work with WordPress and the way that you just bring your best at all times.</p><cite>Josepha Haden, Executive Director of the WordPress project</cite></blockquote>\n\n\n\n<p>We said goodbye to 2021 with the annual State of the Word, along with the release of WordPress 5.9 Beta 4, among many other exciting updates. Read on to learn more about the latest community achievements.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"wordpress-5-9-the-first-release-candidate-just-landed\">WordPress 5.9: The first release candidate just landed</h2>\n\n\n\n<ul><li>Following the<a href=\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-3/\"> Beta 3</a> and<a href=\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-4/\"> Beta 4</a> releases in December, the first <a href=\"https://wordpress.org/news/2022/01/wordpress-5-9-rc-1/\">release candidate for WordPress 5.9</a> is now out and available for testing.</li><li>With less than three weeks to go until the final release, this version continues the work from last year and marks the hard<a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\"> string freeze point</a> of the 5.9 release schedule.</li><li>Follow the <a href=\"https://make.wordpress.org/core/tag/5-9+dev-notes/\">5.9 developer notes</a> to learn more about the <a href=\"https://make.wordpress.org/core/2022/01/04/miscellaneous-core-changes-in-wordpress-5-9/\">changes</a> and updates coming with this release.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Are you interested in contributing to WordPress core?</strong> Join the <a href=\"https://wordpress.slack.com/archives/C02RQBWTW\">#core</a> channel, follow the <a href=\"https://make.wordpress.org/core/\">Core Team blog</a>, and check out the <a href=\"https://make.wordpress.org/core/handbook/\">team handbook</a>. Also, don&#8217;t miss the Core Team’s weekly developer chat on Wednesdays at <a href=\"https://www.timeanddate.com/worldclock/fixedtime.html?hour=20&amp;min=00&amp;sec=0\">8 PM</a> UTC.</p></blockquote>\n\n\n\n<h2 id=\"gutenberg-releases-versions-12-1-and-12-2-are-here\">Gutenberg releases: Versions 12.1 and 12.2 are here</h2>\n\n\n\n<p>The Core Team launched two new versions of Gutenberg last month. Both come with new features, code quality improvements, and bug fixes.</p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2021/12/08/whats-new-in-gutenberg-12-1-8-december/\">Gutenberg 12.1</a> marks the return of the template List View and includes several Navigation block enhancements, new global styles features, an improved developer experience for block themes, and more.</li><li>The<a href=\"https://make.wordpress.org/core/2021/12/22/whats-new-in-gutenberg-12-2-22-december/\"> Gutenberg 12.2</a> release focuses on user experience improvements and brings the block styles preview to the Widgets Editor, among other new features.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Want to get involved in developing Gutenberg?</strong> Follow <a href=\"https://make.wordpress.org/core/\">the Core Team blog</a>, contribute to Gutenberg on <a href=\"https://github.com/WordPress/gutenberg/\">GitHub</a>, and join the <a href=\"https://wordpress.slack.com/archives/C02QB2JS7\">#core-editor</a> channel in the <a href=\"https://make.wordpress.org/chat/\">Make WordPress Slack</a>. Follow the <a href=\"https://make.wordpress.org/core/tag/gutenberg-new/\">#gutenberg-new</a> tag for details on the latest updates.</p></blockquote>\n\n\n\n<h2 id=\"highlights-from-state-of-the-word-2021\">Highlights from State of the Word 2021</h2>\n\n\n\n<ul><li><a href=\"https://wordpress.org/news/2021/12/highlights-from-state-of-the-word-2021/\">State of the Word 2021</a>, the annual keynote address delivered by WordPress co-founder Matt Mullenweg, was livestreamed from New York City on December 14, 2021. The event gathered WordPress enthusiasts at 29 watch parties around the world.</li><li>Matt shared his thoughts on the progress of the WordPress project and made announcements regarding its future in 2022. The presentation was followed by a Question and Answer session.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>If you missed the event’s livestream, you could watch the </strong><a href=\"https://wordpress.tv/2021/12/15/matt-mullenweg-2021-state-of-the-word/\"><strong>State of the Word recording</strong></a><strong> and the </strong><a href=\"https://wordpress.tv/2021/12/15/matt-mullenweg-state-of-the-word-2021-qa/\"><strong>Q&amp;A session</strong></a><strong> on WordPress.tv.</strong></p></blockquote>\n\n\n\n<h2 id=\"team-updates-2022-major-release-timings-new-team-rep-announcements-and-more\">Team updates: 2022 major release timings, new team rep announcements, and more</h2>\n\n\n\n<ul><li>The Core Team opened a discussion on <a href=\"https://make.wordpress.org/core/2021/12/17/discussion-2022-major-release-timing/\">the release dates for 2022</a> and the possibility of having four major WordPress releases this year.</li><li>The following teams announced their team representatives for 2022: <a href=\"https://make.wordpress.org/themes/2021/12/03/introducing-new-themes-team-representatives/\">Themes</a>, <a href=\"https://make.wordpress.org/support/2021/12/agenda-for-the-december-9-support-meeting/\">Support</a>, <a href=\"https://make.wordpress.org/polyglots/2021/11/08/call-for-polyglots-team-representatives/#comment-293358\">Polyglots</a>, and <a href=\"https://make.wordpress.org/community/2022/01/03/announcement-team-representatives-for-2022/\">Community</a>.</li><li>In 2021, 2572 people contributed to WordPress source code using Trac, including 305 first-timers. Check out <a href=\"https://make.wordpress.org/core/2021/12/29/a-year-in-core-2021/\">A Year in Core – 2021</a> for more interesting stats on WordPress Core contributions.</li><li>The Diverse Speaker Training Group (#WPDiversity) shared its accomplishments from last year in this<a href=\"https://make.wordpress.org/community/2021/12/14/diverse-speaker-training-group-wpdiversity-2021-year-end-report/\"> 2021 year-end report</a>.</li><li>The Training Team<a href=\"https://make.wordpress.org/training/2021/12/07/december-2021-team-sprint/\"> planned a sprint</a> to audit and revisit the Learn WordPress content for the WordPress 5.9 release.</li><li>The Design Team summarized some of the key changes behind the<a href=\"https://make.wordpress.org/design/2021/12/17/redesign-of-openverse/\"> Openverse redesign</a>.</li><li>The December 2021 editions of the <a href=\"https://make.wordpress.org/polyglots/2021/12/20/polyglots-monthly-newsletter-december-2021/\">Polyglots Monthly Newsletter</a> and the<a href=\"https://make.wordpress.org/community/2021/12/14/meetup-organizer-newsletter-december-2021/\"> Meetup Organizer Newsletter</a> are out.</li><li>The latest edition of<a href=\"https://wordpress.org/news/2021/12/people-of-wordpress-collins-agbonghama/\"> </a>People of WordPress features <a href=\"https://wordpress.org/news/2021/12/people-of-wordpress-collins-agbonghama/\">Collins Agbonghama</a> from Nigeria.</li><li>The Core Team <a href=\"https://make.wordpress.org/core/2022/01/05/proposal-changes-to-javascript-coding-standards-for-full-prettier-compatibility/\">announced a proposal</a> to change the JavaScript coding standards for complete Prettier compatibility.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Are you looking for some 5.9 resources to share with your local community? </strong>Check out the <a href=\"https://make.wordpress.org/community/2021/12/10/wordpress-5-9-talking-points/\">WordPress 5.9 Talking Points for Meetup Organizers</a> post.</p></blockquote>\n\n\n\n<h2 id=\"feedback-testing-requests-contribute-by-testing-or-translating-wordpress-5-9\">Feedback/Testing requests: Contribute by testing or translating WordPress 5.9</h2>\n\n\n\n<ul><li>Your feedback on WordPress 5.9 release candidates is still needed and appreciated! If you haven’t tried this version yet, you can find instructions on testing 5.9 features <a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\">in this post</a>.</li><li>Do you speak a language other than English? The Polyglots Team announced that <a href=\"https://make.wordpress.org/polyglots/2021/12/16/wordpress-5-9-ready-to-be-translated/\">WordPress 5.9 is also ready to be translated</a>.</li><li>Version 18.9 of WordPress for<a href=\"https://make.wordpress.org/mobile/2021/12/14/call-for-testing-wordpress-for-android-18-9/\"> Android</a> is available for testing.</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\"><strong>Share your feedback</strong></a><strong> on WordPress 5.9.</strong></p></blockquote>\n\n\n\n<h2 id=\"apply-to-speak-or-host-a-workshop-at-wordcamp-europe-2022\">Apply to speak or host a workshop at WordCamp Europe 2022</h2>\n\n\n\n<ul><li>WordCamp US 2022 is currently looking for<a href=\"https://us.wordcamp.org/2022/are-you-ready-to-be-a-2022-organizer/\"> organizers</a>.</li><li>The WordPress community celebrated its first in-person WordCamp after 21 months in<a href=\"https://sevilla.wordcamp.org/2021/\"> Sevilla (Spain)</a> on December 11-12, 2021.<a href=\"https://taiwan.wordcamp.org/2021/\"> WordCamp Taiwan</a> was held online the same weekend.</li><li>The Test Team organized the Hallway Hangout titled <a href=\"https://make.wordpress.org/test/2021/12/21/hallway-hangout-lets-talk-about-wordpress-6-0/\">Let’s talk about WordPress 6.0</a> on December 21, 2021. The team also shared a wrap-up of the <a href=\"https://make.wordpress.org/test/2021/12/16/fse-program-site-editing-safari-summary/\">Site Editing Safari</a> as part of the <a href=\"https://make.wordpress.org/test/handbook/full-site-editing-outreach-experiment/\">FSE Outreach Program</a>.</li><li>The Training Team hosted several WordPress Social Learning Meetups last month, and there will be many more in <a href=\"https://www.meetup.com/wordpress-social-learning/events/\">January 2022</a>.</li><li>Last year the WordPress Foundation made significant progress in its mission to educate the public about open source software. Learn more about it in this <a href=\"https://wordpressfoundation.org/news/2021/looking-back-at-2021/\">2021 recap</a>.</li></ul>\n\n\n\n<p>Don’t miss the following upcoming WordCamps: <a href=\"https://birmingham.wordcamp.org/2022/\">WordCamp Birmingham, Alabama 2022</a>,<a href=\"https://vienna.wordcamp.org/2022/\"> </a><a href=\"https://geneve.wordcamp.org/2022/\">WordCamp Genève 2022</a><a href=\"https://vienna.wordcamp.org/2022/\">, WordCamp Vienna 2022</a>, and <a href=\"https://europe.wordcamp.org/2022/\">WordCamp Europe 2022</a>.</p>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>The</strong><a href=\"https://europe.wordcamp.org/2022/call-for-sponsors/\"><strong> Call For Sponsors</strong></a><strong> and </strong><a href=\"https://europe.wordcamp.org/2022/call-for-speakers/\"><strong>Call For Speakers</strong></a><strong> for WordCamp Europe 2022 are open! </strong>Read <a href=\"https://europe.wordcamp.org/2022/a-sneak-peek-at-wceu2022/\">this post</a> to learn more about the Organizing Team&#8217;s plans for the first in-person WordCamp Europe in three years.</p></blockquote>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p><strong><em>Have a story that we could include in the next ‘Month in WordPress’ post? Let us know by filling out </em></strong><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><strong><em>this form</em></strong></a><strong><em>.</em></strong></p>\n\n\n\n<p><em>The following folks contributed to December 2021’s Month in WordPress: <a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a>, <a href=\'https://profiles.wordpress.org/harishanker/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>harishanker</a> <a href=\'https://profiles.wordpress.org/lmurillom/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>lmurillom</a>  <a href=\'https://profiles.wordpress.org/meher/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>meher</a> <a href=\'https://profiles.wordpress.org/nalininonstopnewsuk/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>nalininonstopnewsuk</a> <a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a></em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11972\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:63:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress 5.9 RC 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/news/2022/01/wordpress-5-9-rc-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Jan 2022 20:43:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11948\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"The WordPress 5.9 Release Candidate 1 is available. The final release is slated for January 25, 2022.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"webcommsat AbhaNonStopNewsUK\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5481:\"\n<p>The first Release Candidate (RC1) for <a href=\"https://make.wordpress.org/core/5-9/\">WordPress 5.9</a> is now available!&nbsp;</p>\n\n\n\n<p>Thank you to everyone who has contributed to reach this important milestone in the community’s progress towards a WordPress 5.9 release.</p>\n\n\n\n<p>“Release Candidate” means the new version of the software is ready for release. It helps the community check that nothing is missed, given the thousands of plugins and themes and differences in how millions of people use the software.</p>\n\n\n\n<p>WordPress 5.9 is slated for release on January 25, 2022. This is just three weeks to go&nbsp; &#8211; and there’s still time to help!</p>\n\n\n\n<h2 id=\"testing-the-release\">Testing the release</h2>\n\n\n\n<p>You can test the WordPress 5.9 release candidate in three ways:</p>\n\n\n\n<p><strong>Option 1:</strong> Install and activate the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\"><strong>WordPress Beta Tester</strong></a><strong> </strong>plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</p>\n\n\n\n<p><strong>Option 2:</strong> Direct download the beta version here (<a href=\"https://wordpress.org/wordpress-5.9-RC1.zip\"><strong>zip</strong></a>).</p>\n\n\n\n<p><strong>Option 3:</strong> When using WP-CLI to upgrade from Beta 1, 2, 3 or 4 on a case-insensitive filesystem, please use the following command sequence:</p>\n\n\n\n<p>Command One:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-RC1</code></pre>\n\n\n\n<p>Command Two:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-RC1 --force</code></pre>\n\n\n\n<p>Your help to test the RC1 is vital: the more testing that happens, the more stable the release, and the better the experience for users and developers—and the entire WordPress community.</p>\n\n\n\n<p>Thank you to all of the contributors who tested the Beta releases and gave feedback. Testing for bugs is not just a critical part of polishing every release; it is also a great way to contribute to WordPress.</p>\n\n\n\n<p><a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\">Help test WordPress 5.9 features</a> &#8211; a guide to how you can take part.</p>\n\n\n\n<h2 id=\"what-is-in-wordpress-5-9-release-candidate\">What is in WordPress 5.9 release candidate?</h2>\n\n\n\n<p>This will be the first release of 2022 and continues the work towards 5.9 from last year. It features the latest advances of the block editor and is the first version of full site editing in Core.</p>\n\n\n\n<p>WordPress 5.9 also brings more refinements to the developer experience. To keep up with the latest updates and discover more about how the community works to continually improve the software, please subscribe to the <a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a>. In particular, the <a href=\"https://make.wordpress.org/core/tag/5-9+dev-notes/\">developer notes tag</a> will keep you up to date on changes that might affect your products or how you use the software.</p>\n\n\n\n<h2 id=\"plugin-and-theme-developers\">Plugin and Theme Developers</h2>\n\n\n\n<p>Please test your plugins and themes against WordPress 5.9 and update the <em>Tested up to</em> version&nbsp; to 5.9 in your readme file. If you find compatibility problems, please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">support forums</a>, so volunteers and developers can help you figure them out before the final release.</p>\n\n\n\n<p>The WordPress 5.9 Field Guide will be out very shortly. It will give you a deeper dive into the major changes.</p>\n\n\n\n<h2 id=\"how-to-help\">How to Help</h2>\n\n\n\n<p>Do you speak a language that is not English? You can <a href=\"https://translate.wordpress.org/projects/wp/dev\">help translate WordPress into more than 100 languages!</a> Release Candidate 1 marks the <a href=\"https://make.wordpress.org/polyglots/handbook/glossary/#hard-freeze\">hard string freeze</a> point of the 5.9 release schedule. Thanks to every locale that is already involved with translations.</p>\n\n\n\n<p><strong><em>If you think you have found a bug</em></strong><em>, you can post to the </em><a href=\"https://wordpress.org/support/forum/alphabeta\"><em>Alpha/Beta area</em></a><em> in the support forums.&nbsp; If you are comfortable writing a reproducible bug report, you can </em><a href=\"https://core.trac.wordpress.org/newticket\"><em>file one on WordPress Trac</em></a><em>, where you can also check the issue against </em><a href=\"https://core.trac.wordpress.org/tickets/major\"><em>a list of known bugs</em></a><em>.</em></p>\n\n\n\n<p>Props to <a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a> for the post and to <a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a> <a href=\'https://profiles.wordpress.org/hellofromtonya/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>hellofromtonya</a> <a href=\'https://profiles.wordpress.org/audrasjb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>audrasjb</a> <a href=\'https://profiles.wordpress.org/davidbaumwald/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>davidbaumwald</a> <a href=\'https://profiles.wordpress.org/estelaris/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>estelaris</a> <a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a> for final review. </p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11948\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:69:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"People of WordPress: Collins Agbonghama\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://wordpress.org/news/2021/12/people-of-wordpress-collins-agbonghama/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 Dec 2021 22:45:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Features\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:10:\"Interviews\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:17:\"Contributor Story\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:19:\"People of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11923\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:130:\"Collins Agbonghama, a web developer from Nigeria, Africa, shares how WordPress gives him a sustainable income and a better future.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"webcommsat AbhaNonStopNewsUK\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9203:\"\n<p>In this series, we share some of the inspiring stories of how WordPress and its global network of contributors can change people’s lives for the better. This month we feature a website builder from Nigeria, who uses the open source WordPress platform to support his family and to share learning with others in his home country and beyond.</p>\n\n\n\n<figure class=\"wp-block-image size-large is-resized\"><img loading=\"lazy\" src=\"https://i2.wp.com/wordpress.org/news/files/2021/12/fimg_collins-agbonghama.jpg?resize=768%2C386&#038;ssl=1\" alt=\"Collins Agbonghama\" class=\"wp-image-11919\" width=\"768\" height=\"386\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2021/12/fimg_collins-agbonghama.jpg?resize=1024%2C515&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2021/12/fimg_collins-agbonghama.jpg?resize=300%2C151&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2021/12/fimg_collins-agbonghama.jpg?resize=768%2C386&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2021/12/fimg_collins-agbonghama.jpg?w=1247&amp;ssl=1 1247w\" sizes=\"(max-width: 768px) 100vw, 768px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<h2 id=\"creating-a-life-in-the-wordpress-ecosystem\"><strong>Creating a life in the WordPress Ecosystem</strong></h2>\n\n\n\n<p>Collins Agbonghama started his journey to becoming a web developer by reading the football news headlines on a friend’s mobile phone. His fascination with development and learning continued to grow, and he now makes a living using WordPress and the web.</p>\n\n\n\n<p>Read on to discover his story, which shows with creativity and determination you can create products and make a living using WordPress.&nbsp;</p>\n\n\n\n<h2 id=\"starting-web-building-on-a-phone\"><strong>Starting web building on a phone</strong></h2>\n\n\n\n<figure class=\"wp-block-image size-full\"><img loading=\"lazy\" width=\"350\" height=\"426\" src=\"https://i2.wp.com/wordpress.org/news/files/2021/12/collins-agbonghama1.jpg?resize=350%2C426&#038;ssl=1\" alt=\"Collins Agbonghama headshot photo\" class=\"wp-image-11920\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2021/12/collins-agbonghama1.jpg?w=350&amp;ssl=1 350w, https://i2.wp.com/wordpress.org/news/files/2021/12/collins-agbonghama1.jpg?resize=246%2C300&amp;ssl=1 246w\" sizes=\"(max-width: 350px) 100vw, 350px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<p>Collins began his exploration of the internet while attending Secondary School in Nigeria, or High School as it is known in some other countries.&nbsp;</p>\n\n\n\n<p>A friend at the school had a simple mobile phone which could browse the internet. Collins had his first introduction to the World Wide Web through access to this device. He became hooked by reading headlines on a sports site about a famous English Premier League Football Club, Chelsea, a soccer team which he has long supported.</p>\n\n\n\n<p>“Being a very inquisitive person, I wanted to learn how the web works as well as have my own website. I was able to buy a classic mobile phone through the menial jobs I did after school,” he said.&nbsp;</p>\n\n\n\n<p>His first website was a wapsite or Wireless Application Protocol site optimized for mobile devices.&nbsp;</p>\n\n\n\n<p>He took to Google to learn how to actually build a site. He discovered he needed something called an ‘email address’ to sign-up for site builders. Google Search came to the rescue again, and he created the first email account for his first website.</p>\n\n\n\n<p>A desire for a website was the catalyst for further learning, starting with HTML and CSS from an online provider. His interest in building sites with more advanced tools grew, and then he came across WordPress.&nbsp;</p>\n\n\n\n<p>Using his savings, he bought the cheapest hosting plan from a local Nigerian web host. He installed WordPress and started writing tutorials for a mobile device platform. He built the site, created the lessons, and started his entry into WordPress all on a mobile phone.&nbsp;</p>\n\n\n\n<p>This led to him having the confidence to start building sites for others, and he was able to earn a small income from that.&nbsp;</p>\n\n\n\n<p>Collins said: “I couldn’t go to the university because of my precarious financial situation. I continued to do menial jobs during the day and started learning PHP in the evenings and at night using my mobile phone via online learning platforms.”</p>\n\n\n\n<p>He was later able to get an old laptop, which helped him access ebooks to learn more and practice his coding.&nbsp;</p>\n\n\n\n<p>Keen to share this learning, he started blogging about what he was learning on his website.&nbsp;&nbsp;</p>\n\n\n\n<p>Collins said: “I later took up a job teaching children at a school primarily because I got tired of the menial jobs and wanted to earn enough to take care of my internet data plan. After a while, I became fairly proficient in PHP and even took up a job to build a school management system.”</p>\n\n\n\n<h2 id=\"using-wordpress-to-make-a-living\"><strong>Using WordPress to make a living</strong></h2>\n\n\n\n<p>Collins’ blog wasn’t making money through advertisements, but he discovered opportunities to write tutorials for other platforms.&nbsp;</p>\n\n\n\n<p>“I started writing PHP and WordPress development tutorials and got paid a few hundred dollars per article. In Nigeria, that’s quite a lot of money. I was able to improve the life and wellbeing of my family and myself,” he said.</p>\n\n\n\n<p>After getting into a higher education program to study computer science, his life dramatically changed. He decided to stop writing and began to focus on building and selling WordPress plugins.&nbsp;His first one was a user and profile plugin for WordPress sites.</p>\n\n\n\n<p>“Thankfully, after a year, it started making enough revenue for me to live pretty comfortably here in Nigeria because the cost of living here is relatively low,” he said</p>\n\n\n\n<p>Today, Collins has several plugins which have given him a sustainable source of income. He’s also a Core and Translation volunteer contributor to the WordPress.org Open Source project. </p>\n\n\n\n<figure class=\"wp-block-pullquote\"><blockquote><p>I am thankful for WordPress because without it, I’m really not sure I would have been able to live a decent quality life. <br>Who knows what would have become of me?</p><cite>Collins Agbonghama</cite></blockquote></figure>\n\n\n\n<p>“I am also thankful for the community. I have made lots of friends that have been very supportive and helpful in my journey.”</p>\n\n\n\n<p>He added: “I tell people, life won’t give you what you want. You demand from life what you want. You make these demands by being determined and never giving up on your dreams and aspirations.</p>\n\n\n\n<p>“If you are poor, perhaps because you came from a humble and poor background, it is not your fault. You can’t go back in time to change things. I implore you to be strong, determined, and work hard.” </p>\n\n\n\n<p></p>\n\n\n\n<p><strong>Meet more WordPress community members in our <a href=\"https://wordpress.org/news/category/interviews/\">People of WordPress series</a>.</strong></p>\n\n\n\n<h2 id=\"contributors\">Contributors</h2>\n\n\n\n<p>Thanks to Michael Geheren (<a href=\'https://profiles.wordpress.org/geheren/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>geheren</a>), Abha Thakor (<a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a>), for writing this feature, to MeherBala (<a href=\'https://profiles.wordpress.org/meher/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>meher</a>) for follow-ups and photo-editing, and to Chloe Bringmann (<a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a>) and Nalini Thakor (<a href=\'https://profiles.wordpress.org/nalininonstopnewsuk/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>nalininonstopnewsuk</a>) for the final proofing. Thank you to Collins Agbonghama (<a href=\'https://profiles.wordpress.org/collizo4sky/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>collizo4sky</a>) for sharing his Contributor Story.</p>\n\n\n\n<p><em>Thanks to Josepha Haden Chomphosy&nbsp;(@<a href=\"https://profiles.wordpress.org/chanthaboune/\">chanthaboune</a>), Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\">@topher1kenobe</a>) and others for their support </em>of this initiative. </p>\n\n\n\n<div class=\"wp-block-media-text is-stacked-on-mobile is-vertically-aligned-center\" style=\"grid-template-columns:29% auto\"><figure class=\"wp-block-media-text__media\"><img loading=\"lazy\" width=\"180\" height=\"135\" src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?resize=180%2C135&#038;ssl=1\" alt=\"HeroPress logo\" class=\"wp-image-8409 size-full\" data-recalc-dims=\"1\" /></figure><div class=\"wp-block-media-text__content\">\n<p class=\"has-small-font-size\"><em>This People of WordPress feature is inspired by an essay originally published on </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>, a community initiative created by Topher DeRosia. It highlights people in the WordPress community who have overcome barriers and whose stories might otherwise go unheard. </em>#HeroPress </p>\n</div></div>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11923\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:66:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.9 Beta 4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Dec 2021 21:17:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11876\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WordPress 5.9 Beta 4 released on 21 December 2021 and is available for testing. \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Jonathan Bossenger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5052:\"\n<p>WordPress 5.9 Beta 4 is now available for testing!</p>\n\n\n\n<p><strong>This software version is still under development.</strong> Please do not run this software on a production site; install it on a test site, where you can try out the newest features and get a feel for how they will work on your site.</p>\n\n\n\n<p>You can test the WordPress 5.9 Beta 4 in three ways:</p>\n\n\n\n<p><strong>Option 1:</strong> Install and activate the<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\"> <strong>WordPress Beta Tester</strong></a><strong> </strong>plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</p>\n\n\n\n<p><strong>Option 2:</strong> Direct download the beta version here (<strong><a href=\"https://wordpress.org/wordpress-5.9-beta4.zip\">zip</a></strong>).</p>\n\n\n\n<p><strong>Option 3:</strong> When using WP-CLI to upgrade from Beta 1, 2, or 3 to Beta 4 on a case-insensitive filesystem, please use the following command sequence:</p>\n\n\n\n<p>Command One:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-beta4</code></pre>\n\n\n\n<p>Command Two:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-beta4 --force</code></pre>\n\n\n\n<p>The current target for the final release of 5.9 is January 25, 2022, which is only five weeks away. Your help testing this beta is vital: the more testing that happens, the more stable the release, and the better the experience for users and developers—and the entire WordPress community.</p>\n\n\n\n<h2 id=\"some-highlights\"><strong>Some Highlights</strong></h2>\n\n\n\n<p>Since <a href=\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-3/\">Beta 3</a>, 20 bugs have been fixed. Here are a few of the changes you will find in Beta 4:</p>\n\n\n\n<ul><li>Bundled Theme: Fixed duplicate CSS rules in Twenty Twenty-One theme (<a href=\"https://core.trac.wordpress.org/ticket/53605\">#53605</a>).</li><li>Customizer: It&#8217;s possible to switch to a block theme from within Customizer (<a href=\"https://core.trac.wordpress.org/ticket/54549\">#54549</a>).</li><li>Themes: Provide guidance to users seeking to preview block themes on WordPress versions below 5.9 (<a href=\"https://core.trac.wordpress.org/ticket/54575\">#54575</a>).</li><li>REST API: The get_theme_item method should respect fields param (<a href=\"https://core.trac.wordpress.org/ticket/54595\">#54595</a>).</li><li>Editor: Block Patterns: &#8220;Featured&#8221; category &amp; patterns missing from inserter (<a href=\"https://core.trac.wordpress.org/ticket/54623\">#54623</a>).</li><li>Login and registration: Add a filter to allow to disable the Login screen language dropdown – (#54675).</li></ul>\n\n\n\n<h2 id=\"how-you-can-help\"><strong>How You Can Help</strong></h2>\n\n\n\n<p><strong>Do some testing!</strong></p>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/handbook/testing/beta-testing/\">Testing for bugs</a> is vital for polishing the release in the beta stage and a great way to contribute.&nbsp;</p>\n\n\n\n<p>Please post to the<a href=\"https://wordpress.org/support/forum/alphabeta/\"> Alpha/Beta</a> area in the support forums if you find a bug. If you’re comfortable writing a reproducible<a href=\"https://make.wordpress.org/core/reports/\"> bug report</a>, file one on<a href=\"https://core.trac.wordpress.org/newticket\"> WordPress Trac</a>, where you can also find a list of<a href=\"https://core.trac.wordpress.org/tickets/major\"> known bugs</a>.</p>\n\n\n\n<h2 id=\"got-questions-here-are-some-answers\"><strong>Got questions? Here are some answers</strong></h2>\n\n\n\n<p>In the coming weeks, follow the<a href=\"https://make.wordpress.org/core/\"> Make WordPress Core blog</a> for<a href=\"https://make.wordpress.org/core/tag/5-9+dev-notes/\"> 5.9-related developer notes</a> that will cover these items in detail.</p>\n\n\n\n<p>So far, contributors have fixed <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=5.9&amp;resolution=fixed\">326 tickets and 108 new features and enhancements</a> in WordPress 5.9. More bug fixes are on the way with your help through testing.</p>\n\n\n\n<p><strong>Props to <a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a>, <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/psykro/\" target=\"_blank\">@psykro</a>, <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/hellofromtonya/\" target=\"_blank\">@hellofromtonya</a>, <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/marybaum/\" target=\"_blank\">@marybaum</a>, <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/webcommsat/\" target=\"_blank\">@webcommsat</a>, <a href=\'https://profiles.wordpress.org/audrasjb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>audrasjb</a>, <a href=\'https://profiles.wordpress.org/costdev/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>costdev</a> and <a href=\'https://profiles.wordpress.org/meher/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>meher</a> for contributions to this post.</strong></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11876\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:61:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"WP Briefing: Episode 22: A Carol of Thanks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/news/2021/12/episode-22-a-carol-of-thanks/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Dec 2021 19:22:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"wp-briefing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=11880\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:404:\"In this last episode of 2021, Josepha Haden Chomphosy takes the time to appreciate those who make the WordPress project a success and offers a carol of thanks. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits Editor:&#160;Dustin Hartzler Logo:&#160;Beatriz Fialho Production:&#160;Chloé Bringmann Song: [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2021/12/WP-Briefing-022.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5720:\"\n<p>In this last episode of 2021, Josepha Haden Chomphosy takes the time to appreciate those who make the WordPress project a success and offers a carol of thanks. </p>\n\n\n\n<p><em><strong>Have a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a></li><li>Song: Fearless First by Kevin MacLeod</li></ul>\n\n\n\n<h2 id=\"references\">References </h2>\n\n\n\n<p><a href=\"https://en.wikipedia.org/wiki/Have_Yourself_a_Merry_Little_Christmas\">Have yourself A Merry Little Christmas </a></p>\n\n\n\n<h2 id=\"transcript\">Transcript</h2>\n\n\n\n<span id=\"more-11880\"></span>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:10</p>\n\n\n\n<p>Hello everyone, and welcome to the WordPress Briefing. The podcast where you can catch quick explanations of the ideas behind the WordPress open source project. Some insight into the community that supports it and get a small list of big things coming up in the next two weeks. I&#8217;m your host Josepha Haden Chomphosy. Here we go!</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:39</p>\n\n\n\n<p>So, ages and ages ago, when I first started this podcast, someone basically requested that Matt and I do a duet for the last podcast of the year. A Christmas carol duet; him on the saxophone and me on voice. I obviously did not get that coordinated I don&#8217;t even know why I said obviously. I&#8217;ll tell you right now I did not get that coordinated. I was a very busy lady this year. So I don&#8217;t have a Matt on saxophone. Still, I did think that maybe it might be nice just for me to sing a teensy little Christmas carol for you all just because it seems especially poignant the words this year, especially after the 2020, 2021 COVID, all the things and trying to get back in person. So I&#8217;m going to sing you all one little verse from <em>Have Yourself a Merry Little Christmas</em>.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy </strong>01:35 <em>Singing</em>  </p>\n\n\n\n<p>Have yourself a merry little Christmas</p>\n\n\n\n<p>Let your heart be light</p>\n\n\n\n<p>From now on our troubles</p>\n\n\n\n<p>Will be out of sight</p>\n\n\n\n<p>Have yourself a merry little Christmas</p>\n\n\n\n<p>Make the Yuletide gay</p>\n\n\n\n<p>From now on our troubles</p>\n\n\n\n<p>Will be miles away</p>\n\n\n\n<p>Here we are as in olden days</p>\n\n\n\n<p>Happy golden days of yore</p>\n\n\n\n<p>Faithful friends who are dear to us</p>\n\n\n\n<p>Gather near to us, once more</p>\n\n\n\n<p>Through the years we all will be together</p>\n\n\n\n<p>If the fates allow</p>\n\n\n\n<p>Hang a shining star upon the highest bough</p>\n\n\n\n<p>And have yourself a merry little Christmas now</p>\n\n\n\n<p>Here we are as in olden days</p>\n\n\n\n<p>Happy golden days of yore</p>\n\n\n\n<p>Faithful friends who are dear to us</p>\n\n\n\n<p>Gather near to us, once more</p>\n\n\n\n<p>Through the years we all will be together</p>\n\n\n\n<p>If the fates allow</p>\n\n\n\n<p>Hang a shining star upon the highest bough</p>\n\n\n\n<p>And have yourself a merry little Christmas now</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>03:34</p>\n\n\n\n<p>Alright, my friends, that was from my heart to yours if you happened to listen. If you skipped a few seconds to get through it, which I would totally understand, that is also fine. But I did want to just kind of wrap up the year to let you all know that I am so incredibly grateful for all of the people who show up for the WordPress project to make it a success. I have made so many friends and wonderful acquaintances throughout my time here with the WordPress project. And especially in my three years as the project&#8217;s Executive Director. You all have put a lot of trust in me and a lot of faith. And I know that we have gotten so much done together in the last few years. And I am equally sure that we&#8217;re going to get so much done in the years to come. And so thank you all so much for your continued work with WordPress and the way that you just bring your best at all times. </p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>04:32</p>\n\n\n\n<p>One other little thanks I want to give. Over the course of this year, I&#8217;ve had an excellent team that works with me on this podcast. I have editing and design folks and people who&#8217;ve joined me here and there, folks who helped me with my production. So big thank you to <a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin</a>, <a href=\"https://profiles.wordpress.org/beafialho/\">Bea</a>, I realize your name is Beatriz in the actual credits, but I call you Bea, and so thank you. Also, a huge thank you to <a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé</a>, who does all of our production and wrangling every couple of weeks. A big round of applause and kudos to that tiny but tough team that helps me get this all done.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:10</p>\n\n\n\n<p>That&#8217;s to go on top of the general thanks to the WordPress project. And if you all are celebrators, I hope you have a wonderful holiday season. If you are not celebrators, I hope that you have a wonderful end to your year and that everything you wanted to get done, you did get done, and that you can start 2022 with a fresh slate. Again, this is the WP Briefing. Thank you so much for listening. I&#8217;m your host Josepha Haden Chomphosy, and I&#8217;ll see you again in 2022.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11880\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"Highlights from State of the Word 2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://wordpress.org/news/2021/12/highlights-from-state-of-the-word-2021/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Dec 2021 01:04:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Events\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11869\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"Highlights and the official video for State of the Word 2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Anjana Vasan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3653:\"\n<figure class=\"wp-block-embed is-type-video is-provider-youtube wp-block-embed-youtube wp-embed-aspect-16-9 wp-has-aspect-ratio\"><div class=\"wp-block-embed__wrapper\">\n<iframe loading=\"lazy\" class=\"youtube-player\" width=\"600\" height=\"338\" src=\"https://www.youtube.com/embed/OpiH_P9aGhQ?version=3&#038;rel=1&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;fs=1&#038;hl=en-US&#038;autohide=2&#038;wmode=transparent\" allowfullscreen=\"true\" style=\"border:0;\" sandbox=\"allow-scripts allow-same-origin allow-popups allow-presentation\"></iframe>\n</div></figure>\n\n\n\n<p>State of the Word 2021, the annual keynote from WordPress co-founder Matt Mullenweg, happened on December 14. The hybrid event took place in New York City with a small audience (proof of vaccination required). As Matt said, &#8220;we had people join by plane, train, and automobile.&#8221; Those who didn’t make the trek to the live event watched the livestream from wherever they call home, all around the world.&nbsp;</p>\n\n\n\n<p>It was an exciting moment for the WordPress community which also celebrated its first in-person WordCamp in Sevilla, Spain, after a lengthy hiatus for in-person events.</p>\n\n\n\n<p>You can <a href=\"https://wordpress.tv/2021/12/15/matt-mullenweg-2021-state-of-the-word/\">view the full recording</a>, complete with captions and transcripts on WordPress.tv.</p>\n\n\n\n<p>It was thrilling to see so many meetup organizers host watch parties worldwide. Twenty-eight watch parties were held across eleven countries, with more than 300 RSVPs.  </p>\n\n\n\n<p>Similar to past State of the Word events, Matt covered a broad range of topics. This year was no different. WordPress’ past, present, and future were in the spotlight, with highlights on the growth of the contributors, language translations, recent release milestones, and educational initiatives, to name a few.</p>\n\n\n\n<p>Audience members and livestreamers alike viewed product demos showcasing upcoming features that will be the hallmark of WordPress 5.9, such as full site editing, block patterns, global styling options, and enhanced image controls.</p>\n\n\n\n<p>Matt took the opportunity to remind everyone of the WordPress roadmap which includes native multi-lingual support and real-time collaborative site editing. He also pointed out that anyone can contribute to WordPress’ progress through a number of different initiatives ranging from creating new features and testing to helping spread the word and educate others.</p>\n\n\n\n<p>Matt emphasized the way that open source software gets better by reminding everyone that “The more people that use a program like WordPress, the better it gets.”</p>\n\n\n\n<p>Broader topics covering the tech landscape including web3, merger and acquisition activity, as well as the growth and support of open source software, rounded out the energetic presentation.&nbsp;</p>\n\n\n\n<p>The one-hour multimedia presentation was followed by an interactive <a href=\"https://wordpress.tv/2021/12/15/matt-mullenweg-state-of-the-word-2021-qa/\">question and answer</a> session where Matt fielded questions that were submitted ahead of the event, as well as questions from the livestream and studio audience.</p>\n\n\n\n<p>Discover everything that was covered by <a href=\"https://wordpress.tv/2021/12/15/matt-mullenweg-2021-state-of-the-word/\">watching the official event recording</a> and join the ongoing <a href=\"https://twitter.com/hashtag/ILoveWP\">#ILoveWP conversation on Twitter</a>!</p>\n\n\n\n<p><em>Special thanks to <a href=\'https://profiles.wordpress.org/dansoschin/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>dansoschin</a> for review and edits! </em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11869\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:69:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.9 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Dec 2021 20:19:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:5:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:11:\"development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11835\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"WordPress 5.9 Beta 3 is now available for testing. Help test to make the release as good as it can be.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Jonathan Bossenger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6087:\"\n<p>WordPress 5.9 Beta 3 is now available for testing!</p>\n\n\n\n<p><strong>This software version is still under development.</strong> Please do not run this software on a production site; install it on a test site, where you can try out the newest features and get a feel for how they will work on your site.</p>\n\n\n\n<p>You can test the WordPress 5.9 Beta 3 in three ways:</p>\n\n\n\n<p><strong>Option 1:</strong> Install and activate the<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\"> <strong>WordPress Beta Tester</strong></a><strong> </strong>plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</p>\n\n\n\n<p><strong>Option 2:</strong> Direct download <a href=\"https://wordpress.org/wordpress-5.9-beta3.zip\">the beta version</a>.</p>\n\n\n\n<p><strong>Option 3:</strong> If you use WP-CLI to upgrade from Beta 1 or Beta 2 to Beta 3 on a case-insensitive filesystem, please use the following command sequence:</p>\n\n\n\n<p>Command One:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-beta2</code></pre>\n\n\n\n<p>Command Two:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-beta3 --force</code></pre>\n\n\n\n<p>The current target for the final release of 5.9 is January 25, 2022, which gets closer every minute. Your help testing this beta is vital: the more testing that happens, the more stable the release, and the better the experience for users and developers—and the entire WordPress community.</p>\n\n\n\n<h2 id=\"some-highlights\"><strong>Some Highlights</strong></h2>\n\n\n\n<p>Since <a href=\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-2/\">Beta 2</a>,<a href=\"https://core.trac.wordpress.org/query?status=closed&amp;changetime=11%2F30%2F2021..12%2F07%2F2021&amp;milestone=5.9&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\"> </a><a href=\"https://core.trac.wordpress.org/query?status=closed&amp;changetime=12%2F08%2F2021..12%2F14%2F2021&amp;milestone=5.9&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">14</a> bugs have been fixed. Here are a few of the changes you will find in Beta 3:</p>\n\n\n\n<ul><li>Editor: Add FSE infrastructure from Gutenberg plugin into Core (<a href=\"https://core.trac.wordpress.org/ticket/54335\">#54335</a>).</li><li>Formatting: Allow PDFs to embedded as objects (<a href=\"https://core.trac.wordpress.org/ticket/54261\">#54261</a>)</li><li>Language switcher on the login screen (<a href=\"https://core.trac.wordpress.org/ticket/43700\">#43700</a>)</li><li>REST API: Add navigation areas REST API endpoint from Gutenberg plugin (<a href=\"https://core.trac.wordpress.org/ticket/54393\">#54393</a>)</li><li>Themes: Live Preview button bug (<a href=\"https://core.trac.wordpress.org/ticket/54578\">#54578</a>)</li></ul>\n\n\n\n<h2 id=\"how-you-can-help\"><strong>How You Can Help</strong></h2>\n\n\n\n<p><strong>Do some testing!</strong></p>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/handbook/testing/beta-testing/\">Testing for bugs</a> is vital for polishing the release in the beta stage and a great way to contribute.&nbsp;</p>\n\n\n\n<p>If you think you’ve found a bug, please post to the<a href=\"https://wordpress.org/support/forum/alphabeta/\"> Alpha/Beta</a> area in the support forums. If you’re comfortable writing a reproducible<a href=\"https://make.wordpress.org/core/reports/\"> bug report</a>, file one on<a href=\"https://core.trac.wordpress.org/newticket\"> WordPress Trac</a>. That’s also where you can find a list of<a href=\"https://core.trac.wordpress.org/tickets/major\"> known bugs</a>.</p>\n\n\n\n<p>For even more ways to test, you can also refer to<a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\"> this official Full Site Editing post from @annezazu</a>.</p>\n\n\n\n<h2 id=\"got-questions-here-are-some-answers\"><strong>Got questions? Here are some answers</strong></h2>\n\n\n\n<p>In the coming weeks, follow the<a href=\"https://make.wordpress.org/core/\"> Make WordPress Core blog</a> for<a href=\"https://make.wordpress.org/core/tag/5-9+dev-notes/\"> 5.9-related developer notes</a> that cover these items in detail. So far, contributors have fixed<a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=5.9&amp;resolution=fixed\"> 316 tickets in WordPress 5.9</a>, including<a href=\"https://core.trac.wordpress.org/query?status=closed&amp;status=reopened&amp;changetime=..12%2F07%2F2021&amp;type=enhancement&amp;type=feature+request&amp;milestone=5.9&amp;group=component&amp;col=id&amp;col=summary&amp;col=type&amp;col=status&amp;col=milestone&amp;col=changetime&amp;col=owner&amp;col=priority&amp;col=keywords&amp;order=changetime\"> 100 new features and enhancements</a>. More bug fixes are on the way with your help through testing.</p>\n\n\n\n<p><em>Props to<a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/chanthaboune/\" target=\"_blank\">&nbsp;</a><a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/psykro/\" target=\"_blank\">@psykro</a>,&nbsp;<a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/estelaris/\" target=\"_blank\">@estelaris</a>,&nbsp;<a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/hellofromtonya/\" target=\"_blank\">@hellofromtonya</a>, <a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/marybaum/\" target=\"_blank\">@marybaum</a>,&nbsp;<a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/webcommsat/\" target=\"_blank\">@webcommsat</a>,&nbsp;<a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/cbringmann/\" target=\"_blank\">@cbringmann</a>,&nbsp;<a href=\'https://profiles.wordpress.org/costdev/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>costdev</a>,</em> <em>and&nbsp;<a rel=\"noreferrer noopener\" href=\"https://profiles.wordpress.org/audrasjb/\" target=\"_blank\">@audrasjb</a></em>&nbsp;<em>for contributions to this post.</em></p>\n\n\n\n<p><em>Filed under #release, #5.9, #beta</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11835\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:75:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.9 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2021/12/wordpress-5-9-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 07 Dec 2021 22:02:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:7:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:6:\"Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:12:\"block editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:6;a:5:{s:4:\"data\";s:11:\"WP releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11794\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"Can you help test the latest software version of WordPress? 5.9 Beta 2 was published on 7 December 2021, help find any bugs. \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Jonathan Bossenger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6225:\"\n<p>WordPress 5.9 Beta 2 is now available for testing!</p>\n\n\n\n<p><strong>This software version is still under development.</strong> Please do not run this software on a production site. Instead, install it on a test site, where you can try out the newest features to get a feel for how they will work on your site.</p>\n\n\n\n<p>You can test the WordPress 5.9 Beta 2 in three ways:</p>\n\n\n\n<p><strong>Option 1:</strong> Install and activate the <strong><a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> </strong>plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</p>\n\n\n\n<p><strong>Option 2:</strong> Direct download the beta version here (<a href=\"https://wordpress.org/wordpress-5.9-beta2.zip\"><strong>zip</strong></a>).</p>\n\n\n\n<p><strong>Option 3:</strong> When using WP-CLI to upgrade from Beta 1 to Beta 2 on a case-insensitive filesystem, please use the following command sequence:<br></p>\n\n\n\n<p>Command One: </p>\n\n\n\n<pre class=\"wp-block-code\"><code>wp core update --version=5.9-beta1 </code></pre>\n\n\n\n<p>Command Two: </p>\n\n\n\n<pre class=\"wp-block-code\"><code> wp core update --version=5.9-beta2 --force </code></pre>\n\n\n\n<p>The current target for the final release of 5.9 is January 25, 2022, which is just seven weeks away. Your help testing this version is a vital part of making this release as good as it can be.</p>\n\n\n\n<h2 id=\"some-highlights\"><strong>Some Highlights</strong></h2>\n\n\n\n<p>Since<a href=\"https://wordpress.org/news/2021/06/wordpress-5-8-beta-1/\"> </a><a href=\"https://wordpress.org/news/2021/11/wordpress-5-9-beta-1/\">Beta 1</a>, <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;changetime=11%2F30%2F2021..12%2F07%2F2021&amp;milestone=5.9&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">24</a> bugs have been fixed. Here are a few of the changes you will find in Beta 2:</p>\n\n\n\n<ul><li>Block Editor: Remove navigation areas (<a href=\"https://core.trac.wordpress.org/ticket/54506\">#54506</a>)</li><li>Block Editor: Navigation block view JavaScript error (<a href=\"https://core.trac.wordpress.org/ticket/54456\">#54456</a>)</li><li>Block Editor: Block template theme error related to child themes (<a href=\"https://core.trac.wordpress.org/ticket/54515\">#54515</a>)</li><li>General: Fixing existing links to Customizer when the Site Editor is enabled (<a href=\"https://core.trac.wordpress.org/ticket/54460\">#54460</a>)</li><li>Media: Media library showing only the selected image (<a href=\"https://core.trac.wordpress.org/ticket/53765\">#53765</a>)</li><li>Media: Fatal error uploading media on PHP8 (<a href=\"https://core.trac.wordpress.org/ticket/54385\">#54385</a>)</li><li>REST API: Add Global Styles REST API endpoints from Gutenberg into Core (<a href=\"https://core.trac.wordpress.org/ticket/54336\">#54336</a>)</li></ul>\n\n\n\n<p>Also, note that some users testing 5.9 Beta 1 faced some fatal errors upon upgrade. In turn, these errors revealed the need for some extra work on the filesystem and upgrader.&nbsp;Those fatal errors are no longer a problem, and the enhancements will be part of version 6.0.</p>\n\n\n\n<h2 id=\"how-you-can-help\"><strong>How You Can Help</strong></h2>\n\n\n\n<p><strong>Do some testing!</strong></p>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/handbook/testing/beta-testing/\">Testing for bugs</a> is vital for polishing the release in the beta stage and a great way to contribute.&nbsp;</p>\n\n\n\n<p>If you think you’ve found a bug, please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta</a> area in the support forums. If you’re comfortable writing a reproducible <a href=\"https://make.wordpress.org/core/reports/\">bug report</a>, file one on <a href=\"https://core.trac.wordpress.org/newticket\">WordPress Trac</a>. That’s also where you can find a list of <a href=\"https://core.trac.wordpress.org/tickets/major\">known bugs</a>.</p>\n\n\n\n<h2 id=\"where-can-i-get-more-information\">Where can I get more information?</h2>\n\n\n\n<p>In the coming weeks, follow the <a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a> for <a href=\"https://make.wordpress.org/core/tag/5-9+dev-notes/\">5.9-related developer notes</a> that cover these items in detail.</p>\n\n\n\n<p>So far, contributors have fixed <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=5.9&amp;resolution=fixed\">305 tickets in WordPress 5.9</a>, including <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;status=reopened&amp;changetime=..12%2F07%2F2021&amp;type=enhancement&amp;type=feature+request&amp;milestone=5.9&amp;group=component&amp;col=id&amp;col=summary&amp;col=type&amp;col=status&amp;col=milestone&amp;col=changetime&amp;col=owner&amp;col=priority&amp;col=keywords&amp;order=changetime\">110 new features and enhancements</a>. More bug fixes are on the way with your help through testing.</p>\n\n\n\n<p><em>Props to</em><a href=\"https://profiles.wordpress.org/chanthaboune/\"><em> </em></a><em><a href=\'https://profiles.wordpress.org/psykro/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>psykro</a>, <a href=\'https://profiles.wordpress.org/estelaris/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>estelaris</a>, <a href=\'https://profiles.wordpress.org/hellofromtonya/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>hellofromtonya</a>, <a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a>, <a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a>, <a href=\'https://profiles.wordpress.org/cbringmann/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>cbringmann</a>, <a href=\'https://profiles.wordpress.org/davidb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>davidb</a>, <a href=\'https://profiles.wordpress.org/audrasjb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>audrasjb</a>, and </em><a href=\'https://profiles.wordpress.org/pbiron/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>pbiron</a><em> for contributions to this post.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11794\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:63:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"The Month in WordPress – November 2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2021/12/month-in-wordpress-november-2021/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Dec 2021 11:30:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:18:\"Month in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:18:\"month in wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:22:\"the month in wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11763\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:334:\"Despite the holiday season being around the corner, the WordPress project didn’t slow down. In a recent episode of WP Briefing, Executive Director Josepha Haden shares the first thing she wants people to notice about WordPress, which is also the heart of this open source project: Now, the first thing I want people to see [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Anjana Vasan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:18182:\"\n<p>Despite the holiday season being around the corner, the WordPress project didn’t slow down. In a <a href=\"https://wordpress.org/news/2021/11/episode-20-wordpressblogging/\">recent episode</a> of <a href=\"https://wordpress.org/news/podcast/\">WP Briefing</a>, Executive Director <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden</a> shares the first thing she wants people to notice about WordPress, which is also the heart of this open source project:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Now, the first thing I want people to see on that site is that WordPress has not only 18 years of learned knowledge that every single new user benefits from, but that it also has thousands of really smart people making sure it works and gets better every day.</p><cite>Josepha Haden, Executive Director of the WordPress project</cite></blockquote>\n\n\n\n<p>As always, contributors across various teams are working hard to ensure the upcoming release of WordPress 5.9 doesn’t disappoint. With State of the Word 2021 coming up soon, there are many exciting things in the works. Read the November 2021 edition of the Month in WordPress to learn more about what’s happening.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"wordpress-5-9-expected-to-release-on-january-25-2022\">WordPress 5.9: Expected to release on January 25, 2022</h2>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img loading=\"lazy\" width=\"1024\" height=\"501\" src=\"https://i2.wp.com/wordpress.org/news/files/2021/12/5.9.png?resize=1024%2C501&#038;ssl=1\" alt=\"\" class=\"wp-image-11764\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2021/12/5.9.png?resize=1024%2C501&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2021/12/5.9.png?resize=300%2C147&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2021/12/5.9.png?resize=768%2C376&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2021/12/5.9.png?resize=1536%2C752&amp;ssl=1 1536w, https://i2.wp.com/wordpress.org/news/files/2021/12/5.9.png?w=1830&amp;ssl=1 1830w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<ul><li>The Core Team announced the <a href=\"https://make.wordpress.org/core/2021/11/22/wordpress-5-9-revised-release-schedule/\">WordPress 5.9 Revised Release Schedule</a>, and the release is now planned for January 25, 2022.</li><li><strong>WordPress 5.9 Beta 1 was recently released and is available for testing.</strong> This version of the WordPress software is under development. Check out the <a href=\"https://wordpress.org/news/2021/11/wordpress-5-9-beta-1/\">release post</a> to learn more about what’s new in version 5.9 and how you can help testing.&nbsp;</li><li>Check out “<a href=\"https://wordpress.org/news/2021/11/a-look-at-wordpress-5-9/\">A Look at WordPress 5.9</a>” for a first peek into the exciting features included in this major release.</li><li><a href=\"https://wordpress.org/news/2021/11/wordpress-5-8-2-security-and-maintenance-release/\">WordPress 5.8.2</a>, a security and maintenance release, was out on November 10, 2021. This release includes two bug fixes and one security fix.</li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong><strong>Are you interested in contributing to WordPress core?</strong> Join the <a href=\"https://wordpress.slack.com/archives/C02RQBWTW\">#core</a> channel, follow the <a href=\"https://make.wordpress.org/core/\">Core Team blog</a>, and check out the <a href=\"https://make.wordpress.org/core/handbook/\">team handbook</a>. Also, don&#8217;t miss the Core Team’s weekly developer chat on Wednesdays at <a href=\"https://www.timeanddate.com/worldclock/fixedtime.html?hour=20&amp;min=00&amp;sec=0\">8 PM</a> UTC.</strong></p></blockquote>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"gutenberg-releases-11-9-and-12-0-are-out\">Gutenberg releases: 11.9 and 12.0 are out</h2>\n\n\n\n<p>Two new Gutenberg versions have been released!</p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2021/11/12/whats-new-in-gutenberg-11-9-0-10-november/\">Version 11.9.0</a> brings new Gutenberg blocks for working with post comments, a fullscreen pattern explorer modal, further iterations on the Navigation block, and many other improvements.</li><li><a href=\"https://make.wordpress.org/core/2021/11/29/whats-new-in-gutenberg-12-0-0-24-november/\">Gutenberg 12.0.0</a>, released on November 24, improves the Block Styles preview and includes featured image block visual enhancements, a site Editor welcome guide, official JSON schema updates, and much more.</li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Want to get involved in developing Gutenberg? </strong>Follow <a href=\"https://make.wordpress.org/core/\">the Core Team blog</a>, contribute to <a href=\"https://github.com/WordPress/gutenberg/\">Gutenberg on GitHub</a>, and join the <a href=\"https://wordpress.slack.com/archives/C02QB2JS7\">#core-editor</a> channel in the <a href=\"https://make.wordpress.org/chat/\">Make WordPress Slack</a>. Follow <a href=\"https://make.wordpress.org/core/tag/gutenberg-new/\">#gutenberg-new</a> for details on the latest updates.</p></blockquote>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"state-of-the-word-2021-join-a-watch-party-in-your-local-community\">State of the Word 2021: Join a watch party in your local community</h2>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img loading=\"lazy\" width=\"1024\" height=\"683\" src=\"https://i2.wp.com/wordpress.org/news/files/2021/12/Web-—-Matt.png?resize=1024%2C683&#038;ssl=1\" alt=\"State of the Word 2021 Announcement, which will take place on December 14 between 5 pm and 7 pm ET (22 - 00 UTC).\" class=\"wp-image-11766\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2021/12/Web-—-Matt.png?resize=1024%2C683&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2021/12/Web-—-Matt.png?resize=300%2C200&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2021/12/Web-—-Matt.png?resize=768%2C512&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2021/12/Web-—-Matt.png?w=1200&amp;ssl=1 1200w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<ul><li><a href=\"https://wordpress.org/news/2021/11/state-of-the-word-2021/\">State of the Word 2021</a>, the annual keynote address delivered by the WordPress project’s co-founder, Matt Mullenweg, will be held on December 14, 2021 <a href=\"https://calendar.google.com/calendar/u/0/r/eventedit?text=State+of+the+Word+2021+livestream&amp;dates=20211214T220000Z/20211215T000000Z&amp;details=State+of+the+Word+is+the+annual+keynote+address+delivered+by+the+WordPress+project%27s+co-founder,+Matt+Mullenweg.%0AJoin+Matt+as+he+provides+a+retrospective+of+2021,+celebrates+the+community%27s+amazing+wins,+discusses+the+latest+trends+he%27s+seeing,+and+explores+the+future+of+open+source.%0AState+of+the+Word+will+be+live+streamed+from+New+York+City,+and+is+free+for+all+to+watch.%0Ahttps://wordpress.org/news/2021/11/state-of-the-word-2021/\">between 5 and 7 pm ET/10 pm – 12 am (December 15) UTC</a>. The event will be <a href=\"https://wordpress.org/news/2021/11/join-us-for-state-of-the-word-2021-in-person-or-online/\">livestreamed from New York City</a>, and include a Question and Answer session.&nbsp;</li><li>Host or join a <a href=\"https://wordpress.org/news/2021/11/watch-state-of-the-word-at-a-watch-party-with-your-wordpress-friends/\">State of the Word watch party</a> to enjoy the event with your WordPress friends. Check <a href=\"https://meetup.com/pro/wordpress\">Meetup</a> to see if a watch party is scheduled to be held in your local community!</li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><a href=\"https://calendar.google.com/calendar/u/0/r/eventedit?text=State+of+the+Word+2021+livestream&amp;dates=20211214T220000Z/20211215T000000Z&amp;details=State+of+the+Word+is+the+annual+keynote+address+delivered+by+the+WordPress+project%27s+co-founder,+Matt+Mullenweg.%0AJoin+Matt+as+he+provides+a+retrospective+of+2021,+celebrates+the+community%27s+amazing+wins,+discusses+the+latest+trends+he%27s+seeing,+and+explores+the+future+of+open+source.%0AState+of+the+Word+will+be+live+streamed+from+New+York+City,+and+is+free+for+all+to+watch.%0Ahttps://wordpress.org/news/2021/11/state-of-the-word-2021/\"><strong>Add the event to your calendar</strong></a><strong> so you don’t miss State of the Word 2021!</strong> Want to ask Matt a question during State of the Word? Please send your questions ahead of time to <a>ask-matt@wordcamp.org</a> or ask them live during the event via YouTube chat.</p></blockquote>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"team-updates-nominations-for-some-team-representatives-are-still-underway\">Team updates: Nominations for some team representatives are still underway</h2>\n\n\n\n<ul><li><a href=\"https://github.com/WordPress/Requests/releases/tag/v2.0.0\">Requests 2.0.0 has been released</a>. This release is fully compatible with PHP 8.0 and 8.1, indicating that a legacy codebase can be modernized, made more stable and secure <em>without</em> breaking backward-compatibility. The Requests project is a dependency of WordPress core, which was adopted into the WordPress organization earlier this year.&nbsp;</li><li>The <a href=\"https://wordpress.org/news/files/2021/11/WordPress.org-2020-Annual-Survey.pdf\">2020 WordPress Annual Survey</a> results are available to be viewed.&nbsp;</li><li>The Core Team added <a href=\"https://make.wordpress.org/core/2021/11/08/new-committers-2021/\">six new committers</a>.</li><li>Last month, the <a href=\"https://make.wordpress.org/marketing/2021/11/22/2022-team-nominations-for-marketing/\">Marketing Team</a> opened its call for team representatives, joining <a href=\"https://make.wordpress.org/core/2021/10/26/nominations-for-core-team-reps-2022/\">Core</a>, <a href=\"https://make.wordpress.org/themes/2021/10/27/nominations-call-for-the-themes-team-representatives/\">Themes</a>, <a href=\"https://make.wordpress.org/accessibility/2021/10/30/call-for-team-rep-nominations-3/\">Accessibility</a>, <a href=\"https://make.wordpress.org/support/2021/10/team-representative-nominations/\">Support</a>, and <a href=\"https://make.wordpress.org/hosting/2021/10/30/nominations-for-hosting-team-reps-2022/\">Hosting</a> from October 2021.</li><li>The <a href=\"https://make.wordpress.org/core/2021/11/24/core-team-reps-for-2020-and-beyond-2/\">Core Team announced its new Team Rep for 2022</a> (and beyond).</li><li>The <a href=\"https://make.wordpress.org/design/2021/10/08/moving-to-bi-weekly-meetings/\">Design Team</a> and the <a href=\"https://make.wordpress.org/accessibility/2021/11/19/accessibility-team-meeting-notes-november-19-2021/\">Accessibility Team’s</a> meetings will be held bi-weekly moving forward.</li><li>The Marketing Team published the latest edition of <a href=\"https://wordpress.org/news/2021/11/people-of-wordpress-devin-maeztri/\">People of WordPress, featuring Devin Maeztri</a> from Indonesia.</li><li>There’s an open call for suggestions for <a href=\"https://make.wordpress.org/community/2021/11/05/2022-goals-for-the-community-team-suggestions-invited/\">Global Community Team</a>, <a href=\"https://make.wordpress.org/training/2021/11/16/team-goal-setting-2022/\">Training Team</a>, and <a href=\"https://make.wordpress.org/polyglots/2021/11/11/2022-polyglots-planning/\">Polyglots</a> goals for 2022. Please drop your ideas by December 6, 2021.</li><li>The Accessibility Team has opened 1-2 <a href=\"https://wordpress.slack.com/archives/C037W5S7X/p1637775719355600\">volunteer positions</a> for the <a href=\"https://make.wordpress.org/community/tag/diverse-speaker-support/\">#diverse-speaker-support</a> channel.</li><li>The <a href=\"https://make.wordpress.org/polyglots/2021/11/22/polyglots-monthly-newsletter-november-2021/\">November 2021 edition</a> of the Polyglots monthly newsletter is out.&nbsp;</li><li>The Marketing Team welcomes any help to <a href=\"https://make.wordpress.org/marketing/2021/11/17/help-promote-wordpress-meetups-each-week/\">promote WordPress Meetups</a> on a weekly basis and thus keep the community connected.</li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>We want to hear from you!</strong> Suggest your 2022 goals for the <a href=\"https://make.wordpress.org/community/2021/11/05/2022-goals-for-the-community-team-suggestions-invited/\">Global Community Team</a> by December 6, 2021.</p></blockquote>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"feedback-testing-requests-test-wordpress-5-9-beta-1-take-the-2021-annual-wordpress-survey-to-share-your-experience\">Feedback/Testing requests: Test WordPress 5.9 Beta 1; Take the 2021 Annual WordPress Survey to share your experience</h2>\n\n\n\n<ul><li>WordPress 5.9 Beta 1 is now available for testing and we’d like to hear from you! Testing is vital to ensure the release is as good as it can be—it’s also a great way to contribute. Read the comprehensive guide, “<a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\">Help test WordPress 5.9 Features</a>,” to learn how to test WordPress 5.9 Beta 1 and report any bugs.</li><li>There’s an open call for testing for <a href=\"https://make.wordpress.org/mobile/2021/11/16/call-for-testing-wordpress-for-ios-18-7/\">WordPress iOS 18.7</a> and <a href=\"https://make.wordpress.org/mobile/2021/11/16/call-for-testing-wordpress-for-android-18-7/\">Android 18.7</a>.</li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>The </strong><a href=\"https://wordpress.org/news/2021/11/take-the-2021-wordpress-annual-survey-and-view-the-2020-results/\"><strong>2021 WordPress Annual Survey</strong></a><strong> is out! </strong>Please respond to the survey, so <em>your</em> WordPress experience is reflected in the results.</p></blockquote>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"keep-an-eye-out-for-wordcamp-taiwan-and-sevilla-along-with-several-wordpress-workshops-in-december-2021\">Keep an eye out for WordCamp Taiwan and Sevilla, along with several WordPress workshops in December 2021</h2>\n\n\n\n<ul><li>Several <a href=\"https://www.meetup.com/wordpress-social-learning/\">WordPress Social Learning Meetups</a> were held in November by the Training Team, and there will be more in December 2021.</li><li><a href=\"https://make.wordpress.org/community/tag/tuesdaytrainings/\">Tuesday Training</a> sessions are paused until 2022.</li><li><a href=\"https://saopaulo.wordcamp.org/2021/\">WordCamp São Paulo</a> was held online on November 27, 2021.</li><li>Get excited for <a href=\"https://sevilla.wordcamp.org/2021/\">WordCamp Sevilla 2021</a>, coming up on December 11-12! Sevilla is the first in-person WordCamp happening in over 18 months, since WordCamps moved online in March 2020 due to COVID-19.</li><li>Don’t miss the following upcoming WordCamps: <a href=\"https://taiwan.wordcamp.org/2021/\">WordCamp Taiwan 2021</a>, <a href=\"https://birmingham.wordcamp.org/2022/\">WordCamp Birmingham 2022</a>, and <a href=\"https://europe.wordcamp.org/2022/\">WordCamp Europe 2022</a>!</li><li>Check out the latest episodes of WordPress Briefing with Josepha Haden on<ul><li>“<a href=\"https://wordpress.org/news/2021/11/episode-21-all-things-block-themes/\">All Things Block Themes!</a>”</li><li>“<a href=\"https://wordpress.org/news/2021/11/episode-20-wordpressblogging/\">WordPress=Blogging+</a>”</li><li>“<a href=\"https://wordpress.org/news/2021/11/episode-19-the-people-of-wordpress/\">The People of WordPress</a>”</li></ul></li></ul>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center\"><p><strong>Give back to open source. </strong>Please donate to<a href=\"https://wordpressfoundation.org/news/2021/give-back-to-open-source-this-giving-tuesday/\"> the WordPress Foundation</a>’s mission this holiday season.</p></blockquote>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p><strong><em>Have a story that we could include in the next ‘Month in WordPress’ post? Let us know&nbsp; by filling out </em></strong><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><strong><em>this form</em></strong></a><strong><em>.&nbsp;</em></strong></p>\n\n\n\n<p><em>The following folks contributed to November 2021’s Month in WordPress: <a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a>, <a href=\'https://profiles.wordpress.org/harishanker/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>harishanker</a>, <a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a>, <a href=\'https://profiles.wordpress.org/callye/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>callye</a>, <a href=\'https://profiles.wordpress.org/jrf/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>jrf</a>, <a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a>, and <a href=\'https://profiles.wordpress.org/nalininonstopnewsuk/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>nalininonstopnewsuk</a></em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11763\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:60:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 5.9 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2021/11/wordpress-5-9-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 30 Nov 2021 23:35:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11584\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:307:\"WordPress 5.9 Beta 1 is now available for testing! This version of the WordPress software is under development. You don’t want to run this version on a production site. Instead, it is recommended that you run this on a test site. This will allow you to test out the new version. You can test the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:10992:\"\n<p>WordPress 5.9 Beta 1 is now available for testing!</p>\n\n\n\n<p><strong>This version of the WordPress software is under development</strong>. You don’t want to run this version on a production site. Instead, it is recommended that you run this on a test site. This will allow you to test out the new version.</p>\n\n\n\n<p>You can test the WordPress 5.9 Beta 1 in three ways:</p>\n\n\n\n<ul><li>Option 1: Install and activate the<a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\"> WordPress Beta Tester</a> plugin (select the “Bleeding edge” channel and “Beta/RC Only” stream).</li><li>Option 2: Direct download the <a href=\"https://wordpress.org/wordpress-5.9-beta1.zip\">beta version here (zip)</a>.</li><li>Option 3: Use WP-CLI to test: <code>wp core update --version=5.9-beta1</code>. <strong><em>Do not use this option if your filesystem is case-insensitive.</em></strong></li></ul>\n\n\n\n<p>The current target for the final release is January 25, 2022, which is just eight weeks away. Your help testing this version is vital to make sure the release is as good as it can be.</p>\n\n\n\n<p>Check the <a href=\"https://make.wordpress.org/core/\">Make WordPress Core blog</a> for <a href=\"https://make.wordpress.org/core/tag/5-9+dev-notes/\">5.9-related developer notes</a> in the coming weeks which will break down all upcoming changes in greater detail.</p>\n\n\n\n<h2 id=\"how-you-can-help-testing\"><strong>How You Can Help – Testing!</strong></h2>\n\n\n\n<p>Testing for bugs is a critical part of polishing the release in the beta stage. It is also a great way to contribute. If you’ve never tested a beta release before, <a href=\"https://make.wordpress.org/test/2021/11/30/help-test-wordpress-5-9-features/\">this detailed guide will help</a> walk you through what and how to test.</p>\n\n\n\n<p>If you think you’ve found a bug, please report it to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area</a> in the support forums. If you’re comfortable writing a reproducible bug report, <a href=\"https://core.trac.wordpress.org/newticket\">file one on WordPress Trac</a>. That’s also where you can find a list of <a href=\"https://core.trac.wordpress.org/tickets/major\">known bugs</a>.</p>\n\n\n\n<p>To see every feature in the Gutenberg releases since WordPress 5.8, check out the What’s New In Gutenberg posts for <a href=\"https://make.wordpress.org/core/2021/06/10/whats-new-in-gutenberg-10-8-9-june/\">10.8</a>, <a href=\"https://make.wordpress.org/core/2021/06/24/whats-new-in-gutenberg-10-9-23-june/\">10.9</a>, <a href=\"https://make.wordpress.org/core/2021/07/09/whats-new-in-gutenberg-11-0-0-9-july/\">11.0</a>, <a href=\"https://make.wordpress.org/core/2021/07/21/whats-new-in-gutenberg-11-1-0-21-july/\">11.1</a>, <a href=\"https://make.wordpress.org/core/2021/08/05/whats-new-in-gutenberg-11-2-0-4-august/\">11.2</a>, <a href=\"https://make.wordpress.org/core/2021/08/18/whats-new-in-gutenberg-11-3-18-august/\">11.3</a>, <a href=\"https://make.wordpress.org/core/2021/09/01/whats-new-in-gutenberg-11-4-1-september/\">11.4</a>, <a href=\"https://make.wordpress.org/core/2021/09/17/whats-new-in-gutenberg-11-5-16-september/\">11.5</a>, <a href=\"https://make.wordpress.org/core/2021/10/01/whats-new-in-gutenberg-11-6-29-september/\">11.6</a>, <a href=\"https://make.wordpress.org/core/2021/10/14/whats-new-in-gutenberg-11-7-october-13th/\">11.7</a>, <a href=\"https://make.wordpress.org/core/2021/10/28/whats-new-in-gutenberg-11-8-0-27-october/\">11.8</a>, and <a href=\"https://make.wordpress.org/core/2021/11/12/whats-new-in-gutenberg-11-9-0-10-november/\">11.9</a>.&nbsp;</p>\n\n\n\n<p>Beyond the noted changes, which include 580 enhancements and nearly 450 bug fixes, contributors have fixed <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;milestone=5.9&amp;group=component&amp;max=500&amp;col=id&amp;col=summary&amp;col=owner&amp;col=type&amp;col=priority&amp;col=component&amp;col=version&amp;order=priority\">297 tickets for WordPress 5.9</a>, including <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;status=reopened&amp;type=enhancement&amp;type=feature+request&amp;milestone=5.9&amp;col=id&amp;col=summary&amp;col=type&amp;col=status&amp;col=milestone&amp;col=owner&amp;col=priority&amp;col=changetime&amp;col=keywords&amp;order=changetime\">110 new features and enhancements</a>. More fixes are on the way.</p>\n\n\n\n<p>Happy testing!</p>\n\n\n\n<p><em>Want to know what’s new in version 5.9? Read on for some highlights.</em></p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"full-site-editing\"><strong><strong>Full Site Editing</strong></strong></h2>\n\n\n\n<h3 id=\"styles-interface\">The <strong>Styles Interface</strong></h3>\n\n\n\n<p>Combine all the features that went live in 5.8 with those making their entrance in 5.9, and you get <strong>Full Site Editing.</strong></p>\n\n\n\n<p>Formerly known as Global Styles, the Styles Interface lets you interact directly with your blocks and elements right in the WordPress Admin. From typography to color palettes, this cohesive design interface means a design change—even a dramatic one—can happen without a theme switch. <strong>No code needed.</strong></p>\n\n\n\n<h3 id=\"theme-json\"><strong>Theme.json</strong></h3>\n\n\n\n<p>Introduced in WordPress 5.8, theme.json has been improved to enable features and default styles for your site and its blocks. With 5.9, theme.json can support child themes and the duotone treatment. Coordinate layers of style with theme.json, taking the weight off of your theme’s required CSS.</p>\n\n\n\n<p>Other features supported by theme.json include: </p>\n\n\n\n<ul><li><strong>Border:</strong> color, style, and width augment the border-radius property that landed in 5.8.</li><li><strong>Flex layouts:</strong> Block Gap support, courtesy of spacing.blockGap.</li><li><strong>Typography:</strong> font families, font style, font weight, text decoration, and text transform.</li><li><strong>Images</strong>: Duotones.</li></ul>\n\n\n\n<h3 id=\"a-new-navigation-block\"><strong>A New Navigation Block</strong></h3>\n\n\n\n<p>Welcome to the most intuitive way to build navigation: the Navigation Block.&nbsp;</p>\n\n\n\n<p>Here are the features that need testing the most:</p>\n\n\n\n<ul><li>Responsive menu options you can turn off, have always on, or opt to use only for small screens.</li><li>Built-in keyboard accessibility.&nbsp; For accessibility, for speed, or both.</li><li>Add extra blocks like Search and Site Icon blocks (and customize them to your liking).</li><li>Submenu items with styling options.</li><li>Horizontal or vertical alignment.</li><li>Reusable navigation? Even across themes? Yes. Because the Navigation Block you build gets saved as a custom post type.</li></ul>\n\n\n\n<h3 id=\"a-better-gallery-block\"><strong>A Better Gallery Block</strong></h3>\n\n\n\n<p>What if you could treat single images in your Gallery Block the same way you treat the Image Block? <strong>Now you can.</strong></p>\n\n\n\n<p> Make every image in your gallery different from the next, with inline cropping or a duotone and change layouts with the ease of drag and drop. With the improved gallery block, every image is its own Image block.</p>\n\n\n\n<p><strong>One thing to note: </strong>Have you built a plugin or theme on the Gallery Block functionality?<a href=\"https://make.wordpress.org/core/2021/08/20/gallery-block-refactor-dev-note/\"> Be sure to review this Dev Note, which details what you need to do for compatibility</a>.</p>\n\n\n\n<h3 id=\"focused-template-part-mode\"><strong>Focused Template Part Mode</strong></h3>\n\n\n\n<p>Building template parts can take a level of focus all its own because you’re making decisions for the entire site. So WordPress 5.9 adds a focus mode that shows you only the part you’re working on right now (and you can get back to the regular view with a keystroke).&nbsp;</p>\n\n\n\n<h3 id=\"block-pattern-directory\"><strong>Block Pattern Directory</strong></h3>\n\n\n\n<p>The <a href=\"https://wordpress.org/patterns/\">Pattern Directory</a> offers a range of prebuilt block patterns, from a couple of blocks that show an image and text, to an entire page layout with columns and sections. Since the 5.8 release, the directory has become a hub for exploratory UI and patterns, taking submissions and offering them to the community. So now, your creation can help other people build out their perfect site.</p>\n\n\n\n<h2 id=\"twenty-twenty-two-default-theme\"><strong>Twenty Twenty-Two Default Theme</strong></h2>\n\n\n\n<p><strong>A whole new way of building WordPress themes.</strong></p>\n\n\n\n<p>WordPress 5.9 introduces features that make Full Site Editing possible, including <strong>the first default block theme</strong>.</p>\n\n\n\n<p>Using minimal CSS, theme styles reside in theme.json so that you can configure them in the Styles interface of the WordPress Admin. Make this theme take on its own personality site-wide, with a wide array of color schemes, type combinations, page templates, premade components (forms), and image treatments to choose from.</p>\n\n\n\n<h2 id=\"more-improvements-and-updates\"><strong>More Improvements and Updates</strong></h2>\n\n\n\n<ul><li>Do you love to blog? New tweaks to the publishing flow let you add new posts just seconds after hitting Publish on your latest post.</li><li>List View lets you drag and drop content as easily as you could always cruise through it – and collapse entire sections – so you can concentrate on a task or get the bigger picture.</li><li><a href=\"https://github.com/WordPress/gutenberg/pull/33955\">The Buttons and Social icons blocks now absorb</a> and display their parent block’s toolbar controls.&nbsp;&nbsp;</li><li><a href=\"https://core.trac.wordpress.org/ticket/43700\">Choose your language</a> on the login screen.</li><li>More <a href=\"https://github.com/WordPress/gutenberg/pull/33868\">performance improvements</a> (i.e., speed).</li></ul>\n\n\n\n<p><em>Props to <a href=\'https://profiles.wordpress.org/chanthaboune/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>chanthaboune</a>, <a href=\'https://profiles.wordpress.org/priethor/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>priethor</a>, <a href=\'https://profiles.wordpress.org/psykro/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>psykro</a>, <a href=\'https://profiles.wordpress.org/annezazu/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>annezazu</a>, <a href=\'https://profiles.wordpress.org/webcommsat/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>webcommsat</a>, <a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a>, <a href=\'https://profiles.wordpress.org/hellofromtonya/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>hellofromtonya</a>, <a href=\'https://profiles.wordpress.org/davidbaumwald/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>davidbaumwald</a>, and <a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a> for their research and copy.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11584\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"People of WordPress: Devin Maeztri\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2021/11/people-of-wordpress-devin-maeztri/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 30 Nov 2021 22:21:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:6:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:10:\"Interviews\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:17:\"Contributor Story\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:9:\"Indonesia\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:4;a:5:{s:4:\"data\";s:19:\"People of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:5;a:5:{s:4:\"data\";s:20:\"Polyglot Contributor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11678\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"Devin Maeztri, a campaigner from Indonesia talks about the difference WordPress makes in her life and her work.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"webcommsat AbhaNonStopNewsUK\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:17025:\"\n<p>In this series, we share some of the inspiring stories of how WordPress and its global network of contributors can change people&#8217;s lives for the better. This month we feature a translator and campaigner who uses WordPress to highlight good causes and helps people in her area benefit from the open source platform.</p>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img loading=\"lazy\" width=\"768\" height=\"1024\" src=\"https://i2.wp.com/wordpress.org/news/files/2021/11/devin-with-her-cat.jpg?resize=768%2C1024&#038;ssl=1\" alt=\"Devin pictured with one of her cats\" class=\"wp-image-11690\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2021/11/devin-with-her-cat-scaled.jpg?resize=768%2C1024&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2021/11/devin-with-her-cat-scaled.jpg?resize=225%2C300&amp;ssl=1 225w, https://i1.wp.com/wordpress.org/news/files/2021/11/devin-with-her-cat-scaled.jpg?resize=1152%2C1536&amp;ssl=1 1152w, https://i1.wp.com/wordpress.org/news/files/2021/11/devin-with-her-cat-scaled.jpg?resize=1536%2C2048&amp;ssl=1 1536w, https://i1.wp.com/wordpress.org/news/files/2021/11/devin-with-her-cat-scaled.jpg?w=1920&amp;ssl=1 1920w\" sizes=\"(max-width: 768px) 100vw, 768px\" data-recalc-dims=\"1\" /></figure></div>\n\n\n\n<p>Going to a WordCamp can be a life-changing experience, as Devin Maeztri discovered. Every event she attends is a further step on a journey of discovering the WordPress community and its many opportunities.</p>\n\n\n\n<figure class=\"wp-block-pullquote\"><blockquote><p>“It is not that hard to fall for WordPress if you have a chance to experience WordPress. For me, it took a WordCamp.”</p><cite>Devin Maeztri</cite></blockquote></figure>\n\n\n\n<p>Devin&#8217;s first experience with camps came when she volunteered impromptu at an Indonesian event, WordCamp Denpasar, Bali in 2016.&nbsp;</p>\n\n\n\n<p>Here, she made a profound discovery: “WordCamps can bring people who will give back to the community, even if they don’t get anything from WordPress directly.”</p>\n\n\n\n<p>With every WordCamp after that first experience, she became more interested in WordPress and the community.&nbsp;</p>\n\n\n\n<p>Over time, Devin found she wanted to be part of WordPress events more often. She became a regular at Meetups in Ubud and Jakarta, joining as a co-organizer at WordCamp Jakarta in 2017 and 2019. Later, she took on the role of co-organizer for Meetups in Jakarta and Ubud.&nbsp;</p>\n\n\n\n<p>Smitten by what WordCamps can offer and how they can bring people together across national borders, she joined the organizing team for WordCamp Asia 2020. Sadly, this event was to become the first major WordPress event to be cancelled in the COVID-19 pandemic.&nbsp;</p>\n\n\n\n<p>Naturally, Devin hopes WordCamp Asia will happen someday very soon. Beyond the expected WordPress learning and sharing that event will promote, she believes its very scale will showcase how WordCamps add international tourism and cultural understanding everywhere they take place.</p>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full\"><img loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://i1.wp.com/wordpress.org/news/files/2021/11/wcasia_2020_organizers_in_wceu_2019.jpeg?resize=1024%2C1024&#038;ssl=1\" alt=\"Devin pictured with other WordCamp Asia organizers who attended WordCamp Europe in 2019\" class=\"wp-image-11692\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2021/11/wcasia_2020_organizers_in_wceu_2019.jpeg?w=1024&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2021/11/wcasia_2020_organizers_in_wceu_2019.jpeg?resize=300%2C300&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2021/11/wcasia_2020_organizers_in_wceu_2019.jpeg?resize=150%2C150&amp;ssl=1 150w, https://i1.wp.com/wordpress.org/news/files/2021/11/wcasia_2020_organizers_in_wceu_2019.jpeg?resize=768%2C768&amp;ssl=1 768w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /><figcaption>WordCamp Asia 2020 Organizers at WordCamp Europe 2019. Devin is pictured in the front row, second from left. Photo Credit: Abha Thakor</figcaption></figure></div>\n\n\n\n<h2 id=\"showing-how-wordpress-can-be-used-locally\">Showing how WordPress can be used locally</h2>\n\n\n\n<p>After experiencing several events, Devin had questions: “At WordCamps and Meetups, you hear stories about how WordPress powers the web. How it changes the lives of so many people, how it helps dreams come true. It made me think, considering WordPress is that powerful, why are there not even more people in Indonesia using websites, and more using WordPress? Why aren’t more talented Indonesian WordPress users, developers, designers, and business owners taking part in WordPress.org projects? Language, for me, was the main answer.”</p>\n\n\n\n<p>The solution Devin felt was to make WordPress available in the main local language. She said: “I believe, the more content translated into Indonesian, the more Indonesian WordPress users see WordPress as more than just a blogging platform or a content management system. They will realize it’s a huge open source community that works together to make the web a better place. The more plugins and themes translated, the easier the work of the developer and designer will be. The more people see how WordPress can enhance their life, the better the ecosystem for business owners becomes.”</p>\n\n\n\n<h3 id=\"encouraging-others-to-translate-wordpress\">Encouraging others to translate WordPress</h3>\n\n\n\n<p>After talking with others about how WordPress could be even more useful in Indonesia, Devin felt she had to make a personal commitment to reviving the polyglot project in Indonesia. With another volunteer contributor and through promotion, the local polyglot team got bigger and the interest in translation grew. She also took on the responsibility of a General Translation Editor for the language.</p>\n\n\n\n<figure class=\"wp-block-image size-large\"><img loading=\"lazy\" width=\"1024\" height=\"515\" src=\"https://i1.wp.com/wordpress.org/news/files/2021/11/featured-img-used-for-devin-pow2.jpg?resize=1024%2C515&#038;ssl=1\" alt=\"Polyglot nominatee - Devin Maeztri\" class=\"wp-image-11706\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2021/11/featured-img-used-for-devin-pow2.jpg?resize=1024%2C515&amp;ssl=1 1024w, https://i1.wp.com/wordpress.org/news/files/2021/11/featured-img-used-for-devin-pow2.jpg?resize=300%2C151&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2021/11/featured-img-used-for-devin-pow2.jpg?resize=768%2C386&amp;ssl=1 768w, https://i1.wp.com/wordpress.org/news/files/2021/11/featured-img-used-for-devin-pow2.jpg?w=1247&amp;ssl=1 1247w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /></figure>\n\n\n\n<p>Through the efforts of Devin and the other translation editors, Indonesia took part in <a href=\"https://wptranslationday.org/\">WordPress Translation Day</a> in 2020, and in 2021 held sprints and learning sessions spanning the whole 30 days of the event. </p>\n\n\n\n<p>Her enthusiasm and dedication to helping others translate WordPress locally and promoting the global community were recognized in the Polyglot Appreciation Nominations for 2021. </p>\n\n\n\n<h2 id=\"helping-to-give-access-to-more-diverse-audiences\">Helping to give access to more diverse audiences</h2>\n\n\n\n<p>Through her involvement in translation, Devin noticed there were not many women involved in the WordPress community in Indonesia. Often, she found herself the only woman at an event.</p>\n\n\n\n<p>So, along with a couple of community members, she started Perempuan WordPress, a local initiative. This group is open for everyone to join, but prioritizes women as event speakers.</p>\n\n\n\n<p>Devin has gone on to support the work of the Diversity Speaker Training group in the Community Team, translating materials and promoting initiatives in Indonesia.&nbsp;She is keen to encourage others to get involved with this initiative which helps increase the diversity of presenters at Meetups and WordCamps. </p>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full\"><img loading=\"lazy\" width=\"600\" height=\"534\" src=\"https://i1.wp.com/wordpress.org/news/files/2021/11/devin-at-wc-jakarta2019.png?resize=600%2C534&#038;ssl=1\" alt=\"\" class=\"wp-image-11689\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2021/11/devin-at-wc-jakarta2019.png?w=600&amp;ssl=1 600w, https://i1.wp.com/wordpress.org/news/files/2021/11/devin-at-wc-jakarta2019.png?resize=300%2C267&amp;ssl=1 300w\" sizes=\"(max-width: 600px) 100vw, 600px\" data-recalc-dims=\"1\" /><figcaption><em>Organizing at WordCamp Jakarta 2019</em></figcaption></figure></div>\n\n\n\n<p>In her professional roles, Devin is an advocate for WordPress as a tool for people with a wide variety of skill sets. She does not code, but uses the platform extensively for her projects. In 2014, she signed up for a free account on WordPress.com to keep and share notes about what she saw or was thinking about as she commuted on public transport to work. This site did not turn into a blog, but instead introduced her to other opportunities and the vast capabilities of the platform.</p>\n\n\n\n<h2 id=\"wordpress-can-support-your-skills-and-passions\">WordPress can support your skills and passions</h2>\n\n\n\n<p>With a background in environmental activism, Devin has worked for international development organizations on everything from policymaking to campaigning.&nbsp;</p>\n\n\n\n<p>Behind the desk, she worked with policymakers and organized conferences and meetings. That meant doing a lot of writing and translating and working with people on the ground who were impacted by the policies. “My work on the ground usually involved researching, movement building and community empowerment,” she noted.</p>\n\n\n\n<p>Her work with events inspired Devin to get involved in WordCamps and Meetups and share her energy for making things happen. As in her professional work, she felt WordPress was an opportunity to work and share with people about something that can make a positive impact on someone else’s life.</p>\n\n\n\n<p>“For me, everything comes from the heart. I do things that I feel so strongly about. Things that call me, and things that I am good at but still giving me room to learn and become better at. WordPress can be the perfect place for this.”</p>\n\n\n\n<p>While she was between jobs, Devin was encouraged to volunteer at WordCamp Denpasar 2016. With some help, she created an online CV. She also learned to manage a WordPress site, navigate the wp-admin, and make the content appeal to potential employers.&nbsp;</p>\n\n\n\n<p>She eventually got a job as a campaigner to build a movement online and offline. The brainchild of many university friends in America, who used digital campaigns to go global, the campaign used WordPress.&nbsp;</p>\n\n\n\n<p>Devin worked alongside a digital campaigner and helped shape the content, the call to action, and the user experience. She also had to use the wp-admin to make some amendments. As a global movement, it developed its resources in English, so she also reviewed the work of the translators she worked with.</p>\n\n\n\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-large\"><img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"https://i2.wp.com/wordpress.org/news/files/2021/11/cat-watching-translation.jpg?resize=1024%2C768&#038;ssl=1\" alt=\"One of Devin\'s cats watches the WPTranslationDay 2021 livestreamed events.\" class=\"wp-image-11688\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2021/11/cat-watching-translation-scaled.jpg?resize=1024%2C768&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2021/11/cat-watching-translation-scaled.jpg?resize=300%2C225&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2021/11/cat-watching-translation-scaled.jpg?resize=768%2C576&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2021/11/cat-watching-translation-scaled.jpg?resize=1536%2C1152&amp;ssl=1 1536w, https://i2.wp.com/wordpress.org/news/files/2021/11/cat-watching-translation-scaled.jpg?resize=2048%2C1536&amp;ssl=1 2048w\" sizes=\"(max-width: 1000px) 100vw, 1000px\" data-recalc-dims=\"1\" /><figcaption>Devin&#8217;s cat became a regular on social media posts about #WPTranslationDay 2021</figcaption></figure></div>\n\n\n\n<p>She left her job as a campaigner at the end of 2018 to concentrate on freelancing – and to spend more of her free time contributing to the WordPress community. She also took up the initiative to help street cats in Jakarta.&nbsp;</p>\n\n\n\n<p>Devin said: “So, I am busy helping these cats but also learning how to fundraise using a website. I’m learning to use online forms, set up a payment service provider, work on SEO, and do other new things I need to learn to grow my initiative. I do have the privilege to learn directly from a personal guru. The same person who convinced me to volunteer at WordCamp Denpasar, and who I married in 2018.”</p>\n\n\n\n<h2 id=\"wordpress-gives-everyone-a-chance-to-learn\">WordPress gives everyone a chance to learn</h2>\n\n\n\n<p>Devin was so enthused by being a contributor for WordPress, she took part in the video shorts following the Translation Day events.</p>\n\n\n\n<figure class=\"wp-block-embed is-type-video is-provider-youtube wp-block-embed-youtube wp-embed-aspect-16-9 wp-has-aspect-ratio\"><div class=\"wp-block-embed__wrapper\">\n<iframe loading=\"lazy\" class=\"youtube-player\" width=\"600\" height=\"338\" src=\"https://www.youtube.com/embed/VsiQzdmAz8g?version=3&#038;rel=1&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;fs=1&#038;hl=en-US&#038;autohide=2&#038;wmode=transparent\" allowfullscreen=\"true\" style=\"border:0;\" sandbox=\"allow-scripts allow-same-origin allow-popups allow-presentation\"></iframe>\n</div><figcaption>Devin talks about translating in this short <a rel=\"noreferrer noopener\" href=\"https://www.youtube.com/watch?v=VsiQzdmAz8g\" target=\"_blank\">video</a> (opens in a new tab on YouTube)</figcaption></figure>\n\n\n\n<p>She is also active in other Contributor Teams and decided to become a Community Team Deputy to support meetups in new cities across Indonesia and perhaps future WordCamps.&nbsp;</p>\n\n\n\n<p>She said: “One of the things that I like about WordPress is that it is very welcoming and open to people like me, who don’t code at all. At the same time, it shows me a different way of looking at the world.”</p>\n\n\n\n<p>Devin believes in the power of WordPress to give ‘everyone a chance to learn new things’ and allows her to contribute and share her knowledge and experience. “By contributing, I hope to make a difference in someone’s life. I hope they feel the benefit of using WordPress and want to give back to create a healthier WordPress community.”</p>\n\n\n\n<h2 id=\"share-the-stories\">Share the stories</h2>\n\n\n\n<p>Help share these stories of open source contributors and continue to grow the community. Meet more WordPressers in the <a href=\"https://wordpress.org/news/category/newsletter/interviews/\">People of WordPress series.</a> #ContributorStory.</p>\n\n\n\n<h2 id=\"contributors\">Contributors</h2>\n\n\n\n<p>Thank you to Abha Thakor (<a href=\"https://profiles.wordpress.org/webcommsat/\">@</a><a href=\"https://profiles.wordpress.org/webcommsat/\" data-type=\"URL\" data-id=\"https://profiles.wordpress.org/webcommsat/\">webcommsat</a>) and Mary Baum (<a href=\'https://profiles.wordpress.org/marybaum/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>marybaum</a>) for the interviews and writing this feature, and to Devin Maeztri (<a href=\"https://profiles.wordpress.org/devinmaeztri/\">@devinmaeztri</a>) for sharing her story. Thanks to Meher Bala (<a href=\"https://profiles.wordpress.org/meher/\">@meher</a>) for work on the images, and to Chloé Bringmann (<a href=\"https://profiles.wordpress.org/cbringmann/\">@cbringmann</a>) and Collieth Clarke (<a href=\'https://profiles.wordpress.org/callye/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>callye</a>) for proofing.</p>\n\n\n\n<p>Thanks to Josepha Haden Chomphosy&nbsp;(@<a href=\"https://profiles.wordpress.org/chanthaboune/\">chanthaboune</a>) and Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\">@topher1kenobe</a>) for their support for the series.</p>\n\n\n\n<div class=\"wp-block-media-text is-stacked-on-mobile is-vertically-aligned-center\" style=\"grid-template-columns:29% auto\"><figure class=\"wp-block-media-text__media\"><img loading=\"lazy\" width=\"180\" height=\"135\" src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?resize=180%2C135&#038;ssl=1\" alt=\"HeroPress logo\" class=\"wp-image-8409 size-full\" data-recalc-dims=\"1\" /></figure><div class=\"wp-block-media-text__content\">\n<p class=\"has-small-font-size\"><em>This People of WordPress feature is inspired by an essay originally published on </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>, a community initiative created by Topher DeRosia. It highlights people in the WordPress community who have overcome barriers and whose stories might otherwise go unheard. </em>#HeroPress </p>\n</div></div>\n\n\n\n<p></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11678\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:58:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WP Briefing: Episode 21: All Things Block Themes!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"https://wordpress.org/news/2021/11/episode-21-all-things-block-themes/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 29 Nov 2021 12:07:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=11636\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:436:\"In episode 21 of the WordPress Briefing, Executive Director, Josepha Haden Chomphosy, talks all things block themes with developers and theme specialists Maggie Cabrera and Jeff Ong. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits Editor:&#160;Dustin Hartzler Logo:&#160;Beatriz Fialho Production:&#160;Chloé Bringmann Song: Fearless [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2021/11/WP-Briefing-021.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:26887:\"\n<p>In episode 21 of the WordPress Briefing, Executive Director, Josepha Haden Chomphosy, talks all things block themes with developers and theme specialists Maggie Cabrera and Jeff Ong.</p>\n\n\n\n<p><em><strong>Have a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a></li><li>Song: Fearless First by Kevin MacLeod</li></ul>\n\n\n\n<h2 id=\"references\">References </h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2021/11/17/wordpress-5-9-beta-1-delayed/\">5.9 Beta 1 Delay Announcement </a></li><li><a href=\"https://make.wordpress.org/core/2021/11/22/wordpress-5-9-revised-release-schedule/\">5.9 Revised Release Schedule</a></li><li><a href=\"https://sevilla.wordcamp.org/2021/\">WordCamp Sevilla 2021</a></li><li>Charitable Giving: <ul><li><a href=\"https://wordpressfoundation.org/donate/\">WordPress Foundation</a></li><li><a href=\"https://donate.bigorangeheart.org/\">Big Orange Heart</a></li><li><a href=\"https://heropressnetwork.com/support/\">HeroPress</a> <em>(Update: This organization is not a non-profit.)</em></li></ul></li></ul>\n\n\n\n<h2 id=\"transcript\">Transcript</h2>\n\n\n\n<span id=\"more-11636\"></span>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:11</p>\n\n\n\n<p>Hello, everyone, and welcome to the WordPress Briefing, the podcast where you can catch quick explanations of the ideas behind the WordPress open source project, some insight into the community that supports it, and get a small list of big things coming up in the next two weeks. I&#8217;m your host, Josepha Haden Chomphosy. See, here we go!</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:40</p>\n\n\n\n<p>Well, today, folks, in our podcast, I am joined by a couple of special guests. I know it&#8217;s been a bit since I&#8217;ve had a guest, so I&#8217;m very excited to introduce you to who I have with me today. Today, I have <a href=\"https://profiles.wordpress.org/onemaggie/\">Maggie Cabrera</a> and <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>. They both are working on themes, and especially the future of themes as we move into this low code, no code block based experience of editing things in WordPress. And there have been so many questions lately about what does the landscape of being a theme developer turns into once we move fully into this excellent promise of user empowerment for Gutenberg? I figured who best to come and talk to us about that than these two. So welcome, Maggie. Welcome, Jeff. I&#8217;m really excited to have this conversation with you today.</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>01:39</p>\n\n\n\n<p>Thank you for having us. Excited to be here.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:45</p>\n\n\n\n<p>I&#8217;m just gonna hop right in, and we will see what happens. The first thing that I want to chat about, I hear so many questions and so much discussion about patterns in a lot of different places. Like obviously, the work that I helped to steward the most is around like the Block Pattern directory and various other user-facing tools. And so I have never really been able to give a really solid answer about like patterns and how they work inside themes. And so I wondered if you all had anything that you could offer to our listeners to help clarify what is the power of patterns inside themes in the future? Implementation of themes?</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>02:34</p>\n\n\n\n<p>I can try to start unless, Maggie? Okay. Well, if you take a look at what I&#8217;ve been doing for the last couple of months working on Twenty Twenty-Two. And if you look at that theme, it&#8217;s mostly just the collection of patterns. Patterns. As you know, if you read the description, the theme, it&#8217;s designed to be the most flexible and kind of like flexible theme ever, dare I say ever created.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>03:04</p>\n\n\n\n<p>I think you can dare to say it.&nbsp;</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>03:03</p>\n\n\n\n<p>And, you know, I think a huge part of that is because of the Full Site Editing being launched, introduced in 5.9. And also that theme itself ships with all of these patterns in it that work with the overall design, but really can be configured to your own kind of unique liking and kind of taste and ultimately, what you want to accomplish, whether that&#8217;s I want to make a portfolio, I want to make, you know, a single-page website promoting like my podcast, or there are patterns for that kind of shipping with the theme. And they&#8217;ve all been kind of designed and tailored to work with the typography choices at a baseline level with the color choices at a baseline level, but can very easily be tweaked. And you can kind of rely on them to work with the editor. And I guess, kind of zooming out for a little bit, not just about Twenty-Twenty Two.&nbsp;</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>04:04</p>\n\n\n\n<p>But like patterns as this idea that a theme, hopefully, what it is, it&#8217;s a collection of different design options or layout options that are ultimately presented as patterns to the user, the patterns are just a really easy way to basically say &#8220;I want you this layout, like two columns of text or with like some images here.&#8221; Basically, a theme becomes a way of packaging the patterns together in a way that feels like a coherent piece of a coherent website. And I think that&#8217;s a pretty powerful idea. I know that the patterns directory is also opening up making those patterns pretty widely available. But I think a theme you could think of as like a curation of those patterns in a way that makes sense. And I think Twenty-Twenty Two is a really good example. I mean, I&#8217;m biased.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:03</p>\n\n\n\n<p>I also think it&#8217;s a good example. Maggie, did you have anything that you wanted to add to that?</p>\n\n\n\n<p><strong>Maggie Cabrera&nbsp; </strong>05:08</p>\n\n\n\n<p>Yeah, What I really like about patterns is how it empowers the user, even if they don&#8217;t really have like a deep knowledge of code, or they&#8217;re not used to the more complex blocks. When the theme developer gives you this pattern about using the query block, for example, it lays out your posts in a very compelling manner. And you can edit it if you want it or just use it out of the box. And you have this dynamic blog that it&#8217;s, like, such a big important part of your website. Like if you want to have a page where you have, you have maybe a podcast website, and you want to showcase your podcasts differently than your regular blog posts. So you can use a different gray pattern for that. And it&#8217;s like, really, really easy to use, even if you&#8217;re not familiar with it.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>06:07</p>\n\n\n\n<p>One of the things that I have found compelling about this new version of themes and kind of the way that themes are planning to look in the future; it&#8217;s going to be like a super throwback, so everyone get ready for me to sound old, my guests and my listeners alike. It reminds me of my original days of blogging on the web. I was not a developer and even though I had this really short stint of working with JavaScript in my career, at some point. Like no one actually would ever look to me and be like, that one is excellent at design and fixing everything with code, like I was just killer at searching for the right pieces of code, right.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>06:57</p>\n\n\n\n<p>And so I remember sitting there on Zynga, which is, of course, now powered by WordPress, I absolutely just went out and found bundles of code that are now what we would consider themes and modified the small pieces that I needed to change in order to like really suit what I wanted to have happen on the site at the time. And they&#8217;re like, I knew I could break it all. Really easily. But also, it was, it was not scary to think about breaking it. Like it was clear how I could fix it if I really broke it. The content, like what I had written, was separate from everything to do with the way that it was looking. And so like, I wouldn&#8217;t destroy all of my work, just because I didn&#8217;t put a semicolon in the right place, or whatever it was in that moment. And so like, this future of themes really reminds me of this a lot where someone has curated how it can look how it should look. And you can just like add in modular pieces that will augment what was already intended, but still kind of work. And if it&#8217;s not gonna work, it&#8217;s kind of easy to fix too. So like, I&#8217;m excited. That was a really exciting time in my learning of the web and certainly was formative in my career, as we all now see. And so yeah, I think that&#8217;s really exciting.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>08:20</p>\n\n\n\n<p>I did have actually another question that this conversation has kind of brought up for me. I have, obviously just use the term modular, which no one has ever used in the context of themes for WordPress. And I know that there is a lot there are a lot of terms kind of wandering around about themes right now. And especially as we&#8217;re moving into what themes can look like in the future. There was block based theme as a term for a while. And now it&#8217;s block themes. There was like this floating around the term, universal themes. And now we&#8217;re looking at just like block themes forever. And so I wondered if y&#8217;all could give us a just like a clear understanding of these terms that had been being used and maybe are going out of fashion? Like, are they important for us to keep knowing?</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>09:11</p>\n\n\n\n<p>So yes, the history of terms around themes. And obviously, even my knowledge only goes back so far. But it was around when we started doing the block based themes meeting. And trying to I think that&#8217;s where that term kind of came from is like, oh, let&#8217;s, let&#8217;s start talking about this idea that themes can be completely made up out of blocks. And what does that mean?&nbsp;</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>09:33</p>\n\n\n\n<p>I think over time, it wasn&#8217;t just block themes, because, you know, previously, there were themes and even default themes that used and took into account the fact that blocks existed. So there was some confusion there. Enough time has gone on where we focus on this idea that themes whose templates are ultimately made out of blocks are block themes. And to me, it&#8217;s kind of as simple as that. Its themes that supply a set of templates that previously in the past were a collection of PHP and various template tags and whatnot is all transitioned to themes made up including other blocks, as well as themes that supply styles through theme.json configuration instead of supplying it in raw CSS. To me this idea is really crystallizing around like this is a block theme, one that is really, at its core, supplying a set of templates, and styles through a language that WordPress understands natively, and can allow it to be configured and customized in a really powerful way. And then maybe someday in the future, they&#8217;ll just be called themes again. If we do a good enough they will just be called themes.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>10:57</p>\n\n\n\n<p>I&#8217;m gonna, I&#8217;m gonna take us into a philosophical area now that you&#8217;ve just put us in there. You said, someday they&#8217;ll be called Themes. Again, I&#8217;ve talked about this on this podcast a few times. And for anyone who&#8217;s worked with me for any length of time, like you all probably heard this from me as well. But like, adjectives are so frequently the realm of things that are not what you expect, right? Because like you have coffee, and then decaf coffee, no one&#8217;s like caffeinated coffee, because that&#8217;s what you expect out of it. And so when you&#8217;re like themes, and block themes, it makes it look like block themes are secondary, which at the moment, they are, ish. But in the future, I think you&#8217;re probably right, there will be a time when the modifier isn&#8217;t necessary anymore because it will be hopefully a much better way for people to kind of change the way that their themes work and make it more usable for users and people who are, you know, having to manage their own site without necessarily wanting to or being able to, like, have a Maggie in the room to fix everything that they break.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>12:08</p>\n\n\n\n<p>Maggie is nowhere near me. And so she&#8217;s never been in the room when I&#8217;ve broken anything. But I believe that Maggie on one occasion, at least, has come in and helped me fix something that I definitely broke. I&#8217;m an excellent breaker of WordPress things. Maggie, did you have anything you wanted to add to that question?&nbsp;</p>\n\n\n\n<p>12:29</p>\n\n\n\n<p>Yeah, I guess, maybe clarify a bit, what universal themes are because, yeah, maybe some people have heard about the term but they don&#8217;t really know what they are. And maybe just clarify that. The term was born when developing block themes wasn&#8217;t something that you could actually do for production websites like you could build them to test some experiments, but they weren&#8217;t really ready for users to use. So universal themes want to grasp the power of love themes while still being ready for users. So the way they do it is they are block based, like we used to call them in the sense that the templates are made of blocks. But they are also able to be customized using the customizer, which is the old way of customizing themes, instead of using the site editor. So they can have a balance between two worlds between the worlds of classic themes and block themes. But they are, at heart, a temporary concept. They are bound to be blocked themes in the future, but with maybe a foot in the past, where they can actually serve users who are not ready for full-on site editor. But they are bound to be full block themes in the future.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>14:00</p>\n\n\n\n<p>There&#8217;s a really interesting concept in there. So universal themes, it sounds like are basically kind of like an on-ramp for people who are not really ready to fully commit to this for any number of reasons. Like we never want to say that we know the reason that people would be a little bit shy to get started with this. But like it&#8217;s kind of like an on-ramp, it&#8217;s a safe way to get back to something that they do know, in the event that what they don&#8217;t know, really hinders their progress makes it hard for them to get the work done.</p>\n\n\n\n<p><strong>Maggie Cabrera&nbsp; </strong>14:31</p>\n\n\n\n<p>I think I wouldn&#8217;t say that they are for people shyer to get into new stuff rather than developers who want to embrace the new stuff before it&#8217;s even really ready. They really want to embrace the power of the blocks instead of doing things the old way. But even if it&#8217;s not fully ready.</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>14:54</p>\n\n\n\n<p>They still need to support the old way of doing things.</p>\n\n\n\n<p><strong>Maggie Cabrera&nbsp; </strong>14:58</p>\n\n\n\n<p>Like being backward compatible and being ready for any kind of user.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>15:05</p>\n\n\n\n<p>So mostly for developers, everyone who heard me just talking about how it was a great thing for users, ignore it. </p>\n\n\n\n<p><strong>Maggie Cabrera&nbsp; </strong>15:12</p>\n\n\n\n<p>It&#8217;s also good for users; If they feel secure in using the customizer.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>15:20</p>\n\n\n\n<p>Well, I think that there&#8217;s something important here that we certainly learned with the adoption of Gutenberg in 5.0. Right, which is that there is certainly one method of helping people to adopt things, which is to go like the art of war style, and kind of smash their rice pots and burn all their boats, like, that&#8217;s one way. Which works for a lot of companies in the world, I&#8217;m sure. But WordPress has always had kind of a commitment, not even kind of, has always had a commitment to backward compatibility. And like, we know that a lot of the work on Gutenberg is going to represent some breaking changes around the around workflows and around the user experience the interface, especially like, we know that. But the opportunity to like have a thing that gives you an early taste of what&#8217;s coming but also the ability to keep kind of working in your old space where you need to, I think it&#8217;s an excellent way to bring people forward into the future of things, I have never been a fan of the just like cut off all avenues and hope that they stay with your method because of course, like you can&#8217;t cut off all the methods. You can&#8217;t cut off all the ways people can get away from you. And even if we could, it wouldn&#8217;t be in line with how WordPress hopes to kind of help people through some tough stuff like making your first website is hard. If you are doing it as part of, an overall campaign that&#8217;s supposed to bring in leads for you or generate revenue like you don&#8217;t want to necessarily play with that in a way that could break things and be risky for you in the long term. So I think all the tools that we offer to help people kind of move forward with the technology move forward with the CMS as it&#8217;s moving forward, I think it&#8217;s really smart. And so universal themes are one of those things, but also not around to stay. As we move into non modified themes, just the word themes that happen to be based in blocks. If I&#8217;ve confused anyone, please email me at wpbriefing@wordpress.org. And tell me how I confused you. And I will do a follow-up to unconfuse everyone.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>17:40</p>\n\n\n\n<p>So speaking of the way that we help people kind of move forward with WordPress and with the technology. So much has been done in the CMS in the past 12 months in the past 18 months to be able to move themes into this same future as the rest of the editor. Right. So like, for folks who have not been listening to me for the last five years, you may not know this. So I&#8217;m going to tell everybody now, like one of the pain points that Gutenberg overall is solving is the fact that you for a long time had to learn five different editing interfaces to get one thing done in WordPress, right. And so like the advent of blocks and moving it into more and more spaces in the CMS is intended to really flatten the editing experience by making the type of user interaction the type of workflow really similar across all of the editing interfaces in the CMS. And so themes are a natural extension of that, where we can take similar user patterns and workflows, and work them out into themes. So over the last 12 months or so probably a little bit more, there&#8217;s been a lot of work on the CMS to move us forward in that that is now enabling the work that we want to be able to do to move things forward ahead. And so, I mean, this is probably our last question. Is there anything that you all want to offer to people who maybe saw themes early on or saw Gutenberg early on and felt like this is just not for me, in that in that context of like, how far it&#8217;s moved ahead in the past 12 months or so.</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>19:23</p>\n\n\n\n<p>So you&#8217;re asking like, what in the last 12 months has maybe like really surprised me or like sticks out to me as something that like, Wow, look how far we&#8217;ve come?</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>19:36</p>\n\n\n\n<p>Yeah, yeah. So like, if you&#8217;re looking at what is the one thing that you saw in the last 12 months, that changed in the CMS that really enabled something wonderful for themes or from the other side of it. Like if someone had looked at themes or WordPress 18 months ago, and now they&#8217;re looking at it and seeing this new and different way to do things with the look and feel of their site, like what is one thing that they should be aware of? On either side of that question,</p>\n\n\n\n<p><strong>Maggie Cabrera&nbsp; </strong>20:05</p>\n\n\n\n<p>I think there&#8217;s more than one thing that has really evolved through this last year, year and a half. Like the maturity of some of the blocks is astounding now, like navigation blog, for example, was really bare-bones at the start and now it&#8217;s full potential, and it&#8217;s really looking really great. I would say the same thing about those days or the features on fire, like how basic it was at the start, was full potential. But now it&#8217;s really, really mature in terms of how much you can do with it. Like, I think the example, the perfect example of that is the work that <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell [Reigstad]</a> has done on Twenty-Twenty Two with the alternative theme.json files, where just changing that file basically feels like a new theme, with just the configuration and the styles. And without writing any CSS without changing any templates. It&#8217;s really, really amazing how that can turn into a reality. And it&#8217;s so easy for users to tinker with that if they want to. And it&#8217;s much easier than having to delve deep into CSS and changing everything in like 2000 lines of code.&nbsp;</p>\n\n\n\n<p><strong>Jeff Ong&nbsp; </strong>21:23</p>\n\n\n\n<p>Yeah, I probably would echo most of that. What the thing that astounds me is global styles and how the UI can be shipping a theme or default theme with basically like, 20 lines of CSS, and have it be one of them. A beautiful, beautiful, like crisp and sharp, like, experience. It&#8217;s super fast. And it&#8217;s like, what this is a theme, you know, I thought a theme was supposed to supply all the styles like no, like, it&#8217;s just yeah. And workers do for you. Exactly. And like that. That&#8217;s pretty amazing to think in the last 12 months, we can go from, you know, shipping 1000s of lines of CSS to you none, it&#8217;s like, Wow, pretty cool.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>22:10</p>\n\n\n\n<p>Well, my friends, thank you so much for joining me today. This has been a really interesting conversation. I hope that all y&#8217;all out listening. Also find it interesting. As I mentioned, if you have any follow-up questions, absolutely. Send them to me via email. And I collect all of my questions that I get through the year for answering at the end of the year, mostly because I don&#8217;t get lots of questions that people want to be answered on this. Everyone just asked me their questions on Twitter and in Slack, which is fine as well.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>22:41</p>\n\n\n\n<p>So, Maggie, Jeff, thank you both for joining me. And I&#8217;m sure that we&#8217;ll talk to you all again soon.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>22:56</p>\n\n\n\n<p>That brings us now to our small list of big things. In the last episode, I got all excited about being in the beta phase. But today, I&#8217;m rolling that back a little bit. As part of our usual open source processes, a group of contributors did a deep dive review on the WordPress 5.9 release and found a workflow that needed some refinement. So we are delaying the beta.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>23:19</p>\n\n\n\n<p>Since we are in the midst of a major commerce slash/sales season, and of course, a lengthy holiday season, that delay also means that it makes sense to delay WordPress 5.9 final release a little as well. And so we are delaying that all the way into 2022 to January 25. For me, the trade-off works really well there. Every decision that we make in open source, of course, has some balance to it. It&#8217;s great for these aspects, it is less great for these aspects over here. But for myself, the opportunity to make sure that we have a really excellent experience for our users and also an opportunity to kind of avoid all of the chaos and hustle and bustle of the end of the year. Really, it seemed like a no-brainer for me. So in case you want to learn a little bit more about why we made the decision and get some insight into the actual milestones and where they have moved now, I&#8217;ll include some posts in the show notes below in case you want to read more and of course, if you have any additional questions you can always ask.</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>24:33</p>\n\n\n\n<p>The second small list of big things is that the first back to people WordCamp. I don&#8217;t think that&#8217;s what we&#8217;re calling it. Our first back to people WordCamp is happening in a couple of weeks actually. WordCamp Sevilla is happening in person on December 11. And I&#8217;m so excited I wish I were local, but I&#8217;m not so if you are local stop by their website and pick up your ticket.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>24:55</p>\n\n\n\n<p>And the third thing on our smallest a big things is that it is, of course, charitable giving season. I don&#8217;t know if you do your charitable giving at the end of the year or if that&#8217;s even part of your general ways of giving back. But I can think of two or three charitable organizations inside the WordPress ecosystem. There&#8217;s of course the WordPress Foundation, but also Big Orange Heart and HeroPress. If there are others out there, I certainly do want to know about them. WordPress Foundation also does additional giving on behalf of just like the open web and open source as a whole. So if you&#8217;re the sort of person who does their charitable giving at the end of the year, just a reminder that you have some options inside the WordPress ecosystem if you were trying to figure out some new places to donate to in 2021.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>25:42</p>\n\n\n\n<p>And that is your small list of big things. Thank you so much for tuning in today for the WordPress Briefing. Thank you again to our special guests, Maggie and Jeff. I&#8217;m your host Josepha Haden Chomphosy, and I&#8217;ll see you again in a couple of weeks.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11636\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"Watch State of the Word at a Watch Party with your WordPress Friends\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"https://wordpress.org/news/2021/11/watch-state-of-the-word-at-a-watch-party-with-your-wordpress-friends/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 24 Nov 2021 18:30:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Events\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11641\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:322:\"State of the Word 2021 is just around the corner!&#160; Although attending State of the Word in person would be ideal, not all WordPress community members get to enjoy the experience of attending the speech live with friends.&#160; This year, as State of the Word is streamed live for the second time, we want to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Hari Shanker R\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:20055:\"\n<p><a href=\"https://wordpress.org/news/2021/11/state-of-the-word-2021/\">State of the Word 2021</a> is just around the corner!&nbsp;</p>\n\n\n\n<p>Although attending State of the Word in person would be ideal, not all WordPress community members get to enjoy the experience of attending the speech live with friends.&nbsp;</p>\n\n\n\n<p>This year, as State of the Word is streamed live for the second time, we want to restore that in person camaraderie through State of the Word watch parties for WordPress Community members around the world.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><strong>We encourage WordPress meetup organizers and community members worldwide to (safely) host State of the Word 2021 watch parties —</strong><a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/\"><strong>read this handbook to learn more</strong></a><strong>.</strong></p></blockquote>\n\n\n\n<h2 id=\"why-organize-a-watch-party\">Why organize a watch party?&nbsp;</h2>\n\n\n\n<ul><li>If you are a <a href=\"https://meetup.com/pro/wordpress\">WordPress meetup</a> organizer, many folks in your meetup may be unaware of the State of the Word, and a watch party could be a great opportunity to introduce or remind them.</li><li>As meetup organizers slowly bid goodbye to a tough year, the watch party could be an excellent opportunity to revitalize your group, especially if you haven’t had many events this year.</li><li>Along with your Meetup group members, you get a platform to ask questions directly to Matt Mullenweg.</li><li>And last but not least, even if you are not a Meetup Organizer, a watch party can be the perfect opportunity to reconnect and have a blast with your WordPress friends!</li></ul>\n\n\n\n<h2 id=\"how-do-i-organize-a-state-of-the-word-watch-party\">How do I organize a State of the Word watch party?</h2>\n\n\n\n<p>You can choose to host a watch party online or in person. Check out <a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/#schedule-a-state-of-the-word-watch-party-for-your-meetup\">our handbook</a> for detailed instructions on how to schedule an event (including event templates).</p>\n\n\n\n<div class=\"wp-container-9 wp-block-columns\">\n<div class=\"wp-block-column\">\n<h3 id=\"online\">Online</h3>\n\n\n\n<p>The simplest way to organize an online watch party is to schedule an online event for your WordPress group and add the State of the Word YouTube streaming link directly on Meetup.com. Alternatively, you can schedule an online meeting using tools like Zoom and broadcast the live stream over there by screen sharing––thereby facilitating better engagement. </p>\n\n\n\n<div class=\"wp-container-7 wp-block-buttons\">\n<div class=\"wp-block-button\"><a class=\"wp-block-button__link\" href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/#organizing-an-online-watch-party\" target=\"_blank\" rel=\"noreferrer noopener\">Organize an Online Watch Party</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<h3 id=\"in-person\">In Person</h3>\n\n\n\n<p>If your region meets <a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/2021-returning-to-in-person-meetups/\">the guidelines for in person events</a> (if vaccines and testing are freely available), you can organize an in person watch party event (for fully vaccinated OR recently tested OR recently recovered folks) for your WordPress Meetup! Group members can hang out together (following local safety guidelines of course) and watch State of the Word live.</p>\n\n\n\n<div class=\"wp-container-8 wp-block-buttons\">\n<div class=\"wp-block-button\"><a class=\"wp-block-button__link\" href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/#organizing-an-in-person-watch-party\" target=\"_blank\" rel=\"noreferrer noopener\">Plan an In person Watch Party</a></div>\n</div>\n</div>\n</div>\n\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p><strong>NOTE:</strong> If State of the Word is happening at an odd hour in your timezone, you can still organize a watch party by organizing a replay of live stream, at a date/time that is convenient for your group.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>If your Local WordPress Meetup is organizing an in person watch party, <a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/request-swag-for-in-person-watch-parties/\"><strong>fill out this form</strong></a><strong> so that we can ship some swag for your group to celebrate!</strong><br>Deadline: November 30, 2021</p></blockquote>\n\n\n\n<h2 id=\"what-else-do-i-need-to-know-about-organizing-a-state-of-the-word-watch-party\">What else do I need to know about organizing a State of the Word watch party?</h2>\n\n\n\n<p>Excited? To help you get started, we’ve put together a few resources:</p>\n\n\n\n<ul><li><strong>Check out this </strong><a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/\"><strong>handbook</strong></a><strong> for detailed instructions on how to organize a watch party, </strong>be it online or in person.</li><li>Looking for a Zoom Pro account to host your online watch party?&nbsp;<a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/getting-started/special-virtual-events-zoom-request/\">Request a community zoom pro account</a>&nbsp;for your event right away!</li><li>We have prepared some <a href=\"https://make.wordpress.org/community/handbook/meetup-organizer/event-formats/2021-state-of-the-word-watch-parties/email-templates-for-state-of-the-word/\">email templates</a> that Meetup Organizers can use to spread the word in their Meetup groups.</li><li>Don’t forget to share on social media about your watch party events using the hashtag <strong>#StateOfTheWord</strong> so we can join in on the fun!</li></ul>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><strong>NOTE: </strong> The guidelines in this post are primarily aimed at WordPress Meetup organizers. <strong>However, you do not need to be a Meetup organizer to schedule a watch party!</strong> You can simply hang out together with your friends online or in person (while following local safety guidelines) and catch the event live!</p></blockquote>\n\n\n\n<h2 id=\"join-a-state-of-the-word-watch-party-near-you\">Join a State of the Word Watch Party near you!</h2>\n\n\n\n<p>We have compiled a list of State of the Word Watch Parties around the world. If you don&#8217;t see a watch party in your region listed here, <a href=\"https://meetup.com/pro/wordpress\" target=\"_blank\" rel=\"noreferrer noopener\">check this page on Meetup.com</a>  to see if your local WordPress group is organizing one. If not, why don&#8217;t you consider organizing a watch party on your own? <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f642.png\" alt=\"🙂\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> </p>\n\n\n\n<ul><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/WordPressNYC\">WordPress NYC Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPressNYC/events/282276960/\" target=\"_blank\">An In Person MeetUp: The State of the Word 2021 is in Manhattan.</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/South-Jersey-WordPress-Meetup\">South Jersey WordPress Meetup</a>]  <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/South-Jersey-WordPress-Meetup/events/282402090/\" target=\"_blank\">JerseyPress: State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Morris-County-NJ-WordPress-Group\" target=\"_blank\">Morris County NJ WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Morris-County-NJ-WordPress-Group/events/282402069/\" target=\"_blank\">JerseyPress: State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Montclair-Meetup\" target=\"_blank\">WordPress Montclair Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Montclair-Meetup/events/282326195/\" target=\"_blank\">JerseyPress: State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/wordpressscv\">WordPress Santa Clarita Valley</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wordpressscv/events/282056842/\" target=\"_blank\">State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/houston-wordpress\" target=\"_blank\">The Houston WordPress Meetup Group</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/houston-wordpress/events/282402609/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/NEOWordPress/\">North East Ohio WordPress Meetup</a>] <a href=\"https://www.meetup.com/NEOWordPress/events/282456476/\">State of Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/Birmingham-WordPress-Meetup\">Birmingham WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Birmingham-WordPress-Meetup/events/282313212/\" target=\"_blank\">State of the Word Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lehigh-Valley-WordPress-Meetup\" target=\"_blank\">Lehigh Valley WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lehigh-Valley-WordPress-Meetup/events/282304472/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/metro-detroit-wordpress-meetup/\">Metro Detroit WordPress Meetup</a>] <a href=\"https://www.meetup.com/metro-detroit-wordpress-meetup/events/282519538/\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Milwaukee-WordPress-MeetUp\" target=\"_blank\">Greater Milwaukee Area WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Milwaukee-WordPress-MeetUp/events/282598865/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Eastbay-WordPress-Meetup\" target=\"_blank\">The East Bay WordPress Meetup Group</a>] <a href=\"https://www.meetup.com/Eastbay-WordPress-Meetup/events/282539457/\">State of the Word 2021 (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Sacramento-WordPress\" target=\"_blank\">Sacramento WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Sacramento-WordPress/events/282593192/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Meetup-Louisville\" target=\"_blank\">WordPress Louisville</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Meetup-Louisville/events/281858101/\" target=\"_blank\">State of the Word Watch Party and Discussion (WP Louisville, KY)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e8-1f1f4.png\" alt=\"🇨🇴\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPressMedellin\" target=\"_blank\">WordPress Medellín</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPressMedellin/events/282306436/\" target=\"_blank\">State of the Word 2021: Discurso de Matt &amp; Fiesta de Comunidad (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ed-1f1f9.png\" alt=\"🇭🇹\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/Port-au-Prince-WordPress-Meetup\">Port-au-Prince WordPress Meetup Group</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Port-au-Prince-WordPress-Meetup\" target=\"_blank\"></a><a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Port-au-Prince-WordPress-Meetup/events/282350488/\" target=\"_blank\">Rejoignez-nous le 14 décembre pour regarder State of the Word 2021 (online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1e7.png\" alt=\"🇬🇧\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpcoventry\" target=\"_blank\">WordPress Coventry Meetup</a>]  <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpcoventry/events/282302051/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1e7.png\" alt=\"🇬🇧\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpexeter\" target=\"_blank\">WordPress Exeter</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpexeter/events/282293408/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ee-1f1f9.png\" alt=\"🇮🇹\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/WordPress-Meetup-Torino/\">WordPress Meetup Torino</a>] <a href=\"https://www.meetup.com/WordPress-Meetup-Torino/events/282467417/\">State of the Word 2021 Video Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f7-1f1fc.png\" alt=\"🇷🇼\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Kigali-WordPress-Meetup\" target=\"_blank\">Kigali WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Kigali-WordPress-Meetup/events/282321636/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f3-1f1ec.png\" alt=\"🇳🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group\" target=\"_blank\">Lagos WordPress Community</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group/events/282321642/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f3-1f1ec.png\" alt=\"🇳🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Ijebu-WordPress-Meetup\" target=\"_blank\">Ijebu WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group/events/282321642/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1ec.png\" alt=\"🇺🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Jinja-WordPress-Meetup\" target=\"_blank\">Jinja WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Jinja-WordPress-Meetup/events/282637298/\" target=\"_blank\">State of the Word 2021 Watch Party &#8211; WordPress Community Uganda (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1ec.png\" alt=\"🇺🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/Kampala-WordPress-Meetup/\">Kampala WordPress Meetup</a>] <a href=\"https://www.meetup.com/Kampala-WordPress-Meetup/events/282678558/\">State of the Word Livestream</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f5-1f1f0.png\" alt=\"🇵🇰\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Lahore\" target=\"_blank\">WordPress Meetups Lahore</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Lahore/events/282311458/\" target=\"_blank\">State of the Word 2021 Watch Party (In-person)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ee-1f1f3.png\" alt=\"🇮🇳\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/WordPress-Bhopal\">WordPress Bhopal</a>] <a href=\"https://www.meetup.com/WordPress-Bhopal/events/282470541/\">State of the Word 2021 Watch Party (In-person)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ee-1f1f3.png\" alt=\"🇮🇳\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/BengaluruWordPress/\">Bengaluru WordPress</a>] <a href=\"https://www.meetup.com/BengaluruWordPress/events/282271921/\">WordPress Meetup &#8211; State of the word -Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f8-1f1ec.png\" alt=\"🇸🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Singapore\" target=\"_blank\">WordPress Singapore</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Singapore/events/282296137/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li></ul>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p>If you are planning a watch party for State of the Word, and have questions, please drop us an email to: <a href=\"mailto:support@wordcamp.org\">support@wordcamp.org</a> if you have any questions. We are happy to help you in the best way possible.</p>\n\n\n\n<p><em>The following folks contributed to this post: <a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a> <a href=\'https://profiles.wordpress.org/eidolonnight/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>eidolonnight</a> <em><a href=\'https://profiles.wordpress.org/evarlese/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>evarlese</a></em></em> <em>and <a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a></em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11641\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:63:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"A Look at WordPress 5.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/news/2021/11/a-look-at-wordpress-5-9/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 23 Nov 2021 21:02:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:6:\"Design\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:8:\"Features\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11625\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:322:\"WordPress 5.9 is expected to be a ground-breaking release. It will introduce the next generation of themes with Twenty Twenty-Two joining the fun and over 30 theme blocks to build all parts of your site. In anticipation of the January 25th release, we hope you enjoy this sneak peek of 5.9. New design tools will [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Kelly Hoffman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2987:\"\n<figure class=\"wp-block-embed is-type-video is-provider-youtube wp-block-embed-youtube wp-embed-aspect-4-3 wp-has-aspect-ratio\"><div class=\"wp-block-embed__wrapper\">\n<iframe loading=\"lazy\" class=\"youtube-player\" width=\"600\" height=\"338\" src=\"https://www.youtube.com/embed/XvEG9XWD4JI?version=3&#038;rel=1&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;fs=1&#038;hl=en-US&#038;autohide=2&#038;wmode=transparent\" allowfullscreen=\"true\" style=\"border:0;\" sandbox=\"allow-scripts allow-same-origin allow-popups allow-presentation\"></iframe>\n</div></figure>\n\n\n\n<p>WordPress 5.9 is expected to be a ground-breaking release. It will introduce the next generation of themes with <a href=\"https://make.wordpress.org/core/2021/10/06/introducing-twenty-twenty-two/\">Twenty Twenty-Two</a> joining the fun and over 30 theme blocks to build all parts of your site. <a href=\"https://make.wordpress.org/core/5-9/\">In anticipation of the January 25th release</a>, we hope you enjoy this sneak peek of 5.9.</p>\n\n\n\n<p>New design tools will allow you to create exactly what you want, from adding filters to all your images to fine-tuning the border radius on all your buttons. With WordPress 5.9 providing more design control along with streamlined access to patterns, you can easily change the entire look and feel of your site without switching themes<strong>.</strong></p>\n\n\n\n<p>No matter what you’re editing, whether it&#8217;s crafting a new post or working on a header, improvements to List View make it simple to navigate content regardless of complexity. More improvements and features for everyone are to come in this release and we can&#8217;t wait to see what you create with WordPress 5.9! </p>\n\n\n\n<h2 id=\"stay-tuned\">Stay Tuned</h2>\n\n\n\n<p>Stay tuned for more updates as the date draws near. If you want to help, the best thing you can do is <a href=\"https://make.wordpress.org/core/handbook/testing/beta-testing/\">test everything</a>! For all the details, <a href=\"https://make.wordpress.org/core/2021/11/22/wordpress-5-9-revised-release-schedule/\">check out this Make Core post</a>.</p>\n\n\n\n<p><em>Video props: <a href=\'https://profiles.wordpress.org/annezazu/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>annezazu</a> (also co-wrote the post) <a href=\'https://profiles.wordpress.org/michaelpick/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>michaelpick</a> <a href=\'https://profiles.wordpress.org/matveb/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>matveb</a> <a href=\'https://profiles.wordpress.org/beafialho/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>beafialho</a> <a href=\'https://profiles.wordpress.org/javiarce/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>javiarce</a> <a href=\'https://profiles.wordpress.org/critterverse/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>critterverse</a> <a href=\'https://profiles.wordpress.org/joen/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>joen</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11625\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"Join us for State of the Word 2021, in person or online!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"https://wordpress.org/news/2021/11/join-us-for-state-of-the-word-2021-in-person-or-online/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 22 Nov 2021 21:08:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Events\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11611\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:297:\"As previously announced, State of the Word will be livestreamed from New York City. That means that you can join the fun either online or in person, on December 14, 2021, between 5 and 7 pm EST! To join State of the Word 2021 online, check your Meetup chapter for a local watch party, or [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Josepha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1715:\"\n<p>As <a href=\"https://wordpress.org/news/2021/11/state-of-the-word-2021/\">previously announced</a>, State of the Word will be livestreamed from New York City. That means that you can join the fun either online or in person, on <a href=\"https://www.worldtimebuddy.com/?qm=1&amp;lid=5128581,100&amp;h=5128581&amp;date=2021-12-14&amp;sln=17-19&amp;hf=0\">December 14, 2021, between 5 and 7 pm EST</a>!</p>\n\n\n\n<p>To join State of the Word 2021 online, check your Meetup chapter for a local watch party, or simply visit <a href=\"https://wordpress.org/news/\">wordpress.org/news</a>, where the livestream will be embedded.&nbsp;</p>\n\n\n\n<p>If you would like to participate in person in New York City, please request a seat by filling out the registration form by Sunday, November 28. Not all requests will receive a seat due to venue capacity, but everyone who requests one will receive further notification on Tuesday, November 30.&nbsp;</p>\n\n\n\n<p>In person attendees will be asked to show their COVID vaccination card at the venue entrance, and are expected to follow the safety measures in place. Because of these safety measures, there is a maximum of 50 attendees.&nbsp;</p>\n\n\n\n<div class=\"wp-container-10 wp-block-buttons\">\n<div class=\"wp-block-button\"><a class=\"wp-block-button__link\" href=\"https://wordcampcentral.survey.fm/request-a-seat-sotw-2021\">Request a seat</a></div>\n</div>\n\n\n\n<p>Whether you participate in person or online, we are so excited to see you on December 14! Don’t forget, State of the Word will be followed by a Question &amp; Answer session. If you have a question for Matt, you can send your question ahead of time to ask-matt@wordcamp.org, or ask during the event in the YouTube chat.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11611\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:58:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WP Briefing: Episode 20: WordPress=Blogging+\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/news/2021/11/episode-20-wordpressblogging/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Nov 2021 12:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=11556\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:386:\"In this episode, WordPress&#8217;s Executive Director, Josepha Haden Chomphosy, answers two recently asked questions. Tune in to hear what those questions were and her response, in addition to this week&#8217;s small list of big things. Have a question you&#8217;d like answered? You can submit them to wpbriefing@wordpress.org, either written or as a voice recording. Credits [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2021/11/WP-Briefing-020.mp3\";s:6:\"length\";s:1:\"0\";s:4:\"type\";s:0:\"\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:10275:\"\n<p>In this episode, WordPress&#8217;s Executive Director, Josepha Haden Chomphosy, answers two recently asked questions. Tune in to hear what those questions were and her response, in addition to this week&#8217;s small list of big things.</p>\n\n\n\n<p><em><strong>Have a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a></li><li>Song: Fearless First by Kevin MacLeod</li></ul>\n\n\n\n<h2 id=\"references\">References </h2>\n\n\n\n<ul><li><a href=\"https://w3techs.com/technologies/details/cm-wordpress\">W3Techs WordPress Usage Statistics </a></li><li><a href=\"https://make.wordpress.org/core/5-9/\">WordPress 5.9 Development Cycle </a></li><li><a href=\"https://make.wordpress.org/updates/2021/10/22/team-rep-nominations/\">Call for Team Rep Nomination</a></li></ul>\n\n\n\n<h2 id=\"transcript\">Transcript</h2>\n\n\n\n<span id=\"more-11556\"></span>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:10</p>\n\n\n\n<p>Hello, everyone, and welcome to the WordPress Briefing, the podcast where you can catch quick explanations of the ideas behind the WordPress open source project, some insight into the community that supports it, and get a small list of big things coming up in the next two weeks. I&#8217;m your host, Josepha Haden Chomphosy. Here we go!</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:40</p>\n\n\n\n<p>So I was in a meeting recently, which I realize isn&#8217;t saying much for me since I spend a quarter of my time in meetings. But in this particular meeting, I was asked a couple of questions that I absolutely loved. The first question was, “if there were one thing you could change in people&#8217;s minds about WordPress, what would it be?” And my answer, predictable though it may be, was that I want to change the idea that WordPress is just a blogging platform.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:06</p>\n\n\n\n<p>WordPress has grown into a lot more than that. But the idea of a content management system, even now, sometimes gets a mental shorthand where content is a stand-in for the word writing or words. If you&#8217;re using WordPress today in an enterprise context, or as part of a governmental agency, or if you use it in a classroom setting, you know that your content cannot be confined that way. And if you&#8217;re supporting or building anything to hand off to clients, you know that timely, easy-to-ship changes on a site are considered a vital part of any overarching brand and marketing strategy. And when was the last time that any marketing strategy was literally only about the words?&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>01:51</p>\n\n\n\n<p>So that was the first question. And also my first answer. There is also this kind of annual, not fear, necessarily, but this annual question that is sort of related that is raised to me and has been asked of me recently, that I&#8217;m just going to give you a small answer to. One annual worry that I get every year around November and December is, &#8220;What are we going to do about the fact that the term blog and blogging are declining in search popularity?&#8221; And I was gonna say it&#8217;s been a while since I answered that in any sort of public format. But I think maybe I&#8217;ve never answered it in a public format at all. And so I&#8217;m just going to answer it here. Because I think maybe a lot of people have that same question.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:36</p>\n\n\n\n<p>So number one, I think that the way that people search now is different. There&#8217;s a lot more semantic cognition. This is not the way to answer this &#8212;  search engines are smarter now. So like, it used to be the case with early search engines that yeah, there was a lot of just like, individual search terms that were looked for. But now, people are asking full questions; they have, essentially, an entire sentence that they are searching for. And then, search engines are able to parse that information better and get more high-quality answers and information for them. So like, that&#8217;s one thing that I&#8217;m already not worried about. If people are searching for individual words anymore, it&#8217;s so that they can get a definition of that word. So I&#8217;m not specifically worried about a decline in search volume for the word blog or blogging for that reason. But the answer to my first question, if there is probably the real reason that I&#8217;m not actually super worried about any decline in search volume for the word blog, or blogging, is that WordPress has really moved beyond that. And since we have moved beyond that, then it doesn&#8217;t necessarily make sense for WordPress as an entity for WordPress as a project to get overly hung up on the idea that the term blog has gone out of fashion.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>03:52</p>\n\n\n\n<p>Okay, now that I did my first question, and the answer, and then an additional question that only ever gets asked in private and is being answered by me for the first time in public, I will tell you now, the second question that I loved, someone asking of me, and that question is this: &#8220;What is one thing you&#8217;d like people to see or experience, right when they first land on wordpress.org?&#8221; Now, I often don&#8217;t get asked questions about the wordpress.org website, like administrative tasks, things that we need to update, move around where they should go. Sure. But like, “Josepha, what&#8217;s the point and purpose of this site?” Never. I&#8217;ve never been asked that, and so I was really excited that someone asked me, and I&#8217;m going to give you a heads up. I think some of you might disagree with my answer.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>04:40</p>\n\n\n\n<p>So the primary thing that I want people to see or experience when they first get to wordpress.org, the website is the depth of WordPress. Not which audience segment they should belong to or that we believe they should belong to or raw data about the CMS or even how much we care about the freedoms of open source. Now the first thing I want people to see on that site is that WordPress has not only 18 years of learned knowledge that every single new user benefits from, but that it also has 1,000s of really smart people making sure it works and gets better every day, now.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:19</p>\n\n\n\n<p>WordPress is a Goliath in its field. I know that we cite this bit of context. Frequently, we say that we are 42% of the web. And that is true that is the percentage by usage. But in its field, which is websites that are using a content management system, we actually have a 65% market share. This is very easy to find. It&#8217;s on the W3Techs website: I can put a link in the show notes, but you could find it just by searching for it.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>05:46</p>\n\n\n\n<p>So WordPress is a Goliath in its field of websites that are run using a CMS. Because we have always brought our learnings forward with us with the understanding that knowledge, when shared grows rather than diminishes. But open source, the heart of what defines this project, open source is not a Goliath; it&#8217;s barely even David somedays. Even though the web is built on scads of open source software, there&#8217;s a pervasive public perception that it is built by and for hobbyists or that it is inherently risky, and that if there were if it were worth something, then people would pay something. And I just know that if the first impression of WordPress, we&#8217;re, &#8220;we&#8217;ve got 18 years of experience and learning that brought us to today,&#8221; the rest of the sale to adopt software that protects other people&#8217;s freedoms would take care of itself. And I guess, to quote John Oliver, at this point, &#8220;And now this.&#8221;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>06:59</p>\n\n\n\n<p>Alright, that brings us now to our small list of big things. There are actually quite a few big things on this small list today. So number one, we have reached the beta phase for the year&#8217;s final release, which means that WordPress 5.9 beta one is happening tomorrow, Tuesday, November 16. And then seven days later, I believe on the 23rd, if I recall correctly, comes beta two.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>07:24</p>\n\n\n\n<p>The second thing on my list is that team rep nominations are happening all over the project right now. I&#8217;ve got a post that I will share in the notes below that I believe all the team reps have put their team&#8217;s nomination posts on. So if you have had an interest in learning more about that and what it means to help keep teams kind of running in the WordPress project, then this is a great opportunity to check those out.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>07:49</p>\n\n\n\n<p>And the third thing, this last thing actually isn&#8217;t in the next two weeks, but it is very important, nonetheless. Matt&#8217;s annual State of the Word is coming up on December 14. So basically a month from today. It&#8217;s going to join the growing list of in-person events that are on the calendar. It will be in New York City but will also be live-streamed across the world as usual. Keep an eye out for additional updates about that for anyone who, like me, really looks forward to this particular presentation from our project co-founder every year.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>08:25</p>\n\n\n\n<p>And that is your small list of big things. Thank you for tuning in today for the WordPress briefing. I&#8217;m your host, Josepha Haden Chomphosy, and I&#8217;ll see you again in a couple of weeks.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11556\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:57:\"\n		\n		\n		\n		\n		\n				\n		\n\n					\n										\n					\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"State of the Word 2021\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wordpress.org/news/2021/11/state-of-the-word-2021/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 13 Nov 2021 00:38:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Events\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=11567\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:346:\"Howdy, World!&#160; Mark your calendars; it’s almost time for State of the Word 2021! State of the Word is the annual keynote address delivered by the WordPress project’s co-founder, Matt Mullenweg. Every year, the event allows us to reflect on the project’s progress and the future of open source. This year will include that and [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Josepha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:17591:\"\n<figure class=\"wp-block-embed is-type-video is-provider-youtube wp-block-embed-youtube wp-embed-aspect-16-9 wp-has-aspect-ratio\"><div class=\"wp-block-embed__wrapper\">\n<iframe loading=\"lazy\" class=\"youtube-player\" width=\"600\" height=\"338\" src=\"https://www.youtube.com/embed/OpiH_P9aGhQ?version=3&#038;rel=1&#038;showsearch=0&#038;showinfo=1&#038;iv_load_policy=1&#038;fs=1&#038;hl=en-US&#038;autohide=2&#038;wmode=transparent\" allowfullscreen=\"true\" style=\"border:0;\" sandbox=\"allow-scripts allow-same-origin allow-popups allow-presentation\"></iframe>\n</div></figure>\n\n\n\n<p>Howdy, World!&nbsp;</p>\n\n\n\n<p><a href=\"https://calendar.google.com/calendar/u/0/r/eventedit?text=State+of+the+Word+2021+livestream&amp;dates=20211214T220000Z/20211215T000000Z&amp;details=State+of+the+Word+is+the+annual+keynote+address+delivered+by+the+WordPress+project%27s+co-founder,+Matt+Mullenweg.%0AJoin+Matt+as+he+provides+a+retrospective+of+2021,+celebrates+the+community%27s+amazing+wins,+discusses+the+latest+trends+he%27s+seeing,+and+explores+the+future+of+open+source.%0AState+of+the+Word+will+be+live+streamed+from+New+York+City,+and+is+free+for+all+to+watch.%0Ahttps://wordpress.org/news/2021/11/state-of-the-word-2021/\">Mark your calendars</a>; it’s almost time for State of the Word 2021!</p>\n\n\n\n<p>State of the Word is the annual keynote address delivered by the WordPress project’s co-founder, Matt Mullenweg. Every year, the event allows us to reflect on the project’s progress and the future of open source. This year will include that and more.</p>\n\n\n\n<p>Due to the pandemic, we moved the State of the Word online for the first time ever in 2020. This year, the event will be livestreamed from New York City. That will enable us to take as many folks as possible along for the ride!</p>\n\n\n\n<p>Join Matt as he provides a retrospective of 2021, discusses the latest trends he’s seeing, celebrates the community’s amazing wins, and explores the future. Expect to hear about a range of topics, from WordPress 5.9 and Openverse to Web3 and non-fungible tokens (NFTs).</p>\n\n\n\n<p><strong>What:</strong> State of the Word 2021</p>\n\n\n\n<p><strong>When:</strong> <a href=\"https://calendar.google.com/calendar/u/0/r/eventedit?text=State+of+the+Word+2021+livestream&amp;dates=20211214T220000Z/20211215T000000Z&amp;details=State+of+the+Word+is+the+annual+keynote+address+delivered+by+the+WordPress+project%27s+co-founder,+Matt+Mullenweg.%0AJoin+Matt+as+he+provides+a+retrospective+of+2021,+celebrates+the+community%27s+amazing+wins,+discusses+the+latest+trends+he%27s+seeing,+and+explores+the+future+of+open+source.%0AState+of+the+Word+will+be+live+streamed+from+New+York+City,+and+is+free+for+all+to+watch.%0Ahttps://wordpress.org/news/2021/11/state-of-the-word-2021/\">December 14, 2021, between 5 and 7 pm ET/10 &#8211; 12 am (December 15) UTC</a></p>\n\n\n\n<p><strong>How:</strong> If you’re watching from the comfort of your home or <a href=\"https://wordpress.org/news/2021/11/watch-state-of-the-word-at-a-watch-party-with-your-wordpress-friends/\">local watch party</a>, the livestream will be embedded on wordpress.org/news.</p>\n\n\n\n<p><strong>Have a question for Matt?</strong></p>\n\n\n\n<p>State of the Word will be followed by a Question &amp; Answer session. If you want to participate, you can either send your question ahead of time to <a href=\"mailto:ask-matt@wordcamp.org\">ask-matt@wordcamp.org</a>, or ask during the event in the livestream chat on YouTube.</p>\n\n\n\n<p>If you’re new to State of the Word, the previous years’ recordings (below) will help you get a sense of what the event is about. Check them out:</p>\n\n\n\n<ul><li><a href=\"https://wordpress.org/news/2020/12/state-of-the-word-2020/\">State of the Word 2020 (online)</a></li><li><a href=\"https://wordpress.tv/2019/11/03/2019-state-of-the-word/\">State of the Word 2019 – WordCamp US, St. Louis</a></li><li><a href=\"https://wordpress.tv/2018/12/27/state-of-the-word-2018/\">State of the Word 2018 – WordCamp US, Nashville</a></li><li><a href=\"https://wordpress.tv/tag/state-of-the-word/\">All recordings</a></li></ul>\n\n\n\n<p>We hope to see you online on December 14th!</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2 id=\"join-a-state-of-the-word-watch-party-near-you\">Join a State of the Word Watch Party near you</h2>\n\n\n\n<p>We have compiled a list of State of the Word Watch Parties around the world. If you don&#8217;t see a watch party in your region listed here, <a rel=\"noreferrer noopener\" href=\"https://meetup.com/pro/wordpress\" target=\"_blank\">check this page on Meetup.com</a> to see if your local WordPress group is organizing one.</p>\n\n\n\n<ul><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/WordPressNYC\">WordPress NYC Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPressNYC/events/282276960/\" target=\"_blank\">An In Person MeetUp: The State of the Word 2021 is in Manhattan.</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/South-Jersey-WordPress-Meetup\">South Jersey WordPress Meetup</a>]  <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/South-Jersey-WordPress-Meetup/events/282402090/\" target=\"_blank\">JerseyPress: State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Morris-County-NJ-WordPress-Group\" target=\"_blank\">Morris County NJ WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Morris-County-NJ-WordPress-Group/events/282402069/\" target=\"_blank\">JerseyPress: State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Montclair-Meetup\" target=\"_blank\">WordPress Montclair Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Montclair-Meetup/events/282326195/\" target=\"_blank\">JerseyPress: State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/wordpressscv\">WordPress Santa Clarita Valley</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wordpressscv/events/282056842/\" target=\"_blank\">State of the Word 2021 Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/houston-wordpress\" target=\"_blank\">The Houston WordPress Meetup Group</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/houston-wordpress/events/282402609/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/NEOWordPress/\">North East Ohio WordPress Meetup</a>] <a href=\"https://www.meetup.com/NEOWordPress/events/282456476/\">State of Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/Birmingham-WordPress-Meetup\">Birmingham WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Birmingham-WordPress-Meetup/events/282313212/\" target=\"_blank\">State of the Word Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lehigh-Valley-WordPress-Meetup\" target=\"_blank\">Lehigh Valley WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lehigh-Valley-WordPress-Meetup/events/282304472/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/metro-detroit-wordpress-meetup/\">Metro Detroit WordPress Meetup</a>] <a href=\"https://www.meetup.com/metro-detroit-wordpress-meetup/events/282519538/\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Milwaukee-WordPress-MeetUp\" target=\"_blank\">Greater Milwaukee Area WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Milwaukee-WordPress-MeetUp/events/282598865/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Eastbay-WordPress-Meetup\" target=\"_blank\">The East Bay WordPress Meetup Group</a>] <a href=\"https://www.meetup.com/Eastbay-WordPress-Meetup/events/282539457/\">State of the Word 2021 (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Sacramento-WordPress\" target=\"_blank\">Sacramento WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Sacramento-WordPress/events/282593192/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Meetup-Louisville\" target=\"_blank\">WordPress Louisville</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Meetup-Louisville/events/281858101/\" target=\"_blank\">State of the Word Watch Party and Discussion (WP Louisville, KY)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e8-1f1f4.png\" alt=\"🇨🇴\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPressMedellin\" target=\"_blank\">WordPress Medellín</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPressMedellin/events/282306436/\" target=\"_blank\">State of the Word 2021: Discurso de Matt &amp; Fiesta de Comunidad (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ed-1f1f9.png\" alt=\"🇭🇹\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/Port-au-Prince-WordPress-Meetup\">Port-au-Prince WordPress Meetup Group</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Port-au-Prince-WordPress-Meetup\" target=\"_blank\"></a><a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Port-au-Prince-WordPress-Meetup/events/282350488/\" target=\"_blank\">Rejoignez-nous le 14 décembre pour regarder State of the Word 2021 (online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1e7.png\" alt=\"🇬🇧\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpcoventry\" target=\"_blank\">WordPress Coventry Meetup</a>]  <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpcoventry/events/282302051/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1e7.png\" alt=\"🇬🇧\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpexeter\" target=\"_blank\">WordPress Exeter</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/wpexeter/events/282293408/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ee-1f1f9.png\" alt=\"🇮🇹\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/WordPress-Meetup-Torino/\">WordPress Meetup Torino</a>] <a href=\"https://www.meetup.com/WordPress-Meetup-Torino/events/282467417/\">State of the Word 2021 Video Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f7-1f1fc.png\" alt=\"🇷🇼\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Kigali-WordPress-Meetup\" target=\"_blank\">Kigali WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Kigali-WordPress-Meetup/events/282321636/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f3-1f1ec.png\" alt=\"🇳🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group\" target=\"_blank\">Lagos WordPress Community</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group/events/282321642/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f3-1f1ec.png\" alt=\"🇳🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Ijebu-WordPress-Meetup\" target=\"_blank\">Ijebu WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Lagos-WordPress-Meetup-Group/events/282321642/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1ec.png\" alt=\"🇺🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Jinja-WordPress-Meetup\" target=\"_blank\">Jinja WordPress Meetup</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/Jinja-WordPress-Meetup/events/282637298/\" target=\"_blank\">State of the Word 2021 Watch Party &#8211; WordPress Community Uganda (Online)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1ec.png\" alt=\"🇺🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/Kampala-WordPress-Meetup/\">Kampala WordPress Meetup</a>] <a href=\"https://www.meetup.com/Kampala-WordPress-Meetup/events/282678558/\">State of the Word Livestream</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f5-1f1f0.png\" alt=\"🇵🇰\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Lahore\" target=\"_blank\">WordPress Meetups Lahore</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Lahore/events/282311458/\" target=\"_blank\">State of the Word 2021 Watch Party (In-person)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ee-1f1f3.png\" alt=\"🇮🇳\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/WordPress-Bhopal\">WordPress Bhopal</a>] <a href=\"https://www.meetup.com/WordPress-Bhopal/events/282470541/\">State of the Word 2021 Watch Party (In-person)</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ee-1f1f3.png\" alt=\"🇮🇳\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a href=\"https://www.meetup.com/BengaluruWordPress/\">Bengaluru WordPress</a>] <a href=\"https://www.meetup.com/BengaluruWordPress/events/282271921/\">WordPress Meetup &#8211; State of the word -Watch Party</a></li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1f8-1f1ec.png\" alt=\"🇸🇬\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /> [<a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Singapore\" target=\"_blank\">WordPress Singapore</a>] <a rel=\"noreferrer noopener\" href=\"https://www.meetup.com/WordPress-Singapore/events/282296137/\" target=\"_blank\">State of the Word 2021 Watch Party (Online)</a></li></ul>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p>If you are planning a watch party for State of the Word, and have questions, please drop us an email to: <a href=\"mailto:support@wordcamp.org\">support@wordcamp.org</a> if you have any questions. We are happy to help you in the best way possible.</p>\n\n\n\n<p><em>Thanks to <a href=\'https://profiles.wordpress.org/anjanavasan/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>anjanavasan</a> <a href=\'https://profiles.wordpress.org/eidolonnight/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>eidolonnight</a> <a href=\'https://profiles.wordpress.org/rmartinezduque/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>rmartinezduque</a> for their work on this post. The featured image was created by <a href=\'https://profiles.wordpress.org/beafialho/\' class=\'mention\'><span class=\'mentions-prefix\'>@</span>beafialho</a></em>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"11567\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:32:\"https://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:4:\"site\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"14607090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 07 Mar 2022 22:50:14 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:6:\"x-olaf\";s:3:\"⛄\";s:13:\"last-modified\";s:29:\"Fri, 04 Mar 2022 22:25:42 GMT\";s:4:\"link\";s:63:\"<https://wordpress.org/news/wp-json/>; rel=\"https://api.w.org/\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 2\";}}s:5:\"build\";s:14:\"20220307224835\";}", "no");
INSERT INTO `wp_options` VALUES("224", "_transient_timeout_feed_mod_9bbd59226dc36b9b26cd43f15694c5c3", "1646736614", "no");
INSERT INTO `wp_options` VALUES("225", "_transient_feed_mod_9bbd59226dc36b9b26cd43f15694c5c3", "1646693414", "no");
INSERT INTO `wp_options` VALUES("226", "_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "1646736614", "no");
INSERT INTO `wp_options` VALUES("227", "_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Post Status: Post Status Excerpt (No. 49) — Performance Team Check-in\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=93886\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://poststatus.com/post-status-excerpt-no-49-performance-team-checkin/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4341:\"<h2 id=\"site-owners-shouldn-t-be-doing-performance-for-the-sake-of-performance-but-for-their-own-success-on-the-web-thierry-muller\">&#8220;Site owners shouldn\'t be doing performance for the sake of performance but for their own success on the web.&#8221; —Thierry Muller</h2>\n\n\n\n<p class=\"has-drop-cap\">In this episode of Post Status Excerpt, David decides it\'s a good time to check in on the newly formed WordPress Performance Team with <strong>Felix Arntz</strong> and <strong>Thierry Muller</strong>. They talk about the things the Performance Team targeted first (and why), backward compatibility, and what other CMSes (beyond WordPress) do a good job with performance. Find out how all of us in the WordPress community can support the performance team.</p>\n\n\n\n<p><strong>Why This is Important:</strong> Performance is an often-discussed topic when it comes to WordPress. The diversity of the plugin ecosystem brings unique performance challenges with it. WordPress core itself needs to remain competitive, if not lead, in performance.&nbsp;</p>\n\n\n\n\n\n\n\n<p class=\"has-background\">Every week <strong><a href=\"https://poststatus.com/podcast/the-excerpt/\">Post Status Excerpt</a></strong> will brief you on important WordPress news — in about 25 minutes or less! Learn what\'s new in WordPress in a flash. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/26a1.png\" alt=\"⚡\" class=\"wp-smiley\" /><br /><br />You can listen to <a href=\"https://poststatus.com/podcast/the-excerpt/\">past episodes</a> of <strong>The Excerpt</strong>, <a href=\"https://poststatus.com/category/post-status-podcasts/\">browse all our podcasts</a>, and don’t forget to subscribe on <a href=\"https://open.spotify.com/show/1m3xwXbe0MG5BzFVPtB0A7\">Spotify</a>, Amazon Music, <a href=\"https://podcasts.google.com/feed/aHR0cHM6Ly9mZWVkcy5zaW1wbGVjYXN0LmNvbS8ySkU5c2M4UA\">Google Podcasts</a>, <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">iTunes</a>, <a href=\"https://castro.fm/podcast/c53552c6-1ee0-4fc4-9de4-08ed6bf1ee4d\">Castro</a>, <a href=\"https://www.youtube.com/c/PostStatus\">YouTube</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, <a href=\"https://player.fm/series/wordpress-post-status-podcasts\">Player.fm</a>, <a href=\"https://pca.st/05rR\">Pocket Casts</a>, <a href=\"https://wordpress-post-status-draft-podcast.simplecast.com/\">Simplecast</a>, or by <a href=\"https://feeds.simplecast.com/2JE9sc8P\">RSS</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f3a7.png\" alt=\"🎧\" class=\"wp-smiley\" /></p>\n\n\n\n<h3 id=\"h-mentioned-in-the-show\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f517.png\" alt=\"🔗\" class=\"wp-smiley\" /> Mentioned in the show:</h3>\n\n\n\n<ul><li><a href=\"https://wordpress.slack.com/archives/performance\">Slack channel</a> (meetings are on Tuesdays 16:00 UTC)</li><li><a href=\"https://make.wordpress.org/core/tag/performance/\" target=\"_blank\" rel=\"noreferrer noopener\">make.wordpress.org/core/tag/performance</a></li><li><a href=\"https://github.com/WordPress/performance\">Performance Plugin In Progress</a> </li><li><a href=\"https://twitter.com/felixarntz\">Thierry Muller</a> (Twitter)</li><li><a href=\"https://twitter.com/felixarntz\">Felix Arniz</a> (Twitter)</li><li><a href=\"https://twitter.com/dimensionmedia\" target=\"_blank\" rel=\"noreferrer noopener\">David Bisset</a> (Twitter)</li><li><a href=\"https://twitter.com/post_status\" target=\"_blank\" rel=\"noreferrer noopener\">Post Status</a> (Twitter)</li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h3 id=\"sponsor-pagely\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f64f.png\" alt=\"🙏\" class=\"wp-smiley\" /> Sponsor: <a href=\"http://poststatus.com/godaddy\">Pagely</a></h3>\n\n\n\n<p>Top-Tier Managed WordPress hosting solutions for <strong>Enterprise</strong>, the<strong> Public Sector</strong>, and <strong>Media</strong> companies. We invented Managed WordPress and we never stopped raising the bar. Expect Extraordinary.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"h-transcript-coming-soon\"><strong>Transcript</strong>: Coming Soon</h2>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 07 Mar 2022 21:30:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"Gutenberg Times: Introducing the Museum of Block Art (MOBA)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://gutenbergtimes.com/?p=20583\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://gutenbergtimes.com/introducing-the-museum-of-block-art-moba/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3575:\"<p><strong>Introducing the Museum of Block Art</strong></p>\n\n\n\n<p>Introducing the <a href=\"https://block-museum.com/\" target=\"_blank\" rel=\"noreferrer noopener\">Museum of Block Art</a> (MOBA), a new project from WordPress community members that seeks to inspire creativity and push the limits around what can be done with WordPress.&nbsp;</p>\n\n\n\n<div></div>\n\n\n\n<div><a href=\"https://block-museum.com/\" target=\"_blank\" rel=\"noopener noreferrer\" class=\"gb-button gb-button-shape-rounded gb-button-size-medium\">Explore the Museum</a></div>\n\n\n\n<div></div>\n\n\n\n<p>All of the art curated here is built using the block editor thanks to design tools that have come over the last few releases from border support to gradients and more. Here’s just a peek of some of the pieces of art below:&nbsp;</p>\n\n\n\n\n<a href=\"https://i0.wp.com/gutenbergtimes.com/wp-content/uploads/2022/03/city-textures-scaled-1.jpeg?ssl=1\"><img /></a>\n\n\n\n<a href=\"https://i0.wp.com/gutenbergtimes.com/wp-content/uploads/2022/03/image-13.png?ssl=1\"><img /></a>\n\n\n\n<a href=\"https://i0.wp.com/gutenbergtimes.com/wp-content/uploads/2022/03/Screen-Shot-2022-01-26-at-4.31.15-PM.png?ssl=1\"><img /></a>\n\n\n\n\n<p>The Museum of Block Art’s mission is to show just how far you can go with WordPress these days. Each featured creation is made using just the block editor, mostly without any custom CSS.&nbsp;</p>\n\n\n\n<p><a href=\"https://block-museum.com/how/\" target=\"_blank\" rel=\"noreferrer noopener\">Wondering how it’s all done?</a>&nbsp;Just click on the art piece that has captured your attention and you’ll see the markup used along with the “raw materials” in the form of blocks. The site itself is designed and built by Beatriz Fialho, Product Designer at Automattic, using the latest and greatest with a block theme and full site editing features.&nbsp;</p>\n\n\n\n<p><strong>Community Innovated and Inspired</strong></p>\n\n\n\n<p>After a <a href=\"https://make.wordpress.org/test/2021/10/20/hallway-hangout-5-9-go-no-go-site-editor-ia-and-more/\" target=\"_blank\" rel=\"noreferrer noopener\">hallway hangout a few months ago</a> with folks from the community, I <a href=\"https://youtu.be/Ep7mcBaeCsI?t=497\" target=\"_blank\" rel=\"noreferrer noopener\">found myself exclaiming out of excitement</a> “we have to do an art museum” after seeing some neat patterns from <a href=\"https://twitter.com/karmatosed\" target=\"_blank\" rel=\"noreferrer noopener\">Tammie Lister</a>, Senior Product Designer at XWP. Unable to get this idea out of my head, I jotted it down into the notes and started to consider how to bring the idea to life, especially as WordPress continued to add even more options for design.</p>\n\n\n\n<img src=\"https://lh5.googleusercontent.com/Ae1p7_gptlUglopq_VveJGOJw3yiEqaZwBPeyZUGgSEc6iZUtpwiJeBXxDsSY_aIyv14U7ASgg1BRZUWkog0Yb6vrbZy96ljAF7XESjXPXZgI0bjbkIt-SFnAaI9yQwKSUsA9kAK\" alt=\"\" />\n\n\n\n<p>It was the same feeling I have when visiting museums where, after being so inspired by what I see, I find myself picking up my camera with new vigor to capture the world creatively. Fast forward to today and a community of folks have come together to make this a reality from all over the world. If you’re like me and find yourself inspired to create your own art, share what you’ve made using the hashtag #WPBlockArt.&nbsp;</p>\n\n\n\n<p>This was a true “teamwork makes the dream work” project with folks so thank you to Tammie Lister, Beatriz Fialho, Allan Cole, Rich Tabor, Nick Hamze, Brian Gardner, Javier Arce, Mel Choyce-Dwan, Channing Ritter, and Francisco Vera for each of your contributions.&nbsp;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 07 Mar 2022 15:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Anne McCarthy\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"Gutenberg Times: Gutenberg Changelog #62 – Gutenberg 12.7, a New Call for Testing, the Web Fonts API Arrival\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://gutenbergtimes.com/?post_type=podcast&p=20636\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"https://gutenbergtimes.com/podcast/gutenberg-changelog-62-gutenberg-12-7-a-new-call-for-testing-the-web-fonts-api-arrival/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:27498:\"<p>In this episode, Birgit Pauli-Haack and Mary Job discuss Gutenberg 12.7, a new call for testing and the web fonts API arrival.</p>\n\n\n\n<ul><li>Music:&nbsp;<a href=\"https://soundcloud.com/xirclebox\">Homer Gaines</a></li><li>Editor:&nbsp;<a href=\"https://www.linkedin.com/in/sandy-reed/\">Sandy Reed</a></li><li>Logo:&nbsp;<a href=\"https://markuraine.com/\">Mark Uraine</a></li><li>Production:&nbsp;<a href=\"https://icodeforapurpose.com\">Birgit Pauli-Haack</a></li></ul>\n\n\n\n<span id=\"more-20636\"></span>\n\n\n\n<p><a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-61-universal-blocks#shownotes\">Show Notes </a>/ <a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-61-universal-blocks#transcript\">Transcript</a></p>\n\n\n\n<p><strong>Subscribe to the&nbsp;<a href=\"https://gutenbergtimes.com/podcast/\">Gutenberg Changelog</a>&nbsp;podcast via your favorite podcast apps!</strong><br />🎙️&nbsp;<a href=\"https://open.spotify.com/show/620NwVKQJGdTupy36zYxvg?mc_cid=4b6c9f88fe\">Spotify</a>&nbsp;|&nbsp;<a href=\"https://podcasts.google.com/feed/aHR0cHM6Ly9ndXRlbmJlcmd0aW1lcy5jb20vZmVlZC9wb2RjYXN0\">Google</a>&nbsp;|&nbsp;<a href=\"https://podcasts.apple.com/us/podcast/gutenberg-changelog/id1469294475\">iTunes</a>&nbsp;|&nbsp;<a href=\"https://pca.st/podcast/f8445ec0-7508-0137-f267-1d245fc5f9cf\">PocketCasts</a>&nbsp;|&nbsp;<a href=\"https://www.stitcher.com/show/gutenberg-changelog\">Stitcher</a>&nbsp;|<br />🎙️&nbsp;<a href=\"https://www.podbean.com/podcast-detail/chi7j-9904a/Gutenberg-Changelog-Podcast\">Pod Bean</a>&nbsp;|&nbsp;<a href=\"https://castbox.fm/channel/Gutenberg-Changelog-id2173375\">CastBox</a>&nbsp;|&nbsp;<a href=\"https://www.podchaser.com/podcasts/gutenberg-changelog-878239/\">Podchaser</a>&nbsp;|&nbsp;<a href=\"https://gutenbergtimes.com/feed/podcast\">RSS Feed</a>&nbsp;</p>\n\n\n\n<p class=\"has-large-font-size\" id=\"shownotes\"><strong>Show Notes </strong></p>\n\n\n\n<p><a href=\"https://make.wordpress.org/test/2022/02/23/fse-program-testing-call-12-hyping-headers/\">FSE Program Testing Call #12: Hyping Headers</a></p>\n\n\n\n<h2><strong>Gutenberg Developer Hours in March</strong></h2>\n\n\n\n<ul><li><a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\">March 8th, 2022 at 16:00 UTC</a> with Tammie Lister, Fabian Kägy and Grzegors Ziolkowski</li><li><a href=\"https://www.meetup.com/wordpress-social-learning/events/284434154/\">March 22, 2022 at 16:00 UTC</a></li></ul>\n\n\n\n<p><a href=\"https://make.wordpress.org/core/2022/03/03/core-editor-improvement-choose-your-style/\">Core Editor Improvement: Choose your Style</a></p>\n\n\n\n<h2>Gutenberg 12.7</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\">What’s new in Gutenberg 12.7? (2 March)</a></li><li><a href=\"https://wptavern.com/gutenberg-12-7-adds-multi-block-selection-in-list-view-and-brings-margin-support-to-group-blocks\">Gutenberg 12.7 Adds Multi-Block Selection in List View and Brings Margin Support to Group Blocks</a></li></ul>\n\n\n\n<h2>Web Fonts API</h2>\n\n\n\n<ul><li><a href=\"https://wptavern.com/the-wordpress-web-fonts-api-has-arrived\">The WordPress Web Fonts API Has Arrived</a></li><li><a href=\"https://github.com/WordPress/gutenberg/pull/37140\">Web fonts API PR by Ari Statopholus</a></li><li><a href=\"https://make.wordpress.org/core/2021/09/28/implementing-a-webfonts-api-in-wordpress-core/\">Implementing a Web fonts API in WordPress Core</a></li></ul>\n\n\n\n<p class=\"has-large-font-size\">Stay in Touch</p>\n\n\n\n<div class=\"wp-container-1 wp-block-group\"><div class=\"wp-block-group__inner-container\">\n<ul><li>Did you like this episode? <a href=\"https://lovethepodcast.com/gutenbergchangelog\"><strong>Please write us a review </strong></a></li><li>Ping us on Twitter or send DMs with questions. <a href=\"https://twitter.com/maryojob\">@maryojob </a>and <a href=\"https://twitter.com/bph\">@bph</a>.</li><li><em>If you have questions or suggestions, or news you want us to include, send them to <a href=\"mailto:changelog@gutenbergtimes.com\">changelog@gutenbergtimes.com</a>. </em></li><li><em>Please write us a review on iTunes! <a href=\"https://gutenbergtimes.com/itunes/\">(Click here to learn how)</a></em></li></ul>\n</div></div>\n\n\n\n<p class=\"transcript has-large-font-size\"><strong>Transcript</strong></p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Hello, and welcome to our 62nd episode of the Gutenberg Changelog podcast. In today&#8217;s episode, we will discuss Gutenberg 12.7 release, the new call for testing and the web fonts API arrived. I&#8217;m Birgit Pauli-Haack, curator at the Gutenberg Times and WordPress developer advocate, and I&#8217;m here with my co-host Mary Job, WordPress advocate and support engineer at Paid Memberships Pro. Good afternoon, Mary. How are you doing today? Well, it&#8217;s actually good evening.</p>\n\n\n\n<p><em>Mary Job</em>: Yes, it&#8217;s actually good evening. It&#8217;s 7:30 PM right now over here in Nigeria. I am doing great, thank you very much, Birgit. This is officially my first show with you alone without Greg so I&#8217;m looking forward to this today.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: And I hope we have all the technical issues that we seemed to have for the last episode of it, figured out. And I apologize that we didn&#8217;t get it sooner. So, Mary Job now that you are here and be on this journey with me, you have such a big influence on WordPress, and I hope that you can tell listeners more about you so they get to know you a little bit more. So first of all, where do you live and what do you do for a living?</p>\n\n\n\n<p><em>Mary Job</em>: Okay, awesome. So I live in the Southwestern part of Nigeria. It&#8217;s called Ijebu. It&#8217;s about an hour drive from Lagos if there&#8217;s no traffic. Of course if there&#8217;s traffic it might be three hours or four hours. I currently work with Paid Memberships Pro. It&#8217;s a membership plugin software, for WordPress, of course. And what else do I do? In my spare time I contribute to the community and I run a village where we teach young girls and women how to use computers and the internet and empower themselves. But lately we&#8217;re focusing on WordPress. That&#8217;s a little bit about me.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, that&#8217;s awesome. It kind of reminds me of when I started out working on digital literacy and internet and teaching people things, what they do and then also got into WordPress. So it seems to be, you&#8217;re the community organizer that I am per heart as well. So I&#8217;m so glad that we can do this together. So do you have family? I know you have a daughter.</p>\n\n\n\n<p><em>Mary Job</em>: Ah, yes. I have one daughter and I have family. I&#8217;m a single mom, so I would say that we&#8217;re a family of two. That&#8217;s what I always say. She&#8217;s going to be 12. She can&#8217;t wait to be a teenager according to her, so good luck to me on that.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: All right. Well, thank you so much. How deep are you in working with Gutenberg on your websites and on your writing on blog posts, or are you Paid Membership Pro?</p>\n\n\n\n<p><em>Mary Job</em>: So I have been using Gutenberg since it came out but I&#8217;m just diving deep into full site editing. The first time I did encounter full site editing, I was a little bit confused to be honest. I was like, okay, so what am I. Because the customizer was also going like, okay, what am I doing? This is going to take more time to get used to learn how to use. So we&#8217;re going to see how that goes. I&#8217;m going to be sharing my findings in future episodes.</p>\n\n\n\n<p>Birgit Pauli-Haack: Excellent. Excellent.&nbsp;</p>\n\n\n\n<h3><strong>Announcements</strong></h3>\n\n\n\n<p>Well, thank you for mentioning the full site editing program. Brings us right into our next topic is that Anne McCarthy has published a new call for testing out of the FSE, the full site editing program, and it&#8217;s called hyping headers. And it leads you through the revisiting of common workflows and you&#8217;re testing all the new tools to customize a header, including the navigation block and template parts, focus mode, and personalized header for different templates.</p>\n\n\n\n<p>So there are some great instructions not only to test things, but this participating in that is definitely a good way to learn about FSE and the little details about it. So you get the testing environment set up and then testing instructions, and then Anne walks you through different tasks to accomplish. And then ask you a few questions. Like, did the experience crash at some point, did you find features missing? Did you especially enjoy or appreciate some of the experience and did it work using a keyboard only? Did it work using her screen reader? And the feedback deadline for that is March 16th. That&#8217;s about 12 days out. And then she will relay all your feedback to the developers.</p>\n\n\n\n<p>So if you want to participate in it, we&#8217;ll have definitely the link in the show notes, or you go to make.wordpress.org/test. That is the second post on that, or just search for hyping headers with Anne McCarthy. The call for testing is also available in Italian, if it&#8217;s easier for you to participate in that within your own language, that link will also be shared in the show notes. So I think that will be a good way to start your own experience, Mary, to kind of follow through there. It&#8217;s also some guided so you don&#8217;t have to think, okay, what do I want to do now?</p>\n\n\n\n<p><em>Mary Job</em>: Right, I totally agree with you. It&#8217;s a good way to start, because there are steps to follow. Literally just have to follow the steps and of course note the results.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Note the results and then, you were breaking up.</p>\n\n\n\n<p><em>Mary Job</em>: Yes, I said it&#8217;s important to participate, because there are steps to follow. So it&#8217;s pretty straightforward for somebody who wants to participate, just have to follow the instructions and then note the results of your test and then share that with everyone to see.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: And there were actually some, I don&#8217;t know if they do it for this call, but sometimes the GoDaddy Pro people around Courtney Robinson. They are also doing sometimes Google and Hangouts where they walk through the call for testing with a group of people. So people can follow along. Once we know about that, we will certainly have it in the weekend edition of the Gutenburg times. So another point I wanted to make is we are in March and we have two more Gutenburg, developer hours. Coming up one is on March 8th at 11:00 AM, Eastern 1600 UTC and on March 22nd at the same time. And that will then conclude the four-event trial for the Gutenburg developer hours. And then we will recap retrospect the events and see what we can do for.</p>\n\n\n\n<p>We will go to extend the offering through the WordPress social learning spaces to also have Asia Pacific good times for the developer hours, and also maybe have different dates and days throughout the month where those, when those good work developer hours happen.&nbsp;</p>\n\n\n\n<h3><strong>What’s Released &#8211; Gutenberg 12.7</strong></h3>\n\n\n\n<p>Yeah, that is that. Now Gutenberg 12.7 was released this week, and there we will have in the show notes, the release notes from the make blog, as well as a link to the WP Tavern post. But before I go in there, there&#8217;s also a core editor improvement post on the make core blog about choosing your style, choosing a style that is a new feature in a good plugin, where you can have a selection of styles from your theme that changes the whole theme. The default theme, Twenty Twenty, allows that already. So you could, as a theme developer have two theme JS on files offering to your users and then styles, it has a new menu items as other styles.</p>\n\n\n\n<p>And then you can switch between a, for instance, a black or white background with everything else changing as well, or as some of the demos for the 5.9 release showed was that you are all of the sudden have a more blue leaning Twenty Twenty Two theme or a more Red leaning. So there are some, a big improvements there, but also big new challenges and options for theme developers and on the core make blog, there&#8217;s a now called Tuesday styles. That gets you a little bit more information about that. All right. So now we get into what&#8217;s new in good book, 12.7, it was released on Wednesday, March 2nd, and it starts with enhancements.&nbsp;</p>\n\n\n\n<h3><strong>Enhancements</strong></h3>\n\n\n\n<p>So the enhancements people will have long waited for it that the columns block has now border support. And it shows up when you select the column block in the sidebar, you will be able to set borders, border radios, border colors or border strength. That is certainly something a lot of people have been waiting for is also something that quite a few block tools, additional plugins have provided for a long time. And now it&#8217;s actually in core. Yay.</p>\n\n\n\n<p><em>Mary Job</em>: Yeah. The group blocks also have margin support added to the top and bottom. So that&#8217;s also a good one.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: You have now more control when you, on the margins there were always quite presets or defaults from the core block, but that you didn&#8217;t have as a user control over how big that was, you needed to get the, to CSS code to actually change it. So this is now in your hands.</p>\n\n\n\n<p><em>Mary Job</em>: Yes.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: OK. The list for you has gotten a new enhancement and now you can have multi-select behavior for blocks. And when the shift key is selected, so you can select one block and the other block and then move them together for instance, or show them together. So there are quite a few additional we are handling. We are, there are just quality of life, so to speak enhancements. So this is definitely one for a power user. So the quick inserter has changed now a little bit, and it&#8217;s prioritizing patterns instead of blocks that when they&#8217;re available in the context of your semantic handling, I think it is, that was the one if you are looking for, and that is in the template editor or the site editor, not so much in the post editor.</p>\n\n\n\n<p>And it&#8217;s part of the pattern and enhancements that we also get in other places you also show existing template parts, and the list of block patterns in the creation flow. That&#8217;s in the four template parts. So if you are editing a header, you also get in the inserter header patterns that come either with core or with the theme that you are using. So that&#8217;s definitely improvement and an enhancement for all those site building editors.</p>\n\n\n\n<p><em>Mary Job</em>: Yeah. That saves you from having to search, because I know previously have to search most times I have to open the entire blocks and pattern and just be able to pick the one that I want for the team or for the pluggin that I&#8217;m working with.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Exactly. Yeah you pass by all the other blocks and patterns until you find the one that is it&#8217;s much easier now to find things that you need.&nbsp;</p>\n\n\n\n<p>So the next part is the initial version of the style engine. There has been quite a few discussions around and I will mention one specifically, but the team is working on a unified kind of style engine to solve a few inconsistencies and to help theme developers to work with the CSS variables that come with the styles and also how to add their own styles without having to revamp it every time a new plugin comes out. And that is now possible because the post editor is fixed and the style editor and the site editor or template editor either way are now much more finalized. So now all the things that have changed in the last three years are now kind of settled.</p>\n\n\n\n<p>And the solutions that were provided can now be kind of consolidated and standardized. And Mark Ru Wiley also has a proposal in the Gutenberg issues where he tackles that topic quite a bit and has a few suggestions on how to solve some of the issues. He also has a very good list of what the issues pain points actually are. So he defines the problem quite nicely and comprehensively. So it&#8217;s definitely worth a read for the same developers that are trying to get the head around full site editing with the block editor. And so that&#8217;s just as a side note, you will find the links all in the show note, I think we mentioned it also briefly in our last episode, in the 61 episode. So there is now a with this versioin, now also an initial work in progress of the styling part.</p>\n\n\n\n<p>Part of it is also the lowering, the specificity of alignment rules for supporting layouts to wide alignment. There was this catch 22, that if you wanted to have wider aligned blocks, like a cover block or a gallery block or full aligned, you needed to get to the edges of the browser. But if you don&#8217;t want the text answer, go to the end of the browser, you needed to have a margin on that. So it was kind of a catch 22 that you couldn&#8217;t use the wide alignment or the full alignment when you wanted to also have borders there. So there is a solution there, if it&#8217;s working for your theme, you&#8217;ll find out. And then speaking of themes, this release removes data alignment for the themes, its a port layout. So you might need to update your theme to adhere to that. And it&#8217;s also remove div wrappers for the aligned image blocks. So that will certainly also interrupt some of the themes when you are using it. But it&#8217;s a very simple adjustment, but I need to go through that. Mary, do you want to take the next one?</p>\n\n\n\n<p><em>Mary Job</em>: Yes. The patterns registration from directory with theme.json is not allowed. So want to write up on that, but those who are building patterns and teams, and then there&#8217;s also the list view. You can now expand block list three on selection.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah the expanding and collapsing of list three is really helpful when you have a long post or template that you need to organize there. Yeah. So let me go back to the allow pattern registration from directory, with the theme.json. So you can now I&#8217;ll put black pattern registration in a sub directory of your theme. And then in theme, Jason, you can link to those patterns through a setting to that directory. The team is also working on a method to actually include patterns from the WordPress directory and have them, that is that? Okay, sorry. So you use the slug from the pattern in the WordPress directory and add it to your theme.json. So it will be shown in your theme for the inserter as well. So that&#8217;s good. All right. That concludes all the enhancements.</p>\n\n\n\n<p>There were quite a few others that we kind of skipped over it, but because there were a little minor or hard to explain there, but the bug fixes are coming and coming, coming bug fixes.&nbsp;</p>\n\n\n\n<h3><strong>Bug Fixes</strong></h3>\n\n\n\n<p>So every release has 20 to 40 bug fixes. And that is really cool how the community kind of reports bug fixes and the get up issues, and then the team to take them on and fix all the things that are, are not working just right, like the latest post block had a missing class for the Post title. So it was very hard for a theme to actually target the Post title for the block that has now been solved. Also the query block got a bug fix noting that when you only want to see sticky post, that nothing will be displayed. If there are no sticky posts. So there was some quirkiness there, but now it&#8217;s solved. The global style duo tone rendering was missing in the post editor.</p>\n\n\n\n<p>And that seems to be a backport that will go into the next minor release of the WordPress core. So that is fixed and onset core. Earlier so you don&#8217;t have to wait to 6.0 to come out. All right.&nbsp;</p>\n\n\n\n<h3><strong>Accessibility</strong></h3>\n\n\n\n<p>That brings us to accessibility updates that are together with a search button. Also the duplication labels for safe draft or saved as pending buttons have been avoided now. And then there is the rich text. There was a change in the rich text component, and that was reversed because it had an area multiline states, which of course doesn&#8217;t work that well. And then the tree grid for at home and end keys and up and to jump to the start and the end of the grid. So that&#8217;s really helpful for keyboard navigation. All right, this Gutenberg plugin also brings us new APIs to handle core data like post data or other records from custom post types, one meta tag, and it proposes two new experiments.</p>\n\n\n\n<h3><strong>PRs</strong></h3>\n\n\n\n<p>One is the use entity records proposal, and then an experimental usage of that, which is a hook that you can use to handle data. And PRS actually have some example quote that you can use. And also what&#8217;s in and out of the scope of this PR. And so that is definitely neat. Your testing, now when you open up the Gutenberg plugin, there&#8217;s in the menu, in the WP admin, there is a sections called experiment. That&#8217;s previously where the navigation block and the patterns and other things that were in experiments and have now been released. Now, the newer experiments is all about the data. So you can have an easier way to use the core data store.</p>\n\n\n\n<p>And structure it&#8217;s definitely very developer centric, of course, and there are other considerations. So the experiments and the PRs have all the discussions in there, and it might be really helpful for community developers like agency developers or plugin developers to take a look at that and see what would be a way to solve these, or is there a need of any changes Adam Selinsky has done the experimental work there, the pioneer work to have the entity record hooks in there. So check it out. It&#8217;s a new API.&nbsp;</p>\n\n\n\n<h3><strong>Documentation</strong></h3>\n\n\n\n<p>And of course the documentation has changed. Some of the handbook includes now all the additional information about the pattern fields for the theme.json also the contextual patterns and pattern transformations and the semantic pattern documentation. So there is definitely some reading materials for you over the weekend. So there&#8217;s one, if you are a developer who also wants to contribute in creating releases, there&#8217;s a new NPM package available now to automate the cherry picking to WordPress trunk commits during publishing. So there are some hiccups that were before that were manually solved are now automated. So that&#8217;s, this part also gets easier and easier.</p>\n\n\n\n<p>Okay. And I like that the release notes always also show now the first time contributors thank you for making the jump to contribute to WordPress Gutenberg, to the Gutenberg repo and Dave Smith. Also now solved has written the script to add all contributors to the end of the GitHub release notes for each Gutenberg plugin. So that&#8217;s also great. So people get recognition beyond the GitHub repo. So it&#8217;s in the WordPress make blog as well. All right. Anything else that stands out for you, Mary from this release?</p>\n\n\n\n<p><em>Mary Job</em>: No, not at all.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Not at all. Good. So we covered everything that is good. I&#8217;m really excited about the multi block selection, the list view, and then margins reports for the group, of course, and the block transformation now retains classes. That&#8217;s certainly something and you can register patterns from the directory. So there are quite a few new features in there that make working with it much easier.&nbsp;</p>\n\n\n\n<h3><strong>What’s in Active Development or Discussed</strong></h3>\n\n\n\n<p>So Justin, so now can we come to the section of what&#8217;s discussed and Justin Tadlock from the WebPress from the WP Tavern has found that the word web funds API has finally arrived and historically it was punted from the WebPress 5.9 release just because it didn&#8217;t seem ready and needed a little bit more testing through a good more plugin releases instead of going right into 5.9. That&#8217;s the way to add web fonts to your web install and have a standardized API to do that.</p>\n\n\n\n<p>So not every plugin and every theme and every yeah, loads, additional web fonts, it all goes through this API and there is no duplication of that. And now you can also, it does not have a theme.json support yet, but that is right now, it&#8217;s only available through PHP. So you definitely need to look at that beforehand, for your theme, Aris Stratus, one of the developers, the initial road about the privacy issues that are there because Germany and some other countries are it&#8217;s about the Google font providers or providing Google fonts in, through a CDN that has some privacy issues there. And now it looks like that local fonts are officially supported, but theme and plugin authors must register the custom providers. So it&#8217;s getting, getting complicated. That&#8217;s a standardized API is really, really helpful for. So there are some privacy issues with the web funds from certain providers.</p>\n\n\n\n<p>The pull request has PHP examples somehow to do that, the theme.json keys and values are corresponding with the font phase rules and Justin Tadlock looked did a great job in putting all the details together in one post. So you don&#8217;t have to read through the make blog posts to find all the different details about it. And I&#8217;m sure the documentation team is working on that right now. You cannot do this now with 12.7, it&#8217;s slated for 12.8, or you can use the good work nightly from the good work times. Gutenburg nightly plugin that is always created from trunk. So it has the newest merged PRs in it. Yeah.&nbsp;</p>\n\n\n\n<p>That brings us to the end of this good book change log. It&#8217;s a little shorter today and that&#8217;s sometimes a relief anyway for our listeners. And before the end of the show, I just wanted to remind everyone, March 8th and March 22nd, or the Gutenburg developer hours. And there is a call for testing called hyping headers. The number 12 call for testing for the full site editing program. Do you have anything that you want the people to know Mary?</p>\n\n\n\n<p><em>Mary Job</em>: No, not yet.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Okay. So you survived the first episode.</p>\n\n\n\n<p><em>Mary Job</em>: Yes. I feel like I have a lot to learn.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, you also know a lot. And so as always, the show notes will be published on gutenburgtimes.com/podcast. gutenburgtimes.com/podcast. And this is number 62. And if you have questions or suggestions or news you want us to include, then send them to <a href=\"mailto:changelog@gutenbergtimes.com\">changelog@gutenbergtimes.com</a> that&#8217;s <a href=\"mailto:changelog@gutenbergtimes.com\">changelog@gutenbergtimes.com</a>. Email address, or just ping me or Mary on Twitter, private chat, or even on the public chat. So thank you, Mary, for being with me today and making the show with me and thank you all for listening. And I&#8217;ll talk to you in two weeks.</p>\n\n\n\n<p><em>Mary Job</em>: Yes. Thank you. Be thank you everyone for this. And I&#8217;ll see again in two weeks.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: All right. Take care. Bye bye.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 06 Mar 2022 01:18:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Birgit Pauli-Haack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"Gutenberg Times: Block Editor: Kid tested, – Custom posts and FSE and Gutenberg 12.7 – Weekend edition #205\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://gutenbergtimes.com/?p=20608\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"https://gutenbergtimes.com/block-editor-kid-tested-custom-posts-and-fse-and-gutenberg-12-7-weekend-edition-205/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14232:\"<p>Howdy, </p>\n\n\n\n<p>It&#8217;s astonishing how the WordPress community comes together to support people in need and despair. You do what you can with the means you have. The article by Sarah Gooding <a href=\"https://wptavern.com/how-the-wordpress-community-is-supporting-ukraines-resistance-against-russian-invasion\">lists many initiatives you can support to help people in Ukraine and its refugees.</a> Don&#8217;t overlook the comments either. </p>\n\n\n\n<p>I hope you can pull yourself away from the doom scrolling on Twitter and other sites, and distract yourself from the horrifying updates by reading through this newsletter. There is also wonderful work being done on Gutenberg and the block editor. And don&#8217;t forget to check out the upcoming events in WordPress Social Learning Space below.  </p>\n\n\n\n<p>Yours, 💕<br />Birgit</p>\n\n\n\n<p>PS: If you are a developer, I hope to see you at the <a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\">next Gutenberg Developer Hours on March 8th 11:00 ET / 16:00 UTC</a> withe fabulous Tammie Lister, Fabian Kägy, and Grzegorz Ziolkowski as expert panelists. </p>\n\n\n\n<a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\"><img /></a>\n\n\n\n<div class=\"wp-container-3 wp-block-group\"><div class=\"wp-block-group__inner-container\">\n\n<div class=\"wp-container-2 wp-block-group has-light-background-background-color has-background\"><div class=\"wp-block-group__inner-container\">\n<p><strong>Table of Contents</strong></p>\n\n\n\n<div class=\"wp-block-sortabrilliant-guidepost\"><ul><li><a href=\"https://gutenbergtimes.com/feed/#0-g\">Gutenberg 12.7 release</a></li><li><a href=\"https://gutenbergtimes.com/feed/#0-block-editor-for-content-creators-and-nocode-site-builders\">Block Editor for content creators and #nocode site builders</a><ul><li><a href=\"https://gutenbergtimes.com/feed/#1-ht\">53 Block Themes in WordPress Directory</a></li></ul></li><li><a href=\"https://gutenbergtimes.com/feed/#1-b\">Block and Theme Building</a></li><li><a href=\"https://gutenbergtimes.com/feed/#3-word-press-social-learning-events\">WordPress Social Learning Events</a></li></ul></div>\n</div></div>\n\n</div></div>\n\n\n\n<h2 id=\"0-g\">Gutenberg 12.7 release</h2>\n\n\n\n<p><strong>Carlos Bravo</strong> spearheaded the plugin release and in his notes <a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\"><strong>What’s new in Gutenberg 12.7? (2 March)</strong></a> he highlighted: </p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/#improving-the-patterns-experience\">Improving the Patterns experience</a></li><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/#list-view-improvements\">List View Improvements</a></li><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/#changes-to-frontend-html-when-using-layouts-and-image-blocks\">Changes to frontend HTML when using layouts and image blocks</a></li></ul>\n\n\n\n<p>There are also some change to data-align and div tags from blocks that might need adjustments from Theme developers (again)</p>\n\n\n\n<p><strong>Justin Tadlock</strong> put it out for a spin <a href=\"https://wptavern.com/gutenberg-12-7-adds-multi-block-selection-in-list-view-and-brings-margin-support-to-group-blocks\">Gutenberg 12.7 Adds Multi-Block Selection in List View and Brings Margin Support to Group Blocks</a></p>\n\n\n\n<div class=\"wp-container-4 wp-block-group has-light-background-background-color has-background\"><div class=\"wp-block-group__inner-container\">\n<p><strong>🎙️ </strong> New episode: <strong><a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-62-gutenberg-12-7-a-new-call-for-testing-the-web-fonts-api-arrival/\">Gutenberg Changelog #62 – Gutenberg 12.7, a New Call for Testing, the Web Fonts API Arrival</a></strong> with co-hosts Birgit Pauli-Haack and Mary Job </p>\n</div></div>\n\n\n\n<h2 id=\"0-block-editor-for-content-creators-and-nocode-site-builders\">Block Editor for content creators and #nocode site builders</h2>\n\n\n\n<p><strong>Eric Karkovack</strong> shared in his interview with <strong>Bob Dunn</strong> on <a href=\"https://dothewoo.io/writer-developer-woocommerce-builder/\"><strong>the Do-the-Woo Podcast</strong></a>, the story of his 12-year-old daughter getting acquainted with WordPress. After a couple of minutes of instructions, the dad was sent away: &#8220;Dad, you can go now. I&#8217;m fine.” When Eric came back an hour later, and she&#8217;s already got it figured out.<em> The Block Editor: Kid Tested</em></p>\n\n\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Earlier this year, Google updated the <a href=\"https://wordpress.org/plugins/material-design/\">Material Design plugin</a>, to enabled <a href=\"https://material.io/blog/material-design-wordpress-plugin-030\"><strong>Using Block Patterns with Material Design for WordPress</strong></a>. It&#8217;s the accompanying plugin with blocks for the <a href=\"https://wordpress.org/themes/material-design-google/\">Material Design Theme</a>, a classic theme. </p>\n\n\n\n<p>In this post, <strong>Eric Karkovack</strong> takes you with him <a href=\"https://speckyboy.com/wordpress-block-pattern-directory/\"><strong>Exploring the WordPress Block Pattern Directory</strong></a>. Learn how do you navigate the directory, how do you preview patterns and how to add them to you website. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n\n<p><strong>&nbsp;<a href=\"https://make.wordpress.org/core/handbook/references/keeping-up-with-gutenberg-index/\" target=\"_blank\" rel=\"noreferrer noopener\">&#8220;Keeping up with Gutenberg &#8211; Index 2022&#8221;</a>&nbsp;</strong><br />A chronological list of the WordPress Make Blog posts from various teams involved in Gutenberg development: Design, Theme Review Team, Core Editor, Core JS, Core CSS, Test, and Meta team from Jan. 2021 on. Updated by yours truly.  <a href=\"https://make.wordpress.org/core/handbook/references/keeping-up-with-gutenberg-index/keeping-up-with-gutenberg-index-2020/\"><em>The index 2020 is here</em></a></p>\n\n\n\n\n<h3 id=\"1-ht\">53 Block Themes in WordPress Directory</h3>\n\n\n\n<p>Today&#8217;s count of Block Themes for Full-site Editing is <strong>53. </strong></p>\n\n\n\n<p>A new theme by Brian Gardner, called <a href=\"https://wordpress.org/themes/avant-garde/\">Avant-Garde</a> is now available in the WordPress repository. &#8220;An experimental block theme for those who love simplicity&#8221;</p>\n\n\n\n<p><a href=\"https://twitter.com/vikasprogrammer\"><strong>Vikas Singhal</strong></a>, builder of themes at  announced the update for their <a href=\"https://wordpress.org/themes/gutena/\"><strong>Gutena Block Theme</strong></a>, with additional block patterns. </p>\n\n\n\n<h2 id=\"1-b\">Block and Theme Building</h2>\n\n\n\n<p>In this week&#8217;s Twitch Stream, Ryan Welcher covered <strong><a href=\"https://www.twitch.tv/videos/1414059025\">Integrating a custom post type into Gutenberg and Full Site Editing</a></strong>.</p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In her post <a href=\"https://make.wordpress.org/core/2022/03/03/core-editor-improvement-choose-your-style/\"><strong>Core Editor Improvement: Choose your Style</strong></a>, <strong>Anne McCarthy</strong> introduces us to the new feature of having multiple set of Global Styles with your theme. Now site owners can switch out color schemes and overall font styles without having to change themes or worry about losing content. McCarthy also shared links to documentation and examples. </p>\n\n\n\n\n<p><strong><a href=\"https://gutenbergtimes.com/need-a-zip-from-master/\">Need a plugin .zip from Gutenberg&#8217;s main (trunk) branch?</a></strong><br />Gutenberg Times provides daily build for testing and review. <br />Have you been using it? Hit reply and let me know.</p>\n\n\n\n<p><img alt=\"GitHub all releases\" src=\"https://img.shields.io/github/downloads/bph/gutenberg/total\" /></p>\n\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Learn how to add a <a href=\"https://www.billerickson.net/color-palette-with-acf-custom-blocks/\"><strong>Color Palette with ACF custom blocks</strong></a> with <strong>Bill Erickson</strong> with code examples and variation for different use cases. &#8220;When registering a new block with&nbsp;<code>acf_register_block_type()</code>, you can use the ‘supports’ array to specify which block editor features this block supports.&#8221; Erickson wrote.</p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Ben Dwyer, theme wrangler on the Themes team,  shared a few <strong><a href=\"https://themeshaper.com/2022/02/28/block-theme-building-tips/\">Block Theme Building Tips</a> </strong>on <em>ThemeShaper.</em> They range from avoiding using CSS, to reusing patterns, and theme.json over block settings. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In her post, <a href=\"https://make.wordpress.org/design/2022/02/28/design-share-feb-14-25/\">WordPress Design Share</a>, <strong>Channing Ritter</strong> shared what the design team has been working on<br />🎛️ Site Editor navigation &#8211;<br />🖼️ Cover block and how to place layers options<br />🔓 User-level Block Locking<br />📒 Documentation and more</p>\n\n\n\n<p>Most is still work in progress and could use your review and input. Check &#8217;em out! </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Jason Bahl, founder and maintainer of WPGraphQL plugin succeeded in <strong><a href=\"https://www.wpgraphql.com/2022/02/17/adding-end-2-end-tests-to-wordpress-plugins-using-wp-env-and-wp-scripts/\">Adding End 2 End Tests to WordPress plugins using wp-env and wp-scripts</a></strong> and shared how he did it. It&#8217;s an in depth look at configuration and execution of e2e testing with WordPress native tools. Bahl also posted an <a href=\"https://www.youtube.com/watch?v=yBBwWSk3kxg\"><em>accompanying video on YouTube </em></a> </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Andrew Serong, published on BuildBetterBlock.com the article <a href=\"https://buildbetterblocks.com/2022/03/03/block-supports-global-styles-and-work-to-consolidate-style-generation-in-gutenberg/\"><strong>Block supports, global styles, and work to consolidate style generation in Gutenberg</strong></a>. It&#8217;s an in-depth look into the Gutenberg codebase and the discussions happening around Styles, themes and user options. Serong has been working actively on the new Style Engine project, and this is a great report on the current stage of the work. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Last year, Helen Hou-Sandí wrote a tutorial on <a href=\"https://helen.blog/2021/02/updating-a-wordpress-plugin-with-a-publish-metabox-field-for-the-block-editor/\"><strong>&#8220;Updating a WordPress plugin with a publish metabox field for the block editor&#8221;</strong></a>. It a great real life use case on adopting development for the block editor one metabox at a time. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<h2 id=\"3-word-press-social-learning-events\">WordPress Social Learning Events</h2>\n\n\n\n<p><br /><strong>March 8, 2022, at 11:00 AM&nbsp;ET / 16:00 UTC</strong><br /><strong><a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\">Gutenberg Developer Hours</a></strong> with Fabian Kägy, Tammie Lister and Grzegorz Ziolkowski </p>\n\n\n\n<p><strong>March 10, 2022 at 10:30 am ET / 15:30 UTC</strong> <br /><strong><a href=\"https://www.meetup.com/wordpress-social-learning/events/284226712/\">Honey, I Broke My Website! What To Do When Site Editing Goes Wrong</a></strong> with Sarah Snow</p>\n\n\n\n<p><strong>March 10, 2022 at 12 pm ET / 17:00 UTC</strong> <br /><a href=\"https://www.meetup.com/wordpress-social-learning/events/284383383/\"><strong>Builder Basics: Designing with Columns, Group, and Row Blocks</strong></a> with Nick Diego</p>\n\n\n\n<p><strong>March 15, 2022 at 9:30 am ET / 14:30 UTC </strong><br /><a href=\"https://www.meetup.com/wordpress-social-learning/events/284252434/\"><strong>Beginner&#8217;s Guide to Full Site Editing </strong></a>with Sarah Snow</p>\n\n\n\n<p><strong>March 22, 2022 at 3 am ET / 8:00  UTC </strong><br /><a href=\"https://www.meetup.com/wordpress-social-learning/events/284320854/\"><strong>Intro to Theme Blocks</strong></a> with Wes Theron</p>\n\n\n\n<p><strong>March 23, 2022 at 1pm ET / 18:00 UTC </strong><br /><a href=\"https://www.meetup.com/wordpress-social-learning/events/284383346/\"><strong>Builder Basics: Exploring Block Layout, Alignment, Dimensions, and Spacing</strong> </a>with Nick Diego </p>\n\n\n\n<p><strong>March 28, 2022 at 11 am ET / 16:00 UTC </strong><br /><strong><a href=\"https://www.meetup.com/wordpress-social-learning/events/284387767/\">Hello Blocks! Coding a custom block</a></strong> with Wes Theron and Ryan Welcher</p>\n\n\n\n<p><strong>March 29, 2022 at 3 pm ET / 20:00 UTC </strong><br /><strong><a href=\"https://www.meetup.com/wordpress-social-learning/events/284252760/\">Beginner&#8217;s Guide to Full Site Editing </a></strong>with Sarah Snow</p>\n\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p class=\"has-text-align-center\"><strong>Don&#8217;t want to miss the next Weekend Edition? </strong></p>\n\n\n\n<form class=\"wp-block-newsletterglue-form ngl-form ngl-portrait\" action=\"https://gutenbergtimes.com/feed/\" method=\"post\"><div class=\"ngl-form-container\"><div class=\"ngl-form-field\"><label class=\"ngl-form-label\" for=\"ngl_email\">Type in your Email address to subscribe.</label><div class=\"ngl-form-input\"><input type=\"email\" class=\"ngl-form-input-text\" name=\"ngl_email\" id=\"ngl_email\" /></div></div><button class=\"ngl-form-button\">Subscribe</button><p class=\"ngl-form-text\">We hate spam, too and won&#8217;t give your email address to anyone except Mailchimp to send out our Weekend Edition</p></div><div class=\"ngl-message-overlay\"><div class=\"ngl-message-svg-wrap\"></div><div class=\"ngl-message-overlay-text\">Thanks for subscribing.</div></div><input type=\"hidden\" name=\"ngl_list_id\" id=\"ngl_list_id\" value=\"26f81bd8ae\" /><input type=\"hidden\" name=\"ngl_double_optin\" id=\"ngl_double_optin\" value=\"yes\" /></form>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 05 Mar 2022 06:26:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Birgit Pauli-Haack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Play the Piano and Other Instruments via the WordPress Block Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130691\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://wptavern.com/play-the-piano-and-other-instruments-via-the-wordpress-block-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4135:\"<p class=\"has-drop-cap\">Tetsuaki Hamano released the <a href=\"https://wordpress.org/plugins/piano-block/\">Piano Block</a> plugin for WordPress on Monday. It allows users to insert a piano-based interface into the editor for playing music. Mostly, it is just a lot of fun.</p>\n\n\n\n<p>Hamano <a href=\"https://wptavern.com/highlight-underline-and-control-font-size-with-richtext-extension\">launched  RichText Extension</a>, his first submission to the WordPress plugin directory, in the spring of 2020. At the time, block-related plugins were still scarce, but he has continued contributing extensions since that initial release. <a href=\"https://wordpress.org/plugins/flexible-spacer-block/\">Flexible Spacer Block</a> is invaluable for responsive vertical spacing. <a href=\"https://wordpress.org/plugins/flexible-table-block/\">Flexible Table</a> does the same for table elements, and his <a href=\"https://wordpress.org/plugins/custom-html-block-extension/\">Custom HTML Block Extension</a> is handy for anyone writing code regularly from the editor.</p>\n\n\n\n<p>While his previous outings covered several vital features for different user groups, his latest is a bit more on the lighter side of things. More than anything, it serves as a brief distraction, a way to break up the day for people who spend a lot of time in the WordPress content editor.</p>\n\n\n\n<p>One thing that I love about blocks is that they do not have to serve a vital function in producing content for a site. Sometimes, their purpose is to simply bring a little joy into our lives. That is what Piano Block does.</p>\n\n\n\n<p>Hamano noted in the plugin description:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>This plugin does not add any useful features to WordPress, nor does it add any useful blocks to help you write posts. Let&#8217;s insert this block and enjoy the music if you are stuck in writing an article or just want a little distraction.</p></blockquote>\n\n\n\n<p>The plugin merely adds a web-based musical instrument to the block editor, offering a change of pace from building content. It does not appear on the front end of the site.</p>\n\n\n\n<img />Piano Block in the editor.\n\n\n\n<p>The block offers a range of 14 instruments. The default is an acoustic piano, but users can switch between various keyboard, string, brass, and woodwind options. Plus, there is a xylophone.</p>\n\n\n\n<p>Users can move up or down two octaves, change the volume, or toggle the sustain pedal on and off. Other than that, there are no other block-specific options.</p>\n\n\n\n<p>The block&#8217;s keyboard mapping threw me off at first. I peeked under the hood and found the JavaScript code for assigning each key. I was tempted to clone the plugin&#8217;s GitHub repository, set up the build tools, and customize it. However, that seemed like a lot of work for a block meant to be a momentary distraction. It was not time for me to put on my developer hat.</p>\n\n\n\n<p>So, I tickled the plastic keys of my laptop, trying to rewire my brain to a layout that did not match an actual piano.  I just had fun with it, and that is kind of the point.</p>\n\n\n\n<p>I rarely record videos, being much more comfortable tapping my laptop&#8217;s keys than doing anything on camera. Therefore, Tavern visitors are in for something of a treat today. I put together a short clip of me playing a song via the Piano Block:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n\n</div>\n\n\n\n<p>That was tougher than it looked with the keys in odd places. Apologies if I missed any notes or lines. It has been a while since I have heard <em>Twinkle, Twinkle, Little Star</em>. I believe it goes a little something like that.</p>\n\n\n\n<p>I am continually amazed at what some developers create on top of the block system.  More than anything, I want to see some of the talented musicians in the WordPress community &#8212; I know some of you are out there &#8212; record themselves playing something with Piano Block.  <em>A little jazz, perhaps?</em></p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"wp-embedded-content\"><a href=\"https://wordpress.org/plugins/piano-block/\">Piano Block</a></blockquote>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 05 Mar 2022 01:03:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: WordPress 6.0 to Introduce Performance Improvements for Custom Pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130920\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"https://wptavern.com/wordpress-6-0-to-introduce-performance-improvements-for-custom-pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2910:\"<p>WordPress core committer Jonny  Harris <a href=\"https://core.trac.wordpress.org/ticket/10886?utm_source=Post+Status+Newsletter&utm_campaign=c4852581a1-EMAIL_CAMPAIGN_2022_01_27_08_35_COPY_01&utm_medium=email&utm_term=0_afc03177a6-c4852581a1-104953921&mc_cid=c4852581a1&mc_eid=ad602f9b49#comment:39\">merged a patch</a> into WordPress core for a 12-year-old <a href=\"https://core.trac.wordpress.org/ticket/10886\">ticket</a> that he says has the potential to bring &#8220;a massive effect on performance for custom pages.&#8221; The change, which will be included in the upcoming 6.0 release, stops unnecessary queries when developers are using the&nbsp;<code>do_parse_request</code>&nbsp;filter, thanks to a <a href=\"https://github.com/WordPress/wordpress-develop/pull/2032\">refreshed patch</a> from contributor Paul Bearne.</p>\n\n\n\n<p>Harris summarized the problem and how the change improves performance in the commit message:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Developers of plugins and themes can use the&nbsp;<code>do_parse_request</code>&nbsp;filter to hot-wire requests and hook in early to render custom pages. However, even through these request may not need post queries and 404 lookups to be run, they run anyway. This can results in unnecessary SQL queries running on these requests. By adding a return value to the&nbsp;<code>parse_request</code>&nbsp;method of the&nbsp;<code>WP</code>&nbsp;class, these queries can now be skipped.</p></blockquote>\n\n\n\n<p>WordPress core contributor Konstantin Kovshenin detailed the need for this change in a Twitter thread he published in 2021, when soliciting help for the ticket:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">I don\'t usually tweet about <a href=\"https://twitter.com/hashtag/SEO?src=hash&ref_src=twsrc%5Etfw\">#SEO</a>, but this is important. Is a static robots.txt file good for WordPress performance? Let\'s find out!<br /><br />To display the default robots.txt, a fresh WordPress install will: <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f9f5.png\" alt=\"🧵\" class=\"wp-smiley\" /></p>&mdash; Konstantin Kovshenin (@kovshenin) <a href=\"https://twitter.com/kovshenin/status/1466732748517822464?ref_src=twsrc%5Etfw\">December 3, 2021</a></blockquote>\n</div>\n\n\n\n<p>Harris performed a quick review of <a href=\"https://wpdirectory.net/search/01FSC39908QH1NKEMG4B9PT6JR\">plugins that use the filter</a> and said he does not anticipate breakages. The search found 133 plugins using the filter. Some of the most popular ones include Google&#8217;s Site Kit plugin (1M+ installs), The Events Calendar (800K installs), and AMP (500K installs). Harris suggested the change requires a dev note, as it may have unanticipated side effects. The dev note is likely to be published closer to the time of release. WordPress 6.0 is currently scheduled for release on May 24, 2022.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 23:52:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"WordPress.org blog: WP Briefing: Episode 26: Matt Mullenweg on Ukraine, Community, and WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/?post_type=podcast&p=12415\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"https://wordpress.org/news/2022/03/episode-26-matt-mullenweg-on-ukraine-community-and-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6331:\"<p>Matt Mullenweg speaks to WordPress contributors worldwide on this special edition of the WP Briefing podcast with Josepha Haden Chomphosy. Join us to hear Matt’s thoughts on Ukraine.</p>\n\n\n\n<p><strong><em>H</em></strong><em><strong>ave a question you&#8217;d like answered? You can submit them to <a href=\"mailto:wpbriefing@wordpress.org\">wpbriefing@wordpress.org</a>, either written or as a voice recording.</strong></em></p>\n\n\n\n<h2 id=\"credits\">Credits</h2>\n\n\n\n<ul><li>Hosts: <a href=\"https://profiles.wordpress.org/chanthaboune/\">Josepha Haden Chomphosy</a> and <a href=\"https://profiles.wordpress.org/matt/\">Matt Mullenweg</a></li><li>Editor:&nbsp;<a href=\"https://profiles.wordpress.org/dustinhartzler/\">Dustin Hartzler</a></li><li>Logo:&nbsp;<a href=\"https://profiles.wordpress.org/beafialho/\">Beatriz Fialho</a></li><li>Production:&nbsp;<a href=\"https://profiles.wordpress.org/cbringmann/\">Chloé Bringmann</a> &amp; <a href=\"https://profiles.wordpress.org/santanainniss/\">Santana Inniss</a></li></ul>\n\n\n\n<h2>How You Can Help</h2>\n\n\n\n<p><a href=\"https://www.unicefusa.org/stories/unicef-children-crossfire-ukraine-crisis/39542?utm_campaign=20220225_Emergencies&utm_medium=Organic&utm_source=UkraineWebStoryChildrenFeb2022&utm_content=LearnMoreUkraineWebStoryChildrenFeb2022&ms=Organic_PRL_2022_Emergencies_20220225_UkraineWebStoryChildrenFeb2022_LearnMoreUkraineWebStoryChildrenFeb2022_none_none&initialms=Organic_PRL_2022_Emergencies_20220225_UkraineWebStoryChildrenFeb2022_LearnMoreUkraineWebStoryChildrenFeb2022_none_none\">UNICEF</a></p>\n\n\n\n<p><a href=\"https://www.doctorswithoutborders.org/what-we-do/countries/ukraine\">Médecins Sans Frontieres</a>&nbsp;</p>\n\n\n\n<p><a href=\"https://www.icrc.org/en/where-we-work/europe-central-asia/ukraine\">International Committee of the Red Cross</a>&nbsp;</p>\n\n\n\n<p><a href=\"https://help.rescue.org/donate/ukraine-acq?ms=gs_ppc_fy22_ukraine_mmus_feb&initialms=gs_ppc_fy22_ukraine_mmus_feb&gclid=CjwKCAiAjoeRBhAJEiwAYY3nDHNlEUUNRM4wKl1bY0ploy1RNl0M7G1OlLTqawZdg_XhrJ0TircZ_RoCfh8QAvD_BwE\">International Rescue Committee</a></p>\n\n\n\n<p><a href=\"https://www.unrefugees.org/what-we-do/\">UN Refugee Agency</a>&nbsp;</p>\n\n\n\n<p><a href=\"https://donate.wck.org/give/236738/#!/donation/checkout\">World Central Kitchen</a></p>\n\n\n\n<p><a href=\"https://www.techtotherescue.org/tech/tech-for-ukraine\">Tech For Ukraine</a></p>\n\n\n\n<p><a href=\"https://twitter.com/hashtag/wp4ukraine\">#WP4Ukraine</a></p>\n\n\n\n<h2>Transcript</h2>\n\n\n\n<span id=\"more-12415\"></span>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>00:00</p>\n\n\n\n<p>Hello, everyone, and welcome to a special edition of the WordPress Briefing. I have Matt here with me today because we want to acknowledge that we are once again at the start of a very difficult time. Neither of us would presume to know what it&#8217;s like to be at the heart of such massive disruption in our lives. But who would we be if we didn&#8217;t stop and check in with you all, the project that we hold so dear? And with that, I&#8217;ll hand it right over to you, Matt.</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>00:27</p>\n\n\n\n<p>Hello everyone. First, I want to thank Josepha for inviting me to join the WordPress Briefing to share what’s been on my mind in light of recent global events.&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>00:37</p>\n\n\n\n<p>I&#8217;ve been listening and watching events escalate in Ukraine, often in a state of shock. The scale alone is hard to take in. I mean, in the last 7 days, more than 500,000 people have fled their homes, more refugees are expected every day. The downstream humanitarian crises of the invasion are unimaginable.&nbsp;&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>00:56</p>\n\n\n\n<p>And seeing destruction in the world we live in is confusing, disconcerting, and difficult. In my experience, open source and WordPress bring people together; people from other countries and cultures, people that we know as friends and colleagues. Technology connects us, regardless of where we are. Nothing can negate the bad things happening in the world, but when I see how this community of contributors collaborates, regardless of borders, you all remind me of the good in the world every day.</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>01:30</p>\n\n\n\n<p>I firmly believe that the web can be an equalizer and a force for good in the world. To me, the WordPress project is the epitome of goodness—everyone has a voice, a platform, and a community. You have the power to make your corner of the world, and the web, a sanctuary for those who need it—especially now.</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>01:45</p>\n\n\n\n<p>If you or someone you know is affected by this war, I encourage you to be present as the ramifications unfold. While we may all feel fatigued and have a sense of languishing from the past two years of the Covid pandemic, the gift of time and support for one another cannot be overstated. I&#8217;m confident that every single person in the WordPress community will approach the situation in Ukraine with sensitivity and understanding.&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>02:07</p>\n\n\n\n<p>I invite you to join me in standing with those in the world working to end conflict and working toward a world of peace, promise, and opportunity. If you&#8217;re looking for a way to help support the humanitarian crisis in Ukraine, I will offer some suggested NGOs, or Non-Governmental Organizations, that provide assistance to local peacebuilders in the region.&nbsp;</p>\n\n\n\n<p><strong>Matt Mullenweg&nbsp; </strong>02:26</p>\n\n\n\n<p>In closing, please know that my thoughts are with everyone in our community. I know that my words here can’t change anything there, but I hope that we all remember that words of support are never unwelcome. And we can never know when a little human kindness can help someone share the invisible heaviness in their heart.&nbsp;</p>\n\n\n\n<p><strong>Josepha Haden Chomphosy&nbsp; </strong>02:44</p>\n\n\n\n<p>Thanks for that, Matt. My friends, there are links in the show notes to some of the groups that Matt referenced. And that is it for this special edition of the WordPress Briefing. I&#8217;m your host, Josepha Haden Chomphosy. Be safe, be kind to yourself and others, and I&#8217;ll see you again in a couple of weeks.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 21:39:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Chloe Bringmann\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WordPress.org blog: The Month in WordPress – February 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12411\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2022/03/the-month-in-wordpress-february-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11737:\"<p>There’s a lot going on in the world right now, and safety is top of mind for everyone in the WordPress community. If you don&#8217;t know where to begin, or how to support your peers, Executive Director <a href=\"https://josepha.blog/2022/02/25/to-my-global-community-start-small/\">Josepha Chomphosy’s advice</a> to the global community is to start small.&nbsp;</p>\n\n\n\n<p>Overall, February has been a busy month for WordPress. To begin with, it was thrilling to see the enthusiasm for the release of WordPress 5.9 Joséphine from January continue last month, and that’s not all.&nbsp;</p>\n\n\n\n<p>We have many exciting updates to share, so keep reading to learn about the latest achievements from the WordPress community.</p>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<h2>WordPress 6.0: May 24, 2022 is the proposed release date</h2>\n\n\n\n<ul><li>The proposed <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-6-0-planning-roundup/\">release schedule for WordPress 6.0</a>, the second major release of 2022, has been published.</li><li>While we’re waiting for 6.0, check out the <a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\">WordPress 5.9.1 maintenance release</a> which was released on February 22, 2022.</li></ul>\n\n\n\n<div class=\"wp-container-1 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://wordpress.slack.com/archives/C02RQBWTW\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Are you interested in contributing to WordPress core?</strong> Join the #core channel in Slack. Also, don&#8217;t miss the Core Team’s weekly developer chat on Wednesdays at 8 PM UTC.</a></div>\n</div>\n\n\n\n<h2>Gutenberg releases: Versions 12.5, 12.6, and 12.7 were released</h2>\n\n\n\n<p>The Core Team launched three new versions of Gutenberg last month. All come with new features, code quality improvements, and bug fixes.</p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\">Gutenberg 12.7 </a>is available to download. This version improves the Patterns experience, allows you to add border styles to column blocks, and includes other new features.</li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/\">Gutenberg 12.6</a> was launched on February 16, 2022. This release includes a new color panel, updated color controls, a new Post Author Biography block, Read More block, and plenty of other exciting updates!</li><li><a href=\"https://make.wordpress.org/core/2022/02/03/whats-new-in-gutenberg-12-5-february-2nd/\">Gutenberg 12.5 </a>was released on February 2, 2022. This version allows switching theme styles variations, custom taxonomies filtering, and more.</li></ul>\n\n\n\n<div class=\"wp-container-2 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://make.wordpress.org/chat/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Want to get involved in developing Gutenberg? </strong>Contribute to Gutenberg on GitHub, and join the #core-editor channel in the Make WordPress Slack. Follow the #gutenberg-new tag for details on the latest updates.</a></div>\n</div>\n\n\n\n<h2>WordPress News gets a new look</h2>\n\n\n\n<p>The redesign of <a href=\"https://wordpress.org/news\">WordPress News</a>, which was first announced by Matt Mullenweg, Co-Founder of WordPress, in State of the Word 2021, went live on February 16, 2022.</p>\n\n\n\n<div class=\"wp-container-3 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://wordpress.org/news/2022/02/a-new-wordpress-news/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Read the redesign announcement </strong>to learn more about the inspiration behind the new look.</a></div>\n</div>\n\n\n\n<h2>Team updates: #WP Diversity, a new blog for developers, and more</h2>\n\n\n\n<ul><li>The #WPDiversity working group, which is part of the Community Team, hosted an open Zoom meeting with volunteers on February 23, 2022. If you’re interested in contributing, read the <a href=\"https://make.wordpress.org/community/2022/02/24/recap-of-the-diverse-speaker-training-group-wpdiversity-on-february-23-2022/\">recap of the meeting</a> to view available roles. </li><li>The Core Team shared a <a href=\"https://make.wordpress.org/core/2022/02/25/proposal-to-start-a-news-blog-on-developer-wordpress-org/\">proposal to start a blog</a> on developer.wordpress.org to share news and updates relevant to developers. </li><li>The first Gutenberg Developer Hours session hosted on February 8th by the Core Team was successful. Head over to <a href=\"https://make.wordpress.org/core/2022/02/24/february-8th-gutenberg-developer-hours-session-evaluation/\">this page</a> to learn more about the participants’ feedback.</li><li>The Core Team published “<a href=\"https://make.wordpress.org/core/2022/02/24/feature-project-plugin-dependencies/\">Feature Project: Plugin Dependencies</a>,” where they identified the problems with plugin dependencies and suggested potential solutions to improve the plugin experience.</li><li>The WordPress Photo Directory has a <a href=\"https://make.wordpress.org/photos/\">new Make team</a>. There is currently an open <a href=\"https://make.wordpress.org/photos/2022/02/23/photo-directory-team-rep-nominations-for-2022/\">call for team reps</a> and collaboration is happening at the new <a href=\"https://wordpress.slack.com/messages/photos/\">#photos</a> channel of the Make WordPress Slack.</li><li>The Polyglots Team shared a proposal for a <a href=\"https://make.wordpress.org/polyglots/2022/02/01/proposal-milestone-template-for-polyglots-locale-teams/\">milestone template </a>for the Polyglots Locale Teams.</li><li>The Community Team published a proposal for <a href=\"https://make.wordpress.org/community/2022/02/16/proposal-refurbishing-camera-kits/\">refurbishing camera kits</a>.</li><li>The <a href=\"https://make.wordpress.org/community/2022/02/21/2022-global-sponsors-announcement/\">Global Community Sponsors for 2022</a> have been announced.</li><li>The February 2022 edition of the monthly <a href=\"https://make.wordpress.org/community/2022/02/15/meetup-organizer-newsletter-february-2022/\">Meetup Organizer Newsletter</a> has been published.</li><li>The latest edition of People of WordPress highlighting <a href=\"https://wordpress.org/news/2022/02/people-of-wordpress-tonya-mork/\">Tonya Mork</a> was published on February 28, 2022. Read Tonya’s story to learn more about how WordPress helped her find herself again after a health crisis. </li><li>The February 2022 edition of the <a href=\"https://make.wordpress.org/polyglots/2022/02/22/polyglots-monthly-newsletter-february-2022/\">Polyglots Monthly Newsletter</a> has been published.</li></ul>\n\n\n\n<div class=\"wp-container-4 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://wordpress.org/news/feed/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>The Community Team published a discussion on diversity in WordPress events.</strong> If you’re comfortable sharing your experience, you can still comment on the post.</a></div>\n</div>\n\n\n\n<h2>Feedback/Testing requests: WordPress iOS 19.3 and Android 19.3 </h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/mobile/2022/02/22/call-for-testing-wordpress-for-ios-19-3/\">WordPress for iOS 19.3</a> beta is available for testing, along with <a href=\"https://make.wordpress.org/mobile/2022/02/22/call-for-testing-wordpress-for-android-19-3/\">WordPress for Android 19.3</a></li></ul>\n\n\n\n<div class=\"wp-container-5 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://make.wordpress.org/polyglots/2022/02/08/call-for-early-testers-glotpress-feedback-feature/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>Test and share your feedback</strong> on the GlotPress feedback feature.</a></div>\n</div>\n\n\n\n<h2>WordCamp Europe 2022 announces steps to ensure a diverse, inclusive, and welcoming event</h2>\n\n\n\n<ul><li>WordCamp Europe 2022 <a href=\"https://europe.wordcamp.org/2022/diversity-at-wceu/\">announced a plan</a> to ensure more diversity and inclusion in events moving forward.</li><li>The WordPress Foundation published a post on how <a href=\"https://wordpressfoundation.org/news/2022/open-source-software-good-for-business/\">open source software is good for business</a>.</li><li>In a recent episode of WP Briefing titled “<a href=\"https://wordpress.org/news/2022/02/episode-25-five-cents-on-five-for-the-future/\">Five Cents on Five for the Future</a>,” Executive Director Josepha Haden Chomphosy talks about future-proofing the WordPress project with the Five for the Future pledge.</li><li>The Training Team is hosting several WordPress Social Learning Meetups <a href=\"https://www.meetup.com/wordpress-social-learning/events/\">in March 2022</a>.</li><li>Don’t miss the following upcoming WordCamps:<ul><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e8-1f1ed.png\" alt=\"🇨🇭\" class=\"wp-smiley\" /> <a href=\"https://geneve.wordcamp.org/2022/\">WordCamp Genève</a>, Switzerland on April 9, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ec-1f1f7.png\" alt=\"🇬🇷\" class=\"wp-smiley\" /> <a href=\"https://central.wordcamp.org/wordcamps/wordcamp-athens-attica-greece-2022/\">WordCamp Athens</a>, Greece between April 9 and 10, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1e6-1f1f9.png\" alt=\"🇦🇹\" class=\"wp-smiley\" /> <a href=\"https://vienna.wordcamp.org/2022/\">WordCamp Vienna</a>, Austria from April 23 to 24, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1ea-1f1fa.png\" alt=\"🇪🇺\" class=\"wp-smiley\" /> <a href=\"https://europe.wordcamp.org/2022/\">WordCamp Europe</a> in Porto, Portugal from June 2 to 4, 2022 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" /> <a href=\"https://montclair.wordcamp.org/2022/\">WordCamp Montclair</a> in New Jersey, USA June 25 (in person)</li><li><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f1fa-1f1f8.png\" alt=\"🇺🇸\" class=\"wp-smiley\" /> <a href=\"https://us.wordcamp.org/2022/\">WordCamp US</a> in San Diego, California from September 9 to 11, 2022 (in person)</li></ul></li></ul>\n\n\n\n<div class=\"wp-container-6 wp-block-buttons\">\n<div class=\"wp-block-button aligncenter\"><a class=\"wp-block-button__link\" href=\"https://europe.wordcamp.org/2022/call-for-volunteers/\" target=\"_blank\" rel=\"noreferrer noopener\"><strong>It’s not too late to be a volunteer at WordCamp Europe 2022. </strong>If you’re interested, head over to this page to apply.</a></div>\n</div>\n\n\n\n<hr class=\"wp-block-separator\" />\n\n\n\n<p><strong><em>Have a story that we could include in the next ‘Month in WordPress’ post? Let us know by filling out </em></strong><a href=\"https://make.wordpress.org/community/month-in-wordpress-submissions/\"><strong><em>this form</em></strong></a><strong><em>.</em></strong></p>\n\n\n\n<p><em>The following folks contributed to December 2021’s Month in WordPress: </em><a href=\"https://profiles.wordpress.org/anjanavasan/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>anjanavasan</a><em> </em><a href=\"https://profiles.wordpress.org/harishanker/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>harishanker</a><em> </em><a href=\"https://profiles.wordpress.org/rmartinezduque/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>rmartinezduque</a> <a href=\"https://profiles.wordpress.org/mysweetcate/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>mysweetcate</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 17:40:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Anjana Vasan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WordPress Foundation: How is open source software good for business?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpressfoundation.org/?p=229098\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"https://wordpressfoundation.org/news/2022/open-source-software-good-for-business/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3866:\"<p>In the late 1970s, staff programmers at the Massachusetts Institute of Technology <a href=\"https://opensource.com/article/18/2/pivotal-moments-history-open-source\">sparked a movement</a>. Little did they know that a jammed printer would lead to the beginning of an era: the free software movement. </p>\n\n\n\n<p>If you&#8217;ve ever heard the phrase, &#8220;free as in freedom, not beer,&#8221; this is what it means:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;Free software&#8221; means software that respects users&#8217; freedom and community. Roughly, it means that the users have the freedom to run, copy, distribute, study, change and improve the software. Thus, &#8220;free software&#8221; is a matter of liberty, not price.&nbsp;</p><cite>The <a href=\"https://www.gnu.org/philosophy/free-sw.en.html\">GNU Project</a> and Free Software Foundation</cite></blockquote>\n\n\n\n<p>The WordPress Foundation&#8217;s philosophy requires that all projects and software we support be licensed under the <a href=\"http://www.gnu.org/copyleft/gpl.html\">GNU Public License</a>, a free, copyleft license—this is intentional. If you mistakenly think open source has no place in business purely because there’s no monetary value attached to the software, we urge you to think again.</p>\n\n\n\n<h2>The path to innovation and progress</h2>\n\n\n\n<p>Open source software offers a low-cost entry to the market and paves an efficient way for innovation. These projects harness the power of diverse knowledge, skills, and community to create the best software. <strong>But what does this mean for businesses?&nbsp;</strong></p>\n\n\n\n<p>&#8220;Companies who wish to create wealth are always interested in productivity. Productivity includes being able to innovate effectively [&#8230;] Effective innovation is not merely being able to invent and improve, but also being able to determine what to invent and how to improve,&#8221; said <a href=\"https://www.google.ca/books/edition/Innovation_Happens_Elsewhere/2VElII9QeakC?hl=en&gbpv=1&printsec=frontcover\">Richard P. Gabriel and Ron Goldman</a>.&nbsp;</p>\n\n\n\n<p>Most individuals recognize Apple as an innovative and successful technology company. However, few people outside the developer community may know MacOS X was based on <a href=\"https://9to5mac.com/2021/06/01/explore-some-of-the-most-memorable-moments-in-wwdc-history-as-we-approach-apples-32nd-conference/\">Darwin</a>, an open source project. Many of <a href=\"https://developer.apple.com/opensource/\">Apple’s platforms</a> draw inspiration from open source, and plenty of other companies have done the same.</p>\n\n\n\n<p>With open source software, organizations have access to the latest updates and bug fixes, thanks to frequent and reliable releases. Put simply, building on that existing work rather than reinventing the wheel puts them on the fastest path to creating a better product for their customers.&nbsp;</p>\n\n\n\n<p>Moreover, business strategies based on open source can level the playing field. Small organizations that rely on open source projects for their products can leverage ubiquity to build brand equity, as Gabriel and Goldman explain. This makes the companies more trustworthy to the customer, allowing them to compete fairly with organizations with extensive resources. There’s also a low risk of the software being discontinued and affecting the business. Even if the original programmers leave the project, the maintenance and development of open source software will go on.</p>\n\n\n\n<p>We’re only scratching the surface of how open source software is good for business. The reality is that the work done in open source projects benefits the society at large—they help create a better world through technology. The best way businesses can support that future is by adopting open source technologies and contributing to such projects.&nbsp;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 16:51:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Anjana Vasan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Post Status: Post Status Notes #488\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=94063\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://cdn.poststatus.com/post-status-notes-488/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12431:\"<p class=\"has-medium-font-size\">Core releases. Static robots.txt for faster load time. Self-care. Health check. Which metric is lying to you? Dev notes and bottom lines.</p>\n\n\n\n<h2 id=\"h-core-concerns\">Core Concerns</h2>\n\n\n\n<p>A <a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\">WordPress 5.9.1 Maintenance Release</a> is out, so make sure your sites are updated. There are quite <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-5-9-1-rc-1/\">a lot of bug fixes</a> in this release — over 80!</p>\n\n\n.kt-block-spacer-_6ce750-54 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_6ce750-54\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Gutenberg 12.7</strong> <a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\">has been released</a>. Patternmaking is easier to discover now. There are some list view improvements and smaller enhancements, bug fixes, and new APIs.</p>\n\n\n.kt-block-spacer-_7d20e5-16 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_7d20e5-16\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Jonny Harris</strong> <a href=\"https://twitter.com/thespacedmonkey/status/1499044349371371520\">announced</a> that he has <a href=\"https://core.trac.wordpress.org/ticket/10886\">merged a patch</a> into WordPress core for a 12-year-old ticket that &#8220;could have a massive effect on performance for custom pages.&#8221;</p>\n\n\n\n<p><strong>Konstantin Kovshenin</strong> <a href=\"https://twitter.com/kovshenin/status/1466732748517822464\">explained how this works</a> with an example on Twitter back in December 2021: &#8220;To display the default <code>robots.txt</code>, [which is <em>not</em> static] a fresh WordPress install will run 15 SQL queries&#8221; and trigger over &#8220;42,000 function calls at 5.46 megs peak memory, about 100 ms wall time.&#8221; (Wall time is the actual duration elapsed, possibly beyond CPU time due to disk access.)</p>\n\n\n.kt-block-spacer-_6633c3-86 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_6633c3-86\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"self-and-health-checks\">Self and Health Checks</h2>\n\n\n\n<p><strong>Josepha Haden&nbsp;Chomphosy</strong> says when it comes to <a href=\"https://josepha.blog/2022/02/25/to-my-global-community-start-small/\">supporting your community</a>, &#8220;start small&#8221; and realize that &#8220;you do not personally hold all the responsibility for &#8216;making things work\' today.&#8221;</p>\n\n\n\n<p>Josepha is <a href=\"https://developer.wordpress.com/2022/03/01/automattic-women-josepha-haden-chomphosy/\">also featured</a> in a recent <strong>Automattic Women</strong> post sharing what a typical day for her is like and what drew her to <strong>Automattic</strong>. Notably, Josepha is identified as &#8220;community steward&#8221; instead of &#8220;Executive Director&#8221; of WordPress (.org). We haven\'t seen that before, but it appears on <a href=\"https://www.guidestar.org/profile/20-5498932#summary\">the WordPress Foundation\'s profile</a> at <strong>GuideStar</strong>.</p>\n\n\n.kt-block-spacer-_2e42d6-19 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_2e42d6-19\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Tonya Mork</strong> talks about <a href=\"https://wordpress.org/news/2022/02/people-of-wordpress-tonya-mork/\">some personal and health challenges in her life</a> and how WordPress helped her &#8220;find [herself] again.” Tonya was both the Core Tech Lead and the Release Coordinator for <strong>WordPress 5.9</strong>, and now she is moving on to new adventures — in teaching. </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>“I’m on a mission to give back and make a difference. Teaching is how I will do it.&#8221;</p></blockquote>\n\n\n.kt-block-spacer-_4ab30a-66 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_4ab30a-66\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"plugin-updates\">Plugin Updates</h2>\n\n\n\n<p><strong>Marius Jensen</strong> says the <strong>Health Check</strong> plugin — which he has maintained since 2017 — needs updating. He shares <a href=\"https://clorith.net/the-need-for-feature-removals-in-the-health-check-plugin/\">some possible solutions</a> for the need to maintain backward compatibility and feature parity between WordPress core and Health Check.</p>\n\n\n.kt-block-spacer-_05c5f6-12 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_05c5f6-12\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><a href=\"https://wpexperts.io/\">WPExperts</a> has acquired the <a href=\"https://wordpress.org/plugins/post-smtp/\">Post SMTP plugin</a> from its former developer, <strong>Yehuda Hassine</strong>. <strong>Sarah Gooding</strong> <a href=\"https://wptavern.com/wpexperts-acquires-post-smtp-plugin\">covers the story</a> and notes that current users &#8220;can expect development and support from a much larger team of professionals, as well as new commercial add-ons in the near future.&#8221;</p>\n\n\n.kt-block-spacer-_9d5956-27 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_9d5956-27\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><a href=\"https://wpconcern.com/\">WP Concern</a> has <a href=\"https://twitter.com/maneshtimilsina/status/1499707237493002247\">acquired</a> <a href=\"https://twitter.com/WebFactoryLtd/status/1499699197469204481\">WebFactory</a>&#8216;s <a href=\"https://wordpress.org/plugins/nifty-coming-soon-and-under-construction-page/\">Coming Soon & Maintenance Mode Page plugin</a>. This is <a href=\"https://poststatus.com/acquisitions/\">the seventh acquisition</a> we\'ve heard of this year. </p>\n\n\n.kt-block-spacer-_a6377d-f0 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_a6377d-f0\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"dev-notes\">Dev Notes</h2>\n\n\n\n<p><strong>Julia Evans</strong> compiled <a href=\"https://jvns.ca/blog/2022/02/20/things-that-used-to-be-hard-and-are-now-easy/\">a list of responses</a> she got on <strong>Twitter</strong> to <a href=\"https://twitter.com/b0rk/status/1494301227533967369?s=20&t=M_RYvWzEOymZ--YjE9jvpQ\">the question</a> of what in programming used to be hard but now is &#8220;easy.&#8221; If you\'ve been in programming and tech long enough, this is a fun trip down memory lane — if you don\'t mind feeling old.</p>\n\n\n.kt-block-spacer-_af6f6c-23 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_af6f6c-23\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Rebecca Monteleone</strong> and <strong>Jamie Brew</strong> explore <a href=\"https://pudding.cool/2022/02/plain/\">what makes writing more readable and how algorithms try to assess readability</a>. They feel it\'s a &#8220;real possibility that plain language will be outsourced to blackbox technologies that are grounded in antiquated data,&#8221; which will hurt accessibility:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;Ultimately, the effectiveness of plain language translations comes down to engagement with your audience. Engagement that doesn’t make assumptions about what the audience understands, but will instead ask them to find out. Engagement that’s willing to work directly with people with disabilities or limited access to education, and not through intermediaries. As disabled <a href=\"https://www.youtube.com/watch?v=fTXg9Yki9Eg&ab_channel=aucdnetwork\">advocates</a> and <a href=\"https://autisticadvocacy.org/wp-content/uploads/2021/07/One-Idea-Per-Line.pdf\">organizations led by disabled people</a> have been saying all along: “Nothing about us without us.”</p></blockquote>\n\n\n.kt-block-spacer-_7f4275-03 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_7f4275-03\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"bottom-lines\">Bottom Lines</h2>\n\n\n\n<p><strong>Jason Cohen</strong>, CTO of <strong>WPEngine</strong>, offers <a href=\"https://blog.asmartbear.com/whos-lying.html\">a reliable way to check for bad data and misleading metrics</a> that impact your bottom line: look at more than one indicator and ask &#8220;Who\'s lying?&#8221; </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;If a metric is important enough to watch it every day, and to act if its behavior deviates from expectation, then it’s important enough to be double-checked. Both for accuracy, and for completeness of comprehension.&#8221;</p></blockquote>\n\n\n.kt-block-spacer-_c41b07-a1 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_c41b07-a1\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p>Does the existence of &#8220;developer pricing&#8221; mean developers are cheap? Developers <em>are</em> cheap says <strong>Keith Casey</strong>, <a href=\"https://caseysoftware.com/blog/the-secret-of-developer-pricing\">but that\'s not why developer pricing is needed</a>. &#8220;<em>The real purpose of developer pricing is to let developers build without doing paperwork.</em>&#8220;</p>\n\n\n.kt-block-spacer-_45b7ef-47 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_45b7ef-47\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p>Is it <a href=\"https://masterwp.com/should-you-raise-your-rates-because-of-inflation/\">time to raise your rates due to inflation</a>? <strong>Rob Howard</strong> thinks so, but he also says there\'s a right way to do it. You can offer updated rates to new clients who are probably seeing inflation-related price increases everywhere and raising their own rates.</p>\n\n\n.kt-block-spacer-_da9ec0-b3 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_da9ec0-b3\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><a href=\"https://twitter.com/theryanking\">Ryan Breslow</a> started a worthwhile <a href=\"https://twitter.com/theryanking/status/1497732269632598018?s=21\">Twitter thread</a> with the assertion that &#8220;<strong>Shopify</strong> is eating their ecosystem.&#8221;  Shopify has become the second biggest CMS and the biggest competitor to <strong>WooCommerce</strong>. Ryan takes a look at Shopify\'s tactics for growth and how it\'s treating its developers.</p>\n\n\n.kt-block-spacer-_ccf749-3c .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_ccf749-3c\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Tom Willmot</strong>, co-founder and CEO of <strong>Human Made</strong>, <a href=\"https://humanmade.com/2022/03/03/human-made-in-2021/\">shares how the company did in 2021</a>: 25% employee growth with almost 100 employees, 3 clients with $50B+ in revenue, and growth for the <strong>AltisDXP</strong> digital experience platform. Not too shabby!</p>\n\n\n.kt-block-spacer-_c0ffd5-6d .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_c0ffd5-6d\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p class=\"has-theme-palette-7-background-color has-background\">For a digest of everything happening in core this week, see <a href=\"https://poststatus.com/this-week-at-wordpress-org-february-28-2022/\">This Week at WordPess.org</a> for <strong>February 28</strong>.</p>\n\n\n.kt-block-spacer-_b8111b-be .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_b8111b-be\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 06:59:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Post Status: Who Uses WordPress Multisite?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=94120\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://poststatus.com/who-uses-wordpress-multisite/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3607:\"<p class=\"has-drop-cap\">WordPress Multisite isn\'t for everyone. Two of our oldest and still popular posts are about <em>not</em> using Multisite. One is about <a href=\"https://poststatus.com/completely-disable-multisite/\">how to disable Multisite</a> when you decide to quit using it after it\'s been active. Another explains when to use it and when not to. Sometimes <a href=\"https://poststatus.com/wordpress-multisite-versus-minisite/\">&#8220;Minisite&#8221; is what you really want</a> instead, a still under-supported concept in WordPress. But when the suggestion to &#8220;kill&#8221; Multisite was floated recently, <a href=\"https://wptavern.com/wordpress-multisite-is-still-a-valuable-and-often-necessary-tool\">its users came out in force to defend it</a>.  </p>\n\n\n\n<p>While this conversation was happening in the WordPress community, <strong>David Bisset</strong> asked <a href=\"https://twitter.com/dimensionmedia/status/1499128507124887552\">on Twitter</a> and <a href=\"https://poststatus.slack.com/archives/CHNM7Q7T8/p1646255345840639\">Post Status Slack</a> how people use or have seen WordPress Multisite being used. Of course, there\'s WordPress.com and WordCamp.org. We\'ve written about the <strong>Modern Language Association</strong>&#8216;s <a href=\"https://poststatus.com/an-interview-with-the-mlas-humanities-commons-team/\">Humanities Commons</a> in the past.</p>\n\n\n\n<p><a href=\"https://poststatus.com/who-uses-wordpress-multisite/\">The responses that rolled in illustrate how diverse Multisite\'s use-cases can be</a>…</p>\n\n\n\n<ul><li><strong>John Jacoby</strong> <a href=\"https://twitter.com/JJJ/status/1499139676795543554\">mentions</a> <strong>Jetpack</strong> &#8220;cloning user-sites to shadow-sites on WordPress.com network… for backups and indexing.&#8221;</li><li><strong>Topher DeRosia</strong> sold <a href=\"https://twitter.com/topher1kenobe/status/1499130405852745730\">subsites offering <strong>BuddyPress</strong></a> with them.</li><li><strong>Angie Meeker</strong> built <a href=\"https://twitter.com/angiemeeker/status/1499165485295935492\">a school’s network</a> where each teacher and club had their own site, grade book, etc.</li><li><strong>Dave Ryan</strong> built <a href=\"https://twitter.com/0aveRyan/status/1499133526058274817\">a paid freelancer network</a>.</li><li><strong>Mike Little</strong> notes that <a href=\"https://t.co/6dfC8FaOMA\" target=\"_blank\" rel=\"noreferrer noopener\">imascientist.org.uk</a> is multisite and after 10 years is still adding new features.</li><li><strong>Marko Heijnen</strong> uses Multisite for <a href=\"https://twitter.com/markoheijnen/status/1499162972102569989\">content delivery to mobile apps</a>. Every site is a new clone of the app for a different person.</li><li><strong>Kathy Zant</strong> said &#8220;<a href=\"https://poststatus.slack.com/archives/CHNM7Q7T8/p1646255345840639\">We use it</a> at <strong>KadenceWP</strong> primarily to give customers the same login and maintaining state across numerous service.&#8221;</li><li><strong>Ross Wintle</strong> noted &#8220;a talk on WordPress.tv covers <a href=\"https://wordpress.tv/2016/06/07/kat-reeve-successfully-managing-a-multisite-system-or-how-we-helped-over-400-food-banks-online/\">an emergency food bank in the UK</a> using Multisite.&#8221;</li><li><strong>Mark Root-Wiley</strong> said <a href=\"https://poststatus.slack.com/archives/CHNM7Q7T8/p1646255345840639\">he built the site</a> of Communities in Schools of Washington (<a href=\"http://ciswa.org/\" target=\"_blank\" rel=\"noreferrer noopener\">ciswa.org</a>) and included all their affiliates on Multisite.</li></ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 06:31:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Dan Knauss\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"WPTavern: Gutenberg 12.7 Adds Multi-Block Selection in List View and Brings Margin Support to Group Blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130793\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"https://wptavern.com/gutenberg-12-7-adds-multi-block-selection-in-list-view-and-brings-margin-support-to-group-blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7753:\"<p class=\"has-drop-cap\">Another two weeks have flown by, and another Gutenberg plugin update is in the books. This release is not as feature-heavy as the last, but it feels solid overall. Other than one breaking issue, <a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\">version 12.7</a> includes several nice-to-have enhancements.</p>\n\n\n\n<p>The latest update includes some early work for a <a href=\"https://github.com/WordPress/gutenberg/pull/37978\">new style engine</a>. This is a longer-term project that should improve saving and rendering block styles.</p>\n\n\n\n<p>The template and site editors should <a href=\"https://github.com/WordPress/gutenberg/pull/38709\">surface patterns</a> over blocks in the quick inserter under certain conditions, such as at the root level of a template. However, I was unable to see this in action. I may need to refresh my install.</p>\n\n\n\n<p>The Columns block also <a href=\"https://github.com/WordPress/gutenberg/pull/31737\">supports border</a> width, style, color, and radius options. I look forward to this eventually being the case for all blocks.</p>\n\n\n\n<h2 id=\"multi-select-in-list-view\">Multi-Select in List View</h2>\n\n\n\n<img />Selecting multiple blocks in the list view.\n\n\n\n<p>Users can now <a href=\"https://github.com/WordPress/gutenberg/pull/38314\">select multiple blocks</a> in the list view when the <code>Shift</code> key is selected.  Once holding the key, users can use the mouse to click on others, adding or removing them.  The up/down arrow keys are an alternative to using the mouse.</p>\n\n\n\n<p>The enhancement also allows users to drag and drop the selected group of blocks.</p>\n\n\n\n<h2 id=\"broken-images\">Broken Images</h2>\n\n\n\n<img />Image from pattern not responsive.\n\n\n\n<p>I let my guard down. I became comfortable with WordPress and Gutenberg handling some of that foundational CSS work I had always included in past themes. Things seemed to be going so well.</p>\n\n\n\n<p><em>Gutenberg, you and I had a sweet streak going where you did not break anything.</em> Now, it is time to reset the ol&#8217; &#8220;releases without incident&#8221; counter.</p>\n\n\n\n<p>Previously, the default block library stylesheet provided baseline responsive styles for images. That <a href=\"https://github.com/WordPress/gutenberg/pull/39045\">CSS now only targets</a> <code>&lt;img></code> tags if they include <code>wp-image-</code> in a class. This is particularly problematic for images in some block patterns. The case may be the same for other image instances.</p>\n\n\n\n<p>The previous selector was overly broad and <a href=\"https://github.com/WordPress/gutenberg/issues/39021\">broke images in third-party plugins</a>.</p>\n\n\n\n<p>The best course of action is for theme authors to include the following CSS for images:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>img {\n    max-width: 100%;\n    height: auto;\n}</code></pre>\n\n\n\n<h2 id=\"group-block-margins\">Group Block Margins</h2>\n\n\n\n<img />Adding extra top margin to a Group block.\n\n\n\n<p>Customizing margins is almost synonymous with the term &#8220;web design.&#8221; The Group block &#8212; the flagship container &#8212; has lacked support for margin control until now. Some have gotten around this limitation by using a Spacer, but it only increases the space between blocks.</p>\n\n\n\n<p>Most issues have been around reducing margins. Theme designers have often needed to employ workarounds, a problem Nick Diego <a href=\"https://github.com/WordPress/gutenberg/pull/37344\">mentioned in the ticket</a>:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Theme developers (myself included) are resorting to &#8220;magic classes&#8221; to zero out, or modify, margins on blocks. Allowing themes to opt-in to Group margin support will provide greater flexibility and decrease the reliance on custom CSS/classes in the theme&#8217;s stylesheet.</p></blockquote>\n\n\n\n<p>Margin support is still missing for many other blocks, <a href=\"https://github.com/WordPress/gutenberg/pull/37300\">including paragraphs</a>. Users can always wrap them within a Group and modify it for now.</p>\n\n\n\n<h2 id=\"block-transformations-maintain-classes\">Block Transformations Maintain Classes</h2>\n\n\n\n<img />Custom block style class maintained when transforming a block.\n\n\n\n<p><a href=\"https://wptavern.com/gutenberg-12-6-enhances-transforming-blocks-adds-read-more-and-post-author-bio-blocks-and-enables-social-icon-labels\">Gutenberg 12.6</a>, released two weeks ago, saw much work on improving the block transforms, a feature that allows users to switch one block to another. One of the primary improvements in the previous update included maintaining font size and color options.</p>\n\n\n\n<p>Version 12.7 adds custom <a href=\"https://github.com/WordPress/gutenberg/pull/38964\">CSS classes to the mix</a>. This includes those users added manually and those added by the custom block styles mechanism.</p>\n\n\n\n<p>The upside of maintaining custom block style classes is that the new block keeps the selected style if supported. The downside is that it becomes a junk class if not.</p>\n\n\n\n<p>There are still some missing options that I would like to see maintained through transforming text-based blocks. In particular, keeping the text alignment the same would help with my workflow.</p>\n\n\n\n<h2 id=\"themes-can-register-patterns-from-the-directory\">Themes Can Register Patterns from the Directory</h2>\n\n\n\n<img />Inserting a registered pattern into the editor.\n\n\n\n<p>Gutenberg 12.7 allows theme authors to <a href=\"https://github.com/WordPress/gutenberg/pull/38323\">load patterns</a> from the WordPress.org pattern directory for their users. Those added will appear in their respective categories in the inserter.</p>\n\n\n\n<p>Currently, there is no method for highlighting the selected patterns, and they will only appear based on the order they were registered. Unfortunately, featured patterns from WordPress.org appear higher on the list, even if they were not selected by the theme.</p>\n\n\n\n<p>This is a solid first iteration. Getting it in now will allow theme authors to provide feedback and contributors to build upon the foundation.</p>\n\n\n\n<p>The <code>theme.json</code> how-to guide includes new <a href=\"https://developer.wordpress.org/block-editor/how-to-guides/themes/theme-json/#patterns\">documentation for registering these patterns</a>.</p>\n\n\n\n<h2 id=\"alignment-wrappers-removed\">Alignment Wrappers Removed</h2>\n\n\n\n<p>It is no secret that I am a block fanboy. However, there has been one longstanding issue that has almost made me want to ditch the system. Actually, I quit developing a free block theme altogether last year in large part because of this problem.</p>\n\n\n\n<p>Gutenberg 12.7 removes the extra <code>&lt;div></code> <a href=\"https://github.com/WordPress/gutenberg/pull/38613\">wrapper for wide and full-width blocks</a> in the editor, at least for themes that support the layout feature. This wrapper element created a conflict between the back and front-end designs previously. In some cases, theme authors couldn&#8217;t style them consistently.</p>\n\n\n\n<p>For example, if a theme author wanted to give extra spacing to a sibling block (one that follows another), it was impossible to target it in the editor with CSS. The additional wrapper meant they were no longer siblings in the document structure.</p>\n\n\n\n<p>The more recent <code>blockGap</code> feature, introduced in WordPress 5.9, alleviated spacing-related issues to some degree. It was enough relief to tolerate the broken system, knowing that some designs were still impossible.</p>\n\n\n\n<p>Today marks the start of a new world of possibilities for designers. This is one roadblock I am happy to see left behind. For the most part, I just want to revisit and implement several old ideas.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Mar 2022 02:28:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"Post Status: Podcast and Video Picks for the Week of February 28\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=94064\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://poststatus.com/podcast-and-video-picks-for-the-week-of-february-28/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2454:\"<h2 id=\"h-my-podcast-picks\">My Podcast Picks</h2>\n\n\n\n<ul><li><strong>WP Builds:</strong> <strong>Nathan Wrigley</strong> and <strong>David Waumsley</strong> talk about <a href=\"https://wpbuilds.com/2022/02/24/267-wheres-the-next-client-coming-from-series-1-episode-6/\">finding and landing new clients</a>.</li><li><strong>The ShopTalk Show:</strong> <strong>Jim Nielsen</strong> <a href=\"https://shoptalkshow.com/504/\">on blogging, writing a book, future vs backwards proofing, color, and images</a> on the web.</li><li><strong>WP Review:</strong> Joe asks and answers a hard question: &#8220;<a href=\"https://wpreview.io/how-can-you-be-a-wordpress-freelancer-in-2022/\">How can you can be a WordPress freelancer in 2022</a>?&#8221;</li><li><strong>How I Built It:</strong> <strong>Wes Kao</strong> shares <a href=\"https://howibuilt.it/creating-better-online-courses-that-you-can-charge-more-for-with-wes-kao/\">how to create better online courses and charge more for them</a>.</li><li><strong>Matt Report:</strong> Matt takes a <a href=\"https://mattreport.com/artificial-intelligence-for-wordpress/\">a look</a> into <a href=\"https://Bertha.ai\">Bertha.ai</a> and artificial intelligence for WordPress in general.</li><li><strong>Syntax.fm</strong>: <a href=\"https://syntax.fm/show/430/creator-of-wordle-josh-wardle\">Talk with the creator</a> of <strong>Wordle</strong> about it\'s tech stack and how it was sold.</li><li><strong>WP Tavern Jukebox</strong>: It\'s <strong>Jon Bossenger</strong> <a href=\"https://wptavern.com/podcast/16-jonathan-bossenger-on-cleaning-up-wordpress-notifications\">on admin notifications</a> and <strong>WP Notify</strong>.</li><li><strong>Growing Software Podcast:</strong> <strong>Brian Casel</strong> from <strong>ZipMessage</strong> talks through <a href=\"https://growing.software/episodes/25-brian-casel-of-zipmessage\">his journey in productized services</a>.</li></ul>\n\n\n\n<h2 id=\"h-videos-of-the-week\">Videos of the Week</h2>\n\n\n\n<ul><li><strong>Torque Social Hour</strong>: Yours truly (<strong>David Bisset</strong>) joined <strong>Chris Wiegman</strong> and <strong>Doc Popular</strong> to <a href=\"https://www.youtube.com/watch?v=UvjjMyBdFS8\">talk WordPress multisite</a> and some upcoming events you ought to know about.</li><li><strong>Jamie Marsland</strong> <a href=\"https://www.youtube.com/watch?v=WK9lD8l_D4k\">shows off</a> a new block theme from <strong>Rich Tabor</strong> called <strong>Wabi</strong>.</li></ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 03 Mar 2022 22:01:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"WPTavern: How the WordPress Community Is Supporting Ukraine’s Resistance Against Russian Invasion\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130764\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"https://wptavern.com/how-the-wordpress-community-is-supporting-ukraines-resistance-against-russian-invasion\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11970:\"<p>While Russia is decimating Ukrainian cities in an unlawful attempt to occupy the country, WordPress companies and individuals are seeking ways to help refugees fleeing the violence, as well as those who have stayed behind to fight. </p>\n\n\n\n<p>We are living in one of those rare times in history where events have captured the attention and hearts of people around the world, with a powerful unifying force. In the face of such unmitigated hostility and injustice, many feel helpless to make a difference, but the WordPress community is finding creative ways to support the brave efforts of the Ukrainian people.</p>\n\n\n\n<p>After identifying an attack on Ukrainian universities&#8217; websites that coincided with Russia&#8217;s invasion, Wordfence <a href=\"https://www.wordfence.com/blog/2022/03/ukraine-universities-hacked-by-brazilian-via-finland-as-russian-invasion-started/\">announced</a> it has enabled its real-time threat intelligence for more than 8,000 of its users on the Ukrainian .UA top-level domain (TLD) until further notice. Ordinarily, this is a paid feature. It includes a commercial-grade IP blocklist, real-time firewall rules, and real-time malware detection. </p>\n\n\n\n<p>&#8220;This is the first time in the history of our company that we are taking this action,&#8221; Defiant (makers of Wordfence) CEO Mark Maunder said. &#8220;We are doing it as a response to the crisis that has unfolded in Ukraine.&#8221;</p>\n\n\n\n<p><a href=\"https://servebolt.com/\">Servebolt</a>, a company that hosts WordPress sites, among other platforms, has offered free hosting to anyone working to help the Ukrainian people.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">These are troubled times for the people of  the Ukraine. The Ukrainian people need all the help they can get and we like to do our part.<br /><br />We’re offering for free hosting to anyone working to help out the Ukrainian people. <br /><br />Reach out to us via DM and we’ll help you set things up.</p>&mdash; Servebolt.com (@servebolt) <a href=\"https://twitter.com/servebolt/status/1498303033578602497?ref_src=twsrc%5Etfw\">February 28, 2022</a></blockquote>\n</div>\n\n\n\n<p> In one extraordinary individual effort that raised €3500, mainly from the WordPress community, Ines van Dijk, a mother of three, living in the Netherlands, drove 2500 km to Poland to donate items and chauffeur refugees. </p>\n\n\n\n<p>&#8220;Many, many people have been displaced&#8221;, she said. &#8220;I am unable to sit with that quietly and do nothing, so I decided to rent a van, load it up with things refugees might need, and drive to Poland.&#8221;</p>\n\n\n\n<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>She collected bags of clothing and blankets, personal items, bought food and water, and transported it to refugees in Poland.</p>\n\n\n\n<img />\n\n\n\n<p>One week after Russia began its invasion of Ukraine, more than <a href=\"https://apnews.com/article/russia-ukraine-vladimir-putin-volodymyr-zelenskyy-joe-biden-kyiv-1b396834ff3e753f8953d86c8db85383\">a million people have fled the country</a> in what the United Nations is calling the swiftest refugee exodus this century. Meanwhile, many have chosen to stay behind and some Ukraine-based companies are struggling to stay in business while sheltering for their lives.</p>\n\n\n\n<p><a href=\"https://crocoblock.com/\">Crocoblock</a>, a company with <a href=\"https://profiles.wordpress.org/crocoblock/\">plugins on WordPress.org</a> as well as commercial products, is made up of a 40+ person team of Ukrainians.  </p>\n\n\n\n<p>&#8220;Our team is located in three cities (Mykolaiv, Lviv, Kyiv),&#8221; Crocoblock Partner Manager Lana Miro said in an update on Post Status Slack. &#8220;We are safe, working somehow. Some stay in basements, some stay in apartments (and use the bathroom during air alarms). Our mood is optimistic and we believe/help our army. Thanks everyone for your support and everything will be fine.&#8221;</p>\n\n\n\n<p>Crocoblock has updated the banner on its site, which links to a <a href=\"https://savelife.in.ua/en/donate/\">donation page for the Ukrainian Army</a>. The banner references the last words of Ukrainian soldiers who were believed to have died defending Snake Island in the Black Sea. They may have been illegally captured by Putin&#8217;s forces but this has not yet been confirmed. Their brave last words have become a rallying cry, echoing the sentiments of pro-Ukrainian supporters around the world.</p>\n\n\n\n<img />\n\n\n\n<p>Paid Memberships Pro CEO Jason Coleman has written a tutorial on <a href=\"https://therealjasoncoleman.com/2022/03/02/heres-one-way-internet-businesses-of-any-kind-can-help-ukrainians-now/\">how internet businesses can find their Ukrainian customers</a> and email them to see how they can be of help. There are specific instructions in the article for those using the PMPro plugin can on how they can find users with a Ukrainian billing address, Ukrainian email addresses, or Ukrainian websites. It is also more broadly applicable to those using other CRM or e-commerce software solutions. </p>\n\n\n\n<p>The team at Codeable, a WordPress freelancer platform, is also working with its developers in Ukraine and Russia to support them in ensuring their clients still receive services.</p>\n\n\n\n<p>&#8220;We are a two sided marketplace between our developers and clients,&#8221; <a href=\"https://www.codeable.io/\">Codeable</a> Expert Community Development Lead Mike Demo said. &#8220;We are doing daily wellness checks, expedited payouts to our developers in Ukraine and Russia, and helping clients with Ukraine and Russian experts find alternative development help if needed at no cost to the client or money lost for the expert.&#8221;</p>\n\n\n\n<p>Earlier this week, Namecheap took a highly controversial approach to making a difference, <a href=\"https://news.ycombinator.com/item?id=30504812\">terminating service for Russian customers</a> with just six days&#8217; notice. (Namecheap has since revised the deadline to March 22). This includes Namecheap Hosting, EasyWP (Namecheap&#8217;s managed WordPress hosting), and Private Email with a domain provided by another registrar in zones .ru, .xn--p1ai (рф), .by, .xn--90ais (бел), and .su. </p>\n\n\n\n<p>The email to customers puts the onus on subjects of authoritarian rule, a tactic that sparked a fiery debate on Hacker News:  </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>“Unfortunately, due to the Russian regime’s war crimes and human rights violations in Ukraine, we will no longer be providing services to users registered in Russia. While we sympathize that this war may not affect your own views or opinion on the matter, the fact is, your authoritarian government is committing human rights abuses and engaging in war crimes so this is a policy decision we have made and will stand by.”</p></blockquote>\n\n\n\n<p>As sanctions are having a catastrophic effect on the Russian economy, and many Russians are scrambling to get out of the country, some contend that these measures are hurtful to those who are trying to help. One user on Hacker News, @_vtoj, highlighted <a href=\"https://news.ycombinator.com/item?id=30507142\">a few reasons</a> why this approach is problematic:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Dude, right now all of us are in deep shock, while:</p><p>&#8211; some are trying to find their relatives in Ukraine</p><p>&#8211; some are coordinating and volunteering</p><p>&#8211; some are trying to get themselves and their families outside of Russia (which gets harder by the minute because of prices and sanctions)</p><p>&#8211; some are trying to smuggle at least some of the money outside, because their entire life savings are now blocked</p><p>&#8211; some are trying to preserve what they have despite ruble and market crashing</p><p>&#8211; some are hunkering down with what they have and their loved ones, trying to stockpile some food before prices skyrocket</p><p>And no one has any time to cope and process anything &#8211; don&#8217;t forget usual workloads, too. Planning for a week feels like it&#8217;s already a strategic, not a tactical scope.</p><p>I get what you&#8217;re trying to do, but can&#8217;t you at least give more time for everyone? Right now I need to drop everything and migrate my DNS as well because my private email that I use for docs will stop working in 6 days. And to figure out how to pay the transfer fees while doing all that. It&#8217;s very much fucking stressful already.</p></blockquote>\n\n\n\n<p>GoDaddy, another major domain registrar and host, took a slightly different approach, <a href=\"https://aboutus.godaddy.net/newsroom/company-news/news-details/2022/How-GoDaddy-is-Supporting-Ukrainian-Customers/default.aspx\">announcing</a> today that the company is renewing, at no cost, any products or services that are set to expire in the next 60 days for Ukrainian customers. The company is also donating $500,000 to humanitarian relief in Ukraine and matching donations from employees, and providing assistance for Ukrainian contract workers.</p>\n\n\n\n<p>&#8220;What&#8217;s happened in Ukraine is horrible,&#8221; GoDaddy said. &#8220;We do not condone the unwarranted aggression from the Russian Government.&#8221;</p>\n\n\n\n<p>The company is also making specific business decision that impact Russian customers but may not affect existing customers as strongly as the Namecheap&#8217;s sanctions:</p>\n\n\n\n<ul><li>Removing the Russian version of our website&nbsp;</li><li>No longer supporting new registrations of .ru and .ru.com</li><li>Removing all .ru domain names from our domain name aftermarket</li><li>Removing the Russian Ruble</li></ul>\n\n\n\n<p>WordPress managed host WP Engine is donating to <a href=\"https://www.pah.org.pl/\">Polish Humanitarian Action</a> and the <a href=\"https://crisisrelief.un.org/t/ukraine\">Ukraine Humanitarian Fund</a>, as well as matching employee donations.</p>\n\n\n\n<p>If you are looking for ideas on where you can lend your support, longtime WordPress contributor and the co-organizer of the <a href=\"https://wptavern.com/kyiv-ukraine-to-host-its-first-official-wordcamp-in-september-2016\">first official WordCamp in Ukraine</a>, Andrey Savchenko, recommends donating to the <a href=\"https://bank.gov.ua/en/news/all/natsionalniy-bank-vidkriv-spetsrahunok-dlya-zboru-koshtiv-na-potrebi-armiyi\">Ukrainian Armed Forces</a> and <a href=\"https://savelife.in.ua/en/donate/\">Come Back Alive fund</a>. He is currently sheltering in Kyiv.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">I\'m of negative military value, but I can make money, so sending them to Ukrainian army &amp; Come Back Alive fund. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4b8.png\" alt=\"💸\" class=\"wp-smiley\" /><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4b8.png\" alt=\"💸\" class=\"wp-smiley\" /><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4b8.png\" alt=\"💸\" class=\"wp-smiley\" /><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4b8.png\" alt=\"💸\" class=\"wp-smiley\" /><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4b8.png\" alt=\"💸\" class=\"wp-smiley\" /><br /><br />I\'ve never taken donations for my WP&amp;OSS work, if you ever offered &#8211; send it to Ukrainian army now, like my life depends on it. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f64f.png\" alt=\"🙏\" class=\"wp-smiley\" /><a href=\"https://t.co/Yay5ux0xTT\">https://t.co/Yay5ux0xTT</a></p>&mdash; Andrey Savchenko (@Rarst) <a href=\"https://twitter.com/Rarst/status/1497516263597387782?ref_src=twsrc%5Etfw\">February 26, 2022</a></blockquote>\n</div>\n\n\n\n<p>These are a few examples of the ways the WordPress community and broader hosting communities are using their influence and resources to help with relief efforts. If your company is launching an effort that was missed here, feel free to leave information about it in the comments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 03 Mar 2022 21:52:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"Post Status: The Block Editor: Kid Tested, Client-Approved\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=94096\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://poststatus.com/the-block-editor-kid-tested-client-approved/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4327:\"<p class=\"has-theme-palette-7-background-color has-background has-medium-font-size\">It’s BobWP’s WooSnippet for the week of February 28, 2022! Get the lowdown on what’s new in the world of WooCommerce.</p>\n\n\n\n<h2 id=\"woocommerce-6-3-rc2-and-woocommerce-blocks-7-1-0-released\">WooCommerce 6.3 RC2 and WooCommerce Blocks 7.1.0 Released</h2>\n\n\n\n<p class=\"has-drop-cap\">This last week has been busy over at WooCommerce. The <a href=\"https://developer.woocommerce.com/2022/02/28/woocommerce-6-3-rc-2/\">second release candidate for 6.3</a> dropped as we near the March 8th final release. In RC2, WooCommerce Admin has been updated from 3.2.0 to 3.2.1 — the <a href=\"https://github.com/woocommerce/woocommerce-admin/blob/main/changelog.txt\">changelog is available here</a>. Two <a href=\"https://developer.woocommerce.com/2022/02/22/woocommerce-6-2-1-security-fix/\">security fixes</a> addressed the permission check for reviews in v1 & v2 REST API and Path Traversal in Importers. </p>\n\n\n\n<p>In addition, <a href=\"https://developer.woocommerce.com/2022/03/01/woocommerce-blocks-7-1-0-release-notes/\">WooCommerce Blocks 7.1.0</a> came out with Global Styles support for more blocks and improved editor capabilities. </p>\n\n\n\n<h2 id=\"guidelines-for-adding-actions-and-filters\">Guidelines for Adding Actions and Filters</h2>\n\n\n\n<p>New <a href=\"https://developer.woocommerce.com/2022/03/01/adding-and-modifying-actions-and-filters/\">guidelines for adding and modifying actions and filters</a> are available on GitHub in the WooCommerce project Wiki. The guidelines bring clarity to the kinds of changes that are acceptable &#8220;and to reduce unnecessary back-and-forth during the code review process.&#8221;</p>\n\n\n\n<h2 id=\"block-editor-passes-the-twelve-year-old-test\">Block Editor Passes the Twelve-Year-Old Test</h2>\n\n\n\n<p>We had a chance to <a href=\"https://dothewoo.io/writer-developer-woocommerce-builder/\">chat with developer and writer Eric Karkovack</a> about Woo and a lot more. Eric shared some insights around the challenges facing WooCommerce site-builders by being a bit too &#8220;piecemeal.&#8221; Eric also talks about his experience with Gutenberg and clients\' reactions to it, as well as his 12-year-old daughter as he helped her set up her own site:  </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;In fact, I set my daughter up on a blog with wordpress.com the other day, and she wants to do a blog about pets and Harry Potter. So I set her up with this, right? </p><p>And I\'m going to start explaining all the good stuff with the blog editor. And here\'s what you do. You hit the plus button and she just looks at me and says, &#8220;Dad, you can go now. I\'m fine.&#8221; I come back an hour later and she\'s already got it figured out.&#8221;</p></blockquote>\n\n\n\n<h2 id=\"h-stress-management-developers-and-remote-work\">Stress Management, Developers, and Remote Work</h2>\n\n\n\n<p>Finally, we all know developers are no strangers to stress. Four of the speakers from WordFest share <a href=\"https://dothewoo.io/tips-how-to-handle-stress-as-a-woocommerce-developer/\">some tips for Woo builders on how to handle the stress of remote work</a>. These are great ideas all developers will appreciate.</p>\n\n\n\n<div class=\"wp-container-62267c621422c wp-block-group\"><div class=\"wp-block-group__inner-container\">\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile has-background\"><a href=\"https://dothewoo.io/post-status-members/\"><img width=\"400\" height=\"400\" src=\"https://cdn.poststatus.com/wp-content/uploads/2022/02/hg1C04vb_400x400.jpg\" alt=\"Do the Woo\" class=\"wp-image-93517 size-full\" /></a><div class=\"wp-block-media-text__content\">\n<p class=\"has-text-align-left\" id=\"h-get-ready-for-remote-work\"><strong><strong>Do the Wo</strong>o!</strong> <a href=\"https://dothewoo.io/subscribe\" target=\"_blank\" rel=\"noreferrer noopener\">Get the Podcast</a>. <a href=\"https://dothewoo.io/subscribe\" target=\"_blank\" rel=\"noreferrer noopener\">Subscribe to the Newsletter</a>.</p>\n\n\n\n<p>Learn from others. Grow your business. Connect with a community of like-minded developers and builders who freelance, run agencies, and build really cool products and sites in the <strong>WooCommerce</strong> ecosystem.</p>\n</div></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n</div></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 03 Mar 2022 19:15:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Bob Dunn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"WPTavern: WordPress Ditches “Pee” and “Tinkle” Jokes in Favor of More Inclusive Language and Clearer Code\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130767\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:112:\"https://wptavern.com/wordpress-ditches-pee-and-tinkle-jokes-in-favor-of-more-inclusive-language-and-clearer-code\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5668:\"<p class=\"has-drop-cap\">It feels like the end of an era. Last week, core contributors <a href=\"https://core.trac.wordpress.org/changeset/52789\">merged a patch</a> that removed PHP variables named <code>$pee</code> and <code>$tinkle</code> from the WordPress codebase.</p>\n\n\n\n<p>Yes, the software that powers 43% of the web has pee-pee jokes in its code.</p>\n\n\n\n<p><em>I know how it sounds. I felt silly writing that sentence.</em></p>\n\n\n\n<p>My job as a writer for WP Tavern affords me the luxury of taking creative license with words every now and again. However, it is a rare treat to write about pee-pee jokes. The chance to do so will not likely come around again. While I could pull out a few doozies from childhood, I promise to remain as professional as possible, given the subject matter.</p>\n\n\n\n<p>The vast majority of users are likely unaware of this joke unless they enjoy trawling through the 6,000+ lines of code in <code>/wp-includes/formatting.php</code>. There is a good chance that any developer who has looked up the <a href=\"https://developer.wordpress.org/reference/functions/wpautop/\"><code>wpautop()</code> function</a> has stumbled upon it.</p>\n\n\n\n<p>Reading through the code can garner a chuckle from a few, but it is a momentary amusement. The problem has always been confusing variable names. In programming, clarity should be favored above all else.</p>\n\n\n\n<p><em>What is a <code>$pee</code>, exactly?</em> It is text. Therefore, <code>$text</code> makes sense as a variable name, which is one of recent code changes. Other modifications include:</p>\n\n\n\n<ul><li><code>$pee_parts</code> to <code>$text_parts</code></li><li><code>$last_pee</code> to <code>$last_part</code></li><li><code>$pees</code> to <code>$paragraphs</code></li><li><code>$tinkle</code> to <code>$paragraph</code></li></ul>\n\n\n\n<p>That complex <code>wpautop()</code> function and its 150+ lines of code start making a bit more sense when things are named for clarity.</p>\n\n\n\n<p>For the historical record: <code>$pee</code> was first seen in the WordPress codebase <a href=\"https://core.trac.wordpress.org/changeset/13\">in 2003</a>. <code>$tinkle</code> did not make an appearance until <a href=\"https://core.trac.wordpress.org/changeset/9255\">five years later</a>.</p>\n\n\n\n<p>Developer Rico Moorman asked for the problematic code to be changed in a <a href=\"https://core.trac.wordpress.org/ticket/25615\">ticket in 2013</a>. There was some movement to replace the variable names at first. However, after several lead developers stepped in, the idea was shot down. The arguments against the change leaned on keeping the spirit of WordPress, its humor, and its history alive.</p>\n\n\n\n<p>However, 2022 is not 2013. The world has changed since the ticket was first opened. While it still has miles to go to be the all-inclusive community it can be, the WordPress space is seemingly more open to checking itself on language issues today.</p>\n\n\n\n<p>In 2020, when many in the worldwide developer community <a href=\"https://wptavern.com/github-to-use-main-instead-of-master-as-the-default-branch-on-all-new-repositories-starting-next-month\">switched their default Git repos</a> from &#8220;master&#8221; to &#8220;main,&#8221; <a href=\"https://wptavern.com/proposal-to-rename-the-master-branch-from-wordpress-owned-git-repositories\">WordPress followed suit</a>. And, it managed to keep a bit of the charm of its SVN roots by using &#8220;trunk&#8221; instead.</p>\n\n\n\n<p>In 2018, contributors <a href=\"https://wptavern.com/without-context-some-lyrics-inside-the-hello-dolly-plugin-are-degrading-to-women\">changed text in the Hello Dolly plugin</a> that was degrading to women, especially out of context. The plugin ships with WordPress and randomly displays a single line from Louis Armstrong&#8217;s &#8220;Hello, Dolly!&#8221; in the admin header. </p>\n\n\n\n<p>The two offending lines were:</p>\n\n\n\n<ul><li>&#8220;Find her an empty lap, fellas&#8221;</li><li>&#8220;Find her a vacant knee, fellas&#8221;</li></ul>\n\n\n\n<p>Along with some other trivial text changes, the former was removed altogether, and the latter was replaced with &#8220;Have a little faith in me, fellas.&#8221;</p>\n\n\n\n<p>The world changes over time. Language evolves, and what may have been acceptable in years past will not always be so in the future.</p>\n\n\n\n<p>Some lead developers may have been OK with the code in 2013. However, the community should never be afraid to reevaluate past stances once in a while. Maybe it was time to ditch the fine art of middle-school jokes in favor of clear and readable code.</p>\n\n\n\n<p>Miriam Schwab renewed the discussion via the Post Status Slack chat in December 2021. The general sense from those in the conversation seemed to agree that it was not necessarily offensive but immature. Most of all, it did not have a place in modern WordPress. A team member of Schwab&#8217;s had found the code and also <a href=\"https://core.trac.wordpress.org/ticket/25615#comment:22\">renewed the Trac ticket discussion</a>.</p>\n\n\n\n<p>During this go-round, there was no pushback. It was simply time to say farewell to a part of the platform&#8217;s history.</p>\n\n\n\n<p>In this instance, WordPress has not lost any of its personality. Plus ,the variable changes will allow more developers to grasp what is happening in the code.</p>\n\n\n\n<p>This does mean that WordPress has a vacancy for at least one new joke or Easter egg. I am still a little salty about losing <a href=\"https://wptavern.com/wordpress-personality-shines-through-again\">access to the Matrix</a>. But, it never hurts to mix it up once in a while. WordPress&#8217;s in-jokes should continue maturing along with the software.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 03 Mar 2022 01:15:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"Post Status: This Week at WordPress.org (February 28, 2022)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=94069\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://poststatus.com/this-week-at-wordpress-org-february-28-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5332:\"<p>Each week we are highlighting the news from WordPress.org that you don\'t want to miss.  If you or your company create products or services that use WordPress, we\'ve got the news you need to know. Be sure to share this resource with your product and project managers.</p>\n\n\n\n<h2 id=\"h-news\"><a href=\"http://wordpress.org/news\">News</a></h2>\n\n\n\n<ul><li><a href=\"https://wordpress.org/news/2022/02/people-of-wordpress-tonya-mork/\">People of WordPress: Tonya Mork</a></li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n<h2 id=\"h-core\"><a href=\"https://make.wordpress.org/core\">Core</a> </h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/03/03/core-editor-improvement-choose-your-style/\">Core Editor Improvement: Choose your Style</a></li><li><a href=\"https://make.wordpress.org/core/2022/03/02/whats-new-in-gutenberg-12-7-2-march/\">What’s new in Gutenberg 12.7? (2 March)</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/28/a-week-in-core-february-28-2022/\">A Week in Core – February 28, 2022</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/25/proposal-to-start-a-news-blog-on-developer-wordpress-org/\">Proposal to Start a News blog on developer.WordPress.org</a></li></ul>\n\n\n\n<h2 id=\"h-design\"><a href=\"https://make.wordpress.org/design\">Design</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/design/2022/02/15/show-and-tell-february-2022/\"></a><a href=\"https://make.wordpress.org/design/2022/02/28/design-share-feb-14-25/\">Design Share: Feb 14–25</a></li></ul>\n\n\n\n<h2 id=\"h-docs\"><a href=\"https://make.wordpress.org/docs\">Docs</a>:</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/updates/2022/02/28/documentation-team-update-february-28-2022/\">Documentation Team Update – February 28, 2022</a></li></ul>\n\n\n\n<h2 id=\"h-photos\">Photos</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/photos/2022/02/23/photo-directory-team-rep-nominations-for-2022/\">Photo Directory Team Rep Nominations for 2022</a></li></ul>\n\n\n\n<h2 id=\"h-plugins\"><a href=\"https://make.wordpress.org/plugins\">Plugins</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/updates/2022/02/22/plugin-review-team-21-february-2022/\"></a><a href=\"https://make.wordpress.org/updates/2022/02/28/plugin-review-team-update-28-feb-2022/\">Plugin Review Team Update: 28 Feb 2022</a></li></ul>\n</div>\n\n\n\n<div class=\"wp-block-column\">\n<h2 id=\"h-test\"><a href=\"https://make.wordpress.org/test\">Test</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/test/2022/02/23/fse-program-testing-call-12-hyping-headers/\">FSE Program Testing Call #12: Hyping Headers</a></li></ul>\n\n\n\n<h2 id=\"h-themes\"><a href=\"https://make.wordpress.org/themes\">Themes</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/updates/2022/02/22/themes-team-update-february-22-2022/\"></a><a href=\"https://make.wordpress.org/updates/2022/03/02/themes-team-update-march-02-2022/\">Themes team update March 02, 2022</a></li></ul>\n\n\n\n<h2 id=\"h-training\"><a href=\"https://make.wordpress.org/training\">Training</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/updates/2022/02/28/whats-new-on-learnwp-in-february-2022/\">What’s new on LearnWP in February 2022</a></li><li><a href=\"https://make.wordpress.org/training/2022/01/31/faculty-program-structure-proposal/\">Faculty Program: Structure Proposal</a></li></ul>\n\n\n\n<h4 id=\"h-workshops\">Workshops</h4>\n\n\n\n<ul><li><a href=\"https://learn.wordpress.org/workshop/building-sidebars-with-the-site-editor/\">Building Sidebars With the Site Editor</a></li><li><a href=\"https://learn.wordpress.org/workshop/intro-to-the-site-editor-and-template-editor/\">Intro to the Site Editor and Template Editor</a></li></ul>\n\n\n\n<h4 id=\"h-social-learning-spaces\">Social Learning Spaces:</h4>\n\n\n\n<ul><li><a href=\"https://learn.wordpress.org/social-learning/\">Calendar</a></li></ul>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile has-background\"><a href=\"https://poststatus.com/\"><img src=\"https://cdn.poststatus.com/wp-content/uploads/2021/09/vertical-post-status-logo-250.png\" alt=\"Post Status\" class=\"wp-image-85823 size-full\" /></a><div class=\"wp-block-media-text__content\">\n<p class=\"has-text-align-left has-normal-font-size\" id=\"h-get-ready-for-remote-work\">You — and <a href=\"https://poststatus.com/business-membership/\">your whole team</a> can <a href=\"https://poststatus.com/post-status-membership-club/\">Join Post Status</a> too!</p>\n\n\n\n<p class=\"has-text-align-left has-small-font-size\"><strong>Build your network. Learn with others. Find your next job — or your next hire.</strong> Read the <strong>Post Status</strong> <a href=\"https://poststatus.com/newsletter/\">newsletter</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/2709.png\" alt=\"✉\" class=\"wp-smiley\" /> Listen to <a href=\"https://poststatus.com/podcasts/\">podcasts</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f399.png\" alt=\"🎙\" class=\"wp-smiley\" /> Follow <a href=\"https://twitter.com/post_status/\">@Post_Status</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f426.png\" alt=\"🐦\" class=\"wp-smiley\" /></p>\n</div></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 02 Mar 2022 17:57:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Courtney Robertson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: #16 – Jonathan Bossenger on Cleaning Up WordPress Notifications\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wptavern.com/?post_type=podcast&p=130378\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"https://wptavern.com/podcast/16-jonathan-bossenger-on-cleaning-up-wordpress-notifications\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:55116:\"<p>On the podcast today we have <a href=\"https://twitter.com/jon_bossenger\">Jonathan Bossenger</a>.</p>\n\n\n\n<p>He’s here to talk about WordPress notifications and how they are managed.</p>\n\n\n\n<p>If you’ve been using WordPress for any length of time, then you&#8217;ll have seen notifications appear in the admin area of your site. These messages can be useful, they might tell you that something needs to be updated, or that something was successfully saved.</p>\n\n\n\n<p>There’s also a chance that you’ve seen notifications for other purposes as well. Perhaps a plugin would like you to notice their upgrade offer, or that they have a sale on.</p>\n\n\n\n<p>All these notifications fall into the same place, and when multiple of them arise at the same time, the admin area can become cluttered and confusing, especially for novice users.</p>\n\n\n\n<p>It’s possible that you don’t mind these notifications, but it seems that many people do, and feel that they’re being overused. They would prefer not to see so many notifications, and if notifications are to appear, that there are limitations on what they can show, and how large they can be.</p>\n\n\n\n<p>In the podcast Jonathan talks about his concerns regarding WordPress notifications, and the fact that there’s no system in place to limit what they can display and for what purpose.</p>\n\n\n\n<p>He’s currently working on WP Notify, which is a project aiming to put a notifications area in to your WordPress website. All notifications would appear in this area, and there would be constraints about what could, and could not, be displayed there.</p>\n\n\n\n<p>It’s not about removing notifications completely, more about putting them in a defined place, like you might find on your mobile phone.</p>\n\n\n\n<p>We talk about how notifications are currently created and how there are few limits on what they can do. How overuse of notifications can be a cause for concern, and how Jonathan’s solution aims to add a unified system to WordPress which would put the user in control of the notifications.</p>\n\n\n\n<h2 id=\"useful-links\">Useful links.</h2>\n\n\n\n<p><a href=\"https://jonathanbossenger.com/about/\">Jonathan&#8217;s website</a></p>\n\n\n\n<p><a href=\"https://github.com/WordPress/wp-notify\">WP Notify on GitHub</a></p>\n\n\n\nTranscript<div>\n<p>[00:00:00] <strong>Nathan Wrigley:</strong> Welcome to the Jukebox podcast from WP Tavern. My name is Nathan Wrigley. Jukebox is a podcast which is dedicated to all things WordPress. The people, the events, the plugins, the blocks, the themes, and in this case, the way that we manage announcements in the WordPress admin. If you&#8217;d like to subscribe to the podcast, you can do that by searching for WP Tavern in your podcast player of choice, or by going to WP Tavern dot com forward slash feed forward slash podcast. And you can copy that URL into most podcast players.</p>\n\n\n\n<p>I&#8217;d really like to hear from anyone out there who would like to come on the podcast and talk about whatever it is that you do with WordPress. It might be that you&#8217;re a developer, a WordCamp organizer contributor, a designer. Honestly, if it&#8217;s about WordPress, I&#8217;m keen to hear from you, and hopefully get you on the show. Head over to WP Tavern dot com forward slash contact forward slash jukebox. And you use the contact form there.</p>\n\n\n\n<p>So on the podcast today, we have Jonathan Bossenger. He&#8217;s here to talk about WordPress notifications and how they are managed. If you&#8217;ve been using WordPress for any length of time, then you&#8217;ll have seen notifications appear in the admin area of your site. These messages can be useful. They might tell you something needs to be updated. Or that something was successfully saved. There&#8217;s also a chance that you&#8217;ve seen notifications for other purposes as well. Perhaps a plugin would like you to notice their upgrade offer, or that they have a sale on. All these notifications fall into the same place, and when multiple of them arise at the same time, the admin area can become cluttered and confusing, especially for novice users.</p>\n\n\n\n<p>It&#8217;s possible that you don&#8217;t mind these notifications, but it seems that many people do, and feel that they&#8217;re being overused. They would prefer not to see so many notifications. And if notifications are to appear, that there are limitations on what they can show, and how large they can be.</p>\n\n\n\n<p>In the podcast, Jonathan talks about his concerns regarding WordPress notifications and the fact that there&#8217;s no system in place to limit what they can display, and for what purpose. He&#8217;s currently working on WP Notify, which is a project aiming to put a notifications area into your WordPress website. All notifications would appear in this area and there would be constraints about what you could and could not display there. It&#8217;s not about removing notifications completely, more about putting them in a defined place. Like you might find on your mobile phone. We talk about how notifications are currently created and how there are a few limits on what they can do. How over use of notifications can be a cause for concern, and how Jonathan&#8217;s solution aims to add a unified system to WordPress, which would put the user in control of the notifications.</p>\n\n\n\n<p>If you&#8217;re interested in finding out more, you can find all the links in the show notes over at WP Tavern dot com forward slash podcast, and look for episode number 16. And so without further delay, I bring you Jonathan Bossenger.</p>\n\n\n\n<p>I am joined on the podcast today by Jonathan Bassinger. Hello Jonathan?</p>\n\n\n\n<p>[00:04:01] <strong>Jonathan Bossenger:</strong> Hello, Nathan, how are you?</p>\n\n\n\n<p>[00:04:02] <strong>Nathan Wrigley:</strong> I&#8217;m very well. Jonathan is joining us today to talk about WordPress notifications. Now I could introduce this subject and say all sorts of things off the bat. My thoughts on things, but it would probably muddy the water.</p>\n\n\n\n<p>So Jonathan, it&#8217;s over to you. Tell us about WordPress notifications and the issues that you see, and then we&#8217;ll get into the weeds and discuss the finer points.</p>\n\n\n\n<p>[00:04:26] <strong>Jonathan Bossenger:</strong> Sure. No problem. So, before I start, I&#8217;d like to mention that my problems with WordPress notifications come from both the point of view of a contributor to WordPress, and also a person who makes money off WordPress.</p>\n\n\n\n<p>So some of the first products that I created for WordPress were plugins and part of those plugins required me to give some kind of feedback to the user if they had saved settings, or if there was some change that they had to make or whatever the case may be. And then from there I moved on to building plugins for clients or doing custom work.</p>\n\n\n\n<p>And the point that I noticed that there was a problem as it were with notifications was when I used to log into client&#8217;s websites, as a new administrator and I was flooded with, and I&#8217;m sure we&#8217;ve all seen the screenshots of this on social media, but flooded with notifications from this plugin that has just been updated to, this plugin has an upgrade, a paid upgrade to this plugin is just on this over here. This theme has got this, that, and the next thing. And I&#8217;m reading half a page, sometimes a full page, of notifications before I can even start working with the dashboard. The, in big inverted air-quotes, problem with notifications is the fact that there is no official centralized way to register and present notifications to the user other than using admin notices.</p>\n\n\n\n<p>So if you&#8217;re a developer of a plugin or developer of a theme, there is the admin notices hook that you can hook into, but you can pretty much hook any HTML into that hook. So the documentation gives you some guidelines as to status classes that you can use for your div to display it in red or green as a success or an error, but you have full leeway to build anything you want there.</p>\n\n\n\n<p>So you could build a full page notification. You could build a tiny notification. They are guidelines in the plugin and theme handbooks that gives you guidelines of what you should do and what you should stick to. But there&#8217;s nothing to force you down that path. And with notifications. These admin notices traditionally should be being used to give the user feedback.</p>\n\n\n\n<p>So I&#8217;ve created a post, I hit save, and I need to see a message that says, yay, my post has been saved. This admin notices functionality is now being, and I don&#8217;t want to use the word abused, so I&#8217;m not going to, but overused by folks who are trying to give the user some other form of notification, some other piece of messaging, some other piece of information.</p>\n\n\n\n<p>[00:07:01] <strong>Nathan Wrigley:</strong> So the problem is a historical one in that WordPress core has the capacity to pop-up things, which presumably the intention was that anybody who wished to use these would have something legitimate to say. As you say, post has been saved, something has been deleted and so on, and there are no constraints around really what you can put in there.</p>\n\n\n\n<p>It could be enormous. It could be very wordy. It could contain images, animated gifts, and so on. And there&#8217;s no real constraints about the way that it can be implemented. And I think for the most experienced users of WordPress, that is to say somebody that&#8217;s dabbling in there everyday, you kind of become a little bit numb to it and you just log into WordPress and immediately dismiss them all, click whatever option is available to make them go away.</p>\n\n\n\n<p>But there they were and clients, people less experienced, I think the problem might reside in the fact that they might cause some sort of alarm, you know, it might be, oh, well, why is that appearing? There&#8217;s probably some kind of upgrade that I should have had. Why haven&#8217;t I got the upgrade and so on and so forth.</p>\n\n\n\n<p>So it&#8217;s a historical problem. Do you know, roughly speaking, how far do we need to rewind the clock before the, in inverted commas, over use of these began. When was the first time you saw this being used for ulterior motives?</p>\n\n\n\n<p>[00:08:23] <strong>Jonathan Bossenger:</strong> So it&#8217;s difficult for me to say that 100%, because I&#8217;ve only been very active in the WordPress space since around 2015.</p>\n\n\n\n<p>I use WordPress as a blogging platform from about 2009, but that&#8217;s, as far as it went, I had a blog. I had maybe a security plugin installed, maybe a forms plugin, but I was just using it for blogging purposes. So it was only in 2015, 2016 that I started building for WordPress that I started seeing, personally seeing these issues.</p>\n\n\n\n<p>I would say that since it&#8217;s definitely gotten worse. There was a stage in about 2017, 2018 that I started seeing it more and more and more. The thing that you mentioned earlier about, you know, as an experienced user of WordPress, we see these notifications. We know how to dismiss them. We know how to click. The concern that I always have is never mind somebody who&#8217;s a client, nevermind somebody who is a business owner. Let&#8217;s just look at somebody who wants to blog with WordPress or build themselves as simple website with WordPress. What is the user story gonna look like? They&#8217;re going to either through their hosting company, they&#8217;re going to install WordPress through some kind of one-click install.</p>\n\n\n\n<p>Maybe they&#8217;re using a managed hosting environment, which does it all for you. Maybe they&#8217;re technically savvy enough to download the zip file and upload it to a server. They&#8217;re going to install it. They&#8217;re going to start using it. They&#8217;re going to need to have, maybe a contact form. They&#8217;re going to need to maybe have some kind of plug-in functionality.</p>\n\n\n\n<p>They&#8217;re going to start looking for plugins to install things. Then as you say, suddenly, they&#8217;re going to see these messages and these messages are going to be jumping out at them. And these messages are different sizes and different shapes, and it just creates this very jagged, jarring experience for the new user.</p>\n\n\n\n<p>Now we can&#8217;t blame WordPress because WordPress Core itself is using admin notices correctly. We can&#8217;t really blame plugin developers and theme developers because, they&#8217;re trying to get this information to the user, with a system that&#8217;s not designed for it. So the problem is not one single entity&#8217;s problem.</p>\n\n\n\n<p>The problem is all of our problems. That&#8217;s the kind of the way I look at it. We all need to work together with WordPress Core, with plugin developers, with team developers and find a better way to register these, non, I don&#8217;t like to call them notifications because to me a notification is&#8230; your post has been saved successfully, or you have created a new post.</p>\n\n\n\n<p>So let&#8217;s call them announcements just for the sake of this podcast. We need to find a way to register these announcements that are outside of the scope of the day-to-day use of WordPress and present them to the user in a way that is clean and nice, and doesn&#8217;t, doesn&#8217;t disturb them using WordPress on a day to day, but is accessible and they can, and they can see the information that they see in a, in a way that is formalised.</p>\n\n\n\n<p>[00:11:23] <strong>Nathan Wrigley:</strong> Do you think then the notifications that we have at the moment, which can consume any HTML, let&#8217;s imagine that nothing additional were to be added into WordPress, and we&#8217;ll get on to your project a little bit later, but if we were simply to have it that just text could go in there and that text could be limited, say to a certain string length, I don&#8217;t know, 30 characters or something.</p>\n\n\n\n<p>Would that potentially solve the problem in your eyes? Or are there situations where anyone may need more than that, because obviously if we just limited it to text, we could still put all sorts of interesting and perhaps unwanted messages in there.</p>\n\n\n\n<p>[00:11:58] <strong>Jonathan Bossenger:</strong> So I speak to you now as a developer. And let me tell you that if you put some kind of limitation down, some clever developer will come along and figure out how to work around this. As it is, you know, the admin, the admin notice the system as it is, is kind of restrictive, but the only way that you could physically restrict it, is if you, every time a new plugin submission comes in, you had somebody physically inspecting every single instance of the notification system and making sure that this person was following the guidelines. And I&#8217;m sure we all remember a number of years ago that the theme team was kind of coming under fire because they were taking a long time to review themes.</p>\n\n\n\n<p>And that was because everything was still being done manually. The plugging team is a small number of people due to the security that&#8217;s involved in getting plugin submitted and what plugins have to deal with. So expecting a team of people to physically inspect every single admin notice that comes through. I mean, sure, you could probably automate it in some way, but we all know that developers are crafty. We all know that developers, I mean, that&#8217;s part of what being developed is, finding ways to solve difficult problems. So you put a constraint down in front of a developer on an open source project, you know, code that is publicly available.</p>\n\n\n\n<p>And say, right, we&#8217;re now stopping you from doing X. They&#8217;re going to find a way. So to me it&#8217;s a little bit less of the stick and more of the carrot. We need to provide a way that gives developers the ability specifically, and I speak now as somebody who failed dismally to try and start a plugin business.</p>\n\n\n\n<p>But one of the biggest things that I struggled with was marketing. How do I market my paid products off of my free ones? You know, WordPress dot org plugin repository and the theme repository is, we all know this, is one of the top places to get yourself known, put out a free product, get customers into the funnel, but then how do you turn them into paying customers?</p>\n\n\n\n<p>We know we have a problem with sponsorship of open source products. It&#8217;s spoken about all the time. How do we, how do we balance the needs of the open source project and the people that are building plugins for it and how do we balance the need for them to market to their customers, to, to bring, you know, free customers into the paying funnel, in a way that isn&#8217;t disruptive to regular users of WordPress?</p>\n\n\n\n<p>And in my opinion, the only way that we can do that is by creating something that is well-defined in terms of, this is how you do things, this is how you register things. But it&#8217;s not, it&#8217;s not being thrown into the user&#8217;s face when they want to see that information. To me, that&#8217;s the only way that, that we do it in</p>\n\n\n\n<p>[00:14:34] <strong>Nathan Wrigley:</strong> In terms of describing problematic notifications or announcements or whatever term we&#8217;d like to use. There must be a point where in your own mind it strays from being, well, that&#8217;s totally acceptable. Everybody ought to be seeing that. And then there&#8217;s some kind of gray area, no man&#8217;s land where that feels a bit shady, I&#8217;m not quite sure what to make of that. And then presumably there are examples which you could mention where it&#8217;s clearly something that you would strongly urge people not to do.</p>\n\n\n\n<p>Do you want to just describe examples of maybe things which you think are totally legitimate and then also some examples, we should probably not use any names, examples where you&#8217;ve seen things that you think actually, I think that you&#8217;re pushing a little bit too hard then.</p>\n\n\n\n<p>[00:15:19] <strong>Jonathan Bossenger:</strong> Sure. I can definitely give some examples. I won&#8217;t give names because that&#8217;s just not something I want to start doing right now, but I can give you some personal examples of notifications that I&#8217;ve dealt with.</p>\n\n\n\n<p>For those of you who don&#8217;t know, I used to be a developer for a company called Castos. We managed a podcasting plugin for WordPress. And at that stage, I was very focused on making sure that our notifications were not disruptive to our users or any other user of the WordPress site that happened to have the plugin installed.</p>\n\n\n\n<p>So as an example, our one, let&#8217;s call it onboarding form to try and get customers to sign up for our podcast hosting service, was only available on the plugin settings page. So only when you went to the plugin settings on the right-hand side, there was a nice little sidebar with a little graphic to say, hey, if you&#8217;re enjoying the plugin, but you&#8217;re looking for a way to host your files, here&#8217;s a form you can fill in. We&#8217;ll give you a 10% discount to try it out. To me, that&#8217;s not disruptive, because the user can still use their settings. They can still make changes. They&#8217;re not seeing this notification at the top of the screen in their face every time, it&#8217;s off to the right. It&#8217;s there, it&#8217;s visible, but it&#8217;s not disruptive.</p>\n\n\n\n<p>The other thing we were very focused on is when we do update messages. So when the plugin gets updated, if there&#8217;s some kind of process that needs to be run, maybe there&#8217;s a database upgrade that needs to be run. That to me makes sense as a, let&#8217;s call it a site-wide notice, or a more general admin notice, but we kept them very limited. Maybe one sentence. We didn&#8217;t use the red color or the green color, we just kept it gray and just said, hey, we noticed you&#8217;ve recently updated. Here&#8217;s a link to click through to make the changes. But specific things related to the plugin. So if we would, I can actually give you a perfect example. There were some changes in the Apple podcast categories and Apple podcasting was changing how the categories worked.</p>\n\n\n\n<p>And so what we did was, if you loaded up the plugin and you updated the plugin, you saw no messages, you saw no notifications, you could carry on doing your things, because it would all just work. When you went to the page that allows you to control your categories, there we showed you a specific message to say, by the way, did you know Apple have recently updated their categories, your old categories are still going to work, but it would be a good idea to change your categories on this page. And then as soon as the person saved that page, that notification goes away. So to me, that&#8217;s an example of how, as a developer, you can sort of think of, you know, how do I get free users onto the paid version?</p>\n\n\n\n<p>You know, how do I display relevant information to the user? Some of the bad things that I&#8217;ve seen, there are a couple of popular page builders that I won&#8217;t name. I think I might&#8217;ve tweeted about it. So maybe if you go back in my feed, you might find. With the Block Editor coming out. When you load up a new post, you have this option to select, and the only reason I know this is because for various reasons, I have both of these page builders on my site because I&#8217;ve done some demo content with them for tutorials in the past. When I create a new post, I get this big, these two big buttons saying, do you want to use this page builder? Do you want to use that page builder? Or do you want to use the default page builder. When I select, and this might&#8217;ve changed, cause it&#8217;s been a while since I&#8217;ve done this, but when I select default page builder, at the very top of the Block Editor, there are now these two big buttons, saying switch back to the other page builders, switch back to the second page builder that you have installed. To me, that&#8217;s kind of pushing it, because I&#8217;ve already chosen that I want to use the default editor. Now to keep bugging me. And the other thing that I hated about those buttons were, they both had their own colour schemes. So they were very jarring in the block editor. Cause I keep my WordPress on a very clean theme. So now I&#8217;ve got these big, bold colors at the top of my editing area. And they were both using separate fonts as well. They weren&#8217;t using standard WordPress dashboard fonts.</p>\n\n\n\n<p>So to me, that was very much in my face and almost getting to a point where I wanted to stop using their products because they were being so vibrant about that. There was another example recently where somebody had, I can&#8217;t remember the details but, I think it was, I think it was The Tavern site, where somebody had added, I think it was a signup or an upgrade or something button as a HTML field in the settings sidebar, which there was quite a bit of conversation around. To me again, that&#8217;s the problem, you know, where you are using space that should be used for one purpose, you know, control or settings or whatever. And now you&#8217;re taking over that space to put in your notifications or your upgrades or upsells. Those to me are the kind of the problematic areas.</p>\n\n\n\n<p>[00:19:53] <strong>Nathan Wrigley:</strong> It sounds to me as if you&#8217;re demarcating in your own head at least, the pages, the places on a website which have legitimate use. So the general admin, if you just click the dashboard link and you&#8217;re into WordPress and you&#8217;re not in any particular setting for any particular plugin. You feel that those ought to be limited to possibly text and just very informational in nature and something which is more or less critical, something which you must take care of because otherwise. Right. Okay. So that&#8217;s what belongs there. But if you were to go into the settings page of any particular plugin, that&#8217;s more of a free for all.</p>\n\n\n\n<p>Do you feel that there&#8217;s any constraints there or are you, you mentioned that for Castos, you have a sidebar. I remember seeing that have actually used that before. And there it was, and it did genuinely feel as if that was the right place for it, because I was already in the settings. I was thinking that I was going to be interacting in some way with Castos, and so the upgrade felt like an appropriate place. Any limitations on that? Are we allowed to go full page in there or should there be some constraints around that?</p>\n\n\n\n<p>[00:21:03] <strong>Jonathan Bossenger:</strong> Well, for me, it&#8217;s always about the user experience. So, I feel like a lot of developers, they understand the the balance between creating a good user experience and interacting with your users. The company that I work for now, Delicious Brains, it was about a year ago now released version two of WP Migrate DB Pro with a new user interface, and the notifications that come up when you log into the plugin page and the plugin settings, they&#8217;re just so nice and clean and they don&#8217;t overwhelm you.</p>\n\n\n\n<p>They are useful information, you know. Even if you install the free plugin, there&#8217;s a little bit of a thing at the top, but it doesn&#8217;t bombard you. So in my opinion, yes, if you&#8217;re building a product for WordPress today, and you are forced to use admin notices. You should think about how you&#8217;re registering these things.</p>\n\n\n\n<p>One of the, one of the things that I spent the most time on when we were releasing updates to the plugin at Castos was triggering certain notifications only at certain points. So, when there was an upgrade from 1.2 to 1.3, then trigger a certain notification. But then when the user dismisses that notification save the fact that they&#8217;ve dismissed it and don&#8217;t show it again.</p>\n\n\n\n<p>So we actually spent time thinking about this, because there&#8217;s nothing worse and this actually happened. So the reason we spend the time is because something happened. We launched an update, it included an upgrade step that the user had to action. But we didn&#8217;t have any kind of check in place. So every single time a new user installed the plugin, they got this upgrade.</p>\n\n\n\n<p>Now that&#8217;s fine in the scope of one plugin. Think about let&#8217;s say 15 popular plugins do that. Your user comes along and likes those plugins and installs those plugins and suddenly has 15 notifications in their main dashboard they have to deal with. If those were separated, off and in the settings for each plugin, then it would limit that amount of overwhelm. And they would only see that notification when they&#8217;re dealing with those settings. So I do believe that putting plugins specific notifications in certain places is a better way. The problem you have with that though, is that the other reason developers use notifications is to push users into that funnel.</p>\n\n\n\n<p>And I am not standing here today saying we shouldn&#8217;t allow developers to do that. I strongly support people who are working on open source products, being able to be given the ability to earn income, to be able to be given the ability to turn non-paying customers, into paying customers. But we need to do it in such a way that it doesn&#8217;t overwhelm the users.</p>\n\n\n\n<p>It doesn&#8217;t frustrate them. We should be making it a, we should be making the process of signing up for our product as fun and pleasant as it is using WordPress. And if we are bombarding our customers with notifications from day one when, and that&#8217;s why I say we, we have to find a better way to do this. We can take what we currently have and try and patch it up because what we currently have has been overused for so long and is already.</p>\n\n\n\n<p>So what&#8217;s the word I want to use? I don&#8217;t want to use broken because it means that it was working before, but it&#8217;s been again, I don&#8217;t want to say misused because that sounds so negative. Used incorrectly, used for the wrong reasons, because the reasons that exist, the reasons that exist today, for people to use these notifications are ten times more, what they were, you know, five, ten years ago.</p>\n\n\n\n<p>[00:24:31] <strong>Nathan Wrigley:</strong> Some of the examples that I&#8217;m going to give here come into my head when I&#8217;m thinking about advertising and overwhelm of advertising and misuse. And so a good example would be, if you go to a news site, I can think of an example of a local news site to me. And I go there and I find it incredibly difficult to use that website because they&#8217;ve taken the path of advertising and there are adverts, splattered everywhere so much so that it&#8217;s almost impossible to find the actual content. The content is split up into small paragraphs and they are punctuated by advertisements. And I feel that&#8217;s probably the argument that you&#8217;re making is that if we clutter the UI, if we allow the UI to be cluttered by things which people didn&#8217;t necessarily wish or need to see, then we are making the experience poorer. And I go to that website. I find it quite difficult to stay there. It may be that I need the content so badly that I&#8217;ll persevere, but I&#8217;ve got this instinctive reaction to get away. And we don&#8217;t wish people to enter WordPress, have an initial experience which is poor and continually frustrated.</p>\n\n\n\n<p>However, on the flip side, there&#8217;s obviously some sort of commercial need, as you&#8217;ve described. People would wish to turn their free projects into paid projects and have some subscribers. And I guess plugin developers would point to the fact that in a normal situation, you would get a product and probably give up your email address in return for that. But on the WordPress side, if they come to the repo and download your free plugin, you have no access to that. You haven&#8217;t managed to get them into a funnel in any way, shape or form. They&#8217;re just consuming your product, and that&#8217;s the end of the road. They may use it forever, and I have no idea who you are or any other product that you may offer.</p>\n\n\n\n<p>And in fact, they may well miss out on something which they genuinely, legitimately needed. And so the developers would argue, I guess, that we need some way to do this. We&#8217;re going to try to keep it under control, but I suppose the problem is human nature. Is that given the fact that the area is open to any HTML as you described, it just starts to get overused. The boundaries get pushed, things that were acceptable yesterday are going to be pushed further. And then what&#8217;s acceptable in a year&#8217;s time may get pushed further. And your position, I suppose, is we just want to reign this in a little bit.</p>\n\n\n\n<p>Another thing which comes to mind is commercial television. On the TV side of things, probably radio as well, we&#8217;ve gotten quite used to the fact that our content will be punctuated with adverts. We&#8217;ve walked across the mental bridge that, I cannot watch this program unless it is paid for by advertising. So every 15 minutes or so I will cope. I&#8217;ll sit there and I&#8217;ll consume the adverts or I&#8217;ll go and make a cup of coffee.</p>\n\n\n\n<p>I guess making coffee is the equivalent of dismissing something in WordPress, but that&#8217;s just part of life. So I do wonder where most people will sit on this. They realize that there&#8217;s a commercial need for these things to exist. And so they cope with it, but it may not be ideal.</p>\n\n\n\n<p>[00:27:37] <strong>Jonathan Bossenger:</strong> And that&#8217;s one of the reasons why we need something new because I am, I&#8217;m not, I&#8217;m not saying that we should punish all plugin developers because they want to make a living.</p>\n\n\n\n<p>I&#8217;m not just saying that. As I said earlier, I failed at building a plugin business because I didn&#8217;t know how to market myself properly. I didn&#8217;t know how to turn plugins that I built for free into a paid product and how to convert customers. And I kind of think there are others that have done it successfully and there are those that haven&#8217;t. So I&#8217;m here just saying, you know, developers shouldn&#8217;t be paid for their work.</p>\n\n\n\n<p>I a hundred percent agree that they should be paid for their work. And I don&#8217;t believe, as I said, I don&#8217;t believe the problem is the plugin developers. Because if you think about it, let&#8217;s go back to the example I had of, you know, Seriously Simple Podcasting. We release an update, so we show that update to the user on the dashboard.</p>\n\n\n\n<p>When I&#8217;m testing that, I&#8217;m just seeing that one notification, but when the user has it on their website, they&#8217;re seeing that notification plus however many other useful, important notifications are being pushed out by other plugins. You might be in a situation, and I have seen this before, where you&#8217;ve got an admin dashboard with ten important notifications.</p>\n\n\n\n<p>Because there&#8217;s been a WordPress update. So that means what plugin X had to make a change in how they do something, so you need to run an upgrade. Plugin Y made an upgrade change to their tables, so you need to run that. This plugin did this. And those are all legitimate notifications. Now, first of all, the user doesn&#8217;t know what&#8217;s more important and what is primary? You know, they&#8217;re all just the same color. They&#8217;re all just red. So it&#8217;s all just a stress factor. So number one, how do we give plugin developers the option to say, hey, this is a minor update, so you should do this, but not the end of the world. Like with the categories, the example I gave earlier.</p>\n\n\n\n<p>How do we give another plugin developer the option to say, this is rather important. If you don&#8217;t do this, something could go wrong with your site. Then how do we say, okay, this is a really low end thing. This is just, you know, okay, the plugin&#8217;s been updated and make a note of this change and you can read it later if you want to. We have no way of doing that right now. We have no way of giving plugin developers, theme developers, an option to create a status level and have a certain type of message that the user can go through.</p>\n\n\n\n<p>I mean, we live in a world where our mobile phones have amazing notification systems. And I can control what notifications I want to read. So I have a Facebook account purely to interact with the folks on some of the WordPress groups that I&#8217;m in. But I switched those notifications off, because none of those notifications are primarily important to me. But I certainly switched the notifications to the messaging app that I have with my wife, because those notifications that are important to me. I allow my banking notifications to come through.</p>\n\n\n\n<p>If my banking app sends me advertising, I&#8217;m okay with that because I accept the fact that they&#8217;re a business. They need to make money. I&#8217;m already giving them some of my money every month with banking fees and all of that, but they want to make more, fine, I accept that. Because the benefits of receiving the SMS to tell me that my credit card has been cloned, do I want to cancel it, overrides my distaste by advertising, but that, that exists as a concept. WordPress doesn&#8217;t have that place where I, as a user can choose, even simply which notifications I want to see and which I don&#8217;t. So if I say I&#8217;m using SEO plugin X, whatever the name is, and I want to see the notifications because my SEO is important.</p>\n\n\n\n<p>Then I will probably accept any upsells or upgrade notifications and I will either read them or just mark them as read, but I will be happy to receive them because the rest of the information they&#8217;re giving me to keep my SEO on board to make sure my meta tags are right, is my featured image working, is my social media image working? All those things that are important to me, I will accept their messaging. And I believe that in doing something like that, where there is a specific, formalized way of doing things. If I see SEO plugin X is using that system, giving me the user the control to receive the messaging, and SEO plug in Z is not, I personally will have more of a inkling to use X, because X is putting the control of notifications back in my hands, which I respect and anybody who&#8217;s bombarding me, I&#8217;ll have less of an inkling to want to use their product.</p>\n\n\n\n<p>[00:32:02] <strong>Nathan Wrigley:</strong> I think the mobile phone example is really excellent because we can probably all identify with that. There&#8217;s usually some kind of drop down notification held and little icons appear to alert you to the fact that there&#8217;s something there to read, if you wish. And then of course you scroll down and you can very quickly dismiss them. But then they are, there in a confined area. And that area is familiar to you as the place where notifications are. It can be totally ignored. You could come back to it in five days time, safe in the knowledge that they will be there still.</p>\n\n\n\n<p>And were are they important? Well, that&#8217;s on you, you knew they were there and you decided to ignore them. And then further to that, I&#8217;ve seen a trend recently within mobile phone apps to have notification settings within the apps. So you can go in and say to the banking app, look, I&#8217;m very happy to receive the critical updates about security breaches, but I&#8217;d probably rather not have the, I don&#8217;t know, here&#8217;s our latest mortgage deal kind of notifications.</p>\n\n\n\n<p>The premise there must be that the banking app realizes that there is some balance of trust to be gained. And if you keep pushing the relevant to some, but irrelevant to most, notifications out at some point, the trust scale tips, and you become tired of this app and you may uninstall it. Now, in the case of banking, it maybe that&#8217;s a step too far, you&#8217;te kind of wedded to that, but you can imagine something where there are three or four rivals and you&#8217;re trying to weigh up, which one&#8217;s better for you. The overwhelm of notifications may just be the thing that tips you against it.</p>\n\n\n\n<p>So let&#8217;s move into the project that you&#8217;ve got, WP Notify, because that feels to me as if you&#8217;re trying to replicate the mobile phone model. In other words, everything is tucked away in a particular area. Do you want to describe this enterprise just in broad brush strokes, and then we&#8217;ll talk about specifically what it does, and also how you may get involved in where the project&#8217;s at right now.</p>\n\n\n\n<p>[00:34:00] <strong>Jonathan Bossenger:</strong> Sure. So, the goal of WP Notify, as we originally defined in the initial post. And before I get into that, I just want to give a shout out to, sorry dude, I can&#8217;t pronounce your surname, but he was the guy who came up with a proposal originally. He tweeted that he didn&#8217;t have time to try and move it forward. So I contacted him and I picked it up from there. But his original proposal was very simply, we need a better notification system for WordPress. We can&#8217;t take what we currently have, which has been overused, which is limited, and it&#8217;s limited in its technology, but unlimited in what people can do with it, and that&#8217;s the problem. We can&#8217;t take that and make that better. We need something brand new. And then once we have something brand new, that works, that makes sense that balances the needs of the user and the open source project. And the developers who are trying to earn money from their project. Once we have something like that, then it&#8217;s easier to control, to tame these notifications.</p>\n\n\n\n<p>Then it&#8217;s easier to put guidelines in place. And then when the developers build their plugins, they are almost forced because when they register a notice, they can only register three fields. Those are the only three fields that are allowed. They can put whatever texts they wanted them, but those are the three fields. They can&#8217;t go overboard. They can&#8217;t make it bigger. They have a specific format, and the way they look. They&#8217;re allowed to add certain things, but not other things. That&#8217;s just where we&#8217;re at. So that&#8217;s what an WP Notify is. It&#8217;s a project that we kicked off now in 2019. So it&#8217;ll be going on for three years in August.</p>\n\n\n\n<p>It&#8217;s an open source, what&#8217;s known as a feature plugin. So a feature plugin is something that is, I want to say, not sponsored by, has been accepted by WordPress Core in general as a good idea. We have an official GitHub repository on the WordPress organization and we have a Slack channel, and we are slowly trying to build this better notification system for WordPress.</p>\n\n\n\n<p>[00:35:57] <strong>Nathan Wrigley:</strong> So imagine that I&#8217;ve enabled this, I&#8217;ve downloaded it and activated it. I will, by the way, link to the GitHub repository and various other things.</p>\n\n\n\n<p>[00:36:07] <strong>Jonathan Bossenger:</strong> I wouldn&#8217;t install and activate it just yet, because it&#8217;s not something that you can actually use yet.</p>\n\n\n\n<p>[00:36:12] <strong>Nathan Wrigley:</strong> So rewind. I haven&#8217;t installed it. I haven&#8217;t activated it. None of that stuff has happened. What does it look like? What will it present me with? As a user if I&#8217;m looking at the screen, what will I be seeing?</p>\n\n\n\n<p>[00:36:24] <strong>Jonathan Bossenger:</strong> Okay. So it&#8217;s difficult to obviously, you know, describe this in a podcast environment, but the idea is very similar to what we were chatting about when we spoke about the Android or the iOS, the mobile phone notification system.</p>\n\n\n\n<p>The idea is to have some kind of icon, not a jumping blinging one, but some kind of icon, be it a bell or something. I think in the design that is. That shows some kind of user interface messaging to say, you have new notifications. The user is then able to click on that. They&#8217;re able to see the notifications come up, they&#8217;re able to scan through, see which ones are important to them, see which ones aren&#8217;t. Read the ones that are dismissed, the ones that aren&#8217;t. The other idea as we spoke about earlier is to give the user the control over who they want to receive notifications from. So if they keep getting a bunch of notifications from plugin X that are never useful to them, they can turn it off if they want to.</p>\n\n\n\n<p>If they receive notifications from plugin X that are useful for them, they leave them on. It is up to the user to then choose to either read or dismiss those notifications. We don&#8217;t want to go as far as saying, we&#8217;re only going to show notifications that are state changes or update changes.</p>\n\n\n\n<p>We want the plugin developers to be able to advertise their products. We want the theme developers and the product developers to be able to say, hey, we&#8217;ve got a black Friday special on. We&#8217;ve got a discount code running, whatever. We want those things, but we want them in a way that the user has the control. So there are some designs, as you can see, if you go through to the GitHub repository on the read me page, we have links to our design documents.</p>\n\n\n\n<p>We have links to our requirements documents. We spent about, due to the nature of open source, we spent probably about a year and a half just working on what are the requirements version one? And that went through a lot of process of feedback and revisions. Then we worked on design and that went through feedback and revisions as well.</p>\n\n\n\n<p>Now we&#8217;re starting at the sort of initial implementation phase and our first goal, our first short term goal right now is to take those designs, and actually implement them purely as HTML so that you, Nathan, or anybody else who is interested, could install the plugin and just see what we&#8217;re planning. Just to get a visual idea of what this could look like.</p>\n\n\n\n<p>The goal after that is to then get feedback from the community. From the plugin developers, from the theme developers, from the users, from the open source community. And say, does this solve the problem we&#8217;re trying to solve? If it does, then we can start looking at how do we implement this?</p>\n\n\n\n<p>[00:38:46] <strong>Nathan Wrigley:</strong> How has the project been received? Have you had a lot of engagement? Has it been a difficult struggle trying to get people involved? What&#8217;s your opinion on where you&#8217;re at given the time that&#8217;s been spent on it?</p>\n\n\n\n<p>[00:38:55] <strong>Jonathan Bossenger:</strong> That&#8217;s so here&#8217;s where we get into a little bit of personal history on this. For me, it&#8217;s been a little bit difficult because I&#8217;m not a fully sponsored contributor to opensource. I have a day job. And my day job requires me to do certain things for the business that I work for, be it, when I started it was Castos, now it&#8217;s Delicious Brains. I am allowed X amount of time to contribute to open source, but it&#8217;s not, I&#8217;m not allowed to spend my whole day. So I&#8217;ve kind of worked in a bit of a, it&#8217;s called a project manager slash wrangler role, just to try and get people interested.</p>\n\n\n\n<p>We had, when we launched, we had, if you go to the initial launch post, we had loads and loads of comments and everybody was keen and everybody was excited. The problem was, in my opinion at least, everybody had their own idea of how this should work. And there was actually a stage, and if you go back into the history of the meetings, there was a stage where there was a bit of a of almost people fighting with each other in the meetings. Because one was saying it should be done this way, and one was saying it should be done then the other way. And we hadn&#8217;t even, we hadn&#8217;t even done requirements gathering yet, but people were already deciding how to build this thing. But we didn&#8217;t even know what we were building yet. So that kind of tapered off, and then we got a nice core group of folks. There was maybe ten of us. I can&#8217;t remember the exact numbers, but around ten of us that were meeting regularly. We were doing the requirements gathering. And I want to shout out to a bunch of people here Mervin, Hernandez, Ari. I can&#8217;t pronounce his surname, but he works at Yoast now, he was the theme team representative. Aaron from who was at Auttomatic, she&#8217;s somewhere else. A couple of other folks that I&#8217;m forgetting right now. I apologize in advance, but they were really involved and keeping things going. There was another chap who I know he&#8217;s a WordPress user name, but I don&#8217;t know his first name. His represented prestigious as Ramen. I don&#8217;t remember his first name. He was very influential in getting the PHP side going. And what&#8217;s happened now is we&#8217;ve kind of reached this point where COVID happened, and people&#8217;s lives changed. And I noticed that things started going down a bit and we just kind of kept chugging along and chugging along.</p>\n\n\n\n<p>And what I&#8217;m now seeing is that with all of this conversation, that&#8217;s going on, people are coming back into the project. So we had a bit of work done last year on getting that HTML going, which I mentioned earlier. That kind of died down. And then recently somebody joined again and said, hey, I want to help out.</p>\n\n\n\n<p>So I think the biggest problem that we have as an open source feature plugin, if you will, is just getting the, and it&#8217;s difficult in an source environment because you don&#8217;t, you don&#8217;t have a lot of easy ways to connect the folks. You have to make blog where you can create posts and I&#8217;ll blame myself here. I probably wasn&#8217;t keeping up the post as much as I should have. But you don&#8217;t really have like an official way to, you know, call to arms and get people involved. So whenever I do see these posts that jump up and down about notifications are a problem, then part of me goes, well, we&#8217;re here, we&#8217;re over here, come and have a look.</p>\n\n\n\n<p>So we have had some people coming in, now, it looks like we&#8217;re moving forward again with HTML side of things. So I&#8217;m hoping that very soon we&#8217;ll be able to actually release this installable plugin that doesn&#8217;t do much, but actually just looks like what it&#8217;s going to look like. And I&#8217;m hoping my, my hope is that when we can do that, when we can physically give people something to install, and see, then they will get excited and start getting involved again.</p>\n\n\n\n<p>[00:42:08] <strong>Nathan Wrigley:</strong> If I were an end user of WordPress and I had things tucked away in a notification panel or whatever that might be, that feels to me like, well, a good repository for notifications. I&#8217;m just wondering from the plugin developer side, especially from the perspective of somebody who is, really, as clean as a whistle. They never misstep and misuse notifications. They just keep everything very slim and very lean and they don&#8217;t bother us too much. What would the future for them look like? Are they going to be additional hurdles that they would have to jump through? Let&#8217;s imagine a scenario in two or three years time. WP Notify has become part of Core and everybody needs to go through the process of registering their notifications in the correct way.</p>\n\n\n\n<p>What would the burden be like? Is it very minimal on the plugin developer side? How does that work?</p>\n\n\n\n<p>[00:42:57] <strong>Jonathan Bossenger:</strong> So I&#8217;ll say this, I don&#8217;t see admin notices going anywhere anytime soon. And one of the reasons for that is because WordPress Core uses it extensively and will probably continue to do so until we move completely towards a JavaScript admin dashboard.</p>\n\n\n\n<p>But I don&#8217;t see admin notices going anywhere anytime soon. So those developers that are using admin notices in big air quotes correctly, won&#8217;t be affected. Those that are using them in different places, but unobtrusively currently it&#8217;s a case of, you register a hook. Your write a little bit of HTML, and your notice works. On the WP Notify side, we want to make it as easy as that as well. So they will be a defined structure. You can actually see, I can send you a link. There&#8217;s a document where we have the defined structure of a notification. And if I remember correctly, it&#8217;s title and description. So very similar to what an admin notice currently looks like. An admin notice just has a description area, if you will. It doesn&#8217;t even, it&#8217;s not even defined, it generally gets used as a description area. We&#8217;ve added a title. And then I seem to recall, can&#8217;t remember hundred percent, I&#8217;ll have to double check, but I think we&#8217;ve also added a possibility to register a URL.</p>\n\n\n\n<p>So if the user needs to click on a link to go and trigger some other action or click on a link internally in WordPress to trigger some action. So as a developer, you would have a similar rich user interface where currently you would hook into an admin notice. You would register a callback. Your call back would continue HTML.</p>\n\n\n\n<p>In WP Notify you would have a similar hook and then you would register an object, and the object has your title, your description, and if you wanted your URL. So we want to keep it as easy to use as what admin notices is, but as friendly to the user as possible.</p>\n\n\n\n<p>[00:44:34] <strong>Nathan Wrigley:</strong> I think probably Jonathan I&#8217;ve asked everything that I wish to ask. The inevitable thing is, is there anything that you wished to describe that I didn&#8217;t ask you about?</p>\n\n\n\n<p>[00:44:43] <strong>Jonathan Bossenger:</strong> No. At the end of the day, The only thing that the only thing that I&#8217;m, let&#8217;s call it keen on, if you want a better word is to move this forward. So right now I&#8217;m going to use this opportunity to say if there are any front end developers or any developers out there who are very good at turning design into HTML. You want to find some way to contribute to WordPress, we have an open track ticket, where some work has been done. If we can get that over the line, that will make a huge. Then, if there are any developers who want to make this happen and they&#8217;re very good on the PHP side, or they&#8217;re very good on the JavaScript side, please come along and take a look.</p>\n\n\n\n<p>Everything is linked through on our GitHub Wiki. We have a project Wiki dedicated towards the requirements documents, the design, the requirements analysis we did, the open issues and the pull request. It&#8217;s all there. So come along and come and join us, come and help us build a better notification system for WordPress, because once we can put that in place, then we can make amazing things happen.</p>\n\n\n\n<p>[00:45:42] <strong>Nathan Wrigley:</strong> Jonathan, if somebody were interested in reaching out to you personally, because they would like to contribute in some way or just find out more. Do you have any links or websites or social channels that you frequent?</p>\n\n\n\n<p>[00:45:54] <strong>Jonathan Bossenger:</strong> Sure. I am on Twitter. It&#8217;s John underscore Bossenger because Jonathan Bossenger was too long for Twitter, back in the day. You&#8217;re also welcome to email me. My email address is my full name. Jonathan Bossenger at gmail dot com. I don&#8217;t mind sharing that email address because Gmail&#8217;s pretty good at handling spam. And I would just say that if you do email me to ask me questions, please give me some time because I am very strict with how I manage my emails.</p>\n\n\n\n<p>So I&#8217;ll check that mailbox once a day and reply when necessary. Finally, if you want to get involved, go to github dot com slash wordpress slash wp hyphen notify and go through from there. If you are already contributing to WordPress and you&#8217;re already in the WordPress Slack, there is a feature notifications channel where we have our meetings every Wednesday.</p>\n\n\n\n<p>And I think it&#8217;s 2:00 PM UTC, please feel free to come and join. And you&#8217;re welcome to DM me in that Slack. Email is the best. I&#8217;m a little bit old now, so this whole Twitter DM thing is something I still struggle with. So, if you want to ask me questions, email is . Probably the best. Otherwise get me onto Twitter.</p>\n\n\n\n<p>[00:46:49] <strong>Nathan Wrigley:</strong> Jonathsn Bossenger, thanks for joining us today on the podcast.</p>\n\n\n\n<p>[00:46:52] <strong>Jonathan Bossenger:</strong> No problem. Thank you. .</p>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 02 Mar 2022 15:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nathan Wrigley\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WPTavern: The WordPress Web Fonts API Has Arrived\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130686\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wptavern.com/the-wordpress-web-fonts-api-has-arrived\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7757:\"<p class=\"has-drop-cap\">The journey toward a web fonts API in WordPress has been a rollercoaster of emotions for developers. After being <a href=\"https://wptavern.com/proposed-web-fonts-api-not-coming-to-wordpress-5-9-possibly-landing-in-gutenberg-first\">punted from the WordPress 5.9 release</a>, it was moved to the Gutenberg project, where it could be built alongside related features that relied on it.</p>\n\n\n\n<p>The API has been <a href=\"https://github.com/WordPress/gutenberg/pull/37140\">merged into the Gutenberg plugin</a> and should land in version 12.8. Theme authors who want to test it can clone the dev version of the plugin or <a href=\"https://gutenbergtimes.com/need-a-zip-from-master/#nightly\">download the nightly version</a> from Gutenberg Times.</p>\n\n\n\n<p>Jono Alderson opened the <a href=\"https://core.trac.wordpress.org/ticket/46370\">original ticket</a> for a web fonts API in February 2019. However, it was not until late 2021 that it gained a mass of <a href=\"https://wptavern.com/a-web-font-api-possibly-coming-to-wordpress\">support and development</a>. By most accounts, the API looked ready to ship with WordPress 5.9. However, it was put on hold by Andrew Ozz, one of the lead WordPress developers.</p>\n\n\n\n<p>It was not a popular decision, but it may have been the best direction. The API was limited because it did not yet have <code>theme.json</code> support. Being only available through PHP meant that theme authors would have mostly been doing what they always have &#8212; rolling out their own solution. This was not the holdup for its unveiling, but it will likely be the API&#8217;s most common use case.</p>\n\n\n\n<p>While many wanted to see this feature land in WordPress 5.9, the extra months have given it time to evolve into a cleaner API that integrates with the site and content editors.</p>\n\n\n\n<p>Theme authors can now define font-face definitions alongside their corresponding families in <code>theme.json</code> files, and WordPress will automatically load the necessary <code>@font-face</code> CSS in the editor and on the front-end. I have tested this extensively and have not run into any problems.</p>\n\n\n\n<p>The potential downside is that the feature only ships with support for a local provider, which means fonts must be bundled with the theme. A Google Fonts provider was part of the original implementation but was later removed.</p>\n\n\n\n<p>Ozz goes into <a href=\"https://github.com/WordPress/gutenberg/pull/36394#issuecomment-981970167\">further details in an earlier ticket</a>, but his recommendation was to drop Google Fonts support for now:</p>\n\n\n\n<blockquote class=\"wp-block-quote is-style-default\"><p>Add support only for local fonts for now. If WordPress decides to include support for the Google CDN later on, the implementation will have to consider web privacy laws and restrictions and be tied with an eventual User Consent API, etc.</p></blockquote>\n\n\n\n<p class=\"has-neutral-900-color has-neutral-100-background-color has-text-color has-background\"><strong>Related article:</strong> <a href=\"https://wptavern.com/german-court-fines-website-owner-for-violating-the-gdpr-by-using-google-hosted-fonts\">German Court Fines Website Owner for Violating the GDPR by Using Google-Hosted Fonts</a></p>\n\n\n\n<p>Ari Stathopoulos, one of the developers behind the web fonts API, explained that bundling a solution in core that writes the font files directly to the server <a href=\"https://github.com/WordPress/gutenberg/pull/36394#issuecomment-986541963\">would improve privacy</a>:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Instead of removing it, maybe we could implement them properly, enforcing locally-hosted webfonts to improve performance &amp; privacy? This way we&#8217;d be setting a good example, and we&#8217;d see a significant performance &amp; privacy improvement in the WP ecosystem as themes &amp; plugins that currently use Google-fonts, Adobe-fonts and whatnot will start to adopt the API.</p></blockquote>\n\n\n\n<p>For now, it looks like local fonts are officially supported, but theme and plugin authors must register custom providers. One fear with leaving out Google Fonts support is that there will be many competing solutions in the wild instead of one solid provider that everyone can rely on. The more developers build their own wheels, the more likely different implementations ship with bugs or security issues.</p>\n\n\n\n<p>Automattic already has a <a href=\"https://github.com/Automattic/jetpack/pull/23045\">draft patch for a Google provider</a> for Jetpack. Assuming that gets pulled into the plugin, it will undoubtedly conflict with a theme down the road that registers its own <code>google</code> provider ID.</p>\n\n\n\n<p>Only supporting local fonts could also create larger theme download sizes. For many themes, this should be a non-issue. One, two, or three font packages are reasonable. However, if global style variations become popular, we could see themes that ship dozens of fonts to cover multiple pre-packaged designs. That will quickly lead to bloated theme files and, combined with enough images, theme authors may hit the 10MB limit for submission to the directory. That feels a little like tomorrow&#8217;s problem, but it is something to begin thinking about today.</p>\n\n\n\n<p>There are still some issues that need to be solved around the API. However, pushing it through this early in the WordPress 6.0 release cycle will give everyone time to test and help improve it.</p>\n\n\n\n<h2 id=\"testing-bundled-fonts\">Testing Bundled Fonts</h2>\n\n\n\n<p>There are two methods for registering web fonts with WordPress. For theme authors, the simplest solution is to define them via their <code>theme.json</code> files. This is the method that I will cover below since the file has been standard since WordPress 5.8. There is a PHP example in the <a href=\"https://github.com/WordPress/gutenberg/pull/37140\">pull request ticket</a>.</p>\n\n\n\n<p>The <code>theme.json</code> keys and values mostly correspond to the CSS <code>@font-face</code> rule. Theme authors should <a href=\"https://developer.mozilla.org/en-US/docs/Web/CSS/@font-face\">brush up on it</a> if it has been a while since they have used it.</p>\n\n\n\n<p>For testing, I registered three web fonts through my theme, and the following screenshot shows them in action in the editor:</p>\n\n\n\n<img />Testing three web fonts.\n\n\n\n<p>Web fonts should be registered under <code>settings.typography.fontFamily</code> as part of a specific font family definition. The following is a copy of the code I am testing in one of my themes using the Cabin font:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>{\n    \"settings\": {\n        \"typography\": {\n            \"fontFamilies\": &#91;\n                {\n                    \"fontFamily\": \"\\\"Cabin\\\", sans-serif\",\n                    \"slug\": \"primary\",\n                    \"name\": \"Primary\",\n                    \"fontFace\": &#91;\n                        {\n                            \"fontFamily\": \"Cabin\",\n                            \"fontWeight\": \"400 700\",\n                            \"fontStyle\": \"normal\",\n                            \"src\": &#91; \"file:./public/fonts/cabin/Cabin-VariableFont_wdth,wght.ttf\" ]\n                        },\n                        {\n                            \"fontFamily\": \"Cabin\",\n                            \"fontWeight\": \"400 700\",\n                            \"fontStyle\": \"italic\",\n                            \"src\": &#91; \"file:./public/fonts/cabin/Cabin-Italic-VariableFont_wdth,wght.ttf\" ]\n                        }\n                    ]\n                }\n            ]\n        }\n    }\n}</code></pre>\n\n\n\n<p>Note that <code>file:./public/fonts/*.ttf</code> is relative to the theme folder. Theme authors need to adjust this to fit their theme structure.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 02 Mar 2022 00:58:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"Post Status: Post Status Excerpt (No. 48) — Running a WordPress Business\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://poststatus.com/?p=93609&preview=true&preview_id=93609\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://poststatus.com/post-status-excerpt-no-48-running-a-wordpress-business/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:31360:\"<h2 id=\"there-is-always-some-space-in-the-wordpress-ecosystem-left-for-developers-dave-rodenbaugh\">&#8220;There is always some space [in the WordPress ecosystem] left for developers.&#8221; —Dave Rodenbaugh</h2>\n\n\n\n<p class=\"has-drop-cap\">In this episode of Post Status Excerpt, David has a conversation with <strong>Dave Rodenbaugh</strong>, founder of Recapture.io. Dave has been involved with the business of WordPress plugins since 2009 with products like <strong>Business Directory Plugin</strong> and <strong>Another Classified WordPress Plugin</strong>. </p>\n\n\n\n<p><strong>Why This Matters:</strong> Dave shares what he\'s learned while running a business in the WordPress space. Others in this space or looking to enter it will learn when (and what) they should outsource to SaaS and open source.</p>\n\n\n\n\n\n\n\n<p class=\"has-background\">Every week <strong><a href=\"https://poststatus.com/podcast/the-excerpt/\">Post Status Excerpt</a></strong> will brief you on important WordPress news — in about 15 minutes or less! Learn what\'s new in WordPress in a flash. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/26a1.png\" alt=\"⚡\" class=\"wp-smiley\" /><br /><br />You can listen to <a href=\"https://poststatus.com/podcast/the-excerpt/\">past episodes</a> of <strong>The Excerpt</strong>, <a href=\"https://poststatus.com/category/post-status-podcasts/\">browse all our podcasts</a>, and don’t forget to subscribe on <a href=\"https://open.spotify.com/show/1m3xwXbe0MG5BzFVPtB0A7\">Spotify</a>, Amazon Music, <a href=\"https://podcasts.google.com/feed/aHR0cHM6Ly9mZWVkcy5zaW1wbGVjYXN0LmNvbS8ySkU5c2M4UA\">Google Podcasts</a>, <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">iTunes</a>, <a href=\"https://castro.fm/podcast/c53552c6-1ee0-4fc4-9de4-08ed6bf1ee4d\">Castro</a>, <a href=\"https://www.youtube.com/c/PostStatus\">YouTube</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, <a href=\"https://player.fm/series/wordpress-post-status-podcasts\">Player.fm</a>, <a href=\"https://pca.st/05rR\">Pocket Casts</a>, <a href=\"https://wordpress-post-status-draft-podcast.simplecast.com/\">Simplecast</a>, or by <a href=\"https://feeds.simplecast.com/2JE9sc8P\">RSS</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f3a7.png\" alt=\"🎧\" class=\"wp-smiley\" /></p>\n\n\n\n<h3 id=\"h-mentioned-in-the-show\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f517.png\" alt=\"🔗\" class=\"wp-smiley\" /> Mentioned in the show:</h3>\n\n\n\n<ul><li><a href=\"https://twitter.com/daverodenbaugh\">Dave Rodenbaugh</a> (Twitter)</li><li><a href=\"https://twitter.com/dimensionmedia\" target=\"_blank\" rel=\"noreferrer noopener\">David Bisset</a> (Twitter)</li><li><a href=\"https://twitter.com/post_status\" target=\"_blank\" rel=\"noreferrer noopener\">Post Status</a> (Twitter)</li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h3 id=\"sponsor-bluehost\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f64f.png\" alt=\"🙏\" class=\"wp-smiley\" /> Sponsor: <a href=\"https://poststatus.com/bluehost\">Bluehost</a></h3>\n\n\n\n<p>Everything your website needs — from start-up to success story — is at Bluehost. Whether you\'re looking to create a website, blog, or online store, Bluehost will get you started with an all-in-one website platform tailored to your specific needs. Get a free domain name in your first year, free 24/7 lifetime support, and total design freedom with WordPress at Bluehost.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"h-transcript\"><strong>Transcript</strong></h2>\n\n\n\n<p>p90</p>\n\n\n\n<p><strong>David Bisset:</strong> Do you just have a brief statement to read ,</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> uh, possible? Um, so I used to run AW PCP, which was a classifieds plugin. I ran business directory plugin, which you can probably guess what that one is. Um, and then I had some other plugins that never really went very far went anywhere. So they\'re not really worth mentoring mentioning, but now, uh, I run recapture a, an email and SMS marketing for e-commerce specifically, uh, in WordPress, we support WooCommerce, paid memberships, pro restrict content pro easy digital downloads.</p>\n\n\n\n<p>Um, so, uh, you know, I have a lot of experience with e-commerce and WordPress and using easy digital downloads. That was the primary way I sold the plugins for a long time.</p>\n\n\n\n<p><strong>David Bisset:</strong> And what you\'re doing now is that.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Yes. So recapture is a SASS and that\'s my, that\'s my gig now. So I sold the other plugins in 2020, uh, actually the awesome motive, uh, and they have taken over them and are doing a great job running them ever since.</p>\n\n\n\n<p>So it\'s, it\'s actually nice to see, you know, you let your baby out of the nest and it flies away and it actually is taking on a new life of its own, which is cool.</p>\n\n\n\n<p><strong>David Bisset:</strong> It doesn\'t get immediately eaten by another animal. That\'s I feel like I\'ve seen that in nature. Uh, who else besides yourself is part of the company.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> So when I was doing the, uh, the classifieds and business directory plugin, I had. One time I had up to two or three other developers that were working on that. I also had a support person when I sold them to awesome motive, that whole staff went with them, so they could continue to maintain the plugins. And now with recapture, I have a full-time tech lead and a QA person, and then I have a person that\'s helping with sales.</p>\n\n\n\n<p>And then I sort of do all the rest of the stuff, whatever that looks.</p>\n\n\n\n<p><strong>David Bisset:</strong> Why didn\'t you start recapture while you were owning the other plugins or did you start it from scratch?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> I\'m sort of a, an aberration, I think in the WordPress world in general, all of my successful WordPress businesses have not been things that I have started from scratch myself.</p>\n\n\n\n<p>I actually bought them from other people.</p>\n\n\n\n<p><strong>David Bisset:</strong> Oh, so you bought recapture.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> I did. Um, I bought the two plugins originally from a freelance developer and, uh, you know, I took those over and grew them from where she was at with them recapture. I bought it from the, a couple of brothers that were actually doing custom iPhone cases and they built this tool for their stores on Magento.</p>\n\n\n\n<p>And then I took it and I was like, oh, well this has some obvious places that you could take it. I can move it to other platforms. I can add more functionality. It was literally just abandoned carts for Magento. That\'s it. So, and you know, the tool itself was well written. It was a very well-documented. It was already set up to be scalable.</p>\n\n\n\n<p>Like I saw lots of potential in it. And I bought it and took that. Um, and I kinda liked buying businesses over building things from scratch because. It helps de-risk things. I come with a set of customers that I can already talk to. I come with a product that\'s functioning for those customers and doing something valuable for them.</p>\n\n\n\n<p>They\'ve paid me money for that. So these are all things that if you\'re building a product from scratch, you have to validate on your own, you know, how do I find the customers? What is it that they really need? How do I build that in the best way possible? Um, yeah, those are, those are tough things to solve.</p>\n\n\n\n<p>Whether you\'re building it from scratch or you\'re buying something else you\'ve got to, you\'ve got to do a good job on all of those things in order to make your product grow. So my strategy was to buy things that looked attractive, that I felt were something in my wheelhouse I could really work with and then, you know, make better as a result of my equity.</p>\n\n\n\n<p><strong>David Bisset:</strong> So, did you ever have to rebuild your code base when you acquired the plugins like this or</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> The first two we did do some revamping. Um, and that was a slow thing over time, but I mean, consider how much WordPress changed. I think when I first bought the plugins, it was at WordPress one dot nine. Oh Lord.</p>\n\n\n\n<p><strong>David Bisset:</strong> I have dirt that\'s younger than that.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> I know. And so there was. Every major release, there was huge shifts in there that we would have to go in and rip out sections of the plugin that were coded to the old way. Yeah. So, and you know, every, every major release, there was always this bridge that we would build that would be like, okay, here\'s all the stuff that we support for the new version.</p>\n\n\n\n<p>And we had to keep the legacy stuff around for the old. And then you\'d retire that every time you\'d move up another major version. So by the time we got to three, we got rid of all the stuff from one dot nine. And you know, the first time we did that, we definitely made some enemies there. People were angry about that because they were still running old versions of WordPress.</p>\n\n\n\n<p>There wasn\'t that upgrade or die kind of mentality back in 2011, 2012, 2013. So</p>\n\n\n\n<p><strong>David Bisset:</strong> is there anything that stands out in you as, if you would to compare WordPress and non WordPress businesses, how they would, how would they would stack up against each other pros and cons, that sort of thing?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> No, one thing. I mean, there are definitely some things that kind of stand out that make WordPress businesses very unique.</p>\n\n\n\n<p>Um, one is the whole plugin and theme model. And the fact that GPL is involved in that, which means that your code is licensed in a way that you, you can\'t really say this is mine and mine alone, and nobody can ever touch it. It\'s not a proprietary closed source model. So that means that, you know, smart competitors can go in and take a look at what you\'re doing.</p>\n\n\n\n<p>Copy it, fork it, make their own version of it. In fact, that happened to me with, uh, with business directory plugin, somebody took my plugin, stole, laid, bought all of the, the, um, extensions for it and then forked it and put it up on embado. So, you know, and then I\'ve, you know, attract their sales after that. And they made six figures selling it on vAuto and it was a long time before I ever actually noticed that it was over there.</p>\n\n\n\n<p>Cause I wasn\'t like, you know, going around and scouring for directory competitors on a marketplace that I wasn\'t even in. But, um, but yeah, I mean, I could have done, they definitely had stolen some images and I could have done a DCMA take down or something like that. But by the time I discovered it, it was so late, it wouldn\'t have mattered.</p>\n\n\n\n<p>They had already revamped a lot of it internally. So that\'s, that\'s a unique aspect of WordPress that I think. You know, discourages some business owners and it causes other business owners to be super secretive and not disclose their strategies and not disclose their plans. They only show what they have to show everything else they\'ll hide,</p>\n\n\n\n<p><strong>David Bisset:</strong> which is the code.</p>\n\n\n\n<p>Right. I mean, they have to show the code.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Right, but, or they don\'t, or they don\'t put it in the repo. Like that\'s the other thing they\'ll do. They\'ll keep all of it and put it on their own private sites. So in order for you to download it, you got to pay for it. So, you know, this is, this is the model of definitely some larger companies that are out there at this point.</p>\n\n\n\n<p>They don\'t they\'ll keep the free plugin. But then all the paid stuff is in a place that\'s totally protected. And that\'s ultimately the model I ended up doing for business directory and AWP, PCP, um, with recapture it\'s different. Cause I\'m a service. So, you know, yeah. I was</p>\n\n\n\n<p><strong>David Bisset:</strong> about to ask you about that because do you think eventually most, um, companies that have a paid plugin in WordPress, maybe most let\'s, let\'s say a good, a larger chunk are going to be migrating to a SASSS model because of some of the reasons we\'ve talked.</p>\n\n\n\n<p>And I think I\'m hearing a lot, um, from company owners and plugin developers is like, SASS is if I can just turn this into a SASS or we may be migrating to assess at some point, because you know, they don\'t have to share the code and they have a lot more control over their finances, their customers, and so forth.</p>\n\n\n\n<p>Do you think that\'s going to be play a larger part in WordPress plugins?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> I think that anybody who can make a SASS will probably start heading that direction. But with that said, There are many plugin and theme businesses in particular that you cannot Salsify. If that is a verb. Um, it is now I absolutely declare that SASSify is now a verb.</p>\n\n\n\n<p>So you, you basically have. To ask yourself, this question is the value that my end user and customer receives. Is that something that is repeatable on a monthly or annual basis? And if it is, then you can probably make that into a SASS model. So like with recapture, my example here is that we\'re doing abandoned cart recovery and generating revenue for e-commerce sites.</p>\n\n\n\n<p>So every month I can hand somebody a report to say, we sent this many emails, we made you this much money as a result of those emails. And here\'s how, what the conversions look like and all these other things. So that\'s a demonstration of ongoing value, but like with my business director, The value was captured right up front.</p>\n\n\n\n<p>Like they would install it, they would configure it, they would set it up and then a year later it wasn\'t like they wanted to pay for the whole thing all over again. It\'s not like they got a new business directory. It\'s not like they got, you know, a totally different UI or a massive upgrade. They just got some minor updates and fixes.</p>\n\n\n\n<p>So the value is captured mostly upfront instead of on an ongoing basis. And for businesses like that, you\'re not going to Salsify those. You\'re certainly not going to get people, you know, you might try to Salsify it, but I don\'t think you\'re going to get a lot of customers signing up for that. Because they\'re not getting that ongoing value and that\'s the difference.</p>\n\n\n\n<p>So there\'s like a huge number of WordPress businesses, like themes. It\'s kind of difficult to capture that theme value on an ongoing basis, unless you have, like, I could see for freelancers, you could do theme subscriptions to say, Hey, we\'re going to have 15 themes this year. Next year, we\'re going to have 30.</p>\n\n\n\n<p>After that, we\'re going to have 45. So we\'re releasing 15 new themes a year. If you\'re building freelance site. Great. Now you want an increasing library of things that you can offer your customers. I could see you. That makes sense in a freelancer paid plan, but for an individual, if I go and buy a theme, I don\'t need a new theme next year or the year after that.</p>\n\n\n\n<p><strong>David Bisset:</strong> What about support? Um, and a lot of business models go, you pay, you\'re paying basically. The support in for the maintenance and the bug fixes and that sort of thing. When, when do you think a product becomes mature?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Yeah, I, I don\'t know what officially makes something mature. I think there is a tension between bug fixes, new features and customer demand.</p>\n\n\n\n<p>And when you kind of satiate the customer demand for the new features, and you\'ve gotten to a point where the bug fixes are in. So you\'re not throwing out a new major fix every month then. Yeah. Something like that would end up being mature. So a great example of that might be Yoast SEO, right? You\'re not seeing like huge major new SEO updates coming out every single month that Yoast is having to put out if there\'s a major Google update.</p>\n\n\n\n<p>Yeah, sure. They do an</p>\n\n\n\n<p><strong>David Bisset:</strong> update. I get an email like every other week from them, but I\'m guessing it\'s Google updates.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> It\'s probably a little stuff in Google updates in there, but yeah, I mean, I would consider that a pretty mature product that, you know, there are some tweaks that go in there and I, you know, I don\'t want to downplay the amount, uh, that the Yoast team puts into that. Cause it\'s huge and SEO is complicated, but it\'s definitely a very mature product because people aren\'t like, Hey, I need you to support this very basic thing out here that nobody\'s ever supported before. Like they\'ve got that stuff covered. They have a lot of complexity in their product, a lot of configuration options, et cetera.</p>\n\n\n\n<p>And then there\'s like newer stuff. So this might be more or less. Gutenberg blocks that are new and novel that do something that nobody else has ever done before, or that yours is the better one to do this slider or this kind of a layout or whatever. Something like that, that kind of stuff is more cutting edge because Gutenberg is not, well, it\'s getting more mature, but it isn\'t as mature as say other aspects in WordPress.</p>\n\n\n\n<p><strong>David Bisset:</strong> Right. I like to remind you, I, like I said, I do have a teenager in high school, so yeah. I\'m the maturity is a subject I\'m somewhat familiar with it. Yes.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Yes. Uh, I I\'m, I\'m right there with you, David. I have a teenager. Who\'s almost about to graduate high school and another one coming in.</p>\n\n\n\n<p><strong>David Bisset:</strong> Me too, this year.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Year. Hold his years.</p>\n\n\n\n<p><strong>David Bisset:</strong> 17.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> 17. Yeah. Mine\'s 17 two. And I also have an eighth grader right behind her. So next year I\'ve got two in, at the same time. So</p>\n\n\n\n<p><strong>David Bisset:</strong> it comes to maturity. Yeah. Some things, some things will mature faster than other. Whereas a developer as a company. I mean that, that\'s, that\'s kinda like a problem you would like to have, because I think before you get to that, you\'re, you\'re so busy.</p>\n\n\n\n<p>You\'re doing 10 different things at once, especially if you\'re like a freelancer or a solo developer. Um, and you know, I\'ve always been freelance for a very long time before I joined a few companies. So I always come business wise. I always come from the aspect of me starting something myself. Me alone, juggling so many balls in the air.</p>\n\n\n\n<p>Um, have you ever had to outsource anything in the early days of capture or now, or any of your businesses? Um, even if it was, um, I don\'t know any, anything from financing or marketing or anything like that?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Um, yeah, actually I have and outsourcing is super valuable to me at this point because there are certain things where.</p>\n\n\n\n<p>I, you know, there\'s a lot of stuff that I can just do because I\'ve had to do it over the years. I\'ve had no choice. So that means I was part accountant, part marketing person, part janitor, part, um, you know, developer part, customer support, just whatever. So you, you wear all these different hats and you can do all of these things.</p>\n\n\n\n<p>But the problem is, is that you are the Jack of all trades master of none. Right. And. There are people who are very, very specialized at those things. And at some point making them be the owner of that piece is more valuable. So here\'s an example. So when I bought recapture, I was still freelancing at the time I still had the plugins.</p>\n\n\n\n<p>So I was doing customer support over there and I was still doing product management. And then of course I was doing my own development. And then I had recapture on top of all that. Well, when I bought it , it didn\'t come with a staff. It was just the guy who was the two brothers that were running it. And I bought it from him and nobody came with him.</p>\n\n\n\n<p>They didn\'t come with a plugin, then they didn\'t come with it. No, they were like, here, it\'s yours. Good luck. And</p>\n\n\n\n<p><strong>David Bisset:</strong> well, insert my children joke here later, but go.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Yes. Uh, so the problem immediately became, I had customers that were asking for new features or bug fixes, and I couldn\'t do any of that stuff just yet.</p>\n\n\n\n<p>I mean, I could, if I invested the time, but a lot of it was time sensitive. So initially what I did is I paid one of the brothers that sold it to me to consult on certain things. Cause he could do things the fastest and he was willing to do that. It was part of the contract that we sold. Anyway.</p>\n\n\n\n<p><strong>David Bisset:</strong> There\'s usually that coverage period, you know?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Right. But the coverage period is only like 90 days. And I think I had him come and help me for like six months. So he was very nice. And was willing to do that, but it was clear that, you know, I needed more than he was able to give and he didn\'t really want to keep doing it for the longterm. So that\'s when I basically had to like go and outsource to somebody else.</p>\n\n\n\n<p>That was more full-time. So I had, you know, cashflow from recapture itself. So I use that to invest in a developer who is now my tech lead for recapture. And, you know, he\'s been working on it for five years, but basically I made a decision early on, I am not going to do the technical development aspects of this SASS.</p>\n\n\n\n<p>I\'m going to let somebody else do it. I just, I can\'t do it and this other stuff. So I had to outsource something that was what I chose to outsource and I totally don\'t regret it. He has taken ownership of all that, and it worked out.</p>\n\n\n\n<p><strong>David Bisset:</strong> So, um, so what\'s your tip in terms of how do you know when it\'s time to outsource something?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> When is it time to outsource something? So I would say it\'s a combination of, do you have. Some kind of way to pay somebody to do that. So like, if you are, you need income, you brand new, you need to have some kind of income, but it doesn\'t have to be from your project. So here\'s, here\'s, here\'s the caveat. I would say that if you are a freelancer and you are pulling in a nice salary and it more than covers your living expenses and you\'re putting stuff in savings, save that up for awhile.</p>\n\n\n\n<p>And then you could use that savings to pay for somebody to out source something while you\'re doing something else. So you can leverage that time, that money in a different way. I always would buy something that was making income so that I could use that income to help hire somebody else. And that way it didn\'t have to come out of my savings personally, cause I already spent the money on the business and I didn\'t want it to spend a second time.</p>\n\n\n\n<p>So those are the two, two ways that I would end up funding that. But if you are by yourself, you don\'t have that money. You\'re just getting started. Or you\'re kind of new to the whole thing. I would strongly encourage you to just try to wear all those different hats and become that Renaissance person.</p>\n\n\n\n<p>Right. It\'s good to know what all those things are because eventually in order for you to outsource it, you have to understand it well enough to tell somebody else exactly what you want. And it\'s hard to do that if you haven\'t had experience in that yourself.</p>\n\n\n\n<p><strong>David Bisset:</strong> And I imagine too, that it helps. Not that everybody has the luxury of the privilege of this, but it also helps if you are starting brand new with a plugin, the rebuild helps to know if you do have plans on growing that beyond just simply what it is.</p>\n\n\n\n<p>And because you, the sooner you start some sort of path to some sort of monetization, the faster you can have that money, automotive and buyer gallery, all these others, they have a pro version people pay and that\'s the, those people are actually paying support people to help with the light you know, the repo, The light versions in the repo and the support there that\'s being financed there.</p>\n\n\n\n<p>But I mean, if you\'re starting from zero, um, it\'s charity at that point until, I guess, like you said, you gotta find the money from somewhere. If you get to a certain, certain scale. So what\'s your advice or what\'s your take on how much attention, um, business owners and entrepreneurs should be paying attention to in the WordPress space when it comes to competence?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> That is a fantastic question. And the truth is you can be in one of two camps, so you can either focus solely on your competitors, or you can kind of ignore them. And if you\'re ignoring your competitors, then you should be paying very close attention to your customers. And, oh, I like to mix the two of those.</p>\n\n\n\n<p>So like, I\'d like to be aware of what my competitors are doing. Sometimes ideas come out of that sometimes like, Uh, I wasn\'t fully aware of what GDPR was until I saw some of my other competitors posting things. Hey, we\'re going to become GDPR compliant. Hey, GDPR is coming down the pike. Here\'s what you need to know.</p>\n\n\n\n<p>And I\'m like, what the heck is GDPR? And that\'s when I dug into it and I\'m like, oh boy, I really need to take care of this because this is going to hit. Ton of bricks. So, um, you know, so you should be aware where your competitors at, you know, knowing about your competitors will help you understand what are their pricing models, who are they focused on?</p>\n\n\n\n<p>Like understand who is the right customer for your competitors. But with all that said, you need to like, look at your product, your market, your audience, and. Understand them and talk to them deeply. And by knowing your competitors, you can say, look competitor a over here, they do all of these things, but that\'s too complicated because you\'re not making as much as the, the hundred million dollar a year business that uses this tool over here.</p>\n\n\n\n<p>You\'re down here. And this is why we\'re better for you because we are simpler. We\'re easier to use. We\'re more focused on this. We have better support, blah, blah, blah, whatever your competitive advantages are, but you can\'t do that. If you don\'t at least understand your competitors, but you know, don\'t focus solely on your competitors.</p>\n\n\n\n<p>If, if all you do is watch what your competitors do, and then repeat that you\'re always going to be behind. You\'re never going to be a market leader in that. So you have to have some awareness, but at the same time, really just be focused on your customers. That\'s my, that\'s my approach.</p>\n\n\n\n<p><strong>David Bisset:</strong> The uniqueness, is that something that you would probably say it would be good advice to, to people who doubt that there\'s any space left in the WordPress ecosystem for whatever product they\'re thinking of?</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Uniqueness is, um, there\'s always some space left. So here\'s a great example. If you were to say, what is the most crowded space in WordPress? And, you know, you could probably give several examples, but I\'ll give one of the most obvious ones for. Right. You\'ve got all the different form plugins that are out there.</p>\n\n\n\n<p>You got formidable forms and ACF and, um, the WP forms and ninja forms and, you know, blah, blah, blah, blah, blah. Right. There\'s tons and tons. Gravity forms, tons of competitors out there, but yet there are new ones that come out all the time and. There\'s always an opportunity to look at that space with a fresh new approach.</p>\n\n\n\n<p>So this is like, uh, you know, side bulky from automotive, talked about this when they released their competitor in there. And I\'m pretty sure this is WP forms, but, uh, if I misspoke, it\'s basically the one that Syed</p>\n\n\n\n<p>does</p>\n\n\n\n<p><strong>David Bisset:</strong> the one. It\'s the one with the bear.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Yeah, yeah, yeah. So that\'s the one that basically is focused on.</p>\n\n\n\n<p>Uh, users that are non-technical and need the most hand-holding and have the most basic set of version of a form functionality available to them. So it\'s, it\'s kind of the polar opposite of like ACF by Brad, Tanard and delicious brains. Right. There\'s is like the most customizable, the most developer friendly, the most.</p>\n\n\n\n<p>Everything product that you can think of out there. And Syed is the opposite of that. And yet both of them are serving very successful markets and Syed\'s came in like years after all the other competitors were out there and, you know, carved out a new niche. So, you know, if you can look at a very hot space in WordPress, it could be payments.</p>\n\n\n\n<p>It could be e-commerce, it could be forms. It could be themes. Any of these things. If you could come up with a unique approach that serves an underserved market, then you can be successful out there. Don\'t come in and try to pick like the teeniest tiniest niche ever, and then hope that you can expand from that.</p>\n\n\n\n<p>If there\'s no demand, you\'re going to have a hard time making that product work. So it\'s, that\'s my advice is that, you know, pick markets that have energy that are, um, interesting that have customers. Demanding things that are, you know, shuffling money around because that\'s how you\'re going to get your solution out there and find somebody to pay for it.</p>\n\n\n\n<p>Each form. Competitor that\'s out there. They all kind of focus on different things. Some of them are focused on certain verticals, some of them on, you know, technical versus non-technical. And you just have to find that thing that you can go in and say, I can offer a solution to this group of people that need this thing that isn\'t served by these other products.</p>\n\n\n\n<p>That\'s a successful, um, that\'s a successful product in a crowded. It\'s been a</p>\n\n\n\n<p><strong>David Bisset:</strong> pleasure talking to you and, um, let\'s, let\'s have people figure out where you are on the web to be able to follow you and reach out for more Sage wisdom that you may spew out from time.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> Well, I don\'t know about Sage wisdom, but if anybody does want to talk to me about business, whether it\'s WordPress or non WordPress or SASS, or, uh, anything else, uh, you can reach me on Twitter at Dave Roden.</p>\n\n\n\n<p>Last name is spelled R O D E N B a U G H. Or if you\'re interested in checking out my SASS, that is recapture.io and we support a variety of WordPress platforms that you are likely using if you\'re in the WordPress space. So please come check it</p>\n\n\n\n<p><strong>David Bisset:</strong> out. And you\'re also in post status. Slack is.</p>\n\n\n\n<p><strong>Dave Rodenbaugh:</strong> I am very regularly.</p>\n\n\n\n<p>It is one of the few places that I check on a daily basis.</p>\n\n\n\n<p><strong>David Bisset:</strong> Yes. Well, thank you very much, Dave. Really appreciate it. And we will see you out there.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 01 Mar 2022 22:15:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"Post Status: Post Status Comments (No. 7) — The State Of WordPress Admin Notifications\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=93986\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://poststatus.com/post-status-comments-no-7-the-state-of-wordpress-admin-notifications/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4671:\"<h2 id=\"h-the-only-folks-able-to-do-a-free-plugin-are-ones-that-are-supported-by-a-big-corporation-matt-cromwell\">“The only folks able to do a free plugin are ones that are supported by a big corporation&#8230;” — Matt Cromwell</h2>\n\n\n\n<p class=\"has-drop-cap\">&#8220;They suck&#8221; might be one way to describe the state of WordPress admin notices as a whole, but that doesn\'t help us very much, does it? <strong>David Bisset</strong> is joined by <strong>Matt Cromwell</strong>, <strong>Jon Bossenger</strong>, <strong>Aurooba Ahmed</strong>, and several guests to discuss the current pain points and possible technical solutions. Why do developers overdo admin notices in the first place? Learn about <strong>WP Notify</strong>, how it approaches the problem, and how the WordPress community can help make this the core solution.</p>\n\n\n\n\n\n\n\n<p class=\"has-background\"><strong>Post Status Comments</strong> <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4ac.png\" alt=\"💬\" class=\"wp-smiley\" /> is a stage for WordPress professionals to exchange ideas and talk about recent topics and trends.<br /><br /><a href=\"https://poststatus.com/podcast/comments/\">Browse past episodes</a> and subscribe to <a href=\"https://poststatus.com/podcasts/\">our podcasts</a> on&nbsp; <a href=\"https://open.spotify.com/show/1m3xwXbe0MG5BzFVPtB0A7\">Spotify</a>, Amazon Music, <a href=\"https://podcasts.google.com/feed/aHR0cHM6Ly9mZWVkcy5zaW1wbGVjYXN0LmNvbS8ySkU5c2M4UA\">Google Podcasts</a>, <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">iTunes</a>, <a href=\"https://castro.fm/podcast/c53552c6-1ee0-4fc4-9de4-08ed6bf1ee4d\">Castro</a>, <a href=\"https://www.youtube.com/c/PostStatus\">YouTube</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, <a href=\"https://player.fm/series/wordpress-post-status-podcasts\">Player.fm</a>, <a href=\"https://pca.st/05rR\">Pocket Casts</a>, <a href=\"https://wordpress-post-status-draft-podcast.simplecast.com/\">Simplecast</a>, or get them by <a href=\"https://feeds.simplecast.com/2JE9sc8P\">RSS</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f399.png\" alt=\"🎙\" class=\"wp-smiley\" /></p>\n\n\n\n<h3 id=\"%f0%9f%99%8f-sponsor-godaddy-pro\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f64f.png\" alt=\"🙏\" class=\"wp-smiley\" /> Sponsor: <a href=\"https://poststatus.com/stellarwp\">StellarWP</a></h3>\n\n\n\n<p>We are a collective of WordPress innovators, empowering business owners and creators with plugins and tools to help them thrive. We build great plugins, but we don’t stop there; we continually challenge ourselves to keep innovating and improving.</p>\n\n\n\n<p>Our solutions include the most trusted names in WordPress, with more than 2.5 Million installs. Since 2021, we’ve grown to encompass seven brands and dozens of plugins.</p>\n\n\n\n<p>StellarWP is part of the Liquid Web family of brands.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h3 id=\"h-mentioned-in-the-show\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f517.png\" alt=\"🔗\" class=\"wp-smiley\" /> Mentioned in the show:</h3>\n\n\n\n<ul><li><a href=\"https://github.com/WordPress/wp-notify\">WP Notify &#8211; A Notification Center for WordPress (Feature Project)</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/01/wp-notify-status-update/\">WP Notify Status Update</a></li><li><a href=\"https://www.mattcromwell.com/delayed-admin-notice/\">Encourage Donations to your Free Plugins with a Delayed Admin Notice</a></li><li><a href=\"https://wptavern.com/clarity-ad-blocker-for-wordpress-announced-receives-mixed-reactions\">Clarity Ad Blocker for WordPress Announced, Receives Mixed Reactions</a></li></ul>\n\n\n\n<h3 id=\"follow-our-panelists-and-post-status-on-twitter-a4ffc805-90f1-41dc-9135-61b3ff20cb40\">Follow Our Panelists (and Post Status) on Twitter:</h3>\n\n\n\n<ul><li><a href=\"https://twitter.com/dimensionmedia\">David Bisset</a></li><li><a href=\"https://twitter.com/aurooba\">Aurooba Ahmed</a></li><li><a href=\"https://twitter.com/jon_bossenger\">Jon Bossenger</a></li><li><a href=\"https://twitter.com/learnwithmattc?lang=en\">Matt Cromwell</a></li><li><a href=\"https://twitter.com/post_status\" target=\"_blank\" rel=\"noreferrer noopener\">Post Status</a></li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<p></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 01 Mar 2022 21:26:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Strattic Acquires WP2Static  Plugin, Plans to Relaunch on WordPress.org\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130646\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"https://wptavern.com/strattic-acquires-wp2static-plugin-plans-to-relaunch-on-wordpress-org\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3332:\"<p>Strattic, a WordPress hosting company that creates static files managed via a headless install, has <a href=\"https://www.strattic.com/wp2static-joins-strattic/\">acquired WP2Static</a>, an open source plugin for generating a static WordPress site. Leon Stafford, the plugin&#8217;s creator, has been working for the company for the past nine months and will continue to maintain WP2Static.</p>\n\n\n\n<p>In 2020, Stafford <a href=\"https://staticword.press/t/removal-of-wp2static-from-wordpress-org/159\">removed WP2Static from WordPress.org</a> after the downsides of hosting in the directory began to outweigh the benefits for his project. He cited WordPress.org&#8217;s lack of a straightforward way to  alert users to important updates, users abusing the Reviews section to file issues, the inability to disable support, and the cumbersome plugin release process.</p>\n\n\n\n<p>WP2Static is a tool aimed more at DIY users who want to manage their own static site generation, but Stafford found that hosting on WordPress.org often brought the plugin to users who didn&#8217;t fully understand its function.</p>\n\n\n\n<p>&#8220;It was almost too easy for people to install <a href=\"https://wordpress.org/plugins/static-html-output-plugin/\">WP2Static/Static HTML Output</a> when in the wp.org repository,&#8221; he said. &#8220;This lead to quite a few people installing it on their live production servers and expecting some magic performance improvement, which is not the way it’s intended to be used.&#8221; </p>\n\n\n\n<p>Acquiring WP2Static allows Strattic to funnel the less technical crowd to its hosting services, as well as those who prefer a more managed experience. At the moment users get updates from the <a href=\"https://wp2static.com/download/\">WP2Static website</a>, or via the Composer package, or GitHub download. Strattic plans to relaunch the plugin on WordPress.org to improve its discovery, installation, and update process.</p>\n\n\n\n<p>&#8220;While Leon was focusing development primarily for the open source/GitHub users of the plugin, we&#8217;d like to get this static site solution helping as many WordPress users as possible and for that, the WordPress repository makes it the easiest experience for them,&#8221; Strattic CEO Miriam Schwab said.</p>\n\n\n\n<p>Schwab said prior to acquiring WP2Static, it was already generating high quality leads for Strattic, as Stafford had listed the company as an alternative to using the plugin.</p>\n\n\n\n<p>&#8220;We expect this trend will continue and grow now that WP2Static is part of the Strattic family,&#8221; Schwab said. &#8220;WP2Static is an excellent option for users who want to test the waters with static WordPress in a low-commitment way, and also for users who are more &#8216;DIY&#8217; and get excited about building their own infrastructure and architecture for their websites, and maintaining it on an ongoing basis.&#8221;</p>\n\n\n\n<p>Strattic will be marketing the plugin as a starting point. Users who outgrow WP2Static will be encouraged to look to Strattic for more complex functionality, such as dynamic plugins, forms, search, 301 redirects, SEO plugins, multi-language, and other features not supported by the plugin. Schwab said they do not currently plan to rebrand WP2Static but are considering revising its name to “WP2Static by Strattic.&#8221; </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 01 Mar 2022 21:16:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: WordPress Multisite Is Still a Valuable and Often Necessary Tool\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130441\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"https://wptavern.com/wordpress-multisite-is-still-a-valuable-and-often-necessary-tool\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6194:\"<p class=\"has-drop-cap\">Rob Howard rocked the boat last week in calling for the <a href=\"https://masterwp.com/its-time-to-deprecate-wordpress-multisite/\">deprecation of WordPress multisite</a> in the latest MasterWP newsletter. He argued that &#8220;the brave and noble add-on is no longer necessary or valuable to developers.&#8221; The <a href=\"https://twitter.com/ChrisWiegman/status/1496500570328342533\">responses via Twitter</a> were swift and in disagreement.</p>\n\n\n\n<p>Before WordPress 3.0, multisite was an entirely separate system called <a href=\"https://codex.wordpress.org/WordPress_MU\">WPMU</a> (WordPress MultiUser). It was a mess to set up, and one of the best things to ever happen to it was that it was rolled into core WordPress. It became a first-class citizen in the WordPress world, and its setup is now simple enough that nearly anyone can get a network up and running in no time.</p>\n\n\n\n<p>I have not used multisite much in my career in the WordPress space. My primary use case has been for setting up theme and plugin demos. These are sites that I do not intend to touch much outside of their initial setup. Multisite always makes it easy to manage theme and plugin updates from the network admin.</p>\n\n\n\n<p>Howard argued that this is no longer necessary in today&#8217;s world:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Likewise, sharing themes and plugins between sites no longer seems like a benefit to developers or end-users. With one click, we can deploy a parent theme from a Git repository to an unlimited number of sites hosted anywhere in the world – so what&#8217;s the real value of having a theme on the Multisite network?</p></blockquote>\n\n\n\n<p>Even with the vast tools available for deploying such things via Git, sometimes I prefer to avoid complicating matters. I can work in the command line well enough, but having that central location to manage all of my sites in one place is simpler. The argument also leaves out an entire segment of users who run multisite and have never even heard of Git. Multisite is sometimes a user tool.</p>\n\n\n\n<p>The most complex multisite setup I have worked on was for a university. I was contracted to do some development work for another WordPress agency a few years ago. My focus area was extending the user role and permissions system.</p>\n\n\n\n<p>The network had sites for each school, department, and various other projects. Setting all of this up on multisite allowed the permanent dev team to create new sites on an as-needed basis instead of spinning up an entirely new WordPress install. Everyone also had user access via their university email and password. It is possible to share a user database via multiple single-site installs, but it adds another layer of complexity that does not exist with multisite.</p>\n\n\n\n<p>I cannot imagine the agency running this through 100s of individual installs. I am sure that some systems would make this easier, but a solution already exists in WordPress.</p>\n\n\n\n<p>My multisite experience is limited. However, I have routinely talked with and helped fellow developers actively working on networks with 1,000s of sites in the enterprise and education sectors. It is almost a given that they are running multisite for every job.</p>\n\n\n\n<p>WordPress co-founder Mike Little explained why multisite is often necessary for his work <a href=\"https://twitter.com/mikelittlezed1/status/1496912733048033285\">via Twitter</a>:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>Of course, I manage a hundred single instances too, a couple of them are 3-6-site multisites, but most are single (and should remain so). But one client of mine has close to 450 sub-sites on one of his multisites. That would be impossible to manage as separate sites.</p><p>Around 1K users per subsite, up to 100+pages of content created/day during an event. etc. It&#8217;s also constantly being developed.</p><p>Rolling out fortnightly code changes to 400+ single sites (not mentioning there are more than a dozen other instances with up to 50 sub sites each) would be unmanageable. And this isn&#8217;t a for profit org, so doesn&#8217;t have unlimited funds.</p></blockquote>\n\n\n\n<p>I have sat on this article since last Wednesday. At the time, I was ready to leap into the fire and defend multisite. However, as the responses rolled in via Twitter to the MasterWP article, I was disheartened by a few of the responses from the WordPress community.  I did not want to feel like I was piling on.</p>\n\n\n\n<p>The world of social media has made knee-jerk reactions all too common and uninviting to those outside of the inner WordPress circle. There is too much pressure to not say the &#8220;wrong&#8221; thing that so few end up saying anything worthwhile &#8212; or at all. Fortunately, there is still some thoughtful discourse, such as the <a href=\"https://wpowls.co/articles/its-time-to-give-wordpress-multisite-some-love/\">response article</a> by Maciek Palmowski on WP Owls and from others on Twitter.</p>\n\n\n\n<p>Perhaps Howard was <em>really</em> just writing a click-bait article. However, because he only recently became the new owner of the MasterWP newsletter, I felt like I owed it to him to believe he was attempting to generate sincere discussion. Maybe his conclusion of deprecating a vital feature for many was off-base, but the conversation around problems with multisite is worth having.</p>\n\n\n\n<p>Regardless of the merits of Howard&#8217;s argument, it did lead to an idea that might just be worth exploring. <a href=\"https://twitter.com/schlessera/status/1496646033891201028\">Alain Schlesser tweeted</a>:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>I&#8217;d prefer for single-site to be deprecated instead, to not have a random differentiation anymore. Everyone just has a network, but some only have a single site on them. Would simplify everything…</p></blockquote>\n\n\n\n<p>I do not know what such a WordPress would look like, but I do know that it could simplify the multisite installation process if there were only one way of doing it. Perhaps there would be fewer edge cases, plugin issues, and wrinkles that developers need to iron out if there were only one flavor of WordPress.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 01 Mar 2022 02:13:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.org blog: People of WordPress: Tonya Mork\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12151\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://wordpress.org/news/2022/02/people-of-wordpress-tonya-mork/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11984:\"<p><strong>In this series, we share some of the inspiring stories of how WordPress and its global network of contributors can change people’s lives for the better. This month we feature a website developer and engineer from the US, who found the software and its community provide the impetus to keep her going forward.</strong></p>\n\n\n\n<p>WordPress gave Tonya Mork a new lease of energy after a health crisis from which she nearly died. She had spent two decades as an electrical and software engineer in high tech automated manufacturing. But when she discovered the WordPress software, teaching it to others became her new purpose. Through this discovery, she has gone on to help thousands of developers understand and build code in great depth.</p>\n\n\n\n<p>As part of her WordPress journey, she has shared her skills in the roles of Release Coordinator and the Core Tech Editor for the most recent major WordPress release, <a href=\"https://make.wordpress.org/core/5-9/\">5.9</a> Joséphine.&nbsp;</p>\n\n\n\n<div class=\"wp-block-image\"><img width=\"1024\" height=\"515\" src=\"https://i0.wp.com/wordpress.org/news/files/2022/02/featured-img-tonyamork.jpg?resize=1024%2C515&ssl=1\" alt=\"Tonya pictured in her work room\" class=\"wp-image-12326\" /></div>\n\n\n\n<h2 id=\"life-takes-an-unexpected-turn\">Life takes an unexpected turn</h2>\n\n\n\n<p>For the first 22 years of Tonya’s life, she rose through the ranks from enlisted personnel in the US Navy to a highly sought after chief engineer with a multi million-dollar industrial automation engineering firm.  </p>\n\n\n\n<p>However, while she was working in engineering, her life was to change dramatically. In 2007, Tonya started to face health challenges that had an impact on all that she had known.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p><strong>“My career defined me. It was my canvas and my art. When it was gone, I did not recognize myself.</strong></p><cite>Tonya Mork</cite></blockquote>\n\n\n\n<p>One day, she woke up at home ready to visit a client’s facility where her firm was building a robotic system. She said: “As I headed for the door, I fell to my knees, as this wave of pain crushed down on my chest.”</p>\n\n\n\n<p>Doctors diagnosed her with a very rare heart disease that caused her blood vessels to spasm, cutting off blood to whatever was downstream of the blockage. </p>\n\n\n\n<p>A few months later, she was diagnosed with a second rare and more serious condition, related to the migraines from which she had been suffering. Combined with her heart condition, this made every migraine attack life-threatening.</p>\n\n\n\n<p>For nearly seven years, the unexpected changes to her health left her mostly homebound and constantly monitored. This meant she had to close her engineering firm and say goodbye to staff and clients. </p>\n\n\n\n<p>“My career defined me. It was my canvas and my art. When it was gone, I was lost. I didn’t recognize myself.”</p>\n\n\n\n<p>But in her darkest hour, she found her strength. Tonya made a choice to move forward, and make the most of her life.</p>\n\n\n\n<p>“When you are at rock bottom, you have to make a decision or else it will consume you. My decision was that I chose to be happy,” said Tonya.</p>\n\n\n\n<p>One of Tonya’s first steps was to start writing a blog using WordPress. In this she shared insights on how to find peace and joy in any situation. She wrote about kindness and helping one another.&nbsp;</p>\n\n\n\n<p>The joy of making solutions through WordPress became a way for Tonya to accept her new life and not feel as limited by her health. She wanted purpose, and in WordPress, she found just that.</p>\n\n\n\n<p>Tonya felt she could do something worthwhile in the virtual world.&nbsp;</p>\n\n\n\n<h2 id=\"a-ray-of-hope-for-tonya\">A ray of hope for Tonya</h2>\n\n\n\n<div class=\"wp-block-image\"><img width=\"1000\" height=\"750\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/02/tonya.jpg?resize=1000%2C750&ssl=1\" alt=\"\" class=\"wp-image-12327\" /></div>\n\n\n\n<p>In 2013, Tonya’s health deteriorated further. She was admitted into intensive care and was diagnosed with a third rare disease, this time related to her autoimmunity. She was not expected to survive this time. </p>\n\n\n\n<p>Following what she describes as a ‘miraculous recovery,’ she became stronger and was able to stop relying on a wheelchair. She used the energy from working on websites to keep going. “WordPress kept my mind alive,” said Tonya.</p>\n\n\n\n<p>She had first used WordPress for her engineering firm’s intranet. But when she discovered the software’s full potential and the collaborative opportunities of open source, it opened a new world.&nbsp;</p>\n\n\n\n<blockquote><p>&#8220;Finding WordPress helped me to find myself again&#8221;</p><cite>Tonya Mork</cite></blockquote>\n\n\n\n<p>During the years which followed, she donated her time to build some WordPress websites and plugins. She said: “Through giving my time, I was able to do something other than sit in isolation.” </p>\n\n\n\n<p>Tonya was amazed by the sharing in open source in general and in WordPress in particular. She said: “I was amazed to see people sharing so much information freely with one another. In my former engineering world, information was proprietary. Throughout my career, I had worked to break down those silos and help anyone to understand complex systems. I was drawn to this open community.”&nbsp;</p>\n\n\n\n<p>She also became aware that WordPress developers were hungry to learn more about development. She wanted to be part of the solution with her passion for teaching and the knowledge she had gained in industry.<br /><br />She said: “Finding WordPress helped me to find myself again. Here in this community, I was able to feel like a person again, not a sick one, but a professional with something to give.”</p>\n\n\n\n<p>As her interest in the software grew, Tonya decided to start a non-profit where she turned to WordPress to build the websites. This re-sparked her interest in programming. She said: “I wanted to really know the code and understand what made it tick.”</p>\n\n\n\n<p>The realization led Tonya to start the WP Developers’ Club, which in turn spawned <a href=\"https://knowthecode.io/\">Know the Code</a>, to help educate individual developers, and is still used today.</p>\n\n\n\n<h2 id=\"from-helping-wordpress-companies-to-working-on-wordpress-core\">From helping WordPress companies to working on WordPress Core</h2>\n\n\n\n<div class=\"wp-block-image\"><img width=\"300\" height=\"300\" src=\"https://i0.wp.com/wordpress.org/news/files/2022/02/tonya-with-dog.jpg?resize=300%2C300&ssl=1\" alt=\"Tonya pictured with her dog\" class=\"wp-image-12328\" /></div>\n\n\n\n<p>Tonya went on to work with big and medium size WordPress companies helping their developers and supporting them in raising their firms’ leverage with WordPress.</p>\n\n\n\n<p>By late 2020, she knew she wanted to do even more with WordPress.</p>\n\n\n\n<p>In February 2021, Tonya joined an international firm in the ecosystem and began working closely on WordPress Core.</p>\n\n\n\n<p>At that time, WordPress Core was pulling together a new Triage team. Tonya started volunteering on that team to find collaborative solutions, and help others do so. In 2020 for <a href=\"https://wordpress.org/news/2020/12/simone/\">WordPress 5.6 Simone</a>, she became the release’s Triage lead, and again for <a href=\"https://make.wordpress.org/core/5-7/\">WordPress 5.7 Esperanza</a>.&nbsp;</p>\n\n\n\n<p>In 2021, she became a Test Team Rep and helped to expand the team and is an advocate for the value of testing and feedback in the release development process.</p>\n\n\n\n<h2 id=\"a-new-successful-chapter-with-wordpress-5-9\">A new, successful chapter with WordPress 5.9</h2>\n\n\n\n<div class=\"wp-block-image\"><img width=\"1024\" height=\"480\" src=\"https://i1.wp.com/wordpress.org/news/files/2022/02/WP59-thumbnail-jb.png?resize=1024%2C480&ssl=1\" alt=\"Tonya was one of the notable contributors to the WordPress 5.9 release featured in this picture.\" class=\"wp-image-12329\" /></div>\n\n\n\n<p>Tonya’s passion for the software and getting people involved in its growth continued. For the WordPress 5.9 release in 2021, she took on the role of both the Core Tech Lead and the Release Coordinator. As this was a big release and included the first major implementation of Full Site Editing, it had many moving parts and hundreds of contributors. She was able to share the skills she had learned in communication and project management from her days streamlining and documenting engineering software and processes.&nbsp;</p>\n\n\n\n<p>In the first 24 hours of WordPress 5.9 landing, it had more than 10 million downloads—and 17 formally reported bugs.</p>\n\n\n\n<h2 id=\"giving-back-to-open-source\">Giving back to open source</h2>\n\n\n\n<p>Now in what Tonya describes as her third chapter. She said: “I’m a very different person from the engineer I used to know. What really matters in this world is when you reach out and make a difference in someone’s life.”</p>\n\n\n\n<p>She feels she has found her purpose in this life. “I’m on a mission to give back and make a difference. Teaching is how I will do it. And in WordPress I have found my professional home, and I have all this software knowledge that I just want to share.”</p>\n\n\n\n<h2 id=\"share-the-stories\">Share the stories</h2>\n\n\n\n<p>Help share these stories of open source contributors and continue to grow the community. Meet more WordPressers in the <a href=\"https://wordpress.org/news/category/newsletter/interviews/\">People of WordPress series.</a> #ContributorStory.</p>\n\n\n\n<h2 id=\"contributors-to-this-feature\">Contributors to this feature</h2>\n\n\n\n<p>Thank you to Tonya Mork (<a href=\"https://profiles.wordpress.org/hellofromtonya/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>hellofromtonya</a>) for sharing her story. </p>\n\n\n\n<p>Interviews and feature by Abha Thakor (<a href=\"https://profiles.wordpress.org/webcommsat/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>webcommsat</a>) and Mary Baum (<a href=\"https://profiles.wordpress.org/marybaum/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>marybaum</a>). Reviewed by Chloe Bringmann (<a href=\"https://profiles.wordpress.org/cbringmann/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>cbringmann</a>), Nalini Thakor (<a href=\"https://profiles.wordpress.org/nalininonstopnewsuk/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>nalininonstopnewsuk</a>), Meher Bala (<a href=\"https://profiles.wordpress.org/meher/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>meher</a>), and Anjana Vasan (<a href=\"https://profiles.wordpress.org/anjanavasan/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>anjanavasan</a>). Photo editing Reyez Martínez (<a href=\"https://profiles.wordpress.org/rmartinezduque/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>rmartinezduque</a>) and Jean Baptiste Audras (<a href=\"https://profiles.wordpress.org/audrasjb/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>audrasjb</a>). </p>\n\n\n\n<p><em>Thanks to Josepha Haden Chomphosy&nbsp;(@<a href=\"https://profiles.wordpress.org/chanthaboune/\">chanthaboune</a>) and Topher DeRosia (<a href=\"https://profiles.wordpress.org/topher1kenobe/\">@topher1kenobe</a>) and others for their support&nbsp;</em>of this initiative.</p>\n\n\n\n<div class=\"wp-block-media-text is-stacked-on-mobile is-vertically-aligned-center\"><img width=\"180\" height=\"135\" src=\"https://i1.wp.com/wordpress.org/news/files/2020/03/heropress_logo_180.png?resize=180%2C135&ssl=1\" alt=\"HeroPress logo\" class=\"wp-image-8409 size-full\" /><div class=\"wp-block-media-text__content\">\n<p class=\"has-small-font-size\"><em>This People of WordPress feature is inspired by an essay originally published on </em><a href=\"https://heropress.com/\"><em>HeroPress.com</em></a><em>, a community initiative created by Topher DeRosia. It highlights people in the WordPress community who have overcome barriers and whose stories might otherwise go unheard. </em>#HeroPress </p>\n</div></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Feb 2022 23:55:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"webcommsat AbhaNonStopNewsUK\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"WPTavern: WPExperts Acquires Post SMTP Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130623\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wptavern.com/wpexperts-acquires-post-smtp-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3010:\"<p><a href=\"https://wpexperts.io/\">WPExperts</a>, a Pakistan and Egypt-based WordPress development agency with more than 120 employees, has acquired the <a href=\"https://wordpress.org/plugins/post-smtp/\">Post SMTP plugin</a> from its former developer, Yehuda Hassine. This is the agency&#8217;s second acquisition this year, after picking up Rich Tabor&#8217;s <a href=\"https://richtabor.com/bye-logindesigner/\">Login Designer</a> plugin in January.</p>\n\n\n\n<p>The Post SMTP plugin is a fork of the <a href=\"https://wordpress.org/plugins/postman-smtp/\">Postman SMTP</a> plugin, which was <a href=\"https://wptavern.com/postman-smtp-plugin-forked-after-removal-from-wordpress-org-for-security-issues\">closed by WordPress.org in 2017</a> due to an unfixed security vulnerability. Hassine, a longtime user of the plugin, fixed the vulnerability, forked it, and renamed it to <a rel=\"noreferrer noopener\" href=\"https://wordpress.org/plugins/post-smtp/\" target=\"_blank\">Post SMTP Mailer/Email Log</a>. He grew the plugin to more than 300,000 active users, managing its development and support by himself, before becoming too busy with his full-time job.</p>\n\n\n\n<p>Post SMTP improves the delivery of emails that WordPress generates and it logs the causes of failed emails to help eliminate configuration mistakes. Its chief competitors include <a href=\"https://wordpress.org/plugins/wp-mail-smtp/\">WP Mail SMTP by WPForms</a> (2 million+ installs) and <a href=\"https://wordpress.org/plugins/easy-wp-smtp/\">Easy WP SMTP</a> (600,000 installs). WPExperts plans to continue the plugin&#8217;s free version and does not plan to release a commercial version. Instead, they are working towards monetizing it with paid add-ons.</p>\n\n\n\n<p>&#8220;This is the biggest acquisition for WPExperts in terms of acquired plugin active users (300,000+),&#8221; WPExperts community manager Zubair Siddiq said. &#8220;WPExperts will enhance Post SMTP&#8217;s current UI, features, and support.&#8221;</p>\n\n\n\n<p>Before selling Post SMTP, Hassine was working on six paid add-ons, which were included in the deal with WPExperts but they are still under development. The add-ons in progress include the following: <a href=\"https://twitter.com/saadyiqbal\"></a></p>\n\n\n\n<ul><li>Office 365 </li><li>Amazon SES </li><li>Sendinblue </li><li>Mail Control </li><li>Twilio Notification </li><li>Better logger</li></ul>\n\n\n\n<p>WPExperts founder Saad Iqbal said the acquisition is aimed at building additional revenue streams for the agency&#8217;s plugin shop. Post SMTP joins WPExperts&#8217; collection of nearly 60 free plugins hosted on WordPress.org. </p>\n\n\n\n<p>&#8220;I normally find plugins in .org and then contact the owner to see if they want to sell,&#8221; Iqbal said. &#8220;We are always looking to acquire cool WordPress plugins.&#8221;</p>\n\n\n\n<p>Now that Post SMTP has moved to its new owner, users can expect development and support from a much larger team of professionals, as well as new commercial add-ons in the near future. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Feb 2022 20:51:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"Gutenberg Times: Building with Blocks, Hyping Headers, 52 Themes and more – Weekend Edition 204\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://gutenbergtimes.com/?p=20496\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"https://gutenbergtimes.com/building-with-blocks-hyping-headers-52-themes-and-more-weekend-edition-204/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:28834:\"<p>Howdy, </p>\n\n\n\n<p>As many, I look with horror at the tanks and troops marching into the Ukraine. My heart goes out to all the people there, especially WordPress contributors. In Friday&#8217;s issue of <em>The Repository</em>, <a href=\"https://twitter.com/raemoreywrites\"><strong>Rae Morey </strong></a>wrote on <a href=\"https://www.therepository.email/?mailpoet_router&endpoint=view_in_browser&action=view&data=WzEyOSwiZGI3MWYyNzYyZmVkIiwwLDAsMjAyLDFd\">Standing by WordPress Folks in Ukraine</a> with more details. We are here for everyone affected. If you need any kind of support, please reach out, and we&#8217;ll do our best to help as much as possible. Please stay safe! </p>\n\n\n\n<p>If it feels hard to focus on work and projects, you are not alone. It&#8217;s ok. Take care of yourself.</p>\n\n\n\n<p>Yours, 💕 <br />Birgit</p>\n\n\n\n<p>PS: If you are a developer, I hope to see you at the <a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\">next Gutenberg Developer Hours on March 8th 11:00 ET / 16:00 UTC</a> withe fabulous Tammie Lister, Fabian Kägy, and Grzegorz Ziolkowski as expert panelists. </p>\n\n\n\n<a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\"><img /></a>\n\n\n\n<p>In the post, <a href=\"https://make.wordpress.org/core/2022/02/24/february-8th-gutenberg-developer-hours-session-evaluation/\"><strong>February 8th Gutenberg Developer Hours – Session Evaluation</strong></a> I published the results from the participant survey. You can read all the comments and suggestions on the Core Make Blog. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-dots\" />\n\n\n\n\n<div class=\"wp-container-5 wp-block-group has-light-background-background-color has-background\"><div class=\"wp-block-group__inner-container\">\n<p><strong>Table of Contents</strong></p>\n\n\n\n<div class=\"wp-block-sortabrilliant-guidepost\"><ul><li><a href=\"https://gutenbergtimes.com/feed/#0-whats-released\">WordPress and Gutenberg releases </a><ul><li><a href=\"https://gutenbergtimes.com/feed/#1-gutenberg-12-6-release\">Gutenberg 12.6 Release</a></li><li><a href=\"https://gutenbergtimes.com/feed/#wordpress-5-9-1-and-6-0\">WordPress 5.9.1 and 6.0</a></li></ul></li><li><a href=\"https://gutenbergtimes.com/feed/#updates-for-site-builders-and-content-creators\">Updates for Site builders and Content Creators</a><ul><li><a href=\"https://gutenbergtimes.com/feed/#training-and-learning\">Training and Learning</a></li><li><a href=\"https://gutenbergtimes.com/feed/#block-themes\">Block themes</a></li><li><a href=\"https://gutenbergtimes.com/feed/#plugins-for-the-block-editor\">Plugins for the Block editor </a></li></ul></li><li><a href=\"https://gutenbergtimes.com/feed/#developing-for-gutenberg\">Developing for Gutenberg</a><ul><li><a href=\"https://gutenbergtimes.com/feed/#around-themes-and-site-design\">Around Themes and Site Design</a></li><li><a href=\"https://gutenbergtimes.com/feed/#proposal-for-standardized-design-and-css-handling\">Proposal for Standardized Design and CSS handling</a></li><li><a href=\"https://gutenbergtimes.com/feed/#custom-blocks-and-tools\">Custom Blocks and Tools</a></li></ul></li><li><a href=\"https://gutenbergtimes.com/feed/#upcoming-wordpress-events\">Upcoming WordPress Events</a><ul><li><a href=\"https://gutenbergtimes.com/feed/#learn-wordpress-social-learning-spaces\">Learn.WordPress Social Learning Spaces</a></li><li><a href=\"https://gutenbergtimes.com/feed/#wordfest-live-starts-march-4th-2022\">WordFest Live starts March 4th, 2022</a></li></ul></li></ul></div>\n</div></div>\n\n\n\n\n<h2 id=\"0-whats-released\">WordPress and Gutenberg releases </h2>\n\n\n\n<h3 id=\"1-gutenberg-12-6-release\">Gutenberg 12.6 Release</h3>\n\n\n\n<p>Have a look at the Release notes by <strong><a href=\"https://twitter.com/apeatling\">Andy Peatling</a></strong> <a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/\">What’s new in Gutenberg 12.6? (16 February)</a> with the highlights: </p>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/#new-color-panel-and-updated-default-color-controls\">New color panel and updated default color controls</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/#new-post-author-biography-and-read-more-blocks\">New Post Author Biography and Read More blocks</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/#keeping-styles-when-transforming-blocks\">Keeping styles when transforming blocks</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/#error-boundary-for-plugin-exceptions\">Error boundary for plugin exceptions</a></li><li><a href=\"https://make.wordpress.org/core/wp-admin/post.php?post=94472&action=edit#iterative-polishing-of-the-loading-states\">Iterative polishing of the loading states</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/#accessibility-improvements\">Accessibility Improvements</a></li></ul>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><strong>Justin Tadlock</strong> headlined his post <a href=\"https://wptavern.com/gutenberg-12-6-enhances-transforming-blocks-adds-read-more-and-post-author-bio-blocks-and-enables-social-icon-labels\"><strong>Gutenberg 12.6 Enhances Transforming Blocks, Adds Read More and Post Author Bio Blocks, and Enables Social Icon Labels</strong></a></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-61-universal-blocks/\"><strong>Gutenberg Changelog #61 Gutenberg 12.6, Planning for WordPress 6.0 and Universal Blocks</strong></a> <strong>Grzegorz Ziolkowski</strong> and I introduce <strong>Mary Job</strong> as the new co-host and discuss Gutenberg 12.6, Planning for WordPress 6.0 and Universal Blocks.</p>\n\n\n\n<img />Hosting the Gutenberg Changelog episode #61: <br />Mary Job, Grzegorz Ziolkowski and yours truly. \n\n\n\n<p>I can&#8217;t tell you how thrilled I am that <strong>Mary Job</strong> joined me as co-host on the Gutenberg Changelog podcast. We first met at the online JavaScript For WordPress conference and I can&#8217;t believe it&#8217;s been four years already. Among other things, Mary Job has been a WordPress community organizer in Nigeria for many years, and works as support engineer with Paid Membership Pro plugin.  </p>\n\n\n\n<p><em>Earlier this week, <a href=\"https://github.com/WordPress/gutenberg/releases/tag/v12.7.0-rc.1\">Gutenberg 12.7 RC </a>was made available, and you can download it from GitHub</em></p>\n\n\n\n\n<p><strong><a href=\"https://gutenbergtimes.com/need-a-zip-from-master/\">Need a plugin .zip from Gutenberg&#8217;s main (trunk) branch?</a></strong><br />Gutenberg Times provides daily build for testing and review. <br />Have you been using it? Hit reply and let me know.</p>\n\n\n\n<p><img alt=\"GitHub all releases\" src=\"https://img.shields.io/github/downloads/bph/gutenberg/total\" /></p>\n\n\n\n\n<h3 id=\"wordpress-5-9-1-and-6-0\">WordPress 5.9.1 and 6.0</h3>\n\n\n\n<p>Coordinated by <a href=\"https://twitter.com/AudrasJb\"><strong>Jean-Baptist Audras</strong></a> and <a href=\"https://twitter.com/Mamaduka\"><strong>George Mamadashvili</strong></a> <a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\"><strong>WordPress 5.9.1 </strong></a>was released on February 22, 2022, and provide 85 bug fixes over all components: Twenty-Twenty-Two Theme, Global Styles, Navigation block, Media Library, Gallery block, other blocks and theme.json.  <strong><a href=\"https://twitter.com/EstelaRueda\">Estela Rueda</a></strong> provided <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-5-9-1-rc-1/\">a list of all the PRs</a> announcing the release candidate.</p>\n\n\n\n<p><strong><a href=\"https://twitter.com/CBringmann\">Chloe Bringmann</a> </strong>published in her <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-6-0-planning-roundup/\">WordPress 6.0 Planning Roundup</a> the preliminary WordPress 6.0 schedule: </p>\n\n\n\n<ul><li>Feature freeze March 29th, 2022</li><li>First Beta release on April 12, 2022,&nbsp;</li><li>First Release candidate May 3rd, 2022&nbsp;</li><li>Final release on May 24, 2022</li></ul>\n\n\n\n<p>The release squad shows still a few open slots. If you consider joining the release squad, <a href=\"https://make.wordpress.org/core/handbook/about/release-cycle/wordpress-release-team-and-focus-leads/\">read up about responsibilities</a> and leave a comment on the post.</p>\n\n\n\n<ul><li><strong>Editor Tech</strong> </li><li><strong>Triage Lead</strong> </li><li><strong>Test Lead</strong></li><li><strong>Design Lead</strong></li><li><strong>Accessibility Lead</strong></li></ul>\n\n\n\n<h2 id=\"updates-for-site-builders-and-content-creators\">Updates for Site builders and Content Creators</h2>\n\n\n\n<p><strong>Anne McCarthy</strong> just published new instructions for testing Full-site editing in their <a href=\"https://make.wordpress.org/test/2022/02/23/fse-program-testing-call-12-hyping-headers/\"><strong>FSE Program Testing Call #12: Hyping Headers</strong></a>. The instructions guide you to  customize a&nbsp;header&nbsp;using everything from the&nbsp;navigation block&nbsp;to&nbsp;template part focus mode. Then you will reuse this personalized header in a different template. </p>\n\n\n\n<p>You&#8217;ll also explore how patterns are integrated into the experience, new dimension control options, and improved&nbsp;UX&nbsp;for the navigation&nbsp;block.&nbsp; <strong>Deadline for your feedback is March 16, 2022. </strong></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><strong><a href=\"https://twitter.com/prithuthakuri\">Prithu Thakuri </a></strong>explores in her article on WPMayor <a href=\"https://wpmayor.com/wordpress-full-site-editing-fse-features-and-its-impact/\"><strong>WordPress Full Site Editing (FSE): The Features and their Impact on Users and Businesses</strong></a>. She first explains the four components of the full-site editing experience and then for each WordPress user group she summarizes what impact there might be and how best to handle old and new projects regarding adoption. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In WPTavern&#8217;s new series &#8220;Building with Blocks&#8221;, <strong>Sarah Gooding</strong> shared <a href=\"https://wptavern.com/how-to-build-a-vcard-website-with-a-video-background\"><strong>How to Build a vCard Website with a Video Background</strong></a>. She estimated you could accomplish the task in under five minutes, using a blank canvas template or theme, a few core blocks and a background video from a service like Pixabay. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In the <a href=\"https://href.li/?https://stunningdigitalmarketing.com/episode-197-the-move-to-gutenberg-and-the-roadmap-to-wordpress-6-0/\"><strong>SDM Show Episode 197: The Move to Gutenberg and The Roadmap to WordPress 6.0</strong></a>, <strong><a href=\"https://twitter.com/RobCairns\">Rob Cairns</a></strong> sat down with <strong>Matias Ventura</strong>, lead architect of Gutenberg at Automattic, and me to discuss Cairn&#8217;s site move to Gutenberg/Blocks from a WordPress Page Builder. We also took a closer look at the roadmap  WordPress 6.0.</p>\n\n\n\n<h3 id=\"training-and-learning\">Training and Learning</h3>\n\n\n\n<p>The newest <em>Learn.WordPress</em> workshop: <a href=\"https://learn.wordpress.org/workshop/building-sidebars-with-the-site-editor/\"><strong>&#8220;Building Sidebars With the Site Editor&#8221;</strong></a> with <strong>Sarah Snow</strong> in which you learn how to use the site editor to add a sidebar automatically to any post, page, or template.</p>\n\n\n\n<p><strong>Full Site Editing Courses published on Learn.Wordpress.org </strong></p>\n\n\n\n<ul><li><a href=\"https://learn.wordpress.org/course/simple-site-design-with-full-site-editing/\">Part I: Simple Site Design with Full Site Editing</a> (15 Lessons)</li><li><a href=\"https://learn.wordpress.org/course/part-2-personalized-site-design-with-full-site-editing-and-theme-blocks/\">Part II: Personalized Site Design with Full Site Editing and Theme Blocks</a> (7 Lessons) </li><li><a href=\"https://learn.wordpress.org/course/part-3-advanced-site-design-with-full-site-editing-site-editor-templates-and-template-parts/\">Part III: Advanced Site Design with Full Site Editing: Site Editor, Templates and Template Parts</a> (7 Lessons)</li></ul>\n\n\n\n<p>A total of 29 Lessons will get you up and running  with the new Site Editor, template editor and Styles controls for your website. </p>\n\n\n\n<p>Sometimes, intuition is not enough to master a new set of technology tools. Occasionally, you need to read the manual or have someone show you what is possible to figure out what you want to do with it. </p>\n\n\n\n<ul><li>Check out <a href=\"https://learn.wordpress.org/workshops/?topic=7\">all other block-editor tutorials</a> available. </li><li>Join the Training team on the <a href=\"https://www.meetup.com/wordpress-social-learning/\">WordPress Social Learning</a> meetup for discussions and demos every week. </li></ul>\n\n\n\n<h3 id=\"block-themes\">Block themes</h3>\n\n\n\n<p><strong>Fifty-two (52)  block themes</strong>, ready for full-site editing, are now available in the <a href=\"https://wordpress.org/themes/tags/full-site-editing/\"><strong>WordPress repository</strong></a>. The latest additions are </p>\n\n\n\n<ul><li><a href=\"https://wordpress.org/themes/skatepark/\"><strong>Skatepark</strong></a> by Automattic (<a href=\"https://wptavern.com/skatepark-is-a-bold-and-vibrant-block-theme-for-events-and-organizations\"><em>WPTavern review</em></a>)</li><li><a href=\"https://wordpress.org/themes/wabi/\"><strong>Wabi </strong></a>by Rich Tabor (<a href=\"https://wptavern.com/unearthing-hidden-treasures-in-the-wabi-wordpress-block-theme\"><em>WPTavern review</em></a>)</li><li><a href=\"https://wordpress.org/themes/allele/\"><strong>Allele</strong></a> by DesignOrbital</li><li><a href=\"https://wordpress.org/themes/x-t9/\"><strong>X-T9</strong></a> by Hidekazu Ishikawa of Vektor, Inc.</li><li><a href=\"https://wordpress.org/themes/x3p0-reflections/\"><strong>X3P0 &#8211; Reflections </strong></a>by Justin Tadlock</li><li><a href=\"https://wordpress.org/themes/richmond/\"><strong>Richmond</strong> </a>by UXL</li></ul>\n\n\n\n<p><em>If you used any of them, let me know how they worked out for you! </em></p>\n\n\n\n<a href=\"https://wordpress.org/themes/tags/full-site-editing/\"><img /></a>\n\n\n\n<p>According to <a href=\"https://twitter.com/Ana_Segota/status/1497258214013952003\"><strong>Ana Segota</strong></a>, the <a href=\"https://wordpress.org/themes/bricksy/\">block theme </a><strong><a href=\"https://wordpress.org/themes/bricksy/\">Bricksy</a> </strong>received an update: </p>\n\n\n\n<ul><li>handwritten images are replaced with a script font for easier customization</li><li>added Dark Mode, in case the Gutenberg plugin activated.</li></ul>\n\n\n\n<p><strong><a href=\"https://twitter.com/richard_tabor\">Rich Tabor</a> </strong>blogged about <a href=\"https://richtabor.com/wabi/\"><strong>his Wabi block theme</strong></a>. &#8220;With Wabi, you may pick an accent color for each post and “theme” that content, providing a clever design layer to compliment the theme’s minimal style.&#8221; </p>\n\n\n\n<p><a href=\"https://twitter.com/pootlepress\"><strong>Jamie Marsland</strong></a> uses the Wabi theme in his latest YouTube Video: <a href=\"https://www.youtube.com/watch?v=WK9lD8l_D4k\"><strong>This Gutenberg Block Theme is the future of WordPress</strong></a></p>\n\n\n\n<p><strong><a href=\"https://twitter.com/ellenbauer\">Ellen Bauer,</a></strong> ElmaStudio &#8211; creators of the <a href=\"https://wordpress.org/themes/aino/\"><strong>Aino Theme</strong></a>, explains briefly in her<a href=\"https://www.tiktok.com/@ainoblocks/video/7068144993675922689\"> latest Tiktok video the feature set that creates a full-site editing experience. </a></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<h3 id=\"plugins-for-the-block-editor\">Plugins for the Block editor </h3>\n\n\n\n<p><a href=\"https://twitter.com/aurooba\"><strong>Aurooba Ahmed</strong></a> is on a roll producing new <a href=\"https://profiles.wordpress.org/aurooba/#content-plugins\">plugins for the block editor</a>  almost every week. The newest plugin, <strong><a href=\"https://wordpress.org/plugins/quickpost/\">Quick Post</a> </strong>brings back the highly used Add New Post button to the top toolbar of the post editor. </p>\n\n\n\n<p>Justin Tadlock&#8217;s review is available on WPTavern: <strong><a href=\"https://wptavern.com/quickpost-plugin-allows-users-to-create-new-or-duplicate-posts-from-the-wordpress-content-editor\">QuickPost Plugin Allows Users To Create New or Duplicate Posts from the WordPress Content Editor</a> </strong></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<h2 id=\"developing-for-gutenberg\">Developing for Gutenberg</h2>\n\n\n\n<p><strong><a href=\"https://twitter.com/wpbuilds\">Nathan Wrigley</a></strong> produces now weekly podcast episodes for the <em>WPTavern Jukebox</em>. In episode #14 he hosted <a href=\"https://wptavern.com/podcast/14-dave-smith-isabel-brison-and-joen-asmussen-on-the-new-navigation-block\"><strong>Dave Smith, Isabel Brison and Joen Asmussen</strong> </a>team members at Automattic and who worked on the new Navigation Block. Learn more about the guests&#8217; various backgrounds, and a look behind the scenes of building one of the most important blocks for a website. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>The <strong><a href=\"https://href.li/?https://www.youtube.com/watch?v=VGkvVvlIWEM\">second session of the Gutenberg Developer Hours</a></strong> saw 100 people register and 47 attending. The raw recording is available on YouTube. Huge thank you to our expert panelists and facilitators Joni Halabi, Daisy Olsen, George Mamadashvili and Nick Diego.</p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>On Make Core block, I published a <strong><a href=\"https://make.wordpress.org/core/2022/02/25/proposal-to-start-a-news-blog-on-developer-wordpress-org/\">Proposal to Start a News blog on developer.WordPress.org</a>.</strong> We worked on this in a team of a few people, before it was published. It now needs your comments, ideas, and support. </p>\n\n\n\n<h3 id=\"around-themes-and-site-design\">Around Themes and Site Design</h3>\n\n\n\n<p>The Theme team published again their roundup of current discussion, new features and updates in <a href=\"https://make.wordpress.org/themes/2022/02/18/gutenberg-themes-week-of-february-14th-2022/\"><strong>Gutenberg + Themes: Week of February 14th, 2022</strong></a>. For instance: You can now <a href=\"https://github.com/WordPress/gutenberg/pull/38323\">register patterns from directory with theme.json</a>. (coming to the plugin in 12.7 version) </p>\n\n\n\n<p>They also highlight a new page in documentation that provides a high-level intro to how styles work in the block editor: <a href=\"https://developer.wordpress.org/block-editor/explanations/architecture/styles/\"><em>Explanation &gt; Architecture</em> sections for <strong>Styles</strong></a>.</p>\n\n\n\n<p><a href=\"https://make.wordpress.org/themes/2022/02/18/gutenberg-themes-week-of-february-14th-2022/\"><em>Have a look at the full post</em></a></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In the Theme team&#8217;s handbook, the page <a href=\"https://developer.wordpress.org/themes/block-themes/converting-customizer-settings-to-block-patterns/\"><strong>Converting customizer settings to block patterns</strong></a> has been updated by <strong><a href=\"https://twitter.com/carolinapoena\">Carolina Nymark</a></strong> to showcase a conversion assuming a real-world example. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><strong><a href=\"https://twitter.com/critterverse\">Channing Ritter</a></strong> from the WordPress Design team published her <a href=\"https://make.wordpress.org/design/2022/02/14/design-share/\">Design Share</a>. Among other topics, she highlights work in progress for </p>\n\n\n\n<ul><li>Advanced template creation</li><li>Using featured images in various blocks</li><li>Pattern fills in overlays</li></ul>\n\n\n\n<p>Ritter stated that these team updates will be published on a bi-weekly basis. You could subscribe to the <a href=\"https://make.wordpress.org/design/tag/design-share/feed/\">tag feed of #design-share </a>in your feed readers</p>\n\n\n\n<p><em><a href=\"https://make.wordpress.org/design/2022/02/14/design-share/\">Check it out</a> and chime in on various design questions.</em> </p>\n\n\n\n<img />Detail from larger mockup\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><strong>Justin Tadlock </strong>picked up on a discussion on Twitter about how naming things might be confusing in the FSE WordPress space and clarified a few things in his post  <a href=\"https://wptavern.com/block-fse-hybrid-universal-what-do-we-call-these-new-wordpress-themes\"><strong>Block, FSE, Hybrid, Universal? What Do We Call These New WordPress Themes?</strong></a> </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In her post, <strong><a href=\"https://wptavern.com/gutenberg-contributors-explore-more-advanced-template-creation\">Gutenberg Contributors Explore More Advanced Template Creation</a> Sarah Gooding</strong> followed a discussion started by <strong>James Koster</strong> on GitHub. She shared Koster&#8217;s video, and then quotes from the discussion around template creation for Custom Post Types. It would allow site administrators to eliminate a lot of hard-coded template PHP from their sites and provide a way for users to update their CPT templates themselves. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><strong>Carolina Nymark</strong> announced on <a href=\"https://twitter.com/carolinapoena/status/1492800102641061890\">Twitter</a> that her <strong><a href=\"https://fullsiteediting.com/block-theme-generator/\">Block Theme Generator</a></strong> provides now optional theme.json settings, and you can choose colors and content widths. She also updated the Advanced Theme version to include an example for global style variation.</p>\n\n\n\n<h3 id=\"proposal-for-standardized-design-and-css-handling\">Proposal for Standardized Design and CSS handling</h3>\n\n\n\n<p><strong><a href=\"https://twitter.com/MRWweb\">Mark Root-Wiley</a></strong> posted a comprehensive outline of how styles could work with the block editor and full-site-editing. <a href=\"https://mrwweb.com/standardized-design-tokens-css-wordpress-future/\"><strong>Standardized Design Tokens and CSS for a consistent, customizable, and interoperable WordPress future</strong></a>. </p>\n\n\n\n<p>The accompanying proposal is discussed on GitHub: <a href=\"https://github.com/WordPress/gutenberg/issues/38998\"><strong>Proposal: Standardized block markup, theme.json design tokens, and CSS classes to improve interoperability</strong></a>. Only a couple of days old, the proposal attracted already thoughtful comments from developers. They also highlight issues previously raised on the repository that would benefit from a standardized architecture. </p>\n\n\n\n<p>J<strong>ustin Tadlock</strong> posted his thoughts on the WPTavern in <a href=\"https://wptavern.com/the-case-for-a-shared-css-toolkit-in-wordpress\"><strong>The Case for a Shared CSS Toolkit in WordPress</strong></a>.</p>\n\n\n\n<h3 id=\"custom-blocks-and-tools\">Custom Blocks and Tools</h3>\n\n\n\n<p>Sometimes, new and experienced developers get tripped up by Block Deprecation and Validation. <strong>Ryan Welcher</strong> took a <strong><a href=\"https://www.youtube.com/watch?v=BWXcQEbVSx8\">Look at Block Deprecation Strategies</a> </strong>in last week&#8217;s YouTube/TwitchStream session. He discussed how to deprecate changes in static blocks and showed how you can convert an existing static block to a dynamic one.</p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p><strong><a href=\"https://twitter.com/losoviz\">Leonardo Losoviz</a></strong> outlines in his post <a href=\"https://www.smashingmagazine.com/2022/02/wordpress-editor-cpts-configure-plugins/\"><strong>Using The WordPress Editor And CPTs To Configure Plugins</strong></a> how to use wp-admin to provide additional configuration UI for plugins users and creators. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>In the developer focused part of WPTavern&#8217;s <em>Building with Blocks</em> series, Justin Tadlock walks you through the steps need to <a href=\"https://wptavern.com/building-a-scotch-tape-image-block-style\"><strong>build a “Scotch Tape” Image Block Style</strong></a>. Block Styles are a great way to extend core blocks with CSS and give site owners more choices for their blocks. </p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>With the <a href=\"https://www.advancedcustomfields.com/blog/acf-5-12-released/\"><strong>new release of ACF Blocks</strong></a>, the plugin is now compatible with Full Site Editing. Using ACF Blocks is a popular way to create custom blocks without using React. &#8220;With 5.12, ACF Blocks work <em>everywhere</em>&#8221; wrote <a href=\"https://twitter.com/polevaultweb\"><strong>Iain Paulson</strong></a>.</p>\n\n\n\n<h2 id=\"upcoming-wordpress-events\">Upcoming WordPress Events</h2>\n\n\n\n<h3 id=\"learn-wordpress-social-learning-spaces\">Learn.WordPress Social Learning Spaces</h3>\n\n\n\n<ul><li><strong>February 28, 2022, at 12:00 pm ET / 17:00 UTC </strong><br /><a href=\"https://www.meetup.com/wordpress-social-learning/events/284054980/\"><strong>Beginner&#8217;s Guide to Full Site Editing</strong></a> with Sarah Snow </li><li><strong>March 1, 2022, at 5 pm ET / 22:00 UTC</strong><br /><a href=\"https://www.meetup.com/wordpress-social-learning/events/283842451/\"><strong>Intro to Templates and Template Parts</strong></a> with Wes Theron</li><li><strong>March 8, 2022, at 11:00 AM ET / 16:00 UTC</strong><br /><strong><a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\">Gutenberg Developer Hours</a></strong> with Fabian Kägy, Tammie Lister and Grzegorz Ziolkowski </li><li><strong>March 10, 2022 at 10:30 am ET / 15:30 UTC</strong> <br /><strong><a href=\"https://www.meetup.com/wordpress-social-learning/events/284226712/\">Honey, I Broke My Website! What To Do When Site Editing Goes Wrong</a></strong></li></ul>\n\n\n\n<h3 id=\"wordfest-live-starts-march-4th-2022\">WordFest Live starts March 4th, 2022</h3>\n\n\n\n<p>With 60 Session around the timezones of this planet is had also a session for you! I selected a few to get you curious. </p>\n\n\n\n<ul><li>March 3rd, 2022 6pm ET / 12 am UTC (Mar 4) <br /><strong><a href=\"https://www.wordfest.live/2022/march/sessions/git-into-the-groove-moving-from-freelance-to-collaborative-workflow/\">Git into the Groove – Moving from Freelance to Collaborative Workflow</a></strong> with AmyJune Hineline</li><li>March 4th, 2022 5 am ET / 10 am UTC <br /><a href=\"https://www.wordfest.live/2022/march/sessions/woocommerce-automation-tips-and-tricks-to-save-your-time-and-money/\"><strong>WooCommerce Automation – tips and tricks to save your time and money</strong></a> with <strong>Andrija Radojev</strong>, GoDaddy</li><li>March 4th, 2022 at 6 am ET / 12:00 pm <small>UTC</small> <br /><strong><a href=\"https://www.wordfest.live/2022/march/sessions/designing-remote/\">Designing Remote</a> with Tammie Lister, XWP</strong></li></ul>\n\n\n\n<p><a href=\"https://www.wordfest.live/2022/march/sessions/\"><em>Have a look at the WordFest Live schedule</em></a>!</p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p>Featured Image: <a href=\"https://wordpress.org/photos/author/topher1kenobe/\">Photo by Topher DeRosia</a> on WordPress Photos Directory. </p>\n\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<p class=\"has-text-align-center\"><strong>Don&#8217;t want to miss the next Weekend Edition? </strong></p>\n\n\n\n<form class=\"wp-block-newsletterglue-form ngl-form ngl-portrait\" action=\"https://gutenbergtimes.com/feed/\" method=\"post\"><div class=\"ngl-form-container\"><div class=\"ngl-form-field\"><label class=\"ngl-form-label\" for=\"ngl_email\">Type in your Email address to subscribe.</label><div class=\"ngl-form-input\"><input type=\"email\" class=\"ngl-form-input-text\" name=\"ngl_email\" id=\"ngl_email\" /></div></div><button class=\"ngl-form-button\">Subscribe</button><p class=\"ngl-form-text\">We hate spam, too and won&#8217;t give your email address to anyone except Mailchimp to send out our Weekend Edition</p></div><div class=\"ngl-message-overlay\"><div class=\"ngl-message-svg-wrap\"></div><div class=\"ngl-message-overlay-text\">Thanks for subscribing.</div></div><input type=\"hidden\" name=\"ngl_list_id\" id=\"ngl_list_id\" value=\"26f81bd8ae\" /><input type=\"hidden\" name=\"ngl_double_optin\" id=\"ngl_double_optin\" value=\"yes\" /></form>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 26 Feb 2022 06:43:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Birgit Pauli-Haack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: FSE Outreach Round #12: Building a Site Header With Blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130558\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"https://wptavern.com/fse-outreach-round-12-building-a-site-header-with-blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7287:\"<p class=\"has-drop-cap\">On Wednesday, Anne McCarthy announced <a href=\"https://make.wordpress.org/test/2022/02/23/fse-program-testing-call-12-hyping-headers/\">Round #12 of the FSE Outreach Program</a>. As always, everyone is free to join by testing features and providing direct feedback on problem areas with the design tools in WordPress. Anyone interested should respond by March 16.</p>\n\n\n\n<p>For this round, volunteers are tasked with testing some oldies but goodies. Early in the program&#8217;s history, anyone who joined did a lot of site header and navigation work. Round #12 asks that users revisit some of these essential tools.</p>\n\n\n\n<p>This was an exciting call for testing for me. In early 2021, I had my fair share of frustrations with the FSE experience. There were so many designs I wanted to tackle, but I far too often fell short of creating what I wanted.</p>\n\n\n\n<p>Therefore, I hopped back in time and revisited a header design from <a href=\"https://wptavern.com/fse-outreach-round-4-building-a-restaurant-themed-header-with-gutenbergs-site-editor\">Round #4 of testing</a> in March 2021. At the time, the WordPress leads were weeks away from deciding whether some FSE-related components would land in WordPress. My conclusion of the tools at the time was:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>I came to the realization that attempting to do anything remotely advanced with the site editor was simply not going to happen…As someone who prides himself on near-infinite patience, Round #4 sought to crack me.</p></blockquote>\n\n\n\n<p>I had wanted to recreate elements from the UK-based <a href=\"https://www.phocafe.co.uk/\">Pho Cafe</a> page header during testing. It was a tall order that could not be filled.</p>\n\n\n\n<img />Pho Cafe header.\n\n\n\n<p>However, almost a year later now, how much has changed? Is it possible to create an exact replica of the site&#8217;s header from the block editor?</p>\n\n\n\n<p>Yes and no. As usual, it depends.</p>\n\n\n\n<p>As a developer and designer, I am confident that I could do it with custom code. Considering this would likely be a one-off design for a paying client, I would be comfortable with that.</p>\n\n\n\n<p>Creating this as a part of a publicly-released, general-purpose theme would have a ton of roadblocks with that level of customization. However, it would be possible to capture much of the character, the essence, of the design.</p>\n\n\n\n<p>As for building it directly from the block editor, there are still some severe limitations. However, that is what I challenged myself to do. I wanted to get a feel for where the site editor was at without writing CSS code.</p>\n\n\n\n<p>The following is the result:</p>\n\n\n\n<img />Pizza restaurant header.<br />Pizza photo credit: <a href=\"https://wordpress.org/photos/photo/99661f0787/\">Jennifer Bourn</a>\n\n\n\n<p>Technically, I did write a little code to load the <a href=\"https://www.dafont.com/kg-happy.font\">KG Happy font</a>. Outside of that, I just forked a block theme I had on hand and changed the &#8220;wide&#8221; size. I created everything else 100% from the site editor.</p>\n\n\n\n<p>Here is a screenshot of the design from the editor itself:</p>\n\n\n\n<img />Custom header template part in the site editor.\n\n\n\n<p>On the whole, this went surprisingly well. In a year, the site editor has become far more powerful.</p>\n\n\n\n<p>As I said, it still has its limitations. Anyone who has worked with block themes will likely tell you the issue with the layout in the above screenshot. The problem area is the Columns block used for the Site Logo, Navigation, and Buttons across the top. You might as well hang up any hope of that working well on smaller screen sizes.</p>\n\n\n\n<img />Mobile view of header.\n\n\n\n<p><em>Is it entirely unusable?</em> No, but it is not anywhere near close to ideal.</p>\n\n\n\n<p>Without responsive controls on layout-type containers like the Columns block, designing anything complex with the site editor can sometimes feel like one giant hack. At this point, this is not a revelation of any sort.</p>\n\n\n\n<p>There are tons of improvements with block design tools in comparison to last year. The core block gap, margin, and padding controls are a godsend for adjusting vertical and horizontal spacing. Back then, even the thought of having any control over this was a headache-inducing affair. Except for a few blocks still missing these options, it is now [mostly] stress-free.</p>\n\n\n\n<p>I hit no spacing-related problems in this experiment. That feels gratifying to say after over a year of testing FSE features.</p>\n\n\n\n<p>However, I did hit some other roadblocks. The Navigation block may be my least favorite thing about the site editor. I have yet to see how it will offer a universal system that plays well with the 1,000s of design variations that theme authors will want to employ. Classic nav menus are still vastly superior for custom design.</p>\n\n\n\n<p>I ran into two primary issues with this experiment. One of the problems I had a year ago with FSE Outreach #4 was creating a menu that had button-like links. This basic design is still impossible with the Navigation block, at least with the core design tools:</p>\n\n\n\n<img />Button-like navigation items.\n\n\n\n<p>Users can add a background to the entire Navigation block but not to the individual menu items. <em>How did I do it?</em> I used a Buttons block instead.</p>\n\n\n\n<p>The more I think about it now, the more I like the Buttons block alternative. However, there is no way to wrap this in a <code>&lt;nav&gt;</code> tag to define it as a navigation element.</p>\n\n\n\n<p>One missing piece of the header I was attempting to replicate was a mobile menu at the far right of the layout. WordPress&#8217;s mobile Navigation menu icon provides no customization options. Users can customize the overall background and text color but not target the button directly. I faked it a little by narrowing down the column:</p>\n\n\n\n<img />Mobile Navigation menu icon next to Buttons.\n\n\n\n<p>There was no way to make the mobile icon larger or give it any padding to align its size with the Button blocks next to it.</p>\n\n\n\n<p>The Navigation block, despite its progress, is still one of the weakest links in FSE. It only covers a handful of simple use cases out of the box. Anything beyond that requires a deep level of customization and the hope that an end-user does not break the delicate balance struck to make it work.</p>\n\n\n\n<p>Twice during testing, my Navigation block disappeared on the front end. I suspect it had something to do with me trying to adjust the outer Column block&#8217;s width. However, I was unable to replicate the issue at will.</p>\n\n\n\n<p>Testing is all about finding problems to solve. I did not run into any crashes or the types of bugs that I would have seen long ago. The experience of designing from within the site and template editors feels pretty smooth these days. The holdups are more about missing capabilities than anything. Making the leap from an impossible header layout to an almost possible one in 11 months is significant.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"wp-embedded-content\"><a href=\"https://make.wordpress.org/test/2022/02/23/fse-program-testing-call-12-hyping-headers/\">FSE Program Testing Call #12: Hyping Headers</a></blockquote>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 26 Feb 2022 02:33:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WPTavern: The Kyiv Independent Seeks Donations to Continue Critical Ukrainian News Coverage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130552\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"https://wptavern.com/the-kyiv-independent-seeks-donations-to-continue-critical-ukrainian-news-coverage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4633:\"<img />photo credit: The Kyiv Independent\n\n\n\n<p><a href=\"https://kyivindependent.com/\">The Kyiv Independent</a>, a new English-language media outlet powered by WordPress, is seeking donations to continue their reporting at this critical time in Ukraine&#8217;s struggle against Russian invasion. </p>\n\n\n\n<p>The fledgling publication is just three months running and its staff is already plunged into what may be some of the most important reporting of their lifetimes. </p>\n\n\n\n<img />\n\n\n\n<p>The Kyiv Independent was created by 30 journalists who were previously employed at the Kyiv Post but fired for what they say was retaliation for exercising their editorial independence. The publication, led by Olga Rudenko, its new editor-in-chief, tells the story of its <a href=\"https://kyivindependent.com/about/\">values and origins</a> on the website: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>The Kyiv Post, Ukraine’s global voice, went silent on Nov. 8, 2021, days after celebrating the 26th year of its uninterrupted run.</p><p>The publication was shut down by the owner in his attempt to take full control of the newsroom that has always followed the principle of editorial independence. </p><p>Yet, the editorial team of the independent Kyiv Post refused to be silenced. If we couldn’t save the Kyiv Post brand, we could save its values.</p></blockquote>\n\n\n\n<p>At the moment the publication reports they are &#8220;dealing with increased volumes of traffic, attacks, and an unpredictable situation on the ground.&#8221; Rudenko gave a brief update from Kyiv via video yesterday:</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"twitter-tweet\"><p lang=\"en\" dir=\"ltr\">Please follow us at <a href=\"https://twitter.com/KyivIndependent?ref_src=twsrc%5Etfw\">@KyivIndependent</a>, most of us are on the ground in <a href=\"https://twitter.com/hashtag/Kyiv?src=hash&ref_src=twsrc%5Etfw\">#Kyiv</a> working to provide you with the latest news. It’s extremely stressful. No one knows where it is safe to be, or whether there will be more strikes and where, and Russian troops are moving from the north. <a href=\"https://t.co/6gXgeSEM1V\">pic.twitter.com/6gXgeSEM1V</a></p>&mdash; Olga Rudenko (@olya_rudenko) <a href=\"https://twitter.com/olya_rudenko/status/1496818179947044873?ref_src=twsrc%5Etfw\">February 24, 2022</a></blockquote>\n</div>\n\n\n\n<p>The Kyiv Independent is running a <a href=\"https://www.gofundme.com/f/kyivindependent-launch\">gofundme campaign</a> to raise funds for their new publication and continued reporting efforts during this critical time. The campaign was set up by Kyiv Independent&#8217;s London-based CFO Jakub Parusinski. Their cause is resonating with free press supporters from around the world and so far they have raised £233,494. The publication also has <a href=\"https://www.patreon.com/kyivindependent\">a Patreon account</a> which is bringing in $24,173/month from more than 2,000 patrons.</p>\n\n\n\n<p>&#8220;It is crucial to bring credible news from Ukraine to the world,&#8221; Parusinski said. &#8220;Especially when Russian forces are working hard to distort the perception of Ukraine abroad.</p>\n\n\n\n<p>&#8220;We are asking you to stand up to it together with us. We are not backed by a rich owner or an oligarch. We will rely first and foremost on fundraising from our readers and donors, and later on commercial activities.&#8221;</p>\n\n\n\n<p><a href=\"https://patchstack.com/\">Patchstack</a> is one of the first companies to reach out to The Kyiv Independent with an offer to help.</p>\n\n\n\n<p>&#8220;Patchstack not only wants to offer them our WordPress security services free but  we are actively looking to help Ukrainian organizations at this time,&#8221;  Patchstack Security Advocate Robert Rowley said. He also signed up to support the organization through the fundraiser. </p>\n\n\n\n<p>&#8220;I personally like to support independent journalists and their background tells the story of the type of journalism I want to support,&#8221; Rowley said.</p>\n\n\n\n<p>Patchstack is in the process of setting up a site called <a rel=\"noreferrer noopener\" href=\"http://uacyberhelp.com/\" target=\"_blank\">UA Cyber Help</a>, an effort led by their CEO Oliver Sild and four employees with an average of 15+ years in security. They are volunteering their time to bring resources to organizations like The Kyiv Independent and others affected by the war in Ukraine.</p>\n\n\n\n<p>I have reached out to The Kyiv Independent&#8217;s news team to inquire about their needs and how the WordPress business and hosting community can help. We will publish a followup when we hear more from their team.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Feb 2022 19:53:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WordCamp Central: Bluehost supports WordPress community events worldwide\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://central.wordcamp.org/?p=3146030\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"https://central.wordcamp.org/news/2022/02/25/bluehost-supports-wordpress-community-events-worldwide-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1071:\"<p><span>We can’t thank </span><strong><span><a href=\"https://www.bluehost.com/\">Bluehost</a></span></strong><span> enough for their continued support as a sponsor for the </span><strong><span><a href=\"https://central.wordcamp.org/sponsor-multiple-wordcamps/\">global WordPress community</a></span></strong><span>! Their support of WordPress community events around the globe at our Gold level!</span></p>\n<p><a href=\"https://central.wordcamp.org/files/2019/02/Bluehost-Transparent_HighRes.png\"><img /></a></p>\n<p><strong><span><a href=\"https://www.bluehost.com/\">Bluehost</a></span></strong><span> has been a WordPress partner since 2005 and powers over 1 million WordPress sites worldwide. Their objective is to help customers, whether novice or pro, create a thriving online presence at an affordable price. With a team of in-house tech experts available 24/7, Bluehost dedicates time and resources to providing the best support and services in the industry. Join millions of other site owners and see what Bluehost can do for you and your online presence.</span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Feb 2022 16:00:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Isotta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"Akismet: The WordPress Comment System Explained: All You Need to Know\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=2279\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://blog.akismet.com/2022/02/25/wordpress-comment-system/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:19242:\"<p>Comments are the lifeblood of many websites. They help you build a community around your brand, encourage discussion and engagement, provide valuable feedback, and even improve your search engine rankings. Whether you have a blog, service-based business, eCommerce store, or any other type of website, comments can be invaluable.</p>\n\n\n\n<p>So let’s take a step back and explore the WordPress comment system and look at how to manage comments on your WordPress site.</p>\n\n\n\n<span id=\"more-2279\"></span>\n\n\n\n<h2 id=\"what-are-wordpress-comments\">What are WordPress comments?</h2>\n\n\n\n<p>WordPress started as a blogging platform and, though it can now be used to build absolutely any type or size of website, content is at its heart. And because of that, WordPress provides everything you need to accept comments on your site. You won’t need any additional plugins to enable, manage, and respond to comments.</p>\n\n\n\n<p>For your site visitors, the comment system is very easy to use. While the exact design of your comment form will vary based on the theme you’re using, it will look something like this:</p>\n\n\n\n<img />\n\n\n\n<p>It has a comment text box, along with fields for name, email, and website. Visitors click the <strong>Post Comment</strong> button to submit their comment on your WordPress website. Published comments will appear in a list beneath the post and, depending on your discussion settings, responses will nest underneath the comments they correspond to.</p>\n\n\n\n<img />\n\n\n\n<p>Each comment will show the commenter’s name, along with the date and time they responded. Don’t worry —&nbsp;their email address won’t appear on the front-end of your site. Comments can be enabled for posts, pages, products, and other post types depending on your website and settings.</p>\n\n\n\n<h2 id=\"how-to-access-your-comments-in-the-wordpress-dashboard\">How to access your comments in the WordPress dashboard</h2>\n\n\n\n<p>Of course, you’ll want to view your comments, respond to them, and delete any that may be spam. While we’ll dive further into this in a moment, let’s look at how to find your comments.</p>\n\n\n\n<p>By default, you’ll receive a notification each time someone leaves a comment on your site. If you want to view that specific comment, you can click on the link in the email. But if you want to view all comments, simply log in to your WordPress dashboard and click <strong>Comments </strong>in the left-hand menu.</p>\n\n\n\n<h2 id=\"how-to-manage-wordpress-comments\">How to manage WordPress comments</h2>\n\n\n\n<p>While comments can be extremely beneficial, they do also involve a bit of work on your end. You’ll want to respond to legitimate comments and answer questions quickly and thoroughly. It’s also important that you learn to <a href=\"https://blog.akismet.com/2022/01/12/how-to-stop-comment-spam-in-wordpress/\">identify comment spam</a> and remove any offending comments.</p>\n\n\n\n<p>Once you navigate to the <strong>Comments</strong> section of your website, you’ll see a full list of comments. Those that are approved will be gray or white in color, while those that are pending will have a light yellow background.&nbsp;</p>\n\n\n\n<img />\n\n\n\n<p>At the top, you’ll see several tabs that help you manage comments:</p>\n\n\n\n<ul><li><strong>All:</strong> Shows all the comments you have on your site, pending and approved</li><li><strong>Pending:</strong> Displays just comments that are waiting on your approval and response</li><li><strong>Approved:</strong> Shows just the comments you’ve approved and published</li><li><strong>Spam:</strong> Displays comments that you (<a href=\"https://akismet.com/\">or a spam plugin</a>) have marked as spam</li><li><strong>Trash:</strong> Shows comments that you’ve moved to the trash and allows you to permanently delete them</li></ul>\n\n\n\n<p>You can use these tabs to filter your comments as needed. For example, if you want to sit down and respond to comments, you may want to click the <strong>Pending</strong> tab so you just view the ones that are waiting on a response. Or if you want to periodically get spam comments out of the way, you can click the <strong>Spam </strong>tab and move them into the trash.</p>\n\n\n\n<p>Each individual comment shows the respondent’s name, their number of approved comments, their email and IP address, and their <a href=\"https://gravatar.com/\" target=\"_blank\" rel=\"noreferrer noopener\">Gravatar</a> if they have one set for their email. You’ll also see what the comment says, the post it was on, and the date and time it was submitted.&nbsp;</p>\n\n\n\n<img />\n\n\n\n<p>When you hover over a comment, a list of actions will appear, side-by-side. Here are the actions you can take for each comment:</p>\n\n\n\n<ul><li><strong>Approve/Unapprove</strong>: Approving a comment publishes it on your site so it can be viewed by anyone online. Unapproving it removes it from public display.</li><li><strong>Reply</strong>: Respond to the comment and answer any questions. This will be published on your site with your name and, depending on your settings, will nest under the comment it’s in response to.</li><li><strong>Quick edit: </strong>Make quick changes to the comment. Edit the name, email, website, and response. You could, for example, remove a link to a third-party site if you don’t allow cross promotions.</li><li><strong>Edit: </strong>This opens a new screen where you can make changes to a comment and view its history on your site.</li><li><strong>History: </strong>See the history of the comment, like when it was published, approved, and more.</li><li><strong>Spam: </strong>This moves a comment into your Spam folder and keeps it from appearing on the front-end of your site.</li><li><strong>Trash: </strong>This moves a comment to your Trash folder. If you accidentally put a comment in the trash, you can still restore it if needed.</li></ul>\n\n\n\n<p>Let’s take a closer look at a few more components of managing comments.</p>\n\n\n\n<h3 id=\"how-to-edit-comments-in-bulk\">How to edit comments in bulk</h3>\n\n\n\n<p>Manually managing comments can be time-consuming and tedious. But it’s a necessary aspect of engaging with visitors and protecting them from potentially dangerous spam. Thankfully, there are some actions you can take to manage comments in bulk.</p>\n\n\n\n<p>In the comment dashboard, you’ll see a checkbox to the left of each column, as well as at the top left, next to the <strong>Author</strong> column. You can use these to check specific comments you want to edit or to select all of the comments on that page. Once you’ve checked them, click the <strong>Bulk Actions </strong>dropdown and choose to approve or unapprove the comments, or mark them as spam or trash.</p>\n\n\n\n<img />\n\n\n\n<p>By default, this screen will show 20 comments per page. Want to edit more than that? Expand the <strong>Screen Options</strong> tab at the top right of the page, type in the number you want to show in the box beside <strong>Number of items per page</strong>, and click <strong>Apply.&nbsp;</strong></p>\n\n\n\n<img />\n\n\n\n<h3 id=\"how-to-restore-comments-from-the-spam-or-trash-folders\">How to restore comments from the spam or trash folders</h3>\n\n\n\n<p>But what if you accidentally mark a comment as spam or add it to the trash? Don’t worry —&nbsp;you can restore it back to where it belongs.&nbsp;</p>\n\n\n\n<p>If you marked the comment as spam, simply click on the <strong>Spam</strong> folder, hover over the comment, and click <strong>Not Spam. </strong>If you put it in the trash, click on the <strong>Trash </strong>folder, hover over it, and click <strong>Restore.</strong></p>\n\n\n\n<img />\n\n\n\n<h3 id=\"how-to-permanently-delete-wordpress-comments\">How to permanently delete WordPress comments</h3>\n\n\n\n<p>By default, trashed comments are still saved in your database — they’re just tucked away so they won’t show up on your website. But, from time to time, you may want to permanently delete these so as not to clog up your database.</p>\n\n\n\n<p>To do this, navigate to the <strong>Trash </strong>folder. Then, click the button that says <strong>Empty Trash. </strong>Note that this will permanently delete all the comments in this folder and you won’t be able to bring them back.</p>\n\n\n\n<img />\n\n\n\n<h2 id=\"an-overview-of-wordpress-discussion-settings\">An overview of WordPress discussion settings&nbsp;</h2>\n\n\n\n<p>WordPress offers a variety of settings that help you tailor your comment section to your specific site, audience, and needs. You can find these by going to <strong>Settings → Discussion </strong>in your WordPress dashboard. There are several comment sections with individual options inside of each one. Let’s break these down.</p>\n\n\n\n<img />\n\n\n\n<h3 id=\"default-post-settings\">Default post settings</h3>\n\n\n\n<p>This section controls how your site interacts with comments. Here are the options:</p>\n\n\n\n<ul><li><strong>Attempt to notify any blogs linked to from the post</strong>: If you link to someone else’s WordPress blog post, this setting will enable WordPress to send a notification or “ping” letting them know.</li><li><strong>Allow link notifications from other blogs (pingbacks and trackbacks) on new posts</strong>: Pingbacks and trackbacks appear in your comment section when someone links to your blog posts. They can be a great display of trust from other sites, but can also quickly overwhelm your comments, so consider this carefully.</li><li><strong>Allow people to submit comments on new posts</strong>: This enables comments across your entire website.</li></ul>\n\n\n\n<img />\n\n\n\n<h3 id=\"other-comment-settings\">Other comment settings</h3>\n\n\n\n<p>These are miscellaneous settings that apply to your comments and are as follows:</p>\n\n\n\n<ul><li><strong>Comment author must fill out a name and email</strong>. This requires each respondent to leave their name and email when they leave a comment and can be helpful for preventing spam.</li><li><strong>Users must be registered and logged in to comment</strong>. This requires commenters to have an account. While this goes a long way towards spam prevention, it can also discourage many people from commenting. You may want to reserve this setting for situations like membership sites or forums.</li><li><strong>Automatically close comments on posts older than 14 days</strong>. This turns off comments on blog posts after a certain number of days — the default is 14 if this setting is enabled. This prevents you from having to moderate comments on posts from months or years ago and is especially helpful if your posts are time-sensitive.</li><li><strong>Show comments cookies opt-in checkbox, allowing comment author cookies to be set</strong>. This adds a checkbox to your comment form that says, “Save my name, email, and website in this browser for the next time I comment.” This helps you stay compliant with privacy laws <a href=\"https://wordpress.com/support/your-site-and-the-gdpr/\" target=\"_blank\" rel=\"noreferrer noopener\">like the GDPR</a>.</li><li><strong>Enable threaded (nested) comments 5 levels deep</strong>. This allows comment responses to nest (tuck) underneath the comment they’re in response to. By default, they will nest five levels deep, but you can change this to whatever you’d like or turn it off altogether.</li><li><strong>Break comments into pages with 50 top level comments per page and the last page displayed by default</strong>. This divides the comments on the front-end of your site into pages, defines the number of comments per page (the default is 50), and lets you choose whether or not to display the first or last page by default.</li><li><strong>Comments should be displayed with the older comments at the top of each page</strong>. This sets the order in which your comments should display. Choose between “older” and “newer.”</li></ul>\n\n\n\n<img />\n\n\n\n<h3 id=\"email-me-whenever\">Email me whenever…</h3>\n\n\n\n<p>This section controls the email notifications you receive in regards to comments on your site. You can receive a notification when:</p>\n\n\n\n<ul><li><strong>Anyone posts a comment</strong></li><li><strong>A comment is held for moderation</strong></li></ul>\n\n\n\n<img />\n\n\n\n<h3 id=\"before-a-comment-appears\">Before a comment appears…</h3>\n\n\n\n<p>Choose what must occur before a comment appears on the front-end of your website:</p>\n\n\n\n<ul><li><strong>Comment must be manually approved</strong>. When this is turned on, you’ll need to manually approve each comment for publication. Turning this on gives you full control over what is published, though this process can be time-consuming.</li><li><strong>Comment author must have a previously approved comment</strong>. This automatically publishes comments from people who have written a comment that you’ve already approved. This is a great way to save valuable time but still reduce spam.</li></ul>\n\n\n\n<img />\n\n\n\n<h3 id=\"comment-moderation\">Comment moderation</h3>\n\n\n\n<p>This section allows you to hold comments in the moderation queue (rather than publish them automatically) if they meet certain criteria.</p>\n\n\n\n<p>Links are a very common indication of spam —&nbsp;bots and malicious actors often try to send your website visitors to harmful third-party sites of their own. The first setting in this section allows you to hold a comment based on the number of links it contains. The default is two, but we recommend setting this to one, as there’s rarely a viable reason to include a link in a comment.</p>\n\n\n\n<p>Below this option, you’ll see a text field that allows you to hold comments that meet the characteristics you define. So, if you’re getting a large number of spam comments that contain certain words or phrases, are from the same email or IP address, or push the same URL over and over, you can list those here.</p>\n\n\n\n<img />\n\n\n\n<h3 id=\"disallowed-comment-keys\">Disallowed comment keys</h3>\n\n\n\n<p>This section is very similar to the previous one, but it sends comments that meet certain criteria straight to the trash. Here, you can list words, author names, URLs, email addresses, IP addresses, or browser user agent strings.</p>\n\n\n\n<img />\n\n\n\n<h3 id=\"avatars\">Avatars</h3>\n\n\n\n<p>An avatar is the picture that shows up next to a respondent’s name. This is typically set by the person using <a href=\"https://gravatar.com/\" target=\"_blank\" rel=\"noreferrer noopener\">Gravatar</a> and is based on the email address they use to submit comments. Here are the options you can choose from:</p>\n\n\n\n<ul><li><strong>Avatar display</strong>: Choose whether or not to show avatars on your site</li><li><strong>Maximum rating: </strong>Block any images that fall above a certain maturity rating</li><li><strong>Default avatar: </strong>Set a default image to display if a respondent doesn’t have an avatar</li></ul>\n\n\n\n<h2 id=\"comment-settings-for-individual-posts-and-pages\">Comment settings for individual posts and pages&nbsp;</h2>\n\n\n\n<p>The settings above apply to all posts and pages across your site. However, there are a few things you can choose on an individual basis.&nbsp;</p>\n\n\n\n<p>Start by going to the page or post you want to edit and clicking the gear icon in the top right. There, you’ll see a list of settings. Scroll down to the <strong>Discussion </strong>section.&nbsp;</p>\n\n\n\n<img />\n\n\n\n<p>There are two options for comments here:</p>\n\n\n\n<ol><li><strong>Allow comments.</strong> Check this box to enable comments for this specific page or post. Uncheck it to turn off comments.&nbsp;</li><li><strong>Allow pingbacks &amp; trackbacks</strong>. Decide whether or not to enable pingbacks and trackbacks on an individual page basis. These are ways to let other blogs know that you’ve linked to them within your content.</li></ol>\n\n\n\n<p>Once you’ve edited the settings, click the blue <strong>Update </strong>button at the top right of the page.</p>\n\n\n\n<p>But there may be times that you want to edit specific posts in bulk. For example, you might want to close comments on all posts around a certain topic. Or may you want to enable comments just for pages about your services.</p>\n\n\n\n<p>To do this, navigate to <strong>Pages</strong> or <strong>Posts</strong> in the WordPress dashboard, depending on which you’d like to edit. To the left of each page or post, you’ll see a checkbox. Check that next to each post or page you want to make changes to, or select the checkbox beside the word <strong>Title</strong> to select all the ones on that page.</p>\n\n\n\n<img />\n\n\n\n<p>Then, in the <strong>Bulk actions</strong> dropbox, select <strong>Edit </strong>and click <strong>Apply. </strong>A new section will appear with various settings. Find the <strong>Comments</strong> dropdown, choose to either turn comments on or off, then click <strong>Update</strong>. That change will be made to all the posts you selected.</p>\n\n\n\n<h2 id=\"how-to-allow-individual-users-to-moderate-comments\">How to allow individual users to moderate comments</h2>\n\n\n\n<p>If you get a lot of comments, moderation can become time-consuming and overwhelming. After all, you have plenty of other things that need your attention! One great solution is to assign the task of comment moderation to specific people. Not only does this mean you won’t have to handle this process, it also means that commenters get responses faster.</p>\n\n\n\n<p>So how do you do this without giving moderators full access to your site? While there are a few methods, we’re going to show you how with the <a href=\"https://wordpress.org/plugins/comment-moderation-role/\" target=\"_blank\" rel=\"noreferrer noopener\">Comment Moderation Role</a> plugin.</p>\n\n\n\n<ol><li>In your dashboard, go to <strong>Plugins → Add New.&nbsp;</strong></li><li>Search for “Comment Moderation Role by WPBeginner” and click <strong>Install now → Activate.</strong></li><li>Then, navigate to <strong>Users → All Users </strong>and select the account you’d like to modify.</li><li>In the <strong>Role</strong> box, select <strong>WPB Comment Moderator</strong>.</li><li>Click the blue <strong>Update User </strong>button at the bottom of the page.</li></ol>\n\n\n\n<img />\n\n\n\n<p>Now, that user will be able to access the comment moderation screen in your dashboard, but nothing else. This allows them to do their job without compromising the security of the rest of your site.</p>\n\n\n\n<h2 id=\"a-good-comment-experience-is-spam-free\">A good comment experience is spam-free</h2>\n\n\n\n<p>Now that you know all about the WordPress comment system, you can enable comments across your website and create a community around your brand! But if your comment section is full of unhelpful, unrelated, and potentially dangerous spam, then your brand, search engine rankings, and engagement can actually suffer.</p>\n\n\n\n<p>Thankfully, you don’t need to add spam filtering to your list of moderation tasks; <a href=\"https://akismet.com/\">Akismet</a> can take care of this for you! Simply activate the plugin —&nbsp;its powerful tools have stopped more than 500,000,000,000 spam comments —&nbsp;and the worst spam will be automatically deleted for you. You never even have to see it.</p>\n\n\n\n<p>Learn more about <a href=\"https://blog.akismet.com/2022/01/12/how-to-stop-comment-spam-in-wordpress/\">how to stop comment spam in WordPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Feb 2022 10:53:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Simon Keating\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Post Status: Post Status Notes #487\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=93811\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://poststatus.com/post-status-notes-487/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14691:\"<p class=\"has-medium-font-size\">WordPress 5.9.1 released. REST or AJAX? Plugin dependency feature plugin. Testing, security, new themes and CSS standards. PHP benchmarks and more.</p>\n\n\n\n<h2 id=\"h-core-news\">Core News</h2>\n\n\n\n<p>A <a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\">WordPress 5.9.1 Maintenance Release</a> is out, so make sure your sites are updated. There are quite <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-5-9-1-rc-1/\">a lot of bug fixes</a> in this release — over 80!</p>\n\n\n\n<p class=\"has-theme-palette-7-background-color has-background\">For a digest of everything happening in core this week, see <a href=\"https://poststatus.com/this-week-at-wordpress-org-february-21-2022/\">This Week at WordPess.org</a> for February 21.</p>\n\n\n.kt-block-spacer-_29ed09-d6 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_29ed09-d6\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"h-dev-notes\">Dev Notes</h2>\n\n\n\n<p><strong>Matt Shaw</strong> tackles the question of whether you should be using the <strong>WordPress REST API</strong> instead of <strong>AJAX</strong>. He compares <a href=\"https://deliciousbrains.com/comparing-wordpress-rest-api-performance-admin-ajax-php/\">the pros and cons of each possible approach</a>, including benchmarks that examine speed and responsiveness. </p>\n\n\n\n<p>Whichever you choose, Matt cautions that &#8220;the REST API and <code>admin-ajax.php</code> still depend on the quality and integrity of the active plugins or themes.&#8221;</p>\n\n\n.kt-block-spacer-_768746-e7 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_768746-e7\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Andy Fragen</strong> details <a href=\"https://make.wordpress.org/core/2022/02/24/feature-project-plugin-dependencies/\">a feature plugin project</a> he is proposing for managing plugin dependencies in the WordPress updater. This idea goes back to a <strong>TRAC</strong> ticket opened nine years ago by the late <strong>Alex Mills</strong>. It already has some comments and discussion going.<br /><br />Andy outlines two approaches to managing plugins that require plugins. Each has subtle differences which he calls &#8220;starting points.&#8221; At the moment I would embrace either one! A core solution to plugin dependencies would help set and keep standards. </p>\n\n\n\n<p>We\'re looking forward to how this project progresses.</p>\n\n\n.kt-block-spacer-_840b95-6b .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_840b95-6b\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Jason Bahl</strong> has written <a href=\"https://www.wpgraphql.com/2022/02/17/adding-end-2-end-tests-to-wordpress-plugins-using-wp-env-and-wp-scripts/\">a tutorial on end-to-end tests</a> for your WordPress plugins. It uses <strong>Puppeteer</strong>, <strong>Jest</strong>, and <strong>Github Actions</strong>. Jason\'s tutorial also shows how to set up a GitHub Workflow (AKA <strong>GitHub Action</strong>) that will run the tests when a Pull Request is opened.</p>\n\n\n\n<p>Jason also published a video <a href=\"https://www.youtube.com/watch?v=yBBwWSk3kxg&t=1s\">walking through the setup for end-to-</a>end tests for <strong>WPGraphQL</strong>.</p>\n\n\n.kt-block-spacer-_c5fed6-75 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_c5fed6-75\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>David C. Zentgraf</strong> has a detailed post on what every programmer &#8220;absolutely, positively needs to know&#8221; about <a href=\"https://kunststube.net/encoding/\">encodings and character sets</a> to work with text.</p>\n\n\n.kt-block-spacer-_0dbedb-9e .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_0dbedb-9e\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Tom McFarlin</strong> shares <a href=\"https://tommcfarlin.com/programmatically-authenticate-a-user/\">how you can programmatically authenticate a user</a> in WordPress — as long as you have a verified user ID for them.</p>\n\n\n.kt-block-spacer-_555570-98 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_555570-98\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"security\">Security</h2>\n\n\n\n<p><strong>Jetpack Scan</strong> security researcher <strong>Marc Montpas</strong> discovered <a href=\"https://jetpack.com/2022/02/17/severe-vulnerability-fixed-in-updraftplus-1-22-3/\">a severe vulnerability</a> in <strong>UpdraftPlus</strong> that could grant attackers access to privileged information in the database. As <strong>Sarah Gooding</strong> reports, the patch was pushed out <a href=\"https://wptavern.com/updraftplus-1-22-3-patches-severe-vulnerability-through-forced-security-update-from-wordpress-org\">via a forced auto-update</a>.</p>\n\n\n\n<p>It\'s rare, but not extremely rare, to see a security-related update pushed out via a forced auto-update. Likely this time around it was the extent of the problem plus the install base of the plugin — more than a million sites — that hadn\'t updated to the latest version. </p>\n\n\n\n<p>It would be nice to see some guidelines in writing to explain when and how the decision for a forced update is made. It might be a &#8220;you know it when you see it&#8221; scenario, but when it comes to security, standards and expectations should be clear.</p>\n\n\n.kt-block-spacer-_e600b1-e0 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_e600b1-e0\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"themes\">Themes</h2>\n\n\n\n<p><strong>Mark Root-Wiley</strong> envisions a path toward <a href=\"https://mrwweb.com/standardized-design-tokens-css-wordpress-future/\">standardizing CSS for WordPress designs and layouts</a>. He notes that &#8220;now is a critical moment to find a path that meets the needs of WordPress core development without sacrificing the needs of 3rd-party themes and plugins.&#8221;</p>\n\n\n\n<p>Mark proposes a four-point plan: Consistent CSS classes, stateful CSS classes, design tokens, and CSS utility classes:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;With a streamlined and transparent approach to design, core development will have a self-documenting, easy-to-understand set of tools for implementing future designs.&#8221;</p></blockquote>\n\n\n.kt-block-spacer-_df7230-15 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_df7230-15\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Rich Tabor</strong> has <a href=\"https://richtabor.com/wabi/\">released a new WordPress block theme</a> called <strong>Wabi</strong> for writers and publishers. Each post can have one of six different accent color. All of them can be modified within the new <strong>Global Styles</strong> interface. </p>\n\n\n\n<p><a href=\"https://richtabor.com/wabi/\">Rich\'s blog</a> is currently running Wabi.</p>\n\n\n.kt-block-spacer-_7a9c08-f0 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_7a9c08-f0\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Skatepark</strong> is a <a href=\"https://wordpress.org/themes/skatepark/\">new WordPress theme</a> &#8220;designed for modern events and organizations&#8221; by <strong><a href=\"https://twitter.com/melchoyce/status/1496152779928350723\">Mel Choyce-Dwan</a></strong>.</p>\n\n\n.kt-block-spacer-_f96c81-58 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_f96c81-58\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"php-performance\">PHP Performance</h2>\n\n\n\n<p><strong>Salman Ravoof</strong> delivers <a href=\"https://kinsta.com/blog/php-benchmarks/\">some benchmarks</a> for <strong>PHP 7.2, 7.3, 7.4, 8.0, and 8.1</strong> on the <strong>Kinsta</strong> blog. These five different PHP versions were tested across 14 unique PHP platforms and configurations for WordPress, <strong>Drupal</strong>, <strong>Joomla</strong>, and <strong>Laravel</strong>.</p>\n\n\n\n<p>Kinsta finds that only 50.6% of WordPress sites are running on supported PHP versions. Salman believes lack of education, compatibility issues, and reluctant WordPress hosting providers are the main causes for this.</p>\n\n\n\n<p>In terms of overall speed on WordPress installs, <strong>PHP 8.0</strong> and <strong>8.1 have proven to be faster than</strong> previous versions. PHP 8.1 is the fastest in all benchmarks. Another reason to upgrade sooner than later: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;With support for PHP 7.4 ending soon in late 2022, you should plan to move your sites to PHP 8.0 and above as soon as possible.&#8221;</p></blockquote>\n\n\n.kt-block-spacer-_b994bc-0d .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_b994bc-0d\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"plugin-updates\">Plugin Updates</h2>\n\n\n\n<p><strong>Advanced Custom Fields</strong> <a href=\"https://www.advancedcustomfields.com/blog/acf-5-12-released/\">version 5.12 is available</a> with <strong>ACF Blocks</strong> compatibility for <strong>WordPress 5.9</strong> and <strong>WordPress 5.8</strong>.</p>\n\n\n.kt-block-spacer-_2ba800-37 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_2ba800-37\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Aurooba Ahmed</strong> has <a href=\"https://poststatus.com/planet/feed/aurooba.com/quickpost/\"><a href=\"https://aurooba.com/quickpost/\">released</a></a> <strong>QuickPost</strong>, &#8220;a little button that lets you create and duplicate posts right from the WordPress Block Editor.&#8221;</p>\n\n\n.kt-block-spacer-_a1b52e-6c .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_a1b52e-6c\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>TrustedLogin</strong> <a href=\"https://www.trustedlogin.com/2022/02/21/remove-dashboard-access-support-me/\">has adopted</a> the <strong>Remove Dashboard Access</strong> and <strong>Support Me plugins</strong> created by <strong>Drew Jaynes</strong>. These plugins are installed on over 50,000 sites.</p>\n\n\n.kt-block-spacer-_ce46dd-da .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_ce46dd-da\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Strattic</strong> <a href=\"https://www.strattic.com/wp2static-joins-strattic/\">has acquired</a> <strong>WP2Static</strong>, which was developed by <strong>Leon Stafford</strong>. Leon is joining <strong>Strattic</strong> and will continue to maintain the plugin, which makes WordPress generate a static file-based site.</p>\n\n\n\n<p><strong>Strattic</strong> will “support keeping WP2Static and its add-ons open source.”</p>\n\n\n.kt-block-spacer-_973c64-22 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_973c64-22\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<h2 id=\"questions-asked-and-lessons-learned\">Questions Asked and Lessons Learned</h2>\n\n\n\n<p><strong>Brian Casel</strong> shares <a href=\"https://twitter.com/CasJam/status/1494330124048556039\">some things he learned from the sale</a> of his <strong>Productize</strong> course business, a 7-year side-business. </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;I still believe [productized services are] the path of least resistance for anyone looking to level up from being a freelancer to a business that can scale. It helped me bootstrap and grow into SaaS. It powers amazing service businesses for many others.&#8221;</p></blockquote>\n\n\n.kt-block-spacer-_3af4ee-a2 .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_3af4ee-a2\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Eric Karkovack</strong> wonders if many of the features WordPress is gaining are for non-designers and <a href=\"https://thewpminute.com/is-wordpress-pushing-freelancers-away/\">will push freelancers away</a>. Eric believes freelancers are vital to growth:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;Without the right balance, there is a potential to squeeze out those of us in the mid-range of the market… we’re not at that point just yet. However, the decisions that are made within the next few years could have a huge impact on freelancers.&#8221;</p></blockquote>\n\n\n.kt-block-spacer-_c19cf5-cd .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_c19cf5-cd\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Nyasha Green</strong> shares her response to those who ask, &#8220;<a href=\"https://masterwp.com/are-wordpress-developers-real-developers/\">Are WordPress developers real developers?</a>&#8221; It depends how you define &#8220;developer.&#8221; There\'s plenty of space in the WordPress community for a variety of different &#8220;developers.&#8221;</p>\n\n\n.kt-block-spacer-_5157ec-3f .kt-divider{width:80%;}\n<div class=\"wp-block-kadence-spacer aligncenter kt-block-spacer-_5157ec-3f\"><div class=\"kt-block-spacer kt-block-spacer-halign-center\"><hr class=\"kt-divider\" /></div></div>\n\n\n\n<p><strong>Allie Nimmons</strong> asks how to be <a href=\"https://masterwp.com/journey-to-better-wordpress-diversity/\">an effective advocate for diversity</a> in WordPress. She recounts the good, bad, and unintended consequences of calling out WCEU for an apparent lack of diversity in its organizers. Allie now has some suggestions such as this one: </p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>&#8220;Communicat[e] &#8230; intentions first. [&#8230;] Bring to the forefront what you hope to accomplish with your advocacy before bringing up tough questions.&#8221;</p></blockquote>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Feb 2022 04:38:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"WPTavern: WooCommerce 6.3 to Introduce New Product Filtering by Attributes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130511\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"https://wptavern.com/woocommerce-6-3-to-introduce-new-product-filtering-by-attributes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2959:\"<p>The WooCommerce development team released the first <a href=\"https://developer.woocommerce.com/2022/02/22/woocommerce-6-3-rc/\">RC for version 6.3</a> this week.  The upcoming major release is expected on March 8, 2022, and is set to introduce an exciting, long-awaited feature: a new lookup table that will offer the ability the accurately <a href=\"https://developer.woocommerce.com/2022/02/02/new-product-filtering-by-attributes-rolling-out-in-woocommerce-6-3/\">filter products by attributes</a>.</p>\n\n\n\n<p>Shop owners who sell variable items have been frustrated for years by WooCommerce&#8217;s broken filtering of variable products. Automattic developer Néstor Soriano explained the problem when the new lookup table <a href=\"https://developer.woocommerce.com/2021/08/12/brace-yourselves-new-product-filtering-by-attributes-is-coming/\">went into testing</a> last year:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>The problem appears when there are variable products where some variations have stock and others don’t, and the “hide out of stock products from the catalog” option is set. What happens is that when an attribute is selected for filtering, all variable products having a variation that corresponds to that attribute will be displayed, even those not having stock for that variation (as long as at least one variation has stock).</p></blockquote>\n\n\n\n<p>Merchants who have experienced this have become frustrated because customers end up having to search through all the items to see if their selected variation is available. Sometimes they abandon the process after the first few items don&#8217;t have the one they are looking for.</p>\n\n\n\n<p>The new lookup table in WooCommerce 6.3 solves this problem in a way that should improve performance &#8211; by creating a table row for each combination of product and attribute, including individual variations and stock status. This will be immensely helpful for any store owner who sells variable products, such as clothes, shoes, jewelry, etc.</p>\n\n\n\n<p>This update will require a database migration. It will also introduce a new “Advanced” section under the Product Settings tab with options for the new product attributes lookup table.</p>\n\n\n\n<div class=\"wp-block-image\"><img />New Advanced settings:  WooCommerce – Settings – Products – Advanced</div>\n\n\n\n<p>WooCommerce 6.3 has updated to the <a href=\"https://developer.woocommerce.com/2022/02/02/woocommerce-blocks-6-9-0-release-notes/\">6.9.0</a> version of the WooCommerce Blocks feature plugin and version 3.2.0-rc of WooCommerce Admin.</p>\n\n\n\n<p>Shop owners who have variable products may want to give the update a test run during the next 12 days before the release lands. It is available for <a href=\"https://downloads.wordpress.org/plugin/woocommerce.6.3.0-rc.1.zip\">download from WordPress.org</a> or via the <a href=\"https://wordpress.org/plugins/woocommerce-beta-tester/\">WooCommerce Beta Tester plugin</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Feb 2022 04:22:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: Recreating Onia: Building Brushstroke Backgrounds With WordPress Blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130503\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"https://wptavern.com/recreating-onia-building-brushstroke-backgrounds-with-wordpress-blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8376:\"<p class=\"has-drop-cap\">As I was looking over the latest releases from the WordPress theme directory this week, I came across one that caught my eye. <a href=\"https://wordpress.org/themes/onia/\">Onia</a> was clean and minimal while reserving its flourishes to bring attention to just a few elements across the page.</p>\n\n\n\n<p><em>Could this be one of those diamonds in the rough I am always looking for in the free theme directory?</em></p>\n\n\n\n<p>It had the potential, but it fell short. As I explored the theme, it felt like the author had spent 90% of their time designing an eye-catching front page. Diving into inner pages showed no attention to typography as the character count per line was pushing 150 and beyond, more than twice what it should be for comfortable reading.</p>\n\n\n\n<p>That is the sort of thing that is easy to address. I was more disappointed that Onia was not a block theme. All the elements were there. It did not do anything particularly complex, and there was no evident reason for it to be a classic theme.</p>\n\n\n\n<p>Yesterday evening, I sat down and recreated Onia as a block theme. Technically, I built its homepage directly from the editor on top of a base theme project I already had on hand. There were a couple of challenges, but I did the bulk of the work in roughly an hour. The other pieces took a little longer as I ran through possible solutions.</p>\n\n\n\n<p>The following is a comparison of the two front pages (Onia is first, followed by my recreation):</p>\n\n\n\n\n<img />\n\n\n\n<img />\n\n\n\n\n<p>I obviously took a few liberties with spacing, sizing, and coloring. I was not attempting an exact replica. Instead, it was a bit of a reboot with a few spins on the original.</p>\n\n\n\n<h2 id=\"some-quick-notes\">Some Quick Notes</h2>\n\n\n\n<p>One of the things that often frustrates me with themes is that they show off these beautiful logos in the demo but offer no way for the user to work with the same font. I was unsure of what the original font family was used in the logo, but I added <a href=\"https://fonts.google.com/specimen/Sacramento\">Sacramento</a> as a cursive handwriting option:</p>\n\n\n\n<img />Pretty font that users can customize.\n\n\n\n<p>These features can make a difference for the average user. Not everyone can load up Photoshop and create their own specialized logo. However, they can type their site&#8217;s name and select a font option for the plain text version.</p>\n\n\n\n<p>Technically, there are two features currently in Gutenberg but not in WordPress 5.9 that I used. The first is the <a href=\"https://github.com/WordPress/gutenberg/pull/37649\">Read More block</a>. Onia had this in its post grid. As a theme author, I would have simply waited for this feature if it was a holdup. Considering that both the featured image and post title link to the single post page, it was not a make-or-break element.</p>\n\n\n\n<p>The second missing feature is the <a href=\"https://github.com/WordPress/gutenberg/pull/38152\">&#8220;show labels&#8221; option</a> for the Social Icons block. A workaround for the original design would have been to use a Navigation block instead since the links were just plain text. Another option would have been a custom block style for Social Icons. Either way, this was not a blocker for this theme being released as a block theme.</p>\n\n\n\n<p>Every other design element of the theme is possible through the block system.</p>\n\n\n\n<h2 id=\"brushstroke-block-style\">Brushstroke Block Style</h2>\n\n\n\n<p>I said there were challenges, but I use that term to mean &#8220;the fun stuff.&#8221; These are the pieces where designers and developers can dive into a problem and attempt to innovate, and they are the solutions that I want to share.</p>\n\n\n\n<p>One of my favorite design elements of the theme was its use of an SVG to create a brushstroke behind the intro heading:</p>\n\n\n\n<img />Onia homepage intro.\n\n\n\n<p>The theme used an old-school method of wrapping a <code>&lt;span></code> element inside an <code>&lt;h1></code>. This applies the brush background to the last few words of the text. However, that implementation is problematic with smaller devices, not keeping up with the natural flow of text-breaks as the screen changes. There was also no way for users to control the color of the brushstroke or text.</p>\n\n\n\n<p>I wanted to know if there was a better way of doing this while offering ultimate flexibility to users.</p>\n\n\n\n<p>Fortunately, <a href=\"https://wptavern.com/wordpress-news-gets-a-new-design\">WordPress News recently relaunched</a> with a brand-new design that leaned heavily on brushstrokes. Plus, the theme is <a href=\"https://github.com/WordPress/wporg-news-2021/blob/trunk/source/wp-content/themes/wporg-news-2021/sass/style.scss#L11-L21\">licensed under the GPL</a>, so its assets are freely available.</p>\n\n\n\n<p>Honestly, I wish I had looked at its source code before reading over various CSS help and support sites. Our community&#8217;s designers had already solved the problems I was hitting. All I had to do was adjust their solutions to fit my needs.</p>\n\n\n\n<p>After a bit of wrangling, I managed to create a customizable brushstroke background for Headings:</p>\n\n\n\n\n<img />\n\n\n\n<img />\nBrushstroke works with any color.\n\n\n\n<p>Users can adjust the text color as always. However, modifying the background color changes the brushstroke color. The stroke always aligns with the last line of text, so it will work regardless of the screen size. That may not always be desirable. However, other solutions exist for use cases like highlighting specific text.</p>\n\n\n\n<p>The following screenshot is an editor view as I change the color:</p>\n\n\n\n<img />Customizing the brushstroke background color.\n\n\n\n<p>To create the brushstroke background for Heading blocks, I added the following code to my theme&#8217;s <code>functions.php</code> file:</p>\n\n\n\n<pre class=\"wp-block-code\"><code>add_action( \'init\', \'tavern_register_block_styles\' );\n\nfunction tavern_register_block_styles() {\n        register_block_style( \'core/heading\', &#91;\n            \'name\' =&gt; \'brush\',\n            \'label\' =&gt; __( \'Brush\', \'tavern\' )\n        ] );\n}</code></pre>\n\n\n\n<p>Then, I downloaded the <code>brush-stroke-big.svg</code> file from the <a href=\"https://github.com/WordPress/wporg-news-2021/blob/trunk/source/wp-content/themes/wporg-news-2021/images/brush-stroke-big.svg\">WordPress News repo</a> and added it to an <code>/assets/svg</code> folder in my theme.</p>\n\n\n\n<p>The final step was adding custom CSS to my theme&#8217;s stylesheet. I <a href=\"https://wptavern.com/building-a-scotch-tape-image-block-style#creating-the-scotch-tape-block-style\">covered adding styles</a> in more depth in my previous Building with Blocks tutorial for those who need a refresher.</p>\n\n\n\n<pre class=\"wp-block-code\"><code>/* Cancel out WP\'s padding on headings with backgrounds. */\n:is( h1, h2, h3, h4, h5, h6 ).is-style-brush.has-background {\n    padding: 0;\n}\n\n/* Add default background to headings. Clip it to the text. */\n:where( h1, h2, h3, h4, h5, h6 ).is-style-brush {\n    position: relative;\n    z-index: 1;\n    background-color: #b5b5b5;\n    background-clip: text !important;\n    -webkit-background-clip: text !important;\n}\n\n/* Adds the brushstroke to ::before. Using ::after can conflict with editor. */\n:where( h1, h2, h3, h4, h5, h6 ).is-style-brush::before {\n    content: \"\";\n    position: absolute;\n    z-index: -1;\n    bottom: -1rem;\n    left: -1rem;\n    height: calc( 1.25em + 1rem );\n    width: 100%;\n    background-color: inherit;\n    -webkit-mask-image: url(\'assets/svg/brush-stroke-big.svg\');\n    mask-image: url(\'assets/svg/brush-stroke-big.svg\');\n    -webkit-mask-position: left bottom;\n    mask-position: left bottom;\n    -webkit-mask-repeat: no-repeat;\n    mask-repeat: no-repeat;\n    -webkit-mask-size: 100% 100%;\n    mask-size: 100% 100%;\n}</code></pre>\n\n\n\n<p>Most of those rules can be adjusted on a case-by-case basis. Some may need a bit of fudging, depending on the theme.</p>\n\n\n\n<p>This solution could work for other blocks. I encourage theme authors to experiment and use other SVGs to see what they come up with.</p>\n\n\n\n<p><strong>Note:</strong> the Onia theme links to a CDN for its SVG background image, which is not supposed to be allowed on WordPress.org. I also could not find any licensing info on it. Being unsure if it was compatible with the GPL, I did not use the asset from the theme.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 25 Feb 2022 02:50:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"Post Status: New Ways to Win Together\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=93887\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://poststatus.com/new-ways-to-win-together/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3211:\"<h2 id=\"fresh-woocommerce-6-3-release-candidate-and-6-2-1-security-release\">Fresh WooCommerce 6.3 Release Candidate and 6.2.1 Security Release </h2>\n\n\n\n<p class=\"has-drop-cap\"><strong>WooCommerce 6.3 RC</strong> has been <a href=\"https://developer.woocommerce.com/2022/02/22/woocommerce-6-3-rc/\">released with updates</a> to the Admin and a couple of fixes to the product attributes table since the release of the beta. So get your testing on! This release candidate was followed up with a <strong>WooCommerce 6.2.1</strong> <a href=\"https://developer.woocommerce.com/2022/02/22/woocommerce-6-2-1-security-fix/\">Security Fix</a>  for permission check in reviews and path traversal in importers.</p>\n\n\n\n<h2 id=\"object-cache-pro-partners-with-convesio-plugin-authors-take-note\">Object Cache Pro Partners with Convesio — Plugin Authors Take Note</h2>\n\n\n\n<p>In other news, hot on the heels of securing $5 Million in new investment capital, <strong>Convesio</strong> has <a href=\"https://convesio.com/object-cache-pro-convesio-partnership/\">partnered with</a> <strong>Object Cache Pro</strong> to increase performance for both their Business and Enterprise WooCommerce/WordPress customers. </p>\n\n\n\n<p>Object Cache Pro is the work of Till Krüss who partnered with Cloudways in a similar fashion in late 2021. Till\'s work with hosting partners is an innovative and exciting business model that seems to align the interests of devs, hosts, and their customer bases for mutual benefit. It\'s an idea other plugin developers might want to consider when a SaaS version of their product isn\'t an option or the best way to grow. </p>\n\n\n\n<h2 id=\"h-jordan-gal-offers-insights-into-the-woo-and-wordpress-space\">Jordan Gal Offers Insights into the Woo and WordPress Space</h2>\n\n\n\n<p>And lastly, <strong>Jordan Gal</strong>, founder of <strong>Rally</strong>, shares <a href=\"https://dothewoo.io/web-3-0-pricing-woocommerce-ecosystem/\">his experiences around entering both the WooCommerce and WordPress space</a>. Jordan has some truly visionary insights into checkout, product pricing, and the overall ecosystem.</p>\n\n\n\n<div class=\"wp-container-62267c622b6d0 wp-block-group\"><div class=\"wp-block-group__inner-container\">\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile has-background\"><a href=\"https://dothewoo.io/post-status-members/\"><img width=\"400\" height=\"400\" src=\"https://cdn.poststatus.com/wp-content/uploads/2022/02/hg1C04vb_400x400.jpg\" alt=\"Do the Woo\" class=\"wp-image-93517 size-full\" /></a><div class=\"wp-block-media-text__content\">\n<p class=\"has-text-align-left\" id=\"h-get-ready-for-remote-work\"><strong><strong>Do the Wo</strong>o!</strong> <a href=\"https://dothewoo.io/subscribe\" target=\"_blank\" rel=\"noreferrer noopener\">Get the Podcast</a>. <a href=\"https://dothewoo.io/subscribe\" target=\"_blank\" rel=\"noreferrer noopener\">Subscribe to the Newsletter</a>.</p>\n\n\n\n<p>Learn from others. Grow your business. Connect with a community of like-minded developers and builders who freelance, run agencies, and build really cool products and sites in the <strong>WooCommerce</strong> ecosystem.</p>\n</div></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n</div></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Feb 2022 22:43:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Bob Dunn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WordCamp Central: Thanks to Jetpack for sponsoring community events worldwide\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://central.wordcamp.org/?p=3146028\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"https://central.wordcamp.org/news/2022/02/24/thanks-to-jetpack-for-sponsoring-community-events-worldwide-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1666:\"<p><span>What would we do without our sponsors? We’re so grateful to </span><strong><span><a href=\"http://jetpack.me/\">Jetpack</a></span></strong><span> for </span><strong><span><a href=\"https://central.wordcamp.org/global-community-sponsors/\">sponsoring WordPress community events all around the globe</a></span></strong><span> at the Gold level in 2022! Jetpack’s support helps make local community events (like WordPress meetup groups and WordCamps) better for WordPress enthusiasts and easier to organize for our wonderful group of hardworking volunteers.</span></p>\n<p><a href=\"https://central.wordcamp.org/files/2019/03/jetpack-logo-horizontal-color.png\"><img /></a></p>\n<p>Transform how you work with your WordPress sites: Jetpack connects your site to the global services, community, and support provided by WordPress.com. Focus on the substance of your site, not the software.</p>\n<p>Jetpack security tools automatically shield your site from spammers, hackers, and malware, while real-time syncing and backup means never worrying about data loss. Traffic-building tools like easy social sharing help you attract readers and search engines, and pages delivered from a high-speed, global content delivery network mean those readers never bounce because of a slow-loading site.</p>\n<p>Jetpack’s Affiliate program gives you 20% every time you sell Jetpack to a customer or client — with unlimited referrals, the sky’s the limit!</p>\n<p>Whether you’re one person with a website or an agency with a dozen clients, Jetpack helps you grow. Make your site work for you at <a href=\"https://jetpack.com/\"><strong><span>Jetpack.com</span></strong></a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Feb 2022 16:00:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Isotta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"BuddyPress: 4 to 6 months to improve our documentation site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=323608\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"https://buddypress.org/2022/02/4-to-6-months-to-improve-our-documentation-site/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2892:\"<p>Hi the BuddyPress community,</p>\n\n\n\n<p>We haven&#8217;t updated the <a href=\"https://codex.buddypress.org/\">BuddyPress Codex</a> for a while and it really needs a big refresh! The BuddyPress development team decided at the end of their <a href=\"https://bpdevel.wordpress.com/2022/02/21/bp-dev-chat-summary-february-16-2022/\">last week meeting</a> to spend the next 4 to 6 months on this very important task: make our documentation <strong>up to date</strong>, better organized, more accurate and more useful to all BuddyPress user &#8220;levels&#8221;.</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>No major releases, all energy on docs!</p><cite><a class=\"bp-suggestions-mention\" href=\"https://buddypress.org/members/imath/\" rel=\"nofollow\">@imath</a></cite></blockquote>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2>This task is huge and we really need your help to make it a success</h2>\n\n\n\n<div class=\"wp-block-image\"><a href=\"https://buddypress.org/wp-content/uploads/1/2022/02/boone-jjj-bp.jpg\"><img width=\"1024\" height=\"681\" src=\"https://buddypress.org/wp-content/uploads/1/2022/02/boone-jjj-bp-1024x681.jpg\" alt=\"\" class=\"wp-image-323612\" /></a>Photo Credits :&nbsp;<a rel=\"noreferrer noopener\" href=\"https://www.flickr.com/photos/ahockley/15731274722\" target=\"_blank\">WordCamp San Francisco by Aaron Hockley, on Flickr</a>.</div>\n\n\n\n<p>That&#8217;s why we kindly invite you all to join this effort and why not become members of a new BuddyPress Docs team!</p>\n\n\n\n<p>We&#8217;ll meet every other Wednesday for an hour to talk about docs during a new &#8220;documentation contributor hour&#8221;. Our kick off meeting is scheduled <a href=\"https://www.timeanddate.com/worldclock/fixedtime.html?iso=20220302T2000\">next week (March 2) at 20:00 UTC</a>. It will happen into the <a href=\"https://wordpress.slack.com/messages/buddypress\">#BuddyPress</a> channel of the <a href=\"https://make.wordpress.org/chat/\">WordPress.org slack</a>.</p>\n\n\n\n<ol><li>If you haven&#8217;t registered a WordPress.org account, you&#8217;ll need to do so: create your account on&nbsp;<a href=\"https://login.wordpress.org/register/\">WordPress.org</a>&nbsp;</li><li>If you haven&#8217;t joined the&nbsp;<a href=\"https://make.wordpress.org/chat/\">WordPress.org Slack</a>&nbsp;(the tool WordPress contributors are using to communicate with), you&#8217;ll need to do it, once you did the 1st step, from this place: <a href=\"https://make.wordpress.org/chat/\">https://make.wordpress.org/chat/</a>.</li><li>If you have questions, don&#8217;t hesitate to comment this post <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f44c.png\" alt=\"👌\" class=\"wp-smiley\" /></li></ol>\n\n\n\n<div><span class=\"dashicons dashicons-buddicons-buddypress-logo\"></span></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-align-center\"><strong>Let&#8217;s all contribute to BuddyPress documentation.</strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Feb 2022 10:56:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mathieu Viet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Skatepark Is a Bold and Vibrant Block Theme for Events and Organizations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130376\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"https://wptavern.com/skatepark-is-a-bold-and-vibrant-block-theme-for-events-and-organizations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5736:\"<p class=\"has-drop-cap\">Automattic&#8217;s <a href=\"https://wordpress.org/themes/skatepark/\">Skatepark</a> landed in the WordPress.org theme directory on Monday. It was designed for modern events and organizations, but it should work well for many sites with a small amount of customization.</p>\n\n\n\n<p>For those keeping count, it is number 52 on the long path <a href=\"https://wptavern.com/what-arent-more-wordpress-theme-authors-creating-block-themes\">toward the 3,000 themes</a> project lead Matt Mullenweg hopes for before the Collaboration phase of the Gutenberg project. The pace has picked up in the past few months, but the lower-cited number of 300 seems more realistic.</p>\n\n\n\n<p>One thing seems inevitable. The Automattic Theme Team will continue pushing new block themes out. Skatepark is now its 10th contribution, nearly a full 1/5 of the <a href=\"https://wordpress.org/themes/tags/full-site-editing/\">total available on WordPress.org</a>.</p>\n\n\n\n<p>With the <a href=\"https://wptavern.com/the-automattic-theme-team-announces-blockbase-its-new-block-parent-theme\">release of the Blockbase theme last year</a>, I expected that most of Automattic&#8217;s theme releases would just become child themes of it. They would be slight variations on that same design, never really pushing the envelope. After all, that is how most of their block themes seemed to be rolling out. However, the Theme Team&#8217;s last three releases have been standalone. Skatepark graduated from child theme status <a href=\"https://github.com/Automattic/themes/pull/5523\">a mere eight days ago</a>.</p>\n\n\n\n<p>I like seeing this approach. Child theming can have its limits, often tucking designers into unnecessary boxes. The team&#8217;s latest theme needed to be let loose to do its own thing.</p>\n\n\n\n<p>If there was ever a theme design that marched to the beat of its own drum, it would be Skatepark.</p>\n\n\n\n<p>The color scheme is&#8230;<em>how do I describe this?</em> THERE. IS. SO. MUCH. GREEN. <em>Blindingly so.</em></p>\n\n\n\n<img />Default Skatepark theme homepage.\n\n\n\n<p>I love the experimentation. We need more of that in the WordPress community. As much as I dislike the default color scheme, it is likely perfect for someone else.</p>\n\n\n\n<p>I would have instantly deactivated and deleted the theme in the classic era.  But, the site editor and global styles system let users modify colors with relative ease these days.</p>\n\n\n\n<p>The first order of business was changing things so that I could explore this theme properly:</p>\n\n\n\n<img />Changing the theme&#8217;s background color.\n\n\n\n<p>Once my eyes readjusted, I enjoyed tinkering with this Skatepark. There is a lot to like about it from just a general-usage standpoint. The bold typography choices and generous use of whitespace give users the freedom to experiment.</p>\n\n\n\n<p>However, the theme provides a helping hand for those who need it. Skatepark includes 10 block patterns out of the box.</p>\n\n\n\n<p>My favorite is also the simplest. The &#8220;Columns in container&#8221; pattern is a Group block that wraps a few other elements:</p>\n\n\n\n<img />Simple-but-handy layout pattern.\n\n\n\n<p>It does not seem to be trying too hard, merely creating a functional and handy layout. Often, that is just what users need.</p>\n\n\n\n<p>One of its unique patterns is &#8220;Full width image with aside caption.&#8221; It places an Image block in the content, followed by a Columns block. The &#8220;caption&#8221; in this case is not a caption at all. Instead, it is a Separator and Paragraph.</p>\n\n\n\n<img />Columns block to create an aside caption.\n\n\n\n<p>I love this concept, but I question the implementation. The design itself could have been accomplished with a custom block style on the Image block and a few lines of CSS targeting the caption element. Perhaps the team wanted to provide users more customizability.</p>\n\n\n\n<p>Captions are not currently self-contained blocks. However, <a href=\"https://github.com/WordPress/gutenberg/pull/31823\">there is an open ticket </a>to separate them from their parent containers. The change would give theme authors and users more design freedom.</p>\n\n\n\n<p>I am generally not a fan of the offset-column patterns that seem to be a signature of the Automattic&#8217;s themes these days. There is definitely a bit of that mixed in. However, the &#8220;Paragraph with quote&#8221; pattern fits well with the overall design, the primary column aligning with the text above it.</p>\n\n\n\n<img />Columns create a quote that sits to the right of the content.\n\n\n\n<p>Technically, this is a three-column design. The left column is empty, and the other two columns hold the content. It gives the illusion that the Quote block is the only thing moved outside the container.</p>\n\n\n\n<p>I have seen this technique employed to align blocks in the past.  At best, it works as a quick hack, but it has a shaky foundation that crumbles at various screen sizes. It also shows that the block system still lacks a robust set of layout tools. In 2022, there are so many ways to accomplish this design with CSS instead of column hacks. However, theme authors use the tools they have on hand. Until the core design tools mature, they will continue experimenting and innovating in their own way.</p>\n\n\n\n<p>I welcome the experimentation in the Skatepark theme. The default green may never be my <em>cup of tea</em>, but that is OK. I want to see theme authors pushing boundaries and trying new things. Plus, underneath it all, the theme includes one thing that Automattic almost always gets right: legible typography.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"wp-embedded-content\"><a href=\"https://wordpress.org/themes/skatepark/\">Skatepark</a></blockquote>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Feb 2022 05:00:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: WordFest Live to Host Free 24-Hour Festival of WordPress March 4, 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130438\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"https://wptavern.com/wordfest-live-to-host-free-24-hour-festival-of-wordpress-march-4-2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3114:\"<div class=\"wp-block-image\"><img /></div>\n\n\n\n<p>The third edition of <a href=\"https://www.wordfest.live/\">WordFest Live</a> is coming up on March 4, 2022. The online event will feature more than 60 sessions over the course of 24 hours, as well as workshops, socials, and celebrations. </p>\n\n\n\n<p>Sessions will be focused on WordPress, remote working, and mental wellbeing. Topics include leadership, freelancing, website performance, podcasting, WooCommerce, dealing with mental disorders in tech, work/life balance, stress and anxiety, and more.</p>\n\n\n\n<p>Although WordFest was created by experienced WordCamp organizers, it is not an event that falls under the official WordCamp Central umbrella. The event remains independent because it was created to raise awareness and funds for <a href=\"https://www.bigorangeheart.org/\">Big Orange Heart</a>, a non-profit that supports and promotes positive wellbeing and mental health within remote working communities. Big Orange Heart&#8217;s first event was held in January 2021.</p>\n\n\n\n<p>&#8220;The event has morphed a bit over the course of 2021 to what it will be next week,&#8221; WordFest speaker lead Michelle Frechette said. &#8220;We’ve perfected the platform, which incorporates live emcees with both live and pre-recorded speaker sessions, live and recorded community interviews, wellness talks as well as tech and business talks, an online photo booth, sponsor rooms, and networking rooms &#8211; all of which contribute to the reduction of those feelings of isolation that come from working in a remote community &#8211; especially after 2+ years of pandemic.&#8221;</p>\n\n\n\n<p>More than 1,300 people have already signed up for WordFest. Frechette said the organizing team anticipates 2,500-3,000 registrations, as many online events usually get the bulk of their signups the week before.</p>\n\n\n\n<p>The schedule for the event is designed to reach WordPress enthusiasts in every timezone across the globe, so everyone has the opportunity to catch some of the events live.</p>\n\n\n\n<p>&#8220;So many times online events are targeted to Europe and North America, so people working in other regions in the world either have to forego sleep or consume the event only through recorded video after the fact,&#8221; Frechette said.</p>\n\n\n\n<p>Although Wordfest happens over the span of 24 hours, it&#8217;s not the type of event where attendees are encouraged to pound caffeinated beverages and power through to the end. </p>\n\n\n\n<p>&#8220;Because we are an organization that promotes positive mental well-being, we don’t want anyone to be up for a full 24 hours &#8211; so those times that someone is not able to be online for the event will be captured and saved for viewing at later times,&#8221; Frechette said.</p>\n\n\n\n<p>WordFest <a href=\"https://www.wordfest.live/2022/march/register/\">registration</a> is free and attendees can add an optional $10 donation. 100% of the funds raised for the event go directly to Big Orange Heart and will be invested in growing the organization&#8217;s free mental health support efforts for the remote working community.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 21:52:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"Post Status: This Week at WordPress.org (February 21, 2022)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=93823\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://poststatus.com/this-week-at-wordpress-org-february-21-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7847:\"<p>Each week we are highlighting the news from WordPress.org that you don\'t want to miss.  If you or your company create products or services that use WordPress, we\'ve got the news you need to know. Be sure to share this resource with your product and project managers.</p>\n\n\n\n<h2 id=\"h-news\"><a href=\"http://wordpress.org/news\">News</a></h2>\n\n\n\n<ul><li><a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\">5.9.1 Maintenance Release</a></li><li><a href=\"https://wordpress.org/news/2022/02/episode-25-five-cents-on-five-for-the-future/\">Episode 25: Five Cents on Five for the Future</a></li><li><a href=\"https://make.wordpress.org/photos/2022/02/17/welcome-to-make-photos/\">Welcome to Make Photos</a> (new team)</li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns\">\n<div class=\"wp-block-column\">\n<h2 id=\"h-accessibility\"><a href=\"https://make.wordpress.org/accessibility\">Accessibility</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/accessibility/2022/01/08/accessibility-teams-goals-for-wordpress-6-0-and-beyond/\">The Accessibility Team’s Goals for WordPress 6.0 and Beyond</a></li></ul>\n\n\n\n<h2 id=\"h-community\"><a href=\"http://make.wordpress.org/community\">Community</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/community/2022/02/15/meetup-organizer-newsletter-february-2022/\"></a><a href=\"https://make.wordpress.org/community/2022/02/21/2022-global-sponsors-announcement/\">2022 Global Sponsors: Announcement</a></li><li><a href=\"https://make.wordpress.org/community/2022/02/16/proposal-refurbishing-camera-kits/\">Proposal: Refurbishing Camera Kits</a><a href=\"https://make.wordpress.org/community/2022/01/10/proposal-mandatory-safety-measures-for-in-person-wordpress-events-in-2022/\"></a></li></ul>\n\n\n\n<h2 id=\"h-core\"><a href=\"https://make.wordpress.org/core\">Core</a> </h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/02/25/proposal-to-start-a-news-blog-on-developer-wordpress-org/\">Proposal to Start a News blog on developer.WordPress.org</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/\">What’s new in Gutenberg 12.6? (16 February)</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/24/feature-project-plugin-dependencies/\">Feature Project: Plugin Dependencies</a></li></ul>\n\n\n\n<h2 id=\"h-design\"><a href=\"https://make.wordpress.org/design\">Design</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/design/2022/02/15/show-and-tell-february-2022/\">Show and Tell — February 2022</a></li></ul>\n\n\n\n<h2 id=\"h-docs\"><a href=\"https://make.wordpress.org/docs\">Docs</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/docs/2022/02/20/the-hashtag-and-its-future-in-documentation-articles/\">The hashtag and its future in documentation articles</a></li></ul>\n\n\n\n<h4 id=\"h-developer\"><a href=\"https://developer.wordpress.org\">Developer</a>: </h4>\n\n\n\n<ul><li><a href=\"https://developer.wordpress.org/block-editor/reference-guides/components/navigator-button/\">NavigatorButton</a></li><li><a href=\"https://developer.wordpress.org/block-editor/reference-guides/components/navigator-back-button/\">NavigatorBackButton</a>&nbsp;</li></ul>\n\n\n\n<h2 id=\"h-hosting\"><a href=\"https://make.wordpress.org/hosting\">Hosting</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/hosting/2022/01/10/wordpress-5-9-and-php-8-0-8-1/\">WordPress 5.9 and PHP 8.0-8.1</a></li></ul>\n\n\n\n<h2 id=\"h-marketing\"><a href=\"https://make.wordpress.org/marketing\">Marketing</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/marketing/2021/12/01/help-contribute-to-social-media-materials-for-5-9-release/\"></a><a href=\"https://make.wordpress.org/marketing/2022/02/17/retiring-team-reps-2022/\">Retiring Team Reps 2022</a></li><li><a href=\"https://make.wordpress.org/marketing/2022/02/17/welcoming-new-marketing-team-reps-for-2022/\">Welcoming new Marketing Team reps for 2022</a></li></ul>\n\n\n\n<h2 id=\"h-photos\">Photos</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/photos/2022/02/23/photo-directory-team-rep-nominations-for-2022/\">Photo Directory Team Rep Nominations for 2022</a></li></ul>\n\n\n\n<h2 id=\"h-polyglots\"><a href=\"https://make.wordpress.org/polyglots/\">Polyglots</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/polyglots/2022/02/22/polyglots-monthly-newsletter-february-2022/\">Polyglots Monthly Newsletter: February 2022</a></li></ul>\n\n\n\n<h2 id=\"h-plugins\"><a href=\"https://make.wordpress.org/plugins\">Plugins</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/updates/2022/02/22/plugin-review-team-21-february-2022/\">Plugin Review Team: 21 February 2022</a></li></ul>\n\n\n\n<h2 id=\"h-mobile\"><a href=\"https://make.wordpress.org/mobile\">Mobile</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/mobile/2022/02/08/call-for-testing-wordpress-for-ios-19-2/\"></a><a href=\"https://make.wordpress.org/mobile/2022/02/22/call-for-testing-wordpress-for-ios-19-3/\">Call for Testing: WordPress for iOS 19.3</a></li><li><a href=\"https://make.wordpress.org/mobile/2022/02/22/call-for-testing-wordpress-for-android-19-3/\">Call for Testing: WordPress for Android 19.3</a></li></ul>\n\n\n\n<h2 id=\"h-test\"><a href=\"https://make.wordpress.org/test\">Test</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/test/2022/02/23/fse-program-testing-call-12-hyping-headers/\">FSE Program Testing Call #12: Hyping Headers</a></li><li><a href=\"https://make.wordpress.org/test/2022/02/25/fse-program-all-things-media-summary/\">FSE Program All Things Media Summary</a><a href=\"https://make.wordpress.org/test/2022/02/02/fse-program-exploration-all-things-media/\"></a></li><li><a href=\"https://make.wordpress.org/test/2022/02/16/hallway-hangout-all-things-media/\">Hallway Hangout: All Things Media</a></li></ul>\n\n\n\n<h2 id=\"h-themes\"><a href=\"https://make.wordpress.org/themes\">Themes</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/updates/2022/02/22/themes-team-update-february-22-2022/\">Themes team update February 22, 2022</a></li></ul>\n\n\n\n<h2 id=\"h-training\"><a href=\"https://make.wordpress.org/training\">Training</a></h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/training/2022/01/31/faculty-program-structure-proposal/\">Faculty Program: Structure Proposal</a></li></ul>\n\n\n\n<h4 id=\"h-social-learning-spaces\">Social Learning Spaces:</h4>\n\n\n\n<ul><li><a href=\"https://learn.wordpress.org/social-learning/\">Calendar</a></li></ul>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile has-background\"><a href=\"https://poststatus.com/\"><img src=\"https://cdn.poststatus.com/wp-content/uploads/2021/09/vertical-post-status-logo-250.png\" alt=\"Post Status\" class=\"wp-image-85823 size-full\" /></a><div class=\"wp-block-media-text__content\">\n<p class=\"has-text-align-left has-normal-font-size\" id=\"h-get-ready-for-remote-work\">You — and <a href=\"https://poststatus.com/business-membership/\">your whole team</a> can <a href=\"https://poststatus.com/post-status-membership-club/\">Join Post Status</a> too!</p>\n\n\n\n<p class=\"has-text-align-left has-small-font-size\"><strong>Build your network. Learn with others. Find your next job — or your next hire.</strong> Read the <strong>Post Status</strong> <a href=\"https://poststatus.com/newsletter/\">newsletter</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/2709.png\" alt=\"✉\" class=\"wp-smiley\" /> Listen to <a href=\"https://poststatus.com/podcasts/\">podcasts</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f399.png\" alt=\"🎙\" class=\"wp-smiley\" /> Follow <a href=\"https://twitter.com/post_status/\">@Post_Status</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f426.png\" alt=\"🐦\" class=\"wp-smiley\" /></p>\n</div></div>\n\n\n\n<div class=\"wp-block-spacer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 18:30:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Courtney Robertson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"Gutenberg Times: Gutenberg Changelog #61 – Gutenberg 12.6, Planning for WordPress 6.0 and Universal Blocks\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://gutenbergtimes.com/?post_type=podcast&p=20488\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://gutenbergtimes.com/podcast/gutenberg-changelog-61-universal-blocks/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:61961:\"<p>Grzegorz Ziolkowski and Birgit Pauli-Haack introduce Mary Job as the new co-host  and discuss Gutenberg 12.6, Planning for WordPress 6.0 and Universal Blocks.</p>\n\n\n\n<ul><li>Music:&nbsp;<a href=\"https://soundcloud.com/xirclebox\">Homer Gaines</a></li><li>Editor:&nbsp;<a href=\"https://www.linkedin.com/in/sandy-reed/\">Sandy Reed</a></li><li>Logo:&nbsp;<a href=\"https://markuraine.com/\">Mark Uraine</a></li><li>Production:&nbsp;<a href=\"https://icodeforapurpose.com\">Birgit Pauli-Haack</a></li></ul>\n\n\n\n<span id=\"more-20488\"></span>\n\n\n\n<p><a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-61-universal-blocks#shownotes\">Show Notes </a>/ <a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-61-universal-blocks#transcript\">Transcript</a></p>\n\n\n\n<p><strong>Subscribe to the&nbsp;<a href=\"https://gutenbergtimes.com/podcast/\">Gutenberg Changelog</a>&nbsp;podcast via your favorite podcast apps!</strong><br />🎙️&nbsp;<a href=\"https://open.spotify.com/show/620NwVKQJGdTupy36zYxvg?mc_cid=4b6c9f88fe\">Spotify</a>&nbsp;|&nbsp;<a href=\"https://podcasts.google.com/feed/aHR0cHM6Ly9ndXRlbmJlcmd0aW1lcy5jb20vZmVlZC9wb2RjYXN0\">Google</a>&nbsp;|&nbsp;<a href=\"https://podcasts.apple.com/us/podcast/gutenberg-changelog/id1469294475\">iTunes</a>&nbsp;|&nbsp;<a href=\"https://pca.st/podcast/f8445ec0-7508-0137-f267-1d245fc5f9cf\">PocketCasts</a>&nbsp;|&nbsp;<a href=\"https://www.stitcher.com/show/gutenberg-changelog\">Stitcher</a>&nbsp;|<br />🎙️&nbsp;<a href=\"https://www.podbean.com/podcast-detail/chi7j-9904a/Gutenberg-Changelog-Podcast\">Pod Bean</a>&nbsp;|&nbsp;<a href=\"https://castbox.fm/channel/Gutenberg-Changelog-id2173375\">CastBox</a>&nbsp;|&nbsp;<a href=\"https://www.podchaser.com/podcasts/gutenberg-changelog-878239/\">Podchaser</a>&nbsp;|&nbsp;<a href=\"https://gutenbergtimes.com/feed/podcast\">RSS Feed</a>&nbsp;</p>\n\n\n\n<p class=\"has-large-font-size\" id=\"shownotes\"><strong>Show Notes </strong></p>\n\n\n\n<h2 id=\"new-co-host-mary-job\">New co-host: Mary Job</h2>\n\n\n\n<ul><li><a href=\"https://heropress.com/contributors/mary-job/\">Mary Job&#8217;s Profile on HeroPress</a></li><li><a href=\"https://twitter.com/maryojob\">Follow Mary Job on Twitter</a></li><li><a href=\"https://maryjob.com/\">Mary Job&#8217;s personal website</a></li></ul>\n\n\n\n<h2 id=\"announcements\">Announcements</h2>\n\n\n\n<ul><li><a href=\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\">WordPress 5.9.1 Maintenance Release</a></li><li><a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-6-0-planning-roundup/\">WordPress 6.0 Planning Roundup</a></li><li><a href=\"https://make.wordpress.org/core/2022/01/26/preliminary-roadmap-for-6-0/\">Preliminary Roadmap for 6.0 (Gutenberg Phase 2)</a></li><li><a href=\"https://gutenbergtimes.com/podcast/gutenberg-changelog-60-restricting-customization-in-a-full-site-editing-world/\">Gutenberg Changelog #60 – Restricting Customization in a Full-Site Editing World, Gutenberg 12.5 and Roadmap for WordPress 6.0</a>&nbsp;with co-hosts Grzegorz Ziolkowski and Birgit Pauli-Haack. Special guest: Matias Ventura</li></ul>\n\n\n\n<h2 id=\"community-contributions\">Community Contributions</h2>\n\n\n\n<p><strong>Wicked Block Builder</strong></p>\n\n\n\n<ul><li><a href=\"https://wordpress.org/plugins/wicked-block-builder/\">Plugin in WP repository </a></li><li><a href=\"https://wptavern.com/wicked-plugins-launches-ui-based-wordpress-block-builder\">Wicked Plugins Launches UI-Based WordPress Block Builder (WPTavern) </a></li><li><a href=\"https://wptavern.com/podcast/11-vinny-mckee-on-his-block-builder-plugin\">Vinny McKee on His Block Builder Plugin</a> (Interview by Nathan Wrigley on WPTavern Jukebox</li></ul>\n\n\n\n<p>WPTavern Jukebox #14 <a href=\"https://wptavern.com/podcast/14-dave-smith-isabel-brison-and-joen-asmussen-on-the-new-navigation-block\">Dave Smith, Isabel Brison and Joen Asmussen on the New Navigation Block</a></p>\n\n\n\n<p id=\"todo-block-by-david-towoju\"><strong>Todo Block by David Towoju</strong></p>\n\n\n\n<ul><li><a href=\"https://wordpress.org/plugins/todo-block/\">WordPress Plugin Repo</a></li><li><a href=\"https://wptavern.com/create-todo-and-checklists-in-the-wordpress-editor-with-new-plugin\">Create Todo and Checklists in the WordPress Editor With New Plugin</a> (WPTavern)</li></ul>\n\n\n\n<p id=\"social-sharing-block\"><strong>Social Sharing Block</strong></p>\n\n\n\n<ul><li><a href=\"https://wordpress.org/plugins/social-sharing-block/\">WordPress Plugin Repo</a> </li><li><a href=\"https://wptavern.com/nick-diego-forks-core-wordpress-block-creates-social-sharing-plugin\">Nick Diego Forks Core WordPress Block, Creates Social Sharing Plugin </a>(WPTavern)</li></ul>\n\n\n\n<h2 id=\"gutenberg-12-6-release\">Gutenberg 12.6 Release</h2>\n\n\n\n<ul><li><a href=\"https://make.wordpress.org/core/2022/02/16/whats-new-in-gutenberg-12-6-16-february/\">What’s new in Gutenberg 12.6? (16 February)</a></li><li><a href=\"https://wptavern.com/gutenberg-12-6-enhances-transforming-blocks-adds-read-more-and-post-author-bio-blocks-and-enables-social-icon-labels\">Gutenberg 12.6 Enhances Transforming Blocks, Adds Read More and Post Author Bio Blocks, and Enables Social Icon Labels</a><ul><li><a href=\"https://github.com/WordPress/gutenberg/pull/38511\">Block Support: Update color panel default controls</a></li><li><strong>Remove APIs deprecated on WordPress 5.4</strong>. (<a href=\"https://github.com/WordPress/gutenberg/pull/38564\">38564</a>)</li></ul></li></ul>\n\n\n\n<p><a href=\"https://www.youtube.com/c/RyanWelcherCodes\">Ryan Welcher&#8217;s YouTube Channel: </a>How to build blocks, Theme building, How to use Create-Block script, Locking down editor features and choices</p>\n\n\n\n<p><a href=\"https://www.twitch.tv/ryanwelchercodes\">Twitch Stream</a></p>\n\n\n\n<h2 id=\"discussion-and-work-in-progress\">Discussion and Work in Progress</h2>\n\n\n\n<p><strong><a href=\"https://github.com/WordPress/gutenberg/discussions/38224\">Universal blocks and block hydration</a></strong></p>\n\n\n\n<p><strong>New Style Engine</strong></p>\n\n\n\n<ul><li><a href=\"https://github.com/WordPress/gutenberg/discussions/37495\">Discussion</a>  </li><li><a href=\"https://github.com/WordPress/gutenberg/issues/38167\">Tracking issue</a></li><li><a href=\"https://github.com/WordPress/gutenberg/pull/37978\">First PR</a></li></ul>\n\n\n\n<p>The next <strong>Gutenberg Developer Hours</strong> will take place <a href=\"https://www.meetup.com/wordpress-social-learning/events/284178232/\">March 8th, 2022 at 11:00 ET / 16:00 UTC</a></p>\n\n\n\n<p class=\"has-large-font-size\" id=\"transcript\">Transcript</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Hello, and welcome to our 61st episode of the Gutenberg Changelog podcast. In today&#8217;s episode will talk about, and with our new co-host Mary Job, about Gutenberg&#8217;s 12.6 release and planning for WordPress 6.0 and universal blocks. I&#8217;m Birgit Pauli-Haack, curator at the Gutenberg Times and WordPress developer advocate at Automatic. And I&#8217;m here with my co-host Grzegorz Ziolkowski, JavaScript developer at Automattic and WordPress core contributor. Hey there Grzegorz, how are you today?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Hello, Birgit. Hello, Mary. I&#8217;m great. The weather is terrible outside. We have storms going through Poland, so I might lose the connection at any time because we already had a blackout for two hours today.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Oh, my God.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: So, it&#8217;s fun, but let&#8217;s hope everything&#8217;s going well.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: So, yeah. So this is the last episode that you and I are hosting together, Grzegorz. I&#8217;m sure we will have your back as a guest in the future and we will stay in touch. So it has been a great honor and privilege to host this podcast with you for the last year almost. I cherish the regular chats with you on and off the air.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, that was great. I mean, it&#8217;s like every two weeks having so nice and deep discussion about everything Gutenberg, definitely a highlight for me. But it&#8217;s also a lot of work and I&#8217;m primarily a developer. So I guess it&#8217;s a good setup that I will be able to join as a panelist from time to time, and we have more people from the community running this excellent podcast.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, thank you. So we have with us the new co-host, what is it? The king is dead. The queen lives. Hail to the queen. So the new co-host of the Gutenberg Changelog podcast, Mary Job. A WordPress advocate support engineer at Paid Membership Pro and a community organizer for Nigeria. Mary, I&#8217;m thrilled that you agreed to go on this new adventure with me. Thank you so much and welcome.</p>\n\n\n\n<p><em>Mary Job</em>: Thank you so much, Birgit. Actually I am also very thrilled to be starting this adventure with you. I wish Grzegorz was staying with us longer, but going to try and do my best and hopefully we talk to him soon as a guest on this podcast.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Wonderful, wonderful. So I&#8217;m glad that we can do a handover. So you see how this all works and also chime in and so it&#8217;s going to be great. We always have very informal conversations here and we jump right into it. Okay. Grzegorz, you want to start with the announcements?</p>\n\n\n\n<h3 id=\"announcements-1\"><strong>Announcements</strong></h3>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. So we are today. We should expect a WordPress 5.9.1, minor RC version of the release, so the first testing version. And I think if everything goes on track, we should have the regularities next week on February 22nd. And JB Audras is the release lead, and he&#8217;s deputy and helper for the editor part is George Mamadashvili. And yeah, I was helping George today to do his first NPM publishing to bring all the code from the block editor to the core and it was like a lot of changes there. All of them are bug fixes, so you should expect next week a lot of improvements in the editing experience. And as we already discussed two weeks ago, the cycles for WordPress 6.0 is in full motion, and we already have a plan in round up and there is a schedule proposed to how that should go and maybe Birgit you can just share more details on that.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Sure. Feature freeze is kind of suggested to be about six weeks from now on March 29, 2022, which brings then two weeks to the first beta release, April 12th. The first release candidate will be May 3rd and also when dev notes are due and it&#8217;s not a string freeze yet, but it&#8217;s almost there. And then the final release is proposed to be scheduled for May 24th in line with proposed schedule that Josepha Haden Chomphosy published two weeks ago to have only two more releases in 2022. So the first one is 6.0, and then end of May, May 24th. And then the next one will be mid October 2022, and we won&#8217;t have, that&#8217;s the 6.1 release. Yeah.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Does it mean that we should expect another release in January or something like that? So that would be very similar to what we had, like we started this year.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: That&#8217;s right. Yeah, that&#8217;s right.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: I think it works great for many agencies and companies because they have a lot of time at the beginning of the year to catch up and it&#8217;s much better. At least people complain a lot about December and every day during that timelines, so maybe that&#8217;s for the best.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. And the move, the postponement of two weeks kind of resulted because of the holidays into the January release and kind of out of a two weeks postponement, we almost had five weeks delay on the release, and it was good for everybody to kind of have the holiday and then year round changes off the release stress day as well. So do you want to talk about the release quarter Grzegorz?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yes.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Just because I&#8217;m in it.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Okay. Sure. So the release squad is not yet complete. What we know already is that as usual, Matt Mullenweg will be the release lead. Hector Prieto will be coordinating the release. For the core part, Peter Wilson will be the lead and we still don&#8217;t have for Gutenberg, for the leader, we still don&#8217;t have the lead picked. So you can still volunteer our listeners. We are waiting for you. And for the documentation, we have great news because Birgit will be the lead there. And how does it feel Birgit?</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, that&#8217;s right. And because it&#8217;s my first release on the squad, being on the squad I&#8217;m kind of the rookie on it, but I will be joined by the brilliant Milana Cap and the amazing Abha Thakor and both have experience in the release squad. So I will definitely cherish their import and also their work on it. It&#8217;s going to be an interesting time for me between March and May when the thing comes out. So I&#8217;m glad, I volunteered for it. So I probably don&#8217;t know what I got myself into, but I will tell you afterwards.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. But fortunately you have a lot of experienced people around and like for 5.9, Marc did an excellent job leading the documentation effort. So you have a lot of work that was done before to look at, and I&#8217;m sure you would do as excellent as they did.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, thank you. Thank you. I&#8217;m definitely going to be standing on the shoulders of giants. So we&#8217;ll see. So two weeks ago, Matias Ventura talked to us about the preliminary roadmap for the Gutenberg phase two in WordPress 6.0, and it&#8217;s an episode 60, WordPress 6.0 episode 60. I really like that coincidence, and he brought us great insight. So Grzegorz and Mary, do you have any particular feature that you are excited about for the next release?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, sure. I definitely have some peaks. I was very inspired by the discussion we had with Matias and from the features he covered, I think two stand out for me. So first of them is start variation for teams. And this is because it gives a lot of power to users. So when you have a team, you would be able to have some sort of presence and you would be able to change how the team looks with a one click, which is like for me, someone who doesn&#8217;t like changing all those aspects, like colors, fonts, margins, spacing, it&#8217;s like, it&#8217;s too much. It just, it&#8217;s like an excellent thing to have. And the other thing is taking patterns to the next level and bringing some semantic meaning, like more semantic meaning to them, what Matias covered.</p>\n\n\n\n<p>Like when you go for instance, on the category page and then could be something that is there for a given category, like for instance, someone could register a pattern for a category, let&#8217;s say music, and you would have something specific to that. Or you go to a page, you create a contact page and you have pattern that is dedicated to this use case or the gallery sub page, and this sort of thinking. Because as of today, the biggest struggle when you start a new site is that you need to fill in all the content and even having all those patterns in the directory and not having a way to easily filter them is a big bottleneck. So yeah, that my picks.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Mary, did you get through it?</p>\n\n\n\n<p><em>Mary Job</em>: Yes, personally, I think I&#8217;m more interested in the long term, precisely with the implementation of most member sites. I think that would be interesting. I&#8217;m more interested in that future and also a collaboration, the idea that two people can, or two or more people can. I think it&#8217;ll be great for the future of bloggers, right? It has this, you know how Google docs function, where multiple people, I can be very interesting. I can&#8217;t wait to see that app like that, because essentially you&#8217;d be able to have a perfectly built internet site on WordPress because then you can have different things on one document. Essentially means you can do all your work on WordPress, you don&#8217;t having to pick some of it out somewhere else.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. We are all waiting for that. That collaboration part is a good book phase three. So I think that&#8217;s phase 3, 23 kind of, yeah. It will be, I&#8217;m playing with the numbers again, but I&#8217;m looking forward to just have the featured image be dynamic and be able to put it in my cover block for my single post. So yeah, they are all different kind of, but I&#8217;m also excited about the pattern stuff, especially that themes will be able to link to the block pattern directory patterns and make them available in their theme without having to add it to the whole theme to it as code. So I think that will definitely speed up loading and developing of themes. So there are quite a few things in there. So we will in the show notes again, put in the preliminary roadmap, post that Matias Ventura had published. And yeah, we also put the link to episode 60 in there, of course. All right. So Grzegorz, you had discovered some amazing plugins you want to share with our listener a bit?</p>\n\n\n\n<h3 id=\"community-contributions-1\"><strong>Community Contributions</strong></h3>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, sure. So one of them is wicked block builder. So I think I read about that on WP Tavern when it was covered for the first time, or maybe on Twitter, like you know, I never know what&#8217;s first. But the idea is really interesting because we discussed before about other ways of creating blocks, like ACF blocking that allows you to build those blocks, but using more custom post fields, like it&#8217;s more in the admin when you need to do a lot of manual work to select some attributes for the block, and then you need to provide PHP template. This solution takes it to the next level because, so you just pre-fill all the regular attributes or settings that the block has, like title, description, category, and all its attributes. And then you go to the screen when you are able to visually, using the drag and drop, inject some, it&#8217;s hard to describe even on the podcast that I listened afterwards, it was really hard to describe.</p>\n\n\n\n<p>So I&#8217;m terrible as well in that doing this job because it&#8217;s like bringing mostly HTML tags to the canvas and just like nesting them and using drag and drop to create your HTML code. But you can also mix that with some interactive elements, like rich text or input field, which allows you to modify some data once that&#8217;s embedded in the block editor. So it&#8217;s like an editor that is outside of the block editor, like a separate page in the WP admin, but then once it&#8217;s finished and you are able to fill some of those fields yourself. So it&#8217;s a really interesting idea and I know that some people are really excited about the possibilities it creates.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. It sounds really amazing. I also know about lazy blocks where you also have to then provide a template for your content in code and some of us are a little bit shy on it. And so Vinny McKee was also a guest on the WP Tavern Jukebox podcast and had a conversation with Nathan Wrigley, the host, about not only his plugin, but also how to approach Gutenberg and all that. So it&#8217;s definitely a great listen to, and I just want to take this as a little opportunity to give a big shout out to Nathan Wrigley, because he has, from a monthly podcast, he&#8217;s now doing weekly Jukebox additions or episodes.</p>\n\n\n\n<p>So every week there will be new people be on the podcast and he interviews them. And he&#8217;s a marvelous interviewer and asks the right questions. And this week just published was the episode 14 where they talked about the navigation block and with the builders of it, like Johan Assmussen, Dave Smith and Isabel Brison, who all worked on it and also what it means to be working for Automattic. Because there are still some open positions there. All right, what was the other plugin?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, so that was the plugin. The other things I wanted to cover are blocks. So first there is a, now a Todo block, by David, I don&#8217;t know how to pronounce the surname. Towoju.</p>\n\n\n\n<p>And it was all covered on WP Tavern, and if you don&#8217;t follow this one, like Gutenberg Times is number one, obviously, and thanks to Birgit. But my second pick for following is WP Tavern. It has a lot of information that covers the Gutenberg plugin and the development and all the things that are built around that. And in particular, there&#8217;s a lot of insight after testing those plugins from Justin Tadlock he&#8217;s doing amazing job, big shout out for him as well. And in here, one I wanted to show is, Todo this is very popular, if someone is into programming is like, if you want to compare libraries, you either do Hacker News app or Todo app just to show the differences between different libraries, frameworks, and so on.</p>\n\n\n\n<p>But this one integrates into the block editor, and before we cover like a few episode backs, we also covered a similar block from each table. But the difference was that the one that Rich created is mostly like a list of things you should to do, but it&#8217;s private for the author that creates the post or the page. Whereas this one, we will be also displayed on the front end and when you will click, like the items was created, like completed, then we will show a different style. So if you want to have sort of distinct edge, definitely something you should check out. And the other plugin is social sharing block. And this block, there is a similar block inside the WordPress core, the difference is that the one in core, it&#8217;s more like a list of links with icons.</p>\n\n\n\n<p>You can style them and they just link to the social services. Like if you want to provide, for instance, in your footer a link to Facebook, GitHub, Twitter, whatever. And this one is more a feature like when you want to share on a given social media, and this one was created by Nick Diego. He just missed those functionality inside the core and I saw that he would be who would love to see whether it&#8217;s fit also for the core. So that needs to be definitely checked, although I&#8217;m not sure it&#8217;s like the target is exactly the same and whether the merging that together into one block would be a great user experience. But that one was also covered on WP Tavern with more details. So check the plugin and the review there.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Nick Diego also has an interesting plugin in the report, that&#8217;s the block visibility, and that gives you a lot of choices. How to conditionally change when a block is visible to a visitor could be either, it needs to be, somebody needs to be logged in to see the block or somebody needs to, or a certain date needs to happen that you can condition on that. So you don&#8217;t have to go back to the post when the date happens and the content shows, or it could also be, if you have, you could actually hook in some user agents. So it could say, okay, if you&#8217;re on Google Chrome, you get this block and if you&#8217;re on there, you get that block. So it&#8217;s quite interesting to have. And the social sharing is a little bit different because the sharing is, you share something, did your visitor shares, use that button and share something on another social network?</p>\n\n\n\n<p>Like share on Twitter kind of thing. And then you help them give all the title and the link all into a tweet. The social links in core are the profile links from your own profile. So yeah, just to make this clear. All right. Yeah. I used both of them. I know that Nick Diego had a post out on Twitter and say, can anybody point me to a social sharing block? I haven&#8217;t found one yet that I wanted to use. And I showed him the one from Kevin, and obviously he wanted to have a more modern experience because the one that was very, wasn&#8217;t updated for a year or so. All right, Mary, do you have favorite block? I&#8217;m sorry, I&#8217;m putting you on the spot. You can kind of cut it out if it not.</p>\n\n\n\n<p><em>Mary Job</em>: No, that is so very fine. Actually, this is the first time I&#8217;m seeing the Todo block. And what I did previously was I created a list and then I would use the structure to structure when I&#8217;m done with that item on this list, but this is a bit perfect. So I&#8217;m definitely exploring this afterwards.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Good. Yeah. Yeah. I&#8217;m going to explore the Wicked Block Builder. Yeah, that definitely interests me.&nbsp;</p>\n\n\n\n<p>So well, Gutenberg 12.6 was released this week. But before we head into the Changelog, I need to issue a correction from the last episode. Big shout to Dave Smith, who set me straight there, the PR with the title allow for HTML and get the underscore title was just a fix for a feature that was new in 12.5 and won&#8217;t be back ported to 5.9.1 because the original feature is not back ported to 5.9.1. The issue I was thinking about was a different one and which I tested. And there was an occasion when you reload an existing post in the editor, it seems to be removing the HTML tags. But then I found out when you put them in again, it saves it again and shows it up on the front end.</p>\n\n\n\n<p>And that bug is still in the works, but it&#8217;s not, it&#8217;s kind of, you have a workaround for it. So it&#8217;s not, yeah. Anyway, so it&#8217;s not a hindrance on your work. It&#8217;s just a little bit tedious to put those tags in when you edit that post, but once you have them in and you&#8217;re not touching it, you&#8217;re fine. All right.&nbsp;</p>\n\n\n\n<h3 id=\"what-s-released-gutenberg-12-6\"><strong>What’s Released &#8211; Gutenberg 12.6</strong></h3>\n\n\n\n<p>So what&#8217;s new in Gutenberg 5.6.? Andy Peatlng handled the release and now there are few enhancements in there that we are going to discuss and some bug fixes and some excellent new features there, not necessarily for the front end, but for the documentation as well.</p>\n\n\n\n<h3 id=\"enhancements\"><strong>Enhancements</strong></h3>\n\n\n\n<p>So there are new blocks in there. One is the post author biography block. So that&#8217;s the block that when you fill out the user profile with the description, that will post it there. And then there is also a new read more block for the post link. So when you have a post with excerpt in your post template or query loop, you can now separate out the post link and make it a button or style it differently, or position it differently in its own block. It&#8217;s a simple way to link to a single page or post with a query block.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. I&#8217;m just checking whether the post author biography allows editing, because that would be great. You wouldn&#8217;t have to go to the set profile setting page, but it&#8217;s probably not yet there. So yeah, definitely a good and for that farther enhancement. And that&#8217;s my favorite one, because I always struggled with this use case. So I wanted, when I saw that on many block posts under the post there would be author with, usually it&#8217;s only a name, a link and something like that. And having an option to provide the avatar that was added previously, and now the biographic that just compliments each other and you can put this nice footer that&#8217;s always displayed on the post page. That&#8217;s just amazing and I&#8217;m happy to see that.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah, me too. Me too. So the next thing are the transforms as an enhancement, it&#8217;s where you can change a block immediately into another kind of block. So for instance, there is a transform now. So there was a transform from the beginning from paragraph to list, you have six paragraphs and now you have a six bullet point list and in one step. And that feature is now expanded, and you can now transform a block from tag cloud to categories. So you don&#8217;t have to highlight it, delete it, grab the other block and put it in again, you just use the transform button on the left, on the farthest left on your block toolbar. And you can also change between a calendar block and the archive block, and you can also transform to row variations in the group block. And then also the heading you could always transform to a paragraph, but one enhancement bug fix is that it now, when you transform it into a paragraph, it omits the anchor that was on that.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, I think that is an excellent direction. And I hope to see more of that, especially with the patterns I mentioned earlier, that just gives more capabilities and some contextual changes. So you can do whatever you want faster with less work and with more options. That&#8217;s so empowering for users.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. And one particular thing that I like is that it actually keeps the styles as much as possible. So if you had a background color that kind of comes with it or the type font or these kind of things, so you don&#8217;t have to restyle or remake those settings again, so it keeps all that. Oh, and I like that there&#8217;s also now a transformation from paragraph to code, which I could have used in a different post a long time ago. All right.&nbsp;</p>\n\n\n\n<p>So the next one of the enhancements is that the social icons, we talked about them before in the core, now have the ability that you can show and hide labels. Up until now it was only the icons from the social networks, when we all know a Twitter icon or Facebook icon, but not everybody knows how a GitHub icon looks or a Reddit icon looks, so you can add the labels to those icons and people are better informed where they&#8217;re heading out now.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: It&#8217;s always also great for accessibility to have those labels included. So I know that we had a lot of other changes in the past where we would complement the icon with the text to bring those improvements for people who have trouble with memorizing all the different icons, which is basically everyone, I guess, as the number of icons grows in the application.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah.</p>\n\n\n\n<p><em>Mary Job</em>: Yeah. I think it&#8217;s has, as Grzegorz said, it&#8217;s a good idea to be able to show an item label now because it&#8217;s true, not everybody knows what those icons look like. So it&#8217;s a great addition to the block, that we able to show an item label. Yeah.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Are there any social networks in Nigeria specifically, or in Africa, that are not kind of in the big realm of US?</p>\n\n\n\n<p><em>Mary Job</em>: There might be, there might be, but none that are particular familiar with. I&#8217;m pretty sure there are quite a number of social networking sites that have sprung up in the past few years, but maybe not as popular as the giants, the Facebook, but I think people are getting back because there was this discussion on LinkedIn that I saw earlier today, where it says that Facebook and Instagram trying to say they would pull out of the EU, is it? Yeah. And then the discussion was when are we getting to have home grown continental sites that we can depend upon because right now most our businesses have Facebook pages, Instagram pages, I think this is great. Things like this inspire people to come up with other solutions and if China was able to do it and I believe we should also be able to do it soon.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah, yeah, yeah. That&#8217;s kind of interesting what happens in the EU right now, because Facebook says they&#8217;re going to, if that particular legislation comes in, they threatened to pull out and two ministers in Germany said, &#8220;Well, okay, go ahead.&#8221;</p>\n\n\n\n<p><em>Mary Job</em>: Right?</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. So yeah, it&#8217;s sometimes interesting when you say ultimatums and then all of a sudden, somebody said, &#8220;Yeah, go ahead.&#8221; It&#8217;s not the threat that you think it is, but we digress a bit.&nbsp;</p>\n\n\n\n<p>So there&#8217;s one component update that I really like, just because it&#8217;s such a subtle change and that&#8217;s the update of the spinner design. Now you get a blue line that&#8217;s rotating and it&#8217;s just those small little visual clues are very important when you wonder what&#8217;s happening. Yeah. And it&#8217;s like, okay, so it&#8217;s loading. Of course, it&#8217;s not good when it&#8217;s not stopping loading, but that&#8217;s a different story.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Hopefully you won&#8217;t have to see that one. And just happens so fast that it never pops up.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. But I think with some dynamic blocks coming in, sometimes you have a little delay there.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Oh, there is also for the design tools, there is quite a change for the colors panel. So this one has grown because for some block you can change colors for the link, for the text, for the background, for the border, the list is sometimes quite long. And the change was to use the pattern that&#8217;s called tools panel. So this is the same concept that we previously had for spacing for phones and so on. And this allows you to narrow down what you see on the first load. So for instance, if you are not, if you don&#8217;t care about most of them, you can just remove them from the view and leave only those that you care about, but you always can unfold that and change other settings.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. And this PR specifically by Aaron, he also shows actually a table of the core blocks and their default settings for the colors. So you can see in one view, check, okay, columns have a default setting for text color, and background color, but you need to enable the link color setting for them or for the comment author name block, you get all three of them already in the color panel, because those are the defaults. Which makes sense because the author also has an author page, so you definitely want to have the link to it and you want to maybe change the color for it. So I really like that overview where you have in one view, can look at the settings and see what are the defaults that come with a core block editor.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. It&#8217;s sometimes gets tricky, especially when you see the table like that, because for instance, comment author avatar, which is only in an image, it obviously doesn&#8217;t have a text included. So this is why it doesn&#8217;t have styling for that.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Makes sense. Makes sense. But it has styling, default styling for the background. So yeah. Image doesn&#8217;t have any styling as default. So, all right. But it&#8217;s good to see the list and because there are some things you never remember and you need a place to look it up, unless you try it out and that saves you a lot of time. Okay. So the next enhancement is about the duo tone and it now allows users to specify custom filters. And there are a few examples in the PR by Ben Dwyer, handle and he shows, however, is from a theme that uses the customizer and has some presets there. But then this is pulled in into the duo tone filter in the background. So it&#8217;s definitely, and it seems to be coming to a WordPress install near you with 5.9. It&#8217;s one of the ones that I find out that it will come over. So in two weeks we probably can also go over the changes that came with 5.9 in two weeks. All right. What else?</p>\n\n\n\n<h3 id=\"new-apis\"><strong>New APIs</strong></h3>\n\n\n\n<p><em>Mary Job</em>: New APIs.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Hey.</p>\n\n\n\n<p><em>Mary Job</em>: So custom scripts was also introduced. Customs scripts allow templates to define additional scripts in package.json. This allows you to create block from livestream suggestion, that is a suggestion.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: So I think that was a suggestion that came in through a live stream from Ryan Welcher. He does Twitch live streams and uses the create block script quite a bit. He also has actually added two templates, if I&#8217;m not mistaken, to the script. But Grzegorz, what are the custom scripts about? What does it allow us to do?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: I was following this Twitch stream and I saw how Ryan was trying to use the creative block and creating a custom template so he could share the way he works with plugin. The one he was trying to build was a template for dynamic blocks. So dynamic, which means that it has PHP file, which allows you to provide the implementation that use some dynamic data that&#8217;s pulled from PHP and displayed on the front end. And this is not covered by the create block tool by default, so he wanted to like fill the gap. Which is amazing and he ran into the issue because he likes to experiment with things. And he wanted also to use a package called WordPress-env, which is an environment, like development environment that allows you to spin up quickly a version of WordPress that&#8217;s based on the bleeding edge, which is for WordPress develop.</p>\n\n\n\n<p>And you have the latest WordPress plus you can build on top of that. And he noticed that you cannot, like don&#8217;t have this comment for running this WPN. So he wanted to add that, but it wasn&#8217;t possible. Now thanks to this new feature that you can provide into the template config, you could add any comment you would like, like included some examples, other examples included is like, if you would like to run end to end script, you could just provide a comment for that using this thing. And in general, like Ryan, he&#8217;s doing so amazing job covering. Like a large variety of topics during his live stream. I&#8217;m a big fan. Whenever I have an occasion, I try to follow along and I think he will also have a session in the learning space on Meetup. And I don&#8217;t know, ability to remember the details about that. It&#8217;s planned. Let me check the calendar.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. He has a show. Hello Blocks! Coding a custom block. I think that&#8217;s the one that you&#8217;re referring to. It&#8217;s coming up actually on Monday.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yes. Exactly.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. So it&#8217;s a beginners kind of thing. And he also shared a documentation link. So you can go through it before you watch it or join it. It&#8217;s more like a social learning space. So there will be some demonstrations and some scripted things, but it mostly lives from the Q and A of the participants. And yeah, you&#8217;re right. Every week, Ryan is on Twitch at Thursdays, 10:30 Eastern, that&#8217;s 3:30 UTC. And he has a series on creating a pole block and also another series on creating a meme block. So he has some great problem that he solves there right in front of you. So sometimes he also, you find him detouring and that&#8217;s actually, you learn quite a lot about it. And because you then see what components are better for UI for that particular problem and why it&#8217;s not working.</p>\n\n\n\n<p>So he does a great job there, pulling it all together, and Twitch only saves them for two weeks, but he also has a YouTube channel where he uploads the final show there as well. And we will put this all in the show notes, of course, if you want to kind of follow him along. He also had a series with Diane Olsen on creating a block theme. And I think there were three sessions on Twitch and YouTube. So that&#8217;s also something for, if you&#8217;re not interested in building blocks, but you want to build a theme. There&#8217;s a lot for everyone on Ryan Welcher&#8217;s YouTube stream. That&#8217;s just a little detour here.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, it&#8217;s a long one. But I must admit that every time I see Ryan covering some code base that I worked on, it just triggers a lot of discussion between two of us. And we just sent a massive amount of pull requests that improve what he struggled with and really inspiring to see where people have some blocks and how to make that process more seamless. So that&#8217;s really nice.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah.</p>\n\n\n\n<p><em>Mary Job</em>: I better jump on that beginner&#8217;s class.</p>\n\n\n\n<h3 id=\"bug-fixes\"><strong>Bug Fixes</strong></h3>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, yeah, we all start from different areas. Okay. So next on our Changelog are bug fixes, and there were quite a lot and I haven&#8217;t even counted them, which is, normally I count the bug fixes but this time. So there were, the cover block had a bug that it was missing styles and they are now back. And then the gallery block, when you transform it to images, so single images instead of all in a gallery, the images would lose some of their settings, if not all of them. So that was kind of a bummer and that is fixed too, and some other gallery quirks there.</p>\n\n\n\n<p>Yeah. I think those are the ones that I wanted to point out. There were some fixes for accessibility, especially for the list view that was a bug fixed in two parts and the part two is now in. And then one of them was also the contrast checker because that was not tied into changing the link color and now it is.&nbsp;</p>\n\n\n\n<p>And the block manager is now announcing the search results. So that&#8217;s definitely for those who are traveling on a screen reader, an improvement, and the search results is for the block manager, when you go into the preference modal and then click on blocks, and then you can switch search for the blocks that you want to turn off. And the search results are now announced. That&#8217;s a big improvement on that modal. All right.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. I personally had some sort of HackaMol game with Windows operating system. So for the development tools and specifically for the build in WordPress script, there was something that didn&#8217;t work in a specific case and it was fixed twice because I fixed that. Then I did some other improvement and it was broken again. So big shout out for contributors, Tisuaki Hamano was one of them that fixed it for the first time and someone else helped this week. And especially Windows users, if you have any troubles with WordPress scripts, you can contact me directly on Twitter, on WordPress or GitHub, and I&#8217;m happy to solve all those issues between those. Because those platforms I develop on Mac OS, those platforms differ too much and it&#8217;s sometimes tricky to cover everything.</p>\n\n\n\n<h3 id=\"documentation\"><strong>Documentation</strong></h3>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: All right. Well, thank you for fixing the Windows bugs there. As I said before, there were quite a few new documentation things that are in this release, and one is the block support chapter was added to the block creation tool, and also for the dynamic blocks chapter for the great block tutorial. So that is kind of in the line of the changes that were done on that script scaffolding tool to create blocks. You can read up about it. And then Adam Selinsky has as a new data tutorial in the block editor handbook. It&#8217;s started, it&#8217;s not yet finished, but he started it, and it kind of how to use the block editor components and the data scripts or data handling functions in a WordPress admin screen. And he has a great tutorial and walks us through all the code for it, also with quite some theory attached to it. So it also helps you learning more about the concept of the block editor.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, it&#8217;s really interesting because before we had an excellent tutorial on how to build your own version of the block editor that was contributed by Dave Smith. And this one allows you to bring more interactivity by handling data, which is like doing REST API calls and stuff like that, and created your own stores to keep some in memory data, which is like, if you are into creating a separate screen in the WordPress admin, that&#8217;s something you should check yourself and see how that things can be done. It&#8217;s very complex, I must admit. But we know stories where people started with a simple block and now they&#8217;re creating new editors.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. And so it&#8217;s called create your first app with Gutenberg data, if you want to search for it. Of course, we have a link in the show notes for this one, because it&#8217;s a whole new tutorial about that.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. And I think related to that, there is also on GitHub, under WordPress, there is Gutenberg-examples repository, and it should also have the same tutorial ready, code that is ready. Like you can just install that as a plugin and play with that.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: I think that it&#8217;s also the first step of movement that I really would be looking forward, that to standardize UIs in WordPress from WordPress plugins and third party plugins, also on the admin. So users will recognize all the components and don&#8217;t have to relearn an interface with every plugin that they put in. And then there are, because it&#8217;s a moving target, there were also updates to the theme support documentation, for those who were still a little and it will be, so the docs clarify how to override the default presets in the changes introduced in WordPress 5.9. So there were in a dev note, but now this is also in the documentation.</p>\n\n\n\n<h3 id=\"code-quality\"><strong>Code Quality</strong></h3>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. And let&#8217;s move to the code quality section. And there are two important things that I wanted to highlight. First, if you are using WordPress 5.7, then the Gutenberg plugin won&#8217;t get any more updates because the minimum supportive version is now WordPress 5.8 and you should be on the latest and the greatest anyway. So if you didn&#8217;t, you should do it now. We will wait.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Upgrade to at least 5.8. Yeah. 5.8.3, it was a very stable version.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah, I expect that it won&#8217;t be an issue for anyone who tries to be up to date with the Gutenberg plugin. And the other thing is some APIs, JavaScript APIs that were introducing WordPress 5.4 and were replaced with other APIs later, were marked as duplicated. And I&#8217;m looking at the name and it&#8217;s better to check the PR that does that. There will be a dev note for sure, because it&#8217;s something that will impact WordPress 6.0. So for now, if you are using plugin, you will only see a notice when you open a browser console that this and that feature is deprecated and planted for removal in the far future.</p>\n\n\n\n<p>So there&#8217;s not nothing to worry about, but if you are a plugin developer, you should check whether your plugin uses those APIs. So I can just share something like get a reference by distinct edits, sounds like something that isn&#8217;t very popular, and that&#8217;s the idea behind that. If you know that those APIs aren&#8217;t used by plugins, that we want to remove them in the future so the bundles are smaller, so users don&#8217;t have to download so big amount of code in the browser.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, thank you. That&#8217;s a good shout out. And I already went to my notes that I already have on WordPress 6.0 to make a point that that definitely needs a dev note. And it&#8217;s already labeled as such in the GitHub repository, but I also want to check out how many plugins actually use those function calls and to make sure, so we can actually target some emails about that as well, or do some plugin.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. It&#8217;s difficult to tell because JavaScript code is often minimized when sent to the plugin directory. But with some things like the name I shared before, the long one, it&#8217;s something that needs to be preserved. So you can search for that for sure.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Right. Right. Yeah. Okay, yeah. And that seems to be all we have from the 12.6 release. Shout out to the first time contributors, Jeff Matson from Pagely and Angel Studio, that&#8217;s Marco and Lucio Janata who have merged PRs for this release. Thanks for contributing and being part of the WordPress community of contributors. All right.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: And the good news is that for the future releases, we also have a list of all contributors included in the release notes.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Yeah. Also thank you to Dave Smith, who has been working on that for a while and I saw the latest version and that looks good. This is also a longer process to streamline the contributors for a WordPress version. When you have hundreds of names that need to come in and need to be handled to make that a little bit more streamlined and not have so many manual jobs in getting the list ready. Which when you have humans involved, what you have is that people all missed out and that&#8217;s the worst scenario of all, then people contribute and then they&#8217;re left out of a release just because you don&#8217;t see it and you don&#8217;t know about it.</p>\n\n\n\n<h3 id=\"what-s-in-active-development-or-discussed\"><strong>What’s in Active Development or Discussed</strong></h3>\n\n\n\n<p>All right. We come to the section, what&#8217;s an active development and discussed, and I wanted to discuss on my list. I know that the Gutenberg team with quite a few people from the community are working on a style engine. That&#8217;s an overall architectural idea to streamline styling for themes and blocks and custom blocks and custom themes and all that. Do you have any more insight Grzegorz?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yes. So on that front, I think there are a few issues with the global style. So one of them that we have the same logic on PHP side and on JavaScript side. And this is the effort to unify that and provide one way for dealing with everything. There are a few challenges as well that were surfaced by the feedback chart from the community. So one of the examples with global styles was that there is now a dynamic class name included for containers. I think it&#8217;s for the group one. I don&#8217;t remember exactly, but the challenge here is that team authors often use class names generated for blocks when they have a certain aspect enabled. Like if you have a custom font size used with the block, this class that is generated for that use case allows people to provide some sort of customization through the CSS code.</p>\n\n\n\n<p>And when you have dynamic classes, it makes it harder. But the other way around, the in-line studs used with blocks that allows you to customize like font size or use a custom color, that makes it harder to override that if a team has some strong opinions. I&#8217;m not a designer, so not the best to explain, but people want to have better control over these things. And the current implementation has some drawbacks in that regard. Of course, like global styles, source tone of other issues for people, and in first in the first place allows so fine grained customizations that it&#8217;s great, but we need to find a good middle ground so all parties involved are happy about the solution that&#8217;s going to be improved. So I&#8217;m really looking forward for how this project evolves. And we definitely expect to hear more from the community and let&#8217;s see how that evolves.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. And I noticed from the feedback also that there are three things that are still not optimally working with the block themes. And one of them is that there is no style or a customization. You could always do it in CSS, of course, but for hover, focus and active styling. So if you hover over a button that&#8217;s the color change and all that, or if you have a menu item, can we show which menu item is the active page? That&#8217;s one thing. And there is a big push also for 6.0 to make blocks much, much more responsive. But if you don&#8217;t have an overall style engine, it&#8217;s going to be hard. So I think that needs to be in place.</p>\n\n\n\n<p>And then the theme also, the theme developers also surfaced one issue, was that you couldn&#8217;t have a full width, you needed to handle differently a block that had a line with full width from the blocks that needed orders around it are pushed in from the sides. So it&#8217;s kind of, if you have that, you couldn&#8217;t have a wide one and if you have a wide one, you couldn&#8217;t, the text would kind of go directly to the left corner or right corner, depending how you read it, of the browser window. So there are certain things that are still not working and there are the teams and community, they are trying to figure out what&#8217;s the best approach for that. And we will share in the show notes the original discussion post by Riad Benguella then also Andrew put a tracking issue together on what needs to happen to have this every little edge case as well, and as a tracking issue. And then the last one that I have is the first PR that Andrew put in. So you can also test things out.&nbsp;</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Yeah. It should already be in the development branch. So expect that to see in the next Gutenberg plugin 12.7.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Okay. Yeah. Thank you. Yeah. And then you also had pointed out a GitHub discussion to me to continue the discussion that we started on Gutenberg clients, but it actually started much earlier about the duplication of code if you wanted to do a JavaScript edit, and then have a PHP rendering, or also create blocks that can be accessed through PHP or JavaScript, but you don&#8217;t have to duplicate them for either environment. So what&#8217;s the discussion here?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: So yeah, that discussion started on Twitter, by Mark Jaquith, and if you are interested in how the block could be developed in the future, you definitely should check the Q and A that Birgit had on Gutenberg Times, which covers that in depth. However, this proposal is this discussion is started by Mihou Chapniski, and he also adds another bit to that, which is, it&#8217;s a very techy name, block hydration, but the idea is that it&#8217;s not only the part that you render on the front end, but also how does a block become interactive. So for instance, if you let&#8217;s say, if you have a post list and you have pagination, so how you could make those block behave, that you click page two, and instead of refreshing the whole page, you could just replace the part inside and just bring another page, it&#8217;s sort of like in many teams, the infinite scrolling works.</p>\n\n\n\n<p>Like you have this load more, like when you scroll it loads more posts and more. Like this kind of behavior just to have back into the blocks. And that&#8217;s just really insightful, so Mihou he collected all the discussions, all the links, all the prototype that has been done before, also he included his own ideas and his own prototype, which is JavaScript based. The first one from Mark Jaquith was PHP based. So it&#8217;s really interesting to see how different community members approach the same problem and how they are trying to improve the experience. And it&#8217;s something that definitely the Gutenberg core team is actively looking into and we are collecting feedback. So if you have some thoughts on this topic, now this place is the best way to share your feedback, we will call like that. And maybe in a few months we will have something that could be tested in the plugin. Maybe it requires more time, but it&#8217;s very interesting that we continue the discussion.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Excellent. Yeah. And I didn&#8217;t get a chance yet to read it, but it&#8217;s very well structured and the post by Michael and also has many, many links in there to previous discussions. So it&#8217;s a really well rounded post on the GitHub Gutenberg repository in under discussion. And of course we even also that, we will show in the show notes.&nbsp;</p>\n\n\n\n<p>So, wow. That brings us to the end of our Gutenberg Changelog episode 61. How is everyone, how are you doing Mary?</p>\n\n\n\n<p><em>Mary Job</em>: I&#8217;m doing very good. I&#8217;m doing very good. I think this is going to be an interesting journey for me because, so let me tell you small story about the first time I came across a Changelog. You know when there&#8217;s a new release where you plug in the team, there&#8217;s usually a Changelog. The first time I was looking at it and I was like, okay, so what am I looking at? It took me a while to figure, oh, this is an enhancement feature, new features. So this feels like this is, I&#8217;m feeling I&#8217;m experiencing that same feeling all over again. I mean, now when I see it change I know exactly what I&#8217;m reading and I know what it all contains, so this is exciting.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yes.</p>\n\n\n\n<p><em>Mary Job</em>: I&#8217;m looking forward to this job.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Yeah. Me, too. Me, too. Yeah. So Grzegorz, you said that you have your time and you changed teams and on Automattic. So what are you concentrating on now that keeps you away from us?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Oh, so actually I was on the rotation with the front TT team, which is like the team that was created after acquisition of the front TT company, which was focused on the frontend experience and they build their own framework. And now they&#8217;re trying to bring some aspect of that directly to WordPress core, which is super exciting. And now I&#8217;m back with my old team, the one that was involved in Gutenberg 5.0, which created so much distraction in the community. And yeah, so these days we focus on bringing features for WordPress 6.0 from the roadmap that Matias shared in the previous episode, and as usual helping with dev tools and improving the developer experience of everyone in the project. It&#8217;s like I wear different hats, it depends on the day.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Well, we&#8217;re so happy that you were on the podcast for so long and enriched our technical understanding for things so well, and I&#8217;m looking forward to have the next episode, episode 62 with Mary Job. And this comes to an end now. Grzegorz, how can people reach you when you&#8217;re not on Gutenberg times anymore?</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Oh, so I can be reached always on WordPress, Slack and on GitHub and on Twitter under G-Z-I-O-L-O handle that&#8217;s the best way.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Excellent. And Mary, when you are not on the Changelog, how can people reach you?</p>\n\n\n\n<p><em>Mary Job</em>: On Twitter too, Maryojob.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Okay. Maryojob. All right. So as always, no, I have one thing before we end this, we have the new Gutenberg developer hours. And first one was on February 8th and was a great success, I think almost 90% thought it was excellent. The questions that we had, though there were two things that were not so good. One is we didn&#8217;t have a recording, that was by designed, but people changed my mind and we will have all the other ones will be recorded. And the second one was my Zoom account didn&#8217;t have live captions enabled, so it was a little hard for people harder hearing to follow along. So those two things are rectified and we have the next event is on February 22nd. That&#8217;s coming Tuesday. If you listen to that over the weekend, you can register, for those who listen to this later, we have another event on March 8th and on March 22nd.</p>\n\n\n\n<p>And there will be announced on the WordPress social learning, Meetup space and of course, link in the show notes. And if you join that, you will actually be notified not only about the developer hours specifically, but also about the other social learning events, like the Hello Block ones or about zero to hero events on building a theme or any of the others discussions. So the social learning space is really very, very active in having additional events there.&nbsp;</p>\n\n\n\n<p>All right, as always, the show notes will be published on Gutenbergtimes.com/podcast. This is episode 61. And if you have questions or suggestions or news you want us to include, send them to <a href=\"mailto:changelog@gutenbergtimes.com\">changelog@gutenbergtimes.com</a>. That&#8217;s an email address, yes. <a href=\"mailto:Changelog@gutenbergtimes.com\">Changelog@gutenbergtimes.com</a>. And thank you so much, Greg, for all the time that we had together here. Thank you Mary, for being here today and for the next adventure together on the Gutenberg Changelog. And thank you all for listening and I wish you all goodbye.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Thank you, Birgit, and thank you all listeners for all the exciting episodes we survived together. It was a great pleasure.</p>\n\n\n\n<p><em>Mary Job</em>: Thank you, Birgit. I look forward to spending more time in this podcast.</p>\n\n\n\n<p><em>Birgit Pauli-Haack</em>: Okay. Excellent. So let&#8217;s get out of here. Bye-bye.</p>\n\n\n\n<p><em>Grzegorz Ziolkowski</em>: Bye.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 16:49:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Gutenberg Changelog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"WordCamp Central: WordPress.com joins the WordPress global community sponsorship program in 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://central.wordcamp.org/?p=3146025\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"https://central.wordcamp.org/news/2022/02/23/wordpress-com-joins-the-wordpress-global-community-sponsorship-program-in-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2066:\"<p><span>We couldn’t be happier to welcome </span><strong><span><a href=\"https://wordpress.com/\">WordPress.com</a></span></strong><span> to the </span><strong><span><a href=\"https://central.wordcamp.org/sponsor-multiple-wordcamps/\">WordPress global community sponsorship program</a></span></strong><span> in 2022! They’re sponsoring at the Gold level supporting official WordPress community events across the globe.</span></p>\n<p><a href=\"https://central.wordcamp.org/files/2022/02/WordCamp-Logo-1-1-1.png\"><img /></a></p>\n<p><span><strong><span><a href=\"https://wordpress.com/\">WordPress.com</a></span></strong> offers managed hosting – a service that is 100% dedicated to hosting WordPress open source software for optimized performance. Managed hosting is a great option for people who don&#8217;t want to deal with the backend technical operations of running a website. You get all the power of WordPress, professionally managed and hassle-free, including: </span></p>\n<ul>\n<li><span>Speed: WordPress.com earned Top Tier status in the WordPress Hosting Performance Benchmarks review with perfect 100% uptime on both monitors, zero errors across both load tests, and the fastest WP bench of any company in any price tier this year.</span></li>\n<li><span>Powerful, built-in SEO: All of our themes are optimized for search engines, which means they are designed to make it easy for the Googlebot (and other search engines) to crawl through them and index your content. </span></li>\n<li><span>Ironclad security: Our systems and security teams are vigilant about protecting your site and personal data. That&#8217;s why we&#8217;re trusted by some of the most high-profile sites on the web.</span></li>\n<li><span>Hands-on support: Get world-class dedicated support from our happiness engineers, educational courses, and webinars. </span></li>\n<li><span>Peace of mind: We make it easy to get started and maintain your site with automatic version updates and real-time silent backups, so you&#8217;ll never worry about losing your site content. </span></li>\n</ul>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 16:00:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Isotta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: #15 – Morten Rand-Hendriksen on Governing Open Source Projects\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wptavern.com/?post_type=podcast&p=130069\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://wptavern.com/podcast/15-morten-rand-hendriksen-on-governing-open-source-projects\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:65807:\"<p>On the podcast today we have <a href=\"https://twitter.com/mor10\">Morten Rand-Hendriksen</a>.</p>\n\n\n\n<p>Morten has a long history of working with WordPress, but that’s not the main focus of the podcast today. Today we talk about the way that open source as a whole is governed and managed, and his thoughts on the changes he thinks are needed.</p>\n\n\n\n<p>When open source software came into the world, the landscape was very different. Back then, there was no real clarity about whether the proprietary or open source software model would dominate. There was no indication that the internet would become such a crucial part of how we communicate, interact and shop.</p>\n\n\n\n<p>People gave their time because they enjoyed what they were doing and had high hopes about the world that they could build with their software.</p>\n\n\n\n<p>Fast forward to today and many open source projects are critical to the functioning of the internet. A small collection of people, sometimes an individual, might be in charge of a component which, were it to fail, would bring the web to a halt.</p>\n\n\n\n<p><a href=\"https://openssf.org/blog/2022/01/13/the-openssf-and-the-linux-foundation-address-software-supply-chain-security-challenges-at-white-house-summit/\">Recent episodes</a> have shown us that given this reliance on the contributions of open source community members, it’s important that we can turn to them for patches and updates when they’re needed. But that might not be the case. The contributors might be busy with other projects, or otherwise unable to fix problems that arise.</p>\n\n\n\n<p>Morten thinks that there’s a need to revisit the governance model for open source given that we now live in a world where important parts of the internet rely on the work of such volunteers. He wants there to be systems by which contributors are remunerated for their contributions.</p>\n\n\n\n<p>He also wants to shine a light on who is able to contribute to open source projects, and so we discuss his thoughts on who in reality has the time, interest and resources to contribute. His opinion is that open source might not be as open to everyone as it would seem.</p>\n\n\n\n<p>It’s a fascinating conversation and will no doubt stir up some discussion.</p>\n\n\n\n<h2 id=\"useful-links\">Useful links.</h2>\n\n\n\n<p><a href=\"https://mor10.com/open-source-considered-harmful/\">Open Source Considered Harmful</a></p>\n\n\n\n<p><a href=\"https://mor10.com/a-fatal-flaw-in-the-bazaars-foundations/\">A Fatal Flaw in the Bazaar’s Foundations</a></p>\n\n\n\nTranscript<div>\n<p>[00:00:00] <strong>Nathan Wrigley:</strong> Welcome to the Jukebox podcast from WP Tavern. My name is Nathan Wrigley. Jukebox is a podcast which is dedicated to all things WordPress. The people, the events, the plugins, the blocks, the themes, and in this case, the nature of open source. Before we begin, I would encourage you to subscribe to the podcast so you can get all the episodes automatically each and every week. You can do that by searching for WP Tavern in the podcast player of your choice. Or by going to WP Tavern dot com forward slash feed forward slash podcast. And you can copy and paste that URL into most podcast players.</p>\n\n\n\n<p>I&#8217;d really like to hear from anyone out there who would like to come onto the podcast and talk about whatever it is that you do with WordPress. It might be that you&#8217;re a designer, a WordCamp organizer, contributor, honestly if it&#8217;s about WordPress I would love to hear from you. And hopefully get you onto the show. To do that. I head over to WP Tavern dot com forward slash contact forward slash jutebox, and use the contact form there.</p>\n\n\n\n<p>So on the podcast today, we have Morten Rand-Hendriksen. Morton has a long history of working with WordPress, but that&#8217;s not the main focus of the podcast today. Today, we talk about the way that open source, as a whole, is governed and managed, and his thoughts on the changes that he thinks are needed.</p>\n\n\n\n<p>When open source software came into the world, the landscape was very different. Back then there was no real clarity about whether the proprietary or open source software model would dominate. There was no indication that the internet would become such a crucial part of how we communicate, interact and shop.</p>\n\n\n\n<p>People gave their time because they enjoyed what they were doing and had high hopes about the world that they could build with their software. Fast forward to today, and many open source projects are critical to the functioning of the internet.</p>\n\n\n\n<p>A small collection of people, sometimes an individual, might be in charge of a component which, were it to fail, would bring the internet to a halt. Recent episodes have shown us that given this reliance on the contributions of open source community members, it&#8217;s important that we can turn to them for patches and updates when they&#8217;re needed. But that might not be the case. The contributors might be busy with other projects, or otherwise unable to fix problems which arise.</p>\n\n\n\n<p>Morton thinks that there&#8217;s a need to revisit the governance model for open source, given that we now live in a world where important parts of the internet rely on the work of such volunteers. He wants there to be a system by which contributors are remunerated for their contributions. He also wants to shine a light on who is able to contribute to open source projects.</p>\n\n\n\n<p>And so we discuss his thoughts on who, in reality, has the time, interest and resources to contribute. His opinion is that open source might not be as open to everyone as it would seem. It&#8217;s a fascinating conversation and will no doubt stir up some discussion.</p>\n\n\n\n<p>If you&#8217;re interested in finding out more, you can find all the links in the show notes over at wp tavern dot com forward slash podcast, and look for episode 15. And so, without further delay, I bring you Morten Rand-Hendrickson. I am joined on the podcast today by Morten&nbsp;Rand-Hendriksen. Hello Morten.</p>\n\n\n\n<p>[00:03:57] <strong>Morten Rand-Hendriksen:</strong> Hello.</p>\n\n\n\n<p>[00:03:59] <strong>Nathan Wrigley:</strong> We are today going to have a fairly interesting in-depth conversation, despite the fact that we are on the WP Tavern Jukebox podcast, today, we are probably going to stay well away from WordPress itself because we&#8217;re going to have a conversation about the open source model in general, obviously that could imply WordPress, but equally it could imply lots and lots of other things out on the internet because Morten has recently produced a couple of pieces.</p>\n\n\n\n<p>I&#8217;m going to link to them in the show notes. It may well be useful to go and read them to provide context for this episode. The first one is at Morten&#8217;s website. It&#8217;s mor10. So. that&#8217;s Mor and then the digits one zero dot com. That&#8217;s a brilliant URL by the way.</p>\n\n\n\n<p>[00:04:42] <strong>Morten Rand-Hendriksen:</strong> I wish I came up with it.</p>\n\n\n\n<p>[00:04:45] <strong>Nathan Wrigley:</strong> It&#8217;s really good. Open source considered harmful is the title of the first one, and then there&#8217;s a sort of followup piece, a fatal flaw in the bazaar&#8217;s foundation. So it might be worth going to provide some context there. Do you want to just drop in what it was that you were vaguely trying to sum up, and then I will steer the conversation a little bit later. You&#8217;ve got some issues the way that certain things are handled on the internet, particularly open source software and the way that they&#8217;re managed, and so on. just sum up what your concerns are.</p>\n\n\n\n<p>[00:05:15] <strong>Morten Rand-Hendriksen:</strong> Yeah, I can explain the two articles in hopefully a short amount of time. So the first one, this one that&#8217;s called open source is considered harmful. There&#8217;s this trope in tech writing, the considered harmful trope, that you say at something you don&#8217;t like is considered harmful. In this case, it&#8217;s actually open source is literally considered harmful by people.</p>\n\n\n\n<p>It was in relation to these major security issues that occurred right before Christmas. Log4j that was anything that runs any kind of Apache server had this major security flaw in it.</p>\n\n\n\n<p>And when the security flaw was discovered, it was also discovered that because it&#8217;s an open source project and there is no, there are maintainers, but the maintainers are volunteers who&#8217;ve worked for other corporations. There&#8217;s no immediate path for the people who discover these flaws to go and say, hey, get this fixed right now, this is mission critical. In the case of Log4j it exposed government state operatives, government institutions, hospitals, very critical infrastructure, as well as companies all over the world. And it exposed this underlying issue with open source, which is that. If something goes wrong, you rely on the open source community to fix it. And that&#8217;s fine, except if something goes wrong and you can&#8217;t talk about it and you need to be able to go to a person and say, you go fix it right now, or a company or an organization to go, you go fix it right now before we tell anyone. It&#8217;s not that easy.</p>\n\n\n\n<p>So in response to that, the Biden administration or the White House as the president is referred to reached out to the community to call them in and say, come have a meeting with us and let&#8217;s figure out how to deal with this moving forward so that we can patch all the security holes in open source software.</p>\n\n\n\n<p>They reached out to industry executives in large companies. And those companies are companies that are invested in open source, and asked them what to do. And you wonder when you hear that, they published a list of people who were invited to the meeting, and yes, the Apache foundation was invited, but there was also a glaring lack of other open source projects that have similar problems. And you wonder, why is it that when the White House goes out and says, we&#8217;re going to talk to the open source leaders, they don&#8217;t talk to the open source leaders. And the simple answer is no one speaks for open source. Because open source as a whole, doesn&#8217;t have a special interest organization. Doesn&#8217;t have any policies, doesn&#8217;t have any representation anywhere, and there is no place you can go and say, hey, I want to speak to open source. Or even something smaller. Hey, I want to speak to web based open source. Because the open source community as a whole has no governance structure, has no meaningful way of appointing someone to do so. Even if there was a person appointed to speak on behalf of open source, there is no policy or any kind of framework to speak from.</p>\n\n\n\n<p>So you wouldn&#8217;t be speaking on behalf of open source who would be speaking either on behalf of yourself, or you&#8217;d be speaking on behalf of your employer. Or the interests of your particular project as you&#8217;ve defined them. Because again, these projects don&#8217;t have any policies. And that was even acknowledged in this meeting, both in the invite to the meeting, and afterwards, that one of the big problems with open source, as seen from like a leadership perspective, a corporate perspective, a government perspective, is there&#8217;s no policies in place because there&#8217;s no one held responsible for anything. Because there&#8217;s no cohesive leadership, there also no accountability within the system. And that is untenable when the software in play is mission-critical to, let&#8217;s say a country, the operation of a country. So when I say open source considered harmful, I mean, people are starting to look at open source and saying, this is actually dangerous because when something goes wrong, we have no guarantees that it can be fixed. And we have no clear path to go to someone and say, even though you think this is okay, it&#8217;s actually not okay. And here are the reasons why you need to patch it or patch it in a specific way. And when you hear me talk about this, you&#8217;ll also notice that a lot of these things I&#8217;m saying, they sound like the opposite of what we want in open source. Like this idea that a government can come to you and say, you need to fix this in a certain way, sounds like something that open source would be against. And it is something that a lot of open source people would be against. However, open source operates in the real world and in the real world, sometimes that is a necessary thing.</p>\n\n\n\n<p>And in those circumstances, if the open source community itself can&#8217;t deal with it, the government or whatever entity needs to get something fixed will go through a corporate interest that is embedded enough of an open source community and has enough power in that community to just strong hand their way in and get it fixed in a way that works for them, which runs against the nature of open source again.</p>\n\n\n\n<p>So it just begs the question, if we won the war, which we did against proprietary software, shouldn&#8217;t we now have to hold ourselves to the same standard that we hold proprietary software to? You can&#8217;t play this game of, ah, we&#8217;re just playing around if you control the internet. And that&#8217;s what&#8217;s happening right now.</p>\n\n\n\n<p>So that was like the first article. The second article is just about how, the reason for this is that of open source, the GNU manifesto, or the GNU manifesto or whatever you want to call it, and The Cathedral and the Bazaar, are both these utopian fever dreams of how the world would be if we had open source and open source won the battle.</p>\n\n\n\n<p>what we know for a fact now is that those fever dreams did not come to pass. In many ways, what we ended up with is completely opposite of what they envisioned yet. Our ideology as open source people, still rests on these fever dreams and that just doesn&#8217;t fly anymore.</p>\n\n\n\n<p>[00:10:52] <strong>Nathan Wrigley:</strong> So we&#8217;ve broadly outlined the articles and therefore we&#8217;ve outlined hopefully the course of the discussion over the next few minutes. I&#8217;m interested though to hear more about you personally, just for a couple of minutes, interested to let the audience know it is that you&#8217;re interested in this. Your history. How it is that you&#8217;ve this that, it&#8217;s obviously very important to you. Why are you concerned about these things? What in your background has led you to put this at critical importance?</p>\n\n\n\n<p>[00:11:19] <strong>Morten Rand-Hendriksen:</strong> I&#8217;ve been an open source contributor for 15, 16 years. I fell into open source, like most people did in the beginning of the modern web, which was, I was building solutions, web solutions for people, for companies, for clients. And I needed to find functional solutions for them, where they could do what they needed to do without either tying themselves to onerous licensing agreements with companies, or use applications that put them at risk of breaking things.</p>\n\n\n\n<p>And what I discovered was the open source community was building tools for users. Whereas big corporations were building tools primarily for developers. Or they were building tools primarily to lock users into specific platforms. And it&#8217;s something that appeals to me. I&#8217;m a socialist. I think this idea of people having self determination and self control of their assets and that there&#8217;s fairness in the system., that power is distributed. I believe in all those things. And it looked to me like open source was embracing those ideals. And open source is embracing those ideals to a degree, which we&#8217;ll, I&#8217;m sure we&#8217;ll talk about later. So I started using open source software. Quickly realized that if you use open source software and you can contribute to open source software, you really should contribute to open source software.</p>\n\n\n\n<p>I started contributing, with code fixes and templates, and just things to support the community and answering questions. Being a productive community member, right. And helping other people onboard into it.</p>\n\n\n\n<p>After awhile, I realized there were challenges within the community that needed to be dealt with. And I tried to help with that. In some cases, those challenges were on a structural basis in terms of how do you manage a project? How do you manage volunteers and direct volunteers towards specific things to get done? How do you solve a very difficult problem, which is there&#8217;s this shiny new thing that people want to work on, but then there&#8217;s this maintenance thing that was just really boring, that&#8217;s very important that gets fixed, when no one is in control over who does what. And when I started looking at that, I quickly realized that there&#8217;s this glaring problem in open source thinking, which is that, if there&#8217;s a problem someone will always find it interesting enough to fix. That turned out to not be the case, that you would see. There might be like one or two people that were interested in fixing a big problem, but for the most case, the big problems were just shoved to the side and then new things were invented. And then eventually those problems became legacy features. And it started really bothering me. Because what I would see is, occasionally open source projects would either omit something, or do something in an incorrect way based on a standard, like they would implement a standard incorrectly. Or they would make an omission in the application, that would then years later, either influence how people outside the open source community were using it, or implement things, or even make a standard that was incorrect, or alter the standard. Or they would introduce a problem that would later become a problem for some users. Let&#8217;s say an accessibility, a lack of accessibility features would bubble to the surface later as the software became more popular.</p>\n\n\n\n<p>And we&#8217;re not going to talk specifically about WordPress here, but, you could look at WordPress as an example of an open source project, and you could say for example, the async and defer feature in JavaScript has been around for, nine years, ten years, eleven years, something like that in browsers. WordPress still has no support for it. And when you look at the ticket for it, the first ticket was filed eight or nine or ten years ago, and it&#8217;s still under debate.</p>\n\n\n\n<p>And the debate around the ticket is still around this, how is this going to be used? And it&#8217;s very weird, the web as a whole has implemented this as a standard. So there&#8217;s no question about how to use it. You&#8217;re talking about implementation internally in the application. That is a problem to be solved separately from whether or not you included in the application as a whole, but because it&#8217;s not being included, the developers who build a WordPress application can&#8217;t use these web standard features that have been around for almost a decade because the application itself isn&#8217;t able to make a decision around this issue, and separate adding a feature or supporting a feature from how would that feature be used internally in the application itself.</p>\n\n\n\n<p>And that&#8217;s harmful to the web, because when WordPress takes 40% of the web or 45% or whatever it is now, and 45% of the web is not implementing a web standards feature in a proper way, it means that the majority of the sites on the web are not using this feature.</p>\n\n\n\n<p>And you can see this in other open source projects too, that you get these sticking points, where lack of decision-making power leads to things not being done properly. And then eventually it becomes a standard within the community to do things the old way, or an incorrect way. And then that standard starts leaching out into the wider community, and disturbs how the web evolves, and stands in the way of certain things taking place, and prevents the platform from moving forward.</p>\n\n\n\n<p>And then, you get this very interesting situation where a corporation with a vested interest in moving the web in a specific direction, say for example, Google sees, hey, we can inject developers into this project, and then get them to implement certain features in a certain way. And then we can help move the web forward in the direction we prefer via the software.</p>\n\n\n\n<p>And that happened with responsive images. So when responsive images was first implemented on the web, there were actually two separate standards. You had the RICG standard, which is what we have now, and then you had like a slightly different version of it that approached responsive images in a slightly different way.</p>\n\n\n\n<p>And then some people who are very pro one side, started to embed themselves in various open source projects to get the open source projects to implement responsive images in that way. And one of those projects was WordPress, and then suddenly, all of WordPress sites were shipping responsive images in a specific implementation. And then that just became the standard.</p>\n\n\n\n<p>And Google has done the same thing. They&#8217;ve said there are certain features that we want on the web, the best way to move that forward is to implement them into CMS&#8217;s. Because CMS&#8217;s then automatically distribute this feature in a specific way across all of their implementations. And that just bumps up the frequency of use. And unless the people in the project are super conscious of what the politics are around those features, and understand what is going on, like, understand whether this feature implementation that&#8217;s being proposed by corporation is actually what is going to be proposed by the standards body, or if this is the corporation&#8217;s interpretation of it. There&#8217;s a lot of politics involved in this. Without acute awareness of this, to the point of almost being in the room, it&#8217;s very hard for a project to make those decisions. And in reality, what happens more often, is that the corporation will come in and say, hey, we have a solution for you to a problem. And then they will implement it and be like, oh yeah, by the way, that also included this thing that we had just decided that we were going to, like, the direction we were going to steer the web in.</p>\n\n\n\n<p>So looking at this, it became very clear to me that there are some very serious problems in terms of how open source projects are governed. And also how open source projects see themselves when it comes to their role on the wider web. Which is, if you win the war of of what type of software runs on the web, which open source did in that said open source is better than proprietary software, we should have open standards. of which are great things. But if you do that you take over control effectively of how the web operates, then you also have to take the responsibility that comes along with that. And that means about your decision-making, not just in terms of how it impacts your particular application, or how it impacts your particular users, but how it impacts the web as a whole.</p>\n\n\n\n<p>also take on the responsibility of speaking on behalf of the web and establishing standards for what we want the web to look like, how we want it to function, or even something as basic as saying, what are the necessary conditions for this way of thinking to persist, in relation to regulations and policies and international politics. None of which is being done because open source developers, by and large, still consider themselves just volunteers who are playing around with software that they have value from. So there&#8217;s a disconnect there, and that&#8217;s how I got involved in this whole nebulous problem of open source governance as a whole.</p>\n\n\n\n<p>[00:19:46] <strong>Nathan Wrigley:</strong> Let&#8217;s rewind, because I think maybe there&#8217;s people who are listening to this podcast who don&#8217;t have any They&#8217;ve not bothered to look into how the open source movement began. And were at pains in your piece to spell that out, or at least in part. You wanted to illustrate how dream of being able to contribute, having software which was freely available, free to modify, and so on. The underpinnings of what is now open source, which as you say, has taken on the role of the dominant software on the internet. But, I think it&#8217;s important to go back and without judging, because when it was happening, obviously there were different constraints and different thoughts.</p>\n\n\n\n<p>And perhaps there was no intention that the web would be sitting in everybody&#8217;s back pocket and everybody would be consuming it twenty-four seven. And, at the time it was just something which would sit on a handful of computers and there was no thought. So we&#8217;re not, trying to rewrite history. We&#8217;re just trying to look back and see what happened. Do you want to just describe those underpinnings of how open source began back in the, I&#8217;m going to say eighties?</p>\n\n\n\n<p>[00:20:47] <strong>Morten Rand-Hendriksen:</strong> The open source way of thinking, as far as I understand it, actually predates open source software. The anecdotal piece that I&#8217;ve seen is that it started with an engineer who wanted to repair a copy machine, and realized that although he knew what part to fix, there was a screw, disassemble it, replace a screw with a new screw.</p>\n\n\n\n<p>And he discovered that there was no way for him to do that without breaking the warranty on the machine. So effectively saying, if I do this, I am in breach of the use agreement of the thing that I own. Which makes no sense, like why on earth should I not be allowed to repair my own things, when I paid for them.</p>\n\n\n\n<p>And anyone who has a cell phone knows this, right? If you open the phone and you&#8217;ll see their stickers inside that say, if you breach this sticker, you&#8217;ve breached a warranty. Which is a bizarre thing. If you think about it, but this is mine. Why on earth would working on my own thing somehow invalidate the value of the thing, right? It&#8217;s very strange.</p>\n\n\n\n<p>So there was the thinking around this open standards thing where people should be allowed to understand how their own things work and be able to repair their own things. It comes from that. But if you make it that broad, you&#8217;re gonna think that that&#8217;s not something that was invented in the eighties. That was probably something that was invented around year minus 3000. The second people started making things, they would also start thinking, this is mine, this rock that I made that has a chink in it. This is mine. And I should be able to modify this to make it work the way I want it to.</p>\n\n\n\n<p>And it&#8217;s only in this modern capitalist world where we have this idea that, oh no, the thing you own is also governed by a corporation who made it and you can&#8217;t make a copy of it and you can&#8217;t. So there&#8217;s a whole thing around there. So in this environment where everything was made by corporations and everything was heavily controlled in terms of what you can do with it, how you can modify it, whether or not you can repair it, who can repair it, et cetera, et cetera, et cetera.</p>\n\n\n\n<p>There was a pushback to people saying, actually, no. I want to be able to make things and then give it to other people and then allow them to do whatever they want with it. And from there came this notion of a new license for software development that explicitly gives the user control over the thing that they pick up.</p>\n\n\n\n<p>So when you develop something, you give it to a person and then you say to that person, okay, you can do whatever you want with this. You can use it as this. You can modify it if you want to. You can redistribute it, give it to your friends. You can redistribute your modifications of it. And you can allow your friends to make modifications and redistribute them.</p>\n\n\n\n<p>And the only requirement I have is that you extend this license to anyone you give the software to. And this is the root of what we call copy left licenses. So instead of copy right, you have copy left. You pass the license onto the next person. And this was manifested in the GNU manifesto, The GNU, GNU, new manifesto that was written by Richard Stallman. It&#8217;s a screed, it&#8217;s a political manifesto in a very real sense. And I encourage anyone who works in open source to read it, maybe many times, and discuss it with each other. Because it is truly a remarkable piece of fictional writing. Embedded within it are all of these ideas, including everything I described. So the four freedoms or the five freedoms of open source.</p>\n\n\n\n<p>The rationale for why we should have free open source software. And why there can still be an economy, even though you have free open source software. You&#8217;re giving away something for free, how do you make money? Why that is a good thing. All of that is described in the document. And it also introduces interesting things like, here are a bunch of different ways you can earn money from it. You can teach or maintain. You can run groups and have people pay dues for those groups. You can introduce a software tax where corporations who use your software have to pay a tax in, and then the money is then paid back into the community. All of those things are contained within the GNU manifesto. Along with very utopian ideas about how, in the future, where open source software will rule the world, no one will need to work because software will do everything for us. So basically you just spend all your time doing whatever you want. And because software developers love writing software, they will continue maintaining it just because it&#8217;s interesting to them. And no one will need to get paid because payment will be automatic. There&#8217;s a picture of a future that will never exist, that is underpinning this whole ideology. So there&#8217;s this document, the GNU manifesto, which is the origin of the GNU, GPL license, which is what most free open source software is published under.</p>\n\n\n\n<p>There&#8217;s also a book called The Cathedral and the Bazaar that was written by Eric S Raymond which is seen as the Bible of open source, or one of the canonical texts of open source that defines the economics of open source. And again, this was written around the same time or a little bit later, it was like 10 years later from the GNU manifesto. In The Cathedral and the Bazaar, Raymond outlines his own project and how he took something that was proprietary and turned it into, or an idea that only was covered by it, proprietary software made an open source type of software that did the same thing, and all the reasons why this is a good thing. And it really outlines this whole idea that if you make something other people will contribute to it because they see value in it.</p>\n\n\n\n<p>And then over time, developers from different spaces will gravitate towards it. So by the time you need security developers, a security developer will find interest in the project, contribute to the project to help you with security. When you need a designer, a designer will gravitate towards the project, and it will build on its own.</p>\n\n\n\n<p>And when you look at open source project in general, you can see that successful open source projects do follow this model, where someone says, hey, I want to build this thing. And then they distributed on the web. And then other people say that&#8217;s cool, but it&#8217;s lacking X. And then they say, hey, I can contribute X. And then someone else says, oh, I can contribute Y, and then over time you grow a community of like-minded people who want to see the things succeed because it&#8217;s useful to them. It keeps growing and attracting more and more people. So that&#8217;s the source of this whole thinking, that if we put something into the world that is valuable to the people, other people will come in and start using it.</p>\n\n\n\n<p>And we&#8217;ll also contribute back to it. Which is very much in honesty, a socialist way of thinking, right? From each according to his ability to each according to his needs. It&#8217;s core sociology. This idea that, you make a thing that&#8217;s valuable, you put it into the world. Other people use it, and if they can, they will contribute to it.</p>\n\n\n\n<p>But contribution should not be requirement for using it. And that part of open source is what has made open source what it is today. But when we talk about socialism, then a bunch of people are going to be like well, you know, that&#8217;s been proven to not work. See Soviet Russia, China, whatever.</p>\n\n\n\n<p>And I always have to point out there is the fundamental difference between the socialist idea of everyone using a thing in a way that&#8217;s meaningful to them, and then contributing back what they can. To the communist Soviet way of thinking, which is from each according to his ability to each according to his work, or labor investment. You see that change at the end there? From needs to work? what you get back from the system is contingent on what you provide.</p>\n\n\n\n<p>And what we&#8217;ve seen over time in source is a gradual shift power from the needs to the work part. That the people who make decisions within open source projects are the people who do the work. The classic term is decisions are made by the people who show up. Which is the same as saying, if you have the benefit of being able to contribute, automatically also get within the community.</p>\n\n\n\n<p>And if you look at who is able to contribute freely, without pay, their own time and expertise, you will notice it&#8217;s a subset of the population is very privileged in some way. Mainly the ability to have time, and the ability to their knowledge without having to take money for it.</p>\n\n\n\n<p>And then you get this power problem, which was never accounted before by Stallman or Raymond, because both of them believe this future in which this is irrelevant. And you can see when you read these articles that they wrote, that they have this underpinning idea that the best developers will automatically bubble to the top, simply because they are the best. Which is meritocracy, which is nonsense.</p>\n\n\n\n<p>Meritocracy is a dystopian idea that doesn&#8217;t comply with how the world works at all, because it assumes that everyone is playing on an even field. That no one has privileges, and that everyone has the capability of partaking in the same way, but that&#8217;s not the case. So there are these underpinning ideological stances that sit on the bottom as the foundational stones of open source ideology that are deeply problematic.</p>\n\n\n\n<p>And then the stuff that&#8217;s built on top, sounds fine until you start investigating, but what happens if this actually becomes the standard? Because due to these ideological underpinnings, there&#8217;s a lack of consideration for things like diversity, things like inclusion, things like imbalances of power, or things like equity.</p>\n\n\n\n<p>They&#8217;re just not there because of these assumptions about equal access and skills being a determinant of whether or not you should be able to contribute.</p>\n\n\n\n<p>[00:30:15] <strong>Nathan Wrigley:</strong> It&#8217;s really interesting because it feels to me as if the problem isn&#8217;t one of open source. It&#8217;s one of growth. And what I mean by that is open source has just grown to the point where, not only is it critical some sense, literally of society will fail if certain portions of the open source community are not updated regularly and what have you. But also, it kind of got away from us, this idea that everybody could contribute, sounds lovely, it feels as if it works very well on a small scale, and all those years ago, when you were talking about the manifesto and so on, imagine that even though it was described in terms of open source will take over the world.</p>\n\n\n\n<p>There probably wasn&#8217;t any conception of what that would actually mean. And yet, here we are. The open source software literally has taken over the world, and tens of thousands, maybe millions of people, are usefully employed in using it, it feels like, maybe what you&#8217;re describing is that it&#8217;s grown in a way that has had really time to inspect. Nobody&#8217;s had eyeballs inspecting this as it&#8217;s grown. On the corporate side, there are people who are paid to govern how things grow, are people whose job it is to make sure that things are made fair and equal. And I&#8217;m guessing that may be, part of the problem you&#8217;re highlighting. Is that there&#8217;s nobody looking down from the top saying, look, we really need to address this thing over here because, it&#8217;s getting out of hand.</p>\n\n\n\n<p>[00:31:45] <strong>Morten Rand-Hendriksen:</strong> It&#8217;s not a problem with scale. It&#8217;s that the governance model, or lack thereof, isn&#8217;t scalable. There is no governance model on the bottom because there&#8217;s an assumption that this will never be large, in terms of who contributes.</p>\n\n\n\n<p>It&#8217;ll always be a small group of people who are building software for everyone. It will not be communities of tens of thousands of contributors. But this scale problem, and the legacy debt problem isn&#8217;t unique to open source. I think the best example I can give you is Internet Explorer.</p>\n\n\n\n<p>When I say this, I have to do the whole disclosure. I work for LinkedIn learning. LinkedIn learning is part of LinkedIn. LinkedIn is owned by Microsoft. Saying that, I have no interfacing with Microsoft nor have I ever worked for the Internet Explorer or the edge team or anything else. So I&#8217;m saying this as an outside observer, and these are my opinions about the history of a browser, not a statement from the company I&#8217;ve worked for nor anything. Okay?</p>\n\n\n\n<p>The people wondered for a very long time why Microsoft didn&#8217;t sunset Internet Explorer, right? Internet Explorer was like the curse on web development, that you had all these browsers that were moving forward very fast. And then you had Internet Explorer that wasn&#8217;t. And what people fail to recognize is it&#8217;s because of how Internet Explorer was originally built.</p>\n\n\n\n<p>So Internet Explorer still is, until it was sunsetted it, Internet Explorer was a variant of the file Explorer inside Windows. Meaning you could open files from your computer into Internet Explorer, just like you could open a webpage. In fact, if you go an open an old version of Windows, and go into the file explorer and type in a URL, you can open a website inside the file explorer, because it&#8217;s the same application. It&#8217;s just a different skin on it. So changing Internet Explorer, meant changing how file explorer works inside Windows. I think the reason that is, is because when Internet Explorer was introduced, way back before the internet was a thing or the web was a thing, people were really using in a meaningful way. It was considered a file repository. The internet was a file repository. You would go on the internet and find files and then open them. And it was natural to take the file explorer and just say, okay, we&#8217;re going to extend it so you can pull files from elsewhere. And then people publishing these HTML documents will be like, add an HTML parser to it. And then eventually a CSS parser. We should probably pull that out and make it a different application, but it&#8217;s actually the same. And then, oh my God, the web is the only thing people are using my computer for, but our Internet Explorer is still tied to our file server, our file Explorer. So how do we solve this? You have this problem of everything is moving so fast, and scaling so rapidly, you can&#8217;t stop everything and be like, stop, we&#8217;re going to spend a year redeveloping this from the ground up to be completely different. Because the whole operating system is wired to this. And this is also why for a while, on Windows you had both Internet Explorer and Edge at the same time. Because Internet Explorer&#8217;s functionality is wired into applications. And that functionality as in Internet Explorer has access to files on your computer, as well as the web at the same time is wired into a lot of applications, which is why you often see these very advanced tools that people are using in say a bank or a doctor&#8217;s office that can only use Internet Explorer, because it&#8217;s also the file explorer, So there&#8217;s decisions made early on in a rapidly evolving space, lead to enormous legacy debt that is almost impossible to get out of. in the open source world, that legacy debt is the lack of governance protocols for how decisions are made. And what you see in the open source world is that ad hoc governance models are introduced, like a very poorly defined consensus model. Because of a lack of existing models. But then due to how the community has over time, and the freedom given to contributors, it&#8217;s very hard to go and say, now that we are successful, we&#8217;re going to start imposing rules onto the way we work. Because then all the people who came in when there was free to do whatever you want, will be like, hey, why are you suddenly restricting my freedoms?</p>\n\n\n\n<p>Why are you standing in the way of me doing things the way I want to? this is what you see anytime you try to bring these issues up that people are saying, you&#8217;re standing in the way of what I&#8217;m doing. again, this becomes a scale problem because, from the individual contributors perspective, when you are working in open source, you&#8217;re really solving your own problems.</p>\n\n\n\n<p>You&#8217;re saying, I want this feature, and I believe that this feature is something someone else would have so I&#8217;m going to make it and put it into the project. But if you&#8217;re doing that on a project that influences or impacts tens of thousands of businesses, for example. Say you&#8217;re making an e-commerce platform, every change you make will have mission critical impact on all the people who use it.</p>\n\n\n\n<p>So you&#8217;re not making a decision for yourself. You&#8217;re making a decision for all the other people who are using the thing. And, when I spoke, I speak at an open source conferences, I always start by saying the people in this room are the 1% of open source. Because by being at an open source conference, you are identifying yourself as not being a standard open source user. The normal open source user, never interfaces with the community at all.</p>\n\n\n\n<p>They download the software and use it as is. That&#8217;s it. That&#8217;s their interface with the community. By being an active part of the community, you are identifying yourself as a privileged person within the community. You have more knowledge of the software than anyone else. You have more influence over the project than anyone else.</p>\n\n\n\n<p>And you do not use the software the way your users use it. So you are not developing the software for you. You&#8217;re developing the software for someone you don&#8217;t fully understand because you&#8217;re not that person anymore. And that&#8217;s a scale thing. Understanding that is very difficult.</p>\n\n\n\n<p>It&#8217;s a skill that you have to constantly train yourself to maintain and understanding that a trivial decision has an impact on a thousand or ten thousand or a hundred thousand or a million people, is very difficult, because it makes it challenging to even do anything, unless you then go, actually, no, it&#8217;s just from me. And I have the power to do it because it&#8217;s open source.</p>\n\n\n\n<p>[00:37:48] <strong>Nathan Wrigley:</strong> One of the things which comes out of your piece is a desire people, going to use the word remunerated, not strike a balance of what it is that you actually want to say, but I&#8217;ll use it anyway, are remunerated for the work that they do. In the sense that, volunteering is laudable. It&#8217;s an altruistic thing. I don&#8217;t think in any walk of life, anybody is going to say that volunteering is not something to be commended, but presumably there is some line in the sand, I don&#8217;t know where that line lives exactly, there&#8217;s a line at which perhaps you feel that remuneration ought to take place.</p>\n\n\n\n<p>And I don&#8217;t know what the criteria for that is/ maybe it&#8217;s the legacy of things that you&#8217;ve done in the past. Maybe it&#8217;s the of the thing that you&#8217;re about to commit. I don&#8217;t know. But I&#8217;d be curious if you could develop that a little bit. Talk about how it is that you feel people desiring remuneration.</p>\n\n\n\n<p>And in the case of some recent events, how perhaps they felt challenged and perhaps bullied is the right word by larger entities who almost imagined that they were employees of theirs. In the case of Log 4 j, being contacted via email by people who just assumed that their software was something that they could force them to update, after sending them a snotty email. So let&#8217;s develop that a little bit.</p>\n\n\n\n<p>[00:39:09] <strong>Morten Rand-Hendriksen:</strong> I&#8217;m going to say two very contradictory things. I don&#8217;t think anyone should be paid for open source development. I also think that all open source developers should be paid for open source development. The reason is, in an ideal world, open source should be completely free, and we should all have the capability to contribute what we can, and build software that has no strings attached. That is the ideal. That is the dream of open source. That open source software exists independent of capitalism. That we can say, you build software, people use it, no one ever attaches any strings to any of that. If you can contribute, you contribute. If you have something meaningful to contribute, you can. It&#8217;ll get included. You can fork it. Everything will be fine.</p>\n\n\n\n<p>However, and this was the dream of the GNU manifesto, that this would be the future we would be building. Where it would no longer be necessary to get paid because dynamically people would just get paid through other means somehow, I don&#8217;t know. It&#8217;s very unclear how that&#8217;s going to happen, but that was the dream. However, we live in a real world and the real world is a capitalist world, where your contributions have value, whether you are paid for them or not. And this has become exceptionally clear in the open source space because in the open source spaces, there are corporations that have billion dollar valuations, that are built either on the open source software or basically represent the open source software itself. Who for every contribution that&#8217;s made by a volunteer, an unpaid volunteer contributor, the corporation is able to pull significant monetary value from the project. At that point, you get this enormous power imbalance between the volunteer, unpaid contributor, and the corporations who earn billions of dollars off the application, and are able to spend some of that money putting contributors into the project. When you have that kind of power imbalance, the only responsible thing to do is to put a monetary value on contribution and say, we are going to redistribute the wealth. And the insane part about this is this was actually addressed by the new manifesto. I have it open here.</p>\n\n\n\n<p>All sorts of development can be funded with a software tax. I&#8217;m just reading verbatim, right? By the way. Suppose everyone who buys a computer has to pay X percent of the price as a software tax. The government gives this to an agency like the NSF, that&#8217;s the organization that he was running at the time, to spend on software development. But if the computer buyer makes a donation to software development itself, he can take a credit against the tax.</p>\n\n\n\n<p>He can donate to the project of his own choosing, often chosen because he hopes to use the results when it&#8217;s done. He can take a credit for any amount of donation up to the total tax he had to pay. The total tax rate could be decided by a vote of the payers of the tax weighted against the amounts they will be taxed on.</p>\n\n\n\n<p>And the consequences for that would be the computer using community support, software development. The community decides what level of support is needed, and users who care, which project their share is spent on can choose this for themselves.</p>\n\n\n\n<p>So, in this, which partly makes sense, and partly is just a utopian fever dream, he lays out in very clear language. There should be a software tax. If you talk to open source leaders, they will aggressively fight this idea. And I think part of the reason for that, and this is purely my opinion and observation, is the second we start paying people for contribution, the power balance shifts dramatically within the open source communities, because there is a large portion of people in the world who do not have the privilege of contribution right now, who just can&#8217;t. Either their jobs preclude them from doing it to begin with. Not because the company&#8217;s saying you can&#8217;t contribute, but because their jobs are too overwhelming to spend time contributing to open source. Their lives may be in the way. They may not have time in their lives to do open source contribution. They may not be in a position where they can volunteer their time because their monetary value they derive from their time in a work is more important to them than being able to contribute.</p>\n\n\n\n<p>And people find themselves in a myriad of circumstances where just volunteerism of any kind is not possible. In addition to that, you have all the socioeconomic factors and the social factors that impact how we interact with other people. All the things that impact our interactions with people impact open source contribution. Including gender representation, sex representation, race, culture, creed, religion, physical location, ethnicity, how you present yourself to the world, neurodivergence, disability, all of these things come into play, right? So the assumption that open source has the best contributors, because the best contributors bubble to the top, assumes everyone is the same. In reality, everyone is not the same. There is a small handful of people who fall into that category of, just being able to contribute their time freely.</p>\n\n\n\n<p>The majority of us can&#8217;t do that. The majority of us are dependent on money to pay for housing, to pay for food, to pay for our kids, to pay for being able to function in the world. And all of those people are more or less excluded from contribution. So therefore you get a subset of the population during the contribution. In that scenario, when you at the same time, have corporations deriving billions of dollars out of the source project, you cannot argue that, no, we should continue to not pay contributors.</p>\n\n\n\n<p>And then you get to that whole question that you brought up with, like, how do you do this? How do you pay contributors? Because how do you measure. Let&#8217;s say someone who goes and rewrites all the PHP in the project from someone who runs one of the support groups on a Slack channel, right?</p>\n\n\n\n<p>Both of those things are valid contributions to the project. One of them is easily measurable. The other one is very difficult to measure. Which one of them have the most impact on the project? I would say if you want to follow like the open source ideology of like in the future, everything will be free no one will have to be paid for anything. would say the measure should be time. It should not be what you do. It should be time. And then you have to qualify the time and say like, if you spend eight hours doing something that should have taken you two minutes, probably shouldn&#8217;t be paid eight hours of work. But if you are spending eight hours on something that someone who is more skilled than you would do in hours, you should probably be paid for the eight hours of work because it&#8217;s a learning process. But then if you go down that route, you then ask, who pays and the simple answer is the people who earn money from this should pay a part of that money back into the community. And it should not be 5%, because their entire financial basis is built on the platform of the open source software.</p>\n\n\n\n<p>The wealth of these companies that are built on top of open source is entirely contingent on the free labor of the volunteers, which is insane and would never fly in any other context, right? If you want to use Marxian terms, it&#8217;s exploitation of labor, right? And you&#8217;re taking the free labor of someone else and turning it into money and not giving money back to them. And no amount of oh, but my corporation volunteers its people back into the community, will account for that because that&#8217;s not what&#8217;s happening. If you have a corporation that&#8217;s financially dependent on the success of the open source project, and you put some of your people back into the project, you are not volunteering anything. Those people are now paid to direct the project in directions that are fruitful to your company so that you can derive more money from it. And if that&#8217;s the model you want to run, that&#8217;s fine. Then that has to be explicitly stated, that this open source project is actually a money machine for me, and I&#8217;m going to put my people into it, and they are being paid to direct the project in directions that are fruitful to me. And if you contribute that as on you. Gatsby actually does this, right. Gatsby used to have two websites. They used to have the dot org version of Gatsby, the open source project. And then they had gatsby.com, which was Gatsby cloud and their commercial offering. They combined them and they said we&#8217;re not going to pretend what&#8217;s happening here. There&#8217;s a commercial project called Gatsby that has an open source component to it. So you can use Gatsby any way you want, but we&#8217;re going to be crystal clear about this being a commercial venture. And when you contribute to Godspeed, you are putting money in our pockets. And it&#8217;s a very open way of dealing with this problem.</p>\n\n\n\n<p>So as long as you have interests within the community that are deriving value from the open source community, they should be paying back into the community. And the way that practically this should be done would probably be something like having a foundation of some kind, or an organization within the community that collects money that anyone can pay to. If you&#8217;re a user and you go, I want to, I can&#8217;t contribute in terms of writing software or being in the community, but I can give some money. Or if you&#8217;re a company that relies on the software, you can pay into this organization, and then that organization determines how to distribute that money, not through what is of interest to the corporate interest, but just like looking at the project, where should we funnel money right now to get things done?</p>\n\n\n\n<p>This is what the open JS foundation does. So they have foundation where you can pay in money and then they will distribute the money according to need, both for the project and for the people who contribute to it so that you can actually get work done. There is no reason why open source projects can&#8217;t have this. Other than that it&#8217;s resisted by the leadership, because it shifts, power. That&#8217;s the way it is. It&#8217;s a power thing. When you give people money for work, you&#8217;re changing the structure of how things are done. And that&#8217;s not something people who are driving massive amounts of money from a project want because then the power shifts.</p>\n\n\n\n<p>[00:49:10] <strong>Nathan Wrigley:</strong> What would you say to somebody, I suspect this imaginary person wouldn&#8217;t be tremendously difficult to find, but what would you say to somebody who said, am totally happy with the way it is now? am really content with volunteering. Some time literally volunteering it with no expectation of anything. Just to be a good citizen, to be a part of the community and to see the project that I&#8217;m involved with over time. Don&#8217;t want to see financial reward or whatever it may be, I just want to contribute and see it grow for growth&#8217;s sake.</p>\n\n\n\n<p>[00:49:41] <strong>Morten Rand-Hendriksen:</strong> Congratulations on being a white man living in north America or Western Europe, is what I would to say to that. That is basically the person you&#8217;re describing. That is a person with enormous privilege. Doesn&#8217;t have to be the person I just described, but it&#8217;s very likely to be that person I described. A person who has the privilege, not only of contributing their free time to a project like this without any expectation of renumeration, and who has the worldview that this is something everyone can do, and therefore it&#8217;s okay, is a person with enormous privilege. This is basic deontology, right. Duty ethics. If you do something, you are saying that this is the model you want everyone else to follow. It also implies that if you think that this is okay, you are saying, this is okay for everyone.</p>\n\n\n\n<p>This is part of the problem that we have. The ideology that underpins this assumes equity in the system. When we know the system is not equitable. When we know that there are people with enormous power within all these open source projects, who earn millions of dollars off the open source project, where there are other people, with great ideas who earned zero dollars off the project who have no power because they don&#8217;t get paid for it, and they don&#8217;t have the ability to contribute. And that&#8217;s when you get this whole like, decisions are made by the people who show up and the people who show up are the people with privilege. So that means decisions are made by the people with privilege. And that&#8217;s how you get things like open source projects that disregard accessibility, because people with accessibility issues have a much higher threshold to walk across to get into the project and be able to contribute. And they are facing challenges in their lives that make it more difficult for them to be able to contribute without getting paid. As a result, the voices that would argue for more accessibility are effectively excluded from the conversation because they are not contributing as much as everyone else and thereby their views of the world are not embedded into the project because they&#8217;re never heard.</p>\n\n\n\n<p>So it&#8217;s about privilege, and it&#8217;s a very privileged position to say, I&#8217;m fine with not getting paid. I&#8217;m one of those people, who, when I was contributing to open source projects, when I still contribute to open source project, I do that while I&#8217;m being paid by my company to do that.</p>\n\n\n\n<p>Part of my job is to be embedded in open source projects to see what&#8217;s going on. And I use part of that time to help open source projects. But that means I am not the normal contributor. And that also means I have freedoms that other people don&#8217;t have to do things that other people can&#8217;t do. And I have to keep that in mind because that means I need to then bring those voices that can&#8217;t be at the table to the table, or represent the ideas of those voices at the table, ensure that those voices are heard in some way. part of that is me having conversations like this and saying, the fact that you don&#8217;t have equity in your system that the system is inequitable, and that the system will remain inequitable until you actively do something about it.</p>\n\n\n\n<p>And the clearest path to doing that is by paying people. then you could extend that and say, people can choose. If you work for a company that&#8217;s paying for a contribution, then you don&#8217;t get paid. you don&#8217;t work for a company that&#8217;s paying for your contributions and you&#8217;re doing it on your own, then you can go apply to get paid.</p>\n\n\n\n<p>[00:52:59] <strong>Nathan Wrigley:</strong> As with all of these things, the broad brush strokes of the idea are easy to crystallize. It&#8217;s straightforward conceive of these things. My guess is that some parts of the internet where you live, these ideas are crystallizing and they&#8217;re up for discussion, and this debate is ongoing. Where do you go to discover these ideas? What communities are you in, where these kinds of things are up for debate and so on.</p>\n\n\n\n<p>[00:53:24] <strong>Morten Rand-Hendriksen:</strong> Open source projects are grassroots political organizations pretending to be software development communities. If you go look at grassroots political organizations, you very quickly see that it&#8217;s the same thing. ad hoc communities that grow over time, power. There&#8217;s power struggles within those communities. And eventually someone realizes, hey, doesn&#8217;t work, so they start implementing governance rules and they turn into either functioning organizations or they collapse, or they fracture, or fork into multiple different versions of themselves. Acknowledgement of this fact a long way to understanding how to move forward. Because the notion that, if you talk to individual open source contributors, especially powerful open source contributors who have significant sway on projects, they will always talk about the project as if it&#8217;s still some sort of hobby thing that they and their friends are doing on their spare time for fun. And in that frame that anyone who comes in and says, hey, we should do things differently are infringing on their freedom to do whatever they want in their spare time, as a hobby, Someone is coming to me and telling me I can&#8217;t drive my RC boats in the local lake. how it&#8217;s approached in reality. not what it is at all. It&#8217;s more like, you started with your little RC boat in a lake, now you&#8217;re running the main transportation hub for people who are moving from one island to another, but you&#8217;re still acting as if it&#8217;s just some hobby project. It&#8217;s not. There&#8217;s a disconnect between the reality of the impact people have how they treat it. And a grassroots political organization, the impact of the work you do become immediately apparent to you because you interface with the people you&#8217;re working with all the time, and you can see the real world impact .</p>\n\n\n\n<p>In software development you never interface with the people you impact, or you only interface with the people, a small handful of them in very specific circumstances. you don&#8217;t really have a full understanding of what you are doing to the people you are building software for. I very intentionally say what you are doing to the people, because when you do any kind of design or development work, you&#8217;re really using people a vehicle to bring forth a view of the world or your vision of what the future should be like. It&#8217;s instrumentalism, you&#8217;re, quite literally building tools for people to use, and when they use those tools, they build the future that you devised for them. And that future is to your design. Software development gives you enormous power, but it also removes you from seeing the consequences of what you&#8217;re doing. And it gives you this cushion that you can sit on where you say, no, it&#8217;s just me mucking around with some software, it&#8217;s not a big deal. Meanwhile, it is a huge deal for a lot of people. So it&#8217;s a very sticky problem because it has to do with changing the way people think about open source software contribution, not as something you&#8217;re doing because you like it, but it&#8217;s something you&#8217;re doing that is changing the world.</p>\n\n\n\n<p>And it&#8217;s funny because the open source contributors will very, very happily talk about the enormous impacts open source software has on the world until you ask them, how are you held accountable for this, at which point they are very quick to tell you, oh no one is allowed to restrict my creativity and freedom in doing any kind of development. How dare you bring this up, right?</p>\n\n\n\n<p>[00:56:43] <strong>Nathan Wrigley:</strong> I feel like we&#8217;ve just scratched the surface. We&#8217;re the best part of an hour in, and I know that you&#8217;re constrained by time, but I&#8217;m sure that for those people who have been intrigued, they&#8217;ll be keen to make contact with you and discover about your thoughts. you have a place, some places on the internet where you can be best discovered?</p>\n\n\n\n<p>[00:57:06] <strong>Morten Rand-Hendriksen:</strong> Yeah. I&#8217;m on Twitter @mor10, mor 10, cause that&#8217;s my name. You can also find me on LinkedIn. I&#8217;m Morten Rand-Hendriksen on LinkedIn. I should be fairly easy to find. And I have a website, Mor10.com, one zero dot com. I&#8217;m I cross post everything. I post elsewhere onto my website too, so that I have control over my own content.</p>\n\n\n\n<p>And I&#8217;m on TikTok now, at mor 10 web, so mor one zero web, because there&#8217;s someone else by the moniker Morten who&#8217;s not using their account, so you can find me there as well. Reach out to me from any platform. You&#8217;ll find me.</p>\n\n\n\n<p>[00:57:41] <strong>Nathan Wrigley:</strong> Absolutely fascinating discussion. I hope that you get some reaching out to you and continuing the discussion and the debate and thank you so much for joining us.</p>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 15:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nathan Wrigley\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WordCamp Central: Nexcess joins the WordPress global community sponsorship program in 2022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://central.wordcamp.org/?p=3146022\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"https://central.wordcamp.org/news/2022/02/23/nexcess-joins-the-wordpress-global-community-sponsorship-program-in-2022/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1270:\"<p><span>We couldn’t be happier to welcome </span><strong><span><a href=\"https://www.nexcess.net/\">Nexcess</a></span></strong><span> to the <a href=\"https://central.wordcamp.org/sponsor-multiple-wordcamps/\">WordPress global community sponsorship program</a></span><span> in 2022! They’re sponsoring at the Gold level, supporting official WordPress community events around the globe.</span></p>\n<p><a href=\"https://central.wordcamp.org/files/2019/02/Nexcess-Logo-Horiz.png\"><img /></a></p>\n<p><span>Nexcess provides a fully managed, high-performance, and best-in-class cloud solution built to optimize WordPress and WooCommerce sites and stores. For over 20 years</span><span>, our holistic, hands-on approach to managed products and solutions has provided users with tools that help them create better websites and e-commerce stores along with expert, on-demand support. By removing the stress of managing the day-to-day operations of their site or store, we afford our customers the ability to </span>PRESS<span> forward and focus more on what inspires them.</span></p>\n<p><span>Whether you&#8217;re a small business owner, designer, developer, or a small to medium-sized agency, Nexcess has a solution </span><span>to help you and your business succeed.</span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 14:00:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Isotta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: The Case for a Shared CSS Toolkit in WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130404\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wptavern.com/the-case-for-a-shared-css-toolkit-in-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6789:\"<p class=\"has-drop-cap\">Earlier today, Mark Root-Wiley published an in-depth <a href=\"https://mrwweb.com/standardized-design-tokens-css-wordpress-future/\">proposal around standardized design tokens and CSS</a> for WordPress. The goal is to create a consistent, customizable, and interoperable system around the design tools in core. Essentially, he is proposing a standardized design framework or, as he refers to it, a &#8220;shared CSS toolkit&#8221; that WordPress, themes, and plugins can rely on.</p>\n\n\n\n<p>The blog post clocks in at nearly 4,000 words. He also added a shorter version of the <a href=\"https://github.com/WordPress/gutenberg/issues/38998\">proposal via a Gutenberg GitHub ticket</a>. However, the post expands on the idea, linking to resources that span a few years.</p>\n\n\n\n<p>I responded to Root-Wiley via email. This was a subject near and dear to me. It has also been a source of frustration from other theme authors I have had the privilege of talking to over the last few years. These are themers who have been 100% behind the block system since Day 1, not the random guy in the back shouting, &#8220;Gutenberg sucks!&#8221;</p>\n\n\n\n<p>The primary thought I shared was that there has been a bit of fatigue on the topic. There is a push to bring standard presets to core every so often. But, it always feels like the wheels are spinning in the mud until everyone gets out of the car when they realize it&#8217;s not moving.</p>\n\n\n\n<p>Root-Wiley pointed to my 2019 post, <a href=\"https://wptavern.com/themes-of-the-future-a-design-framework-and-a-master-theme\">Themes of the Future: A Design Framework and a Master Theme</a>, as a common ancestor to his deep dive into the bowels of this issue. But, others and I have been talking about it even before the launch of the block editor in WordPress 5.0.</p>\n\n\n\n<p>In part, this is because we were excited about the potential of more standardization. WordPress could finally correct some of its longstanding issues and usher in a utopian era of theme creation based on well-designed conventions.</p>\n\n\n\n<p>WordPress 5.0 rolled out theme-support flags for custom font sizes and a color palette. The features in and of themselves were a welcome first step, but they did not go far enough. WordPress should have leaped ahead and set standards from the outset.</p>\n\n\n\n<p>Instead, we got a mish-mash of default font size and color names with no guidelines on what they meant. <em>How huge is the &#8220;huge&#8221; font size? What if I need to follow that naming scheme and need something larger? What should I name it?</em> (For a potentially educational tangent on size names, see my <a href=\"https://wptavern.com/feed#a-never-before-published-list-of-sizes\">notes at the end of this post</a>.)</p>\n\n\n\n<p>I still cringe every time I see classes like <code>.has-luminous-vivid-orange-background-color</code>.</p>\n\n\n\n<p>However, I will not continue bashing the mistakes of the platform&#8217;s past. It is time to look forward. Root-Wiley notes in his post:</p>\n\n\n\n<blockquote class=\"wp-block-quote\"><p>I would like to propose a path toward standardizing how CSS for WordPress designs and layouts are created so they are more transparent, efficient, and customizable. Not only can this approach simplify core styles, it would address a number of long-term WordPress pain points that predate even the block editor&#8217;s release in WordPress 5.0.</p></blockquote>\n\n\n\n<p>I want to see presets for everything users can select via the block design tools. For example, instead of setting absolute units for margins, they can choose predefined sizes from WordPress and/or their theme. However, there should be standards for naming these presets.</p>\n\n\n\n<p><em>Why is this so important?</em> Imagine setting a top margin of <code>20px</code> on a block in some blog post. It looks good and matches your current theme, and you repeat this process dozens or more times on various elements. Then, you change designs down the road. This could be a full theme switch or a change via the global styles system. This new design implements a different vertical spacing system. <code>24px</code> might make more sense than the <code>20px</code> littered throughout the site.</p>\n\n\n\n<p>The old setting would be tied to a global value in an ideal world, not the block. This would allow it to match whatever design system is in place.</p>\n\n\n\n<p>Margins are just one piece of a much larger puzzle. And, presets for the various design tools do not even cover everything in Root-Wiley&#8217;s proposal. That is why I encourage all theme and plugin authors to review it.</p>\n\n\n\n<p>There are a few items I disagree with in the proposal. However, those involve the low-level implementation work, not the concept of creating a standardized system. I had planned to discuss those in detail, but doing so would get into what a former team member I worked with called &#8220;weed discussions.&#8221; They get in the way of the big picture.</p>\n\n\n\n<p>If there is one thing Root-Wiley and I agree on, it is that big picture of creating a CSS toolkit to carry WordPress into the future.</p>\n\n\n\n<h2 id=\"a-never-before-published-list-of-sizes\">A Never-Before-Published List of Sizes</h2>\n\n\n\n<p>This is a bit of a side tangent, but I did do a ton of research on size names following the WordPress font-size model. And, because I will likely never have a reason to publish my findings elsewhere, I might as well post them here.</p>\n\n\n\n<p>If you were ever wondering what specific sizes are bigger or smaller than others (e.g., Colossal vs. Titanic), I present to you a <em>somewhat-educated-but-may-not-be-100%-correct</em> list:</p>\n\n\n\n<ul><li>Diminutive (2XS)</li><li>Tiny (XS)</li><li>Small</li><li>Normal (Medium, Regular, Base)</li><li>Large</li><li>Extra Large (XL)</li><li>Huge (2XL)</li><li>Gargantuan (3XL)</li><li>Colossal (4XL)</li><li>Titanic (5XL)</li><li>Olympic (6XL)</li><li>Planetary (7XL)</li><li>Galactic (8XL)</li><li>Universal (9XL)</li></ul>\n\n\n\n<p>That is likely not an exhaustive list, but I spent several weeks looking up and comparing definitions and resources. I added a few alternatives in the mix for reference.</p>\n\n\n\n<p>I also wanted to post this to show how naming things can break the user experience. The average user should not have to think about which sizes are the biggest or smallest. A naming system like this is a recipe for confusion. Even if the user experience works, the code-based slugs should not confuse developers.</p>\n\n\n\n<p>This same rule applies to colors and all other presets. Naming things is hard, but it is even tougher when you have already made a mess and need to fix it later. It starts at the foundation, especially when everything added today will be a part of the legacy code set for years to come.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Feb 2022 02:01:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"WPTavern: Amazon Drops “Elasticsearch” From Product Names To Settle Trademark Infringement Lawsuit With Elastic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130400\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"https://wptavern.com/amazon-drops-elasticsearch-from-product-names-to-settle-trademark-infringement-lawsuit-with-elastic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3117:\"<p>Elastic has resolved a trademark infringement lawsuit related to usage of the term &#8220;Elasticsearch.&#8221; Amazon has agreed to drop the term from its product line. </p>\n\n\n\n<p>&#8220;We believe this resolution will remove confusion in the marketplace and provide much-needed clarity to our community and customers,&#8221; Elastic CEO Ashutosh Kulkarni said in the <a href=\"https://www.elastic.co/blog/elastic-and-amazon-reach-agreement-on-trademark-infringement-lawsuit\">announcement</a>.</p>\n\n\n\n<p>&#8220;There is only one Elasticsearch, and it comes from Elastic.&#8221; </p>\n\n\n\n<p>In January 2021, <a href=\"https://wptavern.com/elasticpress-io-service-considers-next-move-after-elasticsearch-abandons-open-source-licensing\">Elastic abandoned Elasticsearch&#8217;s open source licensing</a>, claiming that AWS&#8217;s behavior &#8220;forced&#8221; the company to switch from the <a rel=\"noreferrer noopener\" href=\"https://www.apache.org/licenses/LICENSE-2.0\" target=\"_blank\">Apache 2.0-license</a> to be dual-licensed under the <a rel=\"noreferrer noopener\" href=\"https://www.mongodb.com/licensing/server-side-public-license\" target=\"_blank\">Server Side Public License (SSPL)</a> and the <a rel=\"noreferrer noopener\" href=\"https://github.com/elastic/elasticsearch/blob/0d8aa7527e242fbda9d84867ab8bc955758eebce/licenses/ELASTIC-LICENSE.txt\" target=\"_blank\">Elastic License</a>. Elastic cited examples of what they perceived to be &#8220;ethically challenged behavior.&#8221; </p>\n\n\n\n<p>Shortly after, Amazon led a community effort to fork the project in order to maintain its open source license. In September 2021, Amazon <a href=\"https://aws.amazon.com/blogs/aws/amazon-elasticsearch-service-is-now-amazon-opensearch-service-and-supports-opensearch-10/\">renamed</a> its Amazon Elasticsearch Service to Amazon OpenSearch Service after adopting the fork.</p>\n\n\n\n<p>Elastic initiated the trademark infringement lawsuit in 2019 after AWS <a href=\"https://aws.amazon.com/blogs/aws/new-open-distro-for-elasticsearch/\">launched an Open Distro for Elasticsearch</a> in partnership with Expedia and Netflix. AWS said the motivation was to keep Elasticsearch open, because some of the more recent additions were proprietary. Amazon said the open distro was created &#8220;to accelerate open source Elasticsearch innovation.&#8221; Elastic claimed that the branding for this open distro violated their trademark.</p>\n\n\n\n<p>AWS has agreed to drop all instances of Elasticsearch from its product line. The only Elasticsearch service listed on the AWS Marketplace now is the one from Elastic Cloud. Elastic has eased its prior animosity in communication and is now working towards a more amicable partnership in promoting Elastic Cloud in the AWS marketplace.</p>\n\n\n\n<p>&#8220;Looking ahead, we’ll focus on collaborating with Amazon for the benefit of our shared customers who use Elastic on AWS,&#8221; Kulkarni said. &#8220;We are already seeing tremendous momentum in our partnership around our recent areas of investment to streamline data ingestion and simplify onboarding to Elastic Cloud on AWS.&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 23:46:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"Post Status: Post Status Excerpt (No. 47) — Should WordPress Adopt The Block Protocol?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=93789\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"https://poststatus.com/post-status-excerpt-no-47-should-wordpress-adopt-the-block-protocol/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4406:\"<h2 id=\"it-is-now-time-for-the-community-to-weigh-in-and-decide-whether-wordpress-should-stop-and-refuel-in-this-new-port-leonardo-losoviz\">&#8220;It is now time for the community to weigh in and decide whether WordPress should stop and refuel in this new port.&#8221; —Leonardo Losoviz</h2>\n\n\n\n<p class=\"has-drop-cap\">In this episode of Post Status Excerpt, David talks with Leonardo Losoviz about <a href=\"https://blockprotocol.org/\">The Block Protocol</a> and why it might benefit WordPress to adopt it and allow other platforms to share and reuse blocks. Matt Mullenweg <a href=\"https://twitter.com/photomatt/status/1486793646045216769\">has expressed interest</a> in taking this path.</p>\n\n\n\n<p><strong>Why This Is Important:</strong> Gutenberg, according to Matt, is &#8220;bigger than WordPress,&#8221;, especially in the context of the Open Web. The Block Protocol is a way to create and share content across WordPress, half-WordPress, and non-WordPress sites, which supports the project\'s mission to democratize publishing.</p>\n\n\n\n\n\n\n\n<p class=\"has-background\">Every week <strong><a href=\"https://poststatus.com/podcast/the-excerpt/\">Post Status Excerpt</a></strong> will brief you on important WordPress news — in about 15 minutes or less! Learn what\'s new in WordPress in a flash. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/26a1.png\" alt=\"⚡\" class=\"wp-smiley\" /><br /><br />You can listen to <a href=\"https://poststatus.com/podcast/the-excerpt/\">past episodes</a> of <strong>The Excerpt</strong>, <a href=\"https://poststatus.com/category/post-status-podcasts/\">browse all our podcasts</a>, and don’t forget to subscribe on <a href=\"https://open.spotify.com/show/1m3xwXbe0MG5BzFVPtB0A7\">Spotify</a>, Amazon Music, <a href=\"https://podcasts.google.com/feed/aHR0cHM6Ly9mZWVkcy5zaW1wbGVjYXN0LmNvbS8ySkU5c2M4UA\">Google Podcasts</a>, <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">iTunes</a>, <a href=\"https://castro.fm/podcast/c53552c6-1ee0-4fc4-9de4-08ed6bf1ee4d\">Castro</a>, <a href=\"https://www.youtube.com/c/PostStatus\">YouTube</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, <a href=\"https://player.fm/series/wordpress-post-status-podcasts\">Player.fm</a>, <a href=\"https://pca.st/05rR\">Pocket Casts</a>, <a href=\"https://wordpress-post-status-draft-podcast.simplecast.com/\">Simplecast</a>, or by <a href=\"https://feeds.simplecast.com/2JE9sc8P\">RSS</a>. <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f3a7.png\" alt=\"🎧\" class=\"wp-smiley\" /></p>\n\n\n\n<h3 id=\"h-mentioned-in-the-show\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f517.png\" alt=\"🔗\" class=\"wp-smiley\" /> Mentioned in the show:</h3>\n\n\n\n<ul><li><a href=\"https://www.smashingmagazine.com/2022/02/implications-wordpress-joining-block-protocol/\">Implications Of WordPress Joining The Block Protocol</a></li><li><a href=\"https://www.joelonsoftware.com/2022/01/27/making-the-web-better-with-blocks/\">Making The Web Better With Blocks</a></li><li><a href=\"https://blockprotocol.org/\">The Block Protocol</a></li><li><a href=\"https://twitter.com/photomatt/status/1486793646045216769\">Matt Mullenweg on Twitter</a></li><li><a href=\"https://twitter.com/losoviz\">Leonardo Losoviz</a> (Twitter)</li><li><a href=\"https://twitter.com/dimensionmedia\" target=\"_blank\" rel=\"noreferrer noopener\">David Bisset</a> (Twitter)</li><li><a href=\"https://twitter.com/post_status\" target=\"_blank\" rel=\"noreferrer noopener\">Post Status</a> (Twitter)</li></ul>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h3 id=\"sponsor-gravity-forms\"><img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f64f.png\" alt=\"🙏\" class=\"wp-smiley\" /> Sponsor: Gravity Forms</h3>\n\n\n\n<p>Gravity Forms is a powerful form builder for WordPress and the #1 choice for businesses and web professionals across the globe. Its vast array of features, intuitive drag-and-drop form editor, and extensive ecosystem of add-ons, ensure customers can design beautiful, intelligent, and accessible forms for any project requirement.</p>\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<hr class=\"wp-block-separator logo is-style-default\" />\n\n\n\n<div class=\"wp-block-spacer\"></div>\n\n\n\n<h2 id=\"h-transcript\"><strong>Transcript</strong></h2>\n\n\n\n<p>Coming Soon</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 23:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"David Bisset\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"BuddyPress: BuddyPress 10.1.0 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=323557\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://buddypress.org/2022/02/buddypress-10-1-0-maintenance-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1865:\"<p>Immediately available is&nbsp;<a href=\"https://downloads.wordpress.org/plugin/buddypress.10.1.0.zip\">BuddyPress 10.1.0</a>. This maintenance release fixes ten bugs. For details on the changes, please read the&nbsp;<a href=\"https://codex.buddypress.org/releases/version-10-1-0/\">10.1.0 release notes</a>.</p>\n\n\n\n<p>Update to BuddyPress 10.1.0 today in your WordPress Dashboard, or by&nbsp;<a href=\"https://wordpress.org/plugins/buddypress/\">downloading from the WordPress.org plugin repository</a>.</p>\n\n\n\n<h2 id=\"many-thanks-to-9-2-0-contributors\">Many thanks to 10.1.0 contributors&nbsp;<span class=\"dashicons dashicons-heart\"></span></h2>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/muhittinsahilli\">muhittinsahilli</a>, <a href=\"https://profiles.wordpress.org/oztaser\">oztaser</a>, <a href=\"https://profiles.wordpress.org/r-a-y\">r-a-y</a>, <a href=\"https://buddypress.trac.wordpress.org/query?status=!closed&reporter=niftythree\">niftythree</a>, <a href=\"https://profiles.wordpress.org/vapvarun\">vapvarun</a>, <a href=\"https://buddypress.trac.wordpress.org/query?status=!closed&owner=dcavins\">dcavins</a>, <a href=\"https://profiles.wordpress.org/sx1001/\">sx1001</a>, <a href=\"https://profiles.wordpress.org/espellcaste\">espellcaste</a>,&nbsp;<a href=\"https://profiles.wordpress.org/dd32\">dd32</a>&nbsp;&amp;&nbsp;<a href=\"https://profiles.wordpress.org/imath/\">imath</a>.</p>\n\n\n\n<p>Special mentions to <a href=\"https://buddypress.trac.wordpress.org/query?status=!closed&reporter=niftythree\">niftythree</a> who reported 5 bugs <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f60d.png\" alt=\"😍\" class=\"wp-smiley\" /> &nbsp;and to <a href=\"https://profiles.wordpress.org/oztaser\">oztaser</a> who contributed with 5 patches to fix 40% of the bugs <img src=\"https://s.w.org/images/core/emoji/13.1.0/72x72/1f4aa.png\" alt=\"💪\" class=\"wp-smiley\" />.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 21:45:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mathieu Viet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WordCamp Central: WooCommerce sponsors WordPress community events across the globe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://central.wordcamp.org/?p=3146014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:112:\"https://central.wordcamp.org/news/2022/02/22/woocommerce-sponsors-wordpress-community-events-across-the-globe-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1876:\"<p><span>We’d like to thank </span><strong><span><a href=\"https://www.woothemes.com/woocommerce/\">WooCommerce</a></span></strong><span> for their continuing support by participating in the </span><strong><span><a href=\"https://central.wordcamp.org/sponsor-multiple-wordcamps/\">WordPress global sponsorship program</a></span></strong><span>! By generously sponsoring at the Gold level across the globe, WooCommerce helps make local community events (like WordPress meetup groups and WordCamps) better for WordPress enthusiasts and easier to organize for our wonderful group of hardworking volunteers.</span></p>\n<p><a href=\"https://central.wordcamp.org/files/2022/02/Copy-of-woocommerce-logo-color-black@2x.png\"><img /></a></p>\n<p><span>WooCommerce is a customizable, open-source eCommerce platform built on WordPress. </span></p>\n<p><span>Sell anything online with the flexibility and freedom of the world’s most popular CMS.</span></p>\n<ul>\n<li><strong><span><a href=\"https://wordpress.org/plugins/woocommerce/stats/\">4+ million active installations</a></span></strong></li>\n<li><span>55+ million downloads</span></li>\n<li><span>450+ extensions to add and extend functionality</span></li>\n</ul>\n<p><span>Whether you’re selling a few handcrafted items to a niche market, taking an existing business online, or going global with an enterprise-level eCommerce business WooCommerce gets you set up and selling fast, scaling securely as you grow.</span></p>\n<p><span>Your content is forever yours and customizable down to the button color. Plus you’re joining a supportive, </span><strong><span><a href=\"https://woocommerce.com/meetups/\">global community</a></span></strong><span> of developers and store owners.</span></p>\n<p><span>Developed and supported by a distributed team, WooCommerce is powered by Automattic, the creators of Jetpack and WordPress.com.</span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 16:00:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Isotta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WordPress.org blog: WordPress 5.9.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"https://wordpress.org/news/?p=12266\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/news/2022/02/wordpress-5-9-1-maintenance-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7742:\"<p>WordPress 5.9.1 is now available!</p>\n\n\n\n<p>This maintenance release features&nbsp;82 bug fixes in both Core and the block editor.</p>\n\n\n\n<p>WordPress 5.9.1 is a short-cycle maintenance release. The next major release will be version&nbsp;<a href=\"https://make.wordpress.org/core/6.0/\">6.0</a>.</p>\n\n\n\n<p>You can <a href=\"https://wordpress.org/wordpress-5.9.1.zip\">download WordPress 5.9.1 from WordPress.org</a>, or visit your Dashboard&nbsp;→ Updates and click &#8220;Update Now&#8221;.</p>\n\n\n\n<p>If you have sites that support automatic background updates, they’ve already started the update process.</p>\n\n\n\n<p>For more information, browse the <a href=\"https://make.wordpress.org/core/2022/02/16/wordpress-5-9-1-rc-1/\">full list of both Trac and GitHub changes in the release candidate post</a>, or check out the&nbsp;<a href=\"https://wordpress.org/support/wordpress-version/version-5-9-1/\">version 5.9.1 HelpHub documentation page</a>.</p>\n\n\n\n<h2 id=\"thanks-and-props\">Thanks and props!</h2>\n\n\n\n<p>The 5.9.1 release was led by <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a> and <a href=\"https://profiles.wordpress.org/mamaduka/\">George Mamadashvili</a>.</p>\n\n\n\n<p>Special props to <a href=\"https://profiles.wordpress.org/sergeybiryukov/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>sergeybiryukov</a> for running mission control.</p>\n\n\n\n<p>Thank you to everyone who helped make WordPress 5.9.1 happen:</p>\n\n\n\n<p><a href=\"https://profiles.wordpress.org/aljullu/\">Albert Juhé Lluveras</a>, <a href=\"https://profiles.wordpress.org/ajlende/\">Alex Lende</a>, <a href=\"https://profiles.wordpress.org/alexstine/\">alexstine</a>, <a href=\"https://profiles.wordpress.org/oandregal/\">André</a>, <a href=\"https://profiles.wordpress.org/antonvlasenko/\">Anton Vlasenko</a>, <a href=\"https://profiles.wordpress.org/aristath/\">Ari Stathopoulos</a>, <a href=\"https://profiles.wordpress.org/madeinua/\">ArteMa</a>, <a href=\"https://profiles.wordpress.org/scruffian/\">Ben Dwyer</a>, <a href=\"https://profiles.wordpress.org/blogaid/\">BlogAid</a>, <a href=\"https://profiles.wordpress.org/poena/\">Carolina Nymark</a>, <a href=\"https://profiles.wordpress.org/critterverse/\">Channing Ritter</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten/\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/costdev/\">Colin Stewart</a>, <a href=\"https://profiles.wordpress.org/talldanwp/\">Daniel Richards</a>, <a href=\"https://profiles.wordpress.org/davidbinda/\">David Biňovec</a>, <a href=\"https://profiles.wordpress.org/get_dave/\">David Smith</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/eddystile/\">Eddy</a>, <a href=\"https://profiles.wordpress.org/ellatrix/\">Ella van Durpe</a>, <a href=\"https://profiles.wordpress.org/kebbet/\">Erik</a>, <a href=\"https://profiles.wordpress.org/fabiankaegy/\">Fabian Kägy</a>, <a href=\"https://profiles.wordpress.org/azouamauriac/\">Flinim Asso</a>, <a href=\"https://profiles.wordpress.org/gadhiyaravi/\">gadhiyaravi</a>, <a href=\"https://profiles.wordpress.org/revgeorge/\">George Hotelling</a>, <a href=\"https://profiles.wordpress.org/mamaduka/\">George Mamadashvili</a>, <a href=\"https://profiles.wordpress.org/glendaviesnz/\">glendaviesnz</a>, <a href=\"https://profiles.wordpress.org/gziolo/\">Greg Ziółkowski</a>, <a href=\"https://profiles.wordpress.org/ianatkins/\">ianatkins</a>, <a href=\"https://profiles.wordpress.org/ianbelanger/\">Ian Belanger</a>, <a href=\"https://profiles.wordpress.org/ironprogrammer/\">ironprogrammer</a>, <a href=\"https://profiles.wordpress.org/itsamoreh/\">itsamoreh</a>, <a href=\"https://profiles.wordpress.org/audrasjb/\">Jb Audras</a>, <a href=\"https://profiles.wordpress.org/jffng/\">Jeff Ong</a>, <a href=\"https://profiles.wordpress.org/jeherve/\">Jeremy Herve</a>, <a href=\"https://profiles.wordpress.org/joedolson/\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joen/\">Joen A.</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/desrosj/\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/jorgefilipecosta/\">Jorge Costa</a>, <a href=\"https://profiles.wordpress.org/jrf/\">Juliette Reinders Folmer</a>, <a href=\"https://profiles.wordpress.org/kafleg/\">KafleG</a>, <a href=\"https://profiles.wordpress.org/kapilpaul/\">Kapil Paul</a>, <a href=\"https://profiles.wordpress.org/kjellr/\">Kjell Reigstad</a>, <a href=\"https://profiles.wordpress.org/linux4me2/\">linux4me2</a>, <a href=\"https://profiles.wordpress.org/pyrobd/\">Lukman Nakib</a>, <a href=\"https://profiles.wordpress.org/manfcarlo/\">manfcarlo</a>, <a href=\"https://profiles.wordpress.org/clorith/\">Marius L. J.</a>, <a href=\"https://profiles.wordpress.org/mgol/\">mgol</a>, <a href=\"https://profiles.wordpress.org/nidhidhandhukiya/\">nidhidhandhukiya</a>, <a href=\"https://profiles.wordpress.org/ntsekouras/\">Nik Tsekouras</a>, <a href=\"https://profiles.wordpress.org/alshakero/\">Omar Alshaker</a>, <a href=\"https://profiles.wordpress.org/pls78/\">Paolo L. Scala</a>, <a href=\"https://profiles.wordpress.org/swissspidy/\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/pbearne/\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/malinevskiy/\">Pavlo</a>, <a href=\"https://profiles.wordpress.org/petaryoast/\">Petar Ratković</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/walbo/\">Petter Walbø Johnsgård</a>, <a href=\"https://profiles.wordpress.org/johnstonphilip/\">Phil Johnston</a>, <a href=\"https://profiles.wordpress.org/boniu91/\">Piotrek Boniu</a>, <a href=\"https://profiles.wordpress.org/ravipatel/\">ravipatel</a>, <a href=\"https://profiles.wordpress.org/youknowriad/\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/noisysocks/\">Robert Anderson</a>, <a href=\"https://profiles.wordpress.org/rolfsiebers/\">Rolf Siebers</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov/\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/stacimc/\">stacimc</a>, <a href=\"https://profiles.wordpress.org/sabernhardt/\">Stephen Bernhardt</a>, <a href=\"https://profiles.wordpress.org/mahype/\">Sven Wagener</a>, <a href=\"https://profiles.wordpress.org/staatic/\">Team Staatic</a>, <a href=\"https://profiles.wordpress.org/tnolte/\">Tim Nolte</a>, <a href=\"https://profiles.wordpress.org/hellofromtonya/\">Tonya Mork</a>, <a href=\"https://profiles.wordpress.org/webcommsat/\">webcommsat AbhaNonStopNewsUK</a>, <a href=\"https://profiles.wordpress.org/webmandesign/\">WebMan Design | Oliver Juhas</a>, <a href=\"https://profiles.wordpress.org/antonynz/\">wpcharged</a>, <a href=\"https://profiles.wordpress.org/wpsoul/\">wpsoul</a>, <a href=\"https://profiles.wordpress.org/dolphingg/\">Yunus Ertuğrul</a>, and <a href=\"https://profiles.wordpress.org/rafiahmedd/\">Rafi Ahmed</a>.</p>\n\n\n\n<p>Thanks to <a href=\"https://profiles.wordpress.org/estelaris/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>estelaris</a>, <a href=\"https://profiles.wordpress.org/pbiron/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>pbiron</a>, <a href=\"https://profiles.wordpress.org/ironprogrammer/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>ironprogrammer</a>, <a href=\"https://profiles.wordpress.org/bph/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>bph</a>, <a href=\"https://profiles.wordpress.org/abhanonstopnewsuk/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>abhanonstopnewsuk</a> and <a href=\"https://profiles.wordpress.org/threadi/\" class=\"mention\"><span class=\"mentions-prefix\">@</span>threadi</a> for their help to test the release package.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 15:49:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Jb Audras\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"WPTavern: QuickPost Plugin Allows Users To Create New or Duplicate Posts from the WordPress Content Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wptavern.com/?p=130353\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:117:\"https://wptavern.com/quickpost-plugin-allows-users-to-create-new-or-duplicate-posts-from-the-wordpress-content-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4397:\"<p>There is not much I miss about the classic editor. It was dead to me when the block system became the new normal. However, there might be a feature or two that I miss.</p>\n\n\n\n<p><em>The biggest of those features?</em> The &#8220;Add New&#8221; button at the top of the post editor.</p>\n\n\n\n<img />&#8220;Add New&#8221; button in the classic editor.\n\n\n\n<p>So, when Aurooba Ahmed mentioned that she was building a plugin to address this very problem on Twitter, I took note, eagerly awaiting the day of its release. Losing the button for adding a new post was a user experience regression, and her <a href=\"https://wordpress.org/plugins/quickpost/\">QuickPost plugin</a> rights one of the wrongs with the block editor that has long gone unfixed.</p>\n\n\n\n<p>This is particularly true for fullscreen users. They have no quick access to the Add New links available via the toolbar or admin menu. Neither are shown in fullscreen mode.</p>\n\n\n\n<p>The plugin works right out of the box. There are no settings to configure. Just install, activate, and look for the Add New button to appear when editing a post.</p>\n\n\n\n<img />Block editor with &#8220;Add New&#8221; button.\n\n\n\n<p>The button also comes with an extra option for duplicating posts. It is available by clicking the vertical ellipsis icon on the side of the button.</p>\n\n\n\n<p>Ahmed argues in her <a href=\"https://aurooba.com/quickpost/\">announcement post</a> that the duplicate-post feature is a fundamental part of content publishing:</p>\n\n\n\n<blockquote class=\"wp-block-quote has-primary-font-family is-style-default has-lg-font-size\"><p>This functionality is core to anything that provides a content creation experience (excluding social media). Can you imagine Microsoft Word without the &#8220;Save As..&#8221; feature, that essentially serves as a way to duplicate documents? Or the &#8220;Open a copy&#8221; feature they later introduced?</p></blockquote>\n\n\n\n<p>I agree. It has long been needed as a core feature and the active install numbers from <a href=\"https://wordpress.org/plugins/search/duplicate+post/\">plugins that offer it</a> back it up.</p>\n\n\n\n<p>To copy a post, users need to only click the &#8220;Duplicate Post&#8221; button. The plugin will create the copy and transfer the user over to the editing screen for it:</p>\n\n\n\n<img />Duplicated post.\n\n\n\n<p>The plugin automatically copies the post data and metadata. It only changes the title of the duplicate post to &#8220;Copy of Post Title.&#8221; Ahmed noted in the announcement that she might add a feature for customizing this in the future.</p>\n\n\n\n<p>She also said she is thinking of other features to improve the plugin. The ideas include batch duplication, a new post keyboard shortcut, and more UI improvements.</p>\n\n\n\n<p>For my own workflow where I might be working on multiple pieces of content at once, QuickPost feels like it is mere inches away from perfection. One of the downsides of the plugin&#8217;s &#8220;Add New&#8221; button is that it is literally a <code>&lt;button></code> element. This means that users cannot right-click on it and open a new post editor in another browser tab/window. For that functionality, the button would need to be a link (<code>&lt;a></code>) element. This is also the difference between the plugin and the classic editor.</p>\n\n\n\n<p>QuickPost is also a quick answer for a more in-depth issue around navigating content. Ahmed recently <a href=\"https://github.com/WordPress/gutenberg/issues/38554\">opened a ticket</a> for adding a sidebar while in fullscreen mode, which would house links to Posts, Add New Post, and Duplicate Post. The proposal would create a UI that could look like the following:</p>\n\n\n\n<img />Proposed UI (draft) for adding content navigation.\n\n\n\n<p>Do not expect this to land in WordPress any time soon. A <a href=\"https://github.com/WordPress/gutenberg/issues/23328\">browse mode</a> for the site editor is on the 6.0 roadmap, but bringing such a navigation element to the content editor will have to wait.</p>\n\n\n\n<p>There is a ton of discussion to unpack in Ahmed&#8217;s ticket, and it is probably deserving of its own post here at the Tavern. For now, at least some users have access to much-needed features via the QuickPost plugin.</p>\n\n\n\n<div class=\"wp-block-embed__wrapper\">\n<blockquote class=\"wp-embedded-content\"><a href=\"https://wordpress.org/plugins/quickpost/\">QuickPost</a></blockquote>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Feb 2022 00:44:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Justin Tadlock\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:42:\"Requests_Utility_CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 07 Mar 2022 22:50:14 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Mon, 07 Mar 2022 22:45:07 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:9:\"HIT ord 2\";s:16:\"content-encoding\";s:4:\"gzip\";}}s:5:\"build\";s:14:\"20220307224835\";}", "no");
INSERT INTO `wp_options` VALUES("228", "_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1646736614", "no");
INSERT INTO `wp_options` VALUES("229", "_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1646693414", "no");
INSERT INTO `wp_options` VALUES("230", "_transient_timeout_dash_v2_88ae138922fe95674369b1cb3d215a2b", "1646736614", "no");
INSERT INTO `wp_options` VALUES("231", "_transient_dash_v2_88ae138922fe95674369b1cb3d215a2b", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2022/03/episode-26-matt-mullenweg-on-ukraine-community-and-wordpress/\'>WP Briefing: Episode 26: Matt Mullenweg on Ukraine, Community, and WordPress</a></li><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2022/03/the-month-in-wordpress-february-2022/\'>The Month in WordPress – February 2022</a></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://poststatus.com/post-status-excerpt-no-49-performance-team-checkin/\'>Post Status: Post Status Excerpt (No. 49) — Performance Team Check-in</a></li><li><a class=\'rsswidget\' href=\'https://gutenbergtimes.com/introducing-the-museum-of-block-art-moba/\'>Gutenberg Times: Introducing the Museum of Block Art (MOBA)</a></li><li><a class=\'rsswidget\' href=\'https://gutenbergtimes.com/podcast/gutenberg-changelog-62-gutenberg-12-7-a-new-call-for-testing-the-web-fonts-api-arrival/\'>Gutenberg Times: Gutenberg Changelog #62 – Gutenberg 12.7, a New Call for Testing, the Web Fonts API Arrival</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("234", "_transient_timeout_global_styles_twentytwenty", "1646693730", "no");
INSERT INTO `wp_options` VALUES("235", "_transient_global_styles_twentytwenty", "body{--wp--preset--color--black: #000000;--wp--preset--color--cyan-bluish-gray: #abb8c3;--wp--preset--color--white: #ffffff;--wp--preset--color--pale-pink: #f78da7;--wp--preset--color--vivid-red: #cf2e2e;--wp--preset--color--luminous-vivid-orange: #ff6900;--wp--preset--color--luminous-vivid-amber: #fcb900;--wp--preset--color--light-green-cyan: #7bdcb5;--wp--preset--color--vivid-green-cyan: #00d084;--wp--preset--color--pale-cyan-blue: #8ed1fc;--wp--preset--color--vivid-cyan-blue: #0693e3;--wp--preset--color--vivid-purple: #9b51e0;--wp--preset--color--accent: #cd2653;--wp--preset--color--primary: #000000;--wp--preset--color--secondary: #6d6d6d;--wp--preset--color--subtle-background: #dcd7ca;--wp--preset--color--background: #f5efe0;--wp--preset--gradient--vivid-cyan-blue-to-vivid-purple: linear-gradient(135deg,rgba(6,147,227,1) 0%,rgb(155,81,224) 100%);--wp--preset--gradient--light-green-cyan-to-vivid-green-cyan: linear-gradient(135deg,rgb(122,220,180) 0%,rgb(0,208,130) 100%);--wp--preset--gradient--luminous-vivid-amber-to-luminous-vivid-orange: linear-gradient(135deg,rgba(252,185,0,1) 0%,rgba(255,105,0,1) 100%);--wp--preset--gradient--luminous-vivid-orange-to-vivid-red: linear-gradient(135deg,rgba(255,105,0,1) 0%,rgb(207,46,46) 100%);--wp--preset--gradient--very-light-gray-to-cyan-bluish-gray: linear-gradient(135deg,rgb(238,238,238) 0%,rgb(169,184,195) 100%);--wp--preset--gradient--cool-to-warm-spectrum: linear-gradient(135deg,rgb(74,234,220) 0%,rgb(151,120,209) 20%,rgb(207,42,186) 40%,rgb(238,44,130) 60%,rgb(251,105,98) 80%,rgb(254,248,76) 100%);--wp--preset--gradient--blush-light-purple: linear-gradient(135deg,rgb(255,206,236) 0%,rgb(152,150,240) 100%);--wp--preset--gradient--blush-bordeaux: linear-gradient(135deg,rgb(254,205,165) 0%,rgb(254,45,45) 50%,rgb(107,0,62) 100%);--wp--preset--gradient--luminous-dusk: linear-gradient(135deg,rgb(255,203,112) 0%,rgb(199,81,192) 50%,rgb(65,88,208) 100%);--wp--preset--gradient--pale-ocean: linear-gradient(135deg,rgb(255,245,203) 0%,rgb(182,227,212) 50%,rgb(51,167,181) 100%);--wp--preset--gradient--electric-grass: linear-gradient(135deg,rgb(202,248,128) 0%,rgb(113,206,126) 100%);--wp--preset--gradient--midnight: linear-gradient(135deg,rgb(2,3,129) 0%,rgb(40,116,252) 100%);--wp--preset--duotone--dark-grayscale: url(\'#wp-duotone-dark-grayscale\');--wp--preset--duotone--grayscale: url(\'#wp-duotone-grayscale\');--wp--preset--duotone--purple-yellow: url(\'#wp-duotone-purple-yellow\');--wp--preset--duotone--blue-red: url(\'#wp-duotone-blue-red\');--wp--preset--duotone--midnight: url(\'#wp-duotone-midnight\');--wp--preset--duotone--magenta-yellow: url(\'#wp-duotone-magenta-yellow\');--wp--preset--duotone--purple-green: url(\'#wp-duotone-purple-green\');--wp--preset--duotone--blue-orange: url(\'#wp-duotone-blue-orange\');--wp--preset--font-size--small: 18px;--wp--preset--font-size--medium: 20px;--wp--preset--font-size--large: 26.25px;--wp--preset--font-size--x-large: 42px;--wp--preset--font-size--normal: 21px;--wp--preset--font-size--larger: 32px;}.has-black-color{color: var(--wp--preset--color--black) !important;}.has-cyan-bluish-gray-color{color: var(--wp--preset--color--cyan-bluish-gray) !important;}.has-white-color{color: var(--wp--preset--color--white) !important;}.has-pale-pink-color{color: var(--wp--preset--color--pale-pink) !important;}.has-vivid-red-color{color: var(--wp--preset--color--vivid-red) !important;}.has-luminous-vivid-orange-color{color: var(--wp--preset--color--luminous-vivid-orange) !important;}.has-luminous-vivid-amber-color{color: var(--wp--preset--color--luminous-vivid-amber) !important;}.has-light-green-cyan-color{color: var(--wp--preset--color--light-green-cyan) !important;}.has-vivid-green-cyan-color{color: var(--wp--preset--color--vivid-green-cyan) !important;}.has-pale-cyan-blue-color{color: var(--wp--preset--color--pale-cyan-blue) !important;}.has-vivid-cyan-blue-color{color: var(--wp--preset--color--vivid-cyan-blue) !important;}.has-vivid-purple-color{color: var(--wp--preset--color--vivid-purple) !important;}.has-black-background-color{background-color: var(--wp--preset--color--black) !important;}.has-cyan-bluish-gray-background-color{background-color: var(--wp--preset--color--cyan-bluish-gray) !important;}.has-white-background-color{background-color: var(--wp--preset--color--white) !important;}.has-pale-pink-background-color{background-color: var(--wp--preset--color--pale-pink) !important;}.has-vivid-red-background-color{background-color: var(--wp--preset--color--vivid-red) !important;}.has-luminous-vivid-orange-background-color{background-color: var(--wp--preset--color--luminous-vivid-orange) !important;}.has-luminous-vivid-amber-background-color{background-color: var(--wp--preset--color--luminous-vivid-amber) !important;}.has-light-green-cyan-background-color{background-color: var(--wp--preset--color--light-green-cyan) !important;}.has-vivid-green-cyan-background-color{background-color: var(--wp--preset--color--vivid-green-cyan) !important;}.has-pale-cyan-blue-background-color{background-color: var(--wp--preset--color--pale-cyan-blue) !important;}.has-vivid-cyan-blue-background-color{background-color: var(--wp--preset--color--vivid-cyan-blue) !important;}.has-vivid-purple-background-color{background-color: var(--wp--preset--color--vivid-purple) !important;}.has-black-border-color{border-color: var(--wp--preset--color--black) !important;}.has-cyan-bluish-gray-border-color{border-color: var(--wp--preset--color--cyan-bluish-gray) !important;}.has-white-border-color{border-color: var(--wp--preset--color--white) !important;}.has-pale-pink-border-color{border-color: var(--wp--preset--color--pale-pink) !important;}.has-vivid-red-border-color{border-color: var(--wp--preset--color--vivid-red) !important;}.has-luminous-vivid-orange-border-color{border-color: var(--wp--preset--color--luminous-vivid-orange) !important;}.has-luminous-vivid-amber-border-color{border-color: var(--wp--preset--color--luminous-vivid-amber) !important;}.has-light-green-cyan-border-color{border-color: var(--wp--preset--color--light-green-cyan) !important;}.has-vivid-green-cyan-border-color{border-color: var(--wp--preset--color--vivid-green-cyan) !important;}.has-pale-cyan-blue-border-color{border-color: var(--wp--preset--color--pale-cyan-blue) !important;}.has-vivid-cyan-blue-border-color{border-color: var(--wp--preset--color--vivid-cyan-blue) !important;}.has-vivid-purple-border-color{border-color: var(--wp--preset--color--vivid-purple) !important;}.has-vivid-cyan-blue-to-vivid-purple-gradient-background{background: var(--wp--preset--gradient--vivid-cyan-blue-to-vivid-purple) !important;}.has-light-green-cyan-to-vivid-green-cyan-gradient-background{background: var(--wp--preset--gradient--light-green-cyan-to-vivid-green-cyan) !important;}.has-luminous-vivid-amber-to-luminous-vivid-orange-gradient-background{background: var(--wp--preset--gradient--luminous-vivid-amber-to-luminous-vivid-orange) !important;}.has-luminous-vivid-orange-to-vivid-red-gradient-background{background: var(--wp--preset--gradient--luminous-vivid-orange-to-vivid-red) !important;}.has-very-light-gray-to-cyan-bluish-gray-gradient-background{background: var(--wp--preset--gradient--very-light-gray-to-cyan-bluish-gray) !important;}.has-cool-to-warm-spectrum-gradient-background{background: var(--wp--preset--gradient--cool-to-warm-spectrum) !important;}.has-blush-light-purple-gradient-background{background: var(--wp--preset--gradient--blush-light-purple) !important;}.has-blush-bordeaux-gradient-background{background: var(--wp--preset--gradient--blush-bordeaux) !important;}.has-luminous-dusk-gradient-background{background: var(--wp--preset--gradient--luminous-dusk) !important;}.has-pale-ocean-gradient-background{background: var(--wp--preset--gradient--pale-ocean) !important;}.has-electric-grass-gradient-background{background: var(--wp--preset--gradient--electric-grass) !important;}.has-midnight-gradient-background{background: var(--wp--preset--gradient--midnight) !important;}.has-small-font-size{font-size: var(--wp--preset--font-size--small) !important;}.has-medium-font-size{font-size: var(--wp--preset--font-size--medium) !important;}.has-large-font-size{font-size: var(--wp--preset--font-size--large) !important;}.has-x-large-font-size{font-size: var(--wp--preset--font-size--x-large) !important;}", "no");
INSERT INTO `wp_options` VALUES("236", "_transient_timeout_global_styles_svg_filters_twentytwenty", "1646693730", "no");
INSERT INTO `wp_options` VALUES("237", "_transient_global_styles_svg_filters_twentytwenty", "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-dark-grayscale\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 0.49803921568627\" /><feFuncG type=\"table\" tableValues=\"0 0.49803921568627\" /><feFuncB type=\"table\" tableValues=\"0 0.49803921568627\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-grayscale\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 1\" /><feFuncG type=\"table\" tableValues=\"0 1\" /><feFuncB type=\"table\" tableValues=\"0 1\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-purple-yellow\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.54901960784314 0.98823529411765\" /><feFuncG type=\"table\" tableValues=\"0 1\" /><feFuncB type=\"table\" tableValues=\"0.71764705882353 0.25490196078431\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-blue-red\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 1\" /><feFuncG type=\"table\" tableValues=\"0 0.27843137254902\" /><feFuncB type=\"table\" tableValues=\"0.5921568627451 0.27843137254902\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-midnight\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 0\" /><feFuncG type=\"table\" tableValues=\"0 0.64705882352941\" /><feFuncB type=\"table\" tableValues=\"0 1\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-magenta-yellow\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.78039215686275 1\" /><feFuncG type=\"table\" tableValues=\"0 0.94901960784314\" /><feFuncB type=\"table\" tableValues=\"0.35294117647059 0.47058823529412\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-purple-green\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.65098039215686 0.40392156862745\" /><feFuncG type=\"table\" tableValues=\"0 1\" /><feFuncB type=\"table\" tableValues=\"0.44705882352941 0.4\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-blue-orange\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.098039215686275 1\" /><feFuncG type=\"table\" tableValues=\"0 0.66274509803922\" /><feFuncB type=\"table\" tableValues=\"0.84705882352941 0.41960784313725\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg>", "no");
INSERT INTO `wp_options` VALUES("238", "_site_transient_timeout_php_check_ecfa741d55b7b1a85bd61a2307877c8c", "1647298480", "no");
INSERT INTO `wp_options` VALUES("239", "_site_transient_php_check_ecfa741d55b7b1a85bd61a2307877c8c", "a:5:{s:19:\"recommended_version\";s:3:\"7.4\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}", "no");
INSERT INTO `wp_options` VALUES("240", "advgb_custom_styles", "a:8:{i:0;a:5:{s:2:\"id\";i:1;s:5:\"title\";s:12:\"Blue message\";s:4:\"name\";s:12:\"blue-message\";s:13:\"identifyColor\";s:7:\"#3399ff\";s:3:\"css\";s:149:\"background: none repeat scroll 0 0 #3399ff;\n    color: #ffffff;\n    text-shadow: none;\n    font-size: 16px;\n    line-height: 24px;\n    padding: 10px;\";}i:1;a:5:{s:2:\"id\";i:2;s:5:\"title\";s:13:\"Green message\";s:4:\"name\";s:13:\"green-message\";s:13:\"identifyColor\";s:7:\"#8cc14c\";s:3:\"css\";s:149:\"background: none repeat scroll 0 0 #8cc14c;\n    color: #ffffff;\n    text-shadow: none;\n    font-size: 16px;\n    line-height: 24px;\n    padding: 10px;\";}i:2;a:5:{s:2:\"id\";i:3;s:5:\"title\";s:14:\"Orange message\";s:4:\"name\";s:14:\"orange-message\";s:13:\"identifyColor\";s:7:\"#faa732\";s:3:\"css\";s:149:\"background: none repeat scroll 0 0 #faa732;\n    color: #ffffff;\n    text-shadow: none;\n    font-size: 16px;\n    line-height: 24px;\n    padding: 10px;\";}i:3;a:5:{s:2:\"id\";i:4;s:5:\"title\";s:11:\"Red message\";s:4:\"name\";s:11:\"red-message\";s:13:\"identifyColor\";s:7:\"#da4d31\";s:3:\"css\";s:149:\"background: none repeat scroll 0 0 #da4d31;\n    color: #ffffff;\n    text-shadow: none;\n    font-size: 16px;\n    line-height: 24px;\n    padding: 10px;\";}i:4;a:5:{s:2:\"id\";i:5;s:5:\"title\";s:12:\"Grey message\";s:4:\"name\";s:12:\"grey-message\";s:13:\"identifyColor\";s:7:\"#53555c\";s:3:\"css\";s:149:\"background: none repeat scroll 0 0 #53555c;\n    color: #ffffff;\n    text-shadow: none;\n    font-size: 16px;\n    line-height: 24px;\n    padding: 10px;\";}i:5;a:5:{s:2:\"id\";i:6;s:5:\"title\";s:10:\"Left block\";s:4:\"name\";s:10:\"left-block\";s:13:\"identifyColor\";s:7:\"#ff00ff\";s:3:\"css\";s:215:\"background: none repeat scroll 0 0px, radial-gradient(ellipse at center center, #ffffff 0%, #f2f2f2 100%) repeat scroll 0 0 rgba(0, 0, 0, 0);\n    color: #8b8e97;\n    padding: 10px;\n    margin: 10px;\n    float: left;\";}i:6;a:5:{s:2:\"id\";i:7;s:5:\"title\";s:11:\"Right block\";s:4:\"name\";s:11:\"right-block\";s:13:\"identifyColor\";s:7:\"#00ddff\";s:3:\"css\";s:216:\"background: none repeat scroll 0 0px, radial-gradient(ellipse at center center, #ffffff 0%, #f2f2f2 100%) repeat scroll 0 0 rgba(0, 0, 0, 0);\n    color: #8b8e97;\n    padding: 10px;\n    margin: 10px;\n    float: right;\";}i:7;a:5:{s:2:\"id\";i:8;s:5:\"title\";s:11:\"Blockquotes\";s:4:\"name\";s:11:\"blockquotes\";s:13:\"identifyColor\";s:7:\"#cccccc\";s:3:\"css\";s:217:\"background: none;\n    border-left: 5px solid #f1f1f1;\n    color: #8B8E97;\n    font-size: 16px;\n    font-style: italic;\n    line-height: 22px;\n    padding-left: 15px;\n    padding: 10px;\n    width: 60%;\n    float: left;\";}}", "yes");
INSERT INTO `wp_options` VALUES("241", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1646704751", "no");
INSERT INTO `wp_options` VALUES("242", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "O:8:\"stdClass\":100:{s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";i:5409;}s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";i:4784;}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";i:2749;}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";i:2615;}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";i:2025;}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";i:1876;}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";i:1871;}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";i:1554;}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";i:1542;}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";i:1520;}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";i:1515;}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";i:1505;}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";i:1486;}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";i:1353;}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";i:1313;}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";i:1309;}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";i:1252;}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";i:1168;}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";i:1141;}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";i:1097;}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";i:994;}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";i:954;}s:10:\"e-commerce\";a:3:{s:4:\"name\";s:10:\"e-commerce\";s:4:\"slug\";s:10:\"e-commerce\";s:5:\"count\";i:940;}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";i:928;}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";i:893;}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";i:850;}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";i:836;}s:9:\"analytics\";a:3:{s:4:\"name\";s:9:\"analytics\";s:4:\"slug\";s:9:\"analytics\";s:5:\"count\";i:835;}s:6:\"slider\";a:3:{s:4:\"name\";s:6:\"slider\";s:4:\"slug\";s:6:\"slider\";s:5:\"count\";i:834;}s:4:\"form\";a:3:{s:4:\"name\";s:4:\"form\";s:4:\"slug\";s:4:\"form\";s:5:\"count\";i:818;}s:7:\"payment\";a:3:{s:4:\"name\";s:7:\"payment\";s:4:\"slug\";s:7:\"payment\";s:5:\"count\";i:774;}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";i:771;}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";i:769;}s:6:\"search\";a:3:{s:4:\"name\";s:6:\"search\";s:4:\"slug\";s:6:\"search\";s:5:\"count\";i:748;}s:6:\"editor\";a:3:{s:4:\"name\";s:6:\"editor\";s:4:\"slug\";s:6:\"editor\";s:5:\"count\";i:745;}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";i:728;}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";i:721;}s:9:\"gutenberg\";a:3:{s:4:\"name\";s:9:\"gutenberg\";s:4:\"slug\";s:9:\"gutenberg\";s:5:\"count\";i:717;}s:4:\"menu\";a:3:{s:4:\"name\";s:4:\"menu\";s:4:\"slug\";s:4:\"menu\";s:5:\"count\";i:702;}s:12:\"contact-form\";a:3:{s:4:\"name\";s:12:\"contact form\";s:4:\"slug\";s:12:\"contact-form\";s:5:\"count\";i:687;}s:15:\"payment-gateway\";a:3:{s:4:\"name\";s:15:\"payment gateway\";s:4:\"slug\";s:15:\"payment-gateway\";s:5:\"count\";i:681;}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";i:672;}s:5:\"embed\";a:3:{s:4:\"name\";s:5:\"embed\";s:4:\"slug\";s:5:\"embed\";s:5:\"count\";i:670;}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";i:668;}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";i:667;}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"ajax\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";i:659;}s:5:\"block\";a:3:{s:4:\"name\";s:5:\"block\";s:4:\"slug\";s:5:\"block\";s:5:\"count\";i:619;}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";i:611;}s:3:\"css\";a:3:{s:4:\"name\";s:3:\"css\";s:4:\"slug\";s:3:\"css\";s:5:\"count\";i:608;}s:9:\"elementor\";a:3:{s:4:\"name\";s:9:\"elementor\";s:4:\"slug\";s:9:\"elementor\";s:5:\"count\";i:599;}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";i:598;}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";i:596;}s:9:\"affiliate\";a:3:{s:4:\"name\";s:9:\"affiliate\";s:4:\"slug\";s:9:\"affiliate\";s:5:\"count\";i:589;}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";i:580;}s:10:\"responsive\";a:3:{s:4:\"name\";s:10:\"responsive\";s:4:\"slug\";s:10:\"responsive\";s:5:\"count\";i:573;}s:9:\"dashboard\";a:3:{s:4:\"name\";s:9:\"dashboard\";s:4:\"slug\";s:9:\"dashboard\";s:5:\"count\";i:573;}s:3:\"api\";a:3:{s:4:\"name\";s:3:\"api\";s:4:\"slug\";s:3:\"api\";s:5:\"count\";i:572;}s:5:\"theme\";a:3:{s:4:\"name\";s:5:\"theme\";s:4:\"slug\";s:5:\"theme\";s:5:\"count\";i:569;}s:7:\"contact\";a:3:{s:4:\"name\";s:7:\"contact\";s:4:\"slug\";s:7:\"contact\";s:5:\"count\";i:566;}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";i:562;}s:3:\"ads\";a:3:{s:4:\"name\";s:3:\"ads\";s:4:\"slug\";s:3:\"ads\";s:5:\"count\";i:553;}s:6:\"custom\";a:3:{s:4:\"name\";s:6:\"custom\";s:4:\"slug\";s:6:\"custom\";s:5:\"count\";i:546;}s:10:\"categories\";a:3:{s:4:\"name\";s:10:\"categories\";s:4:\"slug\";s:10:\"categories\";s:5:\"count\";i:536;}s:4:\"user\";a:3:{s:4:\"name\";s:4:\"user\";s:4:\"slug\";s:4:\"user\";s:5:\"count\";i:525;}s:6:\"events\";a:3:{s:4:\"name\";s:6:\"events\";s:4:\"slug\";s:6:\"events\";s:5:\"count\";i:522;}s:6:\"button\";a:3:{s:4:\"name\";s:6:\"button\";s:4:\"slug\";s:6:\"button\";s:5:\"count\";i:521;}s:9:\"marketing\";a:3:{s:4:\"name\";s:9:\"marketing\";s:4:\"slug\";s:9:\"marketing\";s:5:\"count\";i:520;}s:6:\"mobile\";a:3:{s:4:\"name\";s:6:\"mobile\";s:4:\"slug\";s:6:\"mobile\";s:5:\"count\";i:505;}s:4:\"chat\";a:3:{s:4:\"name\";s:4:\"chat\";s:4:\"slug\";s:4:\"chat\";s:5:\"count\";i:505;}s:4:\"tags\";a:3:{s:4:\"name\";s:4:\"tags\";s:4:\"slug\";s:4:\"tags\";s:5:\"count\";i:505;}s:8:\"shipping\";a:3:{s:4:\"name\";s:8:\"shipping\";s:4:\"slug\";s:8:\"shipping\";s:5:\"count\";i:503;}s:5:\"users\";a:3:{s:4:\"name\";s:5:\"users\";s:4:\"slug\";s:5:\"users\";s:5:\"count\";i:492;}s:5:\"popup\";a:3:{s:4:\"name\";s:5:\"popup\";s:4:\"slug\";s:5:\"popup\";s:5:\"count\";i:490;}s:14:\"contact-form-7\";a:3:{s:4:\"name\";s:14:\"contact form 7\";s:4:\"slug\";s:14:\"contact-form-7\";s:5:\"count\";i:488;}s:5:\"forms\";a:3:{s:4:\"name\";s:5:\"forms\";s:4:\"slug\";s:5:\"forms\";s:5:\"count\";i:486;}s:8:\"calendar\";a:3:{s:4:\"name\";s:8:\"calendar\";s:4:\"slug\";s:8:\"calendar\";s:5:\"count\";i:480;}s:10:\"newsletter\";a:3:{s:4:\"name\";s:10:\"newsletter\";s:4:\"slug\";s:10:\"newsletter\";s:5:\"count\";i:457;}s:10:\"navigation\";a:3:{s:4:\"name\";s:10:\"navigation\";s:4:\"slug\";s:10:\"navigation\";s:5:\"count\";i:452;}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";i:451;}s:9:\"slideshow\";a:3:{s:4:\"name\";s:9:\"slideshow\";s:4:\"slug\";s:9:\"slideshow\";s:5:\"count\";i:444;}s:11:\"performance\";a:3:{s:4:\"name\";s:11:\"performance\";s:4:\"slug\";s:11:\"performance\";s:5:\"count\";i:439;}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";i:437;}s:10:\"statistics\";a:3:{s:4:\"name\";s:10:\"statistics\";s:4:\"slug\";s:10:\"statistics\";s:5:\"count\";i:429;}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";i:426;}s:12:\"social-media\";a:3:{s:4:\"name\";s:12:\"social media\";s:4:\"slug\";s:12:\"social-media\";s:5:\"count\";i:418;}s:8:\"redirect\";a:3:{s:4:\"name\";s:8:\"redirect\";s:4:\"slug\";s:8:\"redirect\";s:5:\"count\";i:417;}s:4:\"news\";a:3:{s:4:\"name\";s:4:\"news\";s:4:\"slug\";s:4:\"news\";s:5:\"count\";i:411;}s:12:\"notification\";a:3:{s:4:\"name\";s:12:\"notification\";s:4:\"slug\";s:12:\"notification\";s:5:\"count\";i:407;}s:10:\"shortcodes\";a:3:{s:4:\"name\";s:10:\"shortcodes\";s:4:\"slug\";s:10:\"shortcodes\";s:5:\"count\";i:405;}s:6:\"blocks\";a:3:{s:4:\"name\";s:6:\"blocks\";s:4:\"slug\";s:6:\"blocks\";s:5:\"count\";i:401;}s:8:\"tracking\";a:3:{s:4:\"name\";s:8:\"tracking\";s:4:\"slug\";s:8:\"tracking\";s:5:\"count\";i:394;}s:4:\"code\";a:3:{s:4:\"name\";s:4:\"code\";s:4:\"slug\";s:4:\"code\";s:5:\"count\";i:394;}s:6:\"import\";a:3:{s:4:\"name\";s:6:\"import\";s:4:\"slug\";s:6:\"import\";s:5:\"count\";i:392;}s:7:\"plugins\";a:3:{s:4:\"name\";s:7:\"plugins\";s:4:\"slug\";s:7:\"plugins\";s:5:\"count\";i:392;}s:9:\"multisite\";a:3:{s:4:\"name\";s:9:\"multisite\";s:4:\"slug\";s:9:\"multisite\";s:5:\"count\";i:389;}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"url\";s:4:\"slug\";s:3:\"url\";s:5:\"count\";i:385;}s:4:\"meta\";a:3:{s:4:\"name\";s:4:\"meta\";s:4:\"slug\";s:4:\"meta\";s:5:\"count\";i:378;}s:7:\"gateway\";a:3:{s:4:\"name\";s:7:\"gateway\";s:4:\"slug\";s:7:\"gateway\";s:5:\"count\";i:375;}s:4:\"list\";a:3:{s:4:\"name\";s:4:\"list\";s:4:\"slug\";s:4:\"list\";s:5:\"count\";i:375;}s:16:\"google-analytics\";a:3:{s:4:\"name\";s:16:\"google analytics\";s:4:\"slug\";s:16:\"google-analytics\";s:5:\"count\";i:369;}}", "no");
INSERT INTO `wp_options` VALUES("245", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1646694233;s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:8:{s:30:\"advanced-custom-fields/acf.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:36:\"w.org/plugins/advanced-custom-fields\";s:4:\"slug\";s:22:\"advanced-custom-fields\";s:6:\"plugin\";s:30:\"advanced-custom-fields/acf.php\";s:11:\"new_version\";s:4:\"5.12\";s:3:\"url\";s:53:\"https://wordpress.org/plugins/advanced-custom-fields/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/advanced-custom-fields.5.12.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:75:\"https://ps.w.org/advanced-custom-fields/assets/icon-256x256.png?rev=1082746\";s:2:\"1x\";s:75:\"https://ps.w.org/advanced-custom-fields/assets/icon-128x128.png?rev=1082746\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:78:\"https://ps.w.org/advanced-custom-fields/assets/banner-1544x500.jpg?rev=1729099\";s:2:\"1x\";s:77:\"https://ps.w.org/advanced-custom-fields/assets/banner-772x250.jpg?rev=1729102\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.7\";}s:43:\"custom-post-type-ui/custom-post-type-ui.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:33:\"w.org/plugins/custom-post-type-ui\";s:4:\"slug\";s:19:\"custom-post-type-ui\";s:6:\"plugin\";s:43:\"custom-post-type-ui/custom-post-type-ui.php\";s:11:\"new_version\";s:6:\"1.10.2\";s:3:\"url\";s:50:\"https://wordpress.org/plugins/custom-post-type-ui/\";s:7:\"package\";s:69:\"https://downloads.wordpress.org/plugin/custom-post-type-ui.1.10.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:72:\"https://ps.w.org/custom-post-type-ui/assets/icon-256x256.png?rev=2549362\";s:2:\"1x\";s:72:\"https://ps.w.org/custom-post-type-ui/assets/icon-128x128.png?rev=2549362\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:75:\"https://ps.w.org/custom-post-type-ui/assets/banner-1544x500.png?rev=2549362\";s:2:\"1x\";s:74:\"https://ps.w.org/custom-post-type-ui/assets/banner-772x250.png?rev=2549362\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.5\";}s:32:\"duplicate-page/duplicatepage.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:28:\"w.org/plugins/duplicate-page\";s:4:\"slug\";s:14:\"duplicate-page\";s:6:\"plugin\";s:32:\"duplicate-page/duplicatepage.php\";s:11:\"new_version\";s:5:\"4.4.8\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/duplicate-page/\";s:7:\"package\";s:57:\"https://downloads.wordpress.org/plugin/duplicate-page.zip\";s:5:\"icons\";a:1:{s:2:\"1x\";s:67:\"https://ps.w.org/duplicate-page/assets/icon-128x128.jpg?rev=1412874\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:69:\"https://ps.w.org/duplicate-page/assets/banner-772x250.jpg?rev=1410328\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"3.4\";}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:5:\"1.4.4\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/duplicator.1.4.4.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/duplicator/assets/icon-256x256.png?rev=2605836\";s:2:\"1x\";s:63:\"https://ps.w.org/duplicator/assets/icon-128x128.png?rev=2605835\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/duplicator/assets/banner-772x250.png?rev=2085472\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.0\";}s:27:\"ninja-forms/ninja-forms.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:25:\"w.org/plugins/ninja-forms\";s:4:\"slug\";s:11:\"ninja-forms\";s:6:\"plugin\";s:27:\"ninja-forms/ninja-forms.php\";s:11:\"new_version\";s:5:\"3.6.7\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/ninja-forms/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/ninja-forms.3.6.7.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/ninja-forms/assets/icon-256x256.png?rev=1649747\";s:2:\"1x\";s:64:\"https://ps.w.org/ninja-forms/assets/icon-128x128.png?rev=1649747\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/ninja-forms/assets/banner-1544x500.png?rev=2069024\";s:2:\"1x\";s:66:\"https://ps.w.org/ninja-forms/assets/banner-772x250.png?rev=2069024\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.6\";}s:41:\"advanced-gutenberg/advanced-gutenberg.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:32:\"w.org/plugins/advanced-gutenberg\";s:4:\"slug\";s:18:\"advanced-gutenberg\";s:6:\"plugin\";s:41:\"advanced-gutenberg/advanced-gutenberg.php\";s:11:\"new_version\";s:6:\"2.11.5\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/advanced-gutenberg/\";s:7:\"package\";s:68:\"https://downloads.wordpress.org/plugin/advanced-gutenberg.2.11.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:71:\"https://ps.w.org/advanced-gutenberg/assets/icon-256x256.png?rev=2467302\";s:2:\"1x\";s:71:\"https://ps.w.org/advanced-gutenberg/assets/icon-128x128.png?rev=2467302\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/advanced-gutenberg/assets/banner-1544x500.png?rev=2389802\";s:2:\"1x\";s:73:\"https://ps.w.org/advanced-gutenberg/assets/banner-772x250.png?rev=2389802\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.0\";}s:47:\"show-current-template/show-current-template.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:35:\"w.org/plugins/show-current-template\";s:4:\"slug\";s:21:\"show-current-template\";s:6:\"plugin\";s:47:\"show-current-template/show-current-template.php\";s:11:\"new_version\";s:5:\"0.4.6\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/show-current-template/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/show-current-template.0.4.6.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:73:\"https://ps.w.org/show-current-template/assets/icon-256x256.png?rev=976031\";s:2:\"1x\";s:65:\"https://ps.w.org/show-current-template/assets/icon.svg?rev=976031\";s:3:\"svg\";s:65:\"https://ps.w.org/show-current-template/assets/icon.svg?rev=976031\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"3.5\";}s:21:\"unsplash/unsplash.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:22:\"w.org/plugins/unsplash\";s:4:\"slug\";s:8:\"unsplash\";s:6:\"plugin\";s:21:\"unsplash/unsplash.php\";s:11:\"new_version\";s:5:\"1.0.1\";s:3:\"url\";s:39:\"https://wordpress.org/plugins/unsplash/\";s:7:\"package\";s:57:\"https://downloads.wordpress.org/plugin/unsplash.1.0.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:61:\"https://ps.w.org/unsplash/assets/icon-256x256.png?rev=2344056\";s:2:\"1x\";s:61:\"https://ps.w.org/unsplash/assets/icon-128x128.png?rev=2344056\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/unsplash/assets/banner-1544x500.png?rev=2344056\";s:2:\"1x\";s:63:\"https://ps.w.org/unsplash/assets/banner-772x250.png?rev=2344056\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.9\";}}s:7:\"checked\";a:8:{s:30:\"advanced-custom-fields/acf.php\";s:4:\"5.12\";s:43:\"custom-post-type-ui/custom-post-type-ui.php\";s:6:\"1.10.2\";s:32:\"duplicate-page/duplicatepage.php\";s:5:\"4.4.8\";s:25:\"duplicator/duplicator.php\";s:5:\"1.4.4\";s:27:\"ninja-forms/ninja-forms.php\";s:5:\"3.6.7\";s:41:\"advanced-gutenberg/advanced-gutenberg.php\";s:6:\"2.11.5\";s:47:\"show-current-template/show-current-template.php\";s:5:\"0.4.6\";s:21:\"unsplash/unsplash.php\";s:5:\"1.0.1\";}}", "no");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "3", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("3", "5", "_wp_attached_file", "2020/03/face-1.jpg");
INSERT INTO `wp_postmeta` VALUES("4", "5", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-1.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-1-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("5", "6", "_wp_attached_file", "2020/03/face-2.jpg");
INSERT INTO `wp_postmeta` VALUES("6", "6", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-2.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-2-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("7", "7", "_wp_attached_file", "2020/03/face-3.jpg");
INSERT INTO `wp_postmeta` VALUES("8", "7", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-3.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-3-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-3-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("9", "8", "_wp_attached_file", "2020/03/face-4.jpg");
INSERT INTO `wp_postmeta` VALUES("10", "8", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-4.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-4-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-4-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("11", "9", "_wp_attached_file", "2020/03/face-5.jpg");
INSERT INTO `wp_postmeta` VALUES("12", "9", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-5.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-5-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-5-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("13", "10", "_wp_attached_file", "2020/03/face-6.jpg");
INSERT INTO `wp_postmeta` VALUES("14", "10", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-6.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-6-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-6-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("15", "11", "_wp_attached_file", "2020/03/face-7.jpg");
INSERT INTO `wp_postmeta` VALUES("16", "11", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-7.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-7-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-7-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("17", "12", "_wp_attached_file", "2020/03/face-8.jpg");
INSERT INTO `wp_postmeta` VALUES("18", "12", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:18:\"2020/03/face-8.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-8-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-8-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("19", "13", "_wp_attached_file", "2020/03/face-9.jpg");
INSERT INTO `wp_postmeta` VALUES("20", "13", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:2009;s:6:\"height\";i:2009;s:4:\"file\";s:18:\"2020/03/face-9.jpg\";s:5:\"sizes\";a:7:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"face-9-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:20:\"face-9-1024x1024.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"face-9-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"face-9-768x768.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:20:\"face-9-1536x1536.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:20:\"face-9-1200x1200.jpg\";s:5:\"width\";i:1200;s:6:\"height\";i:1200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"twentytwenty-fullscreen\";a:4:{s:4:\"file\";s:20:\"face-9-1980x1980.jpg\";s:5:\"width\";i:1980;s:6:\"height\";i:1980;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("21", "14", "_wp_attached_file", "2020/03/face-10.jpg");
INSERT INTO `wp_postmeta` VALUES("22", "14", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-10.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-10-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("23", "15", "_wp_attached_file", "2020/03/face-11.jpg");
INSERT INTO `wp_postmeta` VALUES("24", "15", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-11.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-11-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-11-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("25", "16", "_wp_attached_file", "2020/03/face-12.jpg");
INSERT INTO `wp_postmeta` VALUES("26", "16", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-12.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-12-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-12-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("27", "17", "_wp_attached_file", "2020/03/face-13.jpg");
INSERT INTO `wp_postmeta` VALUES("28", "17", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-13.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-13-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-13-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("29", "18", "_wp_attached_file", "2020/03/face-14.jpg");
INSERT INTO `wp_postmeta` VALUES("30", "18", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-14.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-14-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-14-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("31", "19", "_wp_attached_file", "2020/03/face-15.jpg");
INSERT INTO `wp_postmeta` VALUES("32", "19", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-15.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-15-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-15-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("33", "20", "_wp_attached_file", "2020/03/face-16.jpg");
INSERT INTO `wp_postmeta` VALUES("34", "20", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-16.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-16-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-16-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("35", "21", "_wp_attached_file", "2020/03/face-17.jpg");
INSERT INTO `wp_postmeta` VALUES("36", "21", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-17.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-17-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-17-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("37", "22", "_wp_attached_file", "2020/03/face-18.jpg");
INSERT INTO `wp_postmeta` VALUES("38", "22", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-18.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-18-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-18-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("39", "23", "_wp_attached_file", "2020/03/face-19.jpg");
INSERT INTO `wp_postmeta` VALUES("40", "23", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:700;s:6:\"height\";i:700;s:4:\"file\";s:19:\"2020/03/face-19.jpg\";s:5:\"sizes\";a:2:{s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"face-19-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"face-19-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("41", "24", "_wp_attached_file", "2020/03/face-20-300x300-1.jpg");
INSERT INTO `wp_postmeta` VALUES("42", "24", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:300;s:4:\"file\";s:29:\"2020/03/face-20-300x300-1.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"face-20-300x300-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("43", "25", "_wp_attached_file", "2020/03/lunch-scaled.jpg");
INSERT INTO `wp_postmeta` VALUES("44", "25", "_wp_attachment_metadata", "a:6:{s:5:\"width\";i:2560;s:6:\"height\";i:1440;s:4:\"file\";s:24:\"2020/03/lunch-scaled.jpg\";s:5:\"sizes\";a:8:{s:6:\"medium\";a:4:{s:4:\"file\";s:17:\"lunch-300x169.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:169;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:18:\"lunch-1024x576.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"lunch-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:17:\"lunch-768x432.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:432;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:18:\"lunch-1536x864.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:864;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:19:\"lunch-2048x1152.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:18:\"lunch-1200x675.jpg\";s:5:\"width\";i:1200;s:6:\"height\";i:675;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"twentytwenty-fullscreen\";a:4:{s:4:\"file\";s:19:\"lunch-1980x1114.jpg\";s:5:\"width\";i:1980;s:6:\"height\";i:1114;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:9:\"lunch.jpg\";}");
INSERT INTO `wp_postmeta` VALUES("45", "26", "_wp_attached_file", "2020/03/breakfast-scaled.jpg");
INSERT INTO `wp_postmeta` VALUES("46", "26", "_wp_attachment_metadata", "a:6:{s:5:\"width\";i:2560;s:6:\"height\";i:1707;s:4:\"file\";s:28:\"2020/03/breakfast-scaled.jpg\";s:5:\"sizes\";a:8:{s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"breakfast-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"breakfast-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"breakfast-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"breakfast-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:23:\"breakfast-1536x1024.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:23:\"breakfast-2048x1365.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1365;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"breakfast-1200x800.jpg\";s:5:\"width\";i:1200;s:6:\"height\";i:800;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"twentytwenty-fullscreen\";a:4:{s:4:\"file\";s:23:\"breakfast-1980x1320.jpg\";s:5:\"width\";i:1980;s:6:\"height\";i:1320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:13:\"breakfast.jpg\";}");
INSERT INTO `wp_postmeta` VALUES("47", "27", "_wp_attached_file", "2020/03/dinner-scaled.jpg");
INSERT INTO `wp_postmeta` VALUES("48", "27", "_wp_attachment_metadata", "a:6:{s:5:\"width\";i:2560;s:6:\"height\";i:1707;s:4:\"file\";s:25:\"2020/03/dinner-scaled.jpg\";s:5:\"sizes\";a:8:{s:6:\"medium\";a:4:{s:4:\"file\";s:18:\"dinner-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:19:\"dinner-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"dinner-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:18:\"dinner-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"1536x1536\";a:4:{s:4:\"file\";s:20:\"dinner-1536x1024.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"2048x2048\";a:4:{s:4:\"file\";s:20:\"dinner-2048x1365.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1365;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:19:\"dinner-1200x800.jpg\";s:5:\"width\";i:1200;s:6:\"height\";i:800;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"twentytwenty-fullscreen\";a:4:{s:4:\"file\";s:20:\"dinner-1980x1320.jpg\";s:5:\"width\";i:1980;s:6:\"height\";i:1320;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:10:\"dinner.jpg\";}");
INSERT INTO `wp_postmeta` VALUES("49", "28", "_wp_attached_file", "2020/03/eatery-logo-1000x470-2.png");
INSERT INTO `wp_postmeta` VALUES("50", "28", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1000;s:6:\"height\";i:470;s:4:\"file\";s:34:\"2020/03/eatery-logo-1000x470-2.png\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"eatery-logo-1000x470-2-300x141.png\";s:5:\"width\";i:300;s:6:\"height\";i:141;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"eatery-logo-1000x470-2-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:34:\"eatery-logo-1000x470-2-768x361.png\";s:5:\"width\";i:768;s:6:\"height\";i:361;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("51", "29", "blocks", "a:2:{s:13:\"active_blocks\";a:89:{i:0;s:15:\"advgb/accordion\";i:1;s:20:\"advgb/accordion-item\";i:2;s:16:\"advgb/accordions\";i:3;s:12:\"advgb/button\";i:4;s:10:\"advgb/icon\";i:5;s:11:\"advgb/image\";i:6;s:10:\"advgb/list\";i:7;s:11:\"advgb/table\";i:8;s:14:\"advgb/adv-tabs\";i:9;s:9:\"advgb/tab\";i:10;s:11:\"advgb/video\";i:11;s:13:\"advgb/columns\";i:12;s:12:\"advgb/column\";i:13;s:18:\"advgb/contact-form\";i:14;s:14:\"advgb/count-up\";i:15;s:14:\"core/paragraph\";i:16;s:10:\"core/image\";i:17;s:12:\"core/heading\";i:18;s:12:\"core/gallery\";i:19;s:9:\"core/list\";i:20;s:10:\"core/quote\";i:21;s:14:\"core/shortcode\";i:22;s:13:\"core/archives\";i:23;s:10:\"core/audio\";i:24;s:11:\"core/button\";i:25;s:13:\"core/calendar\";i:26;s:15:\"core/categories\";i:27;s:9:\"core/code\";i:28;s:12:\"core/columns\";i:29;s:11:\"core/column\";i:30;s:10:\"core/cover\";i:31;s:10:\"core/embed\";i:32;s:18:\"core-embed/twitter\";i:33;s:18:\"core-embed/youtube\";i:34;s:19:\"core-embed/facebook\";i:35;s:20:\"core-embed/instagram\";i:36;s:20:\"core-embed/wordpress\";i:37;s:21:\"core-embed/soundcloud\";i:38;s:18:\"core-embed/spotify\";i:39;s:17:\"core-embed/flickr\";i:40;s:16:\"core-embed/vimeo\";i:41;s:18:\"core-embed/animoto\";i:42;s:18:\"core-embed/cloudup\";i:43;s:23:\"core-embed/collegehumor\";i:44;s:22:\"core-embed/crowdsignal\";i:45;s:22:\"core-embed/dailymotion\";i:46;s:15:\"core-embed/hulu\";i:47;s:16:\"core-embed/imgur\";i:48;s:16:\"core-embed/issuu\";i:49;s:22:\"core-embed/kickstarter\";i:50;s:21:\"core-embed/meetup-com\";i:51;s:19:\"core-embed/mixcloud\";i:52;s:20:\"core-embed/polldaddy\";i:53;s:17:\"core-embed/reddit\";i:54;s:23:\"core-embed/reverbnation\";i:55;s:21:\"core-embed/screencast\";i:56;s:17:\"core-embed/scribd\";i:57;s:21:\"core-embed/slideshare\";i:58;s:18:\"core-embed/smugmug\";i:59;s:18:\"core-embed/speaker\";i:60;s:23:\"core-embed/speaker-deck\";i:61;s:14:\"core-embed/ted\";i:62;s:17:\"core-embed/tumblr\";i:63;s:21:\"core-embed/videopress\";i:64;s:23:\"core-embed/wordpress-tv\";i:65;s:24:\"core-embed/amazon-kindle\";i:66;s:9:\"core/file\";i:67;s:10:\"core/group\";i:68;s:13:\"core/freeform\";i:69;s:9:\"core/html\";i:70;s:15:\"core/media-text\";i:71;s:20:\"core/latest-comments\";i:72;s:17:\"core/latest-posts\";i:73;s:12:\"core/missing\";i:74;s:9:\"core/more\";i:75;s:13:\"core/nextpage\";i:76;s:17:\"core/preformatted\";i:77;s:14:\"core/pullquote\";i:78;s:8:\"core/rss\";i:79;s:11:\"core/search\";i:80;s:14:\"core/separator\";i:81;s:10:\"core/block\";i:82;s:11:\"core/spacer\";i:83;s:12:\"core/subhead\";i:84;s:10:\"core/table\";i:85;s:14:\"core/tag-cloud\";i:86;s:17:\"core/text-columns\";i:87;s:10:\"core/verse\";i:88;s:10:\"core/video\";}s:15:\"inactive_blocks\";a:1:{i:0;s:15:\"advgb/container\";}}");
INSERT INTO `wp_postmeta` VALUES("52", "29", "roles_access", "a:3:{i:0;s:13:\"administrator\";i:1;s:6:\"editor\";i:2;s:6:\"author\";}");
INSERT INTO `wp_postmeta` VALUES("53", "29", "users_access", "a:0:{}");
INSERT INTO `wp_postmeta` VALUES("54", "30", "_edit_lock", "1584956273:1");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "<!-- wp:paragraph -->\n<p>Welcome to WordPress. This is your first post. Edit or delete it, then start writing!</p>\n<!-- /wp:paragraph -->", "Hello world!", "", "publish", "open", "open", "", "hello-world", "", "", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("2", "1", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "<!-- wp:paragraph -->\n<p>This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:quote -->\n<blockquote class=\"wp-block-quote\"><p>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</p></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:paragraph -->\n<p>...or something like this:</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:quote -->\n<blockquote class=\"wp-block-quote\"><p>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</p></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:paragraph -->\n<p>As a new WordPress user, you should go to <a href=\"http://localhost:8888/CanonicalExercises/Eatery-2022/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!</p>\n<!-- /wp:paragraph -->", "Sample Page", "", "publish", "closed", "open", "", "sample-page", "", "", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("3", "1", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "<!-- wp:heading --><h2>Who we are</h2><!-- /wp:heading --><!-- wp:paragraph --><p>Our website address is: http://localhost:8888/CanonicalExercises/Eatery-2022.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What personal data we collect and why we collect it</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Comments</h3><!-- /wp:heading --><!-- wp:paragraph --><p>When visitors leave comments on the site we collect the data shown in the comments form, and also the visitor&#8217;s IP address and browser user agent string to help spam detection.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>An anonymized string created from your email address (also called a hash) may be provided to the Gravatar service to see if you are using it. The Gravatar service privacy policy is available here: https://automattic.com/privacy/. After approval of your comment, your profile picture is visible to the public in the context of your comment.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Media</h3><!-- /wp:heading --><!-- wp:paragraph --><p>If you upload images to the website, you should avoid uploading images with embedded location data (EXIF GPS) included. Visitors to the website can download and extract any location data from images on the website.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Contact forms</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Cookies</h3><!-- /wp:heading --><!-- wp:paragraph --><p>If you leave a comment on our site you may opt-in to saving your name, email address and website in cookies. These are for your convenience so that you do not have to fill in your details again when you leave another comment. These cookies will last for one year.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you visit our login page, we will set a temporary cookie to determine if your browser accepts cookies. This cookie contains no personal data and is discarded when you close your browser.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>When you log in, we will also set up several cookies to save your login information and your screen display choices. Login cookies last for two days, and screen options cookies last for a year. If you select &quot;Remember Me&quot;, your login will persist for two weeks. If you log out of your account, the login cookies will be removed.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>If you edit or publish an article, an additional cookie will be saved in your browser. This cookie includes no personal data and simply indicates the post ID of the article you just edited. It expires after 1 day.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Embedded content from other websites</h3><!-- /wp:heading --><!-- wp:paragraph --><p>Articles on this site may include embedded content (e.g. videos, images, articles, etc.). Embedded content from other websites behaves in the exact same way as if the visitor has visited the other website.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>These websites may collect data about you, use cookies, embed additional third-party tracking, and monitor your interaction with that embedded content, including tracking your interaction with the embedded content if you have an account and are logged in to that website.</p><!-- /wp:paragraph --><!-- wp:heading {\"level\":3} --><h3>Analytics</h3><!-- /wp:heading --><!-- wp:heading --><h2>Who we share your data with</h2><!-- /wp:heading --><!-- wp:heading --><h2>How long we retain your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>If you leave a comment, the comment and its metadata are retained indefinitely. This is so we can recognize and approve any follow-up comments automatically instead of holding them in a moderation queue.</p><!-- /wp:paragraph --><!-- wp:paragraph --><p>For users that register on our website (if any), we also store the personal information they provide in their user profile. All users can see, edit, or delete their personal information at any time (except they cannot change their username). Website administrators can also see and edit that information.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>What rights you have over your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>If you have an account on this site, or have left comments, you can request to receive an exported file of the personal data we hold about you, including any data you have provided to us. You can also request that we erase any personal data we hold about you. This does not include any data we are obliged to keep for administrative, legal, or security purposes.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Where we send your data</h2><!-- /wp:heading --><!-- wp:paragraph --><p>Visitor comments may be checked through an automated spam detection service.</p><!-- /wp:paragraph --><!-- wp:heading --><h2>Your contact information</h2><!-- /wp:heading --><!-- wp:heading --><h2>Additional information</h2><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>How we protect your data</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What data breach procedures we have in place</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What third parties we receive data from</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>What automated decision making and/or profiling we do with user data</h3><!-- /wp:heading --><!-- wp:heading {\"level\":3} --><h3>Industry regulatory disclosure requirements</h3><!-- /wp:heading -->", "Privacy Policy", "", "draft", "closed", "open", "", "privacy-policy", "", "", "2020-03-23 09:27:07", "2020-03-23 09:27:07", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/?page_id=3", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2020-03-23 09:31:29", "2020-03-23 09:31:29", "", "face-1", "", "inherit", "open", "closed", "", "face-1", "", "", "2020-03-23 09:31:29", "2020-03-23 09:31:29", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2020-03-23 09:31:29", "2020-03-23 09:31:29", "", "face-2", "", "inherit", "open", "closed", "", "face-2", "", "", "2020-03-23 09:31:29", "2020-03-23 09:31:29", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("7", "1", "2020-03-23 09:31:30", "2020-03-23 09:31:30", "", "face-3", "", "inherit", "open", "closed", "", "face-3", "", "", "2020-03-23 09:31:30", "2020-03-23 09:31:30", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-3.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2020-03-23 09:31:31", "2020-03-23 09:31:31", "", "face-4", "", "inherit", "open", "closed", "", "face-4", "", "", "2020-03-23 09:31:31", "2020-03-23 09:31:31", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-4.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("9", "1", "2020-03-23 09:31:31", "2020-03-23 09:31:31", "", "face-5", "", "inherit", "open", "closed", "", "face-5", "", "", "2020-03-23 09:31:31", "2020-03-23 09:31:31", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-5.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2020-03-23 09:31:32", "2020-03-23 09:31:32", "", "face-6", "", "inherit", "open", "closed", "", "face-6", "", "", "2020-03-23 09:31:32", "2020-03-23 09:31:32", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-6.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2020-03-23 09:31:32", "2020-03-23 09:31:32", "", "face-7", "", "inherit", "open", "closed", "", "face-7", "", "", "2020-03-23 09:31:32", "2020-03-23 09:31:32", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-7.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2020-03-23 09:31:32", "2020-03-23 09:31:32", "", "face-8", "", "inherit", "open", "closed", "", "face-8", "", "", "2020-03-23 09:31:32", "2020-03-23 09:31:32", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-8.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2020-03-23 09:31:33", "2020-03-23 09:31:33", "", "face-9", "", "inherit", "open", "closed", "", "face-9", "", "", "2020-03-23 09:31:33", "2020-03-23 09:31:33", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-9.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2020-03-23 09:31:36", "2020-03-23 09:31:36", "", "face-10", "", "inherit", "open", "closed", "", "face-10", "", "", "2020-03-23 09:31:36", "2020-03-23 09:31:36", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2020-03-23 09:31:36", "2020-03-23 09:31:36", "", "face-11", "", "inherit", "open", "closed", "", "face-11", "", "", "2020-03-23 09:31:36", "2020-03-23 09:31:36", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-11.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2020-03-23 09:31:36", "2020-03-23 09:31:36", "", "face-12", "", "inherit", "open", "closed", "", "face-12", "", "", "2020-03-23 09:31:36", "2020-03-23 09:31:36", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-12.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2020-03-23 09:31:37", "2020-03-23 09:31:37", "", "face-13", "", "inherit", "open", "closed", "", "face-13", "", "", "2020-03-23 09:31:37", "2020-03-23 09:31:37", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-13.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2020-03-23 09:31:37", "2020-03-23 09:31:37", "", "face-14", "", "inherit", "open", "closed", "", "face-14", "", "", "2020-03-23 09:31:37", "2020-03-23 09:31:37", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-14.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2020-03-23 09:31:38", "2020-03-23 09:31:38", "", "face-15", "", "inherit", "open", "closed", "", "face-15", "", "", "2020-03-23 09:31:38", "2020-03-23 09:31:38", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-15.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2020-03-23 09:31:38", "2020-03-23 09:31:38", "", "face-16", "", "inherit", "open", "closed", "", "face-16", "", "", "2020-03-23 09:31:38", "2020-03-23 09:31:38", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-16.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2020-03-23 09:31:38", "2020-03-23 09:31:38", "", "face-17", "", "inherit", "open", "closed", "", "face-17", "", "", "2020-03-23 09:31:38", "2020-03-23 09:31:38", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-17.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2020-03-23 09:31:39", "2020-03-23 09:31:39", "", "face-18", "", "inherit", "open", "closed", "", "face-18", "", "", "2020-03-23 09:31:39", "2020-03-23 09:31:39", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-18.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2020-03-23 09:31:39", "2020-03-23 09:31:39", "", "face-19", "", "inherit", "open", "closed", "", "face-19", "", "", "2020-03-23 09:31:39", "2020-03-23 09:31:39", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-19.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2020-03-23 09:31:39", "2020-03-23 09:31:39", "", "face-20-300x300", "", "inherit", "open", "closed", "", "face-20-300x300", "", "", "2020-03-23 09:31:39", "2020-03-23 09:31:39", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/face-20-300x300-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2020-03-23 09:31:40", "2020-03-23 09:31:40", "", "lunch", "", "inherit", "open", "closed", "", "lunch", "", "", "2020-03-23 09:31:40", "2020-03-23 09:31:40", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/lunch.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2020-03-23 09:31:44", "2020-03-23 09:31:44", "", "breakfast", "", "inherit", "open", "closed", "", "breakfast", "", "", "2020-03-23 09:31:44", "2020-03-23 09:31:44", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/breakfast.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2020-03-23 09:31:59", "2020-03-23 09:31:59", "", "dinner", "", "inherit", "open", "closed", "", "dinner", "", "", "2020-03-23 09:31:59", "2020-03-23 09:31:59", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/dinner.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2020-03-23 09:32:16", "2020-03-23 09:32:16", "", "eatery-logo-1000x470-2", "", "inherit", "open", "closed", "", "eatery-logo-1000x470-2", "", "", "2020-03-23 09:32:16", "2020-03-23 09:32:16", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/wp-content/uploads/2020/03/eatery-logo-1000x470-2.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2020-03-23 09:35:09", "2020-03-23 09:35:09", "", "Default", "", "publish", "closed", "closed", "", "default", "", "", "2020-03-23 09:35:09", "2020-03-23 09:35:09", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/2020/03/23/default/", "0", "advgb_profiles", "", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2020-03-23 09:35:45", "2020-03-23 09:35:45", "<!-- wp:heading -->\n<h2>Breakfast</h2>\n<!-- /wp:heading -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:heading -->\n<h2>Lunch</h2>\n<!-- /wp:heading -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Dinner</h2>\n<!-- /wp:heading -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Tofu Steak</td><td> $18</td></tr><tr><td>Ahi Tuna</td><td> $18</td></tr><tr><td>Salmon Carpachio</td><td>$22</td></tr><tr><td>Couscous With Beets</td><td> $18</td></tr><tr><td>Roast Beef</td><td>$21</td></tr><tr><td>Kim Chi Udon</td><td> $18</td></tr><tr><td>Bibimbap</td><td>$21</td></tr><tr><td>Cottage Cheese</td><td>$22</td></tr><tr><td>California Roll</td><td> $18</td></tr><tr><td>Scallop Mayo Pizza</td><td>$19</td></tr><tr><td>Soy Marinated Salmon</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Fried Oreos</td><td>$21</td></tr><tr><td>Rubber Chicken</td><td>$19</td></tr><tr><td>Poutine (10 lbs)</td><td> $18</td></tr><tr><td>Poutine (20 lbs)</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>French Onion Soup</td><td>$12</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Bregadeiro</td><td>$11</td></tr><tr><td>Chicken Masala Dosa</td><td>$12</td></tr><tr><td>Broccoli</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Data For Exercise", "", "publish", "closed", "closed", "", "data-for-exercise", "", "", "2020-03-23 09:40:05", "2020-03-23 09:40:05", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/?page_id=30", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2020-03-23 09:35:45", "2020-03-23 09:35:45", "", "Data For Exercise", "", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2020-03-23 09:35:45", "2020-03-23 09:35:45", "", "30", "http://localhost:8888/CanonicalExercises/Eatery-2022/2020/03/23/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2020-03-23 09:37:20", "2020-03-23 09:37:20", "<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Data For Exercise", "", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2020-03-23 09:37:20", "2020-03-23 09:37:20", "", "30", "http://localhost:8888/CanonicalExercises/Eatery-2022/2020/03/23/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2020-03-23 09:39:26", "2020-03-23 09:39:26", "<!-- wp:paragraph -->\n<p>Breakfast</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:paragraph -->\n<p>Lunch</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>Dinner</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Tofu Steak</td><td> $18</td></tr><tr><td>Ahi Tuna</td><td> $18</td></tr><tr><td>Salmon Carpachio</td><td>$22</td></tr><tr><td>Couscous With Beets</td><td> $18</td></tr><tr><td>Roast Beef</td><td>$21</td></tr><tr><td>Kim Chi Udon</td><td> $18</td></tr><tr><td>Bibimbap</td><td>$21</td></tr><tr><td>Cottage Cheese</td><td>$22</td></tr><tr><td>California Roll</td><td> $18</td></tr><tr><td>Scallop Mayo Pizza</td><td>$19</td></tr><tr><td>Soy Marinated Salmon</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Fried Oreos</td><td>$21</td></tr><tr><td>Rubber Chicken</td><td>$19</td></tr><tr><td>Poutine (10 lbs)</td><td> $18</td></tr><tr><td>Poutine (20 lbs)</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>French Onion Soup</td><td>$12</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Bregadeiro</td><td>$11</td></tr><tr><td>Chicken Masala Dosa</td><td>$12</td></tr><tr><td>Broccoli</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Data For Exercise", "", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2020-03-23 09:39:26", "2020-03-23 09:39:26", "", "30", "http://localhost:8888/CanonicalExercises/Eatery-2022/2020/03/23/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2020-03-23 09:40:05", "2020-03-23 09:40:05", "<!-- wp:heading -->\n<h2>Breakfast</h2>\n<!-- /wp:heading -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:heading -->\n<h2>Lunch</h2>\n<!-- /wp:heading -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Eggs Benedict</td><td> $18</td></tr><tr><td>Croque Monsieur</td><td> $18</td></tr><tr><td>Croque Madam</td><td>$22</td></tr><tr><td>Salmon Plate</td><td> $18</td></tr><tr><td>Fruit Plate</td><td>$21</td></tr><tr><td>Poached Eggs</td><td> $18</td></tr><tr><td>Avocado Toast</td><td>$21</td></tr><tr><td>Vegetarian Omlette</td><td>$22</td></tr><tr><td>Cottage Cheese</td><td> $18</td></tr><tr><td>Oats</td><td>$19</td></tr><tr><td>Deluxe Avocado Toast</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Pancakes</td><td>$21</td></tr><tr><td>French Toast</td><td>$19</td></tr><tr><td>Texas Toast</td><td> $18</td></tr><tr><td>Poutine</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>Hash Browns</td><td>$6</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Fish Soup</td><td>$7</td></tr><tr><td>Cantelope</td><td>$5</td></tr><tr><td>Bacon</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Dinner</h2>\n<!-- /wp:heading -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Entrees</td><td>Price</td></tr></thead><tbody><tr><td>Tofu Steak</td><td> $18</td></tr><tr><td>Ahi Tuna</td><td> $18</td></tr><tr><td>Salmon Carpachio</td><td>$22</td></tr><tr><td>Couscous With Beets</td><td> $18</td></tr><tr><td>Roast Beef</td><td>$21</td></tr><tr><td>Kim Chi Udon</td><td> $18</td></tr><tr><td>Bibimbap</td><td>$21</td></tr><tr><td>Cottage Cheese</td><td>$22</td></tr><tr><td>California Roll</td><td> $18</td></tr><tr><td>Scallop Mayo Pizza</td><td>$19</td></tr><tr><td>Soy Marinated Salmon</td><td> $18</td></tr><tr><td>Premium Avocado Toast</td><td>$22</td></tr><tr><td>Fried Oreos</td><td>$21</td></tr><tr><td>Rubber Chicken</td><td>$19</td></tr><tr><td>Poutine (10 lbs)</td><td> $18</td></tr><tr><td>Poutine (20 lbs)</td><td>$22</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Sides</td><td>Price</td></tr></thead><tbody><tr><td>French Onion Soup</td><td>$12</td></tr><tr><td>Waldorf Salad</td><td>$6</td></tr><tr><td>Bregadeiro</td><td>$11</td></tr><tr><td>Chicken Masala Dosa</td><td>$12</td></tr><tr><td>Broccoli</td><td>$6</td></tr></tbody></table>\n<!-- /wp:advgb/table -->\n\n<!-- wp:advgb/table {\"changed\":true} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend\"><thead><tr><td>Drinks</td><td>Price</td></tr></thead><tbody><tr><td>Milk</td><td>$4</td></tr><tr><td>Chocolate Milk</td><td>$4</td></tr><tr><td>Orange Juice</td><td>$4</td></tr><tr><td>Café au Lait</td><td>$4</td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Data For Exercise", "", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2020-03-23 09:40:05", "2020-03-23 09:40:05", "", "30", "http://localhost:8888/CanonicalExercises/Eatery-2022/2020/03/23/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("35", "1", "2022-03-07 22:50:12", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "open", "open", "", "", "", "", "2022-03-07 22:50:12", "0000-00-00 00:00:00", "", "0", "http://localhost:8888/CanonicalExercises/Eatery-2022/?p=35", "0", "post", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "1");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Uncategorized", "uncategorized", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "kevinmcmillan");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "syntax_highlighting", "true");
INSERT INTO `wp_usermeta` VALUES("7", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("8", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("9", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("10", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("11", "1", "locale", "");
INSERT INTO `wp_usermeta` VALUES("12", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("13", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("14", "1", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("15", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("16", "1", "session_tokens", "a:1:{s:64:\"6e6b0e2bab0f3037f090bab557b7f1e20fc1cc4dbf32d8d86c19b3c2d3a76d85\";a:4:{s:10:\"expiration\";i:1646865859;s:2:\"ip\";s:3:\"::1\";s:2:\"ua\";s:121:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.109 Safari/537.36\";s:5:\"login\";i:1646693059;}}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_dashboard_quick_press_last_post_id", "35");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "kevinmcmillan", "$P$BxZbasn50IlrKLjyL0xYTHwhZxzG8//", "kevinmcmillan", "kevinmc@shaw.ca", "", "2020-03-23 09:27:07", "", "0", "kevinmcmillan");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2022-03-07 23:05:05*/
/* DUPLICATOR_MYSQLDUMP_EOF */
